# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ActionRuleStatus',
    'ActionRuleType',
    'ActionType',
    'AlertRuleState',
    'DaysOfWeek',
    'Field',
    'Operator',
    'RecurrenceType',
    'ScopeType',
    'Severity',
    'Status',
    'SuppressionType',
]


@pulumi.type_token("azure-native:alertsmanagement:ActionRuleStatus")
class ActionRuleStatus(builtins.str, Enum):
    """
    Indicates if the given action rule is enabled or disabled
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:alertsmanagement:ActionRuleType")
class ActionRuleType(builtins.str, Enum):
    """
    Indicates type of action rule
    """
    SUPPRESSION = "Suppression"
    ACTION_GROUP = "ActionGroup"
    DIAGNOSTICS = "Diagnostics"


@pulumi.type_token("azure-native:alertsmanagement:ActionType")
class ActionType(builtins.str, Enum):
    """
    Action that should be applied.
    """
    ADD_ACTION_GROUPS = "AddActionGroups"
    REMOVE_ALL_ACTION_GROUPS = "RemoveAllActionGroups"


@pulumi.type_token("azure-native:alertsmanagement:AlertRuleState")
class AlertRuleState(builtins.str, Enum):
    """
    The alert rule state.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:alertsmanagement:DaysOfWeek")
class DaysOfWeek(builtins.str, Enum):
    """
    Days of week.
    """
    SUNDAY = "Sunday"
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"


@pulumi.type_token("azure-native:alertsmanagement:Field")
class Field(builtins.str, Enum):
    """
    Field for a given condition.
    """
    SEVERITY = "Severity"
    MONITOR_SERVICE = "MonitorService"
    MONITOR_CONDITION = "MonitorCondition"
    SIGNAL_TYPE = "SignalType"
    TARGET_RESOURCE_TYPE = "TargetResourceType"
    TARGET_RESOURCE = "TargetResource"
    TARGET_RESOURCE_GROUP = "TargetResourceGroup"
    ALERT_RULE_ID = "AlertRuleId"
    ALERT_RULE_NAME = "AlertRuleName"
    DESCRIPTION = "Description"
    ALERT_CONTEXT = "AlertContext"


@pulumi.type_token("azure-native:alertsmanagement:Operator")
class Operator(builtins.str, Enum):
    """
    Operator for a given condition.
    """
    EQUALS = "Equals"
    NOT_EQUALS = "NotEquals"
    CONTAINS = "Contains"
    DOES_NOT_CONTAIN = "DoesNotContain"


@pulumi.type_token("azure-native:alertsmanagement:RecurrenceType")
class RecurrenceType(builtins.str, Enum):
    """
    Specifies when the recurrence should be applied.
    """
    DAILY = "Daily"
    WEEKLY = "Weekly"
    MONTHLY = "Monthly"


@pulumi.type_token("azure-native:alertsmanagement:ScopeType")
class ScopeType(builtins.str, Enum):
    """
    type of target scope
    """
    RESOURCE_GROUP = "ResourceGroup"
    RESOURCE = "Resource"
    SUBSCRIPTION = "Subscription"


@pulumi.type_token("azure-native:alertsmanagement:Severity")
class Severity(builtins.str, Enum):
    """
    The alert rule severity.
    """
    SEV0 = "Sev0"
    SEV1 = "Sev1"
    SEV2 = "Sev2"
    SEV3 = "Sev3"
    SEV4 = "Sev4"


@pulumi.type_token("azure-native:alertsmanagement:Status")
class Status(builtins.str, Enum):
    """
    The issue status
    """
    NEW = "New"
    """
    The issue is new
    """
    IN_PROGRESS = "InProgress"
    """
    The issue is in progress
    """
    MITIGATED = "Mitigated"
    """
    The issue is mitigated
    """
    CLOSED = "Closed"
    """
    The issue is closed
    """
    CANCELED = "Canceled"
    """
    The issue is canceled
    """


@pulumi.type_token("azure-native:alertsmanagement:SuppressionType")
class SuppressionType(builtins.str, Enum):
    """
    Specifies when the suppression should be applied
    """
    ALWAYS = "Always"
    ONCE = "Once"
    DAILY = "Daily"
    WEEKLY = "Weekly"
    MONTHLY = "Monthly"
