# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['IssueArgs', 'Issue']

@pulumi.input_type
class IssueArgs:
    def __init__(__self__, *,
                 resource_uri: pulumi.Input[builtins.str],
                 issue_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input['IssuePropertiesArgs']] = None):
        """
        The set of arguments for constructing a Issue resource.
        :param pulumi.Input[builtins.str] resource_uri: The fully qualified Azure Resource manager identifier of the resource.
        :param pulumi.Input[builtins.str] issue_name: The name of the IssueResource
        :param pulumi.Input['IssuePropertiesArgs'] properties: The resource-specific properties for this resource.
        """
        pulumi.set(__self__, "resource_uri", resource_uri)
        if issue_name is not None:
            pulumi.set(__self__, "issue_name", issue_name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter(name="resourceUri")
    def resource_uri(self) -> pulumi.Input[builtins.str]:
        """
        The fully qualified Azure Resource manager identifier of the resource.
        """
        return pulumi.get(self, "resource_uri")

    @resource_uri.setter
    def resource_uri(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_uri", value)

    @property
    @pulumi.getter(name="issueName")
    def issue_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the IssueResource
        """
        return pulumi.get(self, "issue_name")

    @issue_name.setter
    def issue_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "issue_name", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input['IssuePropertiesArgs']]:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input['IssuePropertiesArgs']]):
        pulumi.set(self, "properties", value)


@pulumi.type_token("azure-native:alertsmanagement:Issue")
class Issue(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 issue_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['IssuePropertiesArgs', 'IssuePropertiesArgsDict']]] = None,
                 resource_uri: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        The Issue resource

        Uses Azure REST API version 2025-03-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] issue_name: The name of the IssueResource
        :param pulumi.Input[Union['IssuePropertiesArgs', 'IssuePropertiesArgsDict']] properties: The resource-specific properties for this resource.
        :param pulumi.Input[builtins.str] resource_uri: The fully qualified Azure Resource manager identifier of the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: IssueArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The Issue resource

        Uses Azure REST API version 2025-03-01-preview.

        :param str resource_name: The name of the resource.
        :param IssueArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(IssueArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 issue_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['IssuePropertiesArgs', 'IssuePropertiesArgsDict']]] = None,
                 resource_uri: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = IssueArgs.__new__(IssueArgs)

            __props__.__dict__["issue_name"] = issue_name
            __props__.__dict__["properties"] = properties
            if resource_uri is None and not opts.urn:
                raise TypeError("Missing required property 'resource_uri'")
            __props__.__dict__["resource_uri"] = resource_uri
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:alertsmanagement/v20250301preview:Issue")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(Issue, __self__).__init__(
            'azure-native:alertsmanagement:Issue',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Issue':
        """
        Get an existing Issue resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = IssueArgs.__new__(IssueArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return Issue(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.IssuePropertiesResponse']:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

