# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListServerGatewayStatusResult',
    'AwaitableListServerGatewayStatusResult',
    'list_server_gateway_status',
    'list_server_gateway_status_output',
]

@pulumi.output_type
class ListServerGatewayStatusResult:
    """
    Status of gateway is live.
    """
    def __init__(__self__, status=None):
        if status and not isinstance(status, int):
            raise TypeError("Expected argument 'status' to be a int")
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def status(self) -> Optional[builtins.int]:
        """
        Live message of list gateway. Status: 0 - Live
        """
        return pulumi.get(self, "status")


class AwaitableListServerGatewayStatusResult(ListServerGatewayStatusResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListServerGatewayStatusResult(
            status=self.status)


def list_server_gateway_status(resource_group_name: Optional[builtins.str] = None,
                               server_name: Optional[builtins.str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListServerGatewayStatusResult:
    """
    Return the gateway status of the specified Analysis Services server instance.

    Uses Azure REST API version 2017-08-01.


    :param builtins.str resource_group_name: The name of the Azure Resource group of which a given Analysis Services server is part. This name must be at least 1 character in length, and no more than 90.
    :param builtins.str server_name: The name of the Analysis Services server.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['serverName'] = server_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:analysisservices:listServerGatewayStatus', __args__, opts=opts, typ=ListServerGatewayStatusResult).value

    return AwaitableListServerGatewayStatusResult(
        status=pulumi.get(__ret__, 'status'))
def list_server_gateway_status_output(resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                      server_name: Optional[pulumi.Input[builtins.str]] = None,
                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListServerGatewayStatusResult]:
    """
    Return the gateway status of the specified Analysis Services server instance.

    Uses Azure REST API version 2017-08-01.


    :param builtins.str resource_group_name: The name of the Azure Resource group of which a given Analysis Services server is part. This name must be at least 1 character in length, and no more than 90.
    :param builtins.str server_name: The name of the Analysis Services server.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['serverName'] = server_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:analysisservices:listServerGatewayStatus', __args__, opts=opts, typ=ListServerGatewayStatusResult)
    return __ret__.apply(lambda __response__: ListServerGatewayStatusResult(
        status=pulumi.get(__response__, 'status')))
