# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetMetadataSchemaResult',
    'AwaitableGetMetadataSchemaResult',
    'get_metadata_schema',
    'get_metadata_schema_output',
]

@pulumi.output_type
class GetMetadataSchemaResult:
    """
    Metadata schema entity. Used to define metadata for the entities in API catalog.
    """
    def __init__(__self__, assigned_to=None, azure_api_version=None, id=None, name=None, schema=None, system_data=None, type=None):
        if assigned_to and not isinstance(assigned_to, list):
            raise TypeError("Expected argument 'assigned_to' to be a list")
        pulumi.set(__self__, "assigned_to", assigned_to)
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if schema and not isinstance(schema, str):
            raise TypeError("Expected argument 'schema' to be a str")
        pulumi.set(__self__, "schema", schema)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="assignedTo")
    def assigned_to(self) -> Optional[Sequence['outputs.MetadataAssignmentResponse']]:
        """
        The assignees
        """
        return pulumi.get(self, "assigned_to")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def schema(self) -> builtins.str:
        """
        The schema defining the type.
        """
        return pulumi.get(self, "schema")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetMetadataSchemaResult(GetMetadataSchemaResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetMetadataSchemaResult(
            assigned_to=self.assigned_to,
            azure_api_version=self.azure_api_version,
            id=self.id,
            name=self.name,
            schema=self.schema,
            system_data=self.system_data,
            type=self.type)


def get_metadata_schema(metadata_schema_name: Optional[builtins.str] = None,
                        resource_group_name: Optional[builtins.str] = None,
                        service_name: Optional[builtins.str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetMetadataSchemaResult:
    """
    Returns details of the metadata schema.

    Uses Azure REST API version 2024-03-15-preview.

    Other available API versions: 2024-03-01, 2024-06-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native apicenter [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str metadata_schema_name: The name of the metadata schema.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str service_name: The name of Azure API Center service.
    """
    __args__ = dict()
    __args__['metadataSchemaName'] = metadata_schema_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:apicenter:getMetadataSchema', __args__, opts=opts, typ=GetMetadataSchemaResult).value

    return AwaitableGetMetadataSchemaResult(
        assigned_to=pulumi.get(__ret__, 'assigned_to'),
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        schema=pulumi.get(__ret__, 'schema'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_metadata_schema_output(metadata_schema_name: Optional[pulumi.Input[builtins.str]] = None,
                               resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                               service_name: Optional[pulumi.Input[builtins.str]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetMetadataSchemaResult]:
    """
    Returns details of the metadata schema.

    Uses Azure REST API version 2024-03-15-preview.

    Other available API versions: 2024-03-01, 2024-06-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native apicenter [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str metadata_schema_name: The name of the metadata schema.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str service_name: The name of Azure API Center service.
    """
    __args__ = dict()
    __args__['metadataSchemaName'] = metadata_schema_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:apicenter:getMetadataSchema', __args__, opts=opts, typ=GetMetadataSchemaResult)
    return __ret__.apply(lambda __response__: GetMetadataSchemaResult(
        assigned_to=pulumi.get(__response__, 'assigned_to'),
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        schema=pulumi.get(__response__, 'schema'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
