# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'ApiDefinitionPropertiesSpecificationResponse',
    'AzureApiManagementSourceResponse',
    'ContactResponse',
    'DeploymentServerResponse',
    'EnvironmentServerResponse',
    'ExternalDocumentationResponse',
    'LicenseResponse',
    'LinkStateResponse',
    'ManagedServiceIdentityResponse',
    'MetadataAssignmentResponse',
    'OnboardingResponse',
    'SystemDataResponse',
    'TermsOfServiceResponse',
    'UserAssignedIdentityResponse',
]

@pulumi.output_type
class ApiDefinitionPropertiesSpecificationResponse(dict):
    """
    API specification details.
    """
    def __init__(__self__, *,
                 name: Optional[builtins.str] = None,
                 version: Optional[builtins.str] = None):
        """
        API specification details.
        :param builtins.str name: Specification name.
        :param builtins.str version: Specification version.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        Specification name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def version(self) -> Optional[builtins.str]:
        """
        Specification version.
        """
        return pulumi.get(self, "version")


@pulumi.output_type
class AzureApiManagementSourceResponse(dict):
    """
    API source configuration for Azure API Management.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "resourceId":
            suggest = "resource_id"
        elif key == "msiResourceId":
            suggest = "msi_resource_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AzureApiManagementSourceResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AzureApiManagementSourceResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AzureApiManagementSourceResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 resource_id: builtins.str,
                 msi_resource_id: Optional[builtins.str] = None):
        """
        API source configuration for Azure API Management.
        :param builtins.str resource_id: API Management service resource ID.
        :param builtins.str msi_resource_id: The resource ID of the managed identity that has access to the API Management instance.
        """
        pulumi.set(__self__, "resource_id", resource_id)
        if msi_resource_id is not None:
            pulumi.set(__self__, "msi_resource_id", msi_resource_id)

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> builtins.str:
        """
        API Management service resource ID.
        """
        return pulumi.get(self, "resource_id")

    @property
    @pulumi.getter(name="msiResourceId")
    def msi_resource_id(self) -> Optional[builtins.str]:
        """
        The resource ID of the managed identity that has access to the API Management instance.
        """
        return pulumi.get(self, "msi_resource_id")


@pulumi.output_type
class ContactResponse(dict):
    """
    Contact information
    """
    def __init__(__self__, *,
                 email: Optional[builtins.str] = None,
                 name: Optional[builtins.str] = None,
                 url: Optional[builtins.str] = None):
        """
        Contact information
        :param builtins.str email: Email address of the contact.
        :param builtins.str name: Name of the contact.
        :param builtins.str url: URL for the contact.
        """
        if email is not None:
            pulumi.set(__self__, "email", email)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter
    def email(self) -> Optional[builtins.str]:
        """
        Email address of the contact.
        """
        return pulumi.get(self, "email")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        Name of the contact.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def url(self) -> Optional[builtins.str]:
        """
        URL for the contact.
        """
        return pulumi.get(self, "url")


@pulumi.output_type
class DeploymentServerResponse(dict):
    """
    Server
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "runtimeUri":
            suggest = "runtime_uri"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeploymentServerResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeploymentServerResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeploymentServerResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 runtime_uri: Optional[Sequence[builtins.str]] = None):
        """
        Server
        :param Sequence[builtins.str] runtime_uri: Base runtime URLs for this deployment.
        """
        if runtime_uri is not None:
            pulumi.set(__self__, "runtime_uri", runtime_uri)

    @property
    @pulumi.getter(name="runtimeUri")
    def runtime_uri(self) -> Optional[Sequence[builtins.str]]:
        """
        Base runtime URLs for this deployment.
        """
        return pulumi.get(self, "runtime_uri")


@pulumi.output_type
class EnvironmentServerResponse(dict):
    """
    Server information of the environment.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "managementPortalUri":
            suggest = "management_portal_uri"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in EnvironmentServerResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        EnvironmentServerResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        EnvironmentServerResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 management_portal_uri: Optional[Sequence[builtins.str]] = None,
                 type: Optional[builtins.str] = None):
        """
        Server information of the environment.
        :param Sequence[builtins.str] management_portal_uri: The location of the management portal
        :param builtins.str type: Type of the server that represents the environment.
        """
        if management_portal_uri is not None:
            pulumi.set(__self__, "management_portal_uri", management_portal_uri)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="managementPortalUri")
    def management_portal_uri(self) -> Optional[Sequence[builtins.str]]:
        """
        The location of the management portal
        """
        return pulumi.get(self, "management_portal_uri")

    @property
    @pulumi.getter
    def type(self) -> Optional[builtins.str]:
        """
        Type of the server that represents the environment.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class ExternalDocumentationResponse(dict):
    """
    Additional, external documentation for the API.
    """
    def __init__(__self__, *,
                 url: builtins.str,
                 description: Optional[builtins.str] = None,
                 title: Optional[builtins.str] = None):
        """
        Additional, external documentation for the API.
        :param builtins.str url: URL pointing to the documentation.
        :param builtins.str description: Description of the documentation.
        :param builtins.str title: Title of the documentation.
        """
        pulumi.set(__self__, "url", url)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if title is not None:
            pulumi.set(__self__, "title", title)

    @property
    @pulumi.getter
    def url(self) -> builtins.str:
        """
        URL pointing to the documentation.
        """
        return pulumi.get(self, "url")

    @property
    @pulumi.getter
    def description(self) -> Optional[builtins.str]:
        """
        Description of the documentation.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def title(self) -> Optional[builtins.str]:
        """
        Title of the documentation.
        """
        return pulumi.get(self, "title")


@pulumi.output_type
class LicenseResponse(dict):
    """
    The license information for the API.
    """
    def __init__(__self__, *,
                 identifier: Optional[builtins.str] = None,
                 name: Optional[builtins.str] = None,
                 url: Optional[builtins.str] = None):
        """
        The license information for the API.
        :param builtins.str identifier: SPDX license information for the API. The identifier field is mutually
               exclusive of the URL field.
        :param builtins.str name: Name of the license.
        :param builtins.str url: URL pointing to the license details. The URL field is mutually exclusive of the
               identifier field.
        """
        if identifier is not None:
            pulumi.set(__self__, "identifier", identifier)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter
    def identifier(self) -> Optional[builtins.str]:
        """
        SPDX license information for the API. The identifier field is mutually
        exclusive of the URL field.
        """
        return pulumi.get(self, "identifier")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        Name of the license.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def url(self) -> Optional[builtins.str]:
        """
        URL pointing to the license details. The URL field is mutually exclusive of the
        identifier field.
        """
        return pulumi.get(self, "url")


@pulumi.output_type
class LinkStateResponse(dict):
    """
    The link state.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "lastUpdatedOn":
            suggest = "last_updated_on"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinkStateResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinkStateResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinkStateResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 last_updated_on: builtins.str,
                 message: Optional[builtins.str] = None,
                 state: Optional[builtins.str] = None):
        """
        The link state.
        :param builtins.str last_updated_on: The timestamp of the last update of the link state.
        :param builtins.str message: The state message.
        :param builtins.str state: The state of the link.
        """
        pulumi.set(__self__, "last_updated_on", last_updated_on)
        if message is not None:
            pulumi.set(__self__, "message", message)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="lastUpdatedOn")
    def last_updated_on(self) -> builtins.str:
        """
        The timestamp of the last update of the link state.
        """
        return pulumi.get(self, "last_updated_on")

    @property
    @pulumi.getter
    def message(self) -> Optional[builtins.str]:
        """
        The state message.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter
    def state(self) -> Optional[builtins.str]:
        """
        The state of the link.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class ManagedServiceIdentityResponse(dict):
    """
    Managed service identity (system assigned and/or user assigned identities)
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "principalId":
            suggest = "principal_id"
        elif key == "tenantId":
            suggest = "tenant_id"
        elif key == "userAssignedIdentities":
            suggest = "user_assigned_identities"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ManagedServiceIdentityResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ManagedServiceIdentityResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ManagedServiceIdentityResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 principal_id: builtins.str,
                 tenant_id: builtins.str,
                 type: builtins.str,
                 user_assigned_identities: Optional[Mapping[str, 'outputs.UserAssignedIdentityResponse']] = None):
        """
        Managed service identity (system assigned and/or user assigned identities)
        :param builtins.str principal_id: The service principal ID of the system assigned identity. This property will only be provided for a system assigned identity.
        :param builtins.str tenant_id: The tenant ID of the system assigned identity. This property will only be provided for a system assigned identity.
        :param builtins.str type: Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        :param Mapping[str, 'UserAssignedIdentityResponse'] user_assigned_identities: The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        pulumi.set(__self__, "principal_id", principal_id)
        pulumi.set(__self__, "tenant_id", tenant_id)
        pulumi.set(__self__, "type", type)
        if user_assigned_identities is not None:
            pulumi.set(__self__, "user_assigned_identities", user_assigned_identities)

    @property
    @pulumi.getter(name="principalId")
    def principal_id(self) -> builtins.str:
        """
        The service principal ID of the system assigned identity. This property will only be provided for a system assigned identity.
        """
        return pulumi.get(self, "principal_id")

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> builtins.str:
        """
        The tenant ID of the system assigned identity. This property will only be provided for a system assigned identity.
        """
        return pulumi.get(self, "tenant_id")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="userAssignedIdentities")
    def user_assigned_identities(self) -> Optional[Mapping[str, 'outputs.UserAssignedIdentityResponse']]:
        """
        The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        return pulumi.get(self, "user_assigned_identities")


@pulumi.output_type
class MetadataAssignmentResponse(dict):
    """
    Assignment metadata
    """
    def __init__(__self__, *,
                 deprecated: Optional[builtins.bool] = None,
                 entity: Optional[builtins.str] = None,
                 required: Optional[builtins.bool] = None):
        """
        Assignment metadata
        :param builtins.bool deprecated: Deprecated assignment
        :param builtins.str entity: The entities this metadata schema component gets applied to.
        :param builtins.bool required: Required assignment
        """
        if deprecated is not None:
            pulumi.set(__self__, "deprecated", deprecated)
        if entity is not None:
            pulumi.set(__self__, "entity", entity)
        if required is not None:
            pulumi.set(__self__, "required", required)

    @property
    @pulumi.getter
    def deprecated(self) -> Optional[builtins.bool]:
        """
        Deprecated assignment
        """
        return pulumi.get(self, "deprecated")

    @property
    @pulumi.getter
    def entity(self) -> Optional[builtins.str]:
        """
        The entities this metadata schema component gets applied to.
        """
        return pulumi.get(self, "entity")

    @property
    @pulumi.getter
    def required(self) -> Optional[builtins.bool]:
        """
        Required assignment
        """
        return pulumi.get(self, "required")


@pulumi.output_type
class OnboardingResponse(dict):
    """
    Onboarding information
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "developerPortalUri":
            suggest = "developer_portal_uri"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in OnboardingResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        OnboardingResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        OnboardingResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 developer_portal_uri: Optional[Sequence[builtins.str]] = None,
                 instructions: Optional[builtins.str] = None):
        """
        Onboarding information
        :param Sequence[builtins.str] developer_portal_uri: The location of the development portal
        :param builtins.str instructions: Onboarding guide.
        """
        if developer_portal_uri is not None:
            pulumi.set(__self__, "developer_portal_uri", developer_portal_uri)
        if instructions is not None:
            pulumi.set(__self__, "instructions", instructions)

    @property
    @pulumi.getter(name="developerPortalUri")
    def developer_portal_uri(self) -> Optional[Sequence[builtins.str]]:
        """
        The location of the development portal
        """
        return pulumi.get(self, "developer_portal_uri")

    @property
    @pulumi.getter
    def instructions(self) -> Optional[builtins.str]:
        """
        Onboarding guide.
        """
        return pulumi.get(self, "instructions")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[builtins.str] = None,
                 created_by: Optional[builtins.str] = None,
                 created_by_type: Optional[builtins.str] = None,
                 last_modified_at: Optional[builtins.str] = None,
                 last_modified_by: Optional[builtins.str] = None,
                 last_modified_by_type: Optional[builtins.str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param builtins.str created_at: The timestamp of resource creation (UTC).
        :param builtins.str created_by: The identity that created the resource.
        :param builtins.str created_by_type: The type of identity that created the resource.
        :param builtins.str last_modified_at: The timestamp of resource last modification (UTC)
        :param builtins.str last_modified_by: The identity that last modified the resource.
        :param builtins.str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[builtins.str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[builtins.str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[builtins.str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[builtins.str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[builtins.str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[builtins.str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


@pulumi.output_type
class TermsOfServiceResponse(dict):
    """
    Terms of service for the API.
    """
    def __init__(__self__, *,
                 url: builtins.str):
        """
        Terms of service for the API.
        :param builtins.str url: URL pointing to the terms of service.
        """
        pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter
    def url(self) -> builtins.str:
        """
        URL pointing to the terms of service.
        """
        return pulumi.get(self, "url")


@pulumi.output_type
class UserAssignedIdentityResponse(dict):
    """
    User assigned identity properties
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "clientId":
            suggest = "client_id"
        elif key == "principalId":
            suggest = "principal_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in UserAssignedIdentityResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        UserAssignedIdentityResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        UserAssignedIdentityResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 client_id: builtins.str,
                 principal_id: builtins.str):
        """
        User assigned identity properties
        :param builtins.str client_id: The client ID of the assigned identity.
        :param builtins.str principal_id: The principal ID of the assigned identity.
        """
        pulumi.set(__self__, "client_id", client_id)
        pulumi.set(__self__, "principal_id", principal_id)

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> builtins.str:
        """
        The client ID of the assigned identity.
        """
        return pulumi.get(self, "client_id")

    @property
    @pulumi.getter(name="principalId")
    def principal_id(self) -> builtins.str:
        """
        The principal ID of the assigned identity.
        """
        return pulumi.get(self, "principal_id")


