# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetWorkspaceApiDiagnosticResult',
    'AwaitableGetWorkspaceApiDiagnosticResult',
    'get_workspace_api_diagnostic',
    'get_workspace_api_diagnostic_output',
]

@pulumi.output_type
class GetWorkspaceApiDiagnosticResult:
    """
    Diagnostic details.
    """
    def __init__(__self__, always_log=None, azure_api_version=None, backend=None, frontend=None, http_correlation_protocol=None, id=None, large_language_model=None, log_client_ip=None, logger_id=None, metrics=None, name=None, operation_name_format=None, sampling=None, type=None, verbosity=None):
        if always_log and not isinstance(always_log, str):
            raise TypeError("Expected argument 'always_log' to be a str")
        pulumi.set(__self__, "always_log", always_log)
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if backend and not isinstance(backend, dict):
            raise TypeError("Expected argument 'backend' to be a dict")
        pulumi.set(__self__, "backend", backend)
        if frontend and not isinstance(frontend, dict):
            raise TypeError("Expected argument 'frontend' to be a dict")
        pulumi.set(__self__, "frontend", frontend)
        if http_correlation_protocol and not isinstance(http_correlation_protocol, str):
            raise TypeError("Expected argument 'http_correlation_protocol' to be a str")
        pulumi.set(__self__, "http_correlation_protocol", http_correlation_protocol)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if large_language_model and not isinstance(large_language_model, dict):
            raise TypeError("Expected argument 'large_language_model' to be a dict")
        pulumi.set(__self__, "large_language_model", large_language_model)
        if log_client_ip and not isinstance(log_client_ip, bool):
            raise TypeError("Expected argument 'log_client_ip' to be a bool")
        pulumi.set(__self__, "log_client_ip", log_client_ip)
        if logger_id and not isinstance(logger_id, str):
            raise TypeError("Expected argument 'logger_id' to be a str")
        pulumi.set(__self__, "logger_id", logger_id)
        if metrics and not isinstance(metrics, bool):
            raise TypeError("Expected argument 'metrics' to be a bool")
        pulumi.set(__self__, "metrics", metrics)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if operation_name_format and not isinstance(operation_name_format, str):
            raise TypeError("Expected argument 'operation_name_format' to be a str")
        pulumi.set(__self__, "operation_name_format", operation_name_format)
        if sampling and not isinstance(sampling, dict):
            raise TypeError("Expected argument 'sampling' to be a dict")
        pulumi.set(__self__, "sampling", sampling)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if verbosity and not isinstance(verbosity, str):
            raise TypeError("Expected argument 'verbosity' to be a str")
        pulumi.set(__self__, "verbosity", verbosity)

    @property
    @pulumi.getter(name="alwaysLog")
    def always_log(self) -> Optional[builtins.str]:
        """
        Specifies for what type of messages sampling settings should not apply.
        """
        return pulumi.get(self, "always_log")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def backend(self) -> Optional['outputs.PipelineDiagnosticSettingsResponse']:
        """
        Diagnostic settings for incoming/outgoing HTTP messages to the Backend
        """
        return pulumi.get(self, "backend")

    @property
    @pulumi.getter
    def frontend(self) -> Optional['outputs.PipelineDiagnosticSettingsResponse']:
        """
        Diagnostic settings for incoming/outgoing HTTP messages to the Gateway.
        """
        return pulumi.get(self, "frontend")

    @property
    @pulumi.getter(name="httpCorrelationProtocol")
    def http_correlation_protocol(self) -> Optional[builtins.str]:
        """
        Sets correlation protocol to use for Application Insights diagnostics.
        """
        return pulumi.get(self, "http_correlation_protocol")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="largeLanguageModel")
    def large_language_model(self) -> Optional['outputs.LLMDiagnosticSettingsResponse']:
        """
        Large Language Models diagnostic settings
        """
        return pulumi.get(self, "large_language_model")

    @property
    @pulumi.getter(name="logClientIp")
    def log_client_ip(self) -> Optional[builtins.bool]:
        """
        Log the ClientIP. Default is false.
        """
        return pulumi.get(self, "log_client_ip")

    @property
    @pulumi.getter(name="loggerId")
    def logger_id(self) -> builtins.str:
        """
        Resource Id of a target logger.
        """
        return pulumi.get(self, "logger_id")

    @property
    @pulumi.getter
    def metrics(self) -> Optional[builtins.bool]:
        """
        Emit custom metrics via emit-metric policy. Applicable only to Application Insights diagnostic settings.
        """
        return pulumi.get(self, "metrics")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="operationNameFormat")
    def operation_name_format(self) -> Optional[builtins.str]:
        """
        The format of the Operation Name for Application Insights telemetries. Default is Name.
        """
        return pulumi.get(self, "operation_name_format")

    @property
    @pulumi.getter
    def sampling(self) -> Optional['outputs.SamplingSettingsResponse']:
        """
        Sampling settings for Diagnostic.
        """
        return pulumi.get(self, "sampling")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def verbosity(self) -> Optional[builtins.str]:
        """
        The verbosity level applied to traces emitted by trace policies.
        """
        return pulumi.get(self, "verbosity")


class AwaitableGetWorkspaceApiDiagnosticResult(GetWorkspaceApiDiagnosticResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWorkspaceApiDiagnosticResult(
            always_log=self.always_log,
            azure_api_version=self.azure_api_version,
            backend=self.backend,
            frontend=self.frontend,
            http_correlation_protocol=self.http_correlation_protocol,
            id=self.id,
            large_language_model=self.large_language_model,
            log_client_ip=self.log_client_ip,
            logger_id=self.logger_id,
            metrics=self.metrics,
            name=self.name,
            operation_name_format=self.operation_name_format,
            sampling=self.sampling,
            type=self.type,
            verbosity=self.verbosity)


def get_workspace_api_diagnostic(api_id: Optional[builtins.str] = None,
                                 diagnostic_id: Optional[builtins.str] = None,
                                 resource_group_name: Optional[builtins.str] = None,
                                 service_name: Optional[builtins.str] = None,
                                 workspace_id: Optional[builtins.str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWorkspaceApiDiagnosticResult:
    """
    Gets the details of the Diagnostic for an API specified by its identifier.

    Uses Azure REST API version 2024-06-01-preview.

    Other available API versions: 2023-09-01-preview, 2024-05-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native apimanagement [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str api_id: API identifier. Must be unique in the current API Management service instance.
    :param builtins.str diagnostic_id: Diagnostic identifier. Must be unique in the current API Management service instance.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str service_name: The name of the API Management service.
    :param builtins.str workspace_id: Workspace identifier. Must be unique in the current API Management service instance.
    """
    __args__ = dict()
    __args__['apiId'] = api_id
    __args__['diagnosticId'] = diagnostic_id
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    __args__['workspaceId'] = workspace_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:apimanagement:getWorkspaceApiDiagnostic', __args__, opts=opts, typ=GetWorkspaceApiDiagnosticResult).value

    return AwaitableGetWorkspaceApiDiagnosticResult(
        always_log=pulumi.get(__ret__, 'always_log'),
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        backend=pulumi.get(__ret__, 'backend'),
        frontend=pulumi.get(__ret__, 'frontend'),
        http_correlation_protocol=pulumi.get(__ret__, 'http_correlation_protocol'),
        id=pulumi.get(__ret__, 'id'),
        large_language_model=pulumi.get(__ret__, 'large_language_model'),
        log_client_ip=pulumi.get(__ret__, 'log_client_ip'),
        logger_id=pulumi.get(__ret__, 'logger_id'),
        metrics=pulumi.get(__ret__, 'metrics'),
        name=pulumi.get(__ret__, 'name'),
        operation_name_format=pulumi.get(__ret__, 'operation_name_format'),
        sampling=pulumi.get(__ret__, 'sampling'),
        type=pulumi.get(__ret__, 'type'),
        verbosity=pulumi.get(__ret__, 'verbosity'))
def get_workspace_api_diagnostic_output(api_id: Optional[pulumi.Input[builtins.str]] = None,
                                        diagnostic_id: Optional[pulumi.Input[builtins.str]] = None,
                                        resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                        service_name: Optional[pulumi.Input[builtins.str]] = None,
                                        workspace_id: Optional[pulumi.Input[builtins.str]] = None,
                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetWorkspaceApiDiagnosticResult]:
    """
    Gets the details of the Diagnostic for an API specified by its identifier.

    Uses Azure REST API version 2024-06-01-preview.

    Other available API versions: 2023-09-01-preview, 2024-05-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native apimanagement [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str api_id: API identifier. Must be unique in the current API Management service instance.
    :param builtins.str diagnostic_id: Diagnostic identifier. Must be unique in the current API Management service instance.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str service_name: The name of the API Management service.
    :param builtins.str workspace_id: Workspace identifier. Must be unique in the current API Management service instance.
    """
    __args__ = dict()
    __args__['apiId'] = api_id
    __args__['diagnosticId'] = diagnostic_id
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    __args__['workspaceId'] = workspace_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:apimanagement:getWorkspaceApiDiagnostic', __args__, opts=opts, typ=GetWorkspaceApiDiagnosticResult)
    return __ret__.apply(lambda __response__: GetWorkspaceApiDiagnosticResult(
        always_log=pulumi.get(__response__, 'always_log'),
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        backend=pulumi.get(__response__, 'backend'),
        frontend=pulumi.get(__response__, 'frontend'),
        http_correlation_protocol=pulumi.get(__response__, 'http_correlation_protocol'),
        id=pulumi.get(__response__, 'id'),
        large_language_model=pulumi.get(__response__, 'large_language_model'),
        log_client_ip=pulumi.get(__response__, 'log_client_ip'),
        logger_id=pulumi.get(__response__, 'logger_id'),
        metrics=pulumi.get(__response__, 'metrics'),
        name=pulumi.get(__response__, 'name'),
        operation_name_format=pulumi.get(__response__, 'operation_name_format'),
        sampling=pulumi.get(__response__, 'sampling'),
        type=pulumi.get(__response__, 'type'),
        verbosity=pulumi.get(__response__, 'verbosity')))
