# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'ListGatewayDebugCredentialsResult',
    'AwaitableListGatewayDebugCredentialsResult',
    'list_gateway_debug_credentials',
    'list_gateway_debug_credentials_output',
]

@pulumi.output_type
class ListGatewayDebugCredentialsResult:
    """
    Gateway debug credentials.
    """
    def __init__(__self__, token=None):
        if token and not isinstance(token, str):
            raise TypeError("Expected argument 'token' to be a str")
        pulumi.set(__self__, "token", token)

    @property
    @pulumi.getter
    def token(self) -> Optional[builtins.str]:
        """
        Gateway debug token.
        """
        return pulumi.get(self, "token")


class AwaitableListGatewayDebugCredentialsResult(ListGatewayDebugCredentialsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListGatewayDebugCredentialsResult(
            token=self.token)


def list_gateway_debug_credentials(api_id: Optional[builtins.str] = None,
                                   credentials_expire_after: Optional[builtins.str] = None,
                                   gateway_id: Optional[builtins.str] = None,
                                   purposes: Optional[Sequence[Union[builtins.str, 'GatewayListDebugCredentialsContractPurpose']]] = None,
                                   resource_group_name: Optional[builtins.str] = None,
                                   service_name: Optional[builtins.str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListGatewayDebugCredentialsResult:
    """
    Create new debug credentials for gateway.

    Uses Azure REST API version 2024-06-01-preview.

    Other available API versions: 2023-03-01-preview, 2023-05-01-preview, 2023-09-01-preview, 2024-05-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native apimanagement [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str api_id: Full resource Id of an API.
    :param builtins.str credentials_expire_after: Credentials expiration in ISO8601 format. Maximum duration of the credentials is PT1H. When property is not specified, them value PT1H is used.
    :param builtins.str gateway_id: Gateway entity identifier. Must be unique in the current API Management service instance. Must not have value 'managed'
    :param Sequence[Union[builtins.str, 'GatewayListDebugCredentialsContractPurpose']] purposes: Purposes of debug credential.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str service_name: The name of the API Management service.
    """
    __args__ = dict()
    __args__['apiId'] = api_id
    __args__['credentialsExpireAfter'] = credentials_expire_after
    __args__['gatewayId'] = gateway_id
    __args__['purposes'] = purposes
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:apimanagement:listGatewayDebugCredentials', __args__, opts=opts, typ=ListGatewayDebugCredentialsResult).value

    return AwaitableListGatewayDebugCredentialsResult(
        token=pulumi.get(__ret__, 'token'))
def list_gateway_debug_credentials_output(api_id: Optional[pulumi.Input[builtins.str]] = None,
                                          credentials_expire_after: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                          gateway_id: Optional[pulumi.Input[builtins.str]] = None,
                                          purposes: Optional[pulumi.Input[Sequence[Union[builtins.str, 'GatewayListDebugCredentialsContractPurpose']]]] = None,
                                          resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                          service_name: Optional[pulumi.Input[builtins.str]] = None,
                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListGatewayDebugCredentialsResult]:
    """
    Create new debug credentials for gateway.

    Uses Azure REST API version 2024-06-01-preview.

    Other available API versions: 2023-03-01-preview, 2023-05-01-preview, 2023-09-01-preview, 2024-05-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native apimanagement [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str api_id: Full resource Id of an API.
    :param builtins.str credentials_expire_after: Credentials expiration in ISO8601 format. Maximum duration of the credentials is PT1H. When property is not specified, them value PT1H is used.
    :param builtins.str gateway_id: Gateway entity identifier. Must be unique in the current API Management service instance. Must not have value 'managed'
    :param Sequence[Union[builtins.str, 'GatewayListDebugCredentialsContractPurpose']] purposes: Purposes of debug credential.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str service_name: The name of the API Management service.
    """
    __args__ = dict()
    __args__['apiId'] = api_id
    __args__['credentialsExpireAfter'] = credentials_expire_after
    __args__['gatewayId'] = gateway_id
    __args__['purposes'] = purposes
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:apimanagement:listGatewayDebugCredentials', __args__, opts=opts, typ=ListGatewayDebugCredentialsResult)
    return __ret__.apply(lambda __response__: ListGatewayDebugCredentialsResult(
        token=pulumi.get(__response__, 'token')))
