# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AccessMode',
    'Action',
    'ActiveRevisionsMode',
    'Affinity',
    'AppProtocol',
    'BindingType',
    'ClientCredentialMethod',
    'ContainerType',
    'CookieExpirationConvention',
    'DotNetComponentType',
    'ExecutionType',
    'ExtendedLocationTypes',
    'ForwardProxyConvention',
    'IdentitySettingsLifeCycle',
    'IngressClientCertificateMode',
    'IngressTransportMethod',
    'JavaComponentType',
    'LogLevel',
    'ManagedCertificateDomainControlValidation',
    'ManagedServiceIdentityType',
    'PoolManagementType',
    'PrivateEndpointServiceConnectionStatus',
    'Scheme',
    'SessionNetworkStatus',
    'StorageType',
    'TriggerType',
    'Type',
    'UnauthenticatedClientActionV2',
    'WeekDay',
]


@pulumi.type_token("azure-native:app:AccessMode")
class AccessMode(builtins.str, Enum):
    """
    Access mode for storage
    """
    READ_ONLY = "ReadOnly"
    READ_WRITE = "ReadWrite"


@pulumi.type_token("azure-native:app:Action")
class Action(builtins.str, Enum):
    """
    Allow or Deny rules to determine for incoming IP. Note: Rules can only consist of ALL Allow or ALL Deny
    """
    ALLOW = "Allow"
    DENY = "Deny"


@pulumi.type_token("azure-native:app:ActiveRevisionsMode")
class ActiveRevisionsMode(builtins.str, Enum):
    """
    ActiveRevisionsMode controls how active revisions are handled for the Container app:
    <list><item>Multiple: multiple revisions can be active.</item><item>Single: Only one revision can be active at a time. Revision weights can not be used in this mode. If no value if provided, this is the default.</item></list>
    """
    MULTIPLE = "Multiple"
    SINGLE = "Single"


@pulumi.type_token("azure-native:app:Affinity")
class Affinity(builtins.str, Enum):
    """
    Sticky Session Affinity
    """
    STICKY = "sticky"
    NONE = "none"


@pulumi.type_token("azure-native:app:AppProtocol")
class AppProtocol(builtins.str, Enum):
    """
    Tells Dapr which protocol your application is using. Valid options are http and grpc. Default is http
    """
    HTTP = "http"
    GRPC = "grpc"


@pulumi.type_token("azure-native:app:BindingType")
class BindingType(builtins.str, Enum):
    """
    Custom Domain binding type.
    """
    DISABLED = "Disabled"
    SNI_ENABLED = "SniEnabled"
    AUTO = "Auto"


@pulumi.type_token("azure-native:app:ClientCredentialMethod")
class ClientCredentialMethod(builtins.str, Enum):
    """
    The method that should be used to authenticate the user.
    """
    CLIENT_SECRET_POST = "ClientSecretPost"


@pulumi.type_token("azure-native:app:ContainerType")
class ContainerType(builtins.str, Enum):
    """
    The container type of the sessions.
    """
    CUSTOM_CONTAINER = "CustomContainer"
    PYTHON_LTS = "PythonLTS"


@pulumi.type_token("azure-native:app:CookieExpirationConvention")
class CookieExpirationConvention(builtins.str, Enum):
    """
    The convention used when determining the session cookie's expiration.
    """
    FIXED_TIME = "FixedTime"
    IDENTITY_PROVIDER_DERIVED = "IdentityProviderDerived"


@pulumi.type_token("azure-native:app:DotNetComponentType")
class DotNetComponentType(builtins.str, Enum):
    """
    Type of the .NET Component.
    """
    ASPIRE_DASHBOARD = "AspireDashboard"


@pulumi.type_token("azure-native:app:ExecutionType")
class ExecutionType(builtins.str, Enum):
    """
    The execution type of the session pool.
    """
    TIMED = "Timed"


@pulumi.type_token("azure-native:app:ExtendedLocationTypes")
class ExtendedLocationTypes(builtins.str, Enum):
    """
    The type of the extended location.
    """
    CUSTOM_LOCATION = "CustomLocation"


@pulumi.type_token("azure-native:app:ForwardProxyConvention")
class ForwardProxyConvention(builtins.str, Enum):
    """
    The convention used to determine the url of the request made.
    """
    NO_PROXY = "NoProxy"
    STANDARD = "Standard"
    CUSTOM = "Custom"


@pulumi.type_token("azure-native:app:IdentitySettingsLifeCycle")
class IdentitySettingsLifeCycle(builtins.str, Enum):
    """
    Use to select the lifecycle stages of a Session Pool during which the Managed Identity should be available.
    """
    NONE = "None"
    MAIN = "Main"


@pulumi.type_token("azure-native:app:IngressClientCertificateMode")
class IngressClientCertificateMode(builtins.str, Enum):
    """
    Client certificate mode for mTLS authentication. Ignore indicates server drops client certificate on forwarding. Accept indicates server forwards client certificate but does not require a client certificate. Require indicates server requires a client certificate.
    """
    IGNORE = "ignore"
    ACCEPT = "accept"
    REQUIRE = "require"


@pulumi.type_token("azure-native:app:IngressTransportMethod")
class IngressTransportMethod(builtins.str, Enum):
    """
    Ingress transport protocol
    """
    AUTO = "auto"
    HTTP = "http"
    HTTP2 = "http2"
    TCP = "tcp"


@pulumi.type_token("azure-native:app:JavaComponentType")
class JavaComponentType(builtins.str, Enum):
    """
    Type of the Java Component.
    """
    SPRING_BOOT_ADMIN = "SpringBootAdmin"
    SPRING_CLOUD_EUREKA = "SpringCloudEureka"
    SPRING_CLOUD_CONFIG = "SpringCloudConfig"
    SPRING_CLOUD_GATEWAY = "SpringCloudGateway"
    NACOS = "Nacos"


@pulumi.type_token("azure-native:app:LogLevel")
class LogLevel(builtins.str, Enum):
    """
    Sets the log level for the Dapr sidecar. Allowed values are debug, info, warn, error. Default is info.
    """
    INFO = "info"
    DEBUG = "debug"
    WARN = "warn"
    ERROR = "error"


@pulumi.type_token("azure-native:app:ManagedCertificateDomainControlValidation")
class ManagedCertificateDomainControlValidation(builtins.str, Enum):
    """
    Selected type of domain control validation for managed certificates.
    """
    CNAME = "CNAME"
    HTTP = "HTTP"
    TXT = "TXT"


@pulumi.type_token("azure-native:app:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


@pulumi.type_token("azure-native:app:PoolManagementType")
class PoolManagementType(builtins.str, Enum):
    """
    The pool management type of the session pool.
    """
    MANUAL = "Manual"
    DYNAMIC = "Dynamic"


@pulumi.type_token("azure-native:app:PrivateEndpointServiceConnectionStatus")
class PrivateEndpointServiceConnectionStatus(builtins.str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"
    DISCONNECTED = "Disconnected"


@pulumi.type_token("azure-native:app:Scheme")
class Scheme(builtins.str, Enum):
    """
    Scheme to use for connecting to the host. Defaults to HTTP.
    """
    HTTP = "HTTP"
    HTTPS = "HTTPS"


@pulumi.type_token("azure-native:app:SessionNetworkStatus")
class SessionNetworkStatus(builtins.str, Enum):
    """
    Network status for the sessions.
    """
    EGRESS_ENABLED = "EgressEnabled"
    EGRESS_DISABLED = "EgressDisabled"


@pulumi.type_token("azure-native:app:StorageType")
class StorageType(builtins.str, Enum):
    """
    Storage type for the volume. If not provided, use EmptyDir.
    """
    AZURE_FILE = "AzureFile"
    EMPTY_DIR = "EmptyDir"
    SECRET = "Secret"


@pulumi.type_token("azure-native:app:TriggerType")
class TriggerType(builtins.str, Enum):
    """
    Trigger type of the job
    """
    SCHEDULE = "Schedule"
    EVENT = "Event"
    MANUAL = "Manual"


@pulumi.type_token("azure-native:app:Type")
class Type(builtins.str, Enum):
    """
    The type of probe.
    """
    LIVENESS = "Liveness"
    READINESS = "Readiness"
    STARTUP = "Startup"


@pulumi.type_token("azure-native:app:UnauthenticatedClientActionV2")
class UnauthenticatedClientActionV2(builtins.str, Enum):
    """
    The action to take when an unauthenticated client attempts to access the app.
    """
    REDIRECT_TO_LOGIN_PAGE = "RedirectToLoginPage"
    ALLOW_ANONYMOUS = "AllowAnonymous"
    RETURN401 = "Return401"
    RETURN403 = "Return403"


@pulumi.type_token("azure-native:app:WeekDay")
class WeekDay(builtins.str, Enum):
    """
    Day of the week when a managed environment can be patched.
    """
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"
    SUNDAY = "Sunday"
