# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetDaprComponentResiliencyPolicyResult',
    'AwaitableGetDaprComponentResiliencyPolicyResult',
    'get_dapr_component_resiliency_policy',
    'get_dapr_component_resiliency_policy_output',
]

@pulumi.output_type
class GetDaprComponentResiliencyPolicyResult:
    """
    Dapr Component Resiliency Policy.
    """
    def __init__(__self__, azure_api_version=None, id=None, inbound_policy=None, name=None, outbound_policy=None, system_data=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if inbound_policy and not isinstance(inbound_policy, dict):
            raise TypeError("Expected argument 'inbound_policy' to be a dict")
        pulumi.set(__self__, "inbound_policy", inbound_policy)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if outbound_policy and not isinstance(outbound_policy, dict):
            raise TypeError("Expected argument 'outbound_policy' to be a dict")
        pulumi.set(__self__, "outbound_policy", outbound_policy)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="inboundPolicy")
    def inbound_policy(self) -> Optional['outputs.DaprComponentResiliencyPolicyConfigurationResponse']:
        """
        The optional inbound component resiliency policy configuration
        """
        return pulumi.get(self, "inbound_policy")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="outboundPolicy")
    def outbound_policy(self) -> Optional['outputs.DaprComponentResiliencyPolicyConfigurationResponse']:
        """
        The optional outbound component resiliency policy configuration
        """
        return pulumi.get(self, "outbound_policy")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetDaprComponentResiliencyPolicyResult(GetDaprComponentResiliencyPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDaprComponentResiliencyPolicyResult(
            azure_api_version=self.azure_api_version,
            id=self.id,
            inbound_policy=self.inbound_policy,
            name=self.name,
            outbound_policy=self.outbound_policy,
            system_data=self.system_data,
            type=self.type)


def get_dapr_component_resiliency_policy(component_name: Optional[builtins.str] = None,
                                         environment_name: Optional[builtins.str] = None,
                                         name: Optional[builtins.str] = None,
                                         resource_group_name: Optional[builtins.str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDaprComponentResiliencyPolicyResult:
    """
    Dapr Component Resiliency Policy.

    Uses Azure REST API version 2024-10-02-preview.

    Other available API versions: 2023-08-01-preview, 2023-11-02-preview, 2024-02-02-preview, 2024-08-02-preview, 2025-02-02-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native app [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str component_name: Name of the Dapr Component.
    :param builtins.str environment_name: Name of the Managed Environment.
    :param builtins.str name: Name of the Dapr Component Resiliency Policy.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['componentName'] = component_name
    __args__['environmentName'] = environment_name
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:app:getDaprComponentResiliencyPolicy', __args__, opts=opts, typ=GetDaprComponentResiliencyPolicyResult).value

    return AwaitableGetDaprComponentResiliencyPolicyResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        inbound_policy=pulumi.get(__ret__, 'inbound_policy'),
        name=pulumi.get(__ret__, 'name'),
        outbound_policy=pulumi.get(__ret__, 'outbound_policy'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_dapr_component_resiliency_policy_output(component_name: Optional[pulumi.Input[builtins.str]] = None,
                                                environment_name: Optional[pulumi.Input[builtins.str]] = None,
                                                name: Optional[pulumi.Input[builtins.str]] = None,
                                                resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDaprComponentResiliencyPolicyResult]:
    """
    Dapr Component Resiliency Policy.

    Uses Azure REST API version 2024-10-02-preview.

    Other available API versions: 2023-08-01-preview, 2023-11-02-preview, 2024-02-02-preview, 2024-08-02-preview, 2025-02-02-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native app [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str component_name: Name of the Dapr Component.
    :param builtins.str environment_name: Name of the Managed Environment.
    :param builtins.str name: Name of the Dapr Component Resiliency Policy.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['componentName'] = component_name
    __args__['environmentName'] = environment_name
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:app:getDaprComponentResiliencyPolicy', __args__, opts=opts, typ=GetDaprComponentResiliencyPolicyResult)
    return __ret__.apply(lambda __response__: GetDaprComponentResiliencyPolicyResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        inbound_policy=pulumi.get(__response__, 'inbound_policy'),
        name=pulumi.get(__response__, 'name'),
        outbound_policy=pulumi.get(__response__, 'outbound_policy'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
