# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetDaprSubscriptionResult',
    'AwaitableGetDaprSubscriptionResult',
    'get_dapr_subscription',
    'get_dapr_subscription_output',
]

@pulumi.output_type
class GetDaprSubscriptionResult:
    """
    Dapr PubSub Event Subscription.
    """
    def __init__(__self__, azure_api_version=None, bulk_subscribe=None, dead_letter_topic=None, id=None, metadata=None, name=None, pubsub_name=None, routes=None, scopes=None, system_data=None, topic=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if bulk_subscribe and not isinstance(bulk_subscribe, dict):
            raise TypeError("Expected argument 'bulk_subscribe' to be a dict")
        pulumi.set(__self__, "bulk_subscribe", bulk_subscribe)
        if dead_letter_topic and not isinstance(dead_letter_topic, str):
            raise TypeError("Expected argument 'dead_letter_topic' to be a str")
        pulumi.set(__self__, "dead_letter_topic", dead_letter_topic)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if metadata and not isinstance(metadata, dict):
            raise TypeError("Expected argument 'metadata' to be a dict")
        pulumi.set(__self__, "metadata", metadata)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if pubsub_name and not isinstance(pubsub_name, str):
            raise TypeError("Expected argument 'pubsub_name' to be a str")
        pulumi.set(__self__, "pubsub_name", pubsub_name)
        if routes and not isinstance(routes, dict):
            raise TypeError("Expected argument 'routes' to be a dict")
        pulumi.set(__self__, "routes", routes)
        if scopes and not isinstance(scopes, list):
            raise TypeError("Expected argument 'scopes' to be a list")
        pulumi.set(__self__, "scopes", scopes)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if topic and not isinstance(topic, str):
            raise TypeError("Expected argument 'topic' to be a str")
        pulumi.set(__self__, "topic", topic)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="bulkSubscribe")
    def bulk_subscribe(self) -> Optional['outputs.DaprSubscriptionBulkSubscribeOptionsResponse']:
        """
        Bulk subscription options
        """
        return pulumi.get(self, "bulk_subscribe")

    @property
    @pulumi.getter(name="deadLetterTopic")
    def dead_letter_topic(self) -> Optional[builtins.str]:
        """
        Deadletter topic name
        """
        return pulumi.get(self, "dead_letter_topic")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def metadata(self) -> Optional[Mapping[str, builtins.str]]:
        """
        Subscription metadata
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="pubsubName")
    def pubsub_name(self) -> Optional[builtins.str]:
        """
        Dapr PubSub component name
        """
        return pulumi.get(self, "pubsub_name")

    @property
    @pulumi.getter
    def routes(self) -> Optional['outputs.DaprSubscriptionRoutesResponse']:
        """
        Subscription routes
        """
        return pulumi.get(self, "routes")

    @property
    @pulumi.getter
    def scopes(self) -> Optional[Sequence[builtins.str]]:
        """
        Application scopes to restrict the subscription to specific apps.
        """
        return pulumi.get(self, "scopes")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def topic(self) -> Optional[builtins.str]:
        """
        Topic name
        """
        return pulumi.get(self, "topic")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetDaprSubscriptionResult(GetDaprSubscriptionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDaprSubscriptionResult(
            azure_api_version=self.azure_api_version,
            bulk_subscribe=self.bulk_subscribe,
            dead_letter_topic=self.dead_letter_topic,
            id=self.id,
            metadata=self.metadata,
            name=self.name,
            pubsub_name=self.pubsub_name,
            routes=self.routes,
            scopes=self.scopes,
            system_data=self.system_data,
            topic=self.topic,
            type=self.type)


def get_dapr_subscription(environment_name: Optional[builtins.str] = None,
                          name: Optional[builtins.str] = None,
                          resource_group_name: Optional[builtins.str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDaprSubscriptionResult:
    """
    Dapr PubSub Event Subscription.

    Uses Azure REST API version 2024-10-02-preview.

    Other available API versions: 2023-08-01-preview, 2023-11-02-preview, 2024-02-02-preview, 2024-08-02-preview, 2025-02-02-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native app [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str environment_name: Name of the Managed Environment.
    :param builtins.str name: Name of the Dapr subscription.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['environmentName'] = environment_name
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:app:getDaprSubscription', __args__, opts=opts, typ=GetDaprSubscriptionResult).value

    return AwaitableGetDaprSubscriptionResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        bulk_subscribe=pulumi.get(__ret__, 'bulk_subscribe'),
        dead_letter_topic=pulumi.get(__ret__, 'dead_letter_topic'),
        id=pulumi.get(__ret__, 'id'),
        metadata=pulumi.get(__ret__, 'metadata'),
        name=pulumi.get(__ret__, 'name'),
        pubsub_name=pulumi.get(__ret__, 'pubsub_name'),
        routes=pulumi.get(__ret__, 'routes'),
        scopes=pulumi.get(__ret__, 'scopes'),
        system_data=pulumi.get(__ret__, 'system_data'),
        topic=pulumi.get(__ret__, 'topic'),
        type=pulumi.get(__ret__, 'type'))
def get_dapr_subscription_output(environment_name: Optional[pulumi.Input[builtins.str]] = None,
                                 name: Optional[pulumi.Input[builtins.str]] = None,
                                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDaprSubscriptionResult]:
    """
    Dapr PubSub Event Subscription.

    Uses Azure REST API version 2024-10-02-preview.

    Other available API versions: 2023-08-01-preview, 2023-11-02-preview, 2024-02-02-preview, 2024-08-02-preview, 2025-02-02-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native app [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str environment_name: Name of the Managed Environment.
    :param builtins.str name: Name of the Dapr subscription.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['environmentName'] = environment_name
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:app:getDaprSubscription', __args__, opts=opts, typ=GetDaprSubscriptionResult)
    return __ret__.apply(lambda __response__: GetDaprSubscriptionResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        bulk_subscribe=pulumi.get(__response__, 'bulk_subscribe'),
        dead_letter_topic=pulumi.get(__response__, 'dead_letter_topic'),
        id=pulumi.get(__response__, 'id'),
        metadata=pulumi.get(__response__, 'metadata'),
        name=pulumi.get(__response__, 'name'),
        pubsub_name=pulumi.get(__response__, 'pubsub_name'),
        routes=pulumi.get(__response__, 'routes'),
        scopes=pulumi.get(__response__, 'scopes'),
        system_data=pulumi.get(__response__, 'system_data'),
        topic=pulumi.get(__response__, 'topic'),
        type=pulumi.get(__response__, 'type')))
