# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ApplicationType',
    'FavoriteType',
    'FlowType',
    'IngestionMode',
    'ItemScope',
    'ItemType',
    'Kind',
    'ManagedServiceIdentityType',
    'PublicNetworkAccessType',
    'RequestSource',
    'WebTestKind',
    'WorkbookSharedTypeKind',
]


@pulumi.type_token("azure-native:applicationinsights:ApplicationType")
class ApplicationType(builtins.str, Enum):
    """
    Type of application being monitored.
    """
    WEB = "web"
    OTHER = "other"


@pulumi.type_token("azure-native:applicationinsights:FavoriteType")
class FavoriteType(builtins.str, Enum):
    """
    Enum indicating if this favorite definition is owned by a specific user or is shared between all users with access to the Application Insights component.
    """
    SHARED = "shared"
    USER = "user"


@pulumi.type_token("azure-native:applicationinsights:FlowType")
class FlowType(builtins.str, Enum):
    """
    Used by the Application Insights system to determine what kind of flow this component was created by. This is to be set to 'Bluefield' when creating/updating a component via the REST API.
    """
    BLUEFIELD = "Bluefield"


@pulumi.type_token("azure-native:applicationinsights:IngestionMode")
class IngestionMode(builtins.str, Enum):
    """
    Indicates the flow of the ingestion.
    """
    APPLICATION_INSIGHTS = "ApplicationInsights"
    APPLICATION_INSIGHTS_WITH_DIAGNOSTIC_SETTINGS = "ApplicationInsightsWithDiagnosticSettings"
    LOG_ANALYTICS = "LogAnalytics"


@pulumi.type_token("azure-native:applicationinsights:ItemScope")
class ItemScope(builtins.str, Enum):
    """
    Enum indicating if this item definition is owned by a specific user or is shared between all users with access to the Application Insights component.
    """
    SHARED = "shared"
    USER = "user"


@pulumi.type_token("azure-native:applicationinsights:ItemType")
class ItemType(builtins.str, Enum):
    """
    Enum indicating the type of the Analytics item.
    """
    NONE = "none"
    QUERY = "query"
    RECENT = "recent"
    FUNCTION = "function"


@pulumi.type_token("azure-native:applicationinsights:Kind")
class Kind(builtins.str, Enum):
    """
    The kind of workbook. Choices are user and shared.
    """
    USER = "user"
    SHARED = "shared"


@pulumi.type_token("azure-native:applicationinsights:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


@pulumi.type_token("azure-native:applicationinsights:PublicNetworkAccessType")
class PublicNetworkAccessType(builtins.str, Enum):
    """
    The network access type for accessing Application Insights query.
    """
    ENABLED = "Enabled"
    """
    Enables connectivity to Application Insights through public DNS.
    """
    DISABLED = "Disabled"
    """
    Disables public connectivity to Application Insights through public DNS.
    """


@pulumi.type_token("azure-native:applicationinsights:RequestSource")
class RequestSource(builtins.str, Enum):
    """
    Describes what tool created this Application Insights component. Customers using this API should set this to the default 'rest'.
    """
    REST = "rest"


@pulumi.type_token("azure-native:applicationinsights:WebTestKind")
class WebTestKind(builtins.str, Enum):
    """
    The kind of web test this is, valid choices are ping, multistep and standard.
    """
    PING = "ping"
    MULTISTEP = "multistep"
    STANDARD = "standard"


@pulumi.type_token("azure-native:applicationinsights:WorkbookSharedTypeKind")
class WorkbookSharedTypeKind(builtins.str, Enum):
    """
    The kind of workbook. Only valid value is shared.
    """
    SHARED = "shared"
