# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetBuildServiceBuildResultLogResult',
    'AwaitableGetBuildServiceBuildResultLogResult',
    'get_build_service_build_result_log',
    'get_build_service_build_result_log_output',
]

@pulumi.output_type
class GetBuildServiceBuildResultLogResult:
    """
    Build result log resource properties payload
    """
    def __init__(__self__, blob_url=None):
        if blob_url and not isinstance(blob_url, str):
            raise TypeError("Expected argument 'blob_url' to be a str")
        pulumi.set(__self__, "blob_url", blob_url)

    @property
    @pulumi.getter(name="blobUrl")
    def blob_url(self) -> Optional[builtins.str]:
        """
        The public download URL of this build result log
        """
        return pulumi.get(self, "blob_url")


class AwaitableGetBuildServiceBuildResultLogResult(GetBuildServiceBuildResultLogResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBuildServiceBuildResultLogResult(
            blob_url=self.blob_url)


def get_build_service_build_result_log(build_name: Optional[builtins.str] = None,
                                       build_result_name: Optional[builtins.str] = None,
                                       build_service_name: Optional[builtins.str] = None,
                                       resource_group_name: Optional[builtins.str] = None,
                                       service_name: Optional[builtins.str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBuildServiceBuildResultLogResult:
    """
    Get a KPack build result log download URL.

    Uses Azure REST API version 2024-01-01-preview.

    Other available API versions: 2023-05-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native appplatform [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str build_name: The name of the build resource.
    :param builtins.str build_result_name: The name of the build result resource.
    :param builtins.str build_service_name: The name of the build service resource.
    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['buildName'] = build_name
    __args__['buildResultName'] = build_result_name
    __args__['buildServiceName'] = build_service_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:appplatform:getBuildServiceBuildResultLog', __args__, opts=opts, typ=GetBuildServiceBuildResultLogResult).value

    return AwaitableGetBuildServiceBuildResultLogResult(
        blob_url=pulumi.get(__ret__, 'blob_url'))
def get_build_service_build_result_log_output(build_name: Optional[pulumi.Input[builtins.str]] = None,
                                              build_result_name: Optional[pulumi.Input[builtins.str]] = None,
                                              build_service_name: Optional[pulumi.Input[builtins.str]] = None,
                                              resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                              service_name: Optional[pulumi.Input[builtins.str]] = None,
                                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetBuildServiceBuildResultLogResult]:
    """
    Get a KPack build result log download URL.

    Uses Azure REST API version 2024-01-01-preview.

    Other available API versions: 2023-05-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native appplatform [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str build_name: The name of the build resource.
    :param builtins.str build_result_name: The name of the build result resource.
    :param builtins.str build_service_name: The name of the build service resource.
    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['buildName'] = build_name
    __args__['buildResultName'] = build_result_name
    __args__['buildServiceName'] = build_service_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:appplatform:getBuildServiceBuildResultLog', __args__, opts=opts, typ=GetBuildServiceBuildResultLogResult)
    return __ret__.apply(lambda __response__: GetBuildServiceBuildResultLogResult(
        blob_url=pulumi.get(__response__, 'blob_url')))
