# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetDeploymentRemoteDebuggingConfigResult',
    'AwaitableGetDeploymentRemoteDebuggingConfigResult',
    'get_deployment_remote_debugging_config',
    'get_deployment_remote_debugging_config_output',
]

@pulumi.output_type
class GetDeploymentRemoteDebuggingConfigResult:
    """
    Remote debugging config.
    """
    def __init__(__self__, enabled=None, port=None):
        if enabled and not isinstance(enabled, bool):
            raise TypeError("Expected argument 'enabled' to be a bool")
        pulumi.set(__self__, "enabled", enabled)
        if port and not isinstance(port, int):
            raise TypeError("Expected argument 'port' to be a int")
        pulumi.set(__self__, "port", port)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[builtins.bool]:
        """
        Indicate if remote debugging is enabled
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def port(self) -> Optional[builtins.int]:
        """
        Application debugging port
        """
        return pulumi.get(self, "port")


class AwaitableGetDeploymentRemoteDebuggingConfigResult(GetDeploymentRemoteDebuggingConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDeploymentRemoteDebuggingConfigResult(
            enabled=self.enabled,
            port=self.port)


def get_deployment_remote_debugging_config(app_name: Optional[builtins.str] = None,
                                           deployment_name: Optional[builtins.str] = None,
                                           resource_group_name: Optional[builtins.str] = None,
                                           service_name: Optional[builtins.str] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDeploymentRemoteDebuggingConfigResult:
    """
    Get remote debugging config.

    Uses Azure REST API version 2024-01-01-preview.

    Other available API versions: 2023-05-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native appplatform [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str app_name: The name of the App resource.
    :param builtins.str deployment_name: The name of the Deployment resource.
    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['appName'] = app_name
    __args__['deploymentName'] = deployment_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:appplatform:getDeploymentRemoteDebuggingConfig', __args__, opts=opts, typ=GetDeploymentRemoteDebuggingConfigResult).value

    return AwaitableGetDeploymentRemoteDebuggingConfigResult(
        enabled=pulumi.get(__ret__, 'enabled'),
        port=pulumi.get(__ret__, 'port'))
def get_deployment_remote_debugging_config_output(app_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  deployment_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  service_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDeploymentRemoteDebuggingConfigResult]:
    """
    Get remote debugging config.

    Uses Azure REST API version 2024-01-01-preview.

    Other available API versions: 2023-05-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native appplatform [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str app_name: The name of the App resource.
    :param builtins.str deployment_name: The name of the Deployment resource.
    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['appName'] = app_name
    __args__['deploymentName'] = deployment_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:appplatform:getDeploymentRemoteDebuggingConfig', __args__, opts=opts, typ=GetDeploymentRemoteDebuggingConfigResult)
    return __ret__.apply(lambda __response__: GetDeploymentRemoteDebuggingConfigResult(
        enabled=pulumi.get(__response__, 'enabled'),
        port=pulumi.get(__response__, 'port')))
