# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListBuildServiceBuilderDeploymentsResult',
    'AwaitableListBuildServiceBuilderDeploymentsResult',
    'list_build_service_builder_deployments',
    'list_build_service_builder_deployments_output',
]

@pulumi.output_type
class ListBuildServiceBuilderDeploymentsResult:
    """
    A list of deployments resource ids.
    """
    def __init__(__self__, deployments=None):
        if deployments and not isinstance(deployments, list):
            raise TypeError("Expected argument 'deployments' to be a list")
        pulumi.set(__self__, "deployments", deployments)

    @property
    @pulumi.getter
    def deployments(self) -> Optional[Sequence[builtins.str]]:
        """
        A list of deployment resource ids.
        """
        return pulumi.get(self, "deployments")


class AwaitableListBuildServiceBuilderDeploymentsResult(ListBuildServiceBuilderDeploymentsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListBuildServiceBuilderDeploymentsResult(
            deployments=self.deployments)


def list_build_service_builder_deployments(build_service_name: Optional[builtins.str] = None,
                                           builder_name: Optional[builtins.str] = None,
                                           resource_group_name: Optional[builtins.str] = None,
                                           service_name: Optional[builtins.str] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListBuildServiceBuilderDeploymentsResult:
    """
    List deployments that are using the builder.

    Uses Azure REST API version 2024-01-01-preview.

    Other available API versions: 2023-05-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native appplatform [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str build_service_name: The name of the build service resource.
    :param builtins.str builder_name: The name of the builder resource.
    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['buildServiceName'] = build_service_name
    __args__['builderName'] = builder_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:appplatform:listBuildServiceBuilderDeployments', __args__, opts=opts, typ=ListBuildServiceBuilderDeploymentsResult).value

    return AwaitableListBuildServiceBuilderDeploymentsResult(
        deployments=pulumi.get(__ret__, 'deployments'))
def list_build_service_builder_deployments_output(build_service_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  builder_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  service_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListBuildServiceBuilderDeploymentsResult]:
    """
    List deployments that are using the builder.

    Uses Azure REST API version 2024-01-01-preview.

    Other available API versions: 2023-05-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native appplatform [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str build_service_name: The name of the build service resource.
    :param builtins.str builder_name: The name of the builder resource.
    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['buildServiceName'] = build_service_name
    __args__['builderName'] = builder_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:appplatform:listBuildServiceBuilderDeployments', __args__, opts=opts, typ=ListBuildServiceBuilderDeploymentsResult)
    return __ret__.apply(lambda __response__: ListBuildServiceBuilderDeploymentsResult(
        deployments=pulumi.get(__response__, 'deployments')))
