# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListServiceGloballyEnabledApmsResult',
    'AwaitableListServiceGloballyEnabledApmsResult',
    'list_service_globally_enabled_apms',
    'list_service_globally_enabled_apms_output',
]

@pulumi.output_type
class ListServiceGloballyEnabledApmsResult:
    """
    Globally enabled APMs payload
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence[builtins.str]]:
        """
        Collection of the globally enabled APMs
        """
        return pulumi.get(self, "value")


class AwaitableListServiceGloballyEnabledApmsResult(ListServiceGloballyEnabledApmsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListServiceGloballyEnabledApmsResult(
            value=self.value)


def list_service_globally_enabled_apms(resource_group_name: Optional[builtins.str] = None,
                                       service_name: Optional[builtins.str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListServiceGloballyEnabledApmsResult:
    """
    List globally enabled APMs for a Service.

    Uses Azure REST API version 2024-01-01-preview.

    Other available API versions: 2023-05-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native appplatform [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:appplatform:listServiceGloballyEnabledApms', __args__, opts=opts, typ=ListServiceGloballyEnabledApmsResult).value

    return AwaitableListServiceGloballyEnabledApmsResult(
        value=pulumi.get(__ret__, 'value'))
def list_service_globally_enabled_apms_output(resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                              service_name: Optional[pulumi.Input[builtins.str]] = None,
                                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListServiceGloballyEnabledApmsResult]:
    """
    List globally enabled APMs for a Service.

    Uses Azure REST API version 2024-01-01-preview.

    Other available API versions: 2023-05-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native appplatform [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str service_name: The name of the Service resource.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:appplatform:listServiceGloballyEnabledApms', __args__, opts=opts, typ=ListServiceGloballyEnabledApmsResult)
    return __ret__.apply(lambda __response__: ListServiceGloballyEnabledApmsResult(
        value=pulumi.get(__response__, 'value')))
