# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['PolicySetDefinitionArgs', 'PolicySetDefinition']

@pulumi.input_type
class PolicySetDefinitionArgs:
    def __init__(__self__, *,
                 policy_definitions: pulumi.Input[Sequence[pulumi.Input['PolicyDefinitionReferenceArgs']]],
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 display_name: Optional[pulumi.Input[builtins.str]] = None,
                 metadata: Optional[Any] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input['ParameterDefinitionsValueArgs']]]] = None,
                 policy_definition_groups: Optional[pulumi.Input[Sequence[pulumi.Input['PolicyDefinitionGroupArgs']]]] = None,
                 policy_set_definition_name: Optional[pulumi.Input[builtins.str]] = None,
                 policy_type: Optional[pulumi.Input[Union[builtins.str, 'PolicyType']]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 versions: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a PolicySetDefinition resource.
        :param pulumi.Input[Sequence[pulumi.Input['PolicyDefinitionReferenceArgs']]] policy_definitions: An array of policy definition references.
        :param pulumi.Input[builtins.str] description: The policy set definition description.
        :param pulumi.Input[builtins.str] display_name: The display name of the policy set definition.
        :param Any metadata: The policy set definition metadata.  Metadata is an open ended object and is typically a collection of key value pairs.
        :param pulumi.Input[Mapping[str, pulumi.Input['ParameterDefinitionsValueArgs']]] parameters: The policy set definition parameters that can be used in policy definition references.
        :param pulumi.Input[Sequence[pulumi.Input['PolicyDefinitionGroupArgs']]] policy_definition_groups: The metadata describing groups of policy definition references within the policy set definition.
        :param pulumi.Input[builtins.str] policy_set_definition_name: The name of the policy set definition to create.
        :param pulumi.Input[Union[builtins.str, 'PolicyType']] policy_type: The type of policy set definition. Possible values are NotSpecified, BuiltIn, Custom, and Static.
        :param pulumi.Input[builtins.str] version: The policy set definition version in #.#.# format.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] versions: A list of available versions for this policy set definition.
        """
        pulumi.set(__self__, "policy_definitions", policy_definitions)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if parameters is not None:
            pulumi.set(__self__, "parameters", parameters)
        if policy_definition_groups is not None:
            pulumi.set(__self__, "policy_definition_groups", policy_definition_groups)
        if policy_set_definition_name is not None:
            pulumi.set(__self__, "policy_set_definition_name", policy_set_definition_name)
        if policy_type is not None:
            pulumi.set(__self__, "policy_type", policy_type)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if versions is not None:
            pulumi.set(__self__, "versions", versions)

    @property
    @pulumi.getter(name="policyDefinitions")
    def policy_definitions(self) -> pulumi.Input[Sequence[pulumi.Input['PolicyDefinitionReferenceArgs']]]:
        """
        An array of policy definition references.
        """
        return pulumi.get(self, "policy_definitions")

    @policy_definitions.setter
    def policy_definitions(self, value: pulumi.Input[Sequence[pulumi.Input['PolicyDefinitionReferenceArgs']]]):
        pulumi.set(self, "policy_definitions", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The policy set definition description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The display name of the policy set definition.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[Any]:
        """
        The policy set definition metadata.  Metadata is an open ended object and is typically a collection of key value pairs.
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[Any]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input['ParameterDefinitionsValueArgs']]]]:
        """
        The policy set definition parameters that can be used in policy definition references.
        """
        return pulumi.get(self, "parameters")

    @parameters.setter
    def parameters(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input['ParameterDefinitionsValueArgs']]]]):
        pulumi.set(self, "parameters", value)

    @property
    @pulumi.getter(name="policyDefinitionGroups")
    def policy_definition_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PolicyDefinitionGroupArgs']]]]:
        """
        The metadata describing groups of policy definition references within the policy set definition.
        """
        return pulumi.get(self, "policy_definition_groups")

    @policy_definition_groups.setter
    def policy_definition_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PolicyDefinitionGroupArgs']]]]):
        pulumi.set(self, "policy_definition_groups", value)

    @property
    @pulumi.getter(name="policySetDefinitionName")
    def policy_set_definition_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the policy set definition to create.
        """
        return pulumi.get(self, "policy_set_definition_name")

    @policy_set_definition_name.setter
    def policy_set_definition_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "policy_set_definition_name", value)

    @property
    @pulumi.getter(name="policyType")
    def policy_type(self) -> Optional[pulumi.Input[Union[builtins.str, 'PolicyType']]]:
        """
        The type of policy set definition. Possible values are NotSpecified, BuiltIn, Custom, and Static.
        """
        return pulumi.get(self, "policy_type")

    @policy_type.setter
    def policy_type(self, value: Optional[pulumi.Input[Union[builtins.str, 'PolicyType']]]):
        pulumi.set(self, "policy_type", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The policy set definition version in #.#.# format.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter
    def versions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        A list of available versions for this policy set definition.
        """
        return pulumi.get(self, "versions")

    @versions.setter
    def versions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "versions", value)


@pulumi.type_token("azure-native:authorization:PolicySetDefinition")
class PolicySetDefinition(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 display_name: Optional[pulumi.Input[builtins.str]] = None,
                 metadata: Optional[Any] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[Union['ParameterDefinitionsValueArgs', 'ParameterDefinitionsValueArgsDict']]]]] = None,
                 policy_definition_groups: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PolicyDefinitionGroupArgs', 'PolicyDefinitionGroupArgsDict']]]]] = None,
                 policy_definitions: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PolicyDefinitionReferenceArgs', 'PolicyDefinitionReferenceArgsDict']]]]] = None,
                 policy_set_definition_name: Optional[pulumi.Input[builtins.str]] = None,
                 policy_type: Optional[pulumi.Input[Union[builtins.str, 'PolicyType']]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 versions: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        The policy set definition.

        Uses Azure REST API version 2025-01-01. In version 2.x of the Azure Native provider, it used API version 2021-06-01.

        Other available API versions: 2020-09-01, 2021-06-01, 2023-04-01, 2024-05-01, 2025-03-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native authorization [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] description: The policy set definition description.
        :param pulumi.Input[builtins.str] display_name: The display name of the policy set definition.
        :param Any metadata: The policy set definition metadata.  Metadata is an open ended object and is typically a collection of key value pairs.
        :param pulumi.Input[Mapping[str, pulumi.Input[Union['ParameterDefinitionsValueArgs', 'ParameterDefinitionsValueArgsDict']]]] parameters: The policy set definition parameters that can be used in policy definition references.
        :param pulumi.Input[Sequence[pulumi.Input[Union['PolicyDefinitionGroupArgs', 'PolicyDefinitionGroupArgsDict']]]] policy_definition_groups: The metadata describing groups of policy definition references within the policy set definition.
        :param pulumi.Input[Sequence[pulumi.Input[Union['PolicyDefinitionReferenceArgs', 'PolicyDefinitionReferenceArgsDict']]]] policy_definitions: An array of policy definition references.
        :param pulumi.Input[builtins.str] policy_set_definition_name: The name of the policy set definition to create.
        :param pulumi.Input[Union[builtins.str, 'PolicyType']] policy_type: The type of policy set definition. Possible values are NotSpecified, BuiltIn, Custom, and Static.
        :param pulumi.Input[builtins.str] version: The policy set definition version in #.#.# format.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] versions: A list of available versions for this policy set definition.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PolicySetDefinitionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The policy set definition.

        Uses Azure REST API version 2025-01-01. In version 2.x of the Azure Native provider, it used API version 2021-06-01.

        Other available API versions: 2020-09-01, 2021-06-01, 2023-04-01, 2024-05-01, 2025-03-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native authorization [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param PolicySetDefinitionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PolicySetDefinitionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 display_name: Optional[pulumi.Input[builtins.str]] = None,
                 metadata: Optional[Any] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[Union['ParameterDefinitionsValueArgs', 'ParameterDefinitionsValueArgsDict']]]]] = None,
                 policy_definition_groups: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PolicyDefinitionGroupArgs', 'PolicyDefinitionGroupArgsDict']]]]] = None,
                 policy_definitions: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PolicyDefinitionReferenceArgs', 'PolicyDefinitionReferenceArgsDict']]]]] = None,
                 policy_set_definition_name: Optional[pulumi.Input[builtins.str]] = None,
                 policy_type: Optional[pulumi.Input[Union[builtins.str, 'PolicyType']]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 versions: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PolicySetDefinitionArgs.__new__(PolicySetDefinitionArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["display_name"] = display_name
            __props__.__dict__["metadata"] = metadata
            __props__.__dict__["parameters"] = parameters
            __props__.__dict__["policy_definition_groups"] = policy_definition_groups
            if policy_definitions is None and not opts.urn:
                raise TypeError("Missing required property 'policy_definitions'")
            __props__.__dict__["policy_definitions"] = policy_definitions
            __props__.__dict__["policy_set_definition_name"] = policy_set_definition_name
            __props__.__dict__["policy_type"] = policy_type
            __props__.__dict__["version"] = version
            __props__.__dict__["versions"] = versions
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:authorization/v20170601preview:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20180301:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20180501:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20190101:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20190601:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20190901:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20200301:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20200901:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20210601:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20230401:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20240501:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20250101:PolicySetDefinition"), pulumi.Alias(type_="azure-native:authorization/v20250301:PolicySetDefinition")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(PolicySetDefinition, __self__).__init__(
            'azure-native:authorization:PolicySetDefinition',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'PolicySetDefinition':
        """
        Get an existing PolicySetDefinition resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = PolicySetDefinitionArgs.__new__(PolicySetDefinitionArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["description"] = None
        __props__.__dict__["display_name"] = None
        __props__.__dict__["metadata"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["parameters"] = None
        __props__.__dict__["policy_definition_groups"] = None
        __props__.__dict__["policy_definitions"] = None
        __props__.__dict__["policy_type"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["version"] = None
        __props__.__dict__["versions"] = None
        return PolicySetDefinition(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The policy set definition description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The display name of the policy set definition.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def metadata(self) -> pulumi.Output[Optional[Any]]:
        """
        The policy set definition metadata.  Metadata is an open ended object and is typically a collection of key value pairs.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the policy set definition.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def parameters(self) -> pulumi.Output[Optional[Mapping[str, 'outputs.ParameterDefinitionsValueResponse']]]:
        """
        The policy set definition parameters that can be used in policy definition references.
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="policyDefinitionGroups")
    def policy_definition_groups(self) -> pulumi.Output[Optional[Sequence['outputs.PolicyDefinitionGroupResponse']]]:
        """
        The metadata describing groups of policy definition references within the policy set definition.
        """
        return pulumi.get(self, "policy_definition_groups")

    @property
    @pulumi.getter(name="policyDefinitions")
    def policy_definitions(self) -> pulumi.Output[Sequence['outputs.PolicyDefinitionReferenceResponse']]:
        """
        An array of policy definition references.
        """
        return pulumi.get(self, "policy_definitions")

    @property
    @pulumi.getter(name="policyType")
    def policy_type(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The type of policy set definition. Possible values are NotSpecified, BuiltIn, Custom, and Static.
        """
        return pulumi.get(self, "policy_type")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        The system metadata relating to this resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource (Microsoft.Authorization/policySetDefinitions).
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The policy set definition version in #.#.# format.
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter
    def versions(self) -> pulumi.Output[Optional[Sequence[builtins.str]]]:
        """
        A list of available versions for this policy set definition.
        """
        return pulumi.get(self, "versions")

