# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ContentSourceType',
    'EncryptionKeySourceType',
    'LinuxUpdateClasses',
    'OperatingSystemType',
    'ResourceIdentityType',
    'RunbookTypeEnum',
    'ScheduleDay',
    'ScheduleFrequency',
    'SkuNameEnum',
    'SourceType',
    'TagOperators',
    'TokenType',
    'WindowsUpdateClasses',
]


@pulumi.type_token("azure-native:automation:ContentSourceType")
class ContentSourceType(builtins.str, Enum):
    """
    Gets or sets the content source type.
    """
    EMBEDDED_CONTENT = "embeddedContent"
    URI = "uri"


@pulumi.type_token("azure-native:automation:EncryptionKeySourceType")
class EncryptionKeySourceType(builtins.str, Enum):
    """
    Encryption Key Source
    """
    MICROSOFT_AUTOMATION = "Microsoft.Automation"
    MICROSOFT_KEYVAULT = "Microsoft.Keyvault"


@pulumi.type_token("azure-native:automation:LinuxUpdateClasses")
class LinuxUpdateClasses(builtins.str, Enum):
    """
    Update classifications included in the software update configuration.
    """
    UNCLASSIFIED = "Unclassified"
    CRITICAL = "Critical"
    SECURITY = "Security"
    OTHER = "Other"


@pulumi.type_token("azure-native:automation:OperatingSystemType")
class OperatingSystemType(builtins.str, Enum):
    """
    operating system of target machines
    """
    WINDOWS = "Windows"
    LINUX = "Linux"


@pulumi.type_token("azure-native:automation:ResourceIdentityType")
class ResourceIdentityType(builtins.str, Enum):
    """
    The identity type.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:automation:RunbookTypeEnum")
class RunbookTypeEnum(builtins.str, Enum):
    """
    Gets or sets the type of the runbook.
    """
    SCRIPT = "Script"
    GRAPH = "Graph"
    POWER_SHELL_WORKFLOW = "PowerShellWorkflow"
    POWER_SHELL = "PowerShell"
    GRAPH_POWER_SHELL_WORKFLOW = "GraphPowerShellWorkflow"
    GRAPH_POWER_SHELL = "GraphPowerShell"
    PYTHON2 = "Python2"
    PYTHON3 = "Python3"
    POWER_SHELL72 = "PowerShell72"


@pulumi.type_token("azure-native:automation:ScheduleDay")
class ScheduleDay(builtins.str, Enum):
    """
    Day of the occurrence. Must be one of monday, tuesday, wednesday, thursday, friday, saturday, sunday.
    """
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"
    SUNDAY = "Sunday"


@pulumi.type_token("azure-native:automation:ScheduleFrequency")
class ScheduleFrequency(builtins.str, Enum):
    """
    Gets or sets the frequency of the schedule.
    """
    ONE_TIME = "OneTime"
    DAY = "Day"
    HOUR = "Hour"
    WEEK = "Week"
    MONTH = "Month"
    MINUTE = "Minute"
    """
    The minimum allowed interval for Minute schedules is 15 minutes.
    """


@pulumi.type_token("azure-native:automation:SkuNameEnum")
class SkuNameEnum(builtins.str, Enum):
    """
    Gets or sets the SKU name of the account.
    """
    FREE = "Free"
    BASIC = "Basic"


@pulumi.type_token("azure-native:automation:SourceType")
class SourceType(builtins.str, Enum):
    """
    The source type. Must be one of VsoGit, VsoTfvc, GitHub, case sensitive.
    """
    VSO_GIT = "VsoGit"
    VSO_TFVC = "VsoTfvc"
    GIT_HUB = "GitHub"


@pulumi.type_token("azure-native:automation:TagOperators")
class TagOperators(builtins.str, Enum):
    """
    Filter VMs by Any or All specified tags.
    """
    ALL = "All"
    ANY = "Any"


@pulumi.type_token("azure-native:automation:TokenType")
class TokenType(builtins.str, Enum):
    """
    The token type. Must be either PersonalAccessToken or Oauth.
    """
    PERSONAL_ACCESS_TOKEN = "PersonalAccessToken"
    OAUTH = "Oauth"


@pulumi.type_token("azure-native:automation:WindowsUpdateClasses")
class WindowsUpdateClasses(builtins.str, Enum):
    """
    Update classification included in the software update configuration. A comma separated string with required values
    """
    UNCLASSIFIED = "Unclassified"
    CRITICAL = "Critical"
    SECURITY = "Security"
    UPDATE_ROLLUP = "UpdateRollup"
    FEATURE_PACK = "FeaturePack"
    SERVICE_PACK = "ServicePack"
    DEFINITION = "Definition"
    TOOLS = "Tools"
    UPDATES = "Updates"
