# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListKeyByAutomationAccountResult',
    'AwaitableListKeyByAutomationAccountResult',
    'list_key_by_automation_account',
    'list_key_by_automation_account_output',
]

@pulumi.output_type
class ListKeyByAutomationAccountResult:
    def __init__(__self__, keys=None):
        if keys and not isinstance(keys, list):
            raise TypeError("Expected argument 'keys' to be a list")
        pulumi.set(__self__, "keys", keys)

    @property
    @pulumi.getter
    def keys(self) -> Optional[Sequence['outputs.KeyResponse']]:
        """
        Lists the automation keys.
        """
        return pulumi.get(self, "keys")


class AwaitableListKeyByAutomationAccountResult(ListKeyByAutomationAccountResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListKeyByAutomationAccountResult(
            keys=self.keys)


def list_key_by_automation_account(automation_account_name: Optional[builtins.str] = None,
                                   resource_group_name: Optional[builtins.str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListKeyByAutomationAccountResult:
    """
    Retrieve the automation keys for an account.

    Uses Azure REST API version 2023-11-01.

    Other available API versions: 2015-10-31, 2019-06-01, 2020-01-13-preview, 2021-06-22, 2022-08-08, 2023-05-15-preview, 2024-10-23. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native automation [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str automation_account_name: The name of the automation account.
    :param builtins.str resource_group_name: Name of an Azure Resource group.
    """
    __args__ = dict()
    __args__['automationAccountName'] = automation_account_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:automation:listKeyByAutomationAccount', __args__, opts=opts, typ=ListKeyByAutomationAccountResult).value

    return AwaitableListKeyByAutomationAccountResult(
        keys=pulumi.get(__ret__, 'keys'))
def list_key_by_automation_account_output(automation_account_name: Optional[pulumi.Input[builtins.str]] = None,
                                          resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListKeyByAutomationAccountResult]:
    """
    Retrieve the automation keys for an account.

    Uses Azure REST API version 2023-11-01.

    Other available API versions: 2015-10-31, 2019-06-01, 2020-01-13-preview, 2021-06-22, 2022-08-08, 2023-05-15-preview, 2024-10-23. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native automation [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str automation_account_name: The name of the automation account.
    :param builtins.str resource_group_name: Name of an Azure Resource group.
    """
    __args__ = dict()
    __args__['automationAccountName'] = automation_account_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:automation:listKeyByAutomationAccount', __args__, opts=opts, typ=ListKeyByAutomationAccountResult)
    return __ret__.apply(lambda __response__: ListKeyByAutomationAccountResult(
        keys=pulumi.get(__response__, 'keys')))
