# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AccountProvisioningMode',
    'ActivationState',
    'AggregationType',
    'ArcSqlManagedInstanceLicenseType',
    'BillingPlan',
    'DatabaseCreateMode',
    'DatabaseState',
    'EditionType',
    'ExtendedLocationTypes',
    'FailoverGroupPartnerSyncMode',
    'HostType',
    'Infrastructure',
    'InstanceFailoverGroupRole',
    'LicenseCategory',
    'PostgresInstanceSkuTier',
    'RecoveryMode',
    'ScopeType',
    'SqlManagedInstanceSkuName',
    'SqlManagedInstanceSkuTier',
    'SqlVersion',
    'State',
    'Version',
]


@pulumi.type_token("azure-native:azurearcdata:AccountProvisioningMode")
class AccountProvisioningMode(builtins.str, Enum):
    """
    The service account provisioning mode for this Active Directory connector.
    """
    AUTOMATIC = "automatic"
    MANUAL = "manual"


@pulumi.type_token("azure-native:azurearcdata:ActivationState")
class ActivationState(builtins.str, Enum):
    """
    The activation state of the license.
    """
    ACTIVATED = "Activated"
    DEACTIVATED = "Deactivated"


@pulumi.type_token("azure-native:azurearcdata:AggregationType")
class AggregationType(builtins.str, Enum):
    """
    The aggregation type to use for the numerical columns in the dataset.
    """
    AVERAGE = "Average"
    MINIMUM = "Minimum"
    MAXIMUM = "Maximum"
    SUM = "Sum"
    COUNT = "Count"


@pulumi.type_token("azure-native:azurearcdata:ArcSqlManagedInstanceLicenseType")
class ArcSqlManagedInstanceLicenseType(builtins.str, Enum):
    """
    The license type to apply for this managed instance.
    """
    BASE_PRICE = "BasePrice"
    LICENSE_INCLUDED = "LicenseIncluded"
    DISASTER_RECOVERY = "DisasterRecovery"


@pulumi.type_token("azure-native:azurearcdata:BillingPlan")
class BillingPlan(builtins.str, Enum):
    """
    SQL Server license type.
    """
    PAYG = "PAYG"
    PAID = "Paid"


@pulumi.type_token("azure-native:azurearcdata:DatabaseCreateMode")
class DatabaseCreateMode(builtins.str, Enum):
    """
    Database create mode. PointInTimeRestore: Create a database by restoring a point in time backup of an existing database. sourceDatabaseId and restorePointInTime must be specified.
    """
    DEFAULT = "Default"
    POINT_IN_TIME_RESTORE = "PointInTimeRestore"


@pulumi.type_token("azure-native:azurearcdata:DatabaseState")
class DatabaseState(builtins.str, Enum):
    """
    State of the database.
    """
    ONLINE = "Online"
    RESTORING = "Restoring"
    RECOVERING = "Recovering"
    RECOVERY_PENDING = "RecoveryPending"
    SUSPECT = "Suspect"
    EMERGENCY = "Emergency"
    OFFLINE = "Offline"
    COPYING = "Copying"
    OFFLINE_SECONDARY = "OfflineSecondary"


@pulumi.type_token("azure-native:azurearcdata:EditionType")
class EditionType(builtins.str, Enum):
    """
    SQL Server edition.
    """
    EVALUATION = "Evaluation"
    ENTERPRISE = "Enterprise"
    STANDARD = "Standard"
    WEB = "Web"
    DEVELOPER = "Developer"
    EXPRESS = "Express"
    BUSINESS_INTELLIGENCE = "Business Intelligence"


@pulumi.type_token("azure-native:azurearcdata:ExtendedLocationTypes")
class ExtendedLocationTypes(builtins.str, Enum):
    """
    The type of the extended location.
    """
    CUSTOM_LOCATION = "CustomLocation"


@pulumi.type_token("azure-native:azurearcdata:FailoverGroupPartnerSyncMode")
class FailoverGroupPartnerSyncMode(builtins.str, Enum):
    """
    The partner sync mode of the SQL managed instance.
    """
    ASYNC_ = "async"
    SYNC = "sync"


@pulumi.type_token("azure-native:azurearcdata:HostType")
class HostType(builtins.str, Enum):
    """
    Type of host for Azure Arc SQL Server
    """
    AZURE_VIRTUAL_MACHINE = "Azure Virtual Machine"
    AZURE_VM_WARE_VIRTUAL_MACHINE = "Azure VMWare Virtual Machine"
    AZURE_KUBERNETES_SERVICE = "Azure Kubernetes Service"
    AW_S_VM_WARE_VIRTUAL_MACHINE = "AWS VMWare Virtual Machine"
    AW_S_KUBERNETES_SERVICE = "AWS Kubernetes Service"
    GC_P_VM_WARE_VIRTUAL_MACHINE = "GCP VMWare Virtual Machine"
    GC_P_KUBERNETES_SERVICE = "GCP Kubernetes Service"
    CONTAINER = "Container"
    VIRTUAL_MACHINE = "Virtual Machine"
    PHYSICAL_SERVER = "Physical Server"
    AW_S_VIRTUAL_MACHINE = "AWS Virtual Machine"
    GC_P_VIRTUAL_MACHINE = "GCP Virtual Machine"
    OTHER = "Other"


@pulumi.type_token("azure-native:azurearcdata:Infrastructure")
class Infrastructure(builtins.str, Enum):
    """
    The infrastructure the data controller is running on.
    """
    AZURE = "azure"
    GCP = "gcp"
    AWS = "aws"
    ALIBABA = "alibaba"
    ONPREMISES = "onpremises"
    OTHER = "other"


@pulumi.type_token("azure-native:azurearcdata:InstanceFailoverGroupRole")
class InstanceFailoverGroupRole(builtins.str, Enum):
    """
    The role of the SQL managed instance in this failover group.
    """
    PRIMARY = "primary"
    SECONDARY = "secondary"
    FORCE_PRIMARY_ALLOW_DATA_LOSS = "force-primary-allow-data-loss"
    FORCE_SECONDARY = "force-secondary"


@pulumi.type_token("azure-native:azurearcdata:LicenseCategory")
class LicenseCategory(builtins.str, Enum):
    """
    This property represents the choice between SQL Server Core and ESU licenses.
    """
    CORE = "Core"


@pulumi.type_token("azure-native:azurearcdata:PostgresInstanceSkuTier")
class PostgresInstanceSkuTier(builtins.str, Enum):
    """
    This field is required to be implemented by the Resource Provider if the service has more than one tier.
    """
    HYPERSCALE = "Hyperscale"


@pulumi.type_token("azure-native:azurearcdata:RecoveryMode")
class RecoveryMode(builtins.str, Enum):
    """
    Status of the database.
    """
    FULL = "Full"
    BULK_LOGGED = "Bulk-logged"
    SIMPLE = "Simple"


@pulumi.type_token("azure-native:azurearcdata:ScopeType")
class ScopeType(builtins.str, Enum):
    """
    The Azure scope to which the license will apply.
    """
    TENANT = "Tenant"
    SUBSCRIPTION = "Subscription"
    RESOURCE_GROUP = "ResourceGroup"


@pulumi.type_token("azure-native:azurearcdata:SqlManagedInstanceSkuName")
class SqlManagedInstanceSkuName(builtins.str, Enum):
    """
    The name of the SKU.
    """
    V_CORE = "vCore"


@pulumi.type_token("azure-native:azurearcdata:SqlManagedInstanceSkuTier")
class SqlManagedInstanceSkuTier(builtins.str, Enum):
    """
    The pricing tier for the instance.
    """
    GENERAL_PURPOSE = "GeneralPurpose"
    BUSINESS_CRITICAL = "BusinessCritical"


@pulumi.type_token("azure-native:azurearcdata:SqlVersion")
class SqlVersion(builtins.str, Enum):
    """
    SQL Server version.
    """
    SQ_L_SERVER_2012 = "SQL Server 2012"
    SQ_L_SERVER_2014 = "SQL Server 2014"
    SQ_L_SERVER_2016 = "SQL Server 2016"
    SQ_L_SERVER_2017 = "SQL Server 2017"
    SQ_L_SERVER_2019 = "SQL Server 2019"
    SQ_L_SERVER_2022 = "SQL Server 2022"
    UNKNOWN = "Unknown"


@pulumi.type_token("azure-native:azurearcdata:State")
class State(builtins.str, Enum):
    """
    The activation state of the license.
    """
    INACTIVE = "Inactive"
    ACTIVE = "Active"
    TERMINATED = "Terminated"


@pulumi.type_token("azure-native:azurearcdata:Version")
class Version(builtins.str, Enum):
    """
    The SQL Server version the license covers.
    """
    SQ_L_SERVER_2012 = "SQL Server 2012"
    SQ_L_SERVER_2014 = "SQL Server 2014"
