# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetFlowDestinationEndpointsResult',
    'AwaitableGetFlowDestinationEndpointsResult',
    'get_flow_destination_endpoints',
    'get_flow_destination_endpoints_output',
]

@pulumi.output_type
class GetFlowDestinationEndpointsResult:
    """
    List of destination endpoints for the flow stream
    """
    def __init__(__self__, endpoints=None):
        if endpoints and not isinstance(endpoints, list):
            raise TypeError("Expected argument 'endpoints' to be a list")
        pulumi.set(__self__, "endpoints", endpoints)

    @property
    @pulumi.getter
    def endpoints(self) -> Optional[Sequence[builtins.str]]:
        """
        The destination endpoints for the flow stream
        """
        return pulumi.get(self, "endpoints")


class AwaitableGetFlowDestinationEndpointsResult(GetFlowDestinationEndpointsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFlowDestinationEndpointsResult(
            endpoints=self.endpoints)


def get_flow_destination_endpoints(connection_name: Optional[builtins.str] = None,
                                   flow_name: Optional[builtins.str] = None,
                                   resource_group_name: Optional[builtins.str] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFlowDestinationEndpointsResult:
    """
    Get the destination endpoints for the specified flow and stream ID.

    Uses Azure REST API version 2024-09-27.

    Other available API versions: 2025-03-01-preview, 2025-04-11-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azuredatatransfer [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str connection_name: The name for the connection that is to be requested.
    :param builtins.str flow_name: The name for the flow that is to be onboarded.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['connectionName'] = connection_name
    __args__['flowName'] = flow_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:azuredatatransfer:getFlowDestinationEndpoints', __args__, opts=opts, typ=GetFlowDestinationEndpointsResult).value

    return AwaitableGetFlowDestinationEndpointsResult(
        endpoints=pulumi.get(__ret__, 'endpoints'))
def get_flow_destination_endpoints_output(connection_name: Optional[pulumi.Input[builtins.str]] = None,
                                          flow_name: Optional[pulumi.Input[builtins.str]] = None,
                                          resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFlowDestinationEndpointsResult]:
    """
    Get the destination endpoints for the specified flow and stream ID.

    Uses Azure REST API version 2024-09-27.

    Other available API versions: 2025-03-01-preview, 2025-04-11-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azuredatatransfer [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str connection_name: The name for the connection that is to be requested.
    :param builtins.str flow_name: The name for the flow that is to be onboarded.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['connectionName'] = connection_name
    __args__['flowName'] = flow_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:azuredatatransfer:getFlowDestinationEndpoints', __args__, opts=opts, typ=GetFlowDestinationEndpointsResult)
    return __ret__.apply(lambda __response__: GetFlowDestinationEndpointsResult(
        endpoints=pulumi.get(__response__, 'endpoints')))
