# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'ListAzureDataTransferApprovedSchemasResult',
    'AwaitableListAzureDataTransferApprovedSchemasResult',
    'list_azure_data_transfer_approved_schemas',
    'list_azure_data_transfer_approved_schemas_output',
]

@pulumi.output_type
class ListAzureDataTransferApprovedSchemasResult:
    """
    The schemas list result.
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.SchemaResponse']]:
        """
        Schemas array.
        """
        return pulumi.get(self, "value")


class AwaitableListAzureDataTransferApprovedSchemasResult(ListAzureDataTransferApprovedSchemasResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListAzureDataTransferApprovedSchemasResult(
            value=self.value)


def list_azure_data_transfer_approved_schemas(direction: Optional[Union[builtins.str, 'ListApprovedSchemasDirection']] = None,
                                              pipeline: Optional[builtins.str] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListAzureDataTransferApprovedSchemasResult:
    """
    Lists approved schemas for Azure Data Transfer.

    Uses Azure REST API version 2024-09-27.

    Other available API versions: 2023-10-11-preview, 2024-01-25, 2024-05-07, 2024-09-11, 2025-03-01-preview, 2025-04-11-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azuredatatransfer [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param Union[builtins.str, 'ListApprovedSchemasDirection'] direction: The direction pipeline to filter approved schemas.
    :param builtins.str pipeline: The name of the pipeline to filter approved schemas.
    """
    __args__ = dict()
    __args__['direction'] = direction
    __args__['pipeline'] = pipeline
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:azuredatatransfer:listAzureDataTransferApprovedSchemas', __args__, opts=opts, typ=ListAzureDataTransferApprovedSchemasResult).value

    return AwaitableListAzureDataTransferApprovedSchemasResult(
        value=pulumi.get(__ret__, 'value'))
def list_azure_data_transfer_approved_schemas_output(direction: Optional[pulumi.Input[Optional[Union[builtins.str, 'ListApprovedSchemasDirection']]]] = None,
                                                     pipeline: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListAzureDataTransferApprovedSchemasResult]:
    """
    Lists approved schemas for Azure Data Transfer.

    Uses Azure REST API version 2024-09-27.

    Other available API versions: 2023-10-11-preview, 2024-01-25, 2024-05-07, 2024-09-11, 2025-03-01-preview, 2025-04-11-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azuredatatransfer [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param Union[builtins.str, 'ListApprovedSchemasDirection'] direction: The direction pipeline to filter approved schemas.
    :param builtins.str pipeline: The name of the pipeline to filter approved schemas.
    """
    __args__ = dict()
    __args__['direction'] = direction
    __args__['pipeline'] = pipeline
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:azuredatatransfer:listAzureDataTransferApprovedSchemas', __args__, opts=opts, typ=ListAzureDataTransferApprovedSchemasResult)
    return __ret__.apply(lambda __response__: ListAzureDataTransferApprovedSchemasResult(
        value=pulumi.get(__response__, 'value')))
