# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'DiskArgs',
    'DiskArgsDict',
    'HardwareProfileArgs',
    'HardwareProfileArgsDict',
    'IpAddressArgs',
    'IpAddressArgsDict',
    'ManagedServiceIdentityArgs',
    'ManagedServiceIdentityArgsDict',
    'NetworkProfileArgs',
    'NetworkProfileArgsDict',
    'OsProfileArgs',
    'OsProfileArgsDict',
    'StorageBillingPropertiesArgs',
    'StorageBillingPropertiesArgsDict',
    'StorageProfileArgs',
    'StorageProfileArgsDict',
    'StoragePropertiesArgs',
    'StoragePropertiesArgsDict',
]

MYPY = False

if not MYPY:
    class DiskArgsDict(TypedDict):
        """
        Specifies the disk information fo the Azure Large Instance
        """
        disk_size_gb: NotRequired[pulumi.Input[builtins.int]]
        """
        Specifies the size of an empty data disk in gigabytes.
        """
        name: NotRequired[pulumi.Input[builtins.str]]
        """
        The disk name.
        """
elif False:
    DiskArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DiskArgs:
    def __init__(__self__, *,
                 disk_size_gb: Optional[pulumi.Input[builtins.int]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None):
        """
        Specifies the disk information fo the Azure Large Instance
        :param pulumi.Input[builtins.int] disk_size_gb: Specifies the size of an empty data disk in gigabytes.
        :param pulumi.Input[builtins.str] name: The disk name.
        """
        if disk_size_gb is not None:
            pulumi.set(__self__, "disk_size_gb", disk_size_gb)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="diskSizeGB")
    def disk_size_gb(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Specifies the size of an empty data disk in gigabytes.
        """
        return pulumi.get(self, "disk_size_gb")

    @disk_size_gb.setter
    def disk_size_gb(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "disk_size_gb", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The disk name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)


if not MYPY:
    class HardwareProfileArgsDict(TypedDict):
        """
        Specifies the hardware settings for the Azure Large Instance.
        """
        azure_large_instance_size: NotRequired[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceSizeNamesEnum']]]
        """
        Specifies the Azure Large Instance SKU.
        """
        hardware_type: NotRequired[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']]]
        """
        Name of the hardware type (vendor and/or their product name)
        """
elif False:
    HardwareProfileArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class HardwareProfileArgs:
    def __init__(__self__, *,
                 azure_large_instance_size: Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceSizeNamesEnum']]] = None,
                 hardware_type: Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']]] = None):
        """
        Specifies the hardware settings for the Azure Large Instance.
        :param pulumi.Input[Union[builtins.str, 'AzureLargeInstanceSizeNamesEnum']] azure_large_instance_size: Specifies the Azure Large Instance SKU.
        :param pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']] hardware_type: Name of the hardware type (vendor and/or their product name)
        """
        if azure_large_instance_size is not None:
            pulumi.set(__self__, "azure_large_instance_size", azure_large_instance_size)
        if hardware_type is not None:
            pulumi.set(__self__, "hardware_type", hardware_type)

    @property
    @pulumi.getter(name="azureLargeInstanceSize")
    def azure_large_instance_size(self) -> Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceSizeNamesEnum']]]:
        """
        Specifies the Azure Large Instance SKU.
        """
        return pulumi.get(self, "azure_large_instance_size")

    @azure_large_instance_size.setter
    def azure_large_instance_size(self, value: Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceSizeNamesEnum']]]):
        pulumi.set(self, "azure_large_instance_size", value)

    @property
    @pulumi.getter(name="hardwareType")
    def hardware_type(self) -> Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']]]:
        """
        Name of the hardware type (vendor and/or their product name)
        """
        return pulumi.get(self, "hardware_type")

    @hardware_type.setter
    def hardware_type(self, value: Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']]]):
        pulumi.set(self, "hardware_type", value)


if not MYPY:
    class IpAddressArgsDict(TypedDict):
        """
        Specifies the IP address of the network interface.
        """
        ip_address: NotRequired[pulumi.Input[builtins.str]]
        """
        Specifies the IP address of the network interface.
        """
elif False:
    IpAddressArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class IpAddressArgs:
    def __init__(__self__, *,
                 ip_address: Optional[pulumi.Input[builtins.str]] = None):
        """
        Specifies the IP address of the network interface.
        :param pulumi.Input[builtins.str] ip_address: Specifies the IP address of the network interface.
        """
        if ip_address is not None:
            pulumi.set(__self__, "ip_address", ip_address)

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies the IP address of the network interface.
        """
        return pulumi.get(self, "ip_address")

    @ip_address.setter
    def ip_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ip_address", value)


if not MYPY:
    class ManagedServiceIdentityArgsDict(TypedDict):
        """
        Managed service identity (system assigned and/or user assigned identities)
        """
        type: pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']]
        """
        Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        """
        user_assigned_identities: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        """
        The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
elif False:
    ManagedServiceIdentityArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ManagedServiceIdentityArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']],
                 user_assigned_identities: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        Managed service identity (system assigned and/or user assigned identities)
        :param pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']] type: Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] user_assigned_identities: The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        pulumi.set(__self__, "type", type)
        if user_assigned_identities is not None:
            pulumi.set(__self__, "user_assigned_identities", user_assigned_identities)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']]:
        """
        Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="userAssignedIdentities")
    def user_assigned_identities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        return pulumi.get(self, "user_assigned_identities")

    @user_assigned_identities.setter
    def user_assigned_identities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "user_assigned_identities", value)


if not MYPY:
    class NetworkProfileArgsDict(TypedDict):
        """
        Specifies the network settings for the Azure Large Instance disks.
        """
        circuit_id: NotRequired[pulumi.Input[builtins.str]]
        """
        Specifies the circuit id for connecting to express route.
        """
        network_interfaces: NotRequired[pulumi.Input[Sequence[pulumi.Input['IpAddressArgsDict']]]]
        """
        Specifies the network interfaces for the Azure Large Instance.
        """
elif False:
    NetworkProfileArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class NetworkProfileArgs:
    def __init__(__self__, *,
                 circuit_id: Optional[pulumi.Input[builtins.str]] = None,
                 network_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input['IpAddressArgs']]]] = None):
        """
        Specifies the network settings for the Azure Large Instance disks.
        :param pulumi.Input[builtins.str] circuit_id: Specifies the circuit id for connecting to express route.
        :param pulumi.Input[Sequence[pulumi.Input['IpAddressArgs']]] network_interfaces: Specifies the network interfaces for the Azure Large Instance.
        """
        if circuit_id is not None:
            pulumi.set(__self__, "circuit_id", circuit_id)
        if network_interfaces is not None:
            pulumi.set(__self__, "network_interfaces", network_interfaces)

    @property
    @pulumi.getter(name="circuitId")
    def circuit_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies the circuit id for connecting to express route.
        """
        return pulumi.get(self, "circuit_id")

    @circuit_id.setter
    def circuit_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "circuit_id", value)

    @property
    @pulumi.getter(name="networkInterfaces")
    def network_interfaces(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['IpAddressArgs']]]]:
        """
        Specifies the network interfaces for the Azure Large Instance.
        """
        return pulumi.get(self, "network_interfaces")

    @network_interfaces.setter
    def network_interfaces(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['IpAddressArgs']]]]):
        pulumi.set(self, "network_interfaces", value)


if not MYPY:
    class OsProfileArgsDict(TypedDict):
        """
        Specifies the operating system settings for the Azure Large Instance.
        """
        computer_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Specifies the host OS name of the Azure Large Instance.
        """
        os_type: NotRequired[pulumi.Input[builtins.str]]
        """
        This property allows you to specify the type of the OS.
        """
        ssh_public_key: NotRequired[pulumi.Input[builtins.str]]
        """
        Specifies the SSH public key used to access the operating system.
        """
        version: NotRequired[pulumi.Input[builtins.str]]
        """
        Specifies version of operating system.
        """
elif False:
    OsProfileArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class OsProfileArgs:
    def __init__(__self__, *,
                 computer_name: Optional[pulumi.Input[builtins.str]] = None,
                 os_type: Optional[pulumi.Input[builtins.str]] = None,
                 ssh_public_key: Optional[pulumi.Input[builtins.str]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None):
        """
        Specifies the operating system settings for the Azure Large Instance.
        :param pulumi.Input[builtins.str] computer_name: Specifies the host OS name of the Azure Large Instance.
        :param pulumi.Input[builtins.str] os_type: This property allows you to specify the type of the OS.
        :param pulumi.Input[builtins.str] ssh_public_key: Specifies the SSH public key used to access the operating system.
        :param pulumi.Input[builtins.str] version: Specifies version of operating system.
        """
        if computer_name is not None:
            pulumi.set(__self__, "computer_name", computer_name)
        if os_type is not None:
            pulumi.set(__self__, "os_type", os_type)
        if ssh_public_key is not None:
            pulumi.set(__self__, "ssh_public_key", ssh_public_key)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="computerName")
    def computer_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies the host OS name of the Azure Large Instance.
        """
        return pulumi.get(self, "computer_name")

    @computer_name.setter
    def computer_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "computer_name", value)

    @property
    @pulumi.getter(name="osType")
    def os_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        This property allows you to specify the type of the OS.
        """
        return pulumi.get(self, "os_type")

    @os_type.setter
    def os_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "os_type", value)

    @property
    @pulumi.getter(name="sshPublicKey")
    def ssh_public_key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies the SSH public key used to access the operating system.
        """
        return pulumi.get(self, "ssh_public_key")

    @ssh_public_key.setter
    def ssh_public_key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ssh_public_key", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Specifies version of operating system.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)


if not MYPY:
    class StorageBillingPropertiesArgsDict(TypedDict):
        """
        Describes the billing related details of the AzureLargeStorageInstance.
        """
        billing_mode: NotRequired[pulumi.Input[builtins.str]]
        """
        the billing mode for the storage instance
        """
        sku: NotRequired[pulumi.Input[builtins.str]]
        """
        the SKU type that is provisioned
        """
elif False:
    StorageBillingPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class StorageBillingPropertiesArgs:
    def __init__(__self__, *,
                 billing_mode: Optional[pulumi.Input[builtins.str]] = None,
                 sku: Optional[pulumi.Input[builtins.str]] = None):
        """
        Describes the billing related details of the AzureLargeStorageInstance.
        :param pulumi.Input[builtins.str] billing_mode: the billing mode for the storage instance
        :param pulumi.Input[builtins.str] sku: the SKU type that is provisioned
        """
        if billing_mode is not None:
            pulumi.set(__self__, "billing_mode", billing_mode)
        if sku is not None:
            pulumi.set(__self__, "sku", sku)

    @property
    @pulumi.getter(name="billingMode")
    def billing_mode(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the billing mode for the storage instance
        """
        return pulumi.get(self, "billing_mode")

    @billing_mode.setter
    def billing_mode(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "billing_mode", value)

    @property
    @pulumi.getter
    def sku(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the SKU type that is provisioned
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "sku", value)


if not MYPY:
    class StorageProfileArgsDict(TypedDict):
        """
        Specifies the storage settings for the Azure Large Instance disks.
        """
        nfs_ip_address: NotRequired[pulumi.Input[builtins.str]]
        """
        IP Address to connect to storage.
        """
        os_disks: NotRequired[pulumi.Input[Sequence[pulumi.Input['DiskArgsDict']]]]
        """
        Specifies information about the operating system disk used by Azure Large
        Instance.
        """
elif False:
    StorageProfileArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class StorageProfileArgs:
    def __init__(__self__, *,
                 nfs_ip_address: Optional[pulumi.Input[builtins.str]] = None,
                 os_disks: Optional[pulumi.Input[Sequence[pulumi.Input['DiskArgs']]]] = None):
        """
        Specifies the storage settings for the Azure Large Instance disks.
        :param pulumi.Input[builtins.str] nfs_ip_address: IP Address to connect to storage.
        :param pulumi.Input[Sequence[pulumi.Input['DiskArgs']]] os_disks: Specifies information about the operating system disk used by Azure Large
               Instance.
        """
        if nfs_ip_address is not None:
            pulumi.set(__self__, "nfs_ip_address", nfs_ip_address)
        if os_disks is not None:
            pulumi.set(__self__, "os_disks", os_disks)

    @property
    @pulumi.getter(name="nfsIpAddress")
    def nfs_ip_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        IP Address to connect to storage.
        """
        return pulumi.get(self, "nfs_ip_address")

    @nfs_ip_address.setter
    def nfs_ip_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "nfs_ip_address", value)

    @property
    @pulumi.getter(name="osDisks")
    def os_disks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DiskArgs']]]]:
        """
        Specifies information about the operating system disk used by Azure Large
        Instance.
        """
        return pulumi.get(self, "os_disks")

    @os_disks.setter
    def os_disks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DiskArgs']]]]):
        pulumi.set(self, "os_disks", value)


if not MYPY:
    class StoragePropertiesArgsDict(TypedDict):
        """
        described the storage properties of the azure large storage instance
        """
        generation: NotRequired[pulumi.Input[builtins.str]]
        """
        the kind of storage instance
        """
        hardware_type: NotRequired[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']]]
        """
        the hardware type of the storage instance
        """
        offering_type: NotRequired[pulumi.Input[builtins.str]]
        """
        the offering type for which the resource is getting provisioned
        """
        storage_billing_properties: NotRequired[pulumi.Input['StorageBillingPropertiesArgsDict']]
        """
        the billing related information for the resource
        """
        storage_type: NotRequired[pulumi.Input[builtins.str]]
        """
        the storage protocol for which the resource is getting provisioned
        """
        workload_type: NotRequired[pulumi.Input[builtins.str]]
        """
        the workload for which the resource is getting provisioned
        """
elif False:
    StoragePropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class StoragePropertiesArgs:
    def __init__(__self__, *,
                 generation: Optional[pulumi.Input[builtins.str]] = None,
                 hardware_type: Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']]] = None,
                 offering_type: Optional[pulumi.Input[builtins.str]] = None,
                 storage_billing_properties: Optional[pulumi.Input['StorageBillingPropertiesArgs']] = None,
                 storage_type: Optional[pulumi.Input[builtins.str]] = None,
                 workload_type: Optional[pulumi.Input[builtins.str]] = None):
        """
        described the storage properties of the azure large storage instance
        :param pulumi.Input[builtins.str] generation: the kind of storage instance
        :param pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']] hardware_type: the hardware type of the storage instance
        :param pulumi.Input[builtins.str] offering_type: the offering type for which the resource is getting provisioned
        :param pulumi.Input['StorageBillingPropertiesArgs'] storage_billing_properties: the billing related information for the resource
        :param pulumi.Input[builtins.str] storage_type: the storage protocol for which the resource is getting provisioned
        :param pulumi.Input[builtins.str] workload_type: the workload for which the resource is getting provisioned
        """
        if generation is not None:
            pulumi.set(__self__, "generation", generation)
        if hardware_type is not None:
            pulumi.set(__self__, "hardware_type", hardware_type)
        if offering_type is not None:
            pulumi.set(__self__, "offering_type", offering_type)
        if storage_billing_properties is not None:
            pulumi.set(__self__, "storage_billing_properties", storage_billing_properties)
        if storage_type is not None:
            pulumi.set(__self__, "storage_type", storage_type)
        if workload_type is not None:
            pulumi.set(__self__, "workload_type", workload_type)

    @property
    @pulumi.getter
    def generation(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the kind of storage instance
        """
        return pulumi.get(self, "generation")

    @generation.setter
    def generation(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "generation", value)

    @property
    @pulumi.getter(name="hardwareType")
    def hardware_type(self) -> Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']]]:
        """
        the hardware type of the storage instance
        """
        return pulumi.get(self, "hardware_type")

    @hardware_type.setter
    def hardware_type(self, value: Optional[pulumi.Input[Union[builtins.str, 'AzureLargeInstanceHardwareTypeNamesEnum']]]):
        pulumi.set(self, "hardware_type", value)

    @property
    @pulumi.getter(name="offeringType")
    def offering_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the offering type for which the resource is getting provisioned
        """
        return pulumi.get(self, "offering_type")

    @offering_type.setter
    def offering_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "offering_type", value)

    @property
    @pulumi.getter(name="storageBillingProperties")
    def storage_billing_properties(self) -> Optional[pulumi.Input['StorageBillingPropertiesArgs']]:
        """
        the billing related information for the resource
        """
        return pulumi.get(self, "storage_billing_properties")

    @storage_billing_properties.setter
    def storage_billing_properties(self, value: Optional[pulumi.Input['StorageBillingPropertiesArgs']]):
        pulumi.set(self, "storage_billing_properties", value)

    @property
    @pulumi.getter(name="storageType")
    def storage_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the storage protocol for which the resource is getting provisioned
        """
        return pulumi.get(self, "storage_type")

    @storage_type.setter
    def storage_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "storage_type", value)

    @property
    @pulumi.getter(name="workloadType")
    def workload_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the workload for which the resource is getting provisioned
        """
        return pulumi.get(self, "workload_type")

    @workload_type.setter
    def workload_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "workload_type", value)


