# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetDeploymentSettingResult',
    'AwaitableGetDeploymentSettingResult',
    'get_deployment_setting',
    'get_deployment_setting_output',
]

@pulumi.output_type
class GetDeploymentSettingResult:
    """
    Edge device resource
    """
    def __init__(__self__, arc_node_resource_ids=None, azure_api_version=None, deployment_configuration=None, deployment_mode=None, id=None, name=None, operation_type=None, provisioning_state=None, reported_properties=None, system_data=None, type=None):
        if arc_node_resource_ids and not isinstance(arc_node_resource_ids, list):
            raise TypeError("Expected argument 'arc_node_resource_ids' to be a list")
        pulumi.set(__self__, "arc_node_resource_ids", arc_node_resource_ids)
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if deployment_configuration and not isinstance(deployment_configuration, dict):
            raise TypeError("Expected argument 'deployment_configuration' to be a dict")
        pulumi.set(__self__, "deployment_configuration", deployment_configuration)
        if deployment_mode and not isinstance(deployment_mode, str):
            raise TypeError("Expected argument 'deployment_mode' to be a str")
        pulumi.set(__self__, "deployment_mode", deployment_mode)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if operation_type and not isinstance(operation_type, str):
            raise TypeError("Expected argument 'operation_type' to be a str")
        pulumi.set(__self__, "operation_type", operation_type)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if reported_properties and not isinstance(reported_properties, dict):
            raise TypeError("Expected argument 'reported_properties' to be a dict")
        pulumi.set(__self__, "reported_properties", reported_properties)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="arcNodeResourceIds")
    def arc_node_resource_ids(self) -> Sequence[builtins.str]:
        """
        Azure resource ids of Arc machines to be part of cluster.
        """
        return pulumi.get(self, "arc_node_resource_ids")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="deploymentConfiguration")
    def deployment_configuration(self) -> 'outputs.DeploymentConfigurationResponse':
        """
        Scale units will contains list of deployment data
        """
        return pulumi.get(self, "deployment_configuration")

    @property
    @pulumi.getter(name="deploymentMode")
    def deployment_mode(self) -> builtins.str:
        """
        The deployment mode for cluster deployment.
        """
        return pulumi.get(self, "deployment_mode")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="operationType")
    def operation_type(self) -> Optional[builtins.str]:
        """
        The intended operation for a cluster.
        """
        return pulumi.get(self, "operation_type")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        DeploymentSetting provisioning state
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="reportedProperties")
    def reported_properties(self) -> 'outputs.EceReportedPropertiesResponse':
        """
        Deployment Status reported from cluster.
        """
        return pulumi.get(self, "reported_properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetDeploymentSettingResult(GetDeploymentSettingResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDeploymentSettingResult(
            arc_node_resource_ids=self.arc_node_resource_ids,
            azure_api_version=self.azure_api_version,
            deployment_configuration=self.deployment_configuration,
            deployment_mode=self.deployment_mode,
            id=self.id,
            name=self.name,
            operation_type=self.operation_type,
            provisioning_state=self.provisioning_state,
            reported_properties=self.reported_properties,
            system_data=self.system_data,
            type=self.type)


def get_deployment_setting(cluster_name: Optional[builtins.str] = None,
                           deployment_settings_name: Optional[builtins.str] = None,
                           resource_group_name: Optional[builtins.str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDeploymentSettingResult:
    """
    Get a DeploymentSetting

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2023-08-01-preview, 2023-11-01-preview, 2024-01-01, 2024-02-15-preview, 2024-09-01-preview, 2024-12-01-preview, 2025-02-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azurestackhci [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str cluster_name: The name of the cluster.
    :param builtins.str deployment_settings_name: Name of Deployment Setting
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['clusterName'] = cluster_name
    __args__['deploymentSettingsName'] = deployment_settings_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:azurestackhci:getDeploymentSetting', __args__, opts=opts, typ=GetDeploymentSettingResult).value

    return AwaitableGetDeploymentSettingResult(
        arc_node_resource_ids=pulumi.get(__ret__, 'arc_node_resource_ids'),
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        deployment_configuration=pulumi.get(__ret__, 'deployment_configuration'),
        deployment_mode=pulumi.get(__ret__, 'deployment_mode'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        operation_type=pulumi.get(__ret__, 'operation_type'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        reported_properties=pulumi.get(__ret__, 'reported_properties'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_deployment_setting_output(cluster_name: Optional[pulumi.Input[builtins.str]] = None,
                                  deployment_settings_name: Optional[pulumi.Input[builtins.str]] = None,
                                  resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDeploymentSettingResult]:
    """
    Get a DeploymentSetting

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2023-08-01-preview, 2023-11-01-preview, 2024-01-01, 2024-02-15-preview, 2024-09-01-preview, 2024-12-01-preview, 2025-02-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azurestackhci [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str cluster_name: The name of the cluster.
    :param builtins.str deployment_settings_name: Name of Deployment Setting
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['clusterName'] = cluster_name
    __args__['deploymentSettingsName'] = deployment_settings_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:azurestackhci:getDeploymentSetting', __args__, opts=opts, typ=GetDeploymentSettingResult)
    return __ret__.apply(lambda __response__: GetDeploymentSettingResult(
        arc_node_resource_ids=pulumi.get(__response__, 'arc_node_resource_ids'),
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        deployment_configuration=pulumi.get(__response__, 'deployment_configuration'),
        deployment_mode=pulumi.get(__response__, 'deployment_mode'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        operation_type=pulumi.get(__response__, 'operation_type'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        reported_properties=pulumi.get(__response__, 'reported_properties'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
