# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetVirtualHardDiskResult',
    'AwaitableGetVirtualHardDiskResult',
    'get_virtual_hard_disk',
    'get_virtual_hard_disk_output',
]

@pulumi.output_type
class GetVirtualHardDiskResult:
    """
    The virtual hard disk resource definition.
    """
    def __init__(__self__, azure_api_version=None, block_size_bytes=None, container_id=None, create_from_local=None, disk_file_format=None, disk_size_gb=None, download_url=None, dynamic=None, extended_location=None, hyper_v_generation=None, id=None, location=None, logical_sector_bytes=None, name=None, physical_sector_bytes=None, provisioning_state=None, status=None, system_data=None, tags=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if block_size_bytes and not isinstance(block_size_bytes, int):
            raise TypeError("Expected argument 'block_size_bytes' to be a int")
        pulumi.set(__self__, "block_size_bytes", block_size_bytes)
        if container_id and not isinstance(container_id, str):
            raise TypeError("Expected argument 'container_id' to be a str")
        pulumi.set(__self__, "container_id", container_id)
        if create_from_local and not isinstance(create_from_local, bool):
            raise TypeError("Expected argument 'create_from_local' to be a bool")
        pulumi.set(__self__, "create_from_local", create_from_local)
        if disk_file_format and not isinstance(disk_file_format, str):
            raise TypeError("Expected argument 'disk_file_format' to be a str")
        pulumi.set(__self__, "disk_file_format", disk_file_format)
        if disk_size_gb and not isinstance(disk_size_gb, float):
            raise TypeError("Expected argument 'disk_size_gb' to be a float")
        pulumi.set(__self__, "disk_size_gb", disk_size_gb)
        if download_url and not isinstance(download_url, str):
            raise TypeError("Expected argument 'download_url' to be a str")
        pulumi.set(__self__, "download_url", download_url)
        if dynamic and not isinstance(dynamic, bool):
            raise TypeError("Expected argument 'dynamic' to be a bool")
        pulumi.set(__self__, "dynamic", dynamic)
        if extended_location and not isinstance(extended_location, dict):
            raise TypeError("Expected argument 'extended_location' to be a dict")
        pulumi.set(__self__, "extended_location", extended_location)
        if hyper_v_generation and not isinstance(hyper_v_generation, str):
            raise TypeError("Expected argument 'hyper_v_generation' to be a str")
        pulumi.set(__self__, "hyper_v_generation", hyper_v_generation)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if logical_sector_bytes and not isinstance(logical_sector_bytes, int):
            raise TypeError("Expected argument 'logical_sector_bytes' to be a int")
        pulumi.set(__self__, "logical_sector_bytes", logical_sector_bytes)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if physical_sector_bytes and not isinstance(physical_sector_bytes, int):
            raise TypeError("Expected argument 'physical_sector_bytes' to be a int")
        pulumi.set(__self__, "physical_sector_bytes", physical_sector_bytes)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if status and not isinstance(status, dict):
            raise TypeError("Expected argument 'status' to be a dict")
        pulumi.set(__self__, "status", status)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="blockSizeBytes")
    def block_size_bytes(self) -> Optional[builtins.int]:
        """
        Block size in bytes
        """
        return pulumi.get(self, "block_size_bytes")

    @property
    @pulumi.getter(name="containerId")
    def container_id(self) -> Optional[builtins.str]:
        """
        Storage ContainerID of the storage container to be used for VHD
        """
        return pulumi.get(self, "container_id")

    @property
    @pulumi.getter(name="createFromLocal")
    def create_from_local(self) -> Optional[builtins.bool]:
        """
        Boolean indicating whether it is an existing local hard disk or if one should be created.
        """
        return pulumi.get(self, "create_from_local")

    @property
    @pulumi.getter(name="diskFileFormat")
    def disk_file_format(self) -> Optional[builtins.str]:
        """
        The format of the actual VHD file [vhd, vhdx]
        """
        return pulumi.get(self, "disk_file_format")

    @property
    @pulumi.getter(name="diskSizeGB")
    def disk_size_gb(self) -> Optional[builtins.float]:
        """
        Size of the disk in GB
        """
        return pulumi.get(self, "disk_size_gb")

    @property
    @pulumi.getter(name="downloadUrl")
    def download_url(self) -> Optional[builtins.str]:
        """
        URL for downloading or accessing the virtual hard disk. This URL points to a secure link from where the VHD can be downloaded or accessed directly.
        """
        return pulumi.get(self, "download_url")

    @property
    @pulumi.getter
    def dynamic(self) -> Optional[builtins.bool]:
        """
        Boolean for enabling dynamic sizing on the virtual hard disk
        """
        return pulumi.get(self, "dynamic")

    @property
    @pulumi.getter(name="extendedLocation")
    def extended_location(self) -> Optional['outputs.ExtendedLocationResponse']:
        """
        The extendedLocation of the resource.
        """
        return pulumi.get(self, "extended_location")

    @property
    @pulumi.getter(name="hyperVGeneration")
    def hyper_v_generation(self) -> Optional[builtins.str]:
        """
        The hypervisor generation of the Virtual Machine [V1, V2]
        """
        return pulumi.get(self, "hyper_v_generation")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> builtins.str:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter(name="logicalSectorBytes")
    def logical_sector_bytes(self) -> Optional[builtins.int]:
        """
        Logical sector in bytes
        """
        return pulumi.get(self, "logical_sector_bytes")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="physicalSectorBytes")
    def physical_sector_bytes(self) -> Optional[builtins.int]:
        """
        Physical sector in bytes
        """
        return pulumi.get(self, "physical_sector_bytes")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        Provisioning state of the virtual hard disk.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter
    def status(self) -> 'outputs.VirtualHardDiskStatusResponse':
        """
        The observed state of virtual hard disks
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, builtins.str]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetVirtualHardDiskResult(GetVirtualHardDiskResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVirtualHardDiskResult(
            azure_api_version=self.azure_api_version,
            block_size_bytes=self.block_size_bytes,
            container_id=self.container_id,
            create_from_local=self.create_from_local,
            disk_file_format=self.disk_file_format,
            disk_size_gb=self.disk_size_gb,
            download_url=self.download_url,
            dynamic=self.dynamic,
            extended_location=self.extended_location,
            hyper_v_generation=self.hyper_v_generation,
            id=self.id,
            location=self.location,
            logical_sector_bytes=self.logical_sector_bytes,
            name=self.name,
            physical_sector_bytes=self.physical_sector_bytes,
            provisioning_state=self.provisioning_state,
            status=self.status,
            system_data=self.system_data,
            tags=self.tags,
            type=self.type)


def get_virtual_hard_disk(resource_group_name: Optional[builtins.str] = None,
                          virtual_hard_disk_name: Optional[builtins.str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVirtualHardDiskResult:
    """
    Gets a virtual hard disk

    Uses Azure REST API version 2025-02-01-preview.

    Other available API versions: 2022-12-15-preview, 2023-07-01-preview, 2023-09-01-preview, 2024-01-01, 2024-02-01-preview, 2024-05-01-preview, 2024-07-15-preview, 2024-08-01-preview, 2024-10-01-preview, 2025-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azurestackhci [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str virtual_hard_disk_name: Name of the virtual hard disk
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['virtualHardDiskName'] = virtual_hard_disk_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:azurestackhci:getVirtualHardDisk', __args__, opts=opts, typ=GetVirtualHardDiskResult).value

    return AwaitableGetVirtualHardDiskResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        block_size_bytes=pulumi.get(__ret__, 'block_size_bytes'),
        container_id=pulumi.get(__ret__, 'container_id'),
        create_from_local=pulumi.get(__ret__, 'create_from_local'),
        disk_file_format=pulumi.get(__ret__, 'disk_file_format'),
        disk_size_gb=pulumi.get(__ret__, 'disk_size_gb'),
        download_url=pulumi.get(__ret__, 'download_url'),
        dynamic=pulumi.get(__ret__, 'dynamic'),
        extended_location=pulumi.get(__ret__, 'extended_location'),
        hyper_v_generation=pulumi.get(__ret__, 'hyper_v_generation'),
        id=pulumi.get(__ret__, 'id'),
        location=pulumi.get(__ret__, 'location'),
        logical_sector_bytes=pulumi.get(__ret__, 'logical_sector_bytes'),
        name=pulumi.get(__ret__, 'name'),
        physical_sector_bytes=pulumi.get(__ret__, 'physical_sector_bytes'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        status=pulumi.get(__ret__, 'status'),
        system_data=pulumi.get(__ret__, 'system_data'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'))
def get_virtual_hard_disk_output(resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                 virtual_hard_disk_name: Optional[pulumi.Input[builtins.str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetVirtualHardDiskResult]:
    """
    Gets a virtual hard disk

    Uses Azure REST API version 2025-02-01-preview.

    Other available API versions: 2022-12-15-preview, 2023-07-01-preview, 2023-09-01-preview, 2024-01-01, 2024-02-01-preview, 2024-05-01-preview, 2024-07-15-preview, 2024-08-01-preview, 2024-10-01-preview, 2025-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native azurestackhci [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str virtual_hard_disk_name: Name of the virtual hard disk
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['virtualHardDiskName'] = virtual_hard_disk_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:azurestackhci:getVirtualHardDisk', __args__, opts=opts, typ=GetVirtualHardDiskResult)
    return __ret__.apply(lambda __response__: GetVirtualHardDiskResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        block_size_bytes=pulumi.get(__response__, 'block_size_bytes'),
        container_id=pulumi.get(__response__, 'container_id'),
        create_from_local=pulumi.get(__response__, 'create_from_local'),
        disk_file_format=pulumi.get(__response__, 'disk_file_format'),
        disk_size_gb=pulumi.get(__response__, 'disk_size_gb'),
        download_url=pulumi.get(__response__, 'download_url'),
        dynamic=pulumi.get(__response__, 'dynamic'),
        extended_location=pulumi.get(__response__, 'extended_location'),
        hyper_v_generation=pulumi.get(__response__, 'hyper_v_generation'),
        id=pulumi.get(__response__, 'id'),
        location=pulumi.get(__response__, 'location'),
        logical_sector_bytes=pulumi.get(__response__, 'logical_sector_bytes'),
        name=pulumi.get(__response__, 'name'),
        physical_sector_bytes=pulumi.get(__response__, 'physical_sector_bytes'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        status=pulumi.get(__response__, 'status'),
        system_data=pulumi.get(__response__, 'system_data'),
        tags=pulumi.get(__response__, 'tags'),
        type=pulumi.get(__response__, 'type')))
