# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AFDEndpointProtocols',
    'ActionType',
    'AfdCertificateType',
    'AfdMinimumTlsVersion',
    'AfdQueryStringCachingBehavior',
    'Algorithm',
    'AutoGeneratedDomainNameLabelScope',
    'CacheBehavior',
    'CacheType',
    'ClientPortOperator',
    'CookiesOperator',
    'CustomRuleEnabledState',
    'DeliveryRuleActionName',
    'DeliveryRuleActionParametersType',
    'DeliveryRuleConditionParametersType',
    'DestinationProtocol',
    'EnabledState',
    'ForwardingProtocol',
    'GeoFilterActions',
    'HeaderAction',
    'HealthProbeRequestType',
    'HostNameOperator',
    'HttpVersionOperator',
    'HttpsRedirect',
    'IsDeviceMatchValue',
    'IsDeviceOperator',
    'KeyVaultSigningKeyParametersType',
    'LinkToDefaultDomain',
    'ManagedRuleEnabledState',
    'ManagedServiceIdentityType',
    'MatchProcessingBehavior',
    'MatchVariable',
    'Operator',
    'OptimizationType',
    'ParamIndicator',
    'PolicyEnabledState',
    'PolicyMode',
    'PostArgsOperator',
    'ProbeProtocol',
    'ProfileScrubbingState',
    'QueryStringBehavior',
    'QueryStringCachingBehavior',
    'QueryStringOperator',
    'RedirectType',
    'RemoteAddressOperator',
    'RequestBodyOperator',
    'RequestHeaderOperator',
    'RequestMethodMatchValue',
    'RequestMethodOperator',
    'RequestSchemeMatchValue',
    'RequestUriOperator',
    'ResponseBasedDetectedErrorTypes',
    'RuleCacheBehavior',
    'RuleIsCompressionEnabled',
    'RuleQueryStringCachingBehavior',
    'ScrubbingRuleEntryMatchOperator',
    'ScrubbingRuleEntryMatchVariable',
    'ScrubbingRuleEntryState',
    'SecretType',
    'SecurityPolicyType',
    'ServerPortOperator',
    'SharedPrivateLinkResourceStatus',
    'SkuName',
    'SocketAddrOperator',
    'SslProtocol',
    'SslProtocolOperator',
    'Transform',
    'TransformType',
    'TunnelType',
    'UrlFileExtensionOperator',
    'UrlFileNameOperator',
    'UrlPathOperator',
    'WafMatchVariable',
]


@pulumi.type_token("azure-native:cdn:AFDEndpointProtocols")
class AFDEndpointProtocols(builtins.str, Enum):
    """
    Supported protocols for the customer's endpoint.
    """
    HTTP = "Http"
    HTTPS = "Https"


@pulumi.type_token("azure-native:cdn:ActionType")
class ActionType(builtins.str, Enum):
    """
    Describes what action to be applied when rule matches
    """
    ALLOW = "Allow"
    BLOCK = "Block"
    LOG = "Log"
    REDIRECT = "Redirect"


@pulumi.type_token("azure-native:cdn:AfdCertificateType")
class AfdCertificateType(builtins.str, Enum):
    """
    Defines the source of the SSL certificate.
    """
    CUSTOMER_CERTIFICATE = "CustomerCertificate"
    MANAGED_CERTIFICATE = "ManagedCertificate"
    AZURE_FIRST_PARTY_MANAGED_CERTIFICATE = "AzureFirstPartyManagedCertificate"


@pulumi.type_token("azure-native:cdn:AfdMinimumTlsVersion")
class AfdMinimumTlsVersion(builtins.str, Enum):
    """
    TLS protocol version that will be used for Https
    """
    TLS10 = "TLS10"
    TLS12 = "TLS12"


@pulumi.type_token("azure-native:cdn:AfdQueryStringCachingBehavior")
class AfdQueryStringCachingBehavior(builtins.str, Enum):
    """
    Defines how Frontdoor caches requests that include query strings. You can ignore any query strings when caching, ignore specific query strings, cache every request with a unique URL, or cache specific query strings.
    """
    IGNORE_QUERY_STRING = "IgnoreQueryString"
    USE_QUERY_STRING = "UseQueryString"
    IGNORE_SPECIFIED_QUERY_STRINGS = "IgnoreSpecifiedQueryStrings"
    INCLUDE_SPECIFIED_QUERY_STRINGS = "IncludeSpecifiedQueryStrings"


@pulumi.type_token("azure-native:cdn:Algorithm")
class Algorithm(builtins.str, Enum):
    """
    Algorithm to use for URL signing
    """
    SHA256 = "SHA256"


@pulumi.type_token("azure-native:cdn:AutoGeneratedDomainNameLabelScope")
class AutoGeneratedDomainNameLabelScope(builtins.str, Enum):
    """
    Indicates the endpoint name reuse scope. The default value is TenantReuse.
    """
    TENANT_REUSE = "TenantReuse"
    SUBSCRIPTION_REUSE = "SubscriptionReuse"
    RESOURCE_GROUP_REUSE = "ResourceGroupReuse"
    NO_REUSE = "NoReuse"


@pulumi.type_token("azure-native:cdn:CacheBehavior")
class CacheBehavior(builtins.str, Enum):
    """
    Caching behavior for the requests
    """
    BYPASS_CACHE = "BypassCache"
    OVERRIDE = "Override"
    SET_IF_MISSING = "SetIfMissing"


@pulumi.type_token("azure-native:cdn:CacheType")
class CacheType(builtins.str, Enum):
    """
    The level at which the content needs to be cached.
    """
    ALL = "All"


@pulumi.type_token("azure-native:cdn:ClientPortOperator")
class ClientPortOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:CookiesOperator")
class CookiesOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:CustomRuleEnabledState")
class CustomRuleEnabledState(builtins.str, Enum):
    """
    Describes if the custom rule is in enabled or disabled state. Defaults to Enabled if not specified.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:cdn:DeliveryRuleActionName")
class DeliveryRuleActionName(builtins.str, Enum):
    """
    The name of the action for the delivery rule.
    """
    CACHE_EXPIRATION = "CacheExpiration"
    CACHE_KEY_QUERY_STRING = "CacheKeyQueryString"
    MODIFY_REQUEST_HEADER = "ModifyRequestHeader"
    MODIFY_RESPONSE_HEADER = "ModifyResponseHeader"
    URL_REDIRECT = "UrlRedirect"
    URL_REWRITE = "UrlRewrite"
    URL_SIGNING = "UrlSigning"
    ORIGIN_GROUP_OVERRIDE = "OriginGroupOverride"
    ROUTE_CONFIGURATION_OVERRIDE = "RouteConfigurationOverride"


@pulumi.type_token("azure-native:cdn:DeliveryRuleActionParametersType")
class DeliveryRuleActionParametersType(builtins.str, Enum):
    DELIVERY_RULE_URL_REDIRECT_ACTION_PARAMETERS = "DeliveryRuleUrlRedirectActionParameters"
    DELIVERY_RULE_URL_SIGNING_ACTION_PARAMETERS = "DeliveryRuleUrlSigningActionParameters"
    DELIVERY_RULE_ORIGIN_GROUP_OVERRIDE_ACTION_PARAMETERS = "DeliveryRuleOriginGroupOverrideActionParameters"
    DELIVERY_RULE_URL_REWRITE_ACTION_PARAMETERS = "DeliveryRuleUrlRewriteActionParameters"
    DELIVERY_RULE_HEADER_ACTION_PARAMETERS = "DeliveryRuleHeaderActionParameters"
    DELIVERY_RULE_CACHE_EXPIRATION_ACTION_PARAMETERS = "DeliveryRuleCacheExpirationActionParameters"
    DELIVERY_RULE_CACHE_KEY_QUERY_STRING_BEHAVIOR_ACTION_PARAMETERS = "DeliveryRuleCacheKeyQueryStringBehaviorActionParameters"
    DELIVERY_RULE_ROUTE_CONFIGURATION_OVERRIDE_ACTION_PARAMETERS = "DeliveryRuleRouteConfigurationOverrideActionParameters"


@pulumi.type_token("azure-native:cdn:DeliveryRuleConditionParametersType")
class DeliveryRuleConditionParametersType(builtins.str, Enum):
    DELIVERY_RULE_REMOTE_ADDRESS_CONDITION_PARAMETERS = "DeliveryRuleRemoteAddressConditionParameters"
    DELIVERY_RULE_REQUEST_METHOD_CONDITION_PARAMETERS = "DeliveryRuleRequestMethodConditionParameters"
    DELIVERY_RULE_QUERY_STRING_CONDITION_PARAMETERS = "DeliveryRuleQueryStringConditionParameters"
    DELIVERY_RULE_POST_ARGS_CONDITION_PARAMETERS = "DeliveryRulePostArgsConditionParameters"
    DELIVERY_RULE_REQUEST_URI_CONDITION_PARAMETERS = "DeliveryRuleRequestUriConditionParameters"
    DELIVERY_RULE_REQUEST_HEADER_CONDITION_PARAMETERS = "DeliveryRuleRequestHeaderConditionParameters"
    DELIVERY_RULE_REQUEST_BODY_CONDITION_PARAMETERS = "DeliveryRuleRequestBodyConditionParameters"
    DELIVERY_RULE_REQUEST_SCHEME_CONDITION_PARAMETERS = "DeliveryRuleRequestSchemeConditionParameters"
    DELIVERY_RULE_URL_PATH_MATCH_CONDITION_PARAMETERS = "DeliveryRuleUrlPathMatchConditionParameters"
    DELIVERY_RULE_URL_FILE_EXTENSION_MATCH_CONDITION_PARAMETERS = "DeliveryRuleUrlFileExtensionMatchConditionParameters"
    DELIVERY_RULE_URL_FILENAME_CONDITION_PARAMETERS = "DeliveryRuleUrlFilenameConditionParameters"
    DELIVERY_RULE_HTTP_VERSION_CONDITION_PARAMETERS = "DeliveryRuleHttpVersionConditionParameters"
    DELIVERY_RULE_COOKIES_CONDITION_PARAMETERS = "DeliveryRuleCookiesConditionParameters"
    DELIVERY_RULE_IS_DEVICE_CONDITION_PARAMETERS = "DeliveryRuleIsDeviceConditionParameters"
    DELIVERY_RULE_SOCKET_ADDR_CONDITION_PARAMETERS = "DeliveryRuleSocketAddrConditionParameters"
    DELIVERY_RULE_CLIENT_PORT_CONDITION_PARAMETERS = "DeliveryRuleClientPortConditionParameters"
    DELIVERY_RULE_SERVER_PORT_CONDITION_PARAMETERS = "DeliveryRuleServerPortConditionParameters"
    DELIVERY_RULE_HOST_NAME_CONDITION_PARAMETERS = "DeliveryRuleHostNameConditionParameters"
    DELIVERY_RULE_SSL_PROTOCOL_CONDITION_PARAMETERS = "DeliveryRuleSslProtocolConditionParameters"


@pulumi.type_token("azure-native:cdn:DestinationProtocol")
class DestinationProtocol(builtins.str, Enum):
    """
    Protocol to use for the redirect. The default value is MatchRequest
    """
    MATCH_REQUEST = "MatchRequest"
    HTTP = "Http"
    HTTPS = "Https"


@pulumi.type_token("azure-native:cdn:EnabledState")
class EnabledState(builtins.str, Enum):
    """
    Whether to enable use of this rule. Permitted values are 'Enabled' or 'Disabled'
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:cdn:ForwardingProtocol")
class ForwardingProtocol(builtins.str, Enum):
    """
    Protocol this rule will use when forwarding traffic to backends.
    """
    HTTP_ONLY = "HttpOnly"
    HTTPS_ONLY = "HttpsOnly"
    MATCH_REQUEST = "MatchRequest"


@pulumi.type_token("azure-native:cdn:GeoFilterActions")
class GeoFilterActions(builtins.str, Enum):
    """
    Action of the geo filter, i.e. allow or block access.
    """
    BLOCK = "Block"
    ALLOW = "Allow"


@pulumi.type_token("azure-native:cdn:HeaderAction")
class HeaderAction(builtins.str, Enum):
    """
    Action to perform
    """
    APPEND = "Append"
    OVERWRITE = "Overwrite"
    DELETE = "Delete"


@pulumi.type_token("azure-native:cdn:HealthProbeRequestType")
class HealthProbeRequestType(builtins.str, Enum):
    """
    The type of health probe request that is made.
    """
    NOT_SET = "NotSet"
    GET = "GET"
    HEAD = "HEAD"


@pulumi.type_token("azure-native:cdn:HostNameOperator")
class HostNameOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:HttpVersionOperator")
class HttpVersionOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    EQUAL = "Equal"


@pulumi.type_token("azure-native:cdn:HttpsRedirect")
class HttpsRedirect(builtins.str, Enum):
    """
    Whether to automatically redirect HTTP traffic to HTTPS traffic. Note that this is a easy way to set up this rule and it will be the first rule that gets executed.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:cdn:IsDeviceMatchValue")
class IsDeviceMatchValue(builtins.str, Enum):
    MOBILE = "Mobile"
    DESKTOP = "Desktop"


@pulumi.type_token("azure-native:cdn:IsDeviceOperator")
class IsDeviceOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    EQUAL = "Equal"


@pulumi.type_token("azure-native:cdn:KeyVaultSigningKeyParametersType")
class KeyVaultSigningKeyParametersType(builtins.str, Enum):
    KEY_VAULT_SIGNING_KEY_PARAMETERS = "KeyVaultSigningKeyParameters"


@pulumi.type_token("azure-native:cdn:LinkToDefaultDomain")
class LinkToDefaultDomain(builtins.str, Enum):
    """
    whether this route will be linked to the default endpoint domain.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:cdn:ManagedRuleEnabledState")
class ManagedRuleEnabledState(builtins.str, Enum):
    """
    Describes if the managed rule is in enabled or disabled state. Defaults to Disabled if not specified.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:cdn:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


@pulumi.type_token("azure-native:cdn:MatchProcessingBehavior")
class MatchProcessingBehavior(builtins.str, Enum):
    """
    If this rule is a match should the rules engine continue running the remaining rules or stop. If not present, defaults to Continue.
    """
    CONTINUE_ = "Continue"
    STOP = "Stop"


@pulumi.type_token("azure-native:cdn:MatchVariable")
class MatchVariable(builtins.str, Enum):
    """
    The name of the condition for the delivery rule.
    """
    REMOTE_ADDRESS = "RemoteAddress"
    REQUEST_METHOD = "RequestMethod"
    QUERY_STRING = "QueryString"
    POST_ARGS = "PostArgs"
    REQUEST_URI = "RequestUri"
    REQUEST_HEADER = "RequestHeader"
    REQUEST_BODY = "RequestBody"
    REQUEST_SCHEME = "RequestScheme"
    URL_PATH = "UrlPath"
    URL_FILE_EXTENSION = "UrlFileExtension"
    URL_FILE_NAME = "UrlFileName"
    HTTP_VERSION = "HttpVersion"
    COOKIES = "Cookies"
    IS_DEVICE = "IsDevice"
    SOCKET_ADDR = "SocketAddr"
    CLIENT_PORT = "ClientPort"
    SERVER_PORT = "ServerPort"
    HOST_NAME = "HostName"
    SSL_PROTOCOL = "SslProtocol"


@pulumi.type_token("azure-native:cdn:Operator")
class Operator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    IP_MATCH = "IPMatch"
    GEO_MATCH = "GeoMatch"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    LESS_THAN = "LessThan"
    GREATER_THAN = "GreaterThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:OptimizationType")
class OptimizationType(builtins.str, Enum):
    """
    Specifies what scenario the customer wants this CDN endpoint to optimize for, e.g. Download, Media services. With this information, CDN can apply scenario driven optimization.
    """
    GENERAL_WEB_DELIVERY = "GeneralWebDelivery"
    GENERAL_MEDIA_STREAMING = "GeneralMediaStreaming"
    VIDEO_ON_DEMAND_MEDIA_STREAMING = "VideoOnDemandMediaStreaming"
    LARGE_FILE_DOWNLOAD = "LargeFileDownload"
    DYNAMIC_SITE_ACCELERATION = "DynamicSiteAcceleration"


@pulumi.type_token("azure-native:cdn:ParamIndicator")
class ParamIndicator(builtins.str, Enum):
    """
    Indicates the purpose of the parameter
    """
    EXPIRES = "Expires"
    KEY_ID = "KeyId"
    SIGNATURE = "Signature"


@pulumi.type_token("azure-native:cdn:PolicyEnabledState")
class PolicyEnabledState(builtins.str, Enum):
    """
    describes if the policy is in enabled state or disabled state
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:cdn:PolicyMode")
class PolicyMode(builtins.str, Enum):
    """
    Describes if it is in detection mode or prevention mode at policy level.
    """
    PREVENTION = "Prevention"
    DETECTION = "Detection"


@pulumi.type_token("azure-native:cdn:PostArgsOperator")
class PostArgsOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:ProbeProtocol")
class ProbeProtocol(builtins.str, Enum):
    """
    Protocol to use for health probe.
    """
    NOT_SET = "NotSet"
    HTTP = "Http"
    HTTPS = "Https"


@pulumi.type_token("azure-native:cdn:ProfileScrubbingState")
class ProfileScrubbingState(builtins.str, Enum):
    """
    State of the log scrubbing config. Default value is Enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:cdn:QueryStringBehavior")
class QueryStringBehavior(builtins.str, Enum):
    """
    Caching behavior for the requests
    """
    INCLUDE = "Include"
    INCLUDE_ALL = "IncludeAll"
    EXCLUDE = "Exclude"
    EXCLUDE_ALL = "ExcludeAll"


@pulumi.type_token("azure-native:cdn:QueryStringCachingBehavior")
class QueryStringCachingBehavior(builtins.str, Enum):
    """
    Defines how CDN caches requests that include query strings. You can ignore any query strings when caching, bypass caching to prevent requests that contain query strings from being cached, or cache every request with a unique URL.
    """
    IGNORE_QUERY_STRING = "IgnoreQueryString"
    BYPASS_CACHING = "BypassCaching"
    USE_QUERY_STRING = "UseQueryString"
    NOT_SET = "NotSet"


@pulumi.type_token("azure-native:cdn:QueryStringOperator")
class QueryStringOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:RedirectType")
class RedirectType(builtins.str, Enum):
    """
    The redirect type the rule will use when redirecting traffic.
    """
    MOVED = "Moved"
    FOUND = "Found"
    TEMPORARY_REDIRECT = "TemporaryRedirect"
    PERMANENT_REDIRECT = "PermanentRedirect"


@pulumi.type_token("azure-native:cdn:RemoteAddressOperator")
class RemoteAddressOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    IP_MATCH = "IPMatch"
    GEO_MATCH = "GeoMatch"


@pulumi.type_token("azure-native:cdn:RequestBodyOperator")
class RequestBodyOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:RequestHeaderOperator")
class RequestHeaderOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:RequestMethodMatchValue")
class RequestMethodMatchValue(builtins.str, Enum):
    GET = "GET"
    HEAD = "HEAD"
    POST = "POST"
    PUT = "PUT"
    DELETE = "DELETE"
    OPTIONS = "OPTIONS"
    TRACE = "TRACE"


@pulumi.type_token("azure-native:cdn:RequestMethodOperator")
class RequestMethodOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    EQUAL = "Equal"


@pulumi.type_token("azure-native:cdn:RequestSchemeMatchValue")
class RequestSchemeMatchValue(builtins.str, Enum):
    HTTP = "HTTP"
    HTTPS = "HTTPS"


@pulumi.type_token("azure-native:cdn:RequestUriOperator")
class RequestUriOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:ResponseBasedDetectedErrorTypes")
class ResponseBasedDetectedErrorTypes(builtins.str, Enum):
    """
    Type of response errors for real user requests for which origin will be deemed unhealthy
    """
    NONE = "None"
    TCP_ERRORS_ONLY = "TcpErrorsOnly"
    TCP_AND_HTTP_ERRORS = "TcpAndHttpErrors"


@pulumi.type_token("azure-native:cdn:RuleCacheBehavior")
class RuleCacheBehavior(builtins.str, Enum):
    """
    Caching behavior for the requests
    """
    HONOR_ORIGIN = "HonorOrigin"
    OVERRIDE_ALWAYS = "OverrideAlways"
    OVERRIDE_IF_ORIGIN_MISSING = "OverrideIfOriginMissing"


@pulumi.type_token("azure-native:cdn:RuleIsCompressionEnabled")
class RuleIsCompressionEnabled(builtins.str, Enum):
    """
    Indicates whether content compression is enabled. If compression is enabled, content will be served as compressed if user requests for a compressed version. Content won't be compressed on AzureFrontDoor when requested content is smaller than 1 byte or larger than 1 MB.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:cdn:RuleQueryStringCachingBehavior")
class RuleQueryStringCachingBehavior(builtins.str, Enum):
    """
    Defines how Frontdoor caches requests that include query strings. You can ignore any query strings when caching, ignore specific query strings, cache every request with a unique URL, or cache specific query strings.
    """
    IGNORE_QUERY_STRING = "IgnoreQueryString"
    USE_QUERY_STRING = "UseQueryString"
    IGNORE_SPECIFIED_QUERY_STRINGS = "IgnoreSpecifiedQueryStrings"
    INCLUDE_SPECIFIED_QUERY_STRINGS = "IncludeSpecifiedQueryStrings"


@pulumi.type_token("azure-native:cdn:ScrubbingRuleEntryMatchOperator")
class ScrubbingRuleEntryMatchOperator(builtins.str, Enum):
    """
    When matchVariable is a collection, operate on the selector to specify which elements in the collection this rule applies to.
    """
    EQUALS_ANY = "EqualsAny"


@pulumi.type_token("azure-native:cdn:ScrubbingRuleEntryMatchVariable")
class ScrubbingRuleEntryMatchVariable(builtins.str, Enum):
    """
    The variable to be scrubbed from the logs.
    """
    REQUEST_IP_ADDRESS = "RequestIPAddress"
    REQUEST_URI = "RequestUri"
    QUERY_STRING_ARG_NAMES = "QueryStringArgNames"


@pulumi.type_token("azure-native:cdn:ScrubbingRuleEntryState")
class ScrubbingRuleEntryState(builtins.str, Enum):
    """
    Defines the state of a log scrubbing rule. Default value is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:cdn:SecretType")
class SecretType(builtins.str, Enum):
    """
    The type of the secret resource.
    """
    URL_SIGNING_KEY = "UrlSigningKey"
    CUSTOMER_CERTIFICATE = "CustomerCertificate"
    MANAGED_CERTIFICATE = "ManagedCertificate"
    AZURE_FIRST_PARTY_MANAGED_CERTIFICATE = "AzureFirstPartyManagedCertificate"


@pulumi.type_token("azure-native:cdn:SecurityPolicyType")
class SecurityPolicyType(builtins.str, Enum):
    """
    The type of the Security policy to create.
    """
    WEB_APPLICATION_FIREWALL = "WebApplicationFirewall"


@pulumi.type_token("azure-native:cdn:ServerPortOperator")
class ServerPortOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:SharedPrivateLinkResourceStatus")
class SharedPrivateLinkResourceStatus(builtins.str, Enum):
    """
    Status of the shared private link resource. Can be Pending, Approved, Rejected, Disconnected, or Timeout.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"
    DISCONNECTED = "Disconnected"
    TIMEOUT = "Timeout"


@pulumi.type_token("azure-native:cdn:SkuName")
class SkuName(builtins.str, Enum):
    """
    Name of the pricing tier.
    """
    STANDARD_VERIZON = "Standard_Verizon"
    PREMIUM_VERIZON = "Premium_Verizon"
    CUSTOM_VERIZON = "Custom_Verizon"
    STANDARD_AKAMAI = "Standard_Akamai"
    STANDARD_CHINA_CDN = "Standard_ChinaCdn"
    STANDARD_MICROSOFT = "Standard_Microsoft"
    STANDARD_AZURE_FRONT_DOOR = "Standard_AzureFrontDoor"
    PREMIUM_AZURE_FRONT_DOOR = "Premium_AzureFrontDoor"
    STANDARD_955_BAND_WIDTH_CHINA_CDN = "Standard_955BandWidth_ChinaCdn"
    STANDARD_AVG_BAND_WIDTH_CHINA_CDN = "Standard_AvgBandWidth_ChinaCdn"
    STANDARD_PLUS_CHINA_CDN = "StandardPlus_ChinaCdn"
    STANDARD_PLUS_955_BAND_WIDTH_CHINA_CDN = "StandardPlus_955BandWidth_ChinaCdn"
    STANDARD_PLUS_AVG_BAND_WIDTH_CHINA_CDN = "StandardPlus_AvgBandWidth_ChinaCdn"


@pulumi.type_token("azure-native:cdn:SocketAddrOperator")
class SocketAddrOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    IP_MATCH = "IPMatch"


@pulumi.type_token("azure-native:cdn:SslProtocol")
class SslProtocol(builtins.str, Enum):
    """
    The protocol of an established TLS connection.
    """
    TL_SV1 = "TLSv1"
    TL_SV1_1 = "TLSv1.1"
    TL_SV1_2 = "TLSv1.2"


@pulumi.type_token("azure-native:cdn:SslProtocolOperator")
class SslProtocolOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    EQUAL = "Equal"


@pulumi.type_token("azure-native:cdn:Transform")
class Transform(builtins.str, Enum):
    """
    Describes what transforms are applied before matching
    """
    LOWERCASE = "Lowercase"
    UPPERCASE = "Uppercase"
    TRIM = "Trim"
    URL_DECODE = "UrlDecode"
    URL_ENCODE = "UrlEncode"
    REMOVE_NULLS = "RemoveNulls"


@pulumi.type_token("azure-native:cdn:TransformType")
class TransformType(builtins.str, Enum):
    """
    Describes what transforms were applied before matching.
    """
    LOWERCASE = "Lowercase"
    UPPERCASE = "Uppercase"
    TRIM = "Trim"
    URL_DECODE = "UrlDecode"
    URL_ENCODE = "UrlEncode"
    REMOVE_NULLS = "RemoveNulls"


@pulumi.type_token("azure-native:cdn:TunnelType")
class TunnelType(builtins.str, Enum):
    """
    Protocol this tunnel will use for allowing traffic to backends.
    """
    HTTP_CONNECT = "HttpConnect"


@pulumi.type_token("azure-native:cdn:UrlFileExtensionOperator")
class UrlFileExtensionOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:UrlFileNameOperator")
class UrlFileNameOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:UrlPathOperator")
class UrlPathOperator(builtins.str, Enum):
    """
    Describes operator to be matched
    """
    ANY = "Any"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    WILDCARD = "Wildcard"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:cdn:WafMatchVariable")
class WafMatchVariable(builtins.str, Enum):
    """
    Match variable to compare against.
    """
    REMOTE_ADDR = "RemoteAddr"
    SOCKET_ADDR = "SocketAddr"
    REQUEST_METHOD = "RequestMethod"
    REQUEST_HEADER = "RequestHeader"
    REQUEST_URI = "RequestUri"
    QUERY_STRING = "QueryString"
    REQUEST_BODY = "RequestBody"
    COOKIES = "Cookies"
    POST_ARGS = "PostArgs"
