# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetFirewallGlobalRulestackResult',
    'AwaitableGetFirewallGlobalRulestackResult',
    'get_firewall_global_rulestack',
    'get_firewall_global_rulestack_output',
]

@pulumi.output_type
class GetFirewallGlobalRulestackResult:
    """
    PAN Rulestack Describe Object
    """
    def __init__(__self__, azure_id=None):
        if azure_id and not isinstance(azure_id, str):
            raise TypeError("Expected argument 'azure_id' to be a str")
        pulumi.set(__self__, "azure_id", azure_id)

    @property
    @pulumi.getter(name="azureId")
    def azure_id(self) -> builtins.str:
        """
        rulestack description
        """
        return pulumi.get(self, "azure_id")


class AwaitableGetFirewallGlobalRulestackResult(GetFirewallGlobalRulestackResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFirewallGlobalRulestackResult(
            azure_id=self.azure_id)


def get_firewall_global_rulestack(firewall_name: Optional[builtins.str] = None,
                                  resource_group_name: Optional[builtins.str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFirewallGlobalRulestackResult:
    """
    Get Global Rulestack associated with the Firewall

    Uses Azure REST API version 2025-02-06-preview.

    Other available API versions: 2023-09-01, 2023-10-10-preview, 2024-01-19-preview, 2024-02-07-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native cloudngfw [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str firewall_name: Firewall resource name
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['firewallName'] = firewall_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:cloudngfw:getFirewallGlobalRulestack', __args__, opts=opts, typ=GetFirewallGlobalRulestackResult).value

    return AwaitableGetFirewallGlobalRulestackResult(
        azure_id=pulumi.get(__ret__, 'azure_id'))
def get_firewall_global_rulestack_output(firewall_name: Optional[pulumi.Input[builtins.str]] = None,
                                         resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFirewallGlobalRulestackResult]:
    """
    Get Global Rulestack associated with the Firewall

    Uses Azure REST API version 2025-02-06-preview.

    Other available API versions: 2023-09-01, 2023-10-10-preview, 2024-01-19-preview, 2024-02-07-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native cloudngfw [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str firewall_name: Firewall resource name
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['firewallName'] = firewall_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:cloudngfw:getFirewallGlobalRulestack', __args__, opts=opts, typ=GetFirewallGlobalRulestackResult)
    return __ret__.apply(lambda __response__: GetFirewallGlobalRulestackResult(
        azure_id=pulumi.get(__response__, 'azure_id')))
