# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['ProjectCapabilityHostArgs', 'ProjectCapabilityHost']

@pulumi.input_type
class ProjectCapabilityHostArgs:
    def __init__(__self__, *,
                 account_name: pulumi.Input[builtins.str],
                 capability_host_properties: pulumi.Input['CapabilityHostArgs'],
                 project_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 capability_host_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a ProjectCapabilityHost resource.
        :param pulumi.Input[builtins.str] account_name: The name of Cognitive Services account.
        :param pulumi.Input['CapabilityHostArgs'] capability_host_properties: [Required] Additional attributes of the entity.
        :param pulumi.Input[builtins.str] project_name: The name of Cognitive Services account's project.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] capability_host_name: The name of the capability host associated with the Cognitive Services Resource
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "capability_host_properties", capability_host_properties)
        pulumi.set(__self__, "project_name", project_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if capability_host_name is not None:
            pulumi.set(__self__, "capability_host_name", capability_host_name)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of Cognitive Services account.
        """
        return pulumi.get(self, "account_name")

    @account_name.setter
    def account_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "account_name", value)

    @property
    @pulumi.getter(name="capabilityHostProperties")
    def capability_host_properties(self) -> pulumi.Input['CapabilityHostArgs']:
        """
        [Required] Additional attributes of the entity.
        """
        return pulumi.get(self, "capability_host_properties")

    @capability_host_properties.setter
    def capability_host_properties(self, value: pulumi.Input['CapabilityHostArgs']):
        pulumi.set(self, "capability_host_properties", value)

    @property
    @pulumi.getter(name="projectName")
    def project_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of Cognitive Services account's project.
        """
        return pulumi.get(self, "project_name")

    @project_name.setter
    def project_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "project_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="capabilityHostName")
    def capability_host_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the capability host associated with the Cognitive Services Resource
        """
        return pulumi.get(self, "capability_host_name")

    @capability_host_name.setter
    def capability_host_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "capability_host_name", value)


@pulumi.type_token("azure-native:cognitiveservices:ProjectCapabilityHost")
class ProjectCapabilityHost(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 capability_host_name: Optional[pulumi.Input[builtins.str]] = None,
                 capability_host_properties: Optional[pulumi.Input[Union['CapabilityHostArgs', 'CapabilityHostArgsDict']]] = None,
                 project_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Azure Resource Manager resource envelope.

        Uses Azure REST API version 2025-04-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] account_name: The name of Cognitive Services account.
        :param pulumi.Input[builtins.str] capability_host_name: The name of the capability host associated with the Cognitive Services Resource
        :param pulumi.Input[Union['CapabilityHostArgs', 'CapabilityHostArgsDict']] capability_host_properties: [Required] Additional attributes of the entity.
        :param pulumi.Input[builtins.str] project_name: The name of Cognitive Services account's project.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProjectCapabilityHostArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Azure Resource Manager resource envelope.

        Uses Azure REST API version 2025-04-01-preview.

        :param str resource_name: The name of the resource.
        :param ProjectCapabilityHostArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProjectCapabilityHostArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 capability_host_name: Optional[pulumi.Input[builtins.str]] = None,
                 capability_host_properties: Optional[pulumi.Input[Union['CapabilityHostArgs', 'CapabilityHostArgsDict']]] = None,
                 project_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProjectCapabilityHostArgs.__new__(ProjectCapabilityHostArgs)

            if account_name is None and not opts.urn:
                raise TypeError("Missing required property 'account_name'")
            __props__.__dict__["account_name"] = account_name
            __props__.__dict__["capability_host_name"] = capability_host_name
            if capability_host_properties is None and not opts.urn:
                raise TypeError("Missing required property 'capability_host_properties'")
            __props__.__dict__["capability_host_properties"] = capability_host_properties
            if project_name is None and not opts.urn:
                raise TypeError("Missing required property 'project_name'")
            __props__.__dict__["project_name"] = project_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:cognitiveservices/v20250401preview:ProjectCapabilityHost")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(ProjectCapabilityHost, __self__).__init__(
            'azure-native:cognitiveservices:ProjectCapabilityHost',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'ProjectCapabilityHost':
        """
        Get an existing ProjectCapabilityHost resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ProjectCapabilityHostArgs.__new__(ProjectCapabilityHostArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["capability_host_properties"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["type"] = None
        return ProjectCapabilityHost(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="capabilityHostProperties")
    def capability_host_properties(self) -> pulumi.Output['outputs.CapabilityHostResponse']:
        """
        [Required] Additional attributes of the entity.
        """
        return pulumi.get(self, "capability_host_properties")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

