# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetSuppressionListResult',
    'AwaitableGetSuppressionListResult',
    'get_suppression_list',
    'get_suppression_list_output',
]

@pulumi.output_type
class GetSuppressionListResult:
    """
    A class representing a SuppressionList resource.
    """
    def __init__(__self__, azure_api_version=None, created_time_stamp=None, data_location=None, id=None, last_updated_time_stamp=None, list_name=None, name=None, system_data=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if created_time_stamp and not isinstance(created_time_stamp, str):
            raise TypeError("Expected argument 'created_time_stamp' to be a str")
        pulumi.set(__self__, "created_time_stamp", created_time_stamp)
        if data_location and not isinstance(data_location, str):
            raise TypeError("Expected argument 'data_location' to be a str")
        pulumi.set(__self__, "data_location", data_location)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if last_updated_time_stamp and not isinstance(last_updated_time_stamp, str):
            raise TypeError("Expected argument 'last_updated_time_stamp' to be a str")
        pulumi.set(__self__, "last_updated_time_stamp", last_updated_time_stamp)
        if list_name and not isinstance(list_name, str):
            raise TypeError("Expected argument 'list_name' to be a str")
        pulumi.set(__self__, "list_name", list_name)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="createdTimeStamp")
    def created_time_stamp(self) -> builtins.str:
        """
        The date the resource was created.
        """
        return pulumi.get(self, "created_time_stamp")

    @property
    @pulumi.getter(name="dataLocation")
    def data_location(self) -> builtins.str:
        """
        The location where the SuppressionListAddress data is stored at rest. This value is inherited from the parent Domains resource.
        """
        return pulumi.get(self, "data_location")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lastUpdatedTimeStamp")
    def last_updated_time_stamp(self) -> builtins.str:
        """
        The date the resource was last updated.
        """
        return pulumi.get(self, "last_updated_time_stamp")

    @property
    @pulumi.getter(name="listName")
    def list_name(self) -> Optional[builtins.str]:
        """
        The the name of the suppression list. This value must match one of the valid sender usernames of the sending domain.
        """
        return pulumi.get(self, "list_name")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetSuppressionListResult(GetSuppressionListResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSuppressionListResult(
            azure_api_version=self.azure_api_version,
            created_time_stamp=self.created_time_stamp,
            data_location=self.data_location,
            id=self.id,
            last_updated_time_stamp=self.last_updated_time_stamp,
            list_name=self.list_name,
            name=self.name,
            system_data=self.system_data,
            type=self.type)


def get_suppression_list(domain_name: Optional[builtins.str] = None,
                         email_service_name: Optional[builtins.str] = None,
                         resource_group_name: Optional[builtins.str] = None,
                         suppression_list_name: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSuppressionListResult:
    """
    Get a SuppressionList resource.

    Uses Azure REST API version 2023-06-01-preview.

    Other available API versions: 2024-09-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native communication [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str domain_name: The name of the Domains resource.
    :param builtins.str email_service_name: The name of the EmailService resource.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str suppression_list_name: The name of the suppression list.
    """
    __args__ = dict()
    __args__['domainName'] = domain_name
    __args__['emailServiceName'] = email_service_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['suppressionListName'] = suppression_list_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:communication:getSuppressionList', __args__, opts=opts, typ=GetSuppressionListResult).value

    return AwaitableGetSuppressionListResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        created_time_stamp=pulumi.get(__ret__, 'created_time_stamp'),
        data_location=pulumi.get(__ret__, 'data_location'),
        id=pulumi.get(__ret__, 'id'),
        last_updated_time_stamp=pulumi.get(__ret__, 'last_updated_time_stamp'),
        list_name=pulumi.get(__ret__, 'list_name'),
        name=pulumi.get(__ret__, 'name'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_suppression_list_output(domain_name: Optional[pulumi.Input[builtins.str]] = None,
                                email_service_name: Optional[pulumi.Input[builtins.str]] = None,
                                resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                suppression_list_name: Optional[pulumi.Input[builtins.str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSuppressionListResult]:
    """
    Get a SuppressionList resource.

    Uses Azure REST API version 2023-06-01-preview.

    Other available API versions: 2024-09-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native communication [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str domain_name: The name of the Domains resource.
    :param builtins.str email_service_name: The name of the EmailService resource.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str suppression_list_name: The name of the suppression list.
    """
    __args__ = dict()
    __args__['domainName'] = domain_name
    __args__['emailServiceName'] = email_service_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['suppressionListName'] = suppression_list_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:communication:getSuppressionList', __args__, opts=opts, typ=GetSuppressionListResult)
    return __ret__.apply(lambda __response__: GetSuppressionListResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        created_time_stamp=pulumi.get(__response__, 'created_time_stamp'),
        data_location=pulumi.get(__response__, 'data_location'),
        id=pulumi.get(__response__, 'id'),
        last_updated_time_stamp=pulumi.get(__response__, 'last_updated_time_stamp'),
        list_name=pulumi.get(__response__, 'list_name'),
        name=pulumi.get(__response__, 'name'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
