# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult',
    'AwaitableGetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult',
    'get_enterprise_mcc_cache_nodes_operation_cache_node_install_details',
    'get_enterprise_mcc_cache_nodes_operation_cache_node_install_details_output',
]

@pulumi.output_type
class GetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult:
    """
    Mcc cache node resource all install details.
    """
    def __init__(__self__, id=None, location=None, name=None, properties=None, system_data=None, tags=None, type=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> builtins.str:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.CacheNodeInstallPropertiesResponse':
        """
        Mcc cache node resource install script details.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, builtins.str]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult(GetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult(
            id=self.id,
            location=self.location,
            name=self.name,
            properties=self.properties,
            system_data=self.system_data,
            tags=self.tags,
            type=self.type)


def get_enterprise_mcc_cache_nodes_operation_cache_node_install_details(cache_node_resource_name: Optional[builtins.str] = None,
                                                                        customer_resource_name: Optional[builtins.str] = None,
                                                                        resource_group_name: Optional[builtins.str] = None,
                                                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult:
    """
    This api gets secrets of the ispCacheNode resource install details

    Uses Azure REST API version 2023-05-01-preview.


    :param builtins.str cache_node_resource_name: Name of the ConnectedCache resource
    :param builtins.str customer_resource_name: Name of the Customer resource
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['cacheNodeResourceName'] = cache_node_resource_name
    __args__['customerResourceName'] = customer_resource_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:connectedcache:getEnterpriseMccCacheNodesOperationCacheNodeInstallDetails', __args__, opts=opts, typ=GetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult).value

    return AwaitableGetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult(
        id=pulumi.get(__ret__, 'id'),
        location=pulumi.get(__ret__, 'location'),
        name=pulumi.get(__ret__, 'name'),
        properties=pulumi.get(__ret__, 'properties'),
        system_data=pulumi.get(__ret__, 'system_data'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'))
def get_enterprise_mcc_cache_nodes_operation_cache_node_install_details_output(cache_node_resource_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                               customer_resource_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                               resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult]:
    """
    This api gets secrets of the ispCacheNode resource install details

    Uses Azure REST API version 2023-05-01-preview.


    :param builtins.str cache_node_resource_name: Name of the ConnectedCache resource
    :param builtins.str customer_resource_name: Name of the Customer resource
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['cacheNodeResourceName'] = cache_node_resource_name
    __args__['customerResourceName'] = customer_resource_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:connectedcache:getEnterpriseMccCacheNodesOperationCacheNodeInstallDetails', __args__, opts=opts, typ=GetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult)
    return __ret__.apply(lambda __response__: GetEnterpriseMccCacheNodesOperationCacheNodeInstallDetailsResult(
        id=pulumi.get(__response__, 'id'),
        location=pulumi.get(__response__, 'location'),
        name=pulumi.get(__response__, 'name'),
        properties=pulumi.get(__response__, 'properties'),
        system_data=pulumi.get(__response__, 'system_data'),
        tags=pulumi.get(__response__, 'tags'),
        type=pulumi.get(__response__, 'type')))
