# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetArchiveVersionResult',
    'AwaitableGetArchiveVersionResult',
    'get_archive_version',
    'get_archive_version_output',
]

@pulumi.output_type
class GetArchiveVersionResult:
    """
    An object that represents an export pipeline for a container registry.
    """
    def __init__(__self__, archive_version_error_message=None, azure_api_version=None, id=None, name=None, provisioning_state=None, system_data=None, type=None):
        if archive_version_error_message and not isinstance(archive_version_error_message, str):
            raise TypeError("Expected argument 'archive_version_error_message' to be a str")
        pulumi.set(__self__, "archive_version_error_message", archive_version_error_message)
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="archiveVersionErrorMessage")
    def archive_version_error_message(self) -> Optional[builtins.str]:
        """
        The detailed error message for the archive version in the case of failure.
        """
        return pulumi.get(self, "archive_version_error_message")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The resource ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The provisioning state of the archive at the time the operation was called.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Metadata pertaining to creation and last modification of the resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource.
        """
        return pulumi.get(self, "type")


class AwaitableGetArchiveVersionResult(GetArchiveVersionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetArchiveVersionResult(
            archive_version_error_message=self.archive_version_error_message,
            azure_api_version=self.azure_api_version,
            id=self.id,
            name=self.name,
            provisioning_state=self.provisioning_state,
            system_data=self.system_data,
            type=self.type)


def get_archive_version(archive_name: Optional[builtins.str] = None,
                        archive_version_name: Optional[builtins.str] = None,
                        package_type: Optional[builtins.str] = None,
                        registry_name: Optional[builtins.str] = None,
                        resource_group_name: Optional[builtins.str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetArchiveVersionResult:
    """
    Gets the properties of the archive version.

    Uses Azure REST API version 2024-11-01-preview.

    Other available API versions: 2023-06-01-preview, 2023-08-01-preview, 2023-11-01-preview, 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native containerregistry [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str archive_name: The name of the archive resource.
    :param builtins.str archive_version_name: The name of the archive version resource.
    :param builtins.str package_type: The type of the package resource.
    :param builtins.str registry_name: The name of the container registry.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['archiveName'] = archive_name
    __args__['archiveVersionName'] = archive_version_name
    __args__['packageType'] = package_type
    __args__['registryName'] = registry_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:containerregistry:getArchiveVersion', __args__, opts=opts, typ=GetArchiveVersionResult).value

    return AwaitableGetArchiveVersionResult(
        archive_version_error_message=pulumi.get(__ret__, 'archive_version_error_message'),
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_archive_version_output(archive_name: Optional[pulumi.Input[builtins.str]] = None,
                               archive_version_name: Optional[pulumi.Input[builtins.str]] = None,
                               package_type: Optional[pulumi.Input[builtins.str]] = None,
                               registry_name: Optional[pulumi.Input[builtins.str]] = None,
                               resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetArchiveVersionResult]:
    """
    Gets the properties of the archive version.

    Uses Azure REST API version 2024-11-01-preview.

    Other available API versions: 2023-06-01-preview, 2023-08-01-preview, 2023-11-01-preview, 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native containerregistry [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str archive_name: The name of the archive resource.
    :param builtins.str archive_version_name: The name of the archive version resource.
    :param builtins.str package_type: The type of the package resource.
    :param builtins.str registry_name: The name of the container registry.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['archiveName'] = archive_name
    __args__['archiveVersionName'] = archive_version_name
    __args__['packageType'] = package_type
    __args__['registryName'] = registry_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:containerregistry:getArchiveVersion', __args__, opts=opts, typ=GetArchiveVersionResult)
    return __ret__.apply(lambda __response__: GetArchiveVersionResult(
        archive_version_error_message=pulumi.get(__response__, 'archive_version_error_message'),
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
