# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListAgentPoolQueueStatusResult',
    'AwaitableListAgentPoolQueueStatusResult',
    'list_agent_pool_queue_status',
    'list_agent_pool_queue_status_output',
]

@pulumi.output_type
class ListAgentPoolQueueStatusResult:
    """
    The QueueStatus of Agent Pool
    """
    def __init__(__self__, count=None):
        if count and not isinstance(count, int):
            raise TypeError("Expected argument 'count' to be a int")
        pulumi.set(__self__, "count", count)

    @property
    @pulumi.getter
    def count(self) -> Optional[builtins.int]:
        """
        The number of pending runs in the queue
        """
        return pulumi.get(self, "count")


class AwaitableListAgentPoolQueueStatusResult(ListAgentPoolQueueStatusResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListAgentPoolQueueStatusResult(
            count=self.count)


def list_agent_pool_queue_status(agent_pool_name: Optional[builtins.str] = None,
                                 registry_name: Optional[builtins.str] = None,
                                 resource_group_name: Optional[builtins.str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListAgentPoolQueueStatusResult:
    """
    Gets the count of queued runs for a given agent pool.

    Uses Azure REST API version 2019-06-01-preview.

    Other available API versions: 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native containerregistry [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str agent_pool_name: The name of the agent pool.
    :param builtins.str registry_name: The name of the container registry.
    :param builtins.str resource_group_name: The name of the resource group to which the container registry belongs.
    """
    __args__ = dict()
    __args__['agentPoolName'] = agent_pool_name
    __args__['registryName'] = registry_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:containerregistry:listAgentPoolQueueStatus', __args__, opts=opts, typ=ListAgentPoolQueueStatusResult).value

    return AwaitableListAgentPoolQueueStatusResult(
        count=pulumi.get(__ret__, 'count'))
def list_agent_pool_queue_status_output(agent_pool_name: Optional[pulumi.Input[builtins.str]] = None,
                                        registry_name: Optional[pulumi.Input[builtins.str]] = None,
                                        resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListAgentPoolQueueStatusResult]:
    """
    Gets the count of queued runs for a given agent pool.

    Uses Azure REST API version 2019-06-01-preview.

    Other available API versions: 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native containerregistry [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str agent_pool_name: The name of the agent pool.
    :param builtins.str registry_name: The name of the container registry.
    :param builtins.str resource_group_name: The name of the resource group to which the container registry belongs.
    """
    __args__ = dict()
    __args__['agentPoolName'] = agent_pool_name
    __args__['registryName'] = registry_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:containerregistry:listAgentPoolQueueStatus', __args__, opts=opts, typ=ListAgentPoolQueueStatusResult)
    return __ret__.apply(lambda __response__: ListAgentPoolQueueStatusResult(
        count=pulumi.get(__response__, 'count')))
