# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetLoadBalancerResult',
    'AwaitableGetLoadBalancerResult',
    'get_load_balancer',
    'get_load_balancer_output',
]

@pulumi.output_type
class GetLoadBalancerResult:
    """
    The configurations regarding multiple standard load balancers. If not supplied, single load balancer mode will be used. Multiple standard load balancers mode will be used if at lease one configuration is supplied. There has to be a configuration named `kubernetes`.
    """
    def __init__(__self__, allow_service_placement=None, azure_api_version=None, id=None, name=None, node_selector=None, primary_agent_pool_name=None, provisioning_state=None, service_label_selector=None, service_namespace_selector=None, system_data=None, type=None):
        if allow_service_placement and not isinstance(allow_service_placement, bool):
            raise TypeError("Expected argument 'allow_service_placement' to be a bool")
        pulumi.set(__self__, "allow_service_placement", allow_service_placement)
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if node_selector and not isinstance(node_selector, dict):
            raise TypeError("Expected argument 'node_selector' to be a dict")
        pulumi.set(__self__, "node_selector", node_selector)
        if primary_agent_pool_name and not isinstance(primary_agent_pool_name, str):
            raise TypeError("Expected argument 'primary_agent_pool_name' to be a str")
        pulumi.set(__self__, "primary_agent_pool_name", primary_agent_pool_name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if service_label_selector and not isinstance(service_label_selector, dict):
            raise TypeError("Expected argument 'service_label_selector' to be a dict")
        pulumi.set(__self__, "service_label_selector", service_label_selector)
        if service_namespace_selector and not isinstance(service_namespace_selector, dict):
            raise TypeError("Expected argument 'service_namespace_selector' to be a dict")
        pulumi.set(__self__, "service_namespace_selector", service_namespace_selector)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="allowServicePlacement")
    def allow_service_placement(self) -> Optional[builtins.bool]:
        """
        Whether to automatically place services on the load balancer. If not supplied, the default value is true. If set to false manually, both of the external and the internal load balancer will not be selected for services unless they explicitly target it.
        """
        return pulumi.get(self, "allow_service_placement")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodeSelector")
    def node_selector(self) -> Optional['outputs.LabelSelectorResponse']:
        """
        Nodes that match this selector will be possible members of this load balancer.
        """
        return pulumi.get(self, "node_selector")

    @property
    @pulumi.getter(name="primaryAgentPoolName")
    def primary_agent_pool_name(self) -> builtins.str:
        """
        Required field. A string value that must specify the ID of an existing agent pool. All nodes in the given pool will always be added to this load balancer. This agent pool must have at least one node and minCount>=1 for autoscaling operations. An agent pool can only be the primary pool for a single load balancer.
        """
        return pulumi.get(self, "primary_agent_pool_name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The current provisioning state.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="serviceLabelSelector")
    def service_label_selector(self) -> Optional['outputs.LabelSelectorResponse']:
        """
        Only services that must match this selector can be placed on this load balancer.
        """
        return pulumi.get(self, "service_label_selector")

    @property
    @pulumi.getter(name="serviceNamespaceSelector")
    def service_namespace_selector(self) -> Optional['outputs.LabelSelectorResponse']:
        """
        Services created in namespaces that match the selector can be placed on this load balancer.
        """
        return pulumi.get(self, "service_namespace_selector")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetLoadBalancerResult(GetLoadBalancerResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLoadBalancerResult(
            allow_service_placement=self.allow_service_placement,
            azure_api_version=self.azure_api_version,
            id=self.id,
            name=self.name,
            node_selector=self.node_selector,
            primary_agent_pool_name=self.primary_agent_pool_name,
            provisioning_state=self.provisioning_state,
            service_label_selector=self.service_label_selector,
            service_namespace_selector=self.service_namespace_selector,
            system_data=self.system_data,
            type=self.type)


def get_load_balancer(load_balancer_name: Optional[builtins.str] = None,
                      resource_group_name: Optional[builtins.str] = None,
                      resource_name: Optional[builtins.str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLoadBalancerResult:
    """
    The configurations regarding multiple standard load balancers. If not supplied, single load balancer mode will be used. Multiple standard load balancers mode will be used if at lease one configuration is supplied. There has to be a configuration named `kubernetes`.

    Uses Azure REST API version 2024-10-02-preview.

    Other available API versions: 2024-03-02-preview, 2024-04-02-preview, 2024-05-02-preview, 2024-06-02-preview, 2024-07-02-preview, 2024-09-02-preview, 2025-01-02-preview, 2025-02-02-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native containerservice [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str load_balancer_name: The name of the load balancer.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str resource_name: The name of the managed cluster resource.
    """
    __args__ = dict()
    __args__['loadBalancerName'] = load_balancer_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['resourceName'] = resource_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:containerservice:getLoadBalancer', __args__, opts=opts, typ=GetLoadBalancerResult).value

    return AwaitableGetLoadBalancerResult(
        allow_service_placement=pulumi.get(__ret__, 'allow_service_placement'),
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        node_selector=pulumi.get(__ret__, 'node_selector'),
        primary_agent_pool_name=pulumi.get(__ret__, 'primary_agent_pool_name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        service_label_selector=pulumi.get(__ret__, 'service_label_selector'),
        service_namespace_selector=pulumi.get(__ret__, 'service_namespace_selector'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_load_balancer_output(load_balancer_name: Optional[pulumi.Input[builtins.str]] = None,
                             resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                             resource_name: Optional[pulumi.Input[builtins.str]] = None,
                             opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetLoadBalancerResult]:
    """
    The configurations regarding multiple standard load balancers. If not supplied, single load balancer mode will be used. Multiple standard load balancers mode will be used if at lease one configuration is supplied. There has to be a configuration named `kubernetes`.

    Uses Azure REST API version 2024-10-02-preview.

    Other available API versions: 2024-03-02-preview, 2024-04-02-preview, 2024-05-02-preview, 2024-06-02-preview, 2024-07-02-preview, 2024-09-02-preview, 2025-01-02-preview, 2025-02-02-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native containerservice [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str load_balancer_name: The name of the load balancer.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str resource_name: The name of the managed cluster resource.
    """
    __args__ = dict()
    __args__['loadBalancerName'] = load_balancer_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['resourceName'] = resource_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:containerservice:getLoadBalancer', __args__, opts=opts, typ=GetLoadBalancerResult)
    return __ret__.apply(lambda __response__: GetLoadBalancerResult(
        allow_service_placement=pulumi.get(__response__, 'allow_service_placement'),
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        node_selector=pulumi.get(__response__, 'node_selector'),
        primary_agent_pool_name=pulumi.get(__response__, 'primary_agent_pool_name'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        service_label_selector=pulumi.get(__response__, 'service_label_selector'),
        service_namespace_selector=pulumi.get(__response__, 'service_namespace_selector'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
