# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListNamespaceCredentialResult',
    'AwaitableListNamespaceCredentialResult',
    'list_namespace_credential',
    'list_namespace_credential_output',
]

@pulumi.output_type
class ListNamespaceCredentialResult:
    """
    The list credential result response.
    """
    def __init__(__self__, kubeconfigs=None):
        if kubeconfigs and not isinstance(kubeconfigs, list):
            raise TypeError("Expected argument 'kubeconfigs' to be a list")
        pulumi.set(__self__, "kubeconfigs", kubeconfigs)

    @property
    @pulumi.getter
    def kubeconfigs(self) -> Sequence['outputs.CredentialResultResponse']:
        """
        Base64-encoded Kubernetes configuration file.
        """
        return pulumi.get(self, "kubeconfigs")


class AwaitableListNamespaceCredentialResult(ListNamespaceCredentialResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListNamespaceCredentialResult(
            kubeconfigs=self.kubeconfigs)


def list_namespace_credential(namespace_name: Optional[builtins.str] = None,
                              resource_group_name: Optional[builtins.str] = None,
                              resource_name: Optional[builtins.str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListNamespaceCredentialResult:
    """
    The list credential result response.

    Uses Azure REST API version 2025-02-02-preview.


    :param builtins.str namespace_name: The name of the namespace.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str resource_name: The name of the managed cluster resource.
    """
    __args__ = dict()
    __args__['namespaceName'] = namespace_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['resourceName'] = resource_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:containerservice:listNamespaceCredential', __args__, opts=opts, typ=ListNamespaceCredentialResult).value

    return AwaitableListNamespaceCredentialResult(
        kubeconfigs=pulumi.get(__ret__, 'kubeconfigs'))
def list_namespace_credential_output(namespace_name: Optional[pulumi.Input[builtins.str]] = None,
                                     resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                     resource_name: Optional[pulumi.Input[builtins.str]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListNamespaceCredentialResult]:
    """
    The list credential result response.

    Uses Azure REST API version 2025-02-02-preview.


    :param builtins.str namespace_name: The name of the namespace.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str resource_name: The name of the managed cluster resource.
    """
    __args__ = dict()
    __args__['namespaceName'] = namespace_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['resourceName'] = resource_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:containerservice:listNamespaceCredential', __args__, opts=opts, typ=ListNamespaceCredentialResult)
    return __ret__.apply(lambda __response__: ListNamespaceCredentialResult(
        kubeconfigs=pulumi.get(__response__, 'kubeconfigs')))
