# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AnalyticalStorageSchemaType',
    'AuthenticationMethod',
    'AzureConnectionType',
    'BackupPolicyMigrationStatus',
    'BackupPolicyType',
    'BackupStorageRedundancy',
    'CompositePathSortOrder',
    'ConflictResolutionMode',
    'ConnectorOffer',
    'ContinuousTier',
    'CreateMode',
    'DataType',
    'DatabaseAccountKind',
    'DatabaseAccountOfferType',
    'DedicatedGatewayType',
    'DefaultConsistencyLevel',
    'DistanceFunction',
    'FleetspaceApiKind',
    'IndexKind',
    'IndexingMode',
    'ManagedCassandraProvisioningState',
    'ManagedCassandraResourceIdentityType',
    'MinimalTlsVersion',
    'MongoClusterCreateMode',
    'MongoRoleDefinitionType',
    'NetworkAclBypass',
    'NodeKind',
    'PartitionKind',
    'PublicNetworkAccess',
    'ResourceIdentityType',
    'RestoreMode',
    'RoleDefinitionType',
    'ServerVersion',
    'ServiceSize',
    'ServiceTier',
    'ServiceType',
    'SpatialType',
    'StorageLocationType',
    'TriggerOperation',
    'TriggerType',
    'VectorDataType',
    'VectorIndexType',
]


@pulumi.type_token("azure-native:cosmosdb:AnalyticalStorageSchemaType")
class AnalyticalStorageSchemaType(builtins.str, Enum):
    """
    Describes the types of schema for analytical storage.
    """
    WELL_DEFINED = "WellDefined"
    FULL_FIDELITY = "FullFidelity"


@pulumi.type_token("azure-native:cosmosdb:AuthenticationMethod")
class AuthenticationMethod(builtins.str, Enum):
    """
    Which authentication method Cassandra should use to authenticate clients. 'None' turns off authentication, so should not be used except in emergencies. 'Cassandra' is the default password based authentication. The default is 'Cassandra'.
    """
    NONE = "None"
    CASSANDRA = "Cassandra"
    LDAP = "Ldap"


@pulumi.type_token("azure-native:cosmosdb:AzureConnectionType")
class AzureConnectionType(builtins.str, Enum):
    """
    How to connect to the azure services needed for running the cluster
    """
    NONE = "None"
    VPN = "VPN"


@pulumi.type_token("azure-native:cosmosdb:BackupPolicyMigrationStatus")
class BackupPolicyMigrationStatus(builtins.str, Enum):
    """
    Describes the status of migration between backup policy types.
    """
    INVALID = "Invalid"
    IN_PROGRESS = "InProgress"
    COMPLETED = "Completed"
    FAILED = "Failed"


@pulumi.type_token("azure-native:cosmosdb:BackupPolicyType")
class BackupPolicyType(builtins.str, Enum):
    """
    Describes the mode of backups.
    """
    PERIODIC = "Periodic"
    CONTINUOUS = "Continuous"


@pulumi.type_token("azure-native:cosmosdb:BackupStorageRedundancy")
class BackupStorageRedundancy(builtins.str, Enum):
    """
    Enum to indicate type of backup residency
    """
    GEO = "Geo"
    LOCAL = "Local"
    ZONE = "Zone"


@pulumi.type_token("azure-native:cosmosdb:CompositePathSortOrder")
class CompositePathSortOrder(builtins.str, Enum):
    """
    Sort order for composite paths.
    """
    ASCENDING = "ascending"
    DESCENDING = "descending"


@pulumi.type_token("azure-native:cosmosdb:ConflictResolutionMode")
class ConflictResolutionMode(builtins.str, Enum):
    """
    Indicates the conflict resolution mode.
    """
    LAST_WRITER_WINS = "LastWriterWins"
    CUSTOM = "Custom"


@pulumi.type_token("azure-native:cosmosdb:ConnectorOffer")
class ConnectorOffer(builtins.str, Enum):
    """
    The cassandra connector offer type for the Cosmos DB database C* account.
    """
    SMALL = "Small"


@pulumi.type_token("azure-native:cosmosdb:ContinuousTier")
class ContinuousTier(builtins.str, Enum):
    """
    Enum to indicate type of Continuous backup mode
    """
    CONTINUOUS7_DAYS = "Continuous7Days"
    CONTINUOUS30_DAYS = "Continuous30Days"


@pulumi.type_token("azure-native:cosmosdb:CreateMode")
class CreateMode(builtins.str, Enum):
    """
    Enum to indicate the mode of resource creation.
    """
    DEFAULT = "Default"
    RESTORE = "Restore"


@pulumi.type_token("azure-native:cosmosdb:DataType")
class DataType(builtins.str, Enum):
    """
    The datatype for which the indexing behavior is applied to.
    """
    STRING = "String"
    NUMBER = "Number"
    POINT = "Point"
    POLYGON = "Polygon"
    LINE_STRING = "LineString"
    MULTI_POLYGON = "MultiPolygon"


@pulumi.type_token("azure-native:cosmosdb:DatabaseAccountKind")
class DatabaseAccountKind(builtins.str, Enum):
    """
    Indicates the type of database account. This can only be set at database account creation.
    """
    GLOBAL_DOCUMENT_DB = "GlobalDocumentDB"
    MONGO_DB = "MongoDB"
    PARSE = "Parse"


@pulumi.type_token("azure-native:cosmosdb:DatabaseAccountOfferType")
class DatabaseAccountOfferType(builtins.str, Enum):
    """
    The offer type for the database
    """
    STANDARD = "Standard"


@pulumi.type_token("azure-native:cosmosdb:DedicatedGatewayType")
class DedicatedGatewayType(builtins.str, Enum):
    """
    DedicatedGatewayType for the service.
    """
    INTEGRATED_CACHE = "IntegratedCache"
    DISTRIBUTED_QUERY = "DistributedQuery"


@pulumi.type_token("azure-native:cosmosdb:DefaultConsistencyLevel")
class DefaultConsistencyLevel(builtins.str, Enum):
    """
    The default consistency level and configuration settings of the Cosmos DB account.
    """
    EVENTUAL = "Eventual"
    SESSION = "Session"
    BOUNDED_STALENESS = "BoundedStaleness"
    STRONG = "Strong"
    CONSISTENT_PREFIX = "ConsistentPrefix"


@pulumi.type_token("azure-native:cosmosdb:DistanceFunction")
class DistanceFunction(builtins.str, Enum):
    """
    The distance function to use for distance calculation in between vectors.
    """
    EUCLIDEAN = "euclidean"
    COSINE = "cosine"
    DOTPRODUCT = "dotproduct"


@pulumi.type_token("azure-native:cosmosdb:FleetspaceApiKind")
class FleetspaceApiKind(builtins.str, Enum):
    """
    The kind of API this fleetspace belongs to. Acceptable values: 'NoSQL'
    """
    NO_SQL = "NoSQL"


@pulumi.type_token("azure-native:cosmosdb:IndexKind")
class IndexKind(builtins.str, Enum):
    """
    Indicates the type of index.
    """
    HASH = "Hash"
    RANGE = "Range"
    SPATIAL = "Spatial"


@pulumi.type_token("azure-native:cosmosdb:IndexingMode")
class IndexingMode(builtins.str, Enum):
    """
    Indicates the indexing mode.
    """
    CONSISTENT = "consistent"
    LAZY = "lazy"
    NONE = "none"


@pulumi.type_token("azure-native:cosmosdb:ManagedCassandraProvisioningState")
class ManagedCassandraProvisioningState(builtins.str, Enum):
    """
    The status of the resource at the time the operation was called.
    """
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    SUCCEEDED = "Succeeded"
    FAILED = "Failed"
    CANCELED = "Canceled"


@pulumi.type_token("azure-native:cosmosdb:ManagedCassandraResourceIdentityType")
class ManagedCassandraResourceIdentityType(builtins.str, Enum):
    """
    The type of the resource.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:cosmosdb:MinimalTlsVersion")
class MinimalTlsVersion(builtins.str, Enum):
    """
    Indicates the minimum allowed Tls version. The default value is Tls 1.2. Cassandra and Mongo APIs only work with Tls 1.2.
    """
    TLS = "Tls"
    TLS11 = "Tls11"
    TLS12 = "Tls12"


@pulumi.type_token("azure-native:cosmosdb:MongoClusterCreateMode")
class MongoClusterCreateMode(builtins.str, Enum):
    """
    The mode to create a mongo cluster.
    """
    DEFAULT = "Default"
    POINT_IN_TIME_RESTORE = "PointInTimeRestore"


@pulumi.type_token("azure-native:cosmosdb:MongoRoleDefinitionType")
class MongoRoleDefinitionType(builtins.str, Enum):
    """
    Indicates whether the Role Definition was built-in or user created.
    """
    BUILT_IN_ROLE = "BuiltInRole"
    CUSTOM_ROLE = "CustomRole"


@pulumi.type_token("azure-native:cosmosdb:NetworkAclBypass")
class NetworkAclBypass(builtins.str, Enum):
    """
    Indicates what services are allowed to bypass firewall checks.
    """
    NONE = "None"
    AZURE_SERVICES = "AzureServices"


@pulumi.type_token("azure-native:cosmosdb:NodeKind")
class NodeKind(builtins.str, Enum):
    """
    The node type deployed in the node group.
    """
    SHARD = "Shard"


@pulumi.type_token("azure-native:cosmosdb:PartitionKind")
class PartitionKind(builtins.str, Enum):
    """
    Indicates the kind of algorithm used for partitioning. For MultiHash, multiple partition keys (upto three maximum) are supported for container create
    """
    HASH = "Hash"
    RANGE = "Range"
    MULTI_HASH = "MultiHash"


@pulumi.type_token("azure-native:cosmosdb:PublicNetworkAccess")
class PublicNetworkAccess(builtins.str, Enum):
    """
    Whether requests from Public Network are allowed
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"
    SECURED_BY_PERIMETER = "SecuredByPerimeter"


@pulumi.type_token("azure-native:cosmosdb:ResourceIdentityType")
class ResourceIdentityType(builtins.str, Enum):
    """
    The type of identity used for the resource. The type 'SystemAssigned,UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove any identities from the service.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:cosmosdb:RestoreMode")
class RestoreMode(builtins.str, Enum):
    """
    Describes the mode of the restore.
    """
    POINT_IN_TIME = "PointInTime"


@pulumi.type_token("azure-native:cosmosdb:RoleDefinitionType")
class RoleDefinitionType(builtins.str, Enum):
    """
    Indicates whether the Role Definition was built-in or user created.
    """
    BUILT_IN_ROLE = "BuiltInRole"
    CUSTOM_ROLE = "CustomRole"


@pulumi.type_token("azure-native:cosmosdb:ServerVersion")
class ServerVersion(builtins.str, Enum):
    """
    Describes the version of the MongoDB account.
    """
    SERVER_VERSION_3_2 = "3.2"
    SERVER_VERSION_3_6 = "3.6"
    SERVER_VERSION_4_0 = "4.0"
    SERVER_VERSION_4_2 = "4.2"
    SERVER_VERSION_5_0 = "5.0"
    SERVER_VERSION_6_0 = "6.0"
    SERVER_VERSION_7_0 = "7.0"


@pulumi.type_token("azure-native:cosmosdb:ServiceSize")
class ServiceSize(builtins.str, Enum):
    """
    Instance type for the service.
    """
    COSMOS_D4S = "Cosmos.D4s"
    COSMOS_D8S = "Cosmos.D8s"
    COSMOS_D16S = "Cosmos.D16s"


@pulumi.type_token("azure-native:cosmosdb:ServiceTier")
class ServiceTier(builtins.str, Enum):
    """
    Service Tier for the fleetspace. GeneralPurpose types refers to single write region accounts that can be added to this fleetspace, whereas BusinessCritical refers to multi write region.
    """
    GENERAL_PURPOSE = "GeneralPurpose"
    BUSINESS_CRITICAL = "BusinessCritical"


@pulumi.type_token("azure-native:cosmosdb:ServiceType")
class ServiceType(builtins.str, Enum):
    """
    ServiceType for the service.
    """
    SQL_DEDICATED_GATEWAY = "SqlDedicatedGateway"
    DATA_TRANSFER = "DataTransfer"
    GRAPH_API_COMPUTE = "GraphAPICompute"
    MATERIALIZED_VIEWS_BUILDER = "MaterializedViewsBuilder"


@pulumi.type_token("azure-native:cosmosdb:SpatialType")
class SpatialType(builtins.str, Enum):
    """
    Indicates the spatial type of index.
    """
    POINT = "Point"
    LINE_STRING = "LineString"
    POLYGON = "Polygon"
    MULTI_POLYGON = "MultiPolygon"


@pulumi.type_token("azure-native:cosmosdb:StorageLocationType")
class StorageLocationType(builtins.str, Enum):
    """
    The type of the fleet analytics resource.
    """
    STORAGE_ACCOUNT = "StorageAccount"
    FABRIC_LAKEHOUSE = "FabricLakehouse"


@pulumi.type_token("azure-native:cosmosdb:TriggerOperation")
class TriggerOperation(builtins.str, Enum):
    """
    The operation the trigger is associated with
    """
    ALL = "All"
    CREATE = "Create"
    UPDATE = "Update"
    DELETE = "Delete"
    REPLACE = "Replace"


@pulumi.type_token("azure-native:cosmosdb:TriggerType")
class TriggerType(builtins.str, Enum):
    """
    Type of the Trigger
    """
    PRE = "Pre"
    POST = "Post"


@pulumi.type_token("azure-native:cosmosdb:VectorDataType")
class VectorDataType(builtins.str, Enum):
    """
    Indicates the data type of vector.
    """
    FLOAT32 = "float32"
    UINT8 = "uint8"
    INT8 = "int8"


@pulumi.type_token("azure-native:cosmosdb:VectorIndexType")
class VectorIndexType(builtins.str, Enum):
    """
    The index type of the vector. Currently, flat, diskANN, and quantizedFlat are supported.
    """
    FLAT = "flat"
    DISK_ANN = "diskANN"
    QUANTIZED_FLAT = "quantizedFlat"
