# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *
from ._inputs import *

__all__ = ['DatabaseAccountGremlinDatabaseArgs', 'DatabaseAccountGremlinDatabase']

@pulumi.input_type
class DatabaseAccountGremlinDatabaseArgs:
    def __init__(__self__, *,
                 account_name: pulumi.Input[builtins.str],
                 options: pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]],
                 resource: pulumi.Input['GremlinDatabaseResourceArgs'],
                 resource_group_name: pulumi.Input[builtins.str],
                 database_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a DatabaseAccountGremlinDatabase resource.
        :param pulumi.Input[builtins.str] account_name: Cosmos DB database account name.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] options: A key-value pair of options to be applied for the request. This corresponds to the headers sent with the request.
        :param pulumi.Input['GremlinDatabaseResourceArgs'] resource: The standard JSON format of a Gremlin database
        :param pulumi.Input[builtins.str] resource_group_name: Name of an Azure resource group.
        :param pulumi.Input[builtins.str] database_name: Cosmos DB database name.
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "options", options)
        pulumi.set(__self__, "resource", resource)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if database_name is not None:
            pulumi.set(__self__, "database_name", database_name)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> pulumi.Input[builtins.str]:
        """
        Cosmos DB database account name.
        """
        return pulumi.get(self, "account_name")

    @account_name.setter
    def account_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "account_name", value)

    @property
    @pulumi.getter
    def options(self) -> pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]:
        """
        A key-value pair of options to be applied for the request. This corresponds to the headers sent with the request.
        """
        return pulumi.get(self, "options")

    @options.setter
    def options(self, value: pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]):
        pulumi.set(self, "options", value)

    @property
    @pulumi.getter
    def resource(self) -> pulumi.Input['GremlinDatabaseResourceArgs']:
        """
        The standard JSON format of a Gremlin database
        """
        return pulumi.get(self, "resource")

    @resource.setter
    def resource(self, value: pulumi.Input['GremlinDatabaseResourceArgs']):
        pulumi.set(self, "resource", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        Name of an Azure resource group.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="databaseName")
    def database_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Cosmos DB database name.
        """
        return pulumi.get(self, "database_name")

    @database_name.setter
    def database_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "database_name", value)


@pulumi.type_token("azure-native:cosmosdb:DatabaseAccountGremlinDatabase")
class DatabaseAccountGremlinDatabase(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 database_name: Optional[pulumi.Input[builtins.str]] = None,
                 options: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 resource: Optional[pulumi.Input[Union['GremlinDatabaseResourceArgs', 'GremlinDatabaseResourceArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        An Azure Cosmos DB Gremlin database.

        Uses Azure REST API version 2016-03-31.

        Other available API versions: 2015-04-01, 2015-04-08, 2015-11-06, 2016-03-19. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native cosmosdb [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] account_name: Cosmos DB database account name.
        :param pulumi.Input[builtins.str] database_name: Cosmos DB database name.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] options: A key-value pair of options to be applied for the request. This corresponds to the headers sent with the request.
        :param pulumi.Input[Union['GremlinDatabaseResourceArgs', 'GremlinDatabaseResourceArgsDict']] resource: The standard JSON format of a Gremlin database
        :param pulumi.Input[builtins.str] resource_group_name: Name of an Azure resource group.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DatabaseAccountGremlinDatabaseArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        An Azure Cosmos DB Gremlin database.

        Uses Azure REST API version 2016-03-31.

        Other available API versions: 2015-04-01, 2015-04-08, 2015-11-06, 2016-03-19. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native cosmosdb [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param DatabaseAccountGremlinDatabaseArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DatabaseAccountGremlinDatabaseArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 database_name: Optional[pulumi.Input[builtins.str]] = None,
                 options: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 resource: Optional[pulumi.Input[Union['GremlinDatabaseResourceArgs', 'GremlinDatabaseResourceArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DatabaseAccountGremlinDatabaseArgs.__new__(DatabaseAccountGremlinDatabaseArgs)

            if account_name is None and not opts.urn:
                raise TypeError("Missing required property 'account_name'")
            __props__.__dict__["account_name"] = account_name
            __props__.__dict__["database_name"] = database_name
            if options is None and not opts.urn:
                raise TypeError("Missing required property 'options'")
            __props__.__dict__["options"] = options
            if resource is None and not opts.urn:
                raise TypeError("Missing required property 'resource'")
            __props__.__dict__["resource"] = resource
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["etag"] = None
            __props__.__dict__["location"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["rid"] = None
            __props__.__dict__["tags"] = None
            __props__.__dict__["ts"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:cosmosdb/v20150401:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20150408:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20151106:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20160319:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20160331:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20190801:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20191212:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20200301:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20200401:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20200601preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20200901:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20210115:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20210301preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20210315:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20210401preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20210415:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20210515:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20210615:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20210701preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20211015:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20211015preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20211115preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20220215preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20220515:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20220515preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20220815:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20220815preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20221115:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20221115preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20230301preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20230315:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20230315preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20230415:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20230915:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20230915preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20231115:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20231115preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20240215preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20240515:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20240515preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20240815:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20240901preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20241115:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20241201preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20250415:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:cosmosdb/v20250501preview:DatabaseAccountGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20230315preview:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20230415:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20230915:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20230915preview:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20231115:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20231115preview:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20240215preview:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20240515:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20240515preview:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20240815:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20240901preview:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20241115:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb/v20241201preview:GremlinResourceGremlinDatabase"), pulumi.Alias(type_="azure-native:documentdb:GremlinResourceGremlinDatabase")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(DatabaseAccountGremlinDatabase, __self__).__init__(
            'azure-native:cosmosdb:DatabaseAccountGremlinDatabase',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DatabaseAccountGremlinDatabase':
        """
        Get an existing DatabaseAccountGremlinDatabase resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DatabaseAccountGremlinDatabaseArgs.__new__(DatabaseAccountGremlinDatabaseArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["etag"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["rid"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["ts"] = None
        __props__.__dict__["type"] = None
        return DatabaseAccountGremlinDatabase(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        A system generated property representing the resource etag required for optimistic concurrency control.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The location of the resource group to which the resource belongs.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the database account.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def rid(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        A system generated property. A unique identifier.
        """
        return pulumi.get(self, "rid")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        Tags are a list of key-value pairs that describe the resource. These tags can be used in viewing and grouping this resource (across resource groups). A maximum of 15 tags can be provided for a resource. Each tag must have a key no greater than 128 characters and value no greater than 256 characters. For example, the default experience for a template type is set with "defaultExperience": "Cassandra". Current "defaultExperience" values also include "Table", "Graph", "DocumentDB", and "MongoDB".
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def ts(self) -> pulumi.Output[Optional[Any]]:
        """
        A system generated property that denotes the last updated timestamp of the resource.
        """
        return pulumi.get(self, "ts")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of Azure resource.
        """
        return pulumi.get(self, "type")

