# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *
from ._inputs import *

__all__ = ['DatabaseAccountTableArgs', 'DatabaseAccountTable']

@pulumi.input_type
class DatabaseAccountTableArgs:
    def __init__(__self__, *,
                 account_name: pulumi.Input[builtins.str],
                 options: pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]],
                 resource: pulumi.Input['TableResourceArgs'],
                 resource_group_name: pulumi.Input[builtins.str],
                 table_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a DatabaseAccountTable resource.
        :param pulumi.Input[builtins.str] account_name: Cosmos DB database account name.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] options: A key-value pair of options to be applied for the request. This corresponds to the headers sent with the request.
        :param pulumi.Input['TableResourceArgs'] resource: The standard JSON format of a Table
        :param pulumi.Input[builtins.str] resource_group_name: Name of an Azure resource group.
        :param pulumi.Input[builtins.str] table_name: Cosmos DB table name.
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "options", options)
        pulumi.set(__self__, "resource", resource)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if table_name is not None:
            pulumi.set(__self__, "table_name", table_name)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> pulumi.Input[builtins.str]:
        """
        Cosmos DB database account name.
        """
        return pulumi.get(self, "account_name")

    @account_name.setter
    def account_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "account_name", value)

    @property
    @pulumi.getter
    def options(self) -> pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]:
        """
        A key-value pair of options to be applied for the request. This corresponds to the headers sent with the request.
        """
        return pulumi.get(self, "options")

    @options.setter
    def options(self, value: pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]):
        pulumi.set(self, "options", value)

    @property
    @pulumi.getter
    def resource(self) -> pulumi.Input['TableResourceArgs']:
        """
        The standard JSON format of a Table
        """
        return pulumi.get(self, "resource")

    @resource.setter
    def resource(self, value: pulumi.Input['TableResourceArgs']):
        pulumi.set(self, "resource", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        Name of an Azure resource group.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="tableName")
    def table_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Cosmos DB table name.
        """
        return pulumi.get(self, "table_name")

    @table_name.setter
    def table_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "table_name", value)


@pulumi.type_token("azure-native:cosmosdb:DatabaseAccountTable")
class DatabaseAccountTable(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 options: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 resource: Optional[pulumi.Input[Union['TableResourceArgs', 'TableResourceArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 table_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        An Azure Cosmos DB Table.

        Uses Azure REST API version 2016-03-31.

        Other available API versions: 2015-04-01, 2015-04-08, 2015-11-06, 2016-03-19. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native cosmosdb [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] account_name: Cosmos DB database account name.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] options: A key-value pair of options to be applied for the request. This corresponds to the headers sent with the request.
        :param pulumi.Input[Union['TableResourceArgs', 'TableResourceArgsDict']] resource: The standard JSON format of a Table
        :param pulumi.Input[builtins.str] resource_group_name: Name of an Azure resource group.
        :param pulumi.Input[builtins.str] table_name: Cosmos DB table name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DatabaseAccountTableArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        An Azure Cosmos DB Table.

        Uses Azure REST API version 2016-03-31.

        Other available API versions: 2015-04-01, 2015-04-08, 2015-11-06, 2016-03-19. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native cosmosdb [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param DatabaseAccountTableArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DatabaseAccountTableArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 options: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 resource: Optional[pulumi.Input[Union['TableResourceArgs', 'TableResourceArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 table_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DatabaseAccountTableArgs.__new__(DatabaseAccountTableArgs)

            if account_name is None and not opts.urn:
                raise TypeError("Missing required property 'account_name'")
            __props__.__dict__["account_name"] = account_name
            if options is None and not opts.urn:
                raise TypeError("Missing required property 'options'")
            __props__.__dict__["options"] = options
            if resource is None and not opts.urn:
                raise TypeError("Missing required property 'resource'")
            __props__.__dict__["resource"] = resource
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["table_name"] = table_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["location"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["tags"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:cosmosdb/v20150401:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20150408:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20151106:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20160319:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20160331:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20190801:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20191212:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20200301:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20200401:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20200601preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20200901:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20210115:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20210301preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20210315:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20210401preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20210415:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20210515:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20210615:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20210701preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20211015:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20211015preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20211115preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20220215preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20220515:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20220515preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20220815:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20220815preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20221115:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20221115preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20230301preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20230315:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20230315preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20230415:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20230915:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20230915preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20231115:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20231115preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20240215preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20240515:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20240515preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20240815:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20240901preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20241115:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20241201preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20250415:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:cosmosdb/v20250501preview:DatabaseAccountTable"), pulumi.Alias(type_="azure-native:documentdb/v20230315preview:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20230415:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20230915:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20230915preview:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20231115:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20231115preview:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20240215preview:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20240515:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20240515preview:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20240815:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20240901preview:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20241115:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb/v20241201preview:TableResourceTable"), pulumi.Alias(type_="azure-native:documentdb:TableResourceTable")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(DatabaseAccountTable, __self__).__init__(
            'azure-native:cosmosdb:DatabaseAccountTable',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DatabaseAccountTable':
        """
        Get an existing DatabaseAccountTable resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DatabaseAccountTableArgs.__new__(DatabaseAccountTableArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return DatabaseAccountTable(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The location of the resource group to which the resource belongs.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the database account.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        Tags are a list of key-value pairs that describe the resource. These tags can be used in viewing and grouping this resource (across resource groups). A maximum of 15 tags can be provided for a resource. Each tag must have a key no greater than 128 characters and value no greater than 256 characters. For example, the default experience for a template type is set with "defaultExperience": "Cassandra". Current "defaultExperience" values also include "Table", "Graph", "DocumentDB", and "MongoDB".
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of Azure resource.
        """
        return pulumi.get(self, "type")

