# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = ['FleetAnalyticArgs', 'FleetAnalytic']

@pulumi.input_type
class FleetAnalyticArgs:
    def __init__(__self__, *,
                 fleet_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 fleet_analytics_name: Optional[pulumi.Input[builtins.str]] = None,
                 storage_location_type: Optional[pulumi.Input[Union[builtins.str, 'StorageLocationType']]] = None,
                 storage_location_uri: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a FleetAnalytic resource.
        :param pulumi.Input[builtins.str] fleet_name: Cosmos DB fleet name. Needs to be unique under a subscription.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] fleet_analytics_name: Cosmos DB fleetAnalytics name.
        :param pulumi.Input[Union[builtins.str, 'StorageLocationType']] storage_location_type: The type of the fleet analytics resource.
        :param pulumi.Input[builtins.str] storage_location_uri: The unique identifier of the fleet analytics resource.
        """
        pulumi.set(__self__, "fleet_name", fleet_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if fleet_analytics_name is not None:
            pulumi.set(__self__, "fleet_analytics_name", fleet_analytics_name)
        if storage_location_type is not None:
            pulumi.set(__self__, "storage_location_type", storage_location_type)
        if storage_location_uri is not None:
            pulumi.set(__self__, "storage_location_uri", storage_location_uri)

    @property
    @pulumi.getter(name="fleetName")
    def fleet_name(self) -> pulumi.Input[builtins.str]:
        """
        Cosmos DB fleet name. Needs to be unique under a subscription.
        """
        return pulumi.get(self, "fleet_name")

    @fleet_name.setter
    def fleet_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "fleet_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="fleetAnalyticsName")
    def fleet_analytics_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Cosmos DB fleetAnalytics name.
        """
        return pulumi.get(self, "fleet_analytics_name")

    @fleet_analytics_name.setter
    def fleet_analytics_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "fleet_analytics_name", value)

    @property
    @pulumi.getter(name="storageLocationType")
    def storage_location_type(self) -> Optional[pulumi.Input[Union[builtins.str, 'StorageLocationType']]]:
        """
        The type of the fleet analytics resource.
        """
        return pulumi.get(self, "storage_location_type")

    @storage_location_type.setter
    def storage_location_type(self, value: Optional[pulumi.Input[Union[builtins.str, 'StorageLocationType']]]):
        pulumi.set(self, "storage_location_type", value)

    @property
    @pulumi.getter(name="storageLocationUri")
    def storage_location_uri(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The unique identifier of the fleet analytics resource.
        """
        return pulumi.get(self, "storage_location_uri")

    @storage_location_uri.setter
    def storage_location_uri(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "storage_location_uri", value)


@pulumi.type_token("azure-native:cosmosdb:FleetAnalytic")
class FleetAnalytic(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 fleet_analytics_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleet_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 storage_location_type: Optional[pulumi.Input[Union[builtins.str, 'StorageLocationType']]] = None,
                 storage_location_uri: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        An Azure Cosmos DB FleetAnalytics.

        Uses Azure REST API version 2025-05-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] fleet_analytics_name: Cosmos DB fleetAnalytics name.
        :param pulumi.Input[builtins.str] fleet_name: Cosmos DB fleet name. Needs to be unique under a subscription.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Union[builtins.str, 'StorageLocationType']] storage_location_type: The type of the fleet analytics resource.
        :param pulumi.Input[builtins.str] storage_location_uri: The unique identifier of the fleet analytics resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FleetAnalyticArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        An Azure Cosmos DB FleetAnalytics.

        Uses Azure REST API version 2025-05-01-preview.

        :param str resource_name: The name of the resource.
        :param FleetAnalyticArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FleetAnalyticArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 fleet_analytics_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleet_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 storage_location_type: Optional[pulumi.Input[Union[builtins.str, 'StorageLocationType']]] = None,
                 storage_location_uri: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FleetAnalyticArgs.__new__(FleetAnalyticArgs)

            __props__.__dict__["fleet_analytics_name"] = fleet_analytics_name
            if fleet_name is None and not opts.urn:
                raise TypeError("Missing required property 'fleet_name'")
            __props__.__dict__["fleet_name"] = fleet_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["storage_location_type"] = storage_location_type
            __props__.__dict__["storage_location_uri"] = storage_location_uri
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:cosmosdb/v20250501preview:FleetAnalytic")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(FleetAnalytic, __self__).__init__(
            'azure-native:cosmosdb:FleetAnalytic',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'FleetAnalytic':
        """
        Get an existing FleetAnalytic resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = FleetAnalyticArgs.__new__(FleetAnalyticArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["storage_location_type"] = None
        __props__.__dict__["storage_location_uri"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return FleetAnalytic(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        A provisioning state of the FleetAnalytics.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="storageLocationType")
    def storage_location_type(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The type of the fleet analytics resource.
        """
        return pulumi.get(self, "storage_location_type")

    @property
    @pulumi.getter(name="storageLocationUri")
    def storage_location_uri(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The unique identifier of the fleet analytics resource.
        """
        return pulumi.get(self, "storage_location_uri")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

