# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = ['FleetspaceAccountArgs', 'FleetspaceAccount']

@pulumi.input_type
class FleetspaceAccountArgs:
    def __init__(__self__, *,
                 fleet_name: pulumi.Input[builtins.str],
                 fleetspace_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 account_location: Optional[pulumi.Input[builtins.str]] = None,
                 account_resource_identifier: Optional[pulumi.Input[builtins.str]] = None,
                 fleetspace_account_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a FleetspaceAccount resource.
        :param pulumi.Input[builtins.str] fleet_name: Cosmos DB fleet name. Needs to be unique under a subscription.
        :param pulumi.Input[builtins.str] fleetspace_name: Cosmos DB fleetspace name. Needs to be unique under a fleet.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] account_location: The location of  global database account in the Fleetspace Account.
        :param pulumi.Input[builtins.str] account_resource_identifier: The resource identifier of global database account in the Fleetspace Account.
        :param pulumi.Input[builtins.str] fleetspace_account_name: Cosmos DB fleetspace account name.
        """
        pulumi.set(__self__, "fleet_name", fleet_name)
        pulumi.set(__self__, "fleetspace_name", fleetspace_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if account_location is not None:
            pulumi.set(__self__, "account_location", account_location)
        if account_resource_identifier is not None:
            pulumi.set(__self__, "account_resource_identifier", account_resource_identifier)
        if fleetspace_account_name is not None:
            pulumi.set(__self__, "fleetspace_account_name", fleetspace_account_name)

    @property
    @pulumi.getter(name="fleetName")
    def fleet_name(self) -> pulumi.Input[builtins.str]:
        """
        Cosmos DB fleet name. Needs to be unique under a subscription.
        """
        return pulumi.get(self, "fleet_name")

    @fleet_name.setter
    def fleet_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "fleet_name", value)

    @property
    @pulumi.getter(name="fleetspaceName")
    def fleetspace_name(self) -> pulumi.Input[builtins.str]:
        """
        Cosmos DB fleetspace name. Needs to be unique under a fleet.
        """
        return pulumi.get(self, "fleetspace_name")

    @fleetspace_name.setter
    def fleetspace_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "fleetspace_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="accountLocation")
    def account_location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The location of  global database account in the Fleetspace Account.
        """
        return pulumi.get(self, "account_location")

    @account_location.setter
    def account_location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "account_location", value)

    @property
    @pulumi.getter(name="accountResourceIdentifier")
    def account_resource_identifier(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The resource identifier of global database account in the Fleetspace Account.
        """
        return pulumi.get(self, "account_resource_identifier")

    @account_resource_identifier.setter
    def account_resource_identifier(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "account_resource_identifier", value)

    @property
    @pulumi.getter(name="fleetspaceAccountName")
    def fleetspace_account_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Cosmos DB fleetspace account name.
        """
        return pulumi.get(self, "fleetspace_account_name")

    @fleetspace_account_name.setter
    def fleetspace_account_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "fleetspace_account_name", value)


@pulumi.type_token("azure-native:cosmosdb:FleetspaceAccount")
class FleetspaceAccount(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_location: Optional[pulumi.Input[builtins.str]] = None,
                 account_resource_identifier: Optional[pulumi.Input[builtins.str]] = None,
                 fleet_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleetspace_account_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleetspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        An Azure Cosmos DB Fleetspace Account

        Uses Azure REST API version 2025-05-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] account_location: The location of  global database account in the Fleetspace Account.
        :param pulumi.Input[builtins.str] account_resource_identifier: The resource identifier of global database account in the Fleetspace Account.
        :param pulumi.Input[builtins.str] fleet_name: Cosmos DB fleet name. Needs to be unique under a subscription.
        :param pulumi.Input[builtins.str] fleetspace_account_name: Cosmos DB fleetspace account name.
        :param pulumi.Input[builtins.str] fleetspace_name: Cosmos DB fleetspace name. Needs to be unique under a fleet.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FleetspaceAccountArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        An Azure Cosmos DB Fleetspace Account

        Uses Azure REST API version 2025-05-01-preview.

        :param str resource_name: The name of the resource.
        :param FleetspaceAccountArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FleetspaceAccountArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_location: Optional[pulumi.Input[builtins.str]] = None,
                 account_resource_identifier: Optional[pulumi.Input[builtins.str]] = None,
                 fleet_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleetspace_account_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleetspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FleetspaceAccountArgs.__new__(FleetspaceAccountArgs)

            __props__.__dict__["account_location"] = account_location
            __props__.__dict__["account_resource_identifier"] = account_resource_identifier
            if fleet_name is None and not opts.urn:
                raise TypeError("Missing required property 'fleet_name'")
            __props__.__dict__["fleet_name"] = fleet_name
            __props__.__dict__["fleetspace_account_name"] = fleetspace_account_name
            if fleetspace_name is None and not opts.urn:
                raise TypeError("Missing required property 'fleetspace_name'")
            __props__.__dict__["fleetspace_name"] = fleetspace_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:cosmosdb/v20250501preview:FleetspaceAccount")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(FleetspaceAccount, __self__).__init__(
            'azure-native:cosmosdb:FleetspaceAccount',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'FleetspaceAccount':
        """
        Get an existing FleetspaceAccount resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = FleetspaceAccountArgs.__new__(FleetspaceAccountArgs)

        __props__.__dict__["account_location"] = None
        __props__.__dict__["account_resource_identifier"] = None
        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return FleetspaceAccount(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountLocation")
    def account_location(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The location of  global database account in the Fleetspace Account.
        """
        return pulumi.get(self, "account_location")

    @property
    @pulumi.getter(name="accountResourceIdentifier")
    def account_resource_identifier(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The resource identifier of global database account in the Fleetspace Account.
        """
        return pulumi.get(self, "account_resource_identifier")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        A provisioning state of the Fleetspace Account.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

