# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetFleetAnalyticResult',
    'AwaitableGetFleetAnalyticResult',
    'get_fleet_analytic',
    'get_fleet_analytic_output',
]

@pulumi.output_type
class GetFleetAnalyticResult:
    """
    An Azure Cosmos DB FleetAnalytics.
    """
    def __init__(__self__, azure_api_version=None, id=None, name=None, provisioning_state=None, storage_location_type=None, storage_location_uri=None, system_data=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if storage_location_type and not isinstance(storage_location_type, str):
            raise TypeError("Expected argument 'storage_location_type' to be a str")
        pulumi.set(__self__, "storage_location_type", storage_location_type)
        if storage_location_uri and not isinstance(storage_location_uri, str):
            raise TypeError("Expected argument 'storage_location_uri' to be a str")
        pulumi.set(__self__, "storage_location_uri", storage_location_uri)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        A provisioning state of the FleetAnalytics.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="storageLocationType")
    def storage_location_type(self) -> Optional[builtins.str]:
        """
        The type of the fleet analytics resource.
        """
        return pulumi.get(self, "storage_location_type")

    @property
    @pulumi.getter(name="storageLocationUri")
    def storage_location_uri(self) -> Optional[builtins.str]:
        """
        The unique identifier of the fleet analytics resource.
        """
        return pulumi.get(self, "storage_location_uri")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetFleetAnalyticResult(GetFleetAnalyticResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFleetAnalyticResult(
            azure_api_version=self.azure_api_version,
            id=self.id,
            name=self.name,
            provisioning_state=self.provisioning_state,
            storage_location_type=self.storage_location_type,
            storage_location_uri=self.storage_location_uri,
            system_data=self.system_data,
            type=self.type)


def get_fleet_analytic(fleet_analytics_name: Optional[builtins.str] = None,
                       fleet_name: Optional[builtins.str] = None,
                       resource_group_name: Optional[builtins.str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFleetAnalyticResult:
    """
    Retrieves the properties of an existing Azure Cosmos DB FleetAnalytics under a fleet

    Uses Azure REST API version 2025-05-01-preview.


    :param builtins.str fleet_analytics_name: Cosmos DB fleetAnalytics name.
    :param builtins.str fleet_name: Cosmos DB fleet name. Needs to be unique under a subscription.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['fleetAnalyticsName'] = fleet_analytics_name
    __args__['fleetName'] = fleet_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:cosmosdb:getFleetAnalytic', __args__, opts=opts, typ=GetFleetAnalyticResult).value

    return AwaitableGetFleetAnalyticResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        storage_location_type=pulumi.get(__ret__, 'storage_location_type'),
        storage_location_uri=pulumi.get(__ret__, 'storage_location_uri'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_fleet_analytic_output(fleet_analytics_name: Optional[pulumi.Input[builtins.str]] = None,
                              fleet_name: Optional[pulumi.Input[builtins.str]] = None,
                              resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetFleetAnalyticResult]:
    """
    Retrieves the properties of an existing Azure Cosmos DB FleetAnalytics under a fleet

    Uses Azure REST API version 2025-05-01-preview.


    :param builtins.str fleet_analytics_name: Cosmos DB fleetAnalytics name.
    :param builtins.str fleet_name: Cosmos DB fleet name. Needs to be unique under a subscription.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['fleetAnalyticsName'] = fleet_analytics_name
    __args__['fleetName'] = fleet_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:cosmosdb:getFleetAnalytic', __args__, opts=opts, typ=GetFleetAnalyticResult)
    return __ret__.apply(lambda __response__: GetFleetAnalyticResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        storage_location_type=pulumi.get(__response__, 'storage_location_type'),
        storage_location_uri=pulumi.get(__response__, 'storage_location_uri'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
