# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['FleetDatabaseArgs', 'FleetDatabase']

@pulumi.input_type
class FleetDatabaseArgs:
    def __init__(__self__, *,
                 fleet_name: pulumi.Input[builtins.str],
                 fleetspace_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 database_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input['FleetDatabasePropertiesArgs']] = None):
        """
        The set of arguments for constructing a FleetDatabase resource.
        :param pulumi.Input[builtins.str] fleet_name: Name of the database fleet.
        :param pulumi.Input[builtins.str] fleetspace_name: Name of the fleetspace.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] database_name: Name of the database.
        :param pulumi.Input['FleetDatabasePropertiesArgs'] properties: Fleet database properties.
        """
        pulumi.set(__self__, "fleet_name", fleet_name)
        pulumi.set(__self__, "fleetspace_name", fleetspace_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if database_name is not None:
            pulumi.set(__self__, "database_name", database_name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter(name="fleetName")
    def fleet_name(self) -> pulumi.Input[builtins.str]:
        """
        Name of the database fleet.
        """
        return pulumi.get(self, "fleet_name")

    @fleet_name.setter
    def fleet_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "fleet_name", value)

    @property
    @pulumi.getter(name="fleetspaceName")
    def fleetspace_name(self) -> pulumi.Input[builtins.str]:
        """
        Name of the fleetspace.
        """
        return pulumi.get(self, "fleetspace_name")

    @fleetspace_name.setter
    def fleetspace_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "fleetspace_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="databaseName")
    def database_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Name of the database.
        """
        return pulumi.get(self, "database_name")

    @database_name.setter
    def database_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "database_name", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input['FleetDatabasePropertiesArgs']]:
        """
        Fleet database properties.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input['FleetDatabasePropertiesArgs']]):
        pulumi.set(self, "properties", value)


@pulumi.type_token("azure-native:databasefleetmanager:FleetDatabase")
class FleetDatabase(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleet_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleetspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['FleetDatabasePropertiesArgs', 'FleetDatabasePropertiesArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        A fleet database.

        Uses Azure REST API version 2025-02-01-preview. In version 2.x of the Azure Native provider, it used API version 2025-02-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] database_name: Name of the database.
        :param pulumi.Input[builtins.str] fleet_name: Name of the database fleet.
        :param pulumi.Input[builtins.str] fleetspace_name: Name of the fleetspace.
        :param pulumi.Input[Union['FleetDatabasePropertiesArgs', 'FleetDatabasePropertiesArgsDict']] properties: Fleet database properties.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FleetDatabaseArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        A fleet database.

        Uses Azure REST API version 2025-02-01-preview. In version 2.x of the Azure Native provider, it used API version 2025-02-01-preview.

        :param str resource_name: The name of the resource.
        :param FleetDatabaseArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FleetDatabaseArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleet_name: Optional[pulumi.Input[builtins.str]] = None,
                 fleetspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['FleetDatabasePropertiesArgs', 'FleetDatabasePropertiesArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FleetDatabaseArgs.__new__(FleetDatabaseArgs)

            __props__.__dict__["database_name"] = database_name
            if fleet_name is None and not opts.urn:
                raise TypeError("Missing required property 'fleet_name'")
            __props__.__dict__["fleet_name"] = fleet_name
            if fleetspace_name is None and not opts.urn:
                raise TypeError("Missing required property 'fleetspace_name'")
            __props__.__dict__["fleetspace_name"] = fleetspace_name
            __props__.__dict__["properties"] = properties
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:databasefleetmanager/v20250201preview:FleetDatabase")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(FleetDatabase, __self__).__init__(
            'azure-native:databasefleetmanager:FleetDatabase',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'FleetDatabase':
        """
        Get an existing FleetDatabase resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = FleetDatabaseArgs.__new__(FleetDatabaseArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return FleetDatabase(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.FleetDatabasePropertiesResponse']:
        """
        Fleet database properties.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

