# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetTargetResult',
    'AwaitableGetTargetResult',
    'get_target',
    'get_target_output',
]

@pulumi.output_type
class GetTargetResult:
    """
    Concrete proxy resource types can be created by aliasing this type using a specific property type.
    """
    def __init__(__self__, azure_api_version=None, connection_server_name=None, id=None, name=None, provisioning_state=None, system_data=None, target_authentication_type=None, target_type=None, target_vault=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if connection_server_name and not isinstance(connection_server_name, str):
            raise TypeError("Expected argument 'connection_server_name' to be a str")
        pulumi.set(__self__, "connection_server_name", connection_server_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if target_authentication_type and not isinstance(target_authentication_type, str):
            raise TypeError("Expected argument 'target_authentication_type' to be a str")
        pulumi.set(__self__, "target_authentication_type", target_authentication_type)
        if target_type and not isinstance(target_type, str):
            raise TypeError("Expected argument 'target_type' to be a str")
        pulumi.set(__self__, "target_type", target_type)
        if target_vault and not isinstance(target_vault, dict):
            raise TypeError("Expected argument 'target_vault' to be a dict")
        pulumi.set(__self__, "target_vault", target_vault)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="connectionServerName")
    def connection_server_name(self) -> builtins.str:
        """
        The FQDN host name of the server to use in the connection string when connecting to a target. For example, for an Azure SQL logical server in the Azure commercial cloud, the value might be 'sql-logical-server-22092780.database.windows.net'; for an Azure SQL managed instance in the Azure commercial cloud, the value might be 'sql-mi-39441134.767d5869f605.database.windows.net'. Port number and instance name must be specified separately.
        """
        return pulumi.get(self, "connection_server_name")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="targetAuthenticationType")
    def target_authentication_type(self) -> builtins.str:
        """
        The type of authentication to use when connecting to a target.
        """
        return pulumi.get(self, "target_authentication_type")

    @property
    @pulumi.getter(name="targetType")
    def target_type(self) -> builtins.str:
        """
        Discriminator property for TargetProperties.
        """
        return pulumi.get(self, "target_type")

    @property
    @pulumi.getter(name="targetVault")
    def target_vault(self) -> Optional['outputs.VaultSecretResponse']:
        """
        To use SQL authentication when connecting to targets, specify the vault where the login name and password secrets are stored.
        """
        return pulumi.get(self, "target_vault")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetTargetResult(GetTargetResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTargetResult(
            azure_api_version=self.azure_api_version,
            connection_server_name=self.connection_server_name,
            id=self.id,
            name=self.name,
            provisioning_state=self.provisioning_state,
            system_data=self.system_data,
            target_authentication_type=self.target_authentication_type,
            target_type=self.target_type,
            target_vault=self.target_vault,
            type=self.type)


def get_target(resource_group_name: Optional[builtins.str] = None,
               target_name: Optional[builtins.str] = None,
               watcher_name: Optional[builtins.str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTargetResult:
    """
    Get a Target

    Uses Azure REST API version 2024-10-01-preview.

    Other available API versions: 2023-09-01-preview, 2024-07-19-preview, 2025-01-02. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native databasewatcher [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str target_name: The target resource name.
    :param builtins.str watcher_name: The database watcher name.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['targetName'] = target_name
    __args__['watcherName'] = watcher_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:databasewatcher:getTarget', __args__, opts=opts, typ=GetTargetResult).value

    return AwaitableGetTargetResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        connection_server_name=pulumi.get(__ret__, 'connection_server_name'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        system_data=pulumi.get(__ret__, 'system_data'),
        target_authentication_type=pulumi.get(__ret__, 'target_authentication_type'),
        target_type=pulumi.get(__ret__, 'target_type'),
        target_vault=pulumi.get(__ret__, 'target_vault'),
        type=pulumi.get(__ret__, 'type'))
def get_target_output(resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                      target_name: Optional[pulumi.Input[builtins.str]] = None,
                      watcher_name: Optional[pulumi.Input[builtins.str]] = None,
                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTargetResult]:
    """
    Get a Target

    Uses Azure REST API version 2024-10-01-preview.

    Other available API versions: 2023-09-01-preview, 2024-07-19-preview, 2025-01-02. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native databasewatcher [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str target_name: The target resource name.
    :param builtins.str watcher_name: The database watcher name.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['targetName'] = target_name
    __args__['watcherName'] = watcher_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:databasewatcher:getTarget', __args__, opts=opts, typ=GetTargetResult)
    return __ret__.apply(lambda __response__: GetTargetResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        connection_server_name=pulumi.get(__response__, 'connection_server_name'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        system_data=pulumi.get(__response__, 'system_data'),
        target_authentication_type=pulumi.get(__response__, 'target_authentication_type'),
        target_type=pulumi.get(__response__, 'target_type'),
        target_vault=pulumi.get(__response__, 'target_vault'),
        type=pulumi.get(__response__, 'type')))
