# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AccountType',
    'AddonType',
    'AzureContainerDataFormat',
    'ClientPermissionType',
    'DataPolicy',
    'DataResidencyType',
    'DayOfWeek',
    'EncryptionAlgorithm',
    'MonitoringStatus',
    'MsiIdentityType',
    'PlatformType',
    'RoleStatus',
    'RoleTypes',
    'SSLStatus',
    'ShareAccessProtocol',
    'ShareAccessType',
    'ShareStatus',
    'ShipmentType',
    'SkuName',
    'SkuTier',
    'StorageAccountStatus',
    'TriggerEventType',
    'UserType',
]


@pulumi.type_token("azure-native:databoxedge:AccountType")
class AccountType(builtins.str, Enum):
    """
    Type of storage accessed on the storage account.
    """
    GENERAL_PURPOSE_STORAGE = "GeneralPurposeStorage"
    BLOB_STORAGE = "BlobStorage"


@pulumi.type_token("azure-native:databoxedge:AddonType")
class AddonType(builtins.str, Enum):
    """
    Addon type.
    """
    IOT_EDGE = "IotEdge"
    ARC_FOR_KUBERNETES = "ArcForKubernetes"


@pulumi.type_token("azure-native:databoxedge:AzureContainerDataFormat")
class AzureContainerDataFormat(builtins.str, Enum):
    """
    Storage format used for the file represented by the share.
    """
    BLOCK_BLOB = "BlockBlob"
    PAGE_BLOB = "PageBlob"
    AZURE_FILE = "AzureFile"


@pulumi.type_token("azure-native:databoxedge:ClientPermissionType")
class ClientPermissionType(builtins.str, Enum):
    """
    Type of access to be allowed for the client.
    """
    NO_ACCESS = "NoAccess"
    READ_ONLY = "ReadOnly"
    READ_WRITE = "ReadWrite"


@pulumi.type_token("azure-native:databoxedge:DataPolicy")
class DataPolicy(builtins.str, Enum):
    """
    Data policy of the storage Account.
    """
    CLOUD = "Cloud"
    LOCAL = "Local"


@pulumi.type_token("azure-native:databoxedge:DataResidencyType")
class DataResidencyType(builtins.str, Enum):
    """
    DataResidencyType enum
    """
    GEO_ZONE_REPLICATION = "GeoZoneReplication"
    ZONE_REPLICATION = "ZoneReplication"


@pulumi.type_token("azure-native:databoxedge:DayOfWeek")
class DayOfWeek(builtins.str, Enum):
    SUNDAY = "Sunday"
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"


@pulumi.type_token("azure-native:databoxedge:EncryptionAlgorithm")
class EncryptionAlgorithm(builtins.str, Enum):
    """
    The algorithm used to encrypt "Value".
    """
    NONE = "None"
    AES256 = "AES256"
    RSAE_S_PKCS1_V_1_5 = "RSAES_PKCS1_v_1_5"


@pulumi.type_token("azure-native:databoxedge:MonitoringStatus")
class MonitoringStatus(builtins.str, Enum):
    """
    Current monitoring status of the share.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:databoxedge:MsiIdentityType")
class MsiIdentityType(builtins.str, Enum):
    """
    Identity type
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"


@pulumi.type_token("azure-native:databoxedge:PlatformType")
class PlatformType(builtins.str, Enum):
    """
    Host OS supported by the Kubernetes role.
    """
    WINDOWS = "Windows"
    LINUX = "Linux"


@pulumi.type_token("azure-native:databoxedge:RoleStatus")
class RoleStatus(builtins.str, Enum):
    """
    Role status.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:databoxedge:RoleTypes")
class RoleTypes(builtins.str, Enum):
    """
    Role type.
    """
    IOT = "IOT"
    ASA = "ASA"
    FUNCTIONS = "Functions"
    COGNITIVE = "Cognitive"
    MEC = "MEC"
    CLOUD_EDGE_MANAGEMENT = "CloudEdgeManagement"
    KUBERNETES = "Kubernetes"


@pulumi.type_token("azure-native:databoxedge:SSLStatus")
class SSLStatus(builtins.str, Enum):
    """
    Signifies whether SSL needs to be enabled or not.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:databoxedge:ShareAccessProtocol")
class ShareAccessProtocol(builtins.str, Enum):
    """
    Access protocol to be used by the share.
    """
    SMB = "SMB"
    NFS = "NFS"


@pulumi.type_token("azure-native:databoxedge:ShareAccessType")
class ShareAccessType(builtins.str, Enum):
    """
    Type of access to be allowed for the user.
    """
    CHANGE = "Change"
    READ = "Read"
    CUSTOM = "Custom"


@pulumi.type_token("azure-native:databoxedge:ShareStatus")
class ShareStatus(builtins.str, Enum):
    """
    Current status of the share.
    """
    OFFLINE = "Offline"
    UNKNOWN = "Unknown"
    OK = "OK"
    UPDATING = "Updating"
    NEEDS_ATTENTION = "NeedsAttention"


@pulumi.type_token("azure-native:databoxedge:ShipmentType")
class ShipmentType(builtins.str, Enum):
    """
    ShipmentType of the order
    """
    NOT_APPLICABLE = "NotApplicable"
    SHIPPED_TO_CUSTOMER = "ShippedToCustomer"
    SELF_PICKUP = "SelfPickup"


@pulumi.type_token("azure-native:databoxedge:SkuName")
class SkuName(builtins.str, Enum):
    """
    SKU name.
    """
    GATEWAY = "Gateway"
    EDGE = "Edge"
    TE_A_1_NODE = "TEA_1Node"
    TE_A_1_NODE_UPS = "TEA_1Node_UPS"
    TE_A_1_NODE_HEATER = "TEA_1Node_Heater"
    TE_A_1_NODE_UP_S_HEATER = "TEA_1Node_UPS_Heater"
    TE_A_4_NODE_HEATER = "TEA_4Node_Heater"
    TE_A_4_NODE_UP_S_HEATER = "TEA_4Node_UPS_Heater"
    TMA = "TMA"
    TDC = "TDC"
    TC_A_SMALL = "TCA_Small"
    GPU = "GPU"
    TC_A_LARGE = "TCA_Large"
    EDGE_P_BASE = "EdgeP_Base"
    EDGE_P_HIGH = "EdgeP_High"
    EDGE_P_R_BASE = "EdgePR_Base"
    EDGE_P_R_BASE_UPS = "EdgePR_Base_UPS"
    EP2_64_1_VP_U_W = "EP2_64_1VPU_W"
    EP2_128_1_T4_MX1_W = "EP2_128_1T4_Mx1_W"
    EP2_256_2_T4_W = "EP2_256_2T4_W"
    EDGE_M_R_MINI = "EdgeMR_Mini"
    RC_A_SMALL = "RCA_Small"
    RC_A_LARGE = "RCA_Large"
    RDC = "RDC"
    MANAGEMENT = "Management"
    EP2_64_MX1_W = "EP2_64_Mx1_W"
    EP2_128_GPU1_MX1_W = "EP2_128_GPU1_Mx1_W"
    EP2_256_GPU2_MX1 = "EP2_256_GPU2_Mx1"
    EDGE_M_R_TCP = "EdgeMR_TCP"


@pulumi.type_token("azure-native:databoxedge:SkuTier")
class SkuTier(builtins.str, Enum):
    """
    The SKU tier. This is based on the SKU name.
    """
    STANDARD = "Standard"


@pulumi.type_token("azure-native:databoxedge:StorageAccountStatus")
class StorageAccountStatus(builtins.str, Enum):
    """
    Current status of the storage account
    """
    OK = "OK"
    OFFLINE = "Offline"
    UNKNOWN = "Unknown"
    UPDATING = "Updating"
    NEEDS_ATTENTION = "NeedsAttention"


@pulumi.type_token("azure-native:databoxedge:TriggerEventType")
class TriggerEventType(builtins.str, Enum):
    """
    Trigger Kind.
    """
    FILE_EVENT = "FileEvent"
    PERIODIC_TIMER_EVENT = "PeriodicTimerEvent"


@pulumi.type_token("azure-native:databoxedge:UserType")
class UserType(builtins.str, Enum):
    """
    Type of the user.
    """
    SHARE = "Share"
    LOCAL_MANAGEMENT = "LocalManagement"
    ARM = "ARM"
