# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AKSVolumeTypes',
    'AbsoluteMarker',
    'AlertsState',
    'CrossRegionRestoreState',
    'CrossSubscriptionRestoreState',
    'DataStoreTypes',
    'DayOfWeek',
    'EncryptionState',
    'IdentityType',
    'ImmutabilityState',
    'InfrastructureEncryptionState',
    'Month',
    'ResourcePropertiesObjectType',
    'SecretStoreType',
    'SoftDeleteState',
    'StorageSettingStoreTypes',
    'StorageSettingTypes',
    'ValidationType',
    'WeekNumber',
]


@pulumi.type_token("azure-native:dataprotection:AKSVolumeTypes")
class AKSVolumeTypes(builtins.str, Enum):
    AZURE_DISK = "AzureDisk"
    AZURE_FILE_SHARE_SMB = "AzureFileShareSMB"


@pulumi.type_token("azure-native:dataprotection:AbsoluteMarker")
class AbsoluteMarker(builtins.str, Enum):
    ALL_BACKUP = "AllBackup"
    FIRST_OF_DAY = "FirstOfDay"
    FIRST_OF_MONTH = "FirstOfMonth"
    FIRST_OF_WEEK = "FirstOfWeek"
    FIRST_OF_YEAR = "FirstOfYear"


@pulumi.type_token("azure-native:dataprotection:AlertsState")
class AlertsState(builtins.str, Enum):
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dataprotection:CrossRegionRestoreState")
class CrossRegionRestoreState(builtins.str, Enum):
    """
    CrossRegionRestore state
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:dataprotection:CrossSubscriptionRestoreState")
class CrossSubscriptionRestoreState(builtins.str, Enum):
    """
    CrossSubscriptionRestore state
    """
    DISABLED = "Disabled"
    PERMANENTLY_DISABLED = "PermanentlyDisabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:dataprotection:DataStoreTypes")
class DataStoreTypes(builtins.str, Enum):
    """
    type of datastore; Operational/Vault/Archive
    """
    OPERATIONAL_STORE = "OperationalStore"
    VAULT_STORE = "VaultStore"
    ARCHIVE_STORE = "ArchiveStore"


@pulumi.type_token("azure-native:dataprotection:DayOfWeek")
class DayOfWeek(builtins.str, Enum):
    FRIDAY = "Friday"
    MONDAY = "Monday"
    SATURDAY = "Saturday"
    SUNDAY = "Sunday"
    THURSDAY = "Thursday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"


@pulumi.type_token("azure-native:dataprotection:EncryptionState")
class EncryptionState(builtins.str, Enum):
    """
    Encryption state of the Backup Vault.
    """
    ENABLED = "Enabled"
    """
    CMK encryption is enabled on the Backup Vault
    """
    DISABLED = "Disabled"
    """
    CMK encryption is disabled on the Backup Vault. User can not set this state once Encryption State is 'Enabled'.
    """
    INCONSISTENT = "Inconsistent"
    """
    CMK encryption is in inconsistent state on the Backup Vault. This state indicates that user needs to retry the encryption settings operation immediately to correct the state.
    """


@pulumi.type_token("azure-native:dataprotection:IdentityType")
class IdentityType(builtins.str, Enum):
    """
    The identity type. 'SystemAssigned' and 'UserAssigned' are mutually exclusive. 'SystemAssigned' will use implicitly created managed identity.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"


@pulumi.type_token("azure-native:dataprotection:ImmutabilityState")
class ImmutabilityState(builtins.str, Enum):
    """
    Immutability state
    """
    DISABLED = "Disabled"
    UNLOCKED = "Unlocked"
    LOCKED = "Locked"


@pulumi.type_token("azure-native:dataprotection:InfrastructureEncryptionState")
class InfrastructureEncryptionState(builtins.str, Enum):
    """
    Enabling/Disabling the Double Encryption state
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dataprotection:Month")
class Month(builtins.str, Enum):
    APRIL = "April"
    AUGUST = "August"
    DECEMBER = "December"
    FEBRUARY = "February"
    JANUARY = "January"
    JULY = "July"
    JUNE = "June"
    MARCH = "March"
    MAY = "May"
    NOVEMBER = "November"
    OCTOBER = "October"
    SEPTEMBER = "September"


@pulumi.type_token("azure-native:dataprotection:ResourcePropertiesObjectType")
class ResourcePropertiesObjectType(builtins.str, Enum):
    """
    Type of the specific object - used for deserializing
    """
    DEFAULT_RESOURCE_PROPERTIES = "DefaultResourceProperties"


@pulumi.type_token("azure-native:dataprotection:SecretStoreType")
class SecretStoreType(builtins.str, Enum):
    """
    Gets or sets the type of secret store
    """
    INVALID = "Invalid"
    AZURE_KEY_VAULT = "AzureKeyVault"


@pulumi.type_token("azure-native:dataprotection:SoftDeleteState")
class SoftDeleteState(builtins.str, Enum):
    """
    State of soft delete
    """
    OFF = "Off"
    """
    Soft Delete is turned off for the BackupVault
    """
    ON = "On"
    """
    Soft Delete is enabled for the BackupVault but can be turned off
    """
    ALWAYS_ON = "AlwaysOn"
    """
    Soft Delete is permanently enabled for the BackupVault and the setting cannot be changed
    """


@pulumi.type_token("azure-native:dataprotection:StorageSettingStoreTypes")
class StorageSettingStoreTypes(builtins.str, Enum):
    """
    Gets or sets the type of the datastore.
    """
    ARCHIVE_STORE = "ArchiveStore"
    OPERATIONAL_STORE = "OperationalStore"
    VAULT_STORE = "VaultStore"


@pulumi.type_token("azure-native:dataprotection:StorageSettingTypes")
class StorageSettingTypes(builtins.str, Enum):
    """
    Gets or sets the type.
    """
    GEO_REDUNDANT = "GeoRedundant"
    LOCALLY_REDUNDANT = "LocallyRedundant"
    ZONE_REDUNDANT = "ZoneRedundant"


@pulumi.type_token("azure-native:dataprotection:ValidationType")
class ValidationType(builtins.str, Enum):
    """
    Specifies the type of validation. In case of DeepValidation, all validations from /validateForBackup API will run again.
    """
    SHALLOW_VALIDATION = "ShallowValidation"
    DEEP_VALIDATION = "DeepValidation"


@pulumi.type_token("azure-native:dataprotection:WeekNumber")
class WeekNumber(builtins.str, Enum):
    FIRST = "First"
    FOURTH = "Fourth"
    LAST = "Last"
    SECOND = "Second"
    THIRD = "Third"
