# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AdministratorType',
    'ConfigurationSource',
    'CreateMode',
    'DataEncryptionType',
    'EnableStatusEnum',
    'GeoRedundantBackup',
    'HighAvailabilityMode',
    'IdentityType',
    'ImportSourceStorageType',
    'InfrastructureEncryption',
    'ManagedServiceIdentityType',
    'MinimalTlsVersionEnum',
    'PrivateEndpointServiceConnectionStatus',
    'PublicNetworkAccessEnum',
    'ReplicationRole',
    'ServerSkuTier',
    'ServerVersion',
    'SingleServerSkuTier',
    'SingleServerVersion',
    'SslEnforcementEnum',
    'StorageAutogrow',
    'StorageRedundancyEnum',
]


@pulumi.type_token("azure-native:dbformysql:AdministratorType")
class AdministratorType(builtins.str, Enum):
    """
    The type of administrator.
    """
    ACTIVE_DIRECTORY = "ActiveDirectory"


@pulumi.type_token("azure-native:dbformysql:ConfigurationSource")
class ConfigurationSource(builtins.str, Enum):
    """
    Source of the configuration.
    """
    SYSTEM_DEFAULT = "system-default"
    USER_OVERRIDE = "user-override"


@pulumi.type_token("azure-native:dbformysql:CreateMode")
class CreateMode(builtins.str, Enum):
    """
    The mode to create a new server.
    """
    DEFAULT = "Default"
    POINT_IN_TIME_RESTORE = "PointInTimeRestore"
    GEO_RESTORE = "GeoRestore"
    REPLICA = "Replica"


@pulumi.type_token("azure-native:dbformysql:DataEncryptionType")
class DataEncryptionType(builtins.str, Enum):
    """
    The key type, AzureKeyVault for enable cmk, SystemManaged for disable cmk.
    """
    AZURE_KEY_VAULT = "AzureKeyVault"
    SYSTEM_MANAGED = "SystemManaged"


@pulumi.type_token("azure-native:dbformysql:EnableStatusEnum")
class EnableStatusEnum(builtins.str, Enum):
    """
    Enable Log On Disk or not.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbformysql:GeoRedundantBackup")
class GeoRedundantBackup(builtins.str, Enum):
    """
    Enable Geo-redundant or not for server backup.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbformysql:HighAvailabilityMode")
class HighAvailabilityMode(builtins.str, Enum):
    """
    High availability mode for a server.
    """
    DISABLED = "Disabled"
    ZONE_REDUNDANT = "ZoneRedundant"
    SAME_ZONE = "SameZone"


@pulumi.type_token("azure-native:dbformysql:IdentityType")
class IdentityType(builtins.str, Enum):
    """
    The identity type. Set this to 'SystemAssigned' in order to automatically create and assign an Azure Active Directory principal for the resource.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"


@pulumi.type_token("azure-native:dbformysql:ImportSourceStorageType")
class ImportSourceStorageType(builtins.str, Enum):
    """
    Storage type of import source.
    """
    AZURE_BLOB = "AzureBlob"


@pulumi.type_token("azure-native:dbformysql:InfrastructureEncryption")
class InfrastructureEncryption(builtins.str, Enum):
    """
    Status showing whether the server enabled infrastructure encryption.
    """
    ENABLED = "Enabled"
    """
    Default value for single layer of encryption for data at rest.
    """
    DISABLED = "Disabled"
    """
    Additional (2nd) layer of encryption for data at rest
    """


@pulumi.type_token("azure-native:dbformysql:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity.
    """
    USER_ASSIGNED = "UserAssigned"


@pulumi.type_token("azure-native:dbformysql:MinimalTlsVersionEnum")
class MinimalTlsVersionEnum(builtins.str, Enum):
    """
    Enforce a minimal Tls version for the server.
    """
    TLS1_0 = "TLS1_0"
    TLS1_1 = "TLS1_1"
    TLS1_2 = "TLS1_2"
    TLS_ENFORCEMENT_DISABLED = "TLSEnforcementDisabled"


@pulumi.type_token("azure-native:dbformysql:PrivateEndpointServiceConnectionStatus")
class PrivateEndpointServiceConnectionStatus(builtins.str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"


@pulumi.type_token("azure-native:dbformysql:PublicNetworkAccessEnum")
class PublicNetworkAccessEnum(builtins.str, Enum):
    """
    Whether or not public network access is allowed for this server. Value is optional but if passed in, must be 'Enabled' or 'Disabled'
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbformysql:ReplicationRole")
class ReplicationRole(builtins.str, Enum):
    """
    The replication role.
    """
    NONE = "None"
    SOURCE = "Source"
    REPLICA = "Replica"


@pulumi.type_token("azure-native:dbformysql:ServerSkuTier")
class ServerSkuTier(builtins.str, Enum):
    """
    The tier of the particular SKU, e.g. GeneralPurpose.
    """
    BURSTABLE = "Burstable"
    GENERAL_PURPOSE = "GeneralPurpose"
    MEMORY_OPTIMIZED = "MemoryOptimized"


@pulumi.type_token("azure-native:dbformysql:ServerVersion")
class ServerVersion(builtins.str, Enum):
    """
    Server version.
    """
    SERVER_VERSION_5_7 = "5.7"
    SERVER_VERSION_8_0_21 = "8.0.21"


@pulumi.type_token("azure-native:dbformysql:SingleServerSkuTier")
class SingleServerSkuTier(builtins.str, Enum):
    """
    The tier of the particular SKU, e.g. Basic.
    """
    BASIC = "Basic"
    GENERAL_PURPOSE = "GeneralPurpose"
    MEMORY_OPTIMIZED = "MemoryOptimized"


@pulumi.type_token("azure-native:dbformysql:SingleServerVersion")
class SingleServerVersion(builtins.str, Enum):
    """
    Server version.
    """
    SINGLE_SERVER_VERSION_5_6 = "5.6"
    SINGLE_SERVER_VERSION_5_7 = "5.7"
    SINGLE_SERVER_VERSION_8_0 = "8.0"


@pulumi.type_token("azure-native:dbformysql:SslEnforcementEnum")
class SslEnforcementEnum(builtins.str, Enum):
    """
    Enable ssl enforcement or not when connect to server.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbformysql:StorageAutogrow")
class StorageAutogrow(builtins.str, Enum):
    """
    Enable Storage Auto Grow.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbformysql:StorageRedundancyEnum")
class StorageRedundancyEnum(builtins.str, Enum):
    """
    The redundant type of the server storage. The parameter is used for server creation.
    """
    LOCAL_REDUNDANCY = "LocalRedundancy"
    ZONE_REDUNDANCY = "ZoneRedundancy"
