# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ActiveDirectoryAuth',
    'ActiveDirectoryAuthEnum',
    'AdministratorType',
    'ArmServerKeyType',
    'AzureManagedDiskPerformanceTiers',
    'CancelEnum',
    'CreateMode',
    'DataEncryptionType',
    'GeoRedundantBackup',
    'GeoRedundantBackupEnum',
    'HighAvailabilityMode',
    'IdentityType',
    'InfrastructureEncryption',
    'KeyStatusEnum',
    'LogicalReplicationOnSourceDbEnum',
    'MigrateRolesEnum',
    'MigrationMode',
    'MigrationOption',
    'MinimalTlsVersionEnum',
    'OverwriteDbsInTargetEnum',
    'PasswordAuth',
    'PasswordAuthEnum',
    'PrincipalType',
    'PrivateEndpointServiceConnectionStatus',
    'PublicNetworkAccessEnum',
    'ReadReplicaPromoteMode',
    'ReplicationPromoteOption',
    'ReplicationRole',
    'RoleType',
    'ServerPublicNetworkAccessState',
    'ServerSecurityAlertPolicyState',
    'ServerVersion',
    'SingleServerCreateMode',
    'SingleServerIdentityProperties',
    'SingleServerSkuTier',
    'SingleServerVersion',
    'SkuTier',
    'SourceType',
    'SslEnforcementEnum',
    'SslMode',
    'StartDataMigrationEnum',
    'StorageAutoGrow',
    'StorageAutogrow',
    'StorageType',
    'TriggerCutoverEnum',
    'VirtualEndpointType',
]


@pulumi.type_token("azure-native:dbforpostgresql:ActiveDirectoryAuth")
class ActiveDirectoryAuth(builtins.str, Enum):
    ENABLED = "enabled"
    DISABLED = "disabled"


@pulumi.type_token("azure-native:dbforpostgresql:ActiveDirectoryAuthEnum")
class ActiveDirectoryAuthEnum(builtins.str, Enum):
    """
    If Enabled, Azure Active Directory authentication is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:AdministratorType")
class AdministratorType(builtins.str, Enum):
    """
    The type of administrator.
    """
    ACTIVE_DIRECTORY = "ActiveDirectory"


@pulumi.type_token("azure-native:dbforpostgresql:ArmServerKeyType")
class ArmServerKeyType(builtins.str, Enum):
    """
    Data encryption type to depict if it is System Managed vs Azure Key vault.
    """
    SYSTEM_MANAGED = "SystemManaged"
    AZURE_KEY_VAULT = "AzureKeyVault"


@pulumi.type_token("azure-native:dbforpostgresql:AzureManagedDiskPerformanceTiers")
class AzureManagedDiskPerformanceTiers(builtins.str, Enum):
    """
    Name of storage tier for IOPS.
    """
    P1 = "P1"
    P2 = "P2"
    P3 = "P3"
    P4 = "P4"
    P6 = "P6"
    P10 = "P10"
    P15 = "P15"
    P20 = "P20"
    P30 = "P30"
    P40 = "P40"
    P50 = "P50"
    P60 = "P60"
    P70 = "P70"
    P80 = "P80"


@pulumi.type_token("azure-native:dbforpostgresql:CancelEnum")
class CancelEnum(builtins.str, Enum):
    """
    To trigger cancel for entire migration we need to send this flag as True
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:dbforpostgresql:CreateMode")
class CreateMode(builtins.str, Enum):
    """
    The mode to create a new PostgreSQL server.
    """
    DEFAULT = "Default"
    CREATE = "Create"
    UPDATE = "Update"
    POINT_IN_TIME_RESTORE = "PointInTimeRestore"
    GEO_RESTORE = "GeoRestore"
    REPLICA = "Replica"
    REVIVE_DROPPED = "ReviveDropped"


@pulumi.type_token("azure-native:dbforpostgresql:DataEncryptionType")
class DataEncryptionType(builtins.str, Enum):
    AZURE_KEY_VAULT = "AzureKeyVault"
    SYSTEM_ASSIGNED = "SystemAssigned"


@pulumi.type_token("azure-native:dbforpostgresql:GeoRedundantBackup")
class GeoRedundantBackup(builtins.str, Enum):
    """
    Enable Geo-redundant or not for server backup.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:GeoRedundantBackupEnum")
class GeoRedundantBackupEnum(builtins.str, Enum):
    """
    A value indicating whether Geo-Redundant backup is enabled on the server.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:HighAvailabilityMode")
class HighAvailabilityMode(builtins.str, Enum):
    """
    The HA mode for the server.
    """
    DISABLED = "Disabled"
    ZONE_REDUNDANT = "ZoneRedundant"
    SAME_ZONE = "SameZone"


@pulumi.type_token("azure-native:dbforpostgresql:IdentityType")
class IdentityType(builtins.str, Enum):
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED = "SystemAssigned"


@pulumi.type_token("azure-native:dbforpostgresql:InfrastructureEncryption")
class InfrastructureEncryption(builtins.str, Enum):
    """
    Status showing whether the server enabled infrastructure encryption.
    """
    ENABLED = "Enabled"
    """
    Default value for single layer of encryption for data at rest.
    """
    DISABLED = "Disabled"
    """
    Additional (2nd) layer of encryption for data at rest
    """


@pulumi.type_token("azure-native:dbforpostgresql:KeyStatusEnum")
class KeyStatusEnum(builtins.str, Enum):
    """
    Primary encryption key status for Data encryption enabled server.
    """
    VALID = "Valid"
    INVALID = "Invalid"


@pulumi.type_token("azure-native:dbforpostgresql:LogicalReplicationOnSourceDbEnum")
class LogicalReplicationOnSourceDbEnum(builtins.str, Enum):
    """
    Indicates whether to setup LogicalReplicationOnSourceDb, if needed
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:dbforpostgresql:MigrateRolesEnum")
class MigrateRolesEnum(builtins.str, Enum):
    """
    To migrate roles and permissions we need to send this flag as True
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:dbforpostgresql:MigrationMode")
class MigrationMode(builtins.str, Enum):
    """
    There are two types of migration modes Online and Offline
    """
    OFFLINE = "Offline"
    ONLINE = "Online"


@pulumi.type_token("azure-native:dbforpostgresql:MigrationOption")
class MigrationOption(builtins.str, Enum):
    """
    This indicates the supported Migration option for the migration
    """
    VALIDATE = "Validate"
    MIGRATE = "Migrate"
    VALIDATE_AND_MIGRATE = "ValidateAndMigrate"


@pulumi.type_token("azure-native:dbforpostgresql:MinimalTlsVersionEnum")
class MinimalTlsVersionEnum(builtins.str, Enum):
    """
    Enforce a minimal Tls version for the server.
    """
    TLS1_0 = "TLS1_0"
    TLS1_1 = "TLS1_1"
    TLS1_2 = "TLS1_2"
    TLS_ENFORCEMENT_DISABLED = "TLSEnforcementDisabled"


@pulumi.type_token("azure-native:dbforpostgresql:OverwriteDbsInTargetEnum")
class OverwriteDbsInTargetEnum(builtins.str, Enum):
    """
    Indicates whether the databases on the target server can be overwritten, if already present. If set to False, the migration workflow will wait for a confirmation, if it detects that the database already exists.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:dbforpostgresql:PasswordAuth")
class PasswordAuth(builtins.str, Enum):
    ENABLED = "enabled"
    DISABLED = "disabled"


@pulumi.type_token("azure-native:dbforpostgresql:PasswordAuthEnum")
class PasswordAuthEnum(builtins.str, Enum):
    """
    If Enabled, Password authentication is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:PrincipalType")
class PrincipalType(builtins.str, Enum):
    USER = "user"
    SERVICE_PRINCIPAL = "servicePrincipal"
    GROUP = "group"


@pulumi.type_token("azure-native:dbforpostgresql:PrivateEndpointServiceConnectionStatus")
class PrivateEndpointServiceConnectionStatus(builtins.str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"


@pulumi.type_token("azure-native:dbforpostgresql:PublicNetworkAccessEnum")
class PublicNetworkAccessEnum(builtins.str, Enum):
    """
    Whether or not public network access is allowed for this server. Value is optional but if passed in, must be 'Enabled' or 'Disabled'
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:ReadReplicaPromoteMode")
class ReadReplicaPromoteMode(builtins.str, Enum):
    """
    Sets the promote mode for a replica server. This is a write only property.
    """
    STANDALONE = "standalone"
    SWITCHOVER = "switchover"


@pulumi.type_token("azure-native:dbforpostgresql:ReplicationPromoteOption")
class ReplicationPromoteOption(builtins.str, Enum):
    """
    Sets the promote options for a replica server. This is a write only property.
    """
    PLANNED = "planned"
    FORCED = "forced"


@pulumi.type_token("azure-native:dbforpostgresql:ReplicationRole")
class ReplicationRole(builtins.str, Enum):
    """
    Replication role of the server
    """
    NONE = "None"
    PRIMARY = "Primary"
    ASYNC_REPLICA = "AsyncReplica"
    GEO_ASYNC_REPLICA = "GeoAsyncReplica"


@pulumi.type_token("azure-native:dbforpostgresql:RoleType")
class RoleType(builtins.str, Enum):
    USER = "user"
    ADMIN = "admin"


@pulumi.type_token("azure-native:dbforpostgresql:ServerPublicNetworkAccessState")
class ServerPublicNetworkAccessState(builtins.str, Enum):
    """
    public network access is enabled or not
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:ServerSecurityAlertPolicyState")
class ServerSecurityAlertPolicyState(builtins.str, Enum):
    """
    Specifies the state of the policy, whether it is enabled or disabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:ServerVersion")
class ServerVersion(builtins.str, Enum):
    """
    PostgreSQL Server version.
    """
    SERVER_VERSION_16 = "16"
    SERVER_VERSION_15 = "15"
    SERVER_VERSION_14 = "14"
    SERVER_VERSION_13 = "13"
    SERVER_VERSION_12 = "12"
    SERVER_VERSION_11 = "11"


@pulumi.type_token("azure-native:dbforpostgresql:SingleServerCreateMode")
class SingleServerCreateMode(builtins.str, Enum):
    """
    The mode to create a new server.
    """
    DEFAULT = "Default"
    POINT_IN_TIME_RESTORE = "PointInTimeRestore"
    GEO_RESTORE = "GeoRestore"
    REPLICA = "Replica"


@pulumi.type_token("azure-native:dbforpostgresql:SingleServerIdentityProperties")
class SingleServerIdentityProperties(builtins.str, Enum):
    """
    The identity type. Set this to 'SystemAssigned' in order to automatically create and assign an Azure Active Directory principal for the resource.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"


@pulumi.type_token("azure-native:dbforpostgresql:SingleServerSkuTier")
class SingleServerSkuTier(builtins.str, Enum):
    """
    The tier of the particular SKU, e.g. Basic.
    """
    BASIC = "Basic"
    GENERAL_PURPOSE = "GeneralPurpose"
    MEMORY_OPTIMIZED = "MemoryOptimized"


@pulumi.type_token("azure-native:dbforpostgresql:SingleServerVersion")
class SingleServerVersion(builtins.str, Enum):
    """
    Server version.
    """
    SINGLE_SERVER_VERSION_9_5 = "9.5"
    SINGLE_SERVER_VERSION_9_6 = "9.6"
    SINGLE_SERVER_VERSION_10 = "10"
    SINGLE_SERVER_VERSION_10_0 = "10.0"
    SINGLE_SERVER_VERSION_10_2 = "10.2"
    SINGLE_SERVER_VERSION_11 = "11"


@pulumi.type_token("azure-native:dbforpostgresql:SkuTier")
class SkuTier(builtins.str, Enum):
    """
    The tier of the particular SKU, e.g. Burstable.
    """
    BURSTABLE = "Burstable"
    GENERAL_PURPOSE = "GeneralPurpose"
    MEMORY_OPTIMIZED = "MemoryOptimized"


@pulumi.type_token("azure-native:dbforpostgresql:SourceType")
class SourceType(builtins.str, Enum):
    """
    migration source server type : OnPremises, AWS, GCP, AzureVM, PostgreSQLSingleServer, AWS_RDS, AWS_AURORA, AWS_EC2, GCP_CloudSQL, GCP_AlloyDB, GCP_Compute, or EDB
    """
    ON_PREMISES = "OnPremises"
    AWS = "AWS"
    GCP = "GCP"
    AZURE_VM = "AzureVM"
    POSTGRE_SQL_SINGLE_SERVER = "PostgreSQLSingleServer"
    AW_S_RDS = "AWS_RDS"
    AW_S_AURORA = "AWS_AURORA"
    AW_S_EC2 = "AWS_EC2"
    GC_P_CLOUD_SQL = "GCP_CloudSQL"
    GC_P_ALLOY_DB = "GCP_AlloyDB"
    GC_P_COMPUTE = "GCP_Compute"
    EDB = "EDB"


@pulumi.type_token("azure-native:dbforpostgresql:SslEnforcementEnum")
class SslEnforcementEnum(builtins.str, Enum):
    """
    Enable ssl enforcement or not when connect to server.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:SslMode")
class SslMode(builtins.str, Enum):
    """
    SSL modes for migration. Default SSL mode for PostgreSQLSingleServer is VerifyFull and Prefer for other source types
    """
    PREFER = "Prefer"
    REQUIRE = "Require"
    VERIFY_CA = "VerifyCA"
    VERIFY_FULL = "VerifyFull"


@pulumi.type_token("azure-native:dbforpostgresql:StartDataMigrationEnum")
class StartDataMigrationEnum(builtins.str, Enum):
    """
    Indicates whether the data migration should start right away
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:dbforpostgresql:StorageAutoGrow")
class StorageAutoGrow(builtins.str, Enum):
    """
    Flag to enable / disable Storage Auto grow for flexible server.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:StorageAutogrow")
class StorageAutogrow(builtins.str, Enum):
    """
    Enable Storage Auto Grow.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:dbforpostgresql:StorageType")
class StorageType(builtins.str, Enum):
    """
    Storage type for the server. Allowed values are Premium_LRS and PremiumV2_LRS, and default is Premium_LRS if not specified
    """
    PREMIUM_LRS = "Premium_LRS"
    PREMIUM_V2_LRS = "PremiumV2_LRS"


@pulumi.type_token("azure-native:dbforpostgresql:TriggerCutoverEnum")
class TriggerCutoverEnum(builtins.str, Enum):
    """
    To trigger cutover for entire migration we need to send this flag as True
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:dbforpostgresql:VirtualEndpointType")
class VirtualEndpointType(builtins.str, Enum):
    """
    The endpoint type for the virtual endpoint.
    """
    READ_WRITE = "ReadWrite"
