# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'CatalogItemSyncEnableStatus',
    'CatalogItemType',
    'CatalogSyncType',
    'DevboxDisksEncryptionEnableStatus',
    'DomainJoinType',
    'EnvironmentTypeEnableStatus',
    'HibernateSupport',
    'IdentityType',
    'LicenseType',
    'LocalAdminStatus',
    'ManagedServiceIdentityType',
    'PlanMemberType',
    'ScheduleEnableStatus',
    'ScheduledFrequency',
    'ScheduledType',
    'SingleSignOnStatus',
    'SkuTier',
    'StopOnDisconnectEnableStatus',
    'VirtualNetworkType',
]


@pulumi.type_token("azure-native:devcenter:CatalogItemSyncEnableStatus")
class CatalogItemSyncEnableStatus(builtins.str, Enum):
    """
    Whether project catalogs associated with projects in this dev center can be configured to sync catalog items.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:devcenter:CatalogItemType")
class CatalogItemType(builtins.str, Enum):
    """
    Indicates catalog item types.
    """
    ENVIRONMENT_DEFINITION = "EnvironmentDefinition"


@pulumi.type_token("azure-native:devcenter:CatalogSyncType")
class CatalogSyncType(builtins.str, Enum):
    """
    Indicates the type of sync that is configured for the catalog.
    """
    MANUAL = "Manual"
    SCHEDULED = "Scheduled"


@pulumi.type_token("azure-native:devcenter:DevboxDisksEncryptionEnableStatus")
class DevboxDisksEncryptionEnableStatus(builtins.str, Enum):
    """
    Devbox disk encryption enable or disable status. Indicates if Devbox disks encryption using DevCenter CMK is enabled or not.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:devcenter:DomainJoinType")
class DomainJoinType(builtins.str, Enum):
    """
    AAD Join type.
    """
    HYBRID_AZURE_AD_JOIN = "HybridAzureADJoin"
    AZURE_AD_JOIN = "AzureADJoin"


@pulumi.type_token("azure-native:devcenter:EnvironmentTypeEnableStatus")
class EnvironmentTypeEnableStatus(builtins.str, Enum):
    """
    Defines whether this Environment Type can be used in this Project.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:devcenter:HibernateSupport")
class HibernateSupport(builtins.str, Enum):
    """
    Indicates whether Dev Boxes created with this definition are capable of hibernation. Not all images are capable of supporting hibernation. To find out more see https://aka.ms/devbox/hibernate
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:devcenter:IdentityType")
class IdentityType(builtins.str, Enum):
    """
    Values can be systemAssignedIdentity or userAssignedIdentity
    """
    SYSTEM_ASSIGNED_IDENTITY = "systemAssignedIdentity"
    USER_ASSIGNED_IDENTITY = "userAssignedIdentity"
    DELEGATED_RESOURCE_IDENTITY = "delegatedResourceIdentity"


@pulumi.type_token("azure-native:devcenter:LicenseType")
class LicenseType(builtins.str, Enum):
    """
    Specifies the license type indicating the caller has already acquired licenses for the Dev Boxes that will be created.
    """
    WINDOWS_CLIENT = "Windows_Client"


@pulumi.type_token("azure-native:devcenter:LocalAdminStatus")
class LocalAdminStatus(builtins.str, Enum):
    """
    Indicates whether owners of Dev Boxes in this pool are added as local administrators on the Dev Box.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:devcenter:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


@pulumi.type_token("azure-native:devcenter:PlanMemberType")
class PlanMemberType(builtins.str, Enum):
    """
    The type of the member (user, group)
    """
    USER = "User"
    GROUP = "Group"


@pulumi.type_token("azure-native:devcenter:ScheduleEnableStatus")
class ScheduleEnableStatus(builtins.str, Enum):
    """
    Indicates whether or not this scheduled task is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:devcenter:ScheduledFrequency")
class ScheduledFrequency(builtins.str, Enum):
    """
    The frequency of this scheduled task.
    """
    DAILY = "Daily"


@pulumi.type_token("azure-native:devcenter:ScheduledType")
class ScheduledType(builtins.str, Enum):
    """
    Supported type this scheduled task represents.
    """
    STOP_DEV_BOX = "StopDevBox"


@pulumi.type_token("azure-native:devcenter:SingleSignOnStatus")
class SingleSignOnStatus(builtins.str, Enum):
    """
    Indicates whether Dev Boxes in this pool are created with single sign on enabled. The also requires that single sign on be enabled on the tenant.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:devcenter:SkuTier")
class SkuTier(builtins.str, Enum):
    """
    This field is required to be implemented by the Resource Provider if the service has more than one tier, but is not required on a PUT.
    """
    FREE = "Free"
    BASIC = "Basic"
    STANDARD = "Standard"
    PREMIUM = "Premium"


@pulumi.type_token("azure-native:devcenter:StopOnDisconnectEnableStatus")
class StopOnDisconnectEnableStatus(builtins.str, Enum):
    """
    Whether the feature to stop the Dev Box on disconnect once the grace period has lapsed is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:devcenter:VirtualNetworkType")
class VirtualNetworkType(builtins.str, Enum):
    """
    Indicates whether the pool uses a Virtual Network managed by Microsoft or a customer provided network.
    """
    MANAGED = "Managed"
    UNMANAGED = "Unmanaged"
