# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgs',
    'CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgsDict',
    'CustomerManagedKeyEncryptionArgs',
    'CustomerManagedKeyEncryptionArgsDict',
    'DevCenterProjectCatalogSettingsArgs',
    'DevCenterProjectCatalogSettingsArgsDict',
    'EncryptionArgs',
    'EncryptionArgsDict',
    'GitCatalogArgs',
    'GitCatalogArgsDict',
    'ImageReferenceArgs',
    'ImageReferenceArgsDict',
    'ManagedServiceIdentityArgs',
    'ManagedServiceIdentityArgsDict',
    'ProjectCatalogSettingsArgs',
    'ProjectCatalogSettingsArgsDict',
    'ProjectEnvironmentTypeUpdatePropertiesCreatorRoleAssignmentArgs',
    'ProjectEnvironmentTypeUpdatePropertiesCreatorRoleAssignmentArgsDict',
    'ResourcePolicyArgs',
    'ResourcePolicyArgsDict',
    'SkuArgs',
    'SkuArgsDict',
    'StopOnDisconnectConfigurationArgs',
    'StopOnDisconnectConfigurationArgsDict',
    'UserRoleAssignmentArgs',
    'UserRoleAssignmentArgsDict',
]

MYPY = False

if not MYPY:
    class CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgsDict(TypedDict):
        """
        All identity configuration for Customer-managed key settings defining which identity should be used to auth to Key Vault.
        """
        delegated_identity_client_id: NotRequired[pulumi.Input[builtins.str]]
        """
        delegated identity to use for accessing key encryption key Url. Ex: /subscriptions/fa5fc227-a624-475e-b696-cdd604c735bc/resourceGroups/<resource group>/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myId. Mutually exclusive with identityType systemAssignedIdentity and userAssignedIdentity - internal use only.
        """
        identity_type: NotRequired[pulumi.Input[Union[builtins.str, 'IdentityType']]]
        """
        Values can be systemAssignedIdentity or userAssignedIdentity
        """
        user_assigned_identity_resource_id: NotRequired[pulumi.Input[builtins.str]]
        """
        user assigned identity to use for accessing key encryption key Url. Ex: /subscriptions/fa5fc227-a624-475e-b696-cdd604c735bc/resourceGroups/<resource group>/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myId. Mutually exclusive with identityType systemAssignedIdentity and delegatedResourceIdentity.
        """
elif False:
    CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgs:
    def __init__(__self__, *,
                 delegated_identity_client_id: Optional[pulumi.Input[builtins.str]] = None,
                 identity_type: Optional[pulumi.Input[Union[builtins.str, 'IdentityType']]] = None,
                 user_assigned_identity_resource_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        All identity configuration for Customer-managed key settings defining which identity should be used to auth to Key Vault.
        :param pulumi.Input[builtins.str] delegated_identity_client_id: delegated identity to use for accessing key encryption key Url. Ex: /subscriptions/fa5fc227-a624-475e-b696-cdd604c735bc/resourceGroups/<resource group>/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myId. Mutually exclusive with identityType systemAssignedIdentity and userAssignedIdentity - internal use only.
        :param pulumi.Input[Union[builtins.str, 'IdentityType']] identity_type: Values can be systemAssignedIdentity or userAssignedIdentity
        :param pulumi.Input[builtins.str] user_assigned_identity_resource_id: user assigned identity to use for accessing key encryption key Url. Ex: /subscriptions/fa5fc227-a624-475e-b696-cdd604c735bc/resourceGroups/<resource group>/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myId. Mutually exclusive with identityType systemAssignedIdentity and delegatedResourceIdentity.
        """
        if delegated_identity_client_id is not None:
            pulumi.set(__self__, "delegated_identity_client_id", delegated_identity_client_id)
        if identity_type is not None:
            pulumi.set(__self__, "identity_type", identity_type)
        if user_assigned_identity_resource_id is not None:
            pulumi.set(__self__, "user_assigned_identity_resource_id", user_assigned_identity_resource_id)

    @property
    @pulumi.getter(name="delegatedIdentityClientId")
    def delegated_identity_client_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        delegated identity to use for accessing key encryption key Url. Ex: /subscriptions/fa5fc227-a624-475e-b696-cdd604c735bc/resourceGroups/<resource group>/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myId. Mutually exclusive with identityType systemAssignedIdentity and userAssignedIdentity - internal use only.
        """
        return pulumi.get(self, "delegated_identity_client_id")

    @delegated_identity_client_id.setter
    def delegated_identity_client_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "delegated_identity_client_id", value)

    @property
    @pulumi.getter(name="identityType")
    def identity_type(self) -> Optional[pulumi.Input[Union[builtins.str, 'IdentityType']]]:
        """
        Values can be systemAssignedIdentity or userAssignedIdentity
        """
        return pulumi.get(self, "identity_type")

    @identity_type.setter
    def identity_type(self, value: Optional[pulumi.Input[Union[builtins.str, 'IdentityType']]]):
        pulumi.set(self, "identity_type", value)

    @property
    @pulumi.getter(name="userAssignedIdentityResourceId")
    def user_assigned_identity_resource_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        user assigned identity to use for accessing key encryption key Url. Ex: /subscriptions/fa5fc227-a624-475e-b696-cdd604c735bc/resourceGroups/<resource group>/providers/Microsoft.ManagedIdentity/userAssignedIdentities/myId. Mutually exclusive with identityType systemAssignedIdentity and delegatedResourceIdentity.
        """
        return pulumi.get(self, "user_assigned_identity_resource_id")

    @user_assigned_identity_resource_id.setter
    def user_assigned_identity_resource_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_assigned_identity_resource_id", value)


if not MYPY:
    class CustomerManagedKeyEncryptionArgsDict(TypedDict):
        """
        All Customer-managed key encryption properties for the resource.
        """
        key_encryption_key_identity: NotRequired[pulumi.Input['CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgsDict']]
        """
        All identity configuration for Customer-managed key settings defining which identity should be used to auth to Key Vault.
        """
        key_encryption_key_url: NotRequired[pulumi.Input[builtins.str]]
        """
        key encryption key Url, versioned or non-versioned. Ex: https://contosovault.vault.azure.net/keys/contosokek/562a4bb76b524a1493a6afe8e536ee78 or https://contosovault.vault.azure.net/keys/contosokek.
        """
elif False:
    CustomerManagedKeyEncryptionArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class CustomerManagedKeyEncryptionArgs:
    def __init__(__self__, *,
                 key_encryption_key_identity: Optional[pulumi.Input['CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgs']] = None,
                 key_encryption_key_url: Optional[pulumi.Input[builtins.str]] = None):
        """
        All Customer-managed key encryption properties for the resource.
        :param pulumi.Input['CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgs'] key_encryption_key_identity: All identity configuration for Customer-managed key settings defining which identity should be used to auth to Key Vault.
        :param pulumi.Input[builtins.str] key_encryption_key_url: key encryption key Url, versioned or non-versioned. Ex: https://contosovault.vault.azure.net/keys/contosokek/562a4bb76b524a1493a6afe8e536ee78 or https://contosovault.vault.azure.net/keys/contosokek.
        """
        if key_encryption_key_identity is not None:
            pulumi.set(__self__, "key_encryption_key_identity", key_encryption_key_identity)
        if key_encryption_key_url is not None:
            pulumi.set(__self__, "key_encryption_key_url", key_encryption_key_url)

    @property
    @pulumi.getter(name="keyEncryptionKeyIdentity")
    def key_encryption_key_identity(self) -> Optional[pulumi.Input['CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgs']]:
        """
        All identity configuration for Customer-managed key settings defining which identity should be used to auth to Key Vault.
        """
        return pulumi.get(self, "key_encryption_key_identity")

    @key_encryption_key_identity.setter
    def key_encryption_key_identity(self, value: Optional[pulumi.Input['CustomerManagedKeyEncryptionKeyEncryptionKeyIdentityArgs']]):
        pulumi.set(self, "key_encryption_key_identity", value)

    @property
    @pulumi.getter(name="keyEncryptionKeyUrl")
    def key_encryption_key_url(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        key encryption key Url, versioned or non-versioned. Ex: https://contosovault.vault.azure.net/keys/contosokek/562a4bb76b524a1493a6afe8e536ee78 or https://contosovault.vault.azure.net/keys/contosokek.
        """
        return pulumi.get(self, "key_encryption_key_url")

    @key_encryption_key_url.setter
    def key_encryption_key_url(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "key_encryption_key_url", value)


if not MYPY:
    class DevCenterProjectCatalogSettingsArgsDict(TypedDict):
        """
        Project catalog settings for project catalogs under a project associated to this dev center.
        """
        catalog_item_sync_enable_status: NotRequired[pulumi.Input[Union[builtins.str, 'CatalogItemSyncEnableStatus']]]
        """
        Whether project catalogs associated with projects in this dev center can be configured to sync catalog items.
        """
elif False:
    DevCenterProjectCatalogSettingsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DevCenterProjectCatalogSettingsArgs:
    def __init__(__self__, *,
                 catalog_item_sync_enable_status: Optional[pulumi.Input[Union[builtins.str, 'CatalogItemSyncEnableStatus']]] = None):
        """
        Project catalog settings for project catalogs under a project associated to this dev center.
        :param pulumi.Input[Union[builtins.str, 'CatalogItemSyncEnableStatus']] catalog_item_sync_enable_status: Whether project catalogs associated with projects in this dev center can be configured to sync catalog items.
        """
        if catalog_item_sync_enable_status is not None:
            pulumi.set(__self__, "catalog_item_sync_enable_status", catalog_item_sync_enable_status)

    @property
    @pulumi.getter(name="catalogItemSyncEnableStatus")
    def catalog_item_sync_enable_status(self) -> Optional[pulumi.Input[Union[builtins.str, 'CatalogItemSyncEnableStatus']]]:
        """
        Whether project catalogs associated with projects in this dev center can be configured to sync catalog items.
        """
        return pulumi.get(self, "catalog_item_sync_enable_status")

    @catalog_item_sync_enable_status.setter
    def catalog_item_sync_enable_status(self, value: Optional[pulumi.Input[Union[builtins.str, 'CatalogItemSyncEnableStatus']]]):
        pulumi.set(self, "catalog_item_sync_enable_status", value)


if not MYPY:
    class EncryptionArgsDict(TypedDict):
        customer_managed_key_encryption: NotRequired[pulumi.Input['CustomerManagedKeyEncryptionArgsDict']]
        """
        All Customer-managed key encryption properties for the resource.
        """
elif False:
    EncryptionArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class EncryptionArgs:
    def __init__(__self__, *,
                 customer_managed_key_encryption: Optional[pulumi.Input['CustomerManagedKeyEncryptionArgs']] = None):
        """
        :param pulumi.Input['CustomerManagedKeyEncryptionArgs'] customer_managed_key_encryption: All Customer-managed key encryption properties for the resource.
        """
        if customer_managed_key_encryption is not None:
            pulumi.set(__self__, "customer_managed_key_encryption", customer_managed_key_encryption)

    @property
    @pulumi.getter(name="customerManagedKeyEncryption")
    def customer_managed_key_encryption(self) -> Optional[pulumi.Input['CustomerManagedKeyEncryptionArgs']]:
        """
        All Customer-managed key encryption properties for the resource.
        """
        return pulumi.get(self, "customer_managed_key_encryption")

    @customer_managed_key_encryption.setter
    def customer_managed_key_encryption(self, value: Optional[pulumi.Input['CustomerManagedKeyEncryptionArgs']]):
        pulumi.set(self, "customer_managed_key_encryption", value)


if not MYPY:
    class GitCatalogArgsDict(TypedDict):
        """
        Properties for a Git repository catalog.
        """
        branch: NotRequired[pulumi.Input[builtins.str]]
        """
        Git branch.
        """
        path: NotRequired[pulumi.Input[builtins.str]]
        """
        The folder where the catalog items can be found inside the repository.
        """
        secret_identifier: NotRequired[pulumi.Input[builtins.str]]
        """
        A reference to the Key Vault secret containing a security token to authenticate to a Git repository.
        """
        uri: NotRequired[pulumi.Input[builtins.str]]
        """
        Git URI.
        """
elif False:
    GitCatalogArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GitCatalogArgs:
    def __init__(__self__, *,
                 branch: Optional[pulumi.Input[builtins.str]] = None,
                 path: Optional[pulumi.Input[builtins.str]] = None,
                 secret_identifier: Optional[pulumi.Input[builtins.str]] = None,
                 uri: Optional[pulumi.Input[builtins.str]] = None):
        """
        Properties for a Git repository catalog.
        :param pulumi.Input[builtins.str] branch: Git branch.
        :param pulumi.Input[builtins.str] path: The folder where the catalog items can be found inside the repository.
        :param pulumi.Input[builtins.str] secret_identifier: A reference to the Key Vault secret containing a security token to authenticate to a Git repository.
        :param pulumi.Input[builtins.str] uri: Git URI.
        """
        if branch is not None:
            pulumi.set(__self__, "branch", branch)
        if path is not None:
            pulumi.set(__self__, "path", path)
        if secret_identifier is not None:
            pulumi.set(__self__, "secret_identifier", secret_identifier)
        if uri is not None:
            pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter
    def branch(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Git branch.
        """
        return pulumi.get(self, "branch")

    @branch.setter
    def branch(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "branch", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The folder where the catalog items can be found inside the repository.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter(name="secretIdentifier")
    def secret_identifier(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A reference to the Key Vault secret containing a security token to authenticate to a Git repository.
        """
        return pulumi.get(self, "secret_identifier")

    @secret_identifier.setter
    def secret_identifier(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "secret_identifier", value)

    @property
    @pulumi.getter
    def uri(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Git URI.
        """
        return pulumi.get(self, "uri")

    @uri.setter
    def uri(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "uri", value)


if not MYPY:
    class ImageReferenceArgsDict(TypedDict):
        """
        Image reference information
        """
        id: NotRequired[pulumi.Input[builtins.str]]
        """
        Image ID, or Image version ID. When Image ID is provided, its latest version will be used.
        """
elif False:
    ImageReferenceArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ImageReferenceArgs:
    def __init__(__self__, *,
                 id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Image reference information
        :param pulumi.Input[builtins.str] id: Image ID, or Image version ID. When Image ID is provided, its latest version will be used.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Image ID, or Image version ID. When Image ID is provided, its latest version will be used.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "id", value)


if not MYPY:
    class ManagedServiceIdentityArgsDict(TypedDict):
        """
        Managed service identity (system assigned and/or user assigned identities)
        """
        type: pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']]
        """
        Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        """
        user_assigned_identities: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        """
        The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
elif False:
    ManagedServiceIdentityArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ManagedServiceIdentityArgs:
    def __init__(__self__, *,
                 type: pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']],
                 user_assigned_identities: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        Managed service identity (system assigned and/or user assigned identities)
        :param pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']] type: Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] user_assigned_identities: The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        pulumi.set(__self__, "type", type)
        if user_assigned_identities is not None:
            pulumi.set(__self__, "user_assigned_identities", user_assigned_identities)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']]:
        """
        Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[Union[builtins.str, 'ManagedServiceIdentityType']]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="userAssignedIdentities")
    def user_assigned_identities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        return pulumi.get(self, "user_assigned_identities")

    @user_assigned_identities.setter
    def user_assigned_identities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "user_assigned_identities", value)


if not MYPY:
    class ProjectCatalogSettingsArgsDict(TypedDict):
        """
        Settings to be used when associating a project with a catalog.
        """
        catalog_item_sync_types: NotRequired[pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'CatalogItemType']]]]]
        """
        Indicates catalog item types that can be synced.
        """
elif False:
    ProjectCatalogSettingsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ProjectCatalogSettingsArgs:
    def __init__(__self__, *,
                 catalog_item_sync_types: Optional[pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'CatalogItemType']]]]] = None):
        """
        Settings to be used when associating a project with a catalog.
        :param pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'CatalogItemType']]]] catalog_item_sync_types: Indicates catalog item types that can be synced.
        """
        if catalog_item_sync_types is not None:
            pulumi.set(__self__, "catalog_item_sync_types", catalog_item_sync_types)

    @property
    @pulumi.getter(name="catalogItemSyncTypes")
    def catalog_item_sync_types(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'CatalogItemType']]]]]:
        """
        Indicates catalog item types that can be synced.
        """
        return pulumi.get(self, "catalog_item_sync_types")

    @catalog_item_sync_types.setter
    def catalog_item_sync_types(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'CatalogItemType']]]]]):
        pulumi.set(self, "catalog_item_sync_types", value)


if not MYPY:
    class ProjectEnvironmentTypeUpdatePropertiesCreatorRoleAssignmentArgsDict(TypedDict):
        """
        The role definition assigned to the environment creator on backing resources.
        """
        roles: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        """
        A map of roles to assign to the environment creator.
        """
elif False:
    ProjectEnvironmentTypeUpdatePropertiesCreatorRoleAssignmentArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ProjectEnvironmentTypeUpdatePropertiesCreatorRoleAssignmentArgs:
    def __init__(__self__, *,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        The role definition assigned to the environment creator on backing resources.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] roles: A map of roles to assign to the environment creator.
        """
        if roles is not None:
            pulumi.set(__self__, "roles", roles)

    @property
    @pulumi.getter
    def roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        A map of roles to assign to the environment creator.
        """
        return pulumi.get(self, "roles")

    @roles.setter
    def roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "roles", value)


if not MYPY:
    class ResourcePolicyArgsDict(TypedDict):
        """
        A resource policy.
        """
        filter: NotRequired[pulumi.Input[builtins.str]]
        """
        Optional. When specified, this expression is used to filter the resources.
        """
        resources: NotRequired[pulumi.Input[builtins.str]]
        """
        Resources that are included and shared as a part of a project policy.
        """
elif False:
    ResourcePolicyArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ResourcePolicyArgs:
    def __init__(__self__, *,
                 filter: Optional[pulumi.Input[builtins.str]] = None,
                 resources: Optional[pulumi.Input[builtins.str]] = None):
        """
        A resource policy.
        :param pulumi.Input[builtins.str] filter: Optional. When specified, this expression is used to filter the resources.
        :param pulumi.Input[builtins.str] resources: Resources that are included and shared as a part of a project policy.
        """
        if filter is not None:
            pulumi.set(__self__, "filter", filter)
        if resources is not None:
            pulumi.set(__self__, "resources", resources)

    @property
    @pulumi.getter
    def filter(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Optional. When specified, this expression is used to filter the resources.
        """
        return pulumi.get(self, "filter")

    @filter.setter
    def filter(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "filter", value)

    @property
    @pulumi.getter
    def resources(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Resources that are included and shared as a part of a project policy.
        """
        return pulumi.get(self, "resources")

    @resources.setter
    def resources(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "resources", value)


if not MYPY:
    class SkuArgsDict(TypedDict):
        """
        The resource model definition representing SKU
        """
        name: pulumi.Input[builtins.str]
        """
        The name of the SKU. E.g. P3. It is typically a letter+number code
        """
        capacity: NotRequired[pulumi.Input[builtins.int]]
        """
        If the SKU supports scale out/in then the capacity integer should be included. If scale out/in is not possible for the resource this may be omitted.
        """
        family: NotRequired[pulumi.Input[builtins.str]]
        """
        If the service has different generations of hardware, for the same SKU, then that can be captured here.
        """
        size: NotRequired[pulumi.Input[builtins.str]]
        """
        The SKU size. When the name field is the combination of tier and some other value, this would be the standalone code. 
        """
        tier: NotRequired[pulumi.Input['SkuTier']]
        """
        This field is required to be implemented by the Resource Provider if the service has more than one tier, but is not required on a PUT.
        """
elif False:
    SkuArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SkuArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[builtins.str],
                 capacity: Optional[pulumi.Input[builtins.int]] = None,
                 family: Optional[pulumi.Input[builtins.str]] = None,
                 size: Optional[pulumi.Input[builtins.str]] = None,
                 tier: Optional[pulumi.Input['SkuTier']] = None):
        """
        The resource model definition representing SKU
        :param pulumi.Input[builtins.str] name: The name of the SKU. E.g. P3. It is typically a letter+number code
        :param pulumi.Input[builtins.int] capacity: If the SKU supports scale out/in then the capacity integer should be included. If scale out/in is not possible for the resource this may be omitted.
        :param pulumi.Input[builtins.str] family: If the service has different generations of hardware, for the same SKU, then that can be captured here.
        :param pulumi.Input[builtins.str] size: The SKU size. When the name field is the combination of tier and some other value, this would be the standalone code. 
        :param pulumi.Input['SkuTier'] tier: This field is required to be implemented by the Resource Provider if the service has more than one tier, but is not required on a PUT.
        """
        pulumi.set(__self__, "name", name)
        if capacity is not None:
            pulumi.set(__self__, "capacity", capacity)
        if family is not None:
            pulumi.set(__self__, "family", family)
        if size is not None:
            pulumi.set(__self__, "size", size)
        if tier is not None:
            pulumi.set(__self__, "tier", tier)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the SKU. E.g. P3. It is typically a letter+number code
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def capacity(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        If the SKU supports scale out/in then the capacity integer should be included. If scale out/in is not possible for the resource this may be omitted.
        """
        return pulumi.get(self, "capacity")

    @capacity.setter
    def capacity(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "capacity", value)

    @property
    @pulumi.getter
    def family(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        If the service has different generations of hardware, for the same SKU, then that can be captured here.
        """
        return pulumi.get(self, "family")

    @family.setter
    def family(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "family", value)

    @property
    @pulumi.getter
    def size(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The SKU size. When the name field is the combination of tier and some other value, this would be the standalone code. 
        """
        return pulumi.get(self, "size")

    @size.setter
    def size(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "size", value)

    @property
    @pulumi.getter
    def tier(self) -> Optional[pulumi.Input['SkuTier']]:
        """
        This field is required to be implemented by the Resource Provider if the service has more than one tier, but is not required on a PUT.
        """
        return pulumi.get(self, "tier")

    @tier.setter
    def tier(self, value: Optional[pulumi.Input['SkuTier']]):
        pulumi.set(self, "tier", value)


if not MYPY:
    class StopOnDisconnectConfigurationArgsDict(TypedDict):
        """
        Stop on disconnect configuration settings for Dev Boxes created in this pool.
        """
        grace_period_minutes: NotRequired[pulumi.Input[builtins.int]]
        """
        The specified time in minutes to wait before stopping a Dev Box once disconnect is detected.
        """
        status: NotRequired[pulumi.Input[Union[builtins.str, 'StopOnDisconnectEnableStatus']]]
        """
        Whether the feature to stop the Dev Box on disconnect once the grace period has lapsed is enabled.
        """
elif False:
    StopOnDisconnectConfigurationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class StopOnDisconnectConfigurationArgs:
    def __init__(__self__, *,
                 grace_period_minutes: Optional[pulumi.Input[builtins.int]] = None,
                 status: Optional[pulumi.Input[Union[builtins.str, 'StopOnDisconnectEnableStatus']]] = None):
        """
        Stop on disconnect configuration settings for Dev Boxes created in this pool.
        :param pulumi.Input[builtins.int] grace_period_minutes: The specified time in minutes to wait before stopping a Dev Box once disconnect is detected.
        :param pulumi.Input[Union[builtins.str, 'StopOnDisconnectEnableStatus']] status: Whether the feature to stop the Dev Box on disconnect once the grace period has lapsed is enabled.
        """
        if grace_period_minutes is not None:
            pulumi.set(__self__, "grace_period_minutes", grace_period_minutes)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="gracePeriodMinutes")
    def grace_period_minutes(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The specified time in minutes to wait before stopping a Dev Box once disconnect is detected.
        """
        return pulumi.get(self, "grace_period_minutes")

    @grace_period_minutes.setter
    def grace_period_minutes(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "grace_period_minutes", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[Union[builtins.str, 'StopOnDisconnectEnableStatus']]]:
        """
        Whether the feature to stop the Dev Box on disconnect once the grace period has lapsed is enabled.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[Union[builtins.str, 'StopOnDisconnectEnableStatus']]]):
        pulumi.set(self, "status", value)


if not MYPY:
    class UserRoleAssignmentArgsDict(TypedDict):
        """
        Mapping of user object ID to role assignments.
        """
        roles: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        """
        A map of roles to assign to the parent user.
        """
elif False:
    UserRoleAssignmentArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class UserRoleAssignmentArgs:
    def __init__(__self__, *,
                 roles: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        Mapping of user object ID to role assignments.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] roles: A map of roles to assign to the parent user.
        """
        if roles is not None:
            pulumi.set(__self__, "roles", roles)

    @property
    @pulumi.getter
    def roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        A map of roles to assign to the parent user.
        """
        return pulumi.get(self, "roles")

    @roles.setter
    def roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "roles", value)


