# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetEnvironmentDefinitionErrorDetailsResult',
    'AwaitableGetEnvironmentDefinitionErrorDetailsResult',
    'get_environment_definition_error_details',
    'get_environment_definition_error_details_output',
]

@pulumi.output_type
class GetEnvironmentDefinitionErrorDetailsResult:
    """
    List of validator error details. Populated when changes are made to the resource or its dependent resources that impact the validity of the Catalog resource.
    """
    def __init__(__self__, errors=None):
        if errors and not isinstance(errors, list):
            raise TypeError("Expected argument 'errors' to be a list")
        pulumi.set(__self__, "errors", errors)

    @property
    @pulumi.getter
    def errors(self) -> Sequence['outputs.CatalogErrorDetailsResponse']:
        """
        Errors associated with resources synchronized from the catalog.
        """
        return pulumi.get(self, "errors")


class AwaitableGetEnvironmentDefinitionErrorDetailsResult(GetEnvironmentDefinitionErrorDetailsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetEnvironmentDefinitionErrorDetailsResult(
            errors=self.errors)


def get_environment_definition_error_details(catalog_name: Optional[builtins.str] = None,
                                             dev_center_name: Optional[builtins.str] = None,
                                             environment_definition_name: Optional[builtins.str] = None,
                                             resource_group_name: Optional[builtins.str] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetEnvironmentDefinitionErrorDetailsResult:
    """
    Gets Environment Definition error details

    Uses Azure REST API version 2024-02-01.

    Other available API versions: 2023-08-01-preview, 2023-10-01-preview, 2024-05-01-preview, 2024-06-01-preview, 2024-07-01-preview, 2024-08-01-preview, 2024-10-01-preview, 2025-02-01, 2025-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native devcenter [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str catalog_name: The name of the Catalog.
    :param builtins.str dev_center_name: The name of the devcenter.
    :param builtins.str environment_definition_name: The name of the Environment Definition.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['catalogName'] = catalog_name
    __args__['devCenterName'] = dev_center_name
    __args__['environmentDefinitionName'] = environment_definition_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:devcenter:getEnvironmentDefinitionErrorDetails', __args__, opts=opts, typ=GetEnvironmentDefinitionErrorDetailsResult).value

    return AwaitableGetEnvironmentDefinitionErrorDetailsResult(
        errors=pulumi.get(__ret__, 'errors'))
def get_environment_definition_error_details_output(catalog_name: Optional[pulumi.Input[builtins.str]] = None,
                                                    dev_center_name: Optional[pulumi.Input[builtins.str]] = None,
                                                    environment_definition_name: Optional[pulumi.Input[builtins.str]] = None,
                                                    resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetEnvironmentDefinitionErrorDetailsResult]:
    """
    Gets Environment Definition error details

    Uses Azure REST API version 2024-02-01.

    Other available API versions: 2023-08-01-preview, 2023-10-01-preview, 2024-05-01-preview, 2024-06-01-preview, 2024-07-01-preview, 2024-08-01-preview, 2024-10-01-preview, 2025-02-01, 2025-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native devcenter [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str catalog_name: The name of the Catalog.
    :param builtins.str dev_center_name: The name of the devcenter.
    :param builtins.str environment_definition_name: The name of the Environment Definition.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['catalogName'] = catalog_name
    __args__['devCenterName'] = dev_center_name
    __args__['environmentDefinitionName'] = environment_definition_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:devcenter:getEnvironmentDefinitionErrorDetails', __args__, opts=opts, typ=GetEnvironmentDefinitionErrorDetailsResult)
    return __ret__.apply(lambda __response__: GetEnvironmentDefinitionErrorDetailsResult(
        errors=pulumi.get(__response__, 'errors')))
