# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ProjectPolicyArgs', 'ProjectPolicy']

@pulumi.input_type
class ProjectPolicyArgs:
    def __init__(__self__, *,
                 dev_center_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 project_policy_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_policies: Optional[pulumi.Input[Sequence[pulumi.Input['ResourcePolicyArgs']]]] = None,
                 scopes: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a ProjectPolicy resource.
        :param pulumi.Input[builtins.str] dev_center_name: The name of the devcenter.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] project_policy_name: The name of the project policy.
        :param pulumi.Input[Sequence[pulumi.Input['ResourcePolicyArgs']]] resource_policies: Resource policies that are a part of this project policy.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] scopes: Resources that have access to the shared resources that are a part of this project policy.
        """
        pulumi.set(__self__, "dev_center_name", dev_center_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if project_policy_name is not None:
            pulumi.set(__self__, "project_policy_name", project_policy_name)
        if resource_policies is not None:
            pulumi.set(__self__, "resource_policies", resource_policies)
        if scopes is not None:
            pulumi.set(__self__, "scopes", scopes)

    @property
    @pulumi.getter(name="devCenterName")
    def dev_center_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the devcenter.
        """
        return pulumi.get(self, "dev_center_name")

    @dev_center_name.setter
    def dev_center_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "dev_center_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="projectPolicyName")
    def project_policy_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the project policy.
        """
        return pulumi.get(self, "project_policy_name")

    @project_policy_name.setter
    def project_policy_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "project_policy_name", value)

    @property
    @pulumi.getter(name="resourcePolicies")
    def resource_policies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ResourcePolicyArgs']]]]:
        """
        Resource policies that are a part of this project policy.
        """
        return pulumi.get(self, "resource_policies")

    @resource_policies.setter
    def resource_policies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ResourcePolicyArgs']]]]):
        pulumi.set(self, "resource_policies", value)

    @property
    @pulumi.getter
    def scopes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        Resources that have access to the shared resources that are a part of this project policy.
        """
        return pulumi.get(self, "scopes")

    @scopes.setter
    def scopes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "scopes", value)


@pulumi.type_token("azure-native:devcenter:ProjectPolicy")
class ProjectPolicy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dev_center_name: Optional[pulumi.Input[builtins.str]] = None,
                 project_policy_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_policies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ResourcePolicyArgs', 'ResourcePolicyArgsDict']]]]] = None,
                 scopes: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        Represents an project policy resource.

        Uses Azure REST API version 2024-10-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-10-01-preview.

        Other available API versions: 2025-02-01, 2025-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native devcenter [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] dev_center_name: The name of the devcenter.
        :param pulumi.Input[builtins.str] project_policy_name: The name of the project policy.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ResourcePolicyArgs', 'ResourcePolicyArgsDict']]]] resource_policies: Resource policies that are a part of this project policy.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] scopes: Resources that have access to the shared resources that are a part of this project policy.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProjectPolicyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Represents an project policy resource.

        Uses Azure REST API version 2024-10-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-10-01-preview.

        Other available API versions: 2025-02-01, 2025-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native devcenter [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param ProjectPolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProjectPolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dev_center_name: Optional[pulumi.Input[builtins.str]] = None,
                 project_policy_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_policies: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ResourcePolicyArgs', 'ResourcePolicyArgsDict']]]]] = None,
                 scopes: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProjectPolicyArgs.__new__(ProjectPolicyArgs)

            if dev_center_name is None and not opts.urn:
                raise TypeError("Missing required property 'dev_center_name'")
            __props__.__dict__["dev_center_name"] = dev_center_name
            __props__.__dict__["project_policy_name"] = project_policy_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["resource_policies"] = resource_policies
            __props__.__dict__["scopes"] = scopes
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:devcenter/v20241001preview:ProjectPolicy"), pulumi.Alias(type_="azure-native:devcenter/v20250201:ProjectPolicy"), pulumi.Alias(type_="azure-native:devcenter/v20250401preview:ProjectPolicy")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(ProjectPolicy, __self__).__init__(
            'azure-native:devcenter:ProjectPolicy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'ProjectPolicy':
        """
        Get an existing ProjectPolicy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ProjectPolicyArgs.__new__(ProjectPolicyArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["resource_policies"] = None
        __props__.__dict__["scopes"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return ProjectPolicy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        The provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="resourcePolicies")
    def resource_policies(self) -> pulumi.Output[Optional[Sequence['outputs.ResourcePolicyResponse']]]:
        """
        Resource policies that are a part of this project policy.
        """
        return pulumi.get(self, "resource_policies")

    @property
    @pulumi.getter
    def scopes(self) -> pulumi.Output[Optional[Sequence[builtins.str]]]:
        """
        Resources that have access to the shared resources that are a part of this project policy.
        """
        return pulumi.get(self, "scopes")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

