# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'ACRArgs',
    'ACRArgsDict',
    'DeploymentPropertiesArgs',
    'DeploymentPropertiesArgsDict',
    'GitHubWorkflowProfileOidcCredentialsArgs',
    'GitHubWorkflowProfileOidcCredentialsArgsDict',
    'GitHubWorkflowProfileArgs',
    'GitHubWorkflowProfileArgsDict',
    'IacTemplateDetailsArgs',
    'IacTemplateDetailsArgsDict',
    'IacTemplatePropertiesArgs',
    'IacTemplatePropertiesArgsDict',
    'StagePropertiesArgs',
    'StagePropertiesArgsDict',
    'WorkflowRunArgs',
    'WorkflowRunArgsDict',
]

MYPY = False

if not MYPY:
    class ACRArgsDict(TypedDict):
        """
        Information on the azure container registry
        """
        acr_registry_name: NotRequired[pulumi.Input[builtins.str]]
        """
        ACR registry
        """
        acr_repository_name: NotRequired[pulumi.Input[builtins.str]]
        """
        ACR repository
        """
        acr_resource_group: NotRequired[pulumi.Input[builtins.str]]
        """
        ACR resource group
        """
        acr_subscription_id: NotRequired[pulumi.Input[builtins.str]]
        """
        ACR subscription id
        """
elif False:
    ACRArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ACRArgs:
    def __init__(__self__, *,
                 acr_registry_name: Optional[pulumi.Input[builtins.str]] = None,
                 acr_repository_name: Optional[pulumi.Input[builtins.str]] = None,
                 acr_resource_group: Optional[pulumi.Input[builtins.str]] = None,
                 acr_subscription_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Information on the azure container registry
        :param pulumi.Input[builtins.str] acr_registry_name: ACR registry
        :param pulumi.Input[builtins.str] acr_repository_name: ACR repository
        :param pulumi.Input[builtins.str] acr_resource_group: ACR resource group
        :param pulumi.Input[builtins.str] acr_subscription_id: ACR subscription id
        """
        if acr_registry_name is not None:
            pulumi.set(__self__, "acr_registry_name", acr_registry_name)
        if acr_repository_name is not None:
            pulumi.set(__self__, "acr_repository_name", acr_repository_name)
        if acr_resource_group is not None:
            pulumi.set(__self__, "acr_resource_group", acr_resource_group)
        if acr_subscription_id is not None:
            pulumi.set(__self__, "acr_subscription_id", acr_subscription_id)

    @property
    @pulumi.getter(name="acrRegistryName")
    def acr_registry_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ACR registry
        """
        return pulumi.get(self, "acr_registry_name")

    @acr_registry_name.setter
    def acr_registry_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "acr_registry_name", value)

    @property
    @pulumi.getter(name="acrRepositoryName")
    def acr_repository_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ACR repository
        """
        return pulumi.get(self, "acr_repository_name")

    @acr_repository_name.setter
    def acr_repository_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "acr_repository_name", value)

    @property
    @pulumi.getter(name="acrResourceGroup")
    def acr_resource_group(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ACR resource group
        """
        return pulumi.get(self, "acr_resource_group")

    @acr_resource_group.setter
    def acr_resource_group(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "acr_resource_group", value)

    @property
    @pulumi.getter(name="acrSubscriptionId")
    def acr_subscription_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ACR subscription id
        """
        return pulumi.get(self, "acr_subscription_id")

    @acr_subscription_id.setter
    def acr_subscription_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "acr_subscription_id", value)


if not MYPY:
    class DeploymentPropertiesArgsDict(TypedDict):
        helm_chart_path: NotRequired[pulumi.Input[builtins.str]]
        """
        Helm chart directory path in repository.
        """
        helm_values: NotRequired[pulumi.Input[builtins.str]]
        """
        Helm Values.yaml file location in repository.
        """
        kube_manifest_locations: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        manifest_type: NotRequired[pulumi.Input[Union[builtins.str, 'ManifestType']]]
        """
        Determines the type of manifests within the repository.
        """
        overrides: NotRequired[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]
        """
        Manifest override values.
        """
elif False:
    DeploymentPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class DeploymentPropertiesArgs:
    def __init__(__self__, *,
                 helm_chart_path: Optional[pulumi.Input[builtins.str]] = None,
                 helm_values: Optional[pulumi.Input[builtins.str]] = None,
                 kube_manifest_locations: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 manifest_type: Optional[pulumi.Input[Union[builtins.str, 'ManifestType']]] = None,
                 overrides: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None):
        """
        :param pulumi.Input[builtins.str] helm_chart_path: Helm chart directory path in repository.
        :param pulumi.Input[builtins.str] helm_values: Helm Values.yaml file location in repository.
        :param pulumi.Input[Union[builtins.str, 'ManifestType']] manifest_type: Determines the type of manifests within the repository.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] overrides: Manifest override values.
        """
        if helm_chart_path is not None:
            pulumi.set(__self__, "helm_chart_path", helm_chart_path)
        if helm_values is not None:
            pulumi.set(__self__, "helm_values", helm_values)
        if kube_manifest_locations is not None:
            pulumi.set(__self__, "kube_manifest_locations", kube_manifest_locations)
        if manifest_type is not None:
            pulumi.set(__self__, "manifest_type", manifest_type)
        if overrides is not None:
            pulumi.set(__self__, "overrides", overrides)

    @property
    @pulumi.getter(name="helmChartPath")
    def helm_chart_path(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Helm chart directory path in repository.
        """
        return pulumi.get(self, "helm_chart_path")

    @helm_chart_path.setter
    def helm_chart_path(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "helm_chart_path", value)

    @property
    @pulumi.getter(name="helmValues")
    def helm_values(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Helm Values.yaml file location in repository.
        """
        return pulumi.get(self, "helm_values")

    @helm_values.setter
    def helm_values(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "helm_values", value)

    @property
    @pulumi.getter(name="kubeManifestLocations")
    def kube_manifest_locations(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "kube_manifest_locations")

    @kube_manifest_locations.setter
    def kube_manifest_locations(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "kube_manifest_locations", value)

    @property
    @pulumi.getter(name="manifestType")
    def manifest_type(self) -> Optional[pulumi.Input[Union[builtins.str, 'ManifestType']]]:
        """
        Determines the type of manifests within the repository.
        """
        return pulumi.get(self, "manifest_type")

    @manifest_type.setter
    def manifest_type(self, value: Optional[pulumi.Input[Union[builtins.str, 'ManifestType']]]):
        pulumi.set(self, "manifest_type", value)

    @property
    @pulumi.getter
    def overrides(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        Manifest override values.
        """
        return pulumi.get(self, "overrides")

    @overrides.setter
    def overrides(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "overrides", value)


if not MYPY:
    class GitHubWorkflowProfileOidcCredentialsArgsDict(TypedDict):
        """
        The fields needed for OIDC with GitHub.
        """
        azure_client_id: NotRequired[pulumi.Input[builtins.str]]
        """
        Azure Application Client ID
        """
        azure_tenant_id: NotRequired[pulumi.Input[builtins.str]]
        """
        Azure Directory (tenant) ID
        """
elif False:
    GitHubWorkflowProfileOidcCredentialsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GitHubWorkflowProfileOidcCredentialsArgs:
    def __init__(__self__, *,
                 azure_client_id: Optional[pulumi.Input[builtins.str]] = None,
                 azure_tenant_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        The fields needed for OIDC with GitHub.
        :param pulumi.Input[builtins.str] azure_client_id: Azure Application Client ID
        :param pulumi.Input[builtins.str] azure_tenant_id: Azure Directory (tenant) ID
        """
        if azure_client_id is not None:
            pulumi.set(__self__, "azure_client_id", azure_client_id)
        if azure_tenant_id is not None:
            pulumi.set(__self__, "azure_tenant_id", azure_tenant_id)

    @property
    @pulumi.getter(name="azureClientId")
    def azure_client_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Azure Application Client ID
        """
        return pulumi.get(self, "azure_client_id")

    @azure_client_id.setter
    def azure_client_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "azure_client_id", value)

    @property
    @pulumi.getter(name="azureTenantId")
    def azure_tenant_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Azure Directory (tenant) ID
        """
        return pulumi.get(self, "azure_tenant_id")

    @azure_tenant_id.setter
    def azure_tenant_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "azure_tenant_id", value)


if not MYPY:
    class GitHubWorkflowProfileArgsDict(TypedDict):
        """
        GitHub Workflow Profile
        """
        acr: NotRequired[pulumi.Input['ACRArgsDict']]
        """
        Information on the azure container registry
        """
        aks_resource_id: NotRequired[pulumi.Input[builtins.str]]
        """
        The Azure Kubernetes Cluster Resource the application will be deployed to.
        """
        branch_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Repository Branch Name
        """
        deployment_properties: NotRequired[pulumi.Input['DeploymentPropertiesArgsDict']]
        docker_build_context: NotRequired[pulumi.Input[builtins.str]]
        """
        Path to Dockerfile Build Context within the repository.
        """
        dockerfile: NotRequired[pulumi.Input[builtins.str]]
        """
        Path to the Dockerfile within the repository.
        """
        last_workflow_run: NotRequired[pulumi.Input['WorkflowRunArgsDict']]
        namespace: NotRequired[pulumi.Input[builtins.str]]
        """
        Kubernetes namespace the application is deployed to.
        """
        oidc_credentials: NotRequired[pulumi.Input['GitHubWorkflowProfileOidcCredentialsArgsDict']]
        """
        The fields needed for OIDC with GitHub.
        """
        repository_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Repository Name
        """
        repository_owner: NotRequired[pulumi.Input[builtins.str]]
        """
        Repository Owner
        """
elif False:
    GitHubWorkflowProfileArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class GitHubWorkflowProfileArgs:
    def __init__(__self__, *,
                 acr: Optional[pulumi.Input['ACRArgs']] = None,
                 aks_resource_id: Optional[pulumi.Input[builtins.str]] = None,
                 branch_name: Optional[pulumi.Input[builtins.str]] = None,
                 deployment_properties: Optional[pulumi.Input['DeploymentPropertiesArgs']] = None,
                 docker_build_context: Optional[pulumi.Input[builtins.str]] = None,
                 dockerfile: Optional[pulumi.Input[builtins.str]] = None,
                 last_workflow_run: Optional[pulumi.Input['WorkflowRunArgs']] = None,
                 namespace: Optional[pulumi.Input[builtins.str]] = None,
                 oidc_credentials: Optional[pulumi.Input['GitHubWorkflowProfileOidcCredentialsArgs']] = None,
                 repository_name: Optional[pulumi.Input[builtins.str]] = None,
                 repository_owner: Optional[pulumi.Input[builtins.str]] = None):
        """
        GitHub Workflow Profile
        :param pulumi.Input['ACRArgs'] acr: Information on the azure container registry
        :param pulumi.Input[builtins.str] aks_resource_id: The Azure Kubernetes Cluster Resource the application will be deployed to.
        :param pulumi.Input[builtins.str] branch_name: Repository Branch Name
        :param pulumi.Input[builtins.str] docker_build_context: Path to Dockerfile Build Context within the repository.
        :param pulumi.Input[builtins.str] dockerfile: Path to the Dockerfile within the repository.
        :param pulumi.Input[builtins.str] namespace: Kubernetes namespace the application is deployed to.
        :param pulumi.Input['GitHubWorkflowProfileOidcCredentialsArgs'] oidc_credentials: The fields needed for OIDC with GitHub.
        :param pulumi.Input[builtins.str] repository_name: Repository Name
        :param pulumi.Input[builtins.str] repository_owner: Repository Owner
        """
        if acr is not None:
            pulumi.set(__self__, "acr", acr)
        if aks_resource_id is not None:
            pulumi.set(__self__, "aks_resource_id", aks_resource_id)
        if branch_name is not None:
            pulumi.set(__self__, "branch_name", branch_name)
        if deployment_properties is not None:
            pulumi.set(__self__, "deployment_properties", deployment_properties)
        if docker_build_context is not None:
            pulumi.set(__self__, "docker_build_context", docker_build_context)
        if dockerfile is not None:
            pulumi.set(__self__, "dockerfile", dockerfile)
        if last_workflow_run is not None:
            pulumi.set(__self__, "last_workflow_run", last_workflow_run)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)
        if oidc_credentials is not None:
            pulumi.set(__self__, "oidc_credentials", oidc_credentials)
        if repository_name is not None:
            pulumi.set(__self__, "repository_name", repository_name)
        if repository_owner is not None:
            pulumi.set(__self__, "repository_owner", repository_owner)

    @property
    @pulumi.getter
    def acr(self) -> Optional[pulumi.Input['ACRArgs']]:
        """
        Information on the azure container registry
        """
        return pulumi.get(self, "acr")

    @acr.setter
    def acr(self, value: Optional[pulumi.Input['ACRArgs']]):
        pulumi.set(self, "acr", value)

    @property
    @pulumi.getter(name="aksResourceId")
    def aks_resource_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Azure Kubernetes Cluster Resource the application will be deployed to.
        """
        return pulumi.get(self, "aks_resource_id")

    @aks_resource_id.setter
    def aks_resource_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "aks_resource_id", value)

    @property
    @pulumi.getter(name="branchName")
    def branch_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Repository Branch Name
        """
        return pulumi.get(self, "branch_name")

    @branch_name.setter
    def branch_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "branch_name", value)

    @property
    @pulumi.getter(name="deploymentProperties")
    def deployment_properties(self) -> Optional[pulumi.Input['DeploymentPropertiesArgs']]:
        return pulumi.get(self, "deployment_properties")

    @deployment_properties.setter
    def deployment_properties(self, value: Optional[pulumi.Input['DeploymentPropertiesArgs']]):
        pulumi.set(self, "deployment_properties", value)

    @property
    @pulumi.getter(name="dockerBuildContext")
    def docker_build_context(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Path to Dockerfile Build Context within the repository.
        """
        return pulumi.get(self, "docker_build_context")

    @docker_build_context.setter
    def docker_build_context(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "docker_build_context", value)

    @property
    @pulumi.getter
    def dockerfile(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Path to the Dockerfile within the repository.
        """
        return pulumi.get(self, "dockerfile")

    @dockerfile.setter
    def dockerfile(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dockerfile", value)

    @property
    @pulumi.getter(name="lastWorkflowRun")
    def last_workflow_run(self) -> Optional[pulumi.Input['WorkflowRunArgs']]:
        return pulumi.get(self, "last_workflow_run")

    @last_workflow_run.setter
    def last_workflow_run(self, value: Optional[pulumi.Input['WorkflowRunArgs']]):
        pulumi.set(self, "last_workflow_run", value)

    @property
    @pulumi.getter
    def namespace(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Kubernetes namespace the application is deployed to.
        """
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "namespace", value)

    @property
    @pulumi.getter(name="oidcCredentials")
    def oidc_credentials(self) -> Optional[pulumi.Input['GitHubWorkflowProfileOidcCredentialsArgs']]:
        """
        The fields needed for OIDC with GitHub.
        """
        return pulumi.get(self, "oidc_credentials")

    @oidc_credentials.setter
    def oidc_credentials(self, value: Optional[pulumi.Input['GitHubWorkflowProfileOidcCredentialsArgs']]):
        pulumi.set(self, "oidc_credentials", value)

    @property
    @pulumi.getter(name="repositoryName")
    def repository_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Repository Name
        """
        return pulumi.get(self, "repository_name")

    @repository_name.setter
    def repository_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "repository_name", value)

    @property
    @pulumi.getter(name="repositoryOwner")
    def repository_owner(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Repository Owner
        """
        return pulumi.get(self, "repository_owner")

    @repository_owner.setter
    def repository_owner(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "repository_owner", value)


if not MYPY:
    class IacTemplateDetailsArgsDict(TypedDict):
        count: NotRequired[pulumi.Input[builtins.int]]
        """
        Count of the product
        """
        naming_convention: NotRequired[pulumi.Input[builtins.str]]
        """
        Naming convention of this product
        """
        product_name: NotRequired[pulumi.Input[builtins.str]]
        """
        The name of the products.
        """
elif False:
    IacTemplateDetailsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class IacTemplateDetailsArgs:
    def __init__(__self__, *,
                 count: Optional[pulumi.Input[builtins.int]] = None,
                 naming_convention: Optional[pulumi.Input[builtins.str]] = None,
                 product_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        :param pulumi.Input[builtins.int] count: Count of the product
        :param pulumi.Input[builtins.str] naming_convention: Naming convention of this product
        :param pulumi.Input[builtins.str] product_name: The name of the products.
        """
        if count is not None:
            pulumi.set(__self__, "count", count)
        if naming_convention is not None:
            pulumi.set(__self__, "naming_convention", naming_convention)
        if product_name is not None:
            pulumi.set(__self__, "product_name", product_name)

    @property
    @pulumi.getter
    def count(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Count of the product
        """
        return pulumi.get(self, "count")

    @count.setter
    def count(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "count", value)

    @property
    @pulumi.getter(name="namingConvention")
    def naming_convention(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Naming convention of this product
        """
        return pulumi.get(self, "naming_convention")

    @naming_convention.setter
    def naming_convention(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "naming_convention", value)

    @property
    @pulumi.getter(name="productName")
    def product_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the products.
        """
        return pulumi.get(self, "product_name")

    @product_name.setter
    def product_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "product_name", value)


if not MYPY:
    class IacTemplatePropertiesArgsDict(TypedDict):
        """
        Properties of a IacTemplate.
        """
        instance_name: NotRequired[pulumi.Input[builtins.str]]
        """
        the sample instance name of the template
        """
        instance_stage: NotRequired[pulumi.Input[builtins.str]]
        """
        the source stage of the template
        """
        quick_start_template_type: NotRequired[pulumi.Input[Union[builtins.str, 'QuickStartTemplateType']]]
        """
        Determines the authorization status of requests.
        """
        source_resource_id: NotRequired[pulumi.Input[builtins.str]]
        """
        the source store of the template
        """
        template_details: NotRequired[pulumi.Input[Sequence[pulumi.Input['IacTemplateDetailsArgsDict']]]]
        template_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Template Name
        """
elif False:
    IacTemplatePropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class IacTemplatePropertiesArgs:
    def __init__(__self__, *,
                 instance_name: Optional[pulumi.Input[builtins.str]] = None,
                 instance_stage: Optional[pulumi.Input[builtins.str]] = None,
                 quick_start_template_type: Optional[pulumi.Input[Union[builtins.str, 'QuickStartTemplateType']]] = None,
                 source_resource_id: Optional[pulumi.Input[builtins.str]] = None,
                 template_details: Optional[pulumi.Input[Sequence[pulumi.Input['IacTemplateDetailsArgs']]]] = None,
                 template_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        Properties of a IacTemplate.
        :param pulumi.Input[builtins.str] instance_name: the sample instance name of the template
        :param pulumi.Input[builtins.str] instance_stage: the source stage of the template
        :param pulumi.Input[Union[builtins.str, 'QuickStartTemplateType']] quick_start_template_type: Determines the authorization status of requests.
        :param pulumi.Input[builtins.str] source_resource_id: the source store of the template
        :param pulumi.Input[builtins.str] template_name: Template Name
        """
        if instance_name is not None:
            pulumi.set(__self__, "instance_name", instance_name)
        if instance_stage is not None:
            pulumi.set(__self__, "instance_stage", instance_stage)
        if quick_start_template_type is not None:
            pulumi.set(__self__, "quick_start_template_type", quick_start_template_type)
        if source_resource_id is not None:
            pulumi.set(__self__, "source_resource_id", source_resource_id)
        if template_details is not None:
            pulumi.set(__self__, "template_details", template_details)
        if template_name is not None:
            pulumi.set(__self__, "template_name", template_name)

    @property
    @pulumi.getter(name="instanceName")
    def instance_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the sample instance name of the template
        """
        return pulumi.get(self, "instance_name")

    @instance_name.setter
    def instance_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "instance_name", value)

    @property
    @pulumi.getter(name="instanceStage")
    def instance_stage(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the source stage of the template
        """
        return pulumi.get(self, "instance_stage")

    @instance_stage.setter
    def instance_stage(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "instance_stage", value)

    @property
    @pulumi.getter(name="quickStartTemplateType")
    def quick_start_template_type(self) -> Optional[pulumi.Input[Union[builtins.str, 'QuickStartTemplateType']]]:
        """
        Determines the authorization status of requests.
        """
        return pulumi.get(self, "quick_start_template_type")

    @quick_start_template_type.setter
    def quick_start_template_type(self, value: Optional[pulumi.Input[Union[builtins.str, 'QuickStartTemplateType']]]):
        pulumi.set(self, "quick_start_template_type", value)

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        the source store of the template
        """
        return pulumi.get(self, "source_resource_id")

    @source_resource_id.setter
    def source_resource_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "source_resource_id", value)

    @property
    @pulumi.getter(name="templateDetails")
    def template_details(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['IacTemplateDetailsArgs']]]]:
        return pulumi.get(self, "template_details")

    @template_details.setter
    def template_details(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['IacTemplateDetailsArgs']]]]):
        pulumi.set(self, "template_details", value)

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Template Name
        """
        return pulumi.get(self, "template_name")

    @template_name.setter
    def template_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "template_name", value)


if not MYPY:
    class StagePropertiesArgsDict(TypedDict):
        """
        Properties of a Stage.
        """
        dependencies: NotRequired[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]
        git_environment: NotRequired[pulumi.Input[builtins.str]]
        stage_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Stage Name
        """
elif False:
    StagePropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class StagePropertiesArgs:
    def __init__(__self__, *,
                 dependencies: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 git_environment: Optional[pulumi.Input[builtins.str]] = None,
                 stage_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        Properties of a Stage.
        :param pulumi.Input[builtins.str] stage_name: Stage Name
        """
        if dependencies is not None:
            pulumi.set(__self__, "dependencies", dependencies)
        if git_environment is not None:
            pulumi.set(__self__, "git_environment", git_environment)
        if stage_name is not None:
            pulumi.set(__self__, "stage_name", stage_name)

    @property
    @pulumi.getter
    def dependencies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        return pulumi.get(self, "dependencies")

    @dependencies.setter
    def dependencies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "dependencies", value)

    @property
    @pulumi.getter(name="gitEnvironment")
    def git_environment(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "git_environment")

    @git_environment.setter
    def git_environment(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "git_environment", value)

    @property
    @pulumi.getter(name="stageName")
    def stage_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Stage Name
        """
        return pulumi.get(self, "stage_name")

    @stage_name.setter
    def stage_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "stage_name", value)


if not MYPY:
    class WorkflowRunArgsDict(TypedDict):
        workflow_run_status: NotRequired[pulumi.Input[Union[builtins.str, 'WorkflowRunStatus']]]
        """
        Describes the status of the workflow run
        """
elif False:
    WorkflowRunArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkflowRunArgs:
    def __init__(__self__, *,
                 workflow_run_status: Optional[pulumi.Input[Union[builtins.str, 'WorkflowRunStatus']]] = None):
        """
        :param pulumi.Input[Union[builtins.str, 'WorkflowRunStatus']] workflow_run_status: Describes the status of the workflow run
        """
        if workflow_run_status is not None:
            pulumi.set(__self__, "workflow_run_status", workflow_run_status)

    @property
    @pulumi.getter(name="workflowRunStatus")
    def workflow_run_status(self) -> Optional[pulumi.Input[Union[builtins.str, 'WorkflowRunStatus']]]:
        """
        Describes the status of the workflow run
        """
        return pulumi.get(self, "workflow_run_status")

    @workflow_run_status.setter
    def workflow_run_status(self, value: Optional[pulumi.Input[Union[builtins.str, 'WorkflowRunStatus']]]):
        pulumi.set(self, "workflow_run_status", value)


