# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetADOOAuthInfoResult',
    'AwaitableGetADOOAuthInfoResult',
    'get_adoo_auth_info',
    'get_adoo_auth_info_output',
]

@pulumi.output_type
class GetADOOAuthInfoResult:
    """
    Response containing ADO OAuth information
    """
    def __init__(__self__, auth_url=None, token=None):
        if auth_url and not isinstance(auth_url, str):
            raise TypeError("Expected argument 'auth_url' to be a str")
        pulumi.set(__self__, "auth_url", auth_url)
        if token and not isinstance(token, str):
            raise TypeError("Expected argument 'token' to be a str")
        pulumi.set(__self__, "token", token)

    @property
    @pulumi.getter(name="authURL")
    def auth_url(self) -> Optional[builtins.str]:
        """
        URL used to authorize ADO app using Entra ID
        """
        return pulumi.get(self, "auth_url")

    @property
    @pulumi.getter
    def token(self) -> Optional[builtins.str]:
        """
        OAuth token used to make calls to ADO APIs
        """
        return pulumi.get(self, "token")


class AwaitableGetADOOAuthInfoResult(GetADOOAuthInfoResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetADOOAuthInfoResult(
            auth_url=self.auth_url,
            token=self.token)


def get_adoo_auth_info(location: Optional[builtins.str] = None,
                       redirect_url: Optional[builtins.str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetADOOAuthInfoResult:
    """
    Response containing ADO OAuth information

    Uses Azure REST API version 2025-03-01-preview.

    Other available API versions: 2024-08-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native devhub [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str location: The name of the Azure region.
    :param builtins.str redirect_url: The URL the client will redirect to on successful authentication. If empty, no redirect will occur.
    """
    __args__ = dict()
    __args__['location'] = location
    __args__['redirectUrl'] = redirect_url
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:devhub:getADOOAuthInfo', __args__, opts=opts, typ=GetADOOAuthInfoResult).value

    return AwaitableGetADOOAuthInfoResult(
        auth_url=pulumi.get(__ret__, 'auth_url'),
        token=pulumi.get(__ret__, 'token'))
def get_adoo_auth_info_output(location: Optional[pulumi.Input[builtins.str]] = None,
                              redirect_url: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetADOOAuthInfoResult]:
    """
    Response containing ADO OAuth information

    Uses Azure REST API version 2025-03-01-preview.

    Other available API versions: 2024-08-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native devhub [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str location: The name of the Azure region.
    :param builtins.str redirect_url: The URL the client will redirect to on successful authentication. If empty, no redirect will occur.
    """
    __args__ = dict()
    __args__['location'] = location
    __args__['redirectUrl'] = redirect_url
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:devhub:getADOOAuthInfo', __args__, opts=opts, typ=GetADOOAuthInfoResult)
    return __ret__.apply(lambda __response__: GetADOOAuthInfoResult(
        auth_url=pulumi.get(__response__, 'auth_url'),
        token=pulumi.get(__response__, 'token')))
