# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'ACRResponse',
    'DeploymentPropertiesResponse',
    'GitHubWorkflowProfileResponse',
    'GitHubWorkflowProfileResponseOidcCredentials',
    'IacTemplateDetailsResponse',
    'IacTemplatePropertiesResponse',
    'StagePropertiesResponse',
    'SystemDataResponse',
    'WorkflowRunResponse',
]

@pulumi.output_type
class ACRResponse(dict):
    """
    Information on the azure container registry
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "acrRegistryName":
            suggest = "acr_registry_name"
        elif key == "acrRepositoryName":
            suggest = "acr_repository_name"
        elif key == "acrResourceGroup":
            suggest = "acr_resource_group"
        elif key == "acrSubscriptionId":
            suggest = "acr_subscription_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ACRResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ACRResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ACRResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 acr_registry_name: Optional[builtins.str] = None,
                 acr_repository_name: Optional[builtins.str] = None,
                 acr_resource_group: Optional[builtins.str] = None,
                 acr_subscription_id: Optional[builtins.str] = None):
        """
        Information on the azure container registry
        :param builtins.str acr_registry_name: ACR registry
        :param builtins.str acr_repository_name: ACR repository
        :param builtins.str acr_resource_group: ACR resource group
        :param builtins.str acr_subscription_id: ACR subscription id
        """
        if acr_registry_name is not None:
            pulumi.set(__self__, "acr_registry_name", acr_registry_name)
        if acr_repository_name is not None:
            pulumi.set(__self__, "acr_repository_name", acr_repository_name)
        if acr_resource_group is not None:
            pulumi.set(__self__, "acr_resource_group", acr_resource_group)
        if acr_subscription_id is not None:
            pulumi.set(__self__, "acr_subscription_id", acr_subscription_id)

    @property
    @pulumi.getter(name="acrRegistryName")
    def acr_registry_name(self) -> Optional[builtins.str]:
        """
        ACR registry
        """
        return pulumi.get(self, "acr_registry_name")

    @property
    @pulumi.getter(name="acrRepositoryName")
    def acr_repository_name(self) -> Optional[builtins.str]:
        """
        ACR repository
        """
        return pulumi.get(self, "acr_repository_name")

    @property
    @pulumi.getter(name="acrResourceGroup")
    def acr_resource_group(self) -> Optional[builtins.str]:
        """
        ACR resource group
        """
        return pulumi.get(self, "acr_resource_group")

    @property
    @pulumi.getter(name="acrSubscriptionId")
    def acr_subscription_id(self) -> Optional[builtins.str]:
        """
        ACR subscription id
        """
        return pulumi.get(self, "acr_subscription_id")


@pulumi.output_type
class DeploymentPropertiesResponse(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "helmChartPath":
            suggest = "helm_chart_path"
        elif key == "helmValues":
            suggest = "helm_values"
        elif key == "kubeManifestLocations":
            suggest = "kube_manifest_locations"
        elif key == "manifestType":
            suggest = "manifest_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DeploymentPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DeploymentPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DeploymentPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 helm_chart_path: Optional[builtins.str] = None,
                 helm_values: Optional[builtins.str] = None,
                 kube_manifest_locations: Optional[Sequence[builtins.str]] = None,
                 manifest_type: Optional[builtins.str] = None,
                 overrides: Optional[Mapping[str, builtins.str]] = None):
        """
        :param builtins.str helm_chart_path: Helm chart directory path in repository.
        :param builtins.str helm_values: Helm Values.yaml file location in repository.
        :param builtins.str manifest_type: Determines the type of manifests within the repository.
        :param Mapping[str, builtins.str] overrides: Manifest override values.
        """
        if helm_chart_path is not None:
            pulumi.set(__self__, "helm_chart_path", helm_chart_path)
        if helm_values is not None:
            pulumi.set(__self__, "helm_values", helm_values)
        if kube_manifest_locations is not None:
            pulumi.set(__self__, "kube_manifest_locations", kube_manifest_locations)
        if manifest_type is not None:
            pulumi.set(__self__, "manifest_type", manifest_type)
        if overrides is not None:
            pulumi.set(__self__, "overrides", overrides)

    @property
    @pulumi.getter(name="helmChartPath")
    def helm_chart_path(self) -> Optional[builtins.str]:
        """
        Helm chart directory path in repository.
        """
        return pulumi.get(self, "helm_chart_path")

    @property
    @pulumi.getter(name="helmValues")
    def helm_values(self) -> Optional[builtins.str]:
        """
        Helm Values.yaml file location in repository.
        """
        return pulumi.get(self, "helm_values")

    @property
    @pulumi.getter(name="kubeManifestLocations")
    def kube_manifest_locations(self) -> Optional[Sequence[builtins.str]]:
        return pulumi.get(self, "kube_manifest_locations")

    @property
    @pulumi.getter(name="manifestType")
    def manifest_type(self) -> Optional[builtins.str]:
        """
        Determines the type of manifests within the repository.
        """
        return pulumi.get(self, "manifest_type")

    @property
    @pulumi.getter
    def overrides(self) -> Optional[Mapping[str, builtins.str]]:
        """
        Manifest override values.
        """
        return pulumi.get(self, "overrides")


@pulumi.output_type
class GitHubWorkflowProfileResponse(dict):
    """
    GitHub Workflow Profile
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "authStatus":
            suggest = "auth_status"
        elif key == "prStatus":
            suggest = "pr_status"
        elif key == "prURL":
            suggest = "pr_url"
        elif key == "pullNumber":
            suggest = "pull_number"
        elif key == "aksResourceId":
            suggest = "aks_resource_id"
        elif key == "branchName":
            suggest = "branch_name"
        elif key == "deploymentProperties":
            suggest = "deployment_properties"
        elif key == "dockerBuildContext":
            suggest = "docker_build_context"
        elif key == "lastWorkflowRun":
            suggest = "last_workflow_run"
        elif key == "oidcCredentials":
            suggest = "oidc_credentials"
        elif key == "repositoryName":
            suggest = "repository_name"
        elif key == "repositoryOwner":
            suggest = "repository_owner"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GitHubWorkflowProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GitHubWorkflowProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GitHubWorkflowProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 auth_status: builtins.str,
                 pr_status: builtins.str,
                 pr_url: builtins.str,
                 pull_number: builtins.int,
                 acr: Optional['outputs.ACRResponse'] = None,
                 aks_resource_id: Optional[builtins.str] = None,
                 branch_name: Optional[builtins.str] = None,
                 deployment_properties: Optional['outputs.DeploymentPropertiesResponse'] = None,
                 docker_build_context: Optional[builtins.str] = None,
                 dockerfile: Optional[builtins.str] = None,
                 last_workflow_run: Optional['outputs.WorkflowRunResponse'] = None,
                 namespace: Optional[builtins.str] = None,
                 oidc_credentials: Optional['outputs.GitHubWorkflowProfileResponseOidcCredentials'] = None,
                 repository_name: Optional[builtins.str] = None,
                 repository_owner: Optional[builtins.str] = None):
        """
        GitHub Workflow Profile
        :param builtins.str auth_status: Determines the authorization status of requests.
        :param builtins.str pr_status: The status of the Pull Request submitted against the users repository.
        :param builtins.str pr_url: The URL to the Pull Request submitted against the users repository.
        :param builtins.int pull_number: The number associated with the submitted pull request.
        :param 'ACRResponse' acr: Information on the azure container registry
        :param builtins.str aks_resource_id: The Azure Kubernetes Cluster Resource the application will be deployed to.
        :param builtins.str branch_name: Repository Branch Name
        :param builtins.str docker_build_context: Path to Dockerfile Build Context within the repository.
        :param builtins.str dockerfile: Path to the Dockerfile within the repository.
        :param builtins.str namespace: Kubernetes namespace the application is deployed to.
        :param 'GitHubWorkflowProfileResponseOidcCredentials' oidc_credentials: The fields needed for OIDC with GitHub.
        :param builtins.str repository_name: Repository Name
        :param builtins.str repository_owner: Repository Owner
        """
        pulumi.set(__self__, "auth_status", auth_status)
        pulumi.set(__self__, "pr_status", pr_status)
        pulumi.set(__self__, "pr_url", pr_url)
        pulumi.set(__self__, "pull_number", pull_number)
        if acr is not None:
            pulumi.set(__self__, "acr", acr)
        if aks_resource_id is not None:
            pulumi.set(__self__, "aks_resource_id", aks_resource_id)
        if branch_name is not None:
            pulumi.set(__self__, "branch_name", branch_name)
        if deployment_properties is not None:
            pulumi.set(__self__, "deployment_properties", deployment_properties)
        if docker_build_context is not None:
            pulumi.set(__self__, "docker_build_context", docker_build_context)
        if dockerfile is not None:
            pulumi.set(__self__, "dockerfile", dockerfile)
        if last_workflow_run is not None:
            pulumi.set(__self__, "last_workflow_run", last_workflow_run)
        if namespace is not None:
            pulumi.set(__self__, "namespace", namespace)
        if oidc_credentials is not None:
            pulumi.set(__self__, "oidc_credentials", oidc_credentials)
        if repository_name is not None:
            pulumi.set(__self__, "repository_name", repository_name)
        if repository_owner is not None:
            pulumi.set(__self__, "repository_owner", repository_owner)

    @property
    @pulumi.getter(name="authStatus")
    def auth_status(self) -> builtins.str:
        """
        Determines the authorization status of requests.
        """
        return pulumi.get(self, "auth_status")

    @property
    @pulumi.getter(name="prStatus")
    def pr_status(self) -> builtins.str:
        """
        The status of the Pull Request submitted against the users repository.
        """
        return pulumi.get(self, "pr_status")

    @property
    @pulumi.getter(name="prURL")
    def pr_url(self) -> builtins.str:
        """
        The URL to the Pull Request submitted against the users repository.
        """
        return pulumi.get(self, "pr_url")

    @property
    @pulumi.getter(name="pullNumber")
    def pull_number(self) -> builtins.int:
        """
        The number associated with the submitted pull request.
        """
        return pulumi.get(self, "pull_number")

    @property
    @pulumi.getter
    def acr(self) -> Optional['outputs.ACRResponse']:
        """
        Information on the azure container registry
        """
        return pulumi.get(self, "acr")

    @property
    @pulumi.getter(name="aksResourceId")
    def aks_resource_id(self) -> Optional[builtins.str]:
        """
        The Azure Kubernetes Cluster Resource the application will be deployed to.
        """
        return pulumi.get(self, "aks_resource_id")

    @property
    @pulumi.getter(name="branchName")
    def branch_name(self) -> Optional[builtins.str]:
        """
        Repository Branch Name
        """
        return pulumi.get(self, "branch_name")

    @property
    @pulumi.getter(name="deploymentProperties")
    def deployment_properties(self) -> Optional['outputs.DeploymentPropertiesResponse']:
        return pulumi.get(self, "deployment_properties")

    @property
    @pulumi.getter(name="dockerBuildContext")
    def docker_build_context(self) -> Optional[builtins.str]:
        """
        Path to Dockerfile Build Context within the repository.
        """
        return pulumi.get(self, "docker_build_context")

    @property
    @pulumi.getter
    def dockerfile(self) -> Optional[builtins.str]:
        """
        Path to the Dockerfile within the repository.
        """
        return pulumi.get(self, "dockerfile")

    @property
    @pulumi.getter(name="lastWorkflowRun")
    def last_workflow_run(self) -> Optional['outputs.WorkflowRunResponse']:
        return pulumi.get(self, "last_workflow_run")

    @property
    @pulumi.getter
    def namespace(self) -> Optional[builtins.str]:
        """
        Kubernetes namespace the application is deployed to.
        """
        return pulumi.get(self, "namespace")

    @property
    @pulumi.getter(name="oidcCredentials")
    def oidc_credentials(self) -> Optional['outputs.GitHubWorkflowProfileResponseOidcCredentials']:
        """
        The fields needed for OIDC with GitHub.
        """
        return pulumi.get(self, "oidc_credentials")

    @property
    @pulumi.getter(name="repositoryName")
    def repository_name(self) -> Optional[builtins.str]:
        """
        Repository Name
        """
        return pulumi.get(self, "repository_name")

    @property
    @pulumi.getter(name="repositoryOwner")
    def repository_owner(self) -> Optional[builtins.str]:
        """
        Repository Owner
        """
        return pulumi.get(self, "repository_owner")


@pulumi.output_type
class GitHubWorkflowProfileResponseOidcCredentials(dict):
    """
    The fields needed for OIDC with GitHub.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "azureClientId":
            suggest = "azure_client_id"
        elif key == "azureTenantId":
            suggest = "azure_tenant_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GitHubWorkflowProfileResponseOidcCredentials. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GitHubWorkflowProfileResponseOidcCredentials.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GitHubWorkflowProfileResponseOidcCredentials.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 azure_client_id: Optional[builtins.str] = None,
                 azure_tenant_id: Optional[builtins.str] = None):
        """
        The fields needed for OIDC with GitHub.
        :param builtins.str azure_client_id: Azure Application Client ID
        :param builtins.str azure_tenant_id: Azure Directory (tenant) ID
        """
        if azure_client_id is not None:
            pulumi.set(__self__, "azure_client_id", azure_client_id)
        if azure_tenant_id is not None:
            pulumi.set(__self__, "azure_tenant_id", azure_tenant_id)

    @property
    @pulumi.getter(name="azureClientId")
    def azure_client_id(self) -> Optional[builtins.str]:
        """
        Azure Application Client ID
        """
        return pulumi.get(self, "azure_client_id")

    @property
    @pulumi.getter(name="azureTenantId")
    def azure_tenant_id(self) -> Optional[builtins.str]:
        """
        Azure Directory (tenant) ID
        """
        return pulumi.get(self, "azure_tenant_id")


@pulumi.output_type
class IacTemplateDetailsResponse(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "namingConvention":
            suggest = "naming_convention"
        elif key == "productName":
            suggest = "product_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in IacTemplateDetailsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        IacTemplateDetailsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        IacTemplateDetailsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 count: Optional[builtins.int] = None,
                 naming_convention: Optional[builtins.str] = None,
                 product_name: Optional[builtins.str] = None):
        """
        :param builtins.int count: Count of the product
        :param builtins.str naming_convention: Naming convention of this product
        :param builtins.str product_name: The name of the products.
        """
        if count is not None:
            pulumi.set(__self__, "count", count)
        if naming_convention is not None:
            pulumi.set(__self__, "naming_convention", naming_convention)
        if product_name is not None:
            pulumi.set(__self__, "product_name", product_name)

    @property
    @pulumi.getter
    def count(self) -> Optional[builtins.int]:
        """
        Count of the product
        """
        return pulumi.get(self, "count")

    @property
    @pulumi.getter(name="namingConvention")
    def naming_convention(self) -> Optional[builtins.str]:
        """
        Naming convention of this product
        """
        return pulumi.get(self, "naming_convention")

    @property
    @pulumi.getter(name="productName")
    def product_name(self) -> Optional[builtins.str]:
        """
        The name of the products.
        """
        return pulumi.get(self, "product_name")


@pulumi.output_type
class IacTemplatePropertiesResponse(dict):
    """
    Properties of a IacTemplate.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "instanceName":
            suggest = "instance_name"
        elif key == "instanceStage":
            suggest = "instance_stage"
        elif key == "quickStartTemplateType":
            suggest = "quick_start_template_type"
        elif key == "sourceResourceId":
            suggest = "source_resource_id"
        elif key == "templateDetails":
            suggest = "template_details"
        elif key == "templateName":
            suggest = "template_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in IacTemplatePropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        IacTemplatePropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        IacTemplatePropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 instance_name: Optional[builtins.str] = None,
                 instance_stage: Optional[builtins.str] = None,
                 quick_start_template_type: Optional[builtins.str] = None,
                 source_resource_id: Optional[builtins.str] = None,
                 template_details: Optional[Sequence['outputs.IacTemplateDetailsResponse']] = None,
                 template_name: Optional[builtins.str] = None):
        """
        Properties of a IacTemplate.
        :param builtins.str instance_name: the sample instance name of the template
        :param builtins.str instance_stage: the source stage of the template
        :param builtins.str quick_start_template_type: Determines the authorization status of requests.
        :param builtins.str source_resource_id: the source store of the template
        :param builtins.str template_name: Template Name
        """
        if instance_name is not None:
            pulumi.set(__self__, "instance_name", instance_name)
        if instance_stage is not None:
            pulumi.set(__self__, "instance_stage", instance_stage)
        if quick_start_template_type is not None:
            pulumi.set(__self__, "quick_start_template_type", quick_start_template_type)
        if source_resource_id is not None:
            pulumi.set(__self__, "source_resource_id", source_resource_id)
        if template_details is not None:
            pulumi.set(__self__, "template_details", template_details)
        if template_name is not None:
            pulumi.set(__self__, "template_name", template_name)

    @property
    @pulumi.getter(name="instanceName")
    def instance_name(self) -> Optional[builtins.str]:
        """
        the sample instance name of the template
        """
        return pulumi.get(self, "instance_name")

    @property
    @pulumi.getter(name="instanceStage")
    def instance_stage(self) -> Optional[builtins.str]:
        """
        the source stage of the template
        """
        return pulumi.get(self, "instance_stage")

    @property
    @pulumi.getter(name="quickStartTemplateType")
    def quick_start_template_type(self) -> Optional[builtins.str]:
        """
        Determines the authorization status of requests.
        """
        return pulumi.get(self, "quick_start_template_type")

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> Optional[builtins.str]:
        """
        the source store of the template
        """
        return pulumi.get(self, "source_resource_id")

    @property
    @pulumi.getter(name="templateDetails")
    def template_details(self) -> Optional[Sequence['outputs.IacTemplateDetailsResponse']]:
        return pulumi.get(self, "template_details")

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> Optional[builtins.str]:
        """
        Template Name
        """
        return pulumi.get(self, "template_name")


@pulumi.output_type
class StagePropertiesResponse(dict):
    """
    Properties of a Stage.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "gitEnvironment":
            suggest = "git_environment"
        elif key == "stageName":
            suggest = "stage_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in StagePropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        StagePropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        StagePropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dependencies: Optional[Sequence[builtins.str]] = None,
                 git_environment: Optional[builtins.str] = None,
                 stage_name: Optional[builtins.str] = None):
        """
        Properties of a Stage.
        :param builtins.str stage_name: Stage Name
        """
        if dependencies is not None:
            pulumi.set(__self__, "dependencies", dependencies)
        if git_environment is not None:
            pulumi.set(__self__, "git_environment", git_environment)
        if stage_name is not None:
            pulumi.set(__self__, "stage_name", stage_name)

    @property
    @pulumi.getter
    def dependencies(self) -> Optional[Sequence[builtins.str]]:
        return pulumi.get(self, "dependencies")

    @property
    @pulumi.getter(name="gitEnvironment")
    def git_environment(self) -> Optional[builtins.str]:
        return pulumi.get(self, "git_environment")

    @property
    @pulumi.getter(name="stageName")
    def stage_name(self) -> Optional[builtins.str]:
        """
        Stage Name
        """
        return pulumi.get(self, "stage_name")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[builtins.str] = None,
                 created_by: Optional[builtins.str] = None,
                 created_by_type: Optional[builtins.str] = None,
                 last_modified_at: Optional[builtins.str] = None,
                 last_modified_by: Optional[builtins.str] = None,
                 last_modified_by_type: Optional[builtins.str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param builtins.str created_at: The timestamp of resource creation (UTC).
        :param builtins.str created_by: The identity that created the resource.
        :param builtins.str created_by_type: The type of identity that created the resource.
        :param builtins.str last_modified_at: The timestamp of resource last modification (UTC)
        :param builtins.str last_modified_by: The identity that last modified the resource.
        :param builtins.str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[builtins.str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[builtins.str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[builtins.str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[builtins.str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[builtins.str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[builtins.str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


@pulumi.output_type
class WorkflowRunResponse(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "lastRunAt":
            suggest = "last_run_at"
        elif key == "workflowRunURL":
            suggest = "workflow_run_url"
        elif key == "workflowRunStatus":
            suggest = "workflow_run_status"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in WorkflowRunResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        WorkflowRunResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        WorkflowRunResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 last_run_at: builtins.str,
                 succeeded: builtins.bool,
                 workflow_run_url: builtins.str,
                 workflow_run_status: Optional[builtins.str] = None):
        """
        :param builtins.str last_run_at: The timestamp of the last workflow run.
        :param builtins.bool succeeded: Describes if the workflow run succeeded.
        :param builtins.str workflow_run_url: URL to the run of the workflow.
        :param builtins.str workflow_run_status: Describes the status of the workflow run
        """
        pulumi.set(__self__, "last_run_at", last_run_at)
        pulumi.set(__self__, "succeeded", succeeded)
        pulumi.set(__self__, "workflow_run_url", workflow_run_url)
        if workflow_run_status is not None:
            pulumi.set(__self__, "workflow_run_status", workflow_run_status)

    @property
    @pulumi.getter(name="lastRunAt")
    def last_run_at(self) -> builtins.str:
        """
        The timestamp of the last workflow run.
        """
        return pulumi.get(self, "last_run_at")

    @property
    @pulumi.getter
    def succeeded(self) -> builtins.bool:
        """
        Describes if the workflow run succeeded.
        """
        return pulumi.get(self, "succeeded")

    @property
    @pulumi.getter(name="workflowRunURL")
    def workflow_run_url(self) -> builtins.str:
        """
        URL to the run of the workflow.
        """
        return pulumi.get(self, "workflow_run_url")

    @property
    @pulumi.getter(name="workflowRunStatus")
    def workflow_run_status(self) -> Optional[builtins.str]:
        """
        Describes the status of the workflow run
        """
        return pulumi.get(self, "workflow_run_status")


