# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AuthenticationMethod',
    'DataPointObservabilityMode',
    'EventObservabilityMode',
    'Format',
    'SchemaType',
    'SystemAssignedServiceIdentityType',
    'TopicRetainType',
]


@pulumi.type_token("azure-native:deviceregistry:AuthenticationMethod")
class AuthenticationMethod(builtins.str, Enum):
    """
    The method to authenticate the user of the client at the server.
    """
    ANONYMOUS = "Anonymous"
    """
    The user authentication method is anonymous.
    """
    CERTIFICATE = "Certificate"
    """
    The user authentication method is an x509 certificate.
    """
    USERNAME_PASSWORD = "UsernamePassword"
    """
    The user authentication method is a username and password.
    """


@pulumi.type_token("azure-native:deviceregistry:DataPointObservabilityMode")
class DataPointObservabilityMode(builtins.str, Enum):
    """
    An indication of how the data point should be mapped to OpenTelemetry.
    """
    NONE = "None"
    """
    No mapping to OpenTelemetry.
    """
    COUNTER = "Counter"
    """
    Map as counter to OpenTelemetry.
    """
    GAUGE = "Gauge"
    """
    Map as gauge to OpenTelemetry.
    """
    HISTOGRAM = "Histogram"
    """
    Map as histogram to OpenTelemetry.
    """
    LOG = "Log"
    """
    Map as log to OpenTelemetry.
    """


@pulumi.type_token("azure-native:deviceregistry:EventObservabilityMode")
class EventObservabilityMode(builtins.str, Enum):
    """
    An indication of how the event should be mapped to OpenTelemetry.
    """
    NONE = "None"
    """
    No mapping to OpenTelemetry.
    """
    LOG = "Log"
    """
    Map as log to OpenTelemetry.
    """


@pulumi.type_token("azure-native:deviceregistry:Format")
class Format(builtins.str, Enum):
    """
    Format of the schema.
    """
    JSON_SCHEMA_DRAFT7 = "JsonSchema/draft-07"
    """
    JSON Schema version draft 7 format
    """
    DELTA_1_0 = "Delta/1.0"
    """
    Delta format
    """


@pulumi.type_token("azure-native:deviceregistry:SchemaType")
class SchemaType(builtins.str, Enum):
    """
    Type of the schema.
    """
    MESSAGE_SCHEMA = "MessageSchema"
    """
    Message Schema schema type
    """


@pulumi.type_token("azure-native:deviceregistry:SystemAssignedServiceIdentityType")
class SystemAssignedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (either system assigned, or none).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"


@pulumi.type_token("azure-native:deviceregistry:TopicRetainType")
class TopicRetainType(builtins.str, Enum):
    """
    When set to 'Keep', messages published to an MQTT broker will have the retain flag set. Default: 'Never'.
    """
    KEEP = "Keep"
    """
    Retain the messages.
    """
    NEVER = "Never"
    """
    Never retain messages.
    """
