# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = ['SchemaVersionArgs', 'SchemaVersion']

@pulumi.input_type
class SchemaVersionArgs:
    def __init__(__self__, *,
                 resource_group_name: pulumi.Input[builtins.str],
                 schema_content: pulumi.Input[builtins.str],
                 schema_name: pulumi.Input[builtins.str],
                 schema_registry_name: pulumi.Input[builtins.str],
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 schema_version_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a SchemaVersion resource.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] schema_content: Schema content.
        :param pulumi.Input[builtins.str] schema_name: Schema name parameter.
        :param pulumi.Input[builtins.str] schema_registry_name: Schema registry name parameter.
        :param pulumi.Input[builtins.str] description: Human-readable description of the schema.
        :param pulumi.Input[builtins.str] schema_version_name: Schema version name parameter.
        """
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "schema_content", schema_content)
        pulumi.set(__self__, "schema_name", schema_name)
        pulumi.set(__self__, "schema_registry_name", schema_registry_name)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if schema_version_name is not None:
            pulumi.set(__self__, "schema_version_name", schema_version_name)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="schemaContent")
    def schema_content(self) -> pulumi.Input[builtins.str]:
        """
        Schema content.
        """
        return pulumi.get(self, "schema_content")

    @schema_content.setter
    def schema_content(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "schema_content", value)

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> pulumi.Input[builtins.str]:
        """
        Schema name parameter.
        """
        return pulumi.get(self, "schema_name")

    @schema_name.setter
    def schema_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "schema_name", value)

    @property
    @pulumi.getter(name="schemaRegistryName")
    def schema_registry_name(self) -> pulumi.Input[builtins.str]:
        """
        Schema registry name parameter.
        """
        return pulumi.get(self, "schema_registry_name")

    @schema_registry_name.setter
    def schema_registry_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "schema_registry_name", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Human-readable description of the schema.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="schemaVersionName")
    def schema_version_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Schema version name parameter.
        """
        return pulumi.get(self, "schema_version_name")

    @schema_version_name.setter
    def schema_version_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "schema_version_name", value)


@pulumi.type_token("azure-native:deviceregistry:SchemaVersion")
class SchemaVersion(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 schema_content: Optional[pulumi.Input[builtins.str]] = None,
                 schema_name: Optional[pulumi.Input[builtins.str]] = None,
                 schema_registry_name: Optional[pulumi.Input[builtins.str]] = None,
                 schema_version_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Schema version's definition.

        Uses Azure REST API version 2024-09-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-09-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] description: Human-readable description of the schema.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] schema_content: Schema content.
        :param pulumi.Input[builtins.str] schema_name: Schema name parameter.
        :param pulumi.Input[builtins.str] schema_registry_name: Schema registry name parameter.
        :param pulumi.Input[builtins.str] schema_version_name: Schema version name parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SchemaVersionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Schema version's definition.

        Uses Azure REST API version 2024-09-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-09-01-preview.

        :param str resource_name: The name of the resource.
        :param SchemaVersionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SchemaVersionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 schema_content: Optional[pulumi.Input[builtins.str]] = None,
                 schema_name: Optional[pulumi.Input[builtins.str]] = None,
                 schema_registry_name: Optional[pulumi.Input[builtins.str]] = None,
                 schema_version_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SchemaVersionArgs.__new__(SchemaVersionArgs)

            __props__.__dict__["description"] = description
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if schema_content is None and not opts.urn:
                raise TypeError("Missing required property 'schema_content'")
            __props__.__dict__["schema_content"] = schema_content
            if schema_name is None and not opts.urn:
                raise TypeError("Missing required property 'schema_name'")
            __props__.__dict__["schema_name"] = schema_name
            if schema_registry_name is None and not opts.urn:
                raise TypeError("Missing required property 'schema_registry_name'")
            __props__.__dict__["schema_registry_name"] = schema_registry_name
            __props__.__dict__["schema_version_name"] = schema_version_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["hash"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
            __props__.__dict__["uuid"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:deviceregistry/v20240901preview:SchemaVersion")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(SchemaVersion, __self__).__init__(
            'azure-native:deviceregistry:SchemaVersion',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'SchemaVersion':
        """
        Get an existing SchemaVersion resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = SchemaVersionArgs.__new__(SchemaVersionArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["description"] = None
        __props__.__dict__["hash"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["schema_content"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["uuid"] = None
        return SchemaVersion(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Human-readable description of the schema.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def hash(self) -> pulumi.Output[builtins.str]:
        """
        Hash of the schema content.
        """
        return pulumi.get(self, "hash")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        Provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="schemaContent")
    def schema_content(self) -> pulumi.Output[builtins.str]:
        """
        Schema content.
        """
        return pulumi.get(self, "schema_content")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Output[builtins.str]:
        """
        Globally unique, immutable, non-reusable id.
        """
        return pulumi.get(self, "uuid")

