# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetVirtualMachineRdpFileContentsResult',
    'AwaitableGetVirtualMachineRdpFileContentsResult',
    'get_virtual_machine_rdp_file_contents',
    'get_virtual_machine_rdp_file_contents_output',
]

@pulumi.output_type
class GetVirtualMachineRdpFileContentsResult:
    """
    Represents a .rdp file
    """
    def __init__(__self__, contents=None):
        if contents and not isinstance(contents, str):
            raise TypeError("Expected argument 'contents' to be a str")
        pulumi.set(__self__, "contents", contents)

    @property
    @pulumi.getter
    def contents(self) -> Optional[builtins.str]:
        """
        The contents of the .rdp file
        """
        return pulumi.get(self, "contents")


class AwaitableGetVirtualMachineRdpFileContentsResult(GetVirtualMachineRdpFileContentsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVirtualMachineRdpFileContentsResult(
            contents=self.contents)


def get_virtual_machine_rdp_file_contents(lab_name: Optional[builtins.str] = None,
                                          name: Optional[builtins.str] = None,
                                          resource_group_name: Optional[builtins.str] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVirtualMachineRdpFileContentsResult:
    """
    Gets a string that represents the contents of the RDP file for the virtual machine

    Uses Azure REST API version 2018-09-15.


    :param builtins.str lab_name: The name of the lab.
    :param builtins.str name: The name of the virtual machine.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['labName'] = lab_name
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:devtestlab:getVirtualMachineRdpFileContents', __args__, opts=opts, typ=GetVirtualMachineRdpFileContentsResult).value

    return AwaitableGetVirtualMachineRdpFileContentsResult(
        contents=pulumi.get(__ret__, 'contents'))
def get_virtual_machine_rdp_file_contents_output(lab_name: Optional[pulumi.Input[builtins.str]] = None,
                                                 name: Optional[pulumi.Input[builtins.str]] = None,
                                                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetVirtualMachineRdpFileContentsResult]:
    """
    Gets a string that represents the contents of the RDP file for the virtual machine

    Uses Azure REST API version 2018-09-15.


    :param builtins.str lab_name: The name of the lab.
    :param builtins.str name: The name of the virtual machine.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['labName'] = lab_name
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:devtestlab:getVirtualMachineRdpFileContents', __args__, opts=opts, typ=GetVirtualMachineRdpFileContentsResult)
    return __ret__.apply(lambda __response__: GetVirtualMachineRdpFileContentsResult(
        contents=pulumi.get(__response__, 'contents')))
