# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AddressClassification',
    'AddressType',
    'AutoProvisioningStatus',
    'ChildConfigurationType',
    'DoubleEncryptionStatus',
    'NotificationStageName',
    'OrderItemType',
    'OrderMode',
    'SupportedFilterTypes',
    'TermCommitmentType',
    'TransportShipmentTypes',
]


@pulumi.type_token("azure-native:edgeorder:AddressClassification")
class AddressClassification(builtins.str, Enum):
    """
    Type of address based on its usage context.
    """
    SHIPPING = "Shipping"
    """
    Shipping address for the order.
    """
    SITE = "Site"
    """
    Site Address.
    """


@pulumi.type_token("azure-native:edgeorder:AddressType")
class AddressType(builtins.str, Enum):
    """
    Type of address.
    """
    NONE = "None"
    """
    Address type not known.
    """
    RESIDENTIAL = "Residential"
    """
    Residential Address.
    """
    COMMERCIAL = "Commercial"
    """
    Commercial Address.
    """


@pulumi.type_token("azure-native:edgeorder:AutoProvisioningStatus")
class AutoProvisioningStatus(builtins.str, Enum):
    """
    Auto Provisioning Details.
    """
    ENABLED = "Enabled"
    """
    Provisioning Enabled. Will act as pre-approved, and arc extension will be enabled as soon as the device is verified to be at the right edge location.
    """
    DISABLED = "Disabled"
    """
    Provisioning Disabled.
    """


@pulumi.type_token("azure-native:edgeorder:ChildConfigurationType")
class ChildConfigurationType(builtins.str, Enum):
    DEVICE_CONFIGURATION = "DeviceConfiguration"
    """
    Child configuration is a device configuration.
    """
    ADDITIONAL_CONFIGURATION = "AdditionalConfiguration"
    """
    Child configuration is an additional configuration.
    """


@pulumi.type_token("azure-native:edgeorder:DoubleEncryptionStatus")
class DoubleEncryptionStatus(builtins.str, Enum):
    """
    Double encryption status as entered by the customer. It is compulsory to give this parameter if the 'Deny' or 'Disabled' policy is configured.
    """
    DISABLED = "Disabled"
    """
    Double encryption is disabled.
    """
    ENABLED = "Enabled"
    """
    Double encryption is enabled.
    """


@pulumi.type_token("azure-native:edgeorder:NotificationStageName")
class NotificationStageName(builtins.str, Enum):
    """
    Name of the stage.
    """
    SHIPPED = "Shipped"
    """
    Notification at order item shipped from microsoft datacenter.
    """
    DELIVERED = "Delivered"
    """
    Notification at order item delivered to customer.
    """


@pulumi.type_token("azure-native:edgeorder:OrderItemType")
class OrderItemType(builtins.str, Enum):
    """
    Order item type.
    """
    PURCHASE = "Purchase"
    """
    Purchase OrderItem.
    """
    RENTAL = "Rental"
    """
    Rental OrderItem.
    """
    EXTERNAL = "External"
    """
    Orders placed outside of azure.
    """


@pulumi.type_token("azure-native:edgeorder:OrderMode")
class OrderMode(builtins.str, Enum):
    """
    Defines the mode of the Order item.
    """
    DEFAULT = "Default"
    """
    Default Order mode.
    """
    DO_NOT_FULFILL = "DoNotFulfill"
    """
    Mode in which the Order will not be fulfilled.
    """


@pulumi.type_token("azure-native:edgeorder:SupportedFilterTypes")
class SupportedFilterTypes(builtins.str, Enum):
    """
    Type of product filter.
    """
    SHIP_TO_COUNTRIES = "ShipToCountries"
    """
    Ship to country.
    """
    DOUBLE_ENCRYPTION_STATUS = "DoubleEncryptionStatus"
    """
    Double encryption status.
    """


@pulumi.type_token("azure-native:edgeorder:TermCommitmentType")
class TermCommitmentType(builtins.str, Enum):
    """
    Term Commitment Type
    """
    NONE = "None"
    """
    Pay as you go Term Commitment Model.
    """
    TRIAL = "Trial"
    """
    Trial Term Commitment Model.
    """
    TIMED = "Timed"
    """
    Time based Term Commitment Model.
    """


@pulumi.type_token("azure-native:edgeorder:TransportShipmentTypes")
class TransportShipmentTypes(builtins.str, Enum):
    """
    Indicates Shipment Logistics type that the customer preferred.
    """
    CUSTOMER_MANAGED = "CustomerManaged"
    """
    Shipment Logistics is handled by the customer.
    """
    MICROSOFT_MANAGED = "MicrosoftManaged"
    """
    Shipment Logistics is handled by Microsoft.
    """
