# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'CompanyInfoArgs',
    'CompanyInfoArgsDict',
    'FilteringTagArgs',
    'FilteringTagArgsDict',
    'IdentityPropertiesArgs',
    'IdentityPropertiesArgsDict',
    'LogRulesArgs',
    'LogRulesArgsDict',
    'MonitorPropertiesArgs',
    'MonitorPropertiesArgsDict',
    'MonitoredSubscriptionArgs',
    'MonitoredSubscriptionArgsDict',
    'MonitoringTagRulesPropertiesArgs',
    'MonitoringTagRulesPropertiesArgsDict',
    'OpenAIIntegrationPropertiesArgs',
    'OpenAIIntegrationPropertiesArgsDict',
    'PlanDetailsArgs',
    'PlanDetailsArgsDict',
    'ResourceSkuArgs',
    'ResourceSkuArgsDict',
    'SubscriptionListArgs',
    'SubscriptionListArgsDict',
    'UserInfoArgs',
    'UserInfoArgsDict',
]

MYPY = False

if not MYPY:
    class CompanyInfoArgsDict(TypedDict):
        """
        Company information of the user to be passed to partners.
        """
        business: NotRequired[pulumi.Input[builtins.str]]
        """
        Business of the company
        """
        country: NotRequired[pulumi.Input[builtins.str]]
        """
        Country of the company location.
        """
        domain: NotRequired[pulumi.Input[builtins.str]]
        """
        Domain of the company
        """
        employees_number: NotRequired[pulumi.Input[builtins.str]]
        """
        Number of employees in the company
        """
        state: NotRequired[pulumi.Input[builtins.str]]
        """
        State of the company location.
        """
elif False:
    CompanyInfoArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class CompanyInfoArgs:
    def __init__(__self__, *,
                 business: Optional[pulumi.Input[builtins.str]] = None,
                 country: Optional[pulumi.Input[builtins.str]] = None,
                 domain: Optional[pulumi.Input[builtins.str]] = None,
                 employees_number: Optional[pulumi.Input[builtins.str]] = None,
                 state: Optional[pulumi.Input[builtins.str]] = None):
        """
        Company information of the user to be passed to partners.
        :param pulumi.Input[builtins.str] business: Business of the company
        :param pulumi.Input[builtins.str] country: Country of the company location.
        :param pulumi.Input[builtins.str] domain: Domain of the company
        :param pulumi.Input[builtins.str] employees_number: Number of employees in the company
        :param pulumi.Input[builtins.str] state: State of the company location.
        """
        if business is not None:
            pulumi.set(__self__, "business", business)
        if country is not None:
            pulumi.set(__self__, "country", country)
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if employees_number is not None:
            pulumi.set(__self__, "employees_number", employees_number)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter
    def business(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Business of the company
        """
        return pulumi.get(self, "business")

    @business.setter
    def business(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "business", value)

    @property
    @pulumi.getter
    def country(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Country of the company location.
        """
        return pulumi.get(self, "country")

    @country.setter
    def country(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "country", value)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Domain of the company
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter(name="employeesNumber")
    def employees_number(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Number of employees in the company
        """
        return pulumi.get(self, "employees_number")

    @employees_number.setter
    def employees_number(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "employees_number", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        State of the company location.
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "state", value)


if not MYPY:
    class FilteringTagArgsDict(TypedDict):
        """
        The definition of a filtering tag. Filtering tags are used for capturing resources and include/exclude them from being monitored.
        """
        action: NotRequired[pulumi.Input[Union[builtins.str, 'TagAction']]]
        """
        Valid actions for a filtering tag.
        """
        name: NotRequired[pulumi.Input[builtins.str]]
        """
        The name (also known as the key) of the tag.
        """
        value: NotRequired[pulumi.Input[builtins.str]]
        """
        The value of the tag.
        """
elif False:
    FilteringTagArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class FilteringTagArgs:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input[Union[builtins.str, 'TagAction']]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 value: Optional[pulumi.Input[builtins.str]] = None):
        """
        The definition of a filtering tag. Filtering tags are used for capturing resources and include/exclude them from being monitored.
        :param pulumi.Input[Union[builtins.str, 'TagAction']] action: Valid actions for a filtering tag.
        :param pulumi.Input[builtins.str] name: The name (also known as the key) of the tag.
        :param pulumi.Input[builtins.str] value: The value of the tag.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[Union[builtins.str, 'TagAction']]]:
        """
        Valid actions for a filtering tag.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[Union[builtins.str, 'TagAction']]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name (also known as the key) of the tag.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The value of the tag.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "value", value)


if not MYPY:
    class IdentityPropertiesArgsDict(TypedDict):
        """
        Identity properties.
        """
        type: NotRequired[pulumi.Input[Union[builtins.str, 'ManagedIdentityTypes']]]
        """
        Managed identity type.
        """
elif False:
    IdentityPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class IdentityPropertiesArgs:
    def __init__(__self__, *,
                 type: Optional[pulumi.Input[Union[builtins.str, 'ManagedIdentityTypes']]] = None):
        """
        Identity properties.
        :param pulumi.Input[Union[builtins.str, 'ManagedIdentityTypes']] type: Managed identity type.
        """
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[Union[builtins.str, 'ManagedIdentityTypes']]]:
        """
        Managed identity type.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[Union[builtins.str, 'ManagedIdentityTypes']]]):
        pulumi.set(self, "type", value)


if not MYPY:
    class LogRulesArgsDict(TypedDict):
        """
        Set of rules for sending logs for the Monitor resource.
        """
        filtering_tags: NotRequired[pulumi.Input[Sequence[pulumi.Input['FilteringTagArgsDict']]]]
        """
        List of filtering tags to be used for capturing logs. This only takes effect if SendActivityLogs flag is enabled. If empty, all resources will be captured. If only Exclude action is specified, the rules will apply to the list of all available resources. If Include actions are specified, the rules will only include resources with the associated tags.
        """
        send_aad_logs: NotRequired[pulumi.Input[builtins.bool]]
        """
        Flag specifying if AAD logs should be sent for the Monitor resource.
        """
        send_activity_logs: NotRequired[pulumi.Input[builtins.bool]]
        """
        Flag specifying if activity logs from Azure resources should be sent for the Monitor resource.
        """
        send_subscription_logs: NotRequired[pulumi.Input[builtins.bool]]
        """
        Flag specifying if subscription logs should be sent for the Monitor resource.
        """
elif False:
    LogRulesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class LogRulesArgs:
    def __init__(__self__, *,
                 filtering_tags: Optional[pulumi.Input[Sequence[pulumi.Input['FilteringTagArgs']]]] = None,
                 send_aad_logs: Optional[pulumi.Input[builtins.bool]] = None,
                 send_activity_logs: Optional[pulumi.Input[builtins.bool]] = None,
                 send_subscription_logs: Optional[pulumi.Input[builtins.bool]] = None):
        """
        Set of rules for sending logs for the Monitor resource.
        :param pulumi.Input[Sequence[pulumi.Input['FilteringTagArgs']]] filtering_tags: List of filtering tags to be used for capturing logs. This only takes effect if SendActivityLogs flag is enabled. If empty, all resources will be captured. If only Exclude action is specified, the rules will apply to the list of all available resources. If Include actions are specified, the rules will only include resources with the associated tags.
        :param pulumi.Input[builtins.bool] send_aad_logs: Flag specifying if AAD logs should be sent for the Monitor resource.
        :param pulumi.Input[builtins.bool] send_activity_logs: Flag specifying if activity logs from Azure resources should be sent for the Monitor resource.
        :param pulumi.Input[builtins.bool] send_subscription_logs: Flag specifying if subscription logs should be sent for the Monitor resource.
        """
        if filtering_tags is not None:
            pulumi.set(__self__, "filtering_tags", filtering_tags)
        if send_aad_logs is not None:
            pulumi.set(__self__, "send_aad_logs", send_aad_logs)
        if send_activity_logs is not None:
            pulumi.set(__self__, "send_activity_logs", send_activity_logs)
        if send_subscription_logs is not None:
            pulumi.set(__self__, "send_subscription_logs", send_subscription_logs)

    @property
    @pulumi.getter(name="filteringTags")
    def filtering_tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['FilteringTagArgs']]]]:
        """
        List of filtering tags to be used for capturing logs. This only takes effect if SendActivityLogs flag is enabled. If empty, all resources will be captured. If only Exclude action is specified, the rules will apply to the list of all available resources. If Include actions are specified, the rules will only include resources with the associated tags.
        """
        return pulumi.get(self, "filtering_tags")

    @filtering_tags.setter
    def filtering_tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['FilteringTagArgs']]]]):
        pulumi.set(self, "filtering_tags", value)

    @property
    @pulumi.getter(name="sendAadLogs")
    def send_aad_logs(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Flag specifying if AAD logs should be sent for the Monitor resource.
        """
        return pulumi.get(self, "send_aad_logs")

    @send_aad_logs.setter
    def send_aad_logs(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "send_aad_logs", value)

    @property
    @pulumi.getter(name="sendActivityLogs")
    def send_activity_logs(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Flag specifying if activity logs from Azure resources should be sent for the Monitor resource.
        """
        return pulumi.get(self, "send_activity_logs")

    @send_activity_logs.setter
    def send_activity_logs(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "send_activity_logs", value)

    @property
    @pulumi.getter(name="sendSubscriptionLogs")
    def send_subscription_logs(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Flag specifying if subscription logs should be sent for the Monitor resource.
        """
        return pulumi.get(self, "send_subscription_logs")

    @send_subscription_logs.setter
    def send_subscription_logs(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "send_subscription_logs", value)


if not MYPY:
    class MonitorPropertiesArgsDict(TypedDict):
        """
        Properties specific to the monitor resource.
        """
        generate_api_key: NotRequired[pulumi.Input[builtins.bool]]
        """
        Flag to determine if User API Key has to be generated and shared.
        """
        monitoring_status: NotRequired[pulumi.Input[Union[builtins.str, 'MonitoringStatus']]]
        """
        Flag specifying if the resource monitoring is enabled or disabled.
        """
        plan_details: NotRequired[pulumi.Input['PlanDetailsArgsDict']]
        """
        Plan details of the monitor resource.
        """
        provisioning_state: NotRequired[pulumi.Input[Union[builtins.str, 'ProvisioningState']]]
        """
        Provisioning state of the monitor resource.
        """
        saa_s_azure_subscription_status: NotRequired[pulumi.Input[builtins.str]]
        """
        Status of Azure Subscription where Marketplace SaaS is located.
        """
        source_campaign_id: NotRequired[pulumi.Input[builtins.str]]
        """
        A unique identifier associated with the campaign.
        """
        source_campaign_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Name of the marketing campaign.
        """
        subscription_state: NotRequired[pulumi.Input[builtins.str]]
        """
        State of the Azure Subscription containing the monitor resource
        """
        user_info: NotRequired[pulumi.Input['UserInfoArgsDict']]
        """
        User information.
        """
        version: NotRequired[pulumi.Input[builtins.str]]
        """
        Version of elastic of the monitor resource
        """
elif False:
    MonitorPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class MonitorPropertiesArgs:
    def __init__(__self__, *,
                 generate_api_key: Optional[pulumi.Input[builtins.bool]] = None,
                 monitoring_status: Optional[pulumi.Input[Union[builtins.str, 'MonitoringStatus']]] = None,
                 plan_details: Optional[pulumi.Input['PlanDetailsArgs']] = None,
                 provisioning_state: Optional[pulumi.Input[Union[builtins.str, 'ProvisioningState']]] = None,
                 saa_s_azure_subscription_status: Optional[pulumi.Input[builtins.str]] = None,
                 source_campaign_id: Optional[pulumi.Input[builtins.str]] = None,
                 source_campaign_name: Optional[pulumi.Input[builtins.str]] = None,
                 subscription_state: Optional[pulumi.Input[builtins.str]] = None,
                 user_info: Optional[pulumi.Input['UserInfoArgs']] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None):
        """
        Properties specific to the monitor resource.
        :param pulumi.Input[builtins.bool] generate_api_key: Flag to determine if User API Key has to be generated and shared.
        :param pulumi.Input[Union[builtins.str, 'MonitoringStatus']] monitoring_status: Flag specifying if the resource monitoring is enabled or disabled.
        :param pulumi.Input['PlanDetailsArgs'] plan_details: Plan details of the monitor resource.
        :param pulumi.Input[Union[builtins.str, 'ProvisioningState']] provisioning_state: Provisioning state of the monitor resource.
        :param pulumi.Input[builtins.str] saa_s_azure_subscription_status: Status of Azure Subscription where Marketplace SaaS is located.
        :param pulumi.Input[builtins.str] source_campaign_id: A unique identifier associated with the campaign.
        :param pulumi.Input[builtins.str] source_campaign_name: Name of the marketing campaign.
        :param pulumi.Input[builtins.str] subscription_state: State of the Azure Subscription containing the monitor resource
        :param pulumi.Input['UserInfoArgs'] user_info: User information.
        :param pulumi.Input[builtins.str] version: Version of elastic of the monitor resource
        """
        if generate_api_key is not None:
            pulumi.set(__self__, "generate_api_key", generate_api_key)
        if monitoring_status is not None:
            pulumi.set(__self__, "monitoring_status", monitoring_status)
        if plan_details is not None:
            pulumi.set(__self__, "plan_details", plan_details)
        if provisioning_state is not None:
            pulumi.set(__self__, "provisioning_state", provisioning_state)
        if saa_s_azure_subscription_status is not None:
            pulumi.set(__self__, "saa_s_azure_subscription_status", saa_s_azure_subscription_status)
        if source_campaign_id is not None:
            pulumi.set(__self__, "source_campaign_id", source_campaign_id)
        if source_campaign_name is not None:
            pulumi.set(__self__, "source_campaign_name", source_campaign_name)
        if subscription_state is not None:
            pulumi.set(__self__, "subscription_state", subscription_state)
        if user_info is not None:
            pulumi.set(__self__, "user_info", user_info)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="generateApiKey")
    def generate_api_key(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Flag to determine if User API Key has to be generated and shared.
        """
        return pulumi.get(self, "generate_api_key")

    @generate_api_key.setter
    def generate_api_key(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "generate_api_key", value)

    @property
    @pulumi.getter(name="monitoringStatus")
    def monitoring_status(self) -> Optional[pulumi.Input[Union[builtins.str, 'MonitoringStatus']]]:
        """
        Flag specifying if the resource monitoring is enabled or disabled.
        """
        return pulumi.get(self, "monitoring_status")

    @monitoring_status.setter
    def monitoring_status(self, value: Optional[pulumi.Input[Union[builtins.str, 'MonitoringStatus']]]):
        pulumi.set(self, "monitoring_status", value)

    @property
    @pulumi.getter(name="planDetails")
    def plan_details(self) -> Optional[pulumi.Input['PlanDetailsArgs']]:
        """
        Plan details of the monitor resource.
        """
        return pulumi.get(self, "plan_details")

    @plan_details.setter
    def plan_details(self, value: Optional[pulumi.Input['PlanDetailsArgs']]):
        pulumi.set(self, "plan_details", value)

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> Optional[pulumi.Input[Union[builtins.str, 'ProvisioningState']]]:
        """
        Provisioning state of the monitor resource.
        """
        return pulumi.get(self, "provisioning_state")

    @provisioning_state.setter
    def provisioning_state(self, value: Optional[pulumi.Input[Union[builtins.str, 'ProvisioningState']]]):
        pulumi.set(self, "provisioning_state", value)

    @property
    @pulumi.getter(name="saaSAzureSubscriptionStatus")
    def saa_s_azure_subscription_status(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Status of Azure Subscription where Marketplace SaaS is located.
        """
        return pulumi.get(self, "saa_s_azure_subscription_status")

    @saa_s_azure_subscription_status.setter
    def saa_s_azure_subscription_status(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "saa_s_azure_subscription_status", value)

    @property
    @pulumi.getter(name="sourceCampaignId")
    def source_campaign_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A unique identifier associated with the campaign.
        """
        return pulumi.get(self, "source_campaign_id")

    @source_campaign_id.setter
    def source_campaign_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "source_campaign_id", value)

    @property
    @pulumi.getter(name="sourceCampaignName")
    def source_campaign_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Name of the marketing campaign.
        """
        return pulumi.get(self, "source_campaign_name")

    @source_campaign_name.setter
    def source_campaign_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "source_campaign_name", value)

    @property
    @pulumi.getter(name="subscriptionState")
    def subscription_state(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        State of the Azure Subscription containing the monitor resource
        """
        return pulumi.get(self, "subscription_state")

    @subscription_state.setter
    def subscription_state(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "subscription_state", value)

    @property
    @pulumi.getter(name="userInfo")
    def user_info(self) -> Optional[pulumi.Input['UserInfoArgs']]:
        """
        User information.
        """
        return pulumi.get(self, "user_info")

    @user_info.setter
    def user_info(self, value: Optional[pulumi.Input['UserInfoArgs']]):
        pulumi.set(self, "user_info", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Version of elastic of the monitor resource
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)


if not MYPY:
    class MonitoredSubscriptionArgsDict(TypedDict):
        """
        The list of subscriptions and it's monitoring status by current Elastic monitor.
        """
        error: NotRequired[pulumi.Input[builtins.str]]
        """
        The reason of not monitoring the subscription.
        """
        status: NotRequired[pulumi.Input[Union[builtins.str, 'Status']]]
        """
        The state of monitoring.
        """
        subscription_id: NotRequired[pulumi.Input[builtins.str]]
        """
        The subscriptionId to be monitored.
        """
        tag_rules: NotRequired[pulumi.Input['MonitoringTagRulesPropertiesArgsDict']]
        """
        Definition of the properties for a TagRules resource.
        """
elif False:
    MonitoredSubscriptionArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class MonitoredSubscriptionArgs:
    def __init__(__self__, *,
                 error: Optional[pulumi.Input[builtins.str]] = None,
                 status: Optional[pulumi.Input[Union[builtins.str, 'Status']]] = None,
                 subscription_id: Optional[pulumi.Input[builtins.str]] = None,
                 tag_rules: Optional[pulumi.Input['MonitoringTagRulesPropertiesArgs']] = None):
        """
        The list of subscriptions and it's monitoring status by current Elastic monitor.
        :param pulumi.Input[builtins.str] error: The reason of not monitoring the subscription.
        :param pulumi.Input[Union[builtins.str, 'Status']] status: The state of monitoring.
        :param pulumi.Input[builtins.str] subscription_id: The subscriptionId to be monitored.
        :param pulumi.Input['MonitoringTagRulesPropertiesArgs'] tag_rules: Definition of the properties for a TagRules resource.
        """
        if error is not None:
            pulumi.set(__self__, "error", error)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if subscription_id is not None:
            pulumi.set(__self__, "subscription_id", subscription_id)
        if tag_rules is not None:
            pulumi.set(__self__, "tag_rules", tag_rules)

    @property
    @pulumi.getter
    def error(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The reason of not monitoring the subscription.
        """
        return pulumi.get(self, "error")

    @error.setter
    def error(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "error", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[Union[builtins.str, 'Status']]]:
        """
        The state of monitoring.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[Union[builtins.str, 'Status']]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="subscriptionId")
    def subscription_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The subscriptionId to be monitored.
        """
        return pulumi.get(self, "subscription_id")

    @subscription_id.setter
    def subscription_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "subscription_id", value)

    @property
    @pulumi.getter(name="tagRules")
    def tag_rules(self) -> Optional[pulumi.Input['MonitoringTagRulesPropertiesArgs']]:
        """
        Definition of the properties for a TagRules resource.
        """
        return pulumi.get(self, "tag_rules")

    @tag_rules.setter
    def tag_rules(self, value: Optional[pulumi.Input['MonitoringTagRulesPropertiesArgs']]):
        pulumi.set(self, "tag_rules", value)


if not MYPY:
    class MonitoringTagRulesPropertiesArgsDict(TypedDict):
        """
        Definition of the properties for a TagRules resource.
        """
        log_rules: NotRequired[pulumi.Input['LogRulesArgsDict']]
        """
        Rules for sending logs.
        """
        provisioning_state: NotRequired[pulumi.Input[Union[builtins.str, 'ProvisioningState']]]
        """
        Provisioning state of the monitoring tag rules.
        """
elif False:
    MonitoringTagRulesPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class MonitoringTagRulesPropertiesArgs:
    def __init__(__self__, *,
                 log_rules: Optional[pulumi.Input['LogRulesArgs']] = None,
                 provisioning_state: Optional[pulumi.Input[Union[builtins.str, 'ProvisioningState']]] = None):
        """
        Definition of the properties for a TagRules resource.
        :param pulumi.Input['LogRulesArgs'] log_rules: Rules for sending logs.
        :param pulumi.Input[Union[builtins.str, 'ProvisioningState']] provisioning_state: Provisioning state of the monitoring tag rules.
        """
        if log_rules is not None:
            pulumi.set(__self__, "log_rules", log_rules)
        if provisioning_state is not None:
            pulumi.set(__self__, "provisioning_state", provisioning_state)

    @property
    @pulumi.getter(name="logRules")
    def log_rules(self) -> Optional[pulumi.Input['LogRulesArgs']]:
        """
        Rules for sending logs.
        """
        return pulumi.get(self, "log_rules")

    @log_rules.setter
    def log_rules(self, value: Optional[pulumi.Input['LogRulesArgs']]):
        pulumi.set(self, "log_rules", value)

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> Optional[pulumi.Input[Union[builtins.str, 'ProvisioningState']]]:
        """
        Provisioning state of the monitoring tag rules.
        """
        return pulumi.get(self, "provisioning_state")

    @provisioning_state.setter
    def provisioning_state(self, value: Optional[pulumi.Input[Union[builtins.str, 'ProvisioningState']]]):
        pulumi.set(self, "provisioning_state", value)


if not MYPY:
    class OpenAIIntegrationPropertiesArgsDict(TypedDict):
        """
        Open AI Integration details.
        """
        key: NotRequired[pulumi.Input[builtins.str]]
        """
        Value of API key for Open AI resource
        """
        open_ai_resource_endpoint: NotRequired[pulumi.Input[builtins.str]]
        """
        The API endpoint for Open AI resource
        """
        open_ai_resource_id: NotRequired[pulumi.Input[builtins.str]]
        """
        The resource name of Open AI resource
        """
elif False:
    OpenAIIntegrationPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class OpenAIIntegrationPropertiesArgs:
    def __init__(__self__, *,
                 key: Optional[pulumi.Input[builtins.str]] = None,
                 open_ai_resource_endpoint: Optional[pulumi.Input[builtins.str]] = None,
                 open_ai_resource_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Open AI Integration details.
        :param pulumi.Input[builtins.str] key: Value of API key for Open AI resource
        :param pulumi.Input[builtins.str] open_ai_resource_endpoint: The API endpoint for Open AI resource
        :param pulumi.Input[builtins.str] open_ai_resource_id: The resource name of Open AI resource
        """
        if key is not None:
            pulumi.set(__self__, "key", key)
        if open_ai_resource_endpoint is not None:
            pulumi.set(__self__, "open_ai_resource_endpoint", open_ai_resource_endpoint)
        if open_ai_resource_id is not None:
            pulumi.set(__self__, "open_ai_resource_id", open_ai_resource_id)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Value of API key for Open AI resource
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter(name="openAIResourceEndpoint")
    def open_ai_resource_endpoint(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The API endpoint for Open AI resource
        """
        return pulumi.get(self, "open_ai_resource_endpoint")

    @open_ai_resource_endpoint.setter
    def open_ai_resource_endpoint(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "open_ai_resource_endpoint", value)

    @property
    @pulumi.getter(name="openAIResourceId")
    def open_ai_resource_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The resource name of Open AI resource
        """
        return pulumi.get(self, "open_ai_resource_id")

    @open_ai_resource_id.setter
    def open_ai_resource_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "open_ai_resource_id", value)


if not MYPY:
    class PlanDetailsArgsDict(TypedDict):
        """
        Plan details of the monitor resource.
        """
        offer_id: NotRequired[pulumi.Input[builtins.str]]
        """
        Offer ID of the plan
        """
        plan_id: NotRequired[pulumi.Input[builtins.str]]
        """
        Plan ID
        """
        plan_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Plan Name
        """
        publisher_id: NotRequired[pulumi.Input[builtins.str]]
        """
        Publisher ID of the plan
        """
        term_id: NotRequired[pulumi.Input[builtins.str]]
        """
        Term ID of the plan
        """
elif False:
    PlanDetailsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class PlanDetailsArgs:
    def __init__(__self__, *,
                 offer_id: Optional[pulumi.Input[builtins.str]] = None,
                 plan_id: Optional[pulumi.Input[builtins.str]] = None,
                 plan_name: Optional[pulumi.Input[builtins.str]] = None,
                 publisher_id: Optional[pulumi.Input[builtins.str]] = None,
                 term_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Plan details of the monitor resource.
        :param pulumi.Input[builtins.str] offer_id: Offer ID of the plan
        :param pulumi.Input[builtins.str] plan_id: Plan ID
        :param pulumi.Input[builtins.str] plan_name: Plan Name
        :param pulumi.Input[builtins.str] publisher_id: Publisher ID of the plan
        :param pulumi.Input[builtins.str] term_id: Term ID of the plan
        """
        if offer_id is not None:
            pulumi.set(__self__, "offer_id", offer_id)
        if plan_id is not None:
            pulumi.set(__self__, "plan_id", plan_id)
        if plan_name is not None:
            pulumi.set(__self__, "plan_name", plan_name)
        if publisher_id is not None:
            pulumi.set(__self__, "publisher_id", publisher_id)
        if term_id is not None:
            pulumi.set(__self__, "term_id", term_id)

    @property
    @pulumi.getter(name="offerID")
    def offer_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Offer ID of the plan
        """
        return pulumi.get(self, "offer_id")

    @offer_id.setter
    def offer_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "offer_id", value)

    @property
    @pulumi.getter(name="planID")
    def plan_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Plan ID
        """
        return pulumi.get(self, "plan_id")

    @plan_id.setter
    def plan_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "plan_id", value)

    @property
    @pulumi.getter(name="planName")
    def plan_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Plan Name
        """
        return pulumi.get(self, "plan_name")

    @plan_name.setter
    def plan_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "plan_name", value)

    @property
    @pulumi.getter(name="publisherID")
    def publisher_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Publisher ID of the plan
        """
        return pulumi.get(self, "publisher_id")

    @publisher_id.setter
    def publisher_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "publisher_id", value)

    @property
    @pulumi.getter(name="termID")
    def term_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Term ID of the plan
        """
        return pulumi.get(self, "term_id")

    @term_id.setter
    def term_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "term_id", value)


if not MYPY:
    class ResourceSkuArgsDict(TypedDict):
        """
        Microsoft.Elastic SKU.
        """
        name: pulumi.Input[builtins.str]
        """
        Name of the SKU.
        """
elif False:
    ResourceSkuArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ResourceSkuArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[builtins.str]):
        """
        Microsoft.Elastic SKU.
        :param pulumi.Input[builtins.str] name: Name of the SKU.
        """
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[builtins.str]:
        """
        Name of the SKU.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "name", value)


if not MYPY:
    class SubscriptionListArgsDict(TypedDict):
        """
        The request to update subscriptions needed to be monitored by the Elastic monitor resource.
        """
        monitored_subscription_list: NotRequired[pulumi.Input[Sequence[pulumi.Input['MonitoredSubscriptionArgsDict']]]]
        """
        List of subscriptions and the state of the monitoring.
        """
        operation: NotRequired[pulumi.Input[Union[builtins.str, 'Operation']]]
        """
        The operation for the patch on the resource.
        """
elif False:
    SubscriptionListArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class SubscriptionListArgs:
    def __init__(__self__, *,
                 monitored_subscription_list: Optional[pulumi.Input[Sequence[pulumi.Input['MonitoredSubscriptionArgs']]]] = None,
                 operation: Optional[pulumi.Input[Union[builtins.str, 'Operation']]] = None):
        """
        The request to update subscriptions needed to be monitored by the Elastic monitor resource.
        :param pulumi.Input[Sequence[pulumi.Input['MonitoredSubscriptionArgs']]] monitored_subscription_list: List of subscriptions and the state of the monitoring.
        :param pulumi.Input[Union[builtins.str, 'Operation']] operation: The operation for the patch on the resource.
        """
        if monitored_subscription_list is not None:
            pulumi.set(__self__, "monitored_subscription_list", monitored_subscription_list)
        if operation is not None:
            pulumi.set(__self__, "operation", operation)

    @property
    @pulumi.getter(name="monitoredSubscriptionList")
    def monitored_subscription_list(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['MonitoredSubscriptionArgs']]]]:
        """
        List of subscriptions and the state of the monitoring.
        """
        return pulumi.get(self, "monitored_subscription_list")

    @monitored_subscription_list.setter
    def monitored_subscription_list(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['MonitoredSubscriptionArgs']]]]):
        pulumi.set(self, "monitored_subscription_list", value)

    @property
    @pulumi.getter
    def operation(self) -> Optional[pulumi.Input[Union[builtins.str, 'Operation']]]:
        """
        The operation for the patch on the resource.
        """
        return pulumi.get(self, "operation")

    @operation.setter
    def operation(self, value: Optional[pulumi.Input[Union[builtins.str, 'Operation']]]):
        pulumi.set(self, "operation", value)


if not MYPY:
    class UserInfoArgsDict(TypedDict):
        """
        User Information to be passed to partners.
        """
        company_info: NotRequired[pulumi.Input['CompanyInfoArgsDict']]
        """
        Company information of the user to be passed to partners.
        """
        company_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Company name of the user
        """
        email_address: NotRequired[pulumi.Input[builtins.str]]
        """
        Email of the user used by Elastic for contacting them if needed
        """
        first_name: NotRequired[pulumi.Input[builtins.str]]
        """
        First name of the user
        """
        last_name: NotRequired[pulumi.Input[builtins.str]]
        """
        Last name of the user
        """
elif False:
    UserInfoArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class UserInfoArgs:
    def __init__(__self__, *,
                 company_info: Optional[pulumi.Input['CompanyInfoArgs']] = None,
                 company_name: Optional[pulumi.Input[builtins.str]] = None,
                 email_address: Optional[pulumi.Input[builtins.str]] = None,
                 first_name: Optional[pulumi.Input[builtins.str]] = None,
                 last_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        User Information to be passed to partners.
        :param pulumi.Input['CompanyInfoArgs'] company_info: Company information of the user to be passed to partners.
        :param pulumi.Input[builtins.str] company_name: Company name of the user
        :param pulumi.Input[builtins.str] email_address: Email of the user used by Elastic for contacting them if needed
        :param pulumi.Input[builtins.str] first_name: First name of the user
        :param pulumi.Input[builtins.str] last_name: Last name of the user
        """
        if company_info is not None:
            pulumi.set(__self__, "company_info", company_info)
        if company_name is not None:
            pulumi.set(__self__, "company_name", company_name)
        if email_address is not None:
            pulumi.set(__self__, "email_address", email_address)
        if first_name is not None:
            pulumi.set(__self__, "first_name", first_name)
        if last_name is not None:
            pulumi.set(__self__, "last_name", last_name)

    @property
    @pulumi.getter(name="companyInfo")
    def company_info(self) -> Optional[pulumi.Input['CompanyInfoArgs']]:
        """
        Company information of the user to be passed to partners.
        """
        return pulumi.get(self, "company_info")

    @company_info.setter
    def company_info(self, value: Optional[pulumi.Input['CompanyInfoArgs']]):
        pulumi.set(self, "company_info", value)

    @property
    @pulumi.getter(name="companyName")
    def company_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Company name of the user
        """
        return pulumi.get(self, "company_name")

    @company_name.setter
    def company_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "company_name", value)

    @property
    @pulumi.getter(name="emailAddress")
    def email_address(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Email of the user used by Elastic for contacting them if needed
        """
        return pulumi.get(self, "email_address")

    @email_address.setter
    def email_address(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "email_address", value)

    @property
    @pulumi.getter(name="firstName")
    def first_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        First name of the user
        """
        return pulumi.get(self, "first_name")

    @first_name.setter
    def first_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "first_name", value)

    @property
    @pulumi.getter(name="lastName")
    def last_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Last name of the user
        """
        return pulumi.get(self, "last_name")

    @last_name.setter
    def last_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "last_name", value)


