# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetBillingInfoResult',
    'AwaitableGetBillingInfoResult',
    'get_billing_info',
    'get_billing_info_output',
]

@pulumi.output_type
class GetBillingInfoResult:
    """
    Marketplace Subscription and Organization details to which resource gets billed into.
    """
    def __init__(__self__, marketplace_saas_info=None, partner_billing_entity=None):
        if marketplace_saas_info and not isinstance(marketplace_saas_info, dict):
            raise TypeError("Expected argument 'marketplace_saas_info' to be a dict")
        pulumi.set(__self__, "marketplace_saas_info", marketplace_saas_info)
        if partner_billing_entity and not isinstance(partner_billing_entity, dict):
            raise TypeError("Expected argument 'partner_billing_entity' to be a dict")
        pulumi.set(__self__, "partner_billing_entity", partner_billing_entity)

    @property
    @pulumi.getter(name="marketplaceSaasInfo")
    def marketplace_saas_info(self) -> Optional['outputs.MarketplaceSaaSInfoResponse']:
        """
        Marketplace Subscription details
        """
        return pulumi.get(self, "marketplace_saas_info")

    @property
    @pulumi.getter(name="partnerBillingEntity")
    def partner_billing_entity(self) -> Optional['outputs.PartnerBillingEntityResponse']:
        """
        Partner Billing Entity details: Organization Info
        """
        return pulumi.get(self, "partner_billing_entity")


class AwaitableGetBillingInfoResult(GetBillingInfoResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBillingInfoResult(
            marketplace_saas_info=self.marketplace_saas_info,
            partner_billing_entity=self.partner_billing_entity)


def get_billing_info(monitor_name: Optional[builtins.str] = None,
                     resource_group_name: Optional[builtins.str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBillingInfoResult:
    """
    Marketplace Subscription and Organization details to which resource gets billed into.

    Uses Azure REST API version 2024-03-01.

    Other available API versions: 2023-07-01-preview, 2023-10-01-preview, 2023-11-01-preview, 2024-01-01-preview, 2024-05-01-preview, 2024-06-15-preview, 2024-10-01-preview, 2025-01-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native elastic [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str monitor_name: Monitor resource name
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['monitorName'] = monitor_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:elastic:getBillingInfo', __args__, opts=opts, typ=GetBillingInfoResult).value

    return AwaitableGetBillingInfoResult(
        marketplace_saas_info=pulumi.get(__ret__, 'marketplace_saas_info'),
        partner_billing_entity=pulumi.get(__ret__, 'partner_billing_entity'))
def get_billing_info_output(monitor_name: Optional[pulumi.Input[builtins.str]] = None,
                            resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetBillingInfoResult]:
    """
    Marketplace Subscription and Organization details to which resource gets billed into.

    Uses Azure REST API version 2024-03-01.

    Other available API versions: 2023-07-01-preview, 2023-10-01-preview, 2023-11-01-preview, 2024-01-01-preview, 2024-05-01-preview, 2024-06-15-preview, 2024-10-01-preview, 2025-01-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native elastic [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str monitor_name: Monitor resource name
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['monitorName'] = monitor_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:elastic:getBillingInfo', __args__, opts=opts, typ=GetBillingInfoResult)
    return __ret__.apply(lambda __response__: GetBillingInfoResult(
        marketplace_saas_info=pulumi.get(__response__, 'marketplace_saas_info'),
        partner_billing_entity=pulumi.get(__response__, 'partner_billing_entity')))
