# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListAllTrafficFilterResult',
    'AwaitableListAllTrafficFilterResult',
    'list_all_traffic_filter',
    'list_all_traffic_filter_output',
]

@pulumi.output_type
class ListAllTrafficFilterResult:
    """
    List of elastic traffic filters in the account
    """
    def __init__(__self__, rulesets=None):
        if rulesets and not isinstance(rulesets, list):
            raise TypeError("Expected argument 'rulesets' to be a list")
        pulumi.set(__self__, "rulesets", rulesets)

    @property
    @pulumi.getter
    def rulesets(self) -> Optional[Sequence['outputs.ElasticTrafficFilterResponse']]:
        """
        List of elastic traffic filters in the account
        """
        return pulumi.get(self, "rulesets")


class AwaitableListAllTrafficFilterResult(ListAllTrafficFilterResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListAllTrafficFilterResult(
            rulesets=self.rulesets)


def list_all_traffic_filter(monitor_name: Optional[builtins.str] = None,
                            resource_group_name: Optional[builtins.str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListAllTrafficFilterResult:
    """
    List of elastic traffic filters in the account

    Uses Azure REST API version 2024-03-01.

    Other available API versions: 2023-06-01, 2023-06-15-preview, 2023-07-01-preview, 2023-10-01-preview, 2023-11-01-preview, 2024-01-01-preview, 2024-05-01-preview, 2024-06-15-preview, 2024-10-01-preview, 2025-01-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native elastic [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str monitor_name: Monitor resource name
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['monitorName'] = monitor_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:elastic:listAllTrafficFilter', __args__, opts=opts, typ=ListAllTrafficFilterResult).value

    return AwaitableListAllTrafficFilterResult(
        rulesets=pulumi.get(__ret__, 'rulesets'))
def list_all_traffic_filter_output(monitor_name: Optional[pulumi.Input[builtins.str]] = None,
                                   resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                   opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListAllTrafficFilterResult]:
    """
    List of elastic traffic filters in the account

    Uses Azure REST API version 2024-03-01.

    Other available API versions: 2023-06-01, 2023-06-15-preview, 2023-07-01-preview, 2023-10-01-preview, 2023-11-01-preview, 2024-01-01-preview, 2024-05-01-preview, 2024-06-15-preview, 2024-10-01-preview, 2025-01-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native elastic [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str monitor_name: Monitor resource name
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['monitorName'] = monitor_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:elastic:listAllTrafficFilter', __args__, opts=opts, typ=ListAllTrafficFilterResult)
    return __ret__.apply(lambda __response__: ListAllTrafficFilterResult(
        rulesets=pulumi.get(__response__, 'rulesets')))
