# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AdvancedFilterOperatorType',
    'ChannelProvisioningState',
    'ChannelType',
    'ClientCertificateValidationScheme',
    'ClientState',
    'CustomDomainIdentityType',
    'CustomDomainValidationState',
    'DataResidencyBoundary',
    'DeadLetterEndPointType',
    'DeliveryAttributeMappingType',
    'DeliveryMode',
    'DeliverySchema',
    'EndpointType',
    'EventDefinitionKind',
    'EventDeliverySchema',
    'EventInputSchema',
    'EventSubscriptionIdentityType',
    'FilterOperatorType',
    'IdentityType',
    'InputSchema',
    'InputSchemaMappingType',
    'IpActionType',
    'MonitorAlertSeverity',
    'PartnerConfigurationProvisioningState',
    'PartnerDestinationActivationState',
    'PartnerTopicActivationState',
    'PartnerTopicRoutingMode',
    'PermissionType',
    'PersistedConnectionStatus',
    'PublicNetworkAccess',
    'PublisherType',
    'ReadinessState',
    'ResourceProvisioningState',
    'RoutingIdentityType',
    'SkuName',
    'StaticRoutingEnrichmentType',
    'TlsVersion',
    'TopicSpacesConfigurationState',
]


@pulumi.type_token("azure-native:eventgrid:AdvancedFilterOperatorType")
class AdvancedFilterOperatorType(builtins.str, Enum):
    """
    The operator type used for filtering, e.g., NumberIn, StringContains, BoolEquals and others.
    """
    NUMBER_IN = "NumberIn"
    NUMBER_NOT_IN = "NumberNotIn"
    NUMBER_LESS_THAN = "NumberLessThan"
    NUMBER_GREATER_THAN = "NumberGreaterThan"
    NUMBER_LESS_THAN_OR_EQUALS = "NumberLessThanOrEquals"
    NUMBER_GREATER_THAN_OR_EQUALS = "NumberGreaterThanOrEquals"
    BOOL_EQUALS = "BoolEquals"
    STRING_IN = "StringIn"
    STRING_NOT_IN = "StringNotIn"
    STRING_BEGINS_WITH = "StringBeginsWith"
    STRING_ENDS_WITH = "StringEndsWith"
    STRING_CONTAINS = "StringContains"
    NUMBER_IN_RANGE = "NumberInRange"
    NUMBER_NOT_IN_RANGE = "NumberNotInRange"
    STRING_NOT_BEGINS_WITH = "StringNotBeginsWith"
    STRING_NOT_ENDS_WITH = "StringNotEndsWith"
    STRING_NOT_CONTAINS = "StringNotContains"
    IS_NULL_OR_UNDEFINED = "IsNullOrUndefined"
    IS_NOT_NULL = "IsNotNull"


@pulumi.type_token("azure-native:eventgrid:ChannelProvisioningState")
class ChannelProvisioningState(builtins.str, Enum):
    """
    Provisioning state of the channel.
    """
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    SUCCEEDED = "Succeeded"
    CANCELED = "Canceled"
    FAILED = "Failed"
    IDLE_DUE_TO_MIRRORED_PARTNER_TOPIC_DELETION = "IdleDueToMirroredPartnerTopicDeletion"


@pulumi.type_token("azure-native:eventgrid:ChannelType")
class ChannelType(builtins.str, Enum):
    """
    The type of the event channel which represents the direction flow of events.
    """
    PARTNER_TOPIC = "PartnerTopic"


@pulumi.type_token("azure-native:eventgrid:ClientCertificateValidationScheme")
class ClientCertificateValidationScheme(builtins.str, Enum):
    """
    The validation scheme used to authenticate the client. Default value is SubjectMatchesAuthenticationName.
    """
    SUBJECT_MATCHES_AUTHENTICATION_NAME = "SubjectMatchesAuthenticationName"
    DNS_MATCHES_AUTHENTICATION_NAME = "DnsMatchesAuthenticationName"
    URI_MATCHES_AUTHENTICATION_NAME = "UriMatchesAuthenticationName"
    IP_MATCHES_AUTHENTICATION_NAME = "IpMatchesAuthenticationName"
    EMAIL_MATCHES_AUTHENTICATION_NAME = "EmailMatchesAuthenticationName"
    THUMBPRINT_MATCH = "ThumbprintMatch"


@pulumi.type_token("azure-native:eventgrid:ClientState")
class ClientState(builtins.str, Enum):
    """
    Indicates if the client is enabled or not. Default value is Enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:eventgrid:CustomDomainIdentityType")
class CustomDomainIdentityType(builtins.str, Enum):
    """
    The type of managed identity used. Can be either 'SystemAssigned' or 'UserAssigned'.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"


@pulumi.type_token("azure-native:eventgrid:CustomDomainValidationState")
class CustomDomainValidationState(builtins.str, Enum):
    """
    Validation state for the custom domain. This is a read only property and is initially set to 'Pending' and will be updated to 'Approved' by Event Grid only after ownership of the domain name has been successfully validated.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    ERROR_RETRIEVING_DNS_RECORD = "ErrorRetrievingDnsRecord"


@pulumi.type_token("azure-native:eventgrid:DataResidencyBoundary")
class DataResidencyBoundary(builtins.str, Enum):
    """
    Data Residency Boundary of the resource.
    """
    WITHIN_GEOPAIR = "WithinGeopair"
    WITHIN_REGION = "WithinRegion"


@pulumi.type_token("azure-native:eventgrid:DeadLetterEndPointType")
class DeadLetterEndPointType(builtins.str, Enum):
    """
    Type of the endpoint for the dead letter destination
    """
    STORAGE_BLOB = "StorageBlob"


@pulumi.type_token("azure-native:eventgrid:DeliveryAttributeMappingType")
class DeliveryAttributeMappingType(builtins.str, Enum):
    """
    Type of the delivery attribute or header name.
    """
    STATIC = "Static"
    DYNAMIC = "Dynamic"


@pulumi.type_token("azure-native:eventgrid:DeliveryMode")
class DeliveryMode(builtins.str, Enum):
    """
    Delivery mode of the event subscription.
    """
    QUEUE = "Queue"
    PUSH = "Push"


@pulumi.type_token("azure-native:eventgrid:DeliverySchema")
class DeliverySchema(builtins.str, Enum):
    """
    The event delivery schema for the event subscription.
    """
    CLOUD_EVENT_SCHEMA_V1_0 = "CloudEventSchemaV1_0"


@pulumi.type_token("azure-native:eventgrid:EndpointType")
class EndpointType(builtins.str, Enum):
    """
    Type of the endpoint for the event subscription destination.
    """
    WEB_HOOK = "WebHook"
    EVENT_HUB = "EventHub"
    STORAGE_QUEUE = "StorageQueue"
    HYBRID_CONNECTION = "HybridConnection"
    SERVICE_BUS_QUEUE = "ServiceBusQueue"
    SERVICE_BUS_TOPIC = "ServiceBusTopic"
    AZURE_FUNCTION = "AzureFunction"
    MONITOR_ALERT = "MonitorAlert"
    NAMESPACE_TOPIC = "NamespaceTopic"


@pulumi.type_token("azure-native:eventgrid:EventDefinitionKind")
class EventDefinitionKind(builtins.str, Enum):
    """
    The kind of event type used.
    """
    INLINE = "Inline"


@pulumi.type_token("azure-native:eventgrid:EventDeliverySchema")
class EventDeliverySchema(builtins.str, Enum):
    """
    The event delivery schema for the event subscription.
    """
    EVENT_GRID_SCHEMA = "EventGridSchema"
    CUSTOM_INPUT_SCHEMA = "CustomInputSchema"
    CLOUD_EVENT_SCHEMA_V1_0 = "CloudEventSchemaV1_0"


@pulumi.type_token("azure-native:eventgrid:EventInputSchema")
class EventInputSchema(builtins.str, Enum):
    """
    This determines the format that is expected for incoming events published to the topic.
    """
    CLOUD_EVENT_SCHEMA_V1_0 = "CloudEventSchemaV1_0"


@pulumi.type_token("azure-native:eventgrid:EventSubscriptionIdentityType")
class EventSubscriptionIdentityType(builtins.str, Enum):
    """
    The type of managed identity used. Can be either 'SystemAssigned' or 'UserAssigned'.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"


@pulumi.type_token("azure-native:eventgrid:FilterOperatorType")
class FilterOperatorType(builtins.str, Enum):
    """
    The operator type used for filtering, e.g., NumberIn, StringContains, BoolEquals and others.
    """
    NUMBER_IN = "NumberIn"
    NUMBER_NOT_IN = "NumberNotIn"
    NUMBER_LESS_THAN = "NumberLessThan"
    NUMBER_GREATER_THAN = "NumberGreaterThan"
    NUMBER_LESS_THAN_OR_EQUALS = "NumberLessThanOrEquals"
    NUMBER_GREATER_THAN_OR_EQUALS = "NumberGreaterThanOrEquals"
    BOOL_EQUALS = "BoolEquals"
    STRING_IN = "StringIn"
    STRING_NOT_IN = "StringNotIn"
    STRING_BEGINS_WITH = "StringBeginsWith"
    STRING_ENDS_WITH = "StringEndsWith"
    STRING_CONTAINS = "StringContains"
    NUMBER_IN_RANGE = "NumberInRange"
    NUMBER_NOT_IN_RANGE = "NumberNotInRange"
    STRING_NOT_BEGINS_WITH = "StringNotBeginsWith"
    STRING_NOT_ENDS_WITH = "StringNotEndsWith"
    STRING_NOT_CONTAINS = "StringNotContains"
    IS_NULL_OR_UNDEFINED = "IsNullOrUndefined"
    IS_NOT_NULL = "IsNotNull"


@pulumi.type_token("azure-native:eventgrid:IdentityType")
class IdentityType(builtins.str, Enum):
    """
    The type of managed identity used. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user-assigned identities. The type 'None' will remove any identity.
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


@pulumi.type_token("azure-native:eventgrid:InputSchema")
class InputSchema(builtins.str, Enum):
    """
    This determines the format that Event Grid should expect for incoming events published to the topic.
    """
    EVENT_GRID_SCHEMA = "EventGridSchema"
    CUSTOM_EVENT_SCHEMA = "CustomEventSchema"
    CLOUD_EVENT_SCHEMA_V1_0 = "CloudEventSchemaV1_0"


@pulumi.type_token("azure-native:eventgrid:InputSchemaMappingType")
class InputSchemaMappingType(builtins.str, Enum):
    """
    Type of the custom mapping
    """
    JSON = "Json"


@pulumi.type_token("azure-native:eventgrid:IpActionType")
class IpActionType(builtins.str, Enum):
    """
    Action to perform based on the match or no match of the IpMask.
    """
    ALLOW = "Allow"


@pulumi.type_token("azure-native:eventgrid:MonitorAlertSeverity")
class MonitorAlertSeverity(builtins.str, Enum):
    """
    The severity that will be attached to every Alert fired through this event subscription.
    This field must be provided.
    """
    SEV0 = "Sev0"
    SEV1 = "Sev1"
    SEV2 = "Sev2"
    SEV3 = "Sev3"
    SEV4 = "Sev4"


@pulumi.type_token("azure-native:eventgrid:PartnerConfigurationProvisioningState")
class PartnerConfigurationProvisioningState(builtins.str, Enum):
    """
    Provisioning state of the partner configuration.
    """
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    SUCCEEDED = "Succeeded"
    CANCELED = "Canceled"
    FAILED = "Failed"


@pulumi.type_token("azure-native:eventgrid:PartnerDestinationActivationState")
class PartnerDestinationActivationState(builtins.str, Enum):
    """
    Activation state of the partner destination.
    """
    NEVER_ACTIVATED = "NeverActivated"
    ACTIVATED = "Activated"


@pulumi.type_token("azure-native:eventgrid:PartnerTopicActivationState")
class PartnerTopicActivationState(builtins.str, Enum):
    """
    Activation state of the partner topic.
    """
    NEVER_ACTIVATED = "NeverActivated"
    ACTIVATED = "Activated"
    DEACTIVATED = "Deactivated"


@pulumi.type_token("azure-native:eventgrid:PartnerTopicRoutingMode")
class PartnerTopicRoutingMode(builtins.str, Enum):
    """
    This determines if events published to this partner namespace should use the source attribute in the event payload
    or use the channel name in the header when matching to the partner topic. If none is specified, source attribute routing will be used to match the partner topic.
    """
    SOURCE_EVENT_ATTRIBUTE = "SourceEventAttribute"
    CHANNEL_NAME_HEADER = "ChannelNameHeader"


@pulumi.type_token("azure-native:eventgrid:PermissionType")
class PermissionType(builtins.str, Enum):
    """
    The allowed permission.
    """
    PUBLISHER = "Publisher"
    SUBSCRIBER = "Subscriber"


@pulumi.type_token("azure-native:eventgrid:PersistedConnectionStatus")
class PersistedConnectionStatus(builtins.str, Enum):
    """
    Status of the connection.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"
    DISCONNECTED = "Disconnected"


@pulumi.type_token("azure-native:eventgrid:PublicNetworkAccess")
class PublicNetworkAccess(builtins.str, Enum):
    """
    This determines if traffic is allowed over public network. By default it is enabled. 
    You can further restrict to specific IPs by configuring <seealso cref="P:Microsoft.Azure.Events.ResourceProvider.Common.Contracts.TopicProperties.InboundIpRules" />
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:eventgrid:PublisherType")
class PublisherType(builtins.str, Enum):
    """
    Publisher type of the namespace topic.
    """
    CUSTOM = "Custom"


@pulumi.type_token("azure-native:eventgrid:ReadinessState")
class ReadinessState(builtins.str, Enum):
    """
    The readiness state of the corresponding partner topic.
    """
    NEVER_ACTIVATED = "NeverActivated"
    ACTIVATED = "Activated"


@pulumi.type_token("azure-native:eventgrid:ResourceProvisioningState")
class ResourceProvisioningState(builtins.str, Enum):
    """
    Provisioning state of the Private Endpoint Connection.
    """
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    SUCCEEDED = "Succeeded"
    CANCELED = "Canceled"
    FAILED = "Failed"


@pulumi.type_token("azure-native:eventgrid:RoutingIdentityType")
class RoutingIdentityType(builtins.str, Enum):
    """
    Routing identity type for topic spaces configuration.
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"


@pulumi.type_token("azure-native:eventgrid:SkuName")
class SkuName(builtins.str, Enum):
    """
    The name of the SKU.
    """
    STANDARD = "Standard"


@pulumi.type_token("azure-native:eventgrid:StaticRoutingEnrichmentType")
class StaticRoutingEnrichmentType(builtins.str, Enum):
    """
    Static routing enrichment value type. For e.g. this property value can be 'String'.
    """
    STRING = "String"


@pulumi.type_token("azure-native:eventgrid:TlsVersion")
class TlsVersion(builtins.str, Enum):
    """
    Minimum TLS version that should be supported by webhook endpoint
    """
    TLS_VERSION_1_0 = "1.0"
    TLS_VERSION_1_1 = "1.1"
    TLS_VERSION_1_2 = "1.2"


@pulumi.type_token("azure-native:eventgrid:TopicSpacesConfigurationState")
class TopicSpacesConfigurationState(builtins.str, Enum):
    """
    Indicate if Topic Spaces Configuration is enabled for the namespace. Default is Disabled.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"
