# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetDomainEventSubscriptionFullUrlResult',
    'AwaitableGetDomainEventSubscriptionFullUrlResult',
    'get_domain_event_subscription_full_url',
    'get_domain_event_subscription_full_url_output',
]

@pulumi.output_type
class GetDomainEventSubscriptionFullUrlResult:
    """
    Full endpoint URL of an event subscription
    """
    def __init__(__self__, endpoint_url=None):
        if endpoint_url and not isinstance(endpoint_url, str):
            raise TypeError("Expected argument 'endpoint_url' to be a str")
        pulumi.set(__self__, "endpoint_url", endpoint_url)

    @property
    @pulumi.getter(name="endpointUrl")
    def endpoint_url(self) -> Optional[builtins.str]:
        """
        The URL that represents the endpoint of the destination of an event subscription.
        """
        return pulumi.get(self, "endpoint_url")


class AwaitableGetDomainEventSubscriptionFullUrlResult(GetDomainEventSubscriptionFullUrlResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDomainEventSubscriptionFullUrlResult(
            endpoint_url=self.endpoint_url)


def get_domain_event_subscription_full_url(domain_name: Optional[builtins.str] = None,
                                           event_subscription_name: Optional[builtins.str] = None,
                                           resource_group_name: Optional[builtins.str] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDomainEventSubscriptionFullUrlResult:
    """
    Get the full endpoint URL for an event subscription for domain.

    Uses Azure REST API version 2025-02-15.

    Other available API versions: 2022-06-15, 2023-06-01-preview, 2023-12-15-preview, 2024-06-01-preview, 2024-12-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native eventgrid [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str domain_name: Name of the domain topic.
    :param builtins.str event_subscription_name: Name of the event subscription.
    :param builtins.str resource_group_name: The name of the resource group within the user's subscription.
    """
    __args__ = dict()
    __args__['domainName'] = domain_name
    __args__['eventSubscriptionName'] = event_subscription_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:eventgrid:getDomainEventSubscriptionFullUrl', __args__, opts=opts, typ=GetDomainEventSubscriptionFullUrlResult).value

    return AwaitableGetDomainEventSubscriptionFullUrlResult(
        endpoint_url=pulumi.get(__ret__, 'endpoint_url'))
def get_domain_event_subscription_full_url_output(domain_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  event_subscription_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDomainEventSubscriptionFullUrlResult]:
    """
    Get the full endpoint URL for an event subscription for domain.

    Uses Azure REST API version 2025-02-15.

    Other available API versions: 2022-06-15, 2023-06-01-preview, 2023-12-15-preview, 2024-06-01-preview, 2024-12-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native eventgrid [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str domain_name: Name of the domain topic.
    :param builtins.str event_subscription_name: Name of the event subscription.
    :param builtins.str resource_group_name: The name of the resource group within the user's subscription.
    """
    __args__ = dict()
    __args__['domainName'] = domain_name
    __args__['eventSubscriptionName'] = event_subscription_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:eventgrid:getDomainEventSubscriptionFullUrl', __args__, opts=opts, typ=GetDomainEventSubscriptionFullUrlResult)
    return __ret__.apply(lambda __response__: GetDomainEventSubscriptionFullUrlResult(
        endpoint_url=pulumi.get(__response__, 'endpoint_url')))
