# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetPartnerTopicEventSubscriptionDeliveryAttributesResult',
    'AwaitableGetPartnerTopicEventSubscriptionDeliveryAttributesResult',
    'get_partner_topic_event_subscription_delivery_attributes',
    'get_partner_topic_event_subscription_delivery_attributes_output',
]

@pulumi.output_type
class GetPartnerTopicEventSubscriptionDeliveryAttributesResult:
    """
    Result of the Get delivery attributes operation.
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence[Any]]:
        """
        A collection of DeliveryAttributeMapping
        """
        return pulumi.get(self, "value")


class AwaitableGetPartnerTopicEventSubscriptionDeliveryAttributesResult(GetPartnerTopicEventSubscriptionDeliveryAttributesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPartnerTopicEventSubscriptionDeliveryAttributesResult(
            value=self.value)


def get_partner_topic_event_subscription_delivery_attributes(event_subscription_name: Optional[builtins.str] = None,
                                                             partner_topic_name: Optional[builtins.str] = None,
                                                             resource_group_name: Optional[builtins.str] = None,
                                                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPartnerTopicEventSubscriptionDeliveryAttributesResult:
    """
    Get all delivery attributes for an event subscription of a partner topic.

    Uses Azure REST API version 2025-02-15.

    Other available API versions: 2022-06-15, 2023-06-01-preview, 2023-12-15-preview, 2024-06-01-preview, 2024-12-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native eventgrid [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str event_subscription_name: Name of the event subscription.
    :param builtins.str partner_topic_name: Name of the partner topic.
    :param builtins.str resource_group_name: The name of the resource group within the user's subscription.
    """
    __args__ = dict()
    __args__['eventSubscriptionName'] = event_subscription_name
    __args__['partnerTopicName'] = partner_topic_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:eventgrid:getPartnerTopicEventSubscriptionDeliveryAttributes', __args__, opts=opts, typ=GetPartnerTopicEventSubscriptionDeliveryAttributesResult).value

    return AwaitableGetPartnerTopicEventSubscriptionDeliveryAttributesResult(
        value=pulumi.get(__ret__, 'value'))
def get_partner_topic_event_subscription_delivery_attributes_output(event_subscription_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                    partner_topic_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                    resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetPartnerTopicEventSubscriptionDeliveryAttributesResult]:
    """
    Get all delivery attributes for an event subscription of a partner topic.

    Uses Azure REST API version 2025-02-15.

    Other available API versions: 2022-06-15, 2023-06-01-preview, 2023-12-15-preview, 2024-06-01-preview, 2024-12-15-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native eventgrid [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str event_subscription_name: Name of the event subscription.
    :param builtins.str partner_topic_name: Name of the partner topic.
    :param builtins.str resource_group_name: The name of the resource group within the user's subscription.
    """
    __args__ = dict()
    __args__['eventSubscriptionName'] = event_subscription_name
    __args__['partnerTopicName'] = partner_topic_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:eventgrid:getPartnerTopicEventSubscriptionDeliveryAttributes', __args__, opts=opts, typ=GetPartnerTopicEventSubscriptionDeliveryAttributesResult)
    return __ret__.apply(lambda __response__: GetPartnerTopicEventSubscriptionDeliveryAttributesResult(
        value=pulumi.get(__response__, 'value')))
