# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'CapacityAdministrationArgs',
    'CapacityAdministrationArgsDict',
    'RpSkuArgs',
    'RpSkuArgsDict',
]

MYPY = False

if not MYPY:
    class CapacityAdministrationArgsDict(TypedDict):
        """
        The administration properties of the Fabric capacity resource
        """
        members: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]
        """
        An array of administrator user identities.
        """
elif False:
    CapacityAdministrationArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class CapacityAdministrationArgs:
    def __init__(__self__, *,
                 members: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        """
        The administration properties of the Fabric capacity resource
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] members: An array of administrator user identities.
        """
        pulumi.set(__self__, "members", members)

    @property
    @pulumi.getter
    def members(self) -> pulumi.Input[Sequence[pulumi.Input[builtins.str]]]:
        """
        An array of administrator user identities.
        """
        return pulumi.get(self, "members")

    @members.setter
    def members(self, value: pulumi.Input[Sequence[pulumi.Input[builtins.str]]]):
        pulumi.set(self, "members", value)


if not MYPY:
    class RpSkuArgsDict(TypedDict):
        """
        Represents the SKU name and Azure pricing tier for Microsoft Fabric capacity resource.
        """
        name: pulumi.Input[builtins.str]
        """
        The name of the SKU level.
        """
        tier: pulumi.Input[Union[builtins.str, 'RpSkuTier']]
        """
        The name of the Azure pricing tier to which the SKU applies.
        """
elif False:
    RpSkuArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class RpSkuArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[builtins.str],
                 tier: pulumi.Input[Union[builtins.str, 'RpSkuTier']]):
        """
        Represents the SKU name and Azure pricing tier for Microsoft Fabric capacity resource.
        :param pulumi.Input[builtins.str] name: The name of the SKU level.
        :param pulumi.Input[Union[builtins.str, 'RpSkuTier']] tier: The name of the Azure pricing tier to which the SKU applies.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "tier", tier)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the SKU level.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def tier(self) -> pulumi.Input[Union[builtins.str, 'RpSkuTier']]:
        """
        The name of the Azure pricing tier to which the SKU applies.
        """
        return pulumi.get(self, "tier")

    @tier.setter
    def tier(self, value: pulumi.Input[Union[builtins.str, 'RpSkuTier']]):
        pulumi.set(self, "tier", value)


