# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ActionType',
    'BackendEnabledState',
    'CustomRuleEnabledState',
    'DynamicCompressionEnabled',
    'EnforceCertificateNameCheckEnabledState',
    'FrontDoorEnabledState',
    'FrontDoorForwardingProtocol',
    'FrontDoorHealthProbeMethod',
    'FrontDoorProtocol',
    'FrontDoorQuery',
    'FrontDoorRedirectProtocol',
    'FrontDoorRedirectType',
    'HeaderActionType',
    'HealthProbeEnabled',
    'ManagedRuleEnabledState',
    'ManagedRuleExclusionMatchVariable',
    'ManagedRuleExclusionSelectorMatchOperator',
    'ManagedRuleSetActionType',
    'MatchProcessingBehavior',
    'MatchVariable',
    'Operator',
    'PolicyEnabledState',
    'PolicyMode',
    'PolicyRequestBodyCheck',
    'RoutingRuleEnabledState',
    'RuleType',
    'RulesEngineMatchVariable',
    'RulesEngineOperator',
    'ScrubbingRuleEntryMatchOperator',
    'ScrubbingRuleEntryMatchVariable',
    'ScrubbingRuleEntryState',
    'SessionAffinityEnabledState',
    'SkuName',
    'State',
    'Transform',
    'TransformType',
    'VariableName',
    'WebApplicationFirewallScrubbingState',
]


@pulumi.type_token("azure-native:frontdoor:ActionType")
class ActionType(builtins.str, Enum):
    """
    Describes the override action to be applied when rule matches.
    """
    ALLOW = "Allow"
    BLOCK = "Block"
    LOG = "Log"
    REDIRECT = "Redirect"
    ANOMALY_SCORING = "AnomalyScoring"
    JS_CHALLENGE = "JSChallenge"


@pulumi.type_token("azure-native:frontdoor:BackendEnabledState")
class BackendEnabledState(builtins.str, Enum):
    """
    Whether to enable use of this backend. Permitted values are 'Enabled' or 'Disabled'
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:CustomRuleEnabledState")
class CustomRuleEnabledState(builtins.str, Enum):
    """
    Describes if the custom rule is in enabled or disabled state. Defaults to Enabled if not specified.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:frontdoor:DynamicCompressionEnabled")
class DynamicCompressionEnabled(builtins.str, Enum):
    """
    Whether to use dynamic compression for cached content
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:EnforceCertificateNameCheckEnabledState")
class EnforceCertificateNameCheckEnabledState(builtins.str, Enum):
    """
    Whether to enforce certificate name check on HTTPS requests to all backend pools. No effect on non-HTTPS requests.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:FrontDoorEnabledState")
class FrontDoorEnabledState(builtins.str, Enum):
    """
    Operational status of the Front Door load balancer. Permitted values are 'Enabled' or 'Disabled'
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:FrontDoorForwardingProtocol")
class FrontDoorForwardingProtocol(builtins.str, Enum):
    """
    Protocol this rule will use when forwarding traffic to backends.
    """
    HTTP_ONLY = "HttpOnly"
    HTTPS_ONLY = "HttpsOnly"
    MATCH_REQUEST = "MatchRequest"


@pulumi.type_token("azure-native:frontdoor:FrontDoorHealthProbeMethod")
class FrontDoorHealthProbeMethod(builtins.str, Enum):
    """
    Configures which HTTP method to use to probe the backends defined under backendPools.
    """
    GET = "GET"
    HEAD = "HEAD"


@pulumi.type_token("azure-native:frontdoor:FrontDoorProtocol")
class FrontDoorProtocol(builtins.str, Enum):
    """
    Accepted protocol schemes.
    """
    HTTP = "Http"
    HTTPS = "Https"


@pulumi.type_token("azure-native:frontdoor:FrontDoorQuery")
class FrontDoorQuery(builtins.str, Enum):
    """
    Treatment of URL query terms when forming the cache key.
    """
    STRIP_NONE = "StripNone"
    STRIP_ALL = "StripAll"
    STRIP_ONLY = "StripOnly"
    STRIP_ALL_EXCEPT = "StripAllExcept"


@pulumi.type_token("azure-native:frontdoor:FrontDoorRedirectProtocol")
class FrontDoorRedirectProtocol(builtins.str, Enum):
    """
    The protocol of the destination to where the traffic is redirected
    """
    HTTP_ONLY = "HttpOnly"
    HTTPS_ONLY = "HttpsOnly"
    MATCH_REQUEST = "MatchRequest"


@pulumi.type_token("azure-native:frontdoor:FrontDoorRedirectType")
class FrontDoorRedirectType(builtins.str, Enum):
    """
    The redirect type the rule will use when redirecting traffic.
    """
    MOVED = "Moved"
    FOUND = "Found"
    TEMPORARY_REDIRECT = "TemporaryRedirect"
    PERMANENT_REDIRECT = "PermanentRedirect"


@pulumi.type_token("azure-native:frontdoor:HeaderActionType")
class HeaderActionType(builtins.str, Enum):
    """
    Which type of manipulation to apply to the header.
    """
    APPEND = "Append"
    DELETE = "Delete"
    OVERWRITE = "Overwrite"


@pulumi.type_token("azure-native:frontdoor:HealthProbeEnabled")
class HealthProbeEnabled(builtins.str, Enum):
    """
    Whether to enable health probes to be made against backends defined under backendPools. Health probes can only be disabled if there is a single enabled backend in single enabled backend pool.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:ManagedRuleEnabledState")
class ManagedRuleEnabledState(builtins.str, Enum):
    """
    Describes if the managed rule is in enabled or disabled state. Defaults to Disabled if not specified.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:frontdoor:ManagedRuleExclusionMatchVariable")
class ManagedRuleExclusionMatchVariable(builtins.str, Enum):
    """
    The variable type to be excluded.
    """
    REQUEST_HEADER_NAMES = "RequestHeaderNames"
    REQUEST_COOKIE_NAMES = "RequestCookieNames"
    QUERY_STRING_ARG_NAMES = "QueryStringArgNames"
    REQUEST_BODY_POST_ARG_NAMES = "RequestBodyPostArgNames"
    REQUEST_BODY_JSON_ARG_NAMES = "RequestBodyJsonArgNames"


@pulumi.type_token("azure-native:frontdoor:ManagedRuleExclusionSelectorMatchOperator")
class ManagedRuleExclusionSelectorMatchOperator(builtins.str, Enum):
    """
    Comparison operator to apply to the selector when specifying which elements in the collection this exclusion applies to.
    """
    EQUALS = "Equals"
    CONTAINS = "Contains"
    STARTS_WITH = "StartsWith"
    ENDS_WITH = "EndsWith"
    EQUALS_ANY = "EqualsAny"


@pulumi.type_token("azure-native:frontdoor:ManagedRuleSetActionType")
class ManagedRuleSetActionType(builtins.str, Enum):
    """
    Defines the rule set action.
    """
    BLOCK = "Block"
    LOG = "Log"
    REDIRECT = "Redirect"


@pulumi.type_token("azure-native:frontdoor:MatchProcessingBehavior")
class MatchProcessingBehavior(builtins.str, Enum):
    """
    If this rule is a match should the rules engine continue running the remaining rules or stop. If not present, defaults to Continue.
    """
    CONTINUE_ = "Continue"
    STOP = "Stop"


@pulumi.type_token("azure-native:frontdoor:MatchVariable")
class MatchVariable(builtins.str, Enum):
    """
    Request variable to compare with.
    """
    REMOTE_ADDR = "RemoteAddr"
    REQUEST_METHOD = "RequestMethod"
    QUERY_STRING = "QueryString"
    POST_ARGS = "PostArgs"
    REQUEST_URI = "RequestUri"
    REQUEST_HEADER = "RequestHeader"
    REQUEST_BODY = "RequestBody"
    COOKIES = "Cookies"
    SOCKET_ADDR = "SocketAddr"


@pulumi.type_token("azure-native:frontdoor:Operator")
class Operator(builtins.str, Enum):
    """
    Comparison type to use for matching with the variable value.
    """
    ANY = "Any"
    IP_MATCH = "IPMatch"
    GEO_MATCH = "GeoMatch"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    LESS_THAN = "LessThan"
    GREATER_THAN = "GreaterThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"
    REG_EX = "RegEx"


@pulumi.type_token("azure-native:frontdoor:PolicyEnabledState")
class PolicyEnabledState(builtins.str, Enum):
    """
    Describes if the policy is in enabled or disabled state. Defaults to Enabled if not specified.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:frontdoor:PolicyMode")
class PolicyMode(builtins.str, Enum):
    """
    Describes if it is in detection mode or prevention mode at policy level.
    """
    PREVENTION = "Prevention"
    DETECTION = "Detection"


@pulumi.type_token("azure-native:frontdoor:PolicyRequestBodyCheck")
class PolicyRequestBodyCheck(builtins.str, Enum):
    """
    Describes if policy managed rules will inspect the request body content.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:frontdoor:RoutingRuleEnabledState")
class RoutingRuleEnabledState(builtins.str, Enum):
    """
    Whether to enable use of this rule. Permitted values are 'Enabled' or 'Disabled'
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:RuleType")
class RuleType(builtins.str, Enum):
    """
    Describes type of rule.
    """
    MATCH_RULE = "MatchRule"
    RATE_LIMIT_RULE = "RateLimitRule"


@pulumi.type_token("azure-native:frontdoor:RulesEngineMatchVariable")
class RulesEngineMatchVariable(builtins.str, Enum):
    """
    Match Variable
    """
    IS_MOBILE = "IsMobile"
    REMOTE_ADDR = "RemoteAddr"
    REQUEST_METHOD = "RequestMethod"
    QUERY_STRING = "QueryString"
    POST_ARGS = "PostArgs"
    REQUEST_URI = "RequestUri"
    REQUEST_PATH = "RequestPath"
    REQUEST_FILENAME = "RequestFilename"
    REQUEST_FILENAME_EXTENSION = "RequestFilenameExtension"
    REQUEST_HEADER = "RequestHeader"
    REQUEST_BODY = "RequestBody"
    REQUEST_SCHEME = "RequestScheme"


@pulumi.type_token("azure-native:frontdoor:RulesEngineOperator")
class RulesEngineOperator(builtins.str, Enum):
    """
    Describes operator to apply to the match condition.
    """
    ANY = "Any"
    IP_MATCH = "IPMatch"
    GEO_MATCH = "GeoMatch"
    EQUAL = "Equal"
    CONTAINS = "Contains"
    LESS_THAN = "LessThan"
    GREATER_THAN = "GreaterThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    BEGINS_WITH = "BeginsWith"
    ENDS_WITH = "EndsWith"


@pulumi.type_token("azure-native:frontdoor:ScrubbingRuleEntryMatchOperator")
class ScrubbingRuleEntryMatchOperator(builtins.str, Enum):
    """
    When matchVariable is a collection, operate on the selector to specify which elements in the collection this rule applies to.
    """
    EQUALS_ANY = "EqualsAny"
    EQUALS = "Equals"


@pulumi.type_token("azure-native:frontdoor:ScrubbingRuleEntryMatchVariable")
class ScrubbingRuleEntryMatchVariable(builtins.str, Enum):
    """
    The variable to be scrubbed from the logs.
    """
    REQUEST_IP_ADDRESS = "RequestIPAddress"
    REQUEST_URI = "RequestUri"
    QUERY_STRING_ARG_NAMES = "QueryStringArgNames"
    REQUEST_HEADER_NAMES = "RequestHeaderNames"
    REQUEST_COOKIE_NAMES = "RequestCookieNames"
    REQUEST_BODY_POST_ARG_NAMES = "RequestBodyPostArgNames"
    REQUEST_BODY_JSON_ARG_NAMES = "RequestBodyJsonArgNames"


@pulumi.type_token("azure-native:frontdoor:ScrubbingRuleEntryState")
class ScrubbingRuleEntryState(builtins.str, Enum):
    """
    Defines the state of a log scrubbing rule. Default value is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:SessionAffinityEnabledState")
class SessionAffinityEnabledState(builtins.str, Enum):
    """
    Whether to allow session affinity on this host. Valid options are 'Enabled' or 'Disabled'
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:SkuName")
class SkuName(builtins.str, Enum):
    """
    Name of the pricing tier.
    """
    CLASSIC_AZURE_FRONT_DOOR = "Classic_AzureFrontDoor"
    STANDARD_AZURE_FRONT_DOOR = "Standard_AzureFrontDoor"
    PREMIUM_AZURE_FRONT_DOOR = "Premium_AzureFrontDoor"


@pulumi.type_token("azure-native:frontdoor:State")
class State(builtins.str, Enum):
    """
    The state of the Experiment
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:frontdoor:Transform")
class Transform(builtins.str, Enum):
    """
    Describes what transforms are applied before matching
    """
    LOWERCASE = "Lowercase"
    UPPERCASE = "Uppercase"
    TRIM = "Trim"
    URL_DECODE = "UrlDecode"
    URL_ENCODE = "UrlEncode"
    REMOVE_NULLS = "RemoveNulls"


@pulumi.type_token("azure-native:frontdoor:TransformType")
class TransformType(builtins.str, Enum):
    """
    Describes what transforms applied before matching.
    """
    LOWERCASE = "Lowercase"
    UPPERCASE = "Uppercase"
    TRIM = "Trim"
    URL_DECODE = "UrlDecode"
    URL_ENCODE = "UrlEncode"
    REMOVE_NULLS = "RemoveNulls"


@pulumi.type_token("azure-native:frontdoor:VariableName")
class VariableName(builtins.str, Enum):
    """
    Describes the supported variable for group by
    """
    SOCKET_ADDR = "SocketAddr"
    GEO_LOCATION = "GeoLocation"
    NONE = "None"


@pulumi.type_token("azure-native:frontdoor:WebApplicationFirewallScrubbingState")
class WebApplicationFirewallScrubbingState(builtins.str, Enum):
    """
    State of the log scrubbing config. Default value is Enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"
