# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AnalyticsConnectorDataDestinationType',
    'AnalyticsConnectorDataSourceType',
    'AnalyticsConnectorMappingType',
    'FhirResourceVersionPolicy',
    'FhirServiceKind',
    'FhirServiceVersion',
    'IotIdentityResolutionType',
    'Kind',
    'ManagedServiceIdentityType',
    'PrivateEndpointServiceConnectionStatus',
    'PublicNetworkAccess',
    'ServiceManagedIdentityType',
    'SmartDataActions',
]


@pulumi.type_token("azure-native:healthcareapis:AnalyticsConnectorDataDestinationType")
class AnalyticsConnectorDataDestinationType(builtins.str, Enum):
    """
    Type of data destination.
    """
    DATALAKE = "datalake"


@pulumi.type_token("azure-native:healthcareapis:AnalyticsConnectorDataSourceType")
class AnalyticsConnectorDataSourceType(builtins.str, Enum):
    """
    Type of data source.
    """
    FHIRSERVICE = "fhirservice"


@pulumi.type_token("azure-native:healthcareapis:AnalyticsConnectorMappingType")
class AnalyticsConnectorMappingType(builtins.str, Enum):
    """
    Type of data mapping.
    """
    FHIR_TO_PARQUET = "fhirToParquet"


@pulumi.type_token("azure-native:healthcareapis:FhirResourceVersionPolicy")
class FhirResourceVersionPolicy(builtins.str, Enum):
    """
    Controls how resources are versioned on the FHIR service
    """
    NO_VERSION = "no-version"
    VERSIONED = "versioned"
    VERSIONED_UPDATE = "versioned-update"


@pulumi.type_token("azure-native:healthcareapis:FhirServiceKind")
class FhirServiceKind(builtins.str, Enum):
    """
    The kind of the service.
    """
    FHIR_STU3 = "fhir-Stu3"
    FHIR_R4 = "fhir-R4"


@pulumi.type_token("azure-native:healthcareapis:FhirServiceVersion")
class FhirServiceVersion(builtins.str, Enum):
    """
    The kind of FHIR Service.
    """
    STU3 = "STU3"
    R4 = "R4"


@pulumi.type_token("azure-native:healthcareapis:IotIdentityResolutionType")
class IotIdentityResolutionType(builtins.str, Enum):
    """
    Determines how resource identity is resolved on the destination.
    """
    CREATE = "Create"
    LOOKUP = "Lookup"


@pulumi.type_token("azure-native:healthcareapis:Kind")
class Kind(builtins.str, Enum):
    """
    The kind of the service.
    """
    FHIR = "fhir"
    FHIR_STU3 = "fhir-Stu3"
    FHIR_R4 = "fhir-R4"


@pulumi.type_token("azure-native:healthcareapis:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of identity being specified, currently SystemAssigned and None are allowed.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:healthcareapis:PrivateEndpointServiceConnectionStatus")
class PrivateEndpointServiceConnectionStatus(builtins.str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"


@pulumi.type_token("azure-native:healthcareapis:PublicNetworkAccess")
class PublicNetworkAccess(builtins.str, Enum):
    """
    Control permission for data plane traffic coming from public networks while private endpoint is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:healthcareapis:ServiceManagedIdentityType")
class ServiceManagedIdentityType(builtins.str, Enum):
    """
    Type of identity being specified, currently SystemAssigned and None are allowed.
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


@pulumi.type_token("azure-native:healthcareapis:SmartDataActions")
class SmartDataActions(builtins.str, Enum):
    """
    The Data Actions that can be enabled for a Smart Identity Provider Application.
    """
    READ = "Read"
