# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ArcKindEnum',
    'AssessmentModeTypes',
    'GatewayType',
    'LicenseAssignmentState',
    'LicenseCoreType',
    'LicenseEdition',
    'LicenseProfileProductType',
    'LicenseProfileSubscriptionStatus',
    'LicenseState',
    'LicenseTarget',
    'LicenseType',
    'PatchModeTypes',
    'ProgramYear',
    'PublicNetworkAccessType',
    'ResourceIdentityType',
    'StatusLevelTypes',
]


@pulumi.type_token("azure-native:hybridcompute:ArcKindEnum")
class ArcKindEnum(builtins.str, Enum):
    """
    Indicates which kind of Arc machine placement on-premises, such as HCI, SCVMM or VMware etc.
    """
    AVS = "AVS"
    HCI = "HCI"
    SCVMM = "SCVMM"
    V_MWARE = "VMware"
    EPS = "EPS"
    GCP = "GCP"
    AWS = "AWS"


@pulumi.type_token("azure-native:hybridcompute:AssessmentModeTypes")
class AssessmentModeTypes(builtins.str, Enum):
    """
    Specifies the assessment mode.
    """
    IMAGE_DEFAULT = "ImageDefault"
    AUTOMATIC_BY_PLATFORM = "AutomaticByPlatform"


@pulumi.type_token("azure-native:hybridcompute:GatewayType")
class GatewayType(builtins.str, Enum):
    """
    The type of the Gateway resource.
    """
    PUBLIC = "Public"


@pulumi.type_token("azure-native:hybridcompute:LicenseAssignmentState")
class LicenseAssignmentState(builtins.str, Enum):
    """
    Describes the license assignment state (Assigned or NotAssigned).
    """
    ASSIGNED = "Assigned"
    NOT_ASSIGNED = "NotAssigned"


@pulumi.type_token("azure-native:hybridcompute:LicenseCoreType")
class LicenseCoreType(builtins.str, Enum):
    """
    Describes the license core type (pCore or vCore).
    """
    P_CORE = "pCore"
    V_CORE = "vCore"


@pulumi.type_token("azure-native:hybridcompute:LicenseEdition")
class LicenseEdition(builtins.str, Enum):
    """
    Describes the edition of the license. The values are either Standard or Datacenter.
    """
    STANDARD = "Standard"
    DATACENTER = "Datacenter"


@pulumi.type_token("azure-native:hybridcompute:LicenseProfileProductType")
class LicenseProfileProductType(builtins.str, Enum):
    """
    Indicates the product type of the license.
    """
    WINDOWS_SERVER = "WindowsServer"
    WINDOWS_IO_T_ENTERPRISE = "WindowsIoTEnterprise"


@pulumi.type_token("azure-native:hybridcompute:LicenseProfileSubscriptionStatus")
class LicenseProfileSubscriptionStatus(builtins.str, Enum):
    """
    Indicates the subscription status of the product.
    """
    UNKNOWN = "Unknown"
    ENABLING = "Enabling"
    ENABLED = "Enabled"
    DISABLED = "Disabled"
    DISABLING = "Disabling"
    FAILED = "Failed"


@pulumi.type_token("azure-native:hybridcompute:LicenseState")
class LicenseState(builtins.str, Enum):
    """
    Describes the state of the license.
    """
    ACTIVATED = "Activated"
    DEACTIVATED = "Deactivated"


@pulumi.type_token("azure-native:hybridcompute:LicenseTarget")
class LicenseTarget(builtins.str, Enum):
    """
    Describes the license target server.
    """
    WINDOWS_SERVER_2012 = "Windows Server 2012"
    WINDOWS_SERVER_2012_R2 = "Windows Server 2012 R2"


@pulumi.type_token("azure-native:hybridcompute:LicenseType")
class LicenseType(builtins.str, Enum):
    """
    The type of the license resource.
    """
    ESU = "ESU"


@pulumi.type_token("azure-native:hybridcompute:PatchModeTypes")
class PatchModeTypes(builtins.str, Enum):
    """
    Specifies the patch mode.
    """
    IMAGE_DEFAULT = "ImageDefault"
    AUTOMATIC_BY_PLATFORM = "AutomaticByPlatform"
    AUTOMATIC_BY_OS = "AutomaticByOS"
    MANUAL = "Manual"


@pulumi.type_token("azure-native:hybridcompute:ProgramYear")
class ProgramYear(builtins.str, Enum):
    """
    Describes the program year the volume license is for.
    """
    YEAR_1 = "Year 1"
    YEAR_2 = "Year 2"
    YEAR_3 = "Year 3"


@pulumi.type_token("azure-native:hybridcompute:PublicNetworkAccessType")
class PublicNetworkAccessType(builtins.str, Enum):
    """
    Indicates whether machines associated with the private link scope can also use public Azure Arc service endpoints.
    """
    ENABLED = "Enabled"
    """
    Allows Azure Arc agents to communicate with Azure Arc services over both public (internet) and private endpoints.
    """
    DISABLED = "Disabled"
    """
    Does not allow Azure Arc agents to communicate with Azure Arc services over public (internet) endpoints. The agents must use the private link.
    """
    SECURED_BY_PERIMETER = "SecuredByPerimeter"
    """
    Azure Arc agent communication with Azure Arc services over public (internet) is enforced by Network Security Perimeter (NSP)
    """


@pulumi.type_token("azure-native:hybridcompute:ResourceIdentityType")
class ResourceIdentityType(builtins.str, Enum):
    """
    The identity type.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"


@pulumi.type_token("azure-native:hybridcompute:StatusLevelTypes")
class StatusLevelTypes(builtins.str, Enum):
    """
    The level code.
    """
    INFO = "Info"
    WARNING = "Warning"
    ERROR = "Error"
