# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['PublicCloudConnectorArgs', 'PublicCloudConnector']

@pulumi.input_type
class PublicCloudConnectorArgs:
    def __init__(__self__, *,
                 aws_cloud_profile: pulumi.Input['AwsCloudProfileArgs'],
                 host_type: pulumi.Input[Union[builtins.str, 'HostType']],
                 resource_group_name: pulumi.Input[builtins.str],
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 public_cloud_connector: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a PublicCloudConnector resource.
        :param pulumi.Input['AwsCloudProfileArgs'] aws_cloud_profile: Cloud profile for AWS.
        :param pulumi.Input[Union[builtins.str, 'HostType']] host_type: Host cloud the public cloud connector.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] location: The geo-location where the resource lives
        :param pulumi.Input[builtins.str] public_cloud_connector: Represent public cloud connectors resource.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "aws_cloud_profile", aws_cloud_profile)
        pulumi.set(__self__, "host_type", host_type)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if public_cloud_connector is not None:
            pulumi.set(__self__, "public_cloud_connector", public_cloud_connector)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="awsCloudProfile")
    def aws_cloud_profile(self) -> pulumi.Input['AwsCloudProfileArgs']:
        """
        Cloud profile for AWS.
        """
        return pulumi.get(self, "aws_cloud_profile")

    @aws_cloud_profile.setter
    def aws_cloud_profile(self, value: pulumi.Input['AwsCloudProfileArgs']):
        pulumi.set(self, "aws_cloud_profile", value)

    @property
    @pulumi.getter(name="hostType")
    def host_type(self) -> pulumi.Input[Union[builtins.str, 'HostType']]:
        """
        Host cloud the public cloud connector.
        """
        return pulumi.get(self, "host_type")

    @host_type.setter
    def host_type(self, value: pulumi.Input[Union[builtins.str, 'HostType']]):
        pulumi.set(self, "host_type", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="publicCloudConnector")
    def public_cloud_connector(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Represent public cloud connectors resource.
        """
        return pulumi.get(self, "public_cloud_connector")

    @public_cloud_connector.setter
    def public_cloud_connector(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "public_cloud_connector", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.type_token("azure-native:hybridconnectivity:PublicCloudConnector")
class PublicCloudConnector(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 aws_cloud_profile: Optional[pulumi.Input[Union['AwsCloudProfileArgs', 'AwsCloudProfileArgsDict']]] = None,
                 host_type: Optional[pulumi.Input[Union[builtins.str, 'HostType']]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 public_cloud_connector: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        Public Cloud Connector

        Uses Azure REST API version 2024-12-01. In version 2.x of the Azure Native provider, it used API version 2024-12-01.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['AwsCloudProfileArgs', 'AwsCloudProfileArgsDict']] aws_cloud_profile: Cloud profile for AWS.
        :param pulumi.Input[Union[builtins.str, 'HostType']] host_type: Host cloud the public cloud connector.
        :param pulumi.Input[builtins.str] location: The geo-location where the resource lives
        :param pulumi.Input[builtins.str] public_cloud_connector: Represent public cloud connectors resource.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: Resource tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PublicCloudConnectorArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Public Cloud Connector

        Uses Azure REST API version 2024-12-01. In version 2.x of the Azure Native provider, it used API version 2024-12-01.

        :param str resource_name: The name of the resource.
        :param PublicCloudConnectorArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PublicCloudConnectorArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 aws_cloud_profile: Optional[pulumi.Input[Union['AwsCloudProfileArgs', 'AwsCloudProfileArgsDict']]] = None,
                 host_type: Optional[pulumi.Input[Union[builtins.str, 'HostType']]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 public_cloud_connector: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PublicCloudConnectorArgs.__new__(PublicCloudConnectorArgs)

            if aws_cloud_profile is None and not opts.urn:
                raise TypeError("Missing required property 'aws_cloud_profile'")
            __props__.__dict__["aws_cloud_profile"] = aws_cloud_profile
            if host_type is None and not opts.urn:
                raise TypeError("Missing required property 'host_type'")
            __props__.__dict__["host_type"] = host_type
            __props__.__dict__["location"] = location
            __props__.__dict__["public_cloud_connector"] = public_cloud_connector
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["connector_primary_identifier"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:hybridconnectivity/v20241201:PublicCloudConnector")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(PublicCloudConnector, __self__).__init__(
            'azure-native:hybridconnectivity:PublicCloudConnector',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'PublicCloudConnector':
        """
        Get an existing PublicCloudConnector resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = PublicCloudConnectorArgs.__new__(PublicCloudConnectorArgs)

        __props__.__dict__["aws_cloud_profile"] = None
        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["connector_primary_identifier"] = None
        __props__.__dict__["host_type"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return PublicCloudConnector(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="awsCloudProfile")
    def aws_cloud_profile(self) -> pulumi.Output['outputs.AwsCloudProfileResponse']:
        """
        Cloud profile for AWS.
        """
        return pulumi.get(self, "aws_cloud_profile")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="connectorPrimaryIdentifier")
    def connector_primary_identifier(self) -> pulumi.Output[builtins.str]:
        """
        Connector primary identifier.
        """
        return pulumi.get(self, "connector_primary_identifier")

    @property
    @pulumi.getter(name="hostType")
    def host_type(self) -> pulumi.Output[builtins.str]:
        """
        Host cloud the public cloud connector.
        """
        return pulumi.get(self, "host_type")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[builtins.str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        The resource provisioning state.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

