# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListArtifactStoreNetworkFabricControllerPrivateEndPointsResult',
    'AwaitableListArtifactStoreNetworkFabricControllerPrivateEndPointsResult',
    'list_artifact_store_network_fabric_controller_private_end_points',
    'list_artifact_store_network_fabric_controller_private_end_points_output',
]

@pulumi.output_type
class ListArtifactStoreNetworkFabricControllerPrivateEndPointsResult:
    """
    List of manual private endpoints.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> builtins.str:
        """
        The URI to get the next set of results.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.ArtifactStoreNetworkFabricControllerEndPointsResponse']]:
        """
        A list of network fabric controllers.
        """
        return pulumi.get(self, "value")


class AwaitableListArtifactStoreNetworkFabricControllerPrivateEndPointsResult(ListArtifactStoreNetworkFabricControllerPrivateEndPointsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListArtifactStoreNetworkFabricControllerPrivateEndPointsResult(
            next_link=self.next_link,
            value=self.value)


def list_artifact_store_network_fabric_controller_private_end_points(artifact_store_name: Optional[builtins.str] = None,
                                                                     publisher_name: Optional[builtins.str] = None,
                                                                     resource_group_name: Optional[builtins.str] = None,
                                                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListArtifactStoreNetworkFabricControllerPrivateEndPointsResult:
    """
    List network fabric controllers to artifact stores

    Uses Azure REST API version 2024-04-15.


    :param builtins.str artifact_store_name: The name of the artifact store.
    :param builtins.str publisher_name: The name of the publisher.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['artifactStoreName'] = artifact_store_name
    __args__['publisherName'] = publisher_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:hybridnetwork:listArtifactStoreNetworkFabricControllerPrivateEndPoints', __args__, opts=opts, typ=ListArtifactStoreNetworkFabricControllerPrivateEndPointsResult).value

    return AwaitableListArtifactStoreNetworkFabricControllerPrivateEndPointsResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))
def list_artifact_store_network_fabric_controller_private_end_points_output(artifact_store_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                            publisher_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                            resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListArtifactStoreNetworkFabricControllerPrivateEndPointsResult]:
    """
    List network fabric controllers to artifact stores

    Uses Azure REST API version 2024-04-15.


    :param builtins.str artifact_store_name: The name of the artifact store.
    :param builtins.str publisher_name: The name of the publisher.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['artifactStoreName'] = artifact_store_name
    __args__['publisherName'] = publisher_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:hybridnetwork:listArtifactStoreNetworkFabricControllerPrivateEndPoints', __args__, opts=opts, typ=ListArtifactStoreNetworkFabricControllerPrivateEndPointsResult)
    return __ret__.apply(lambda __response__: ListArtifactStoreNetworkFabricControllerPrivateEndPointsResult(
        next_link=pulumi.get(__response__, 'next_link'),
        value=pulumi.get(__response__, 'value')))
