# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListDeviceRegistrationKeyResult',
    'AwaitableListDeviceRegistrationKeyResult',
    'list_device_registration_key',
    'list_device_registration_key_output',
]

@pulumi.output_type
class ListDeviceRegistrationKeyResult:
    """
    The device registration key.
    """
    def __init__(__self__, registration_key=None):
        if registration_key and not isinstance(registration_key, str):
            raise TypeError("Expected argument 'registration_key' to be a str")
        pulumi.set(__self__, "registration_key", registration_key)

    @property
    @pulumi.getter(name="registrationKey")
    def registration_key(self) -> builtins.str:
        """
        The registration key for the device.
        """
        return pulumi.get(self, "registration_key")


class AwaitableListDeviceRegistrationKeyResult(ListDeviceRegistrationKeyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListDeviceRegistrationKeyResult(
            registration_key=self.registration_key)


def list_device_registration_key(device_name: Optional[builtins.str] = None,
                                 resource_group_name: Optional[builtins.str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListDeviceRegistrationKeyResult:
    """
    List the registration key for the device.

    Uses Azure REST API version 2022-01-01-preview.


    :param builtins.str device_name: The name of the device resource.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['deviceName'] = device_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:hybridnetwork:listDeviceRegistrationKey', __args__, opts=opts, typ=ListDeviceRegistrationKeyResult).value

    return AwaitableListDeviceRegistrationKeyResult(
        registration_key=pulumi.get(__ret__, 'registration_key'))
def list_device_registration_key_output(device_name: Optional[pulumi.Input[builtins.str]] = None,
                                        resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListDeviceRegistrationKeyResult]:
    """
    List the registration key for the device.

    Uses Azure REST API version 2022-01-01-preview.


    :param builtins.str device_name: The name of the device resource.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['deviceName'] = device_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:hybridnetwork:listDeviceRegistrationKey', __args__, opts=opts, typ=ListDeviceRegistrationKeyResult)
    return __ret__.apply(lambda __response__: ListDeviceRegistrationKeyResult(
        registration_key=pulumi.get(__response__, 'registration_key')))
