# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ConfidenceLevel',
    'IncidentSource',
    'MetricUnit',
    'Platform',
    'Protocol',
    'Toolset',
]


@pulumi.type_token("azure-native:impact:ConfidenceLevel")
class ConfidenceLevel(builtins.str, Enum):
    """
    Degree of confidence on the impact being a platform issue
    """
    LOW = "Low"
    """
    Low confidence on azure being the source of impact
    """
    MEDIUM = "Medium"
    """
    Medium confidence on azure being the source of impact
    """
    HIGH = "High"
    """
    High confidence on azure being the source of impact
    """


@pulumi.type_token("azure-native:impact:IncidentSource")
class IncidentSource(builtins.str, Enum):
    """
    Client incident source. ex : source system name where the incident is created
    """
    AZURE_DEVOPS = "AzureDevops"
    """
    When source of Incident is AzureDevops
    """
    ICM = "ICM"
    """
    When source of Incident is Microsoft ICM
    """
    JIRA = "Jira"
    """
    When source of Incident is Jira
    """
    SERVICE_NOW = "ServiceNow"
    """
    When source of Incident is ServiceNow
    """
    OTHER = "Other"
    """
    When source of Incident is Other
    """


@pulumi.type_token("azure-native:impact:MetricUnit")
class MetricUnit(builtins.str, Enum):
    """
    Unit of the metric ex: Bytes, Percentage, Count, Seconds, Milliseconds, Bytes/Second, Count/Second, etc.., Other
    """
    BYTE_SECONDS = "ByteSeconds"
    """
    When measurement is in ByteSeconds
    """
    BYTES = "Bytes"
    """
    When measurement is in Bytes
    """
    BYTES_PER_SECOND = "BytesPerSecond"
    """
    When measurement is in BytesPerSecond
    """
    CORES = "Cores"
    """
    When measurement is in Cores
    """
    COUNT = "Count"
    """
    When measurement is in Count
    """
    COUNT_PER_SECOND = "CountPerSecond"
    """
    When measurement is in CountPerSecond
    """
    MILLI_CORES = "MilliCores"
    """
    When measurement is in MilliCores
    """
    MILLI_SECONDS = "MilliSeconds"
    """
    When measurement is in MilliSeconds
    """
    NANO_CORES = "NanoCores"
    """
    When measurement is in NanoCores
    """
    PERCENT = "Percent"
    """
    When measurement is in Percent
    """
    SECONDS = "Seconds"
    """
    When measurement is in Seconds
    """
    OTHER = "Other"
    """
    When measurement is in Other than listed
    """


@pulumi.type_token("azure-native:impact:Platform")
class Platform(builtins.str, Enum):
    """
    connector type
    """
    AZURE_MONITOR = "AzureMonitor"
    """
    Type of Azure Monitor
    """


@pulumi.type_token("azure-native:impact:Protocol")
class Protocol(builtins.str, Enum):
    """
    Protocol used for the connection
    """
    TCP = "TCP"
    """
    When communication protocol is TCP
    """
    UDP = "UDP"
    """
    When communication protocol is UDP
    """
    HTTP = "HTTP"
    """
    When communication protocol is HTTP
    """
    HTTPS = "HTTPS"
    """
    When communication protocol is HTTPS
    """
    RDP = "RDP"
    """
    When communication protocol is RDP
    """
    FTP = "FTP"
    """
    When communication protocol is FTP
    """
    SSH = "SSH"
    """
    When communication protocol is SSH
    """
    OTHER = "Other"
    """
    When communication protocol is Other
    """


@pulumi.type_token("azure-native:impact:Toolset")
class Toolset(builtins.str, Enum):
    """
    Tool used to interact with Azure. SDK, AzPortal, etc.., Other
    """
    TERRAFORM = "Terraform"
    """
    If communication toolset is Terraform
    """
    PUPPET = "Puppet"
    """
    If communication toolset is Puppet
    """
    CHEF = "Chef"
    """
    If communication toolset is Chef
    """
    SDK = "SDK"
    """
    If communication toolset is SDK
    """
    ANSIBLE = "Ansible"
    """
    If communication toolset is Ansible
    """
    ARM = "ARM"
    """
    If communication toolset is ARM
    """
    PORTAL = "Portal"
    """
    If communication toolset is Portal
    """
    SHELL = "Shell"
    """
    If communication toolset is Shell
    """
    OTHER = "Other"
    """
    If communication toolset is Other
    """
