# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['WorkloadImpactArgs', 'WorkloadImpact']

@pulumi.input_type
class WorkloadImpactArgs:
    def __init__(__self__, *,
                 properties: Optional[pulumi.Input['WorkloadImpactPropertiesArgs']] = None,
                 workload_impact_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a WorkloadImpact resource.
        :param pulumi.Input['WorkloadImpactPropertiesArgs'] properties: The resource-specific properties for this resource.
        :param pulumi.Input[builtins.str] workload_impact_name: workloadImpact resource 
        """
        if properties is not None:
            pulumi.set(__self__, "properties", properties)
        if workload_impact_name is not None:
            pulumi.set(__self__, "workload_impact_name", workload_impact_name)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input['WorkloadImpactPropertiesArgs']]:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input['WorkloadImpactPropertiesArgs']]):
        pulumi.set(self, "properties", value)

    @property
    @pulumi.getter(name="workloadImpactName")
    def workload_impact_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        workloadImpact resource 
        """
        return pulumi.get(self, "workload_impact_name")

    @workload_impact_name.setter
    def workload_impact_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "workload_impact_name", value)


@pulumi.type_token("azure-native:impact:WorkloadImpact")
class WorkloadImpact(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 properties: Optional[pulumi.Input[Union['WorkloadImpactPropertiesArgs', 'WorkloadImpactPropertiesArgsDict']]] = None,
                 workload_impact_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Workload Impact properties

        Uses Azure REST API version 2024-05-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-05-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['WorkloadImpactPropertiesArgs', 'WorkloadImpactPropertiesArgsDict']] properties: The resource-specific properties for this resource.
        :param pulumi.Input[builtins.str] workload_impact_name: workloadImpact resource 
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[WorkloadImpactArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Workload Impact properties

        Uses Azure REST API version 2024-05-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-05-01-preview.

        :param str resource_name: The name of the resource.
        :param WorkloadImpactArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WorkloadImpactArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 properties: Optional[pulumi.Input[Union['WorkloadImpactPropertiesArgs', 'WorkloadImpactPropertiesArgsDict']]] = None,
                 workload_impact_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WorkloadImpactArgs.__new__(WorkloadImpactArgs)

            __props__.__dict__["properties"] = properties
            __props__.__dict__["workload_impact_name"] = workload_impact_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:impact/v20240501preview:WorkloadImpact")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(WorkloadImpact, __self__).__init__(
            'azure-native:impact:WorkloadImpact',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'WorkloadImpact':
        """
        Get an existing WorkloadImpact resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = WorkloadImpactArgs.__new__(WorkloadImpactArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return WorkloadImpact(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.WorkloadImpactPropertiesResponse']:
        """
        The resource-specific properties for this resource.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

