# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ActionsRequired',
    'CertificatePermissions',
    'CreateMode',
    'JsonWebKeyCurveName',
    'JsonWebKeyOperation',
    'JsonWebKeyType',
    'KeyPermissions',
    'KeyRotationPolicyActionType',
    'ManagedHsmSkuFamily',
    'ManagedHsmSkuName',
    'ManagedServiceIdentityType',
    'NetworkRuleAction',
    'NetworkRuleBypassOptions',
    'PrivateEndpointServiceConnectionStatus',
    'PublicNetworkAccess',
    'SecretPermissions',
    'SkuFamily',
    'SkuName',
    'StoragePermissions',
]


@pulumi.type_token("azure-native:keyvault:ActionsRequired")
class ActionsRequired(builtins.str, Enum):
    """
    A message indicating if changes on the service provider require any updates on the consumer.
    """
    NONE = "None"


@pulumi.type_token("azure-native:keyvault:CertificatePermissions")
class CertificatePermissions(builtins.str, Enum):
    ALL = "all"
    GET = "get"
    LIST = "list"
    DELETE = "delete"
    CREATE = "create"
    IMPORT_ = "import"
    UPDATE = "update"
    MANAGECONTACTS = "managecontacts"
    GETISSUERS = "getissuers"
    LISTISSUERS = "listissuers"
    SETISSUERS = "setissuers"
    DELETEISSUERS = "deleteissuers"
    MANAGEISSUERS = "manageissuers"
    RECOVER = "recover"
    PURGE = "purge"
    BACKUP = "backup"
    RESTORE = "restore"


@pulumi.type_token("azure-native:keyvault:CreateMode")
class CreateMode(builtins.str, Enum):
    """
    The vault's create mode to indicate whether the vault need to be recovered or not.
    """
    RECOVER = "recover"
    DEFAULT = "default"


@pulumi.type_token("azure-native:keyvault:JsonWebKeyCurveName")
class JsonWebKeyCurveName(builtins.str, Enum):
    """
    The elliptic curve name. For valid values, see JsonWebKeyCurveName. Default for EC and EC-HSM keys is P-256
    """
    P_256 = "P-256"
    P_384 = "P-384"
    P_521 = "P-521"
    P_256_K = "P-256K"


@pulumi.type_token("azure-native:keyvault:JsonWebKeyOperation")
class JsonWebKeyOperation(builtins.str, Enum):
    """
    The permitted JSON web key operations of the key. For more information, see JsonWebKeyOperation.
    """
    ENCRYPT = "encrypt"
    DECRYPT = "decrypt"
    SIGN = "sign"
    VERIFY = "verify"
    WRAP_KEY = "wrapKey"
    UNWRAP_KEY = "unwrapKey"
    IMPORT_ = "import"
    RELEASE = "release"


@pulumi.type_token("azure-native:keyvault:JsonWebKeyType")
class JsonWebKeyType(builtins.str, Enum):
    """
    The type of the key. For valid values, see JsonWebKeyType.
    """
    EC = "EC"
    E_C_HSM = "EC-HSM"
    RSA = "RSA"
    RS_A_HSM = "RSA-HSM"


@pulumi.type_token("azure-native:keyvault:KeyPermissions")
class KeyPermissions(builtins.str, Enum):
    ALL = "all"
    ENCRYPT = "encrypt"
    DECRYPT = "decrypt"
    WRAP_KEY = "wrapKey"
    UNWRAP_KEY = "unwrapKey"
    SIGN = "sign"
    VERIFY = "verify"
    GET = "get"
    LIST = "list"
    CREATE = "create"
    UPDATE = "update"
    IMPORT_ = "import"
    DELETE = "delete"
    BACKUP = "backup"
    RESTORE = "restore"
    RECOVER = "recover"
    PURGE = "purge"
    RELEASE = "release"
    ROTATE = "rotate"
    GETROTATIONPOLICY = "getrotationpolicy"
    SETROTATIONPOLICY = "setrotationpolicy"


@pulumi.type_token("azure-native:keyvault:KeyRotationPolicyActionType")
class KeyRotationPolicyActionType(builtins.str, Enum):
    """
    The type of action.
    """
    ROTATE = "rotate"
    NOTIFY = "notify"


@pulumi.type_token("azure-native:keyvault:ManagedHsmSkuFamily")
class ManagedHsmSkuFamily(builtins.str, Enum):
    """
    SKU Family of the managed HSM Pool
    """
    B = "B"
    C = "C"


@pulumi.type_token("azure-native:keyvault:ManagedHsmSkuName")
class ManagedHsmSkuName(builtins.str, Enum):
    """
    SKU of the managed HSM Pool
    """
    STANDARD_B1 = "Standard_B1"
    CUSTOM_B32 = "Custom_B32"
    CUSTOM_B6 = "Custom_B6"
    CUSTOM_C42 = "Custom_C42"
    CUSTOM_C10 = "Custom_C10"


@pulumi.type_token("azure-native:keyvault:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


@pulumi.type_token("azure-native:keyvault:NetworkRuleAction")
class NetworkRuleAction(builtins.str, Enum):
    """
    The default action when no rule from ipRules and from virtualNetworkRules match. This is only used after the bypass property has been evaluated.
    """
    ALLOW = "Allow"
    DENY = "Deny"


@pulumi.type_token("azure-native:keyvault:NetworkRuleBypassOptions")
class NetworkRuleBypassOptions(builtins.str, Enum):
    """
    Tells what traffic can bypass network rules. This can be 'AzureServices' or 'None'.  If not specified the default is 'AzureServices'.
    """
    AZURE_SERVICES = "AzureServices"
    NONE = "None"


@pulumi.type_token("azure-native:keyvault:PrivateEndpointServiceConnectionStatus")
class PrivateEndpointServiceConnectionStatus(builtins.str, Enum):
    """
    Indicates whether the connection has been approved, rejected or removed by the key vault owner.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"
    DISCONNECTED = "Disconnected"


@pulumi.type_token("azure-native:keyvault:PublicNetworkAccess")
class PublicNetworkAccess(builtins.str, Enum):
    """
    Control permission to the managed HSM from public networks.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:keyvault:SecretPermissions")
class SecretPermissions(builtins.str, Enum):
    ALL = "all"
    GET = "get"
    LIST = "list"
    SET = "set"
    DELETE = "delete"
    BACKUP = "backup"
    RESTORE = "restore"
    RECOVER = "recover"
    PURGE = "purge"


@pulumi.type_token("azure-native:keyvault:SkuFamily")
class SkuFamily(builtins.str, Enum):
    """
    SKU family name
    """
    A = "A"


@pulumi.type_token("azure-native:keyvault:SkuName")
class SkuName(builtins.str, Enum):
    """
    SKU name to specify whether the key vault is a standard vault or a premium vault.
    """
    STANDARD = "standard"
    PREMIUM = "premium"


@pulumi.type_token("azure-native:keyvault:StoragePermissions")
class StoragePermissions(builtins.str, Enum):
    ALL = "all"
    GET = "get"
    LIST = "list"
    DELETE = "delete"
    SET = "set"
    UPDATE = "update"
    REGENERATEKEY = "regeneratekey"
    RECOVER = "recover"
    PURGE = "purge"
    BACKUP = "backup"
    RESTORE = "restore"
    SETSAS = "setsas"
    LISTSAS = "listsas"
    GETSAS = "getsas"
    DELETESAS = "deletesas"
