# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetLoadTestProfileMappingResult',
    'AwaitableGetLoadTestProfileMappingResult',
    'get_load_test_profile_mapping',
    'get_load_test_profile_mapping_output',
]

@pulumi.output_type
class GetLoadTestProfileMappingResult:
    """
    LoadTest profile mapping resource details
    """
    def __init__(__self__, azure_api_version=None, azure_load_testing_resource_id=None, id=None, name=None, source_resource_id=None, system_data=None, test_profile_id=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if azure_load_testing_resource_id and not isinstance(azure_load_testing_resource_id, str):
            raise TypeError("Expected argument 'azure_load_testing_resource_id' to be a str")
        pulumi.set(__self__, "azure_load_testing_resource_id", azure_load_testing_resource_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if source_resource_id and not isinstance(source_resource_id, str):
            raise TypeError("Expected argument 'source_resource_id' to be a str")
        pulumi.set(__self__, "source_resource_id", source_resource_id)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if test_profile_id and not isinstance(test_profile_id, str):
            raise TypeError("Expected argument 'test_profile_id' to be a str")
        pulumi.set(__self__, "test_profile_id", test_profile_id)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="azureLoadTestingResourceId")
    def azure_load_testing_resource_id(self) -> Optional[builtins.str]:
        """
        Mapped Azure Load Test resource Id.
        """
        return pulumi.get(self, "azure_load_testing_resource_id")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> Optional[builtins.str]:
        """
        Mapped source resource Id.
        """
        return pulumi.get(self, "source_resource_id")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="testProfileId")
    def test_profile_id(self) -> Optional[builtins.str]:
        """
        Mapped Azure Load Test resource test-profile-id.
        """
        return pulumi.get(self, "test_profile_id")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")


class AwaitableGetLoadTestProfileMappingResult(GetLoadTestProfileMappingResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLoadTestProfileMappingResult(
            azure_api_version=self.azure_api_version,
            azure_load_testing_resource_id=self.azure_load_testing_resource_id,
            id=self.id,
            name=self.name,
            source_resource_id=self.source_resource_id,
            system_data=self.system_data,
            test_profile_id=self.test_profile_id,
            type=self.type)


def get_load_test_profile_mapping(load_test_profile_mapping_name: Optional[builtins.str] = None,
                                  resource_uri: Optional[builtins.str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLoadTestProfileMappingResult:
    """
    Get a LoadTestProfileMappingResource

    Uses Azure REST API version 2023-12-01-preview.

    Other available API versions: 2024-12-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native loadtestservice [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str load_test_profile_mapping_name: Load Test Profile Mapping name
    :param builtins.str resource_uri: The fully qualified Azure Resource manager identifier of the resource.
    """
    __args__ = dict()
    __args__['loadTestProfileMappingName'] = load_test_profile_mapping_name
    __args__['resourceUri'] = resource_uri
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:loadtestservice:getLoadTestProfileMapping', __args__, opts=opts, typ=GetLoadTestProfileMappingResult).value

    return AwaitableGetLoadTestProfileMappingResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        azure_load_testing_resource_id=pulumi.get(__ret__, 'azure_load_testing_resource_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        source_resource_id=pulumi.get(__ret__, 'source_resource_id'),
        system_data=pulumi.get(__ret__, 'system_data'),
        test_profile_id=pulumi.get(__ret__, 'test_profile_id'),
        type=pulumi.get(__ret__, 'type'))
def get_load_test_profile_mapping_output(load_test_profile_mapping_name: Optional[pulumi.Input[builtins.str]] = None,
                                         resource_uri: Optional[pulumi.Input[builtins.str]] = None,
                                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetLoadTestProfileMappingResult]:
    """
    Get a LoadTestProfileMappingResource

    Uses Azure REST API version 2023-12-01-preview.

    Other available API versions: 2024-12-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native loadtestservice [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str load_test_profile_mapping_name: Load Test Profile Mapping name
    :param builtins.str resource_uri: The fully qualified Azure Resource manager identifier of the resource.
    """
    __args__ = dict()
    __args__['loadTestProfileMappingName'] = load_test_profile_mapping_name
    __args__['resourceUri'] = resource_uri
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:loadtestservice:getLoadTestProfileMapping', __args__, opts=opts, typ=GetLoadTestProfileMappingResult)
    return __ret__.apply(lambda __response__: GetLoadTestProfileMappingResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        azure_load_testing_resource_id=pulumi.get(__response__, 'azure_load_testing_resource_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        source_resource_id=pulumi.get(__response__, 'source_resource_id'),
        system_data=pulumi.get(__response__, 'system_data'),
        test_profile_id=pulumi.get(__response__, 'test_profile_id'),
        type=pulumi.get(__response__, 'type')))
