# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetIntegrationAccountCertificateResult',
    'AwaitableGetIntegrationAccountCertificateResult',
    'get_integration_account_certificate',
    'get_integration_account_certificate_output',
]

@pulumi.output_type
class GetIntegrationAccountCertificateResult:
    """
    The integration account certificate.
    """
    def __init__(__self__, azure_api_version=None, changed_time=None, created_time=None, id=None, key=None, location=None, metadata=None, name=None, public_certificate=None, tags=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if changed_time and not isinstance(changed_time, str):
            raise TypeError("Expected argument 'changed_time' to be a str")
        pulumi.set(__self__, "changed_time", changed_time)
        if created_time and not isinstance(created_time, str):
            raise TypeError("Expected argument 'created_time' to be a str")
        pulumi.set(__self__, "created_time", created_time)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if key and not isinstance(key, dict):
            raise TypeError("Expected argument 'key' to be a dict")
        pulumi.set(__self__, "key", key)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if metadata and not isinstance(metadata, dict):
            raise TypeError("Expected argument 'metadata' to be a dict")
        pulumi.set(__self__, "metadata", metadata)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if public_certificate and not isinstance(public_certificate, str):
            raise TypeError("Expected argument 'public_certificate' to be a str")
        pulumi.set(__self__, "public_certificate", public_certificate)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="changedTime")
    def changed_time(self) -> builtins.str:
        """
        The changed time.
        """
        return pulumi.get(self, "changed_time")

    @property
    @pulumi.getter(name="createdTime")
    def created_time(self) -> builtins.str:
        """
        The created time.
        """
        return pulumi.get(self, "created_time")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The resource id.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def key(self) -> Optional['outputs.KeyVaultKeyReferenceResponse']:
        """
        The key details in the key vault.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def location(self) -> Optional[builtins.str]:
        """
        The resource location.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def metadata(self) -> Optional[Any]:
        """
        The metadata.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Gets the resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="publicCertificate")
    def public_certificate(self) -> Optional[builtins.str]:
        """
        The public certificate.
        """
        return pulumi.get(self, "public_certificate")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, builtins.str]]:
        """
        The resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Gets the resource type.
        """
        return pulumi.get(self, "type")


class AwaitableGetIntegrationAccountCertificateResult(GetIntegrationAccountCertificateResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIntegrationAccountCertificateResult(
            azure_api_version=self.azure_api_version,
            changed_time=self.changed_time,
            created_time=self.created_time,
            id=self.id,
            key=self.key,
            location=self.location,
            metadata=self.metadata,
            name=self.name,
            public_certificate=self.public_certificate,
            tags=self.tags,
            type=self.type)


def get_integration_account_certificate(certificate_name: Optional[builtins.str] = None,
                                        integration_account_name: Optional[builtins.str] = None,
                                        resource_group_name: Optional[builtins.str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIntegrationAccountCertificateResult:
    """
    Gets an integration account certificate.

    Uses Azure REST API version 2019-05-01.

    Other available API versions: 2015-08-01-preview, 2018-07-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native logic [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str certificate_name: The integration account certificate name.
    :param builtins.str integration_account_name: The integration account name.
    :param builtins.str resource_group_name: The resource group name.
    """
    __args__ = dict()
    __args__['certificateName'] = certificate_name
    __args__['integrationAccountName'] = integration_account_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:logic:getIntegrationAccountCertificate', __args__, opts=opts, typ=GetIntegrationAccountCertificateResult).value

    return AwaitableGetIntegrationAccountCertificateResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        changed_time=pulumi.get(__ret__, 'changed_time'),
        created_time=pulumi.get(__ret__, 'created_time'),
        id=pulumi.get(__ret__, 'id'),
        key=pulumi.get(__ret__, 'key'),
        location=pulumi.get(__ret__, 'location'),
        metadata=pulumi.get(__ret__, 'metadata'),
        name=pulumi.get(__ret__, 'name'),
        public_certificate=pulumi.get(__ret__, 'public_certificate'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'))
def get_integration_account_certificate_output(certificate_name: Optional[pulumi.Input[builtins.str]] = None,
                                               integration_account_name: Optional[pulumi.Input[builtins.str]] = None,
                                               resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetIntegrationAccountCertificateResult]:
    """
    Gets an integration account certificate.

    Uses Azure REST API version 2019-05-01.

    Other available API versions: 2015-08-01-preview, 2018-07-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native logic [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str certificate_name: The integration account certificate name.
    :param builtins.str integration_account_name: The integration account name.
    :param builtins.str resource_group_name: The resource group name.
    """
    __args__ = dict()
    __args__['certificateName'] = certificate_name
    __args__['integrationAccountName'] = integration_account_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:logic:getIntegrationAccountCertificate', __args__, opts=opts, typ=GetIntegrationAccountCertificateResult)
    return __ret__.apply(lambda __response__: GetIntegrationAccountCertificateResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        changed_time=pulumi.get(__response__, 'changed_time'),
        created_time=pulumi.get(__response__, 'created_time'),
        id=pulumi.get(__response__, 'id'),
        key=pulumi.get(__response__, 'key'),
        location=pulumi.get(__response__, 'location'),
        metadata=pulumi.get(__response__, 'metadata'),
        name=pulumi.get(__response__, 'name'),
        public_certificate=pulumi.get(__response__, 'public_certificate'),
        tags=pulumi.get(__response__, 'tags'),
        type=pulumi.get(__response__, 'type')))
