# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListWorkflowAccessKeySecretKeysResult',
    'AwaitableListWorkflowAccessKeySecretKeysResult',
    'list_workflow_access_key_secret_keys',
    'list_workflow_access_key_secret_keys_output',
]

@pulumi.output_type
class ListWorkflowAccessKeySecretKeysResult:
    def __init__(__self__, primary_secret_key=None, secondary_secret_key=None):
        if primary_secret_key and not isinstance(primary_secret_key, str):
            raise TypeError("Expected argument 'primary_secret_key' to be a str")
        pulumi.set(__self__, "primary_secret_key", primary_secret_key)
        if secondary_secret_key and not isinstance(secondary_secret_key, str):
            raise TypeError("Expected argument 'secondary_secret_key' to be a str")
        pulumi.set(__self__, "secondary_secret_key", secondary_secret_key)

    @property
    @pulumi.getter(name="primarySecretKey")
    def primary_secret_key(self) -> builtins.str:
        """
        Gets the primary secret key.
        """
        return pulumi.get(self, "primary_secret_key")

    @property
    @pulumi.getter(name="secondarySecretKey")
    def secondary_secret_key(self) -> builtins.str:
        """
        Gets the secondary secret key.
        """
        return pulumi.get(self, "secondary_secret_key")


class AwaitableListWorkflowAccessKeySecretKeysResult(ListWorkflowAccessKeySecretKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListWorkflowAccessKeySecretKeysResult(
            primary_secret_key=self.primary_secret_key,
            secondary_secret_key=self.secondary_secret_key)


def list_workflow_access_key_secret_keys(access_key_name: Optional[builtins.str] = None,
                                         resource_group_name: Optional[builtins.str] = None,
                                         workflow_name: Optional[builtins.str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListWorkflowAccessKeySecretKeysResult:
    """
    Lists secret keys.

    Uses Azure REST API version 2015-02-01-preview.


    :param builtins.str access_key_name: The workflow access key name.
    :param builtins.str resource_group_name: The resource group name.
    :param builtins.str workflow_name: The workflow name.
    """
    __args__ = dict()
    __args__['accessKeyName'] = access_key_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workflowName'] = workflow_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:logic:listWorkflowAccessKeySecretKeys', __args__, opts=opts, typ=ListWorkflowAccessKeySecretKeysResult).value

    return AwaitableListWorkflowAccessKeySecretKeysResult(
        primary_secret_key=pulumi.get(__ret__, 'primary_secret_key'),
        secondary_secret_key=pulumi.get(__ret__, 'secondary_secret_key'))
def list_workflow_access_key_secret_keys_output(access_key_name: Optional[pulumi.Input[builtins.str]] = None,
                                                resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                workflow_name: Optional[pulumi.Input[builtins.str]] = None,
                                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListWorkflowAccessKeySecretKeysResult]:
    """
    Lists secret keys.

    Uses Azure REST API version 2015-02-01-preview.


    :param builtins.str access_key_name: The workflow access key name.
    :param builtins.str resource_group_name: The resource group name.
    :param builtins.str workflow_name: The workflow name.
    """
    __args__ = dict()
    __args__['accessKeyName'] = access_key_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workflowName'] = workflow_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:logic:listWorkflowAccessKeySecretKeys', __args__, opts=opts, typ=ListWorkflowAccessKeySecretKeysResult)
    return __ret__.apply(lambda __response__: ListWorkflowAccessKeySecretKeysResult(
        primary_secret_key=pulumi.get(__response__, 'primary_secret_key'),
        secondary_secret_key=pulumi.get(__response__, 'secondary_secret_key')))
