# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ConnectionRaiBlocklistArgs', 'ConnectionRaiBlocklist']

@pulumi.input_type
class ConnectionRaiBlocklistArgs:
    def __init__(__self__, *,
                 connection_name: pulumi.Input[builtins.str],
                 properties: pulumi.Input['RaiBlocklistPropertiesArgs'],
                 resource_group_name: pulumi.Input[builtins.str],
                 workspace_name: pulumi.Input[builtins.str],
                 proxy_api_version: Optional[pulumi.Input[builtins.str]] = None,
                 rai_blocklist_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a ConnectionRaiBlocklist resource.
        :param pulumi.Input[builtins.str] connection_name: Friendly name of the workspace connection
        :param pulumi.Input['RaiBlocklistPropertiesArgs'] properties: RAI Custom Blocklist properties.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] workspace_name: Azure Machine Learning Workspace Name
        :param pulumi.Input[builtins.str] proxy_api_version: Api version used by proxy call
        :param pulumi.Input[builtins.str] rai_blocklist_name: The name of the RaiBlocklist.
        """
        pulumi.set(__self__, "connection_name", connection_name)
        pulumi.set(__self__, "properties", properties)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "workspace_name", workspace_name)
        if proxy_api_version is not None:
            pulumi.set(__self__, "proxy_api_version", proxy_api_version)
        if rai_blocklist_name is not None:
            pulumi.set(__self__, "rai_blocklist_name", rai_blocklist_name)

    @property
    @pulumi.getter(name="connectionName")
    def connection_name(self) -> pulumi.Input[builtins.str]:
        """
        Friendly name of the workspace connection
        """
        return pulumi.get(self, "connection_name")

    @connection_name.setter
    def connection_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "connection_name", value)

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Input['RaiBlocklistPropertiesArgs']:
        """
        RAI Custom Blocklist properties.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: pulumi.Input['RaiBlocklistPropertiesArgs']):
        pulumi.set(self, "properties", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="workspaceName")
    def workspace_name(self) -> pulumi.Input[builtins.str]:
        """
        Azure Machine Learning Workspace Name
        """
        return pulumi.get(self, "workspace_name")

    @workspace_name.setter
    def workspace_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "workspace_name", value)

    @property
    @pulumi.getter(name="proxyApiVersion")
    def proxy_api_version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Api version used by proxy call
        """
        return pulumi.get(self, "proxy_api_version")

    @proxy_api_version.setter
    def proxy_api_version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "proxy_api_version", value)

    @property
    @pulumi.getter(name="raiBlocklistName")
    def rai_blocklist_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the RaiBlocklist.
        """
        return pulumi.get(self, "rai_blocklist_name")

    @rai_blocklist_name.setter
    def rai_blocklist_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "rai_blocklist_name", value)


@pulumi.type_token("azure-native:machinelearningservices:ConnectionRaiBlocklist")
class ConnectionRaiBlocklist(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 connection_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['RaiBlocklistPropertiesArgs', 'RaiBlocklistPropertiesArgsDict']]] = None,
                 proxy_api_version: Optional[pulumi.Input[builtins.str]] = None,
                 rai_blocklist_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Uses Azure REST API version 2025-01-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-04-01-preview.

        Other available API versions: 2024-07-01-preview, 2024-10-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native machinelearningservices [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] connection_name: Friendly name of the workspace connection
        :param pulumi.Input[Union['RaiBlocklistPropertiesArgs', 'RaiBlocklistPropertiesArgsDict']] properties: RAI Custom Blocklist properties.
        :param pulumi.Input[builtins.str] proxy_api_version: Api version used by proxy call
        :param pulumi.Input[builtins.str] rai_blocklist_name: The name of the RaiBlocklist.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] workspace_name: Azure Machine Learning Workspace Name
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConnectionRaiBlocklistArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Uses Azure REST API version 2025-01-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-04-01-preview.

        Other available API versions: 2024-07-01-preview, 2024-10-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native machinelearningservices [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param ConnectionRaiBlocklistArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConnectionRaiBlocklistArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 connection_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['RaiBlocklistPropertiesArgs', 'RaiBlocklistPropertiesArgsDict']]] = None,
                 proxy_api_version: Optional[pulumi.Input[builtins.str]] = None,
                 rai_blocklist_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConnectionRaiBlocklistArgs.__new__(ConnectionRaiBlocklistArgs)

            if connection_name is None and not opts.urn:
                raise TypeError("Missing required property 'connection_name'")
            __props__.__dict__["connection_name"] = connection_name
            if properties is None and not opts.urn:
                raise TypeError("Missing required property 'properties'")
            __props__.__dict__["properties"] = properties
            __props__.__dict__["proxy_api_version"] = proxy_api_version
            __props__.__dict__["rai_blocklist_name"] = rai_blocklist_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if workspace_name is None and not opts.urn:
                raise TypeError("Missing required property 'workspace_name'")
            __props__.__dict__["workspace_name"] = workspace_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:machinelearningservices/v20240401preview:ConnectionRaiBlocklist"), pulumi.Alias(type_="azure-native:machinelearningservices/v20240401preview:ConnectionRaiBlocklistItem"), pulumi.Alias(type_="azure-native:machinelearningservices/v20240701preview:ConnectionRaiBlocklist"), pulumi.Alias(type_="azure-native:machinelearningservices/v20241001preview:ConnectionRaiBlocklist"), pulumi.Alias(type_="azure-native:machinelearningservices/v20250101preview:ConnectionRaiBlocklist"), pulumi.Alias(type_="azure-native:machinelearningservices:ConnectionRaiBlocklistItem")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(ConnectionRaiBlocklist, __self__).__init__(
            'azure-native:machinelearningservices:ConnectionRaiBlocklist',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'ConnectionRaiBlocklist':
        """
        Get an existing ConnectionRaiBlocklist resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ConnectionRaiBlocklistArgs.__new__(ConnectionRaiBlocklistArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return ConnectionRaiBlocklist(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.RaiBlocklistPropertiesResponse']:
        """
        RAI Custom Blocklist properties.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

