# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetComputeAllowedResizeSizesResult',
    'AwaitableGetComputeAllowedResizeSizesResult',
    'get_compute_allowed_resize_sizes',
    'get_compute_allowed_resize_sizes_output',
]

@pulumi.output_type
class GetComputeAllowedResizeSizesResult:
    """
    The List Virtual Machine size operation response.
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.VirtualMachineSizeResponse']]:
        """
        The list of virtual machine sizes supported by AmlCompute.
        """
        return pulumi.get(self, "value")


class AwaitableGetComputeAllowedResizeSizesResult(GetComputeAllowedResizeSizesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetComputeAllowedResizeSizesResult(
            value=self.value)


def get_compute_allowed_resize_sizes(compute_name: Optional[builtins.str] = None,
                                     resource_group_name: Optional[builtins.str] = None,
                                     workspace_name: Optional[builtins.str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetComputeAllowedResizeSizesResult:
    """
    Returns supported virtual machine sizes for resize

    Uses Azure REST API version 2025-01-01-preview.

    Other available API versions: 2023-08-01-preview, 2024-01-01-preview, 2024-07-01-preview, 2024-10-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native machinelearningservices [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str compute_name: Name of the Azure Machine Learning compute.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str workspace_name: Name of Azure Machine Learning workspace.
    """
    __args__ = dict()
    __args__['computeName'] = compute_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:machinelearningservices:getComputeAllowedResizeSizes', __args__, opts=opts, typ=GetComputeAllowedResizeSizesResult).value

    return AwaitableGetComputeAllowedResizeSizesResult(
        value=pulumi.get(__ret__, 'value'))
def get_compute_allowed_resize_sizes_output(compute_name: Optional[pulumi.Input[builtins.str]] = None,
                                            resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                            workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetComputeAllowedResizeSizesResult]:
    """
    Returns supported virtual machine sizes for resize

    Uses Azure REST API version 2025-01-01-preview.

    Other available API versions: 2023-08-01-preview, 2024-01-01-preview, 2024-07-01-preview, 2024-10-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native machinelearningservices [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str compute_name: Name of the Azure Machine Learning compute.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str workspace_name: Name of Azure Machine Learning workspace.
    """
    __args__ = dict()
    __args__['computeName'] = compute_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:machinelearningservices:getComputeAllowedResizeSizes', __args__, opts=opts, typ=GetComputeAllowedResizeSizesResult)
    return __ret__.apply(lambda __response__: GetComputeAllowedResizeSizesResult(
        value=pulumi.get(__response__, 'value')))
