# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'GetOnlineDeploymentLogsResult',
    'AwaitableGetOnlineDeploymentLogsResult',
    'get_online_deployment_logs',
    'get_online_deployment_logs_output',
]

@pulumi.output_type
class GetOnlineDeploymentLogsResult:
    def __init__(__self__, content=None):
        if content and not isinstance(content, str):
            raise TypeError("Expected argument 'content' to be a str")
        pulumi.set(__self__, "content", content)

    @property
    @pulumi.getter
    def content(self) -> Optional[builtins.str]:
        """
        The retrieved online deployment logs.
        """
        return pulumi.get(self, "content")


class AwaitableGetOnlineDeploymentLogsResult(GetOnlineDeploymentLogsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOnlineDeploymentLogsResult(
            content=self.content)


def get_online_deployment_logs(container_type: Optional[Union[builtins.str, 'ContainerType']] = None,
                               deployment_name: Optional[builtins.str] = None,
                               endpoint_name: Optional[builtins.str] = None,
                               resource_group_name: Optional[builtins.str] = None,
                               tail: Optional[builtins.int] = None,
                               workspace_name: Optional[builtins.str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOnlineDeploymentLogsResult:
    """
    Uses Azure REST API version 2024-10-01.

    Other available API versions: 2021-03-01-preview, 2022-02-01-preview, 2022-05-01, 2022-06-01-preview, 2022-10-01, 2022-10-01-preview, 2022-12-01-preview, 2023-02-01-preview, 2023-04-01, 2023-04-01-preview, 2023-06-01-preview, 2023-08-01-preview, 2023-10-01, 2024-01-01-preview, 2024-04-01, 2024-07-01-preview, 2024-10-01-preview, 2025-01-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native machinelearningservices [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param Union[builtins.str, 'ContainerType'] container_type: The type of container to retrieve logs from.
    :param builtins.str deployment_name: The name and identifier for the endpoint.
    :param builtins.str endpoint_name: Inference endpoint name.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.int tail: The maximum number of lines to tail.
    :param builtins.str workspace_name: Name of Azure Machine Learning workspace.
    """
    __args__ = dict()
    __args__['containerType'] = container_type
    __args__['deploymentName'] = deployment_name
    __args__['endpointName'] = endpoint_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['tail'] = tail
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:machinelearningservices:getOnlineDeploymentLogs', __args__, opts=opts, typ=GetOnlineDeploymentLogsResult).value

    return AwaitableGetOnlineDeploymentLogsResult(
        content=pulumi.get(__ret__, 'content'))
def get_online_deployment_logs_output(container_type: Optional[pulumi.Input[Optional[Union[builtins.str, 'ContainerType']]]] = None,
                                      deployment_name: Optional[pulumi.Input[builtins.str]] = None,
                                      endpoint_name: Optional[pulumi.Input[builtins.str]] = None,
                                      resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                      tail: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                                      workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetOnlineDeploymentLogsResult]:
    """
    Uses Azure REST API version 2024-10-01.

    Other available API versions: 2021-03-01-preview, 2022-02-01-preview, 2022-05-01, 2022-06-01-preview, 2022-10-01, 2022-10-01-preview, 2022-12-01-preview, 2023-02-01-preview, 2023-04-01, 2023-04-01-preview, 2023-06-01-preview, 2023-08-01-preview, 2023-10-01, 2024-01-01-preview, 2024-04-01, 2024-07-01-preview, 2024-10-01-preview, 2025-01-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native machinelearningservices [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param Union[builtins.str, 'ContainerType'] container_type: The type of container to retrieve logs from.
    :param builtins.str deployment_name: The name and identifier for the endpoint.
    :param builtins.str endpoint_name: Inference endpoint name.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.int tail: The maximum number of lines to tail.
    :param builtins.str workspace_name: Name of Azure Machine Learning workspace.
    """
    __args__ = dict()
    __args__['containerType'] = container_type
    __args__['deploymentName'] = deployment_name
    __args__['endpointName'] = endpoint_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['tail'] = tail
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:machinelearningservices:getOnlineDeploymentLogs', __args__, opts=opts, typ=GetOnlineDeploymentLogsResult)
    return __ret__.apply(lambda __response__: GetOnlineDeploymentLogsResult(
        content=pulumi.get(__response__, 'content')))
