# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListEndpointKeysResult',
    'AwaitableListEndpointKeysResult',
    'list_endpoint_keys',
    'list_endpoint_keys_output',
]

@pulumi.output_type
class ListEndpointKeysResult:
    def __init__(__self__, keys=None):
        if keys and not isinstance(keys, dict):
            raise TypeError("Expected argument 'keys' to be a dict")
        pulumi.set(__self__, "keys", keys)

    @property
    @pulumi.getter
    def keys(self) -> Optional['outputs.AccountApiKeysResponse']:
        """
        Dictionary of Keys for the endpoint.
        """
        return pulumi.get(self, "keys")


class AwaitableListEndpointKeysResult(ListEndpointKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListEndpointKeysResult(
            keys=self.keys)


def list_endpoint_keys(endpoint_name: Optional[builtins.str] = None,
                       resource_group_name: Optional[builtins.str] = None,
                       workspace_name: Optional[builtins.str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListEndpointKeysResult:
    """
    Uses Azure REST API version 2025-01-01-preview.

    Other available API versions: 2024-01-01-preview, 2024-07-01-preview, 2024-10-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native machinelearningservices [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str endpoint_name: Name of the endpoint resource.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str workspace_name: Azure Machine Learning Workspace Name
    """
    __args__ = dict()
    __args__['endpointName'] = endpoint_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:machinelearningservices:listEndpointKeys', __args__, opts=opts, typ=ListEndpointKeysResult).value

    return AwaitableListEndpointKeysResult(
        keys=pulumi.get(__ret__, 'keys'))
def list_endpoint_keys_output(endpoint_name: Optional[pulumi.Input[builtins.str]] = None,
                              resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                              workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListEndpointKeysResult]:
    """
    Uses Azure REST API version 2025-01-01-preview.

    Other available API versions: 2024-01-01-preview, 2024-07-01-preview, 2024-10-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native machinelearningservices [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str endpoint_name: Name of the endpoint resource.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str workspace_name: Azure Machine Learning Workspace Name
    """
    __args__ = dict()
    __args__['endpointName'] = endpoint_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:machinelearningservices:listEndpointKeys', __args__, opts=opts, typ=ListEndpointKeysResult)
    return __ret__.apply(lambda __response__: ListEndpointKeysResult(
        keys=pulumi.get(__response__, 'keys')))
