# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AclActionType',
    'Action',
    'AddressFamilyType',
    'AllowASOverride',
    'BooleanEnumProperty',
    'CommunityActionTypes',
    'Condition',
    'ConfigurationType',
    'DestinationType',
    'Encapsulation',
    'EncapsulationType',
    'Extension',
    'GatewayType',
    'IPAddressType',
    'IsManagementType',
    'IsMonitoringEnabled',
    'IsWorkloadManagementNetworkEnabled',
    'Layer4Protocol',
    'NetworkRackType',
    'NfcSku',
    'NniType',
    'PeeringOption',
    'PollingType',
    'PortType',
    'PrefixType',
    'RedistributeConnectedSubnets',
    'RedistributeStaticRoutes',
    'RoutePolicyActionType',
    'RoutePolicyConditionType',
    'SourceDestinationType',
    'TapRuleActionType',
    'WellKnownCommunities',
]


@pulumi.type_token("azure-native:managednetworkfabric:AclActionType")
class AclActionType(builtins.str, Enum):
    """
    Type of actions that can be performed.
    """
    DROP = "Drop"
    COUNT = "Count"
    LOG = "Log"


@pulumi.type_token("azure-native:managednetworkfabric:Action")
class Action(builtins.str, Enum):
    """
    Specify action.
    """
    ALLOW = "Allow"
    DENY = "Deny"


@pulumi.type_token("azure-native:managednetworkfabric:AddressFamilyType")
class AddressFamilyType(builtins.str, Enum):
    """
    AddressFamilyType. This parameter decides whether the given ipv4 or ipv6 route policy.
    """
    I_PV4 = "IPv4"
    I_PV6 = "IPv6"


@pulumi.type_token("azure-native:managednetworkfabric:AllowASOverride")
class AllowASOverride(builtins.str, Enum):
    """
    Enable Or Disable state.
    """
    ENABLE = "Enable"
    DISABLE = "Disable"


@pulumi.type_token("azure-native:managednetworkfabric:BooleanEnumProperty")
class BooleanEnumProperty(builtins.str, Enum):
    """
    Based on this option layer3 parameters are mandatory. Example: True/False
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:managednetworkfabric:CommunityActionTypes")
class CommunityActionTypes(builtins.str, Enum):
    """
    Default action that needs to be applied when no condition is matched. Example: Permit | Deny.
    """
    PERMIT = "Permit"
    DENY = "Deny"


@pulumi.type_token("azure-native:managednetworkfabric:Condition")
class Condition(builtins.str, Enum):
    """
    Specify prefix-list bounds.
    """
    EQUAL_TO = "EqualTo"
    GREATER_THAN_OR_EQUAL_TO = "GreaterThanOrEqualTo"
    LESSER_THAN_OR_EQUAL_TO = "LesserThanOrEqualTo"
    RANGE = "Range"


@pulumi.type_token("azure-native:managednetworkfabric:ConfigurationType")
class ConfigurationType(builtins.str, Enum):
    """
    Input method to configure Network Tap Rule.
    """
    FILE = "File"
    INLINE = "Inline"


@pulumi.type_token("azure-native:managednetworkfabric:DestinationType")
class DestinationType(builtins.str, Enum):
    """
    Type of destination. Input can be IsolationDomain or Direct.
    """
    ISOLATION_DOMAIN = "IsolationDomain"
    DIRECT = "Direct"


@pulumi.type_token("azure-native:managednetworkfabric:Encapsulation")
class Encapsulation(builtins.str, Enum):
    """
    Type of encapsulation.
    """
    NONE = "None"
    GRE = "GRE"


@pulumi.type_token("azure-native:managednetworkfabric:EncapsulationType")
class EncapsulationType(builtins.str, Enum):
    """
    Encapsulation Type that needs to be matched.
    """
    NONE = "None"
    GT_PV1 = "GTPv1"


@pulumi.type_token("azure-native:managednetworkfabric:Extension")
class Extension(builtins.str, Enum):
    """
    Extension. Example: NoExtension | NPB.
    """
    NO_EXTENSION = "NoExtension"
    NPB = "NPB"


@pulumi.type_token("azure-native:managednetworkfabric:GatewayType")
class GatewayType(builtins.str, Enum):
    """
    Gateway Type of the resource.
    """
    INFRASTRUCTURE = "Infrastructure"
    WORKLOAD = "Workload"


@pulumi.type_token("azure-native:managednetworkfabric:IPAddressType")
class IPAddressType(builtins.str, Enum):
    """
    Type of IP Address. IPv4 or IPv6
    """
    I_PV4 = "IPv4"
    I_PV6 = "IPv6"


@pulumi.type_token("azure-native:managednetworkfabric:IsManagementType")
class IsManagementType(builtins.str, Enum):
    """
    Configuration to use NNI for Infrastructure Management. Example: True/False.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:managednetworkfabric:IsMonitoringEnabled")
class IsMonitoringEnabled(builtins.str, Enum):
    """
    To check whether monitoring of internal network is enabled or not.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:managednetworkfabric:IsWorkloadManagementNetworkEnabled")
class IsWorkloadManagementNetworkEnabled(builtins.str, Enum):
    """
    A workload management network is required for all the tenant (workload) traffic. This traffic is only dedicated for Tenant workloads which are required to access internet or any other MSFT/Public endpoints.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:managednetworkfabric:Layer4Protocol")
class Layer4Protocol(builtins.str, Enum):
    """
    Layer4 protocol type that needs to be matched.
    """
    TCP = "TCP"
    UDP = "UDP"


@pulumi.type_token("azure-native:managednetworkfabric:NetworkRackType")
class NetworkRackType(builtins.str, Enum):
    """
    Network Rack SKU name.
    """
    AGGREGATE = "Aggregate"
    COMPUTE = "Compute"
    COMBINED = "Combined"


@pulumi.type_token("azure-native:managednetworkfabric:NfcSku")
class NfcSku(builtins.str, Enum):
    """
    Network Fabric Controller SKU.
    """
    BASIC = "Basic"
    STANDARD = "Standard"
    HIGH_PERFORMANCE = "HighPerformance"


@pulumi.type_token("azure-native:managednetworkfabric:NniType")
class NniType(builtins.str, Enum):
    """
    Type of NNI used. Example: CE | NPB
    """
    CE = "CE"
    NPB = "NPB"


@pulumi.type_token("azure-native:managednetworkfabric:PeeringOption")
class PeeringOption(builtins.str, Enum):
    """
    Peering option list.
    """
    OPTION_A = "OptionA"
    OPTION_B = "OptionB"


@pulumi.type_token("azure-native:managednetworkfabric:PollingType")
class PollingType(builtins.str, Enum):
    """
    Polling type.
    """
    PULL = "Pull"
    PUSH = "Push"


@pulumi.type_token("azure-native:managednetworkfabric:PortType")
class PortType(builtins.str, Enum):
    """
    Port type that needs to be matched.
    """
    SOURCE_PORT = "SourcePort"
    DESTINATION_PORT = "DestinationPort"


@pulumi.type_token("azure-native:managednetworkfabric:PrefixType")
class PrefixType(builtins.str, Enum):
    """
    IP Prefix Type that needs to be matched.
    """
    PREFIX = "Prefix"
    LONGEST_PREFIX = "LongestPrefix"


@pulumi.type_token("azure-native:managednetworkfabric:RedistributeConnectedSubnets")
class RedistributeConnectedSubnets(builtins.str, Enum):
    """
    Advertise Connected Subnets. Ex: "True" | "False".
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:managednetworkfabric:RedistributeStaticRoutes")
class RedistributeStaticRoutes(builtins.str, Enum):
    """
    Advertise Static Routes. Ex: "True" | "False".
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:managednetworkfabric:RoutePolicyActionType")
class RoutePolicyActionType(builtins.str, Enum):
    """
    Action type. Example: Permit | Deny | Continue.
    """
    PERMIT = "Permit"
    DENY = "Deny"
    CONTINUE_ = "Continue"


@pulumi.type_token("azure-native:managednetworkfabric:RoutePolicyConditionType")
class RoutePolicyConditionType(builtins.str, Enum):
    """
    Type of the condition used.
    """
    OR_ = "Or"
    AND_ = "And"


@pulumi.type_token("azure-native:managednetworkfabric:SourceDestinationType")
class SourceDestinationType(builtins.str, Enum):
    """
    IP Address type that needs to be matched.
    """
    SOURCE_IP = "SourceIP"
    DESTINATION_IP = "DestinationIP"


@pulumi.type_token("azure-native:managednetworkfabric:TapRuleActionType")
class TapRuleActionType(builtins.str, Enum):
    """
    Type of actions that can be performed.
    """
    DROP = "Drop"
    COUNT = "Count"
    LOG = "Log"
    REPLICATE = "Replicate"
    GOTO = "Goto"
    REDIRECT = "Redirect"
    MIRROR = "Mirror"


@pulumi.type_token("azure-native:managednetworkfabric:WellKnownCommunities")
class WellKnownCommunities(builtins.str, Enum):
    """

    `Internet` - Advertise routes to internet community.
     `LocalAS` - Advertise routes to only localAS peers.
     `NoAdvertise` - Don't advertise routes to any peer.
    `NoExport` - Don't export to next AS.
    `GShut` - Graceful Shutdown (GSHUT) withdraw routes before terminating BGP connection.
    """
    INTERNET = "Internet"
    LOCAL_AS = "LocalAS"
    NO_ADVERTISE = "NoAdvertise"
    NO_EXPORT = "NoExport"
    G_SHUT = "GShut"
