# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListServiceGroupAncestorsResult',
    'AwaitableListServiceGroupAncestorsResult',
    'list_service_group_ancestors',
    'list_service_group_ancestors_output',
]

@pulumi.output_type
class ListServiceGroupAncestorsResult:
    """
    Response holding an array of service groups and a nextLink that supports pagination
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> Optional[builtins.str]:
        """
        URL to query the next page of results for this request
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.ServiceGroupResponse']]:
        """
        Array of service groups based on the request criteria
        """
        return pulumi.get(self, "value")


class AwaitableListServiceGroupAncestorsResult(ListServiceGroupAncestorsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListServiceGroupAncestorsResult(
            next_link=self.next_link,
            value=self.value)


def list_service_group_ancestors(service_group_name: Optional[builtins.str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListServiceGroupAncestorsResult:
    """
    Get the details of the serviceGroup's ancestors

    Uses Azure REST API version 2024-02-01-preview.


    :param builtins.str service_group_name: ServiceGroup Name.
    """
    __args__ = dict()
    __args__['serviceGroupName'] = service_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:management:listServiceGroupAncestors', __args__, opts=opts, typ=ListServiceGroupAncestorsResult).value

    return AwaitableListServiceGroupAncestorsResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))
def list_service_group_ancestors_output(service_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListServiceGroupAncestorsResult]:
    """
    Get the details of the serviceGroup's ancestors

    Uses Azure REST API version 2024-02-01-preview.


    :param builtins.str service_group_name: ServiceGroup Name.
    """
    __args__ = dict()
    __args__['serviceGroupName'] = service_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:management:listServiceGroupAncestors', __args__, opts=opts, typ=ListServiceGroupAncestorsResult)
    return __ret__.apply(lambda __response__: ListServiceGroupAncestorsResult(
        next_link=pulumi.get(__response__, 'next_link'),
        value=pulumi.get(__response__, 'value')))
