# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'ListAccountSasResult',
    'AwaitableListAccountSasResult',
    'list_account_sas',
    'list_account_sas_output',
]

@pulumi.output_type
class ListAccountSasResult:
    """
    A new Sas token which can be used to access the Maps REST APIs and is controlled by the specified Managed identity permissions on Azure (IAM) Role Based Access Control.
    """
    def __init__(__self__, account_sas_token=None):
        if account_sas_token and not isinstance(account_sas_token, str):
            raise TypeError("Expected argument 'account_sas_token' to be a str")
        pulumi.set(__self__, "account_sas_token", account_sas_token)

    @property
    @pulumi.getter(name="accountSasToken")
    def account_sas_token(self) -> builtins.str:
        """
        The shared access signature access token.
        """
        return pulumi.get(self, "account_sas_token")


class AwaitableListAccountSasResult(ListAccountSasResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListAccountSasResult(
            account_sas_token=self.account_sas_token)


def list_account_sas(account_name: Optional[builtins.str] = None,
                     expiry: Optional[builtins.str] = None,
                     max_rate_per_second: Optional[builtins.int] = None,
                     principal_id: Optional[builtins.str] = None,
                     regions: Optional[Sequence[builtins.str]] = None,
                     resource_group_name: Optional[builtins.str] = None,
                     signing_key: Optional[Union[builtins.str, 'SigningKey']] = None,
                     start: Optional[builtins.str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListAccountSasResult:
    """
    Create and list an account shared access signature token. Use this SAS token for authentication to Azure Maps REST APIs through various Azure Maps SDKs. As prerequisite to create a SAS Token.

    Prerequisites:
    1. Create or have an existing User Assigned Managed Identity in the same Azure region as the account.
    2. Create or update an Azure Maps account with the same Azure region as the User Assigned Managed Identity is placed.

    Uses Azure REST API version 2024-07-01-preview.

    Other available API versions: 2021-12-01-preview, 2023-06-01, 2023-08-01-preview, 2023-12-01-preview, 2024-01-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native maps [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str account_name: The name of the Maps Account.
    :param builtins.str expiry: The date time offset of when the token validity expires. For example "2017-05-24T10:42:03.1567373Z". Maximum duration allowed is 24 hours between `start` and `expiry`.
    :param builtins.int max_rate_per_second: Required parameter which represents the desired maximum request per second to allowed for the given SAS token. This does not guarantee perfect accuracy in measurements but provides application safe guards of abuse with eventual enforcement.
    :param builtins.str principal_id: The principal Id also known as the object Id of a User Assigned Managed Identity currently assigned to the Maps Account. To assign a Managed Identity of the account, use operation Create or Update an assign a User Assigned Identity resource Id.
    :param Sequence[builtins.str] regions: Optional, allows control of which region locations are permitted access to Azure Maps REST APIs with the SAS token. Example: "eastus", "westus2". Omitting this parameter will allow all region locations to be accessible.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param Union[builtins.str, 'SigningKey'] signing_key: The Maps account key to use for signing. Picking `primaryKey` or `secondaryKey` will use the Maps account Shared Keys, and using `managedIdentity` will use the auto-renewed private key to sign the SAS.
    :param builtins.str start: The date time offset of when the token validity begins. For example "2017-05-24T10:42:03.1567373Z". Maximum duration allowed is 24 hours between `start` and `expiry`.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['expiry'] = expiry
    __args__['maxRatePerSecond'] = max_rate_per_second
    __args__['principalId'] = principal_id
    __args__['regions'] = regions
    __args__['resourceGroupName'] = resource_group_name
    __args__['signingKey'] = signing_key
    __args__['start'] = start
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:maps:listAccountSas', __args__, opts=opts, typ=ListAccountSasResult).value

    return AwaitableListAccountSasResult(
        account_sas_token=pulumi.get(__ret__, 'account_sas_token'))
def list_account_sas_output(account_name: Optional[pulumi.Input[builtins.str]] = None,
                            expiry: Optional[pulumi.Input[builtins.str]] = None,
                            max_rate_per_second: Optional[pulumi.Input[builtins.int]] = None,
                            principal_id: Optional[pulumi.Input[builtins.str]] = None,
                            regions: Optional[pulumi.Input[Optional[Sequence[builtins.str]]]] = None,
                            resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                            signing_key: Optional[pulumi.Input[Union[builtins.str, 'SigningKey']]] = None,
                            start: Optional[pulumi.Input[builtins.str]] = None,
                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListAccountSasResult]:
    """
    Create and list an account shared access signature token. Use this SAS token for authentication to Azure Maps REST APIs through various Azure Maps SDKs. As prerequisite to create a SAS Token.

    Prerequisites:
    1. Create or have an existing User Assigned Managed Identity in the same Azure region as the account.
    2. Create or update an Azure Maps account with the same Azure region as the User Assigned Managed Identity is placed.

    Uses Azure REST API version 2024-07-01-preview.

    Other available API versions: 2021-12-01-preview, 2023-06-01, 2023-08-01-preview, 2023-12-01-preview, 2024-01-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native maps [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str account_name: The name of the Maps Account.
    :param builtins.str expiry: The date time offset of when the token validity expires. For example "2017-05-24T10:42:03.1567373Z". Maximum duration allowed is 24 hours between `start` and `expiry`.
    :param builtins.int max_rate_per_second: Required parameter which represents the desired maximum request per second to allowed for the given SAS token. This does not guarantee perfect accuracy in measurements but provides application safe guards of abuse with eventual enforcement.
    :param builtins.str principal_id: The principal Id also known as the object Id of a User Assigned Managed Identity currently assigned to the Maps Account. To assign a Managed Identity of the account, use operation Create or Update an assign a User Assigned Identity resource Id.
    :param Sequence[builtins.str] regions: Optional, allows control of which region locations are permitted access to Azure Maps REST APIs with the SAS token. Example: "eastus", "westus2". Omitting this parameter will allow all region locations to be accessible.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param Union[builtins.str, 'SigningKey'] signing_key: The Maps account key to use for signing. Picking `primaryKey` or `secondaryKey` will use the Maps account Shared Keys, and using `managedIdentity` will use the auto-renewed private key to sign the SAS.
    :param builtins.str start: The date time offset of when the token validity begins. For example "2017-05-24T10:42:03.1567373Z". Maximum duration allowed is 24 hours between `start` and `expiry`.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['expiry'] = expiry
    __args__['maxRatePerSecond'] = max_rate_per_second
    __args__['principalId'] = principal_id
    __args__['regions'] = regions
    __args__['resourceGroupName'] = resource_group_name
    __args__['signingKey'] = signing_key
    __args__['start'] = start
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:maps:listAccountSas', __args__, opts=opts, typ=ListAccountSasResult)
    return __ret__.apply(lambda __response__: ListAccountSasResult(
        account_sas_token=pulumi.get(__response__, 'account_sas_token')))
