# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetVMwareCollectorResult',
    'AwaitableGetVMwareCollectorResult',
    'get_v_mware_collector',
    'get_v_mware_collector_output',
]

@pulumi.output_type
class GetVMwareCollectorResult:
    def __init__(__self__, azure_api_version=None, e_tag=None, id=None, name=None, properties=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if e_tag and not isinstance(e_tag, str):
            raise TypeError("Expected argument 'e_tag' to be a str")
        pulumi.set(__self__, "e_tag", e_tag)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="eTag")
    def e_tag(self) -> Optional[builtins.str]:
        return pulumi.get(self, "e_tag")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.CollectorPropertiesResponse':
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        return pulumi.get(self, "type")


class AwaitableGetVMwareCollectorResult(GetVMwareCollectorResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVMwareCollectorResult(
            azure_api_version=self.azure_api_version,
            e_tag=self.e_tag,
            id=self.id,
            name=self.name,
            properties=self.properties,
            type=self.type)


def get_v_mware_collector(project_name: Optional[builtins.str] = None,
                          resource_group_name: Optional[builtins.str] = None,
                          vm_ware_collector_name: Optional[builtins.str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVMwareCollectorResult:
    """
    Get a VMware collector.

    Uses Azure REST API version 2019-10-01.


    :param builtins.str project_name: Name of the Azure Migrate project.
    :param builtins.str resource_group_name: Name of the Azure Resource Group that project is part of.
    :param builtins.str vm_ware_collector_name: Unique name of a VMware collector within a project.
    """
    __args__ = dict()
    __args__['projectName'] = project_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['vmWareCollectorName'] = vm_ware_collector_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:migrate:getVMwareCollector', __args__, opts=opts, typ=GetVMwareCollectorResult).value

    return AwaitableGetVMwareCollectorResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        e_tag=pulumi.get(__ret__, 'e_tag'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        properties=pulumi.get(__ret__, 'properties'),
        type=pulumi.get(__ret__, 'type'))
def get_v_mware_collector_output(project_name: Optional[pulumi.Input[builtins.str]] = None,
                                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                 vm_ware_collector_name: Optional[pulumi.Input[builtins.str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetVMwareCollectorResult]:
    """
    Get a VMware collector.

    Uses Azure REST API version 2019-10-01.


    :param builtins.str project_name: Name of the Azure Migrate project.
    :param builtins.str resource_group_name: Name of the Azure Resource Group that project is part of.
    :param builtins.str vm_ware_collector_name: Unique name of a VMware collector within a project.
    """
    __args__ = dict()
    __args__['projectName'] = project_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['vmWareCollectorName'] = vm_ware_collector_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:migrate:getVMwareCollector', __args__, opts=opts, typ=GetVMwareCollectorResult)
    return __ret__.apply(lambda __response__: GetVMwareCollectorResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        e_tag=pulumi.get(__response__, 'e_tag'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        properties=pulumi.get(__response__, 'properties'),
        type=pulumi.get(__response__, 'type')))
