# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListRemoteRenderingAccountKeysResult',
    'AwaitableListRemoteRenderingAccountKeysResult',
    'list_remote_rendering_account_keys',
    'list_remote_rendering_account_keys_output',
]

@pulumi.output_type
class ListRemoteRenderingAccountKeysResult:
    """
    Developer Keys of account
    """
    def __init__(__self__, primary_key=None, secondary_key=None):
        if primary_key and not isinstance(primary_key, str):
            raise TypeError("Expected argument 'primary_key' to be a str")
        pulumi.set(__self__, "primary_key", primary_key)
        if secondary_key and not isinstance(secondary_key, str):
            raise TypeError("Expected argument 'secondary_key' to be a str")
        pulumi.set(__self__, "secondary_key", secondary_key)

    @property
    @pulumi.getter(name="primaryKey")
    def primary_key(self) -> builtins.str:
        """
        value of primary key.
        """
        return pulumi.get(self, "primary_key")

    @property
    @pulumi.getter(name="secondaryKey")
    def secondary_key(self) -> builtins.str:
        """
        value of secondary key.
        """
        return pulumi.get(self, "secondary_key")


class AwaitableListRemoteRenderingAccountKeysResult(ListRemoteRenderingAccountKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListRemoteRenderingAccountKeysResult(
            primary_key=self.primary_key,
            secondary_key=self.secondary_key)


def list_remote_rendering_account_keys(account_name: Optional[builtins.str] = None,
                                       resource_group_name: Optional[builtins.str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListRemoteRenderingAccountKeysResult:
    """
    > [!NOTE]
    > 
    > **Mixed Reality retirement**
    > 
    > The Mixed Reality service is now deprecated and will be retired.

     List Both of the 2 Keys of a Remote Rendering Account

    Uses Azure REST API version 2021-03-01-preview.

    Other available API versions: 2021-01-01, 2025-01-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native mixedreality [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str account_name: Name of an Mixed Reality Account.
    :param builtins.str resource_group_name: Name of an Azure resource group.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:mixedreality:listRemoteRenderingAccountKeys', __args__, opts=opts, typ=ListRemoteRenderingAccountKeysResult).value

    return AwaitableListRemoteRenderingAccountKeysResult(
        primary_key=pulumi.get(__ret__, 'primary_key'),
        secondary_key=pulumi.get(__ret__, 'secondary_key'))
def list_remote_rendering_account_keys_output(account_name: Optional[pulumi.Input[builtins.str]] = None,
                                              resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListRemoteRenderingAccountKeysResult]:
    """
    > [!NOTE]
    > 
    > **Mixed Reality retirement**
    > 
    > The Mixed Reality service is now deprecated and will be retired.

     List Both of the 2 Keys of a Remote Rendering Account

    Uses Azure REST API version 2021-03-01-preview.

    Other available API versions: 2021-01-01, 2025-01-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native mixedreality [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str account_name: Name of an Mixed Reality Account.
    :param builtins.str resource_group_name: Name of an Azure resource group.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:mixedreality:listRemoteRenderingAccountKeys', __args__, opts=opts, typ=ListRemoteRenderingAccountKeysResult)
    return __ret__.apply(lambda __response__: ListRemoteRenderingAccountKeysResult(
        primary_key=pulumi.get(__response__, 'primary_key'),
        secondary_key=pulumi.get(__response__, 'secondary_key')))
