# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = [
    'AdministratorPropertiesArgs',
    'AdministratorPropertiesArgsDict',
    'ComputePropertiesArgs',
    'ComputePropertiesArgsDict',
    'FirewallRulePropertiesArgs',
    'FirewallRulePropertiesArgsDict',
    'HighAvailabilityPropertiesArgs',
    'HighAvailabilityPropertiesArgsDict',
    'MongoClusterPropertiesArgs',
    'MongoClusterPropertiesArgsDict',
    'MongoClusterReplicaParametersArgs',
    'MongoClusterReplicaParametersArgsDict',
    'MongoClusterRestoreParametersArgs',
    'MongoClusterRestoreParametersArgsDict',
    'PrivateEndpointConnectionPropertiesArgs',
    'PrivateEndpointConnectionPropertiesArgsDict',
    'PrivateLinkServiceConnectionStateArgs',
    'PrivateLinkServiceConnectionStateArgsDict',
    'ShardingPropertiesArgs',
    'ShardingPropertiesArgsDict',
    'StoragePropertiesArgs',
    'StoragePropertiesArgsDict',
]

MYPY = False

if not MYPY:
    class AdministratorPropertiesArgsDict(TypedDict):
        """
        The local administrator login properties.
        """
        password: NotRequired[pulumi.Input[builtins.str]]
        """
        The administrator password.
        """
        user_name: NotRequired[pulumi.Input[builtins.str]]
        """
        The administrator user name.
        """
elif False:
    AdministratorPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class AdministratorPropertiesArgs:
    def __init__(__self__, *,
                 password: Optional[pulumi.Input[builtins.str]] = None,
                 user_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The local administrator login properties.
        :param pulumi.Input[builtins.str] password: The administrator password.
        :param pulumi.Input[builtins.str] user_name: The administrator user name.
        """
        if password is not None:
            pulumi.set(__self__, "password", password)
        if user_name is not None:
            pulumi.set(__self__, "user_name", user_name)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The administrator password.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="userName")
    def user_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The administrator user name.
        """
        return pulumi.get(self, "user_name")

    @user_name.setter
    def user_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_name", value)


if not MYPY:
    class ComputePropertiesArgsDict(TypedDict):
        """
        The compute properties of the cluster. This includes the virtual-cores/memory and scaling options applied to servers in the cluster.
        """
        tier: NotRequired[pulumi.Input[builtins.str]]
        """
        The compute tier to assign to the cluster, where each tier maps to a virtual-core and memory size. Example values: 'M30', 'M40'.
        """
elif False:
    ComputePropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ComputePropertiesArgs:
    def __init__(__self__, *,
                 tier: Optional[pulumi.Input[builtins.str]] = None):
        """
        The compute properties of the cluster. This includes the virtual-cores/memory and scaling options applied to servers in the cluster.
        :param pulumi.Input[builtins.str] tier: The compute tier to assign to the cluster, where each tier maps to a virtual-core and memory size. Example values: 'M30', 'M40'.
        """
        if tier is not None:
            pulumi.set(__self__, "tier", tier)

    @property
    @pulumi.getter
    def tier(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The compute tier to assign to the cluster, where each tier maps to a virtual-core and memory size. Example values: 'M30', 'M40'.
        """
        return pulumi.get(self, "tier")

    @tier.setter
    def tier(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "tier", value)


if not MYPY:
    class FirewallRulePropertiesArgsDict(TypedDict):
        """
        The properties of a mongo cluster firewall rule.
        """
        end_ip_address: pulumi.Input[builtins.str]
        """
        The end IP address of the mongo cluster firewall rule. Must be IPv4 format.
        """
        start_ip_address: pulumi.Input[builtins.str]
        """
        The start IP address of the mongo cluster firewall rule. Must be IPv4 format.
        """
elif False:
    FirewallRulePropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class FirewallRulePropertiesArgs:
    def __init__(__self__, *,
                 end_ip_address: pulumi.Input[builtins.str],
                 start_ip_address: pulumi.Input[builtins.str]):
        """
        The properties of a mongo cluster firewall rule.
        :param pulumi.Input[builtins.str] end_ip_address: The end IP address of the mongo cluster firewall rule. Must be IPv4 format.
        :param pulumi.Input[builtins.str] start_ip_address: The start IP address of the mongo cluster firewall rule. Must be IPv4 format.
        """
        pulumi.set(__self__, "end_ip_address", end_ip_address)
        pulumi.set(__self__, "start_ip_address", start_ip_address)

    @property
    @pulumi.getter(name="endIpAddress")
    def end_ip_address(self) -> pulumi.Input[builtins.str]:
        """
        The end IP address of the mongo cluster firewall rule. Must be IPv4 format.
        """
        return pulumi.get(self, "end_ip_address")

    @end_ip_address.setter
    def end_ip_address(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "end_ip_address", value)

    @property
    @pulumi.getter(name="startIpAddress")
    def start_ip_address(self) -> pulumi.Input[builtins.str]:
        """
        The start IP address of the mongo cluster firewall rule. Must be IPv4 format.
        """
        return pulumi.get(self, "start_ip_address")

    @start_ip_address.setter
    def start_ip_address(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "start_ip_address", value)


if not MYPY:
    class HighAvailabilityPropertiesArgsDict(TypedDict):
        """
        The high availability properties of the cluster.
        """
        target_mode: NotRequired[pulumi.Input[Union[builtins.str, 'HighAvailabilityMode']]]
        """
        The target high availability mode requested for the cluster.
        """
elif False:
    HighAvailabilityPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class HighAvailabilityPropertiesArgs:
    def __init__(__self__, *,
                 target_mode: Optional[pulumi.Input[Union[builtins.str, 'HighAvailabilityMode']]] = None):
        """
        The high availability properties of the cluster.
        :param pulumi.Input[Union[builtins.str, 'HighAvailabilityMode']] target_mode: The target high availability mode requested for the cluster.
        """
        if target_mode is not None:
            pulumi.set(__self__, "target_mode", target_mode)

    @property
    @pulumi.getter(name="targetMode")
    def target_mode(self) -> Optional[pulumi.Input[Union[builtins.str, 'HighAvailabilityMode']]]:
        """
        The target high availability mode requested for the cluster.
        """
        return pulumi.get(self, "target_mode")

    @target_mode.setter
    def target_mode(self, value: Optional[pulumi.Input[Union[builtins.str, 'HighAvailabilityMode']]]):
        pulumi.set(self, "target_mode", value)


if not MYPY:
    class MongoClusterPropertiesArgsDict(TypedDict):
        """
        The properties of a mongo cluster.
        """
        administrator: NotRequired[pulumi.Input['AdministratorPropertiesArgsDict']]
        """
        The local administrator properties for the mongo cluster.
        """
        compute: NotRequired[pulumi.Input['ComputePropertiesArgsDict']]
        """
        The compute properties of the mongo cluster.
        """
        create_mode: NotRequired[pulumi.Input[Union[builtins.str, 'CreateMode']]]
        """
        The mode to create a mongo cluster.
        """
        high_availability: NotRequired[pulumi.Input['HighAvailabilityPropertiesArgsDict']]
        """
        The high availability properties of the mongo cluster.
        """
        preview_features: NotRequired[pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'PreviewFeature']]]]]
        """
        List of private endpoint connections.
        """
        public_network_access: NotRequired[pulumi.Input[Union[builtins.str, 'PublicNetworkAccess']]]
        """
        Whether or not public endpoint access is allowed for this mongo cluster.
        """
        replica_parameters: NotRequired[pulumi.Input['MongoClusterReplicaParametersArgsDict']]
        """
        The parameters to create a replica mongo cluster.
        """
        restore_parameters: NotRequired[pulumi.Input['MongoClusterRestoreParametersArgsDict']]
        """
        The parameters to create a point-in-time restore mongo cluster.
        """
        server_version: NotRequired[pulumi.Input[builtins.str]]
        """
        The Mongo DB server version. Defaults to the latest available version if not specified.
        """
        sharding: NotRequired[pulumi.Input['ShardingPropertiesArgsDict']]
        """
        The sharding properties of the mongo cluster.
        """
        storage: NotRequired[pulumi.Input['StoragePropertiesArgsDict']]
        """
        The storage properties of the mongo cluster.
        """
elif False:
    MongoClusterPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class MongoClusterPropertiesArgs:
    def __init__(__self__, *,
                 administrator: Optional[pulumi.Input['AdministratorPropertiesArgs']] = None,
                 compute: Optional[pulumi.Input['ComputePropertiesArgs']] = None,
                 create_mode: Optional[pulumi.Input[Union[builtins.str, 'CreateMode']]] = None,
                 high_availability: Optional[pulumi.Input['HighAvailabilityPropertiesArgs']] = None,
                 preview_features: Optional[pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'PreviewFeature']]]]] = None,
                 public_network_access: Optional[pulumi.Input[Union[builtins.str, 'PublicNetworkAccess']]] = None,
                 replica_parameters: Optional[pulumi.Input['MongoClusterReplicaParametersArgs']] = None,
                 restore_parameters: Optional[pulumi.Input['MongoClusterRestoreParametersArgs']] = None,
                 server_version: Optional[pulumi.Input[builtins.str]] = None,
                 sharding: Optional[pulumi.Input['ShardingPropertiesArgs']] = None,
                 storage: Optional[pulumi.Input['StoragePropertiesArgs']] = None):
        """
        The properties of a mongo cluster.
        :param pulumi.Input['AdministratorPropertiesArgs'] administrator: The local administrator properties for the mongo cluster.
        :param pulumi.Input['ComputePropertiesArgs'] compute: The compute properties of the mongo cluster.
        :param pulumi.Input[Union[builtins.str, 'CreateMode']] create_mode: The mode to create a mongo cluster.
        :param pulumi.Input['HighAvailabilityPropertiesArgs'] high_availability: The high availability properties of the mongo cluster.
        :param pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'PreviewFeature']]]] preview_features: List of private endpoint connections.
        :param pulumi.Input[Union[builtins.str, 'PublicNetworkAccess']] public_network_access: Whether or not public endpoint access is allowed for this mongo cluster.
        :param pulumi.Input['MongoClusterReplicaParametersArgs'] replica_parameters: The parameters to create a replica mongo cluster.
        :param pulumi.Input['MongoClusterRestoreParametersArgs'] restore_parameters: The parameters to create a point-in-time restore mongo cluster.
        :param pulumi.Input[builtins.str] server_version: The Mongo DB server version. Defaults to the latest available version if not specified.
        :param pulumi.Input['ShardingPropertiesArgs'] sharding: The sharding properties of the mongo cluster.
        :param pulumi.Input['StoragePropertiesArgs'] storage: The storage properties of the mongo cluster.
        """
        if administrator is not None:
            pulumi.set(__self__, "administrator", administrator)
        if compute is not None:
            pulumi.set(__self__, "compute", compute)
        if create_mode is not None:
            pulumi.set(__self__, "create_mode", create_mode)
        if high_availability is not None:
            pulumi.set(__self__, "high_availability", high_availability)
        if preview_features is not None:
            pulumi.set(__self__, "preview_features", preview_features)
        if public_network_access is not None:
            pulumi.set(__self__, "public_network_access", public_network_access)
        if replica_parameters is not None:
            pulumi.set(__self__, "replica_parameters", replica_parameters)
        if restore_parameters is not None:
            pulumi.set(__self__, "restore_parameters", restore_parameters)
        if server_version is not None:
            pulumi.set(__self__, "server_version", server_version)
        if sharding is not None:
            pulumi.set(__self__, "sharding", sharding)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)

    @property
    @pulumi.getter
    def administrator(self) -> Optional[pulumi.Input['AdministratorPropertiesArgs']]:
        """
        The local administrator properties for the mongo cluster.
        """
        return pulumi.get(self, "administrator")

    @administrator.setter
    def administrator(self, value: Optional[pulumi.Input['AdministratorPropertiesArgs']]):
        pulumi.set(self, "administrator", value)

    @property
    @pulumi.getter
    def compute(self) -> Optional[pulumi.Input['ComputePropertiesArgs']]:
        """
        The compute properties of the mongo cluster.
        """
        return pulumi.get(self, "compute")

    @compute.setter
    def compute(self, value: Optional[pulumi.Input['ComputePropertiesArgs']]):
        pulumi.set(self, "compute", value)

    @property
    @pulumi.getter(name="createMode")
    def create_mode(self) -> Optional[pulumi.Input[Union[builtins.str, 'CreateMode']]]:
        """
        The mode to create a mongo cluster.
        """
        return pulumi.get(self, "create_mode")

    @create_mode.setter
    def create_mode(self, value: Optional[pulumi.Input[Union[builtins.str, 'CreateMode']]]):
        pulumi.set(self, "create_mode", value)

    @property
    @pulumi.getter(name="highAvailability")
    def high_availability(self) -> Optional[pulumi.Input['HighAvailabilityPropertiesArgs']]:
        """
        The high availability properties of the mongo cluster.
        """
        return pulumi.get(self, "high_availability")

    @high_availability.setter
    def high_availability(self, value: Optional[pulumi.Input['HighAvailabilityPropertiesArgs']]):
        pulumi.set(self, "high_availability", value)

    @property
    @pulumi.getter(name="previewFeatures")
    def preview_features(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'PreviewFeature']]]]]:
        """
        List of private endpoint connections.
        """
        return pulumi.get(self, "preview_features")

    @preview_features.setter
    def preview_features(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[Union[builtins.str, 'PreviewFeature']]]]]):
        pulumi.set(self, "preview_features", value)

    @property
    @pulumi.getter(name="publicNetworkAccess")
    def public_network_access(self) -> Optional[pulumi.Input[Union[builtins.str, 'PublicNetworkAccess']]]:
        """
        Whether or not public endpoint access is allowed for this mongo cluster.
        """
        return pulumi.get(self, "public_network_access")

    @public_network_access.setter
    def public_network_access(self, value: Optional[pulumi.Input[Union[builtins.str, 'PublicNetworkAccess']]]):
        pulumi.set(self, "public_network_access", value)

    @property
    @pulumi.getter(name="replicaParameters")
    def replica_parameters(self) -> Optional[pulumi.Input['MongoClusterReplicaParametersArgs']]:
        """
        The parameters to create a replica mongo cluster.
        """
        return pulumi.get(self, "replica_parameters")

    @replica_parameters.setter
    def replica_parameters(self, value: Optional[pulumi.Input['MongoClusterReplicaParametersArgs']]):
        pulumi.set(self, "replica_parameters", value)

    @property
    @pulumi.getter(name="restoreParameters")
    def restore_parameters(self) -> Optional[pulumi.Input['MongoClusterRestoreParametersArgs']]:
        """
        The parameters to create a point-in-time restore mongo cluster.
        """
        return pulumi.get(self, "restore_parameters")

    @restore_parameters.setter
    def restore_parameters(self, value: Optional[pulumi.Input['MongoClusterRestoreParametersArgs']]):
        pulumi.set(self, "restore_parameters", value)

    @property
    @pulumi.getter(name="serverVersion")
    def server_version(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Mongo DB server version. Defaults to the latest available version if not specified.
        """
        return pulumi.get(self, "server_version")

    @server_version.setter
    def server_version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "server_version", value)

    @property
    @pulumi.getter
    def sharding(self) -> Optional[pulumi.Input['ShardingPropertiesArgs']]:
        """
        The sharding properties of the mongo cluster.
        """
        return pulumi.get(self, "sharding")

    @sharding.setter
    def sharding(self, value: Optional[pulumi.Input['ShardingPropertiesArgs']]):
        pulumi.set(self, "sharding", value)

    @property
    @pulumi.getter
    def storage(self) -> Optional[pulumi.Input['StoragePropertiesArgs']]:
        """
        The storage properties of the mongo cluster.
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: Optional[pulumi.Input['StoragePropertiesArgs']]):
        pulumi.set(self, "storage", value)


if not MYPY:
    class MongoClusterReplicaParametersArgsDict(TypedDict):
        """
        Parameters used for replica operations.
        """
        source_location: pulumi.Input[builtins.str]
        """
        The location of the source cluster
        """
        source_resource_id: pulumi.Input[builtins.str]
        """
        The id of the replication source cluster.
        """
elif False:
    MongoClusterReplicaParametersArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class MongoClusterReplicaParametersArgs:
    def __init__(__self__, *,
                 source_location: pulumi.Input[builtins.str],
                 source_resource_id: pulumi.Input[builtins.str]):
        """
        Parameters used for replica operations.
        :param pulumi.Input[builtins.str] source_location: The location of the source cluster
        :param pulumi.Input[builtins.str] source_resource_id: The id of the replication source cluster.
        """
        pulumi.set(__self__, "source_location", source_location)
        pulumi.set(__self__, "source_resource_id", source_resource_id)

    @property
    @pulumi.getter(name="sourceLocation")
    def source_location(self) -> pulumi.Input[builtins.str]:
        """
        The location of the source cluster
        """
        return pulumi.get(self, "source_location")

    @source_location.setter
    def source_location(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "source_location", value)

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> pulumi.Input[builtins.str]:
        """
        The id of the replication source cluster.
        """
        return pulumi.get(self, "source_resource_id")

    @source_resource_id.setter
    def source_resource_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "source_resource_id", value)


if not MYPY:
    class MongoClusterRestoreParametersArgsDict(TypedDict):
        """
        Parameters used for restore operations
        """
        point_in_time_utc: NotRequired[pulumi.Input[builtins.str]]
        """
        UTC point in time to restore a mongo cluster
        """
        source_resource_id: NotRequired[pulumi.Input[builtins.str]]
        """
        Resource ID to locate the source cluster to restore
        """
elif False:
    MongoClusterRestoreParametersArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class MongoClusterRestoreParametersArgs:
    def __init__(__self__, *,
                 point_in_time_utc: Optional[pulumi.Input[builtins.str]] = None,
                 source_resource_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Parameters used for restore operations
        :param pulumi.Input[builtins.str] point_in_time_utc: UTC point in time to restore a mongo cluster
        :param pulumi.Input[builtins.str] source_resource_id: Resource ID to locate the source cluster to restore
        """
        if point_in_time_utc is not None:
            pulumi.set(__self__, "point_in_time_utc", point_in_time_utc)
        if source_resource_id is not None:
            pulumi.set(__self__, "source_resource_id", source_resource_id)

    @property
    @pulumi.getter(name="pointInTimeUTC")
    def point_in_time_utc(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        UTC point in time to restore a mongo cluster
        """
        return pulumi.get(self, "point_in_time_utc")

    @point_in_time_utc.setter
    def point_in_time_utc(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "point_in_time_utc", value)

    @property
    @pulumi.getter(name="sourceResourceId")
    def source_resource_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Resource ID to locate the source cluster to restore
        """
        return pulumi.get(self, "source_resource_id")

    @source_resource_id.setter
    def source_resource_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "source_resource_id", value)


if not MYPY:
    class PrivateEndpointConnectionPropertiesArgsDict(TypedDict):
        """
        Properties of the private endpoint connection.
        """
        private_link_service_connection_state: pulumi.Input['PrivateLinkServiceConnectionStateArgsDict']
        """
        A collection of information about the state of the connection between service consumer and provider.
        """
elif False:
    PrivateEndpointConnectionPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class PrivateEndpointConnectionPropertiesArgs:
    def __init__(__self__, *,
                 private_link_service_connection_state: pulumi.Input['PrivateLinkServiceConnectionStateArgs']):
        """
        Properties of the private endpoint connection.
        :param pulumi.Input['PrivateLinkServiceConnectionStateArgs'] private_link_service_connection_state: A collection of information about the state of the connection between service consumer and provider.
        """
        pulumi.set(__self__, "private_link_service_connection_state", private_link_service_connection_state)

    @property
    @pulumi.getter(name="privateLinkServiceConnectionState")
    def private_link_service_connection_state(self) -> pulumi.Input['PrivateLinkServiceConnectionStateArgs']:
        """
        A collection of information about the state of the connection between service consumer and provider.
        """
        return pulumi.get(self, "private_link_service_connection_state")

    @private_link_service_connection_state.setter
    def private_link_service_connection_state(self, value: pulumi.Input['PrivateLinkServiceConnectionStateArgs']):
        pulumi.set(self, "private_link_service_connection_state", value)


if not MYPY:
    class PrivateLinkServiceConnectionStateArgsDict(TypedDict):
        """
        A collection of information about the state of the connection between service consumer and provider.
        """
        actions_required: NotRequired[pulumi.Input[builtins.str]]
        """
        A message indicating if changes on the service provider require any updates on the consumer.
        """
        description: NotRequired[pulumi.Input[builtins.str]]
        """
        The reason for approval/rejection of the connection.
        """
        status: NotRequired[pulumi.Input[Union[builtins.str, 'PrivateEndpointServiceConnectionStatus']]]
        """
        Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
        """
elif False:
    PrivateLinkServiceConnectionStateArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class PrivateLinkServiceConnectionStateArgs:
    def __init__(__self__, *,
                 actions_required: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 status: Optional[pulumi.Input[Union[builtins.str, 'PrivateEndpointServiceConnectionStatus']]] = None):
        """
        A collection of information about the state of the connection between service consumer and provider.
        :param pulumi.Input[builtins.str] actions_required: A message indicating if changes on the service provider require any updates on the consumer.
        :param pulumi.Input[builtins.str] description: The reason for approval/rejection of the connection.
        :param pulumi.Input[Union[builtins.str, 'PrivateEndpointServiceConnectionStatus']] status: Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
        """
        if actions_required is not None:
            pulumi.set(__self__, "actions_required", actions_required)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="actionsRequired")
    def actions_required(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A message indicating if changes on the service provider require any updates on the consumer.
        """
        return pulumi.get(self, "actions_required")

    @actions_required.setter
    def actions_required(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "actions_required", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The reason for approval/rejection of the connection.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[Union[builtins.str, 'PrivateEndpointServiceConnectionStatus']]]:
        """
        Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[Union[builtins.str, 'PrivateEndpointServiceConnectionStatus']]]):
        pulumi.set(self, "status", value)


if not MYPY:
    class ShardingPropertiesArgsDict(TypedDict):
        """
        The sharding properties of the cluster. This includes the shard count and scaling options for the cluster.
        """
        shard_count: NotRequired[pulumi.Input[builtins.int]]
        """
        Number of shards to provision on the cluster.
        """
elif False:
    ShardingPropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class ShardingPropertiesArgs:
    def __init__(__self__, *,
                 shard_count: Optional[pulumi.Input[builtins.int]] = None):
        """
        The sharding properties of the cluster. This includes the shard count and scaling options for the cluster.
        :param pulumi.Input[builtins.int] shard_count: Number of shards to provision on the cluster.
        """
        if shard_count is not None:
            pulumi.set(__self__, "shard_count", shard_count)

    @property
    @pulumi.getter(name="shardCount")
    def shard_count(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Number of shards to provision on the cluster.
        """
        return pulumi.get(self, "shard_count")

    @shard_count.setter
    def shard_count(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "shard_count", value)


if not MYPY:
    class StoragePropertiesArgsDict(TypedDict):
        """
        The storage properties of the cluster. This includes the data storage size and scaling applied to servers in the cluster.
        """
        size_gb: NotRequired[pulumi.Input[builtins.float]]
        """
        The size of the data disk assigned to each server.
        """
elif False:
    StoragePropertiesArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class StoragePropertiesArgs:
    def __init__(__self__, *,
                 size_gb: Optional[pulumi.Input[builtins.float]] = None):
        """
        The storage properties of the cluster. This includes the data storage size and scaling applied to servers in the cluster.
        :param pulumi.Input[builtins.float] size_gb: The size of the data disk assigned to each server.
        """
        if size_gb is not None:
            pulumi.set(__self__, "size_gb", size_gb)

    @property
    @pulumi.getter(name="sizeGb")
    def size_gb(self) -> Optional[pulumi.Input[builtins.float]]:
        """
        The size of the data disk assigned to each server.
        """
        return pulumi.get(self, "size_gb")

    @size_gb.setter
    def size_gb(self, value: Optional[pulumi.Input[builtins.float]]):
        pulumi.set(self, "size_gb", value)


