# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListMongoClusterConnectionStringsResult',
    'AwaitableListMongoClusterConnectionStringsResult',
    'list_mongo_cluster_connection_strings',
    'list_mongo_cluster_connection_strings_output',
]

@pulumi.output_type
class ListMongoClusterConnectionStringsResult:
    """
    The connection strings for the given mongo cluster.
    """
    def __init__(__self__, connection_strings=None):
        if connection_strings and not isinstance(connection_strings, list):
            raise TypeError("Expected argument 'connection_strings' to be a list")
        pulumi.set(__self__, "connection_strings", connection_strings)

    @property
    @pulumi.getter(name="connectionStrings")
    def connection_strings(self) -> Sequence['outputs.ConnectionStringResponse']:
        """
        An array that contains the connection strings for a mongo cluster.
        """
        return pulumi.get(self, "connection_strings")


class AwaitableListMongoClusterConnectionStringsResult(ListMongoClusterConnectionStringsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListMongoClusterConnectionStringsResult(
            connection_strings=self.connection_strings)


def list_mongo_cluster_connection_strings(mongo_cluster_name: Optional[builtins.str] = None,
                                          resource_group_name: Optional[builtins.str] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListMongoClusterConnectionStringsResult:
    """
    List mongo cluster connection strings. This includes the default connection string using SCRAM-SHA-256, as well as other connection strings supported by the cluster.

    Uses Azure REST API version 2024-07-01.

    Other available API versions: 2024-03-01-preview, 2024-06-01-preview, 2024-10-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native mongocluster [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str mongo_cluster_name: The name of the mongo cluster.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['mongoClusterName'] = mongo_cluster_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:mongocluster:listMongoClusterConnectionStrings', __args__, opts=opts, typ=ListMongoClusterConnectionStringsResult).value

    return AwaitableListMongoClusterConnectionStringsResult(
        connection_strings=pulumi.get(__ret__, 'connection_strings'))
def list_mongo_cluster_connection_strings_output(mongo_cluster_name: Optional[pulumi.Input[builtins.str]] = None,
                                                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListMongoClusterConnectionStringsResult]:
    """
    List mongo cluster connection strings. This includes the default connection string using SCRAM-SHA-256, as well as other connection strings supported by the cluster.

    Uses Azure REST API version 2024-07-01.

    Other available API versions: 2024-03-01-preview, 2024-06-01-preview, 2024-10-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native mongocluster [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str mongo_cluster_name: The name of the mongo cluster.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    """
    __args__ = dict()
    __args__['mongoClusterName'] = mongo_cluster_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:mongocluster:listMongoClusterConnectionStrings', __args__, opts=opts, typ=ListMongoClusterConnectionStringsResult)
    return __ret__.apply(lambda __response__: ListMongoClusterConnectionStringsResult(
        connection_strings=pulumi.get(__response__, 'connection_strings')))
