# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AccessMode',
    'AggregationTypeEnum',
    'ComparisonOperationType',
    'ConditionOperator',
    'CriterionType',
    'DimensionOperator',
    'DynamicThresholdOperator',
    'DynamicThresholdSensitivity',
    'ExporterType',
    'ExtendedLocationType',
    'ExternalNetworkingMode',
    'IdentityType',
    'IncidentManagementService',
    'JsonMapperElement',
    'Kind',
    'KnownColumnDefinitionType',
    'KnownDataCollectionEndpointResourceKind',
    'KnownDataCollectionRuleResourceKind',
    'KnownDataFlowStreams',
    'KnownExtensionDataSourceStreams',
    'KnownLogFileTextSettingsRecordStartTimestampFormat',
    'KnownLogFilesDataSourceFormat',
    'KnownPerfCounterDataSourceStreams',
    'KnownPrometheusForwarderDataSourceStreams',
    'KnownPublicNetworkAccessOptions',
    'KnownSyslogDataSourceFacilityNames',
    'KnownSyslogDataSourceLogLevels',
    'KnownSyslogDataSourceStreams',
    'KnownWindowsEventLogDataSourceStreams',
    'ManagedServiceIdentityType',
    'MetricStatisticType',
    'Odatatype',
    'OperationType',
    'Operator',
    'PipelineType',
    'PredictiveAutoscalePolicyScaleMode',
    'PrivateEndpointServiceConnectionStatus',
    'ProcessorType',
    'PublicNetworkAccess',
    'ReceiverType',
    'RecurrenceFrequency',
    'ScaleDirection',
    'ScaleRuleMetricDimensionOperationType',
    'ScaleType',
    'ScopedResourceKind',
    'StreamEncodingType',
    'SyslogProtocol',
    'TimeAggregation',
    'TimeAggregationType',
]


@pulumi.type_token("azure-native:monitor:AccessMode")
class AccessMode(builtins.str, Enum):
    """
    Specifies the default access mode of queries through associated private endpoints in scope. If not specified default value is 'Open'. You can override this default setting for a specific private endpoint connection by adding an exclusion in the 'exclusions' array.
    """
    OPEN = "Open"
    PRIVATE_ONLY = "PrivateOnly"


@pulumi.type_token("azure-native:monitor:AggregationTypeEnum")
class AggregationTypeEnum(builtins.str, Enum):
    """
    the criteria time aggregation types.
    """
    AVERAGE = "Average"
    COUNT = "Count"
    MINIMUM = "Minimum"
    MAXIMUM = "Maximum"
    TOTAL = "Total"


@pulumi.type_token("azure-native:monitor:ComparisonOperationType")
class ComparisonOperationType(builtins.str, Enum):
    """
    the operator that is used to compare the metric data and the threshold.
    """
    EQUALS = "Equals"
    NOT_EQUALS = "NotEquals"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"


@pulumi.type_token("azure-native:monitor:ConditionOperator")
class ConditionOperator(builtins.str, Enum):
    """
    The criteria operator. Relevant and required only for rules of the kind LogAlert.
    """
    EQUALS = "Equals"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    GREATER_OR_LESS_THAN = "GreaterOrLessThan"


@pulumi.type_token("azure-native:monitor:CriterionType")
class CriterionType(builtins.str, Enum):
    """
    Specifies the type of threshold criteria
    """
    STATIC_THRESHOLD_CRITERION = "StaticThresholdCriterion"
    DYNAMIC_THRESHOLD_CRITERION = "DynamicThresholdCriterion"


@pulumi.type_token("azure-native:monitor:DimensionOperator")
class DimensionOperator(builtins.str, Enum):
    """
    Operator for dimension values
    """
    INCLUDE = "Include"
    EXCLUDE = "Exclude"


@pulumi.type_token("azure-native:monitor:DynamicThresholdOperator")
class DynamicThresholdOperator(builtins.str, Enum):
    """
    The operator used to compare the metric value against the threshold.
    """
    GREATER_THAN = "GreaterThan"
    LESS_THAN = "LessThan"
    GREATER_OR_LESS_THAN = "GreaterOrLessThan"


@pulumi.type_token("azure-native:monitor:DynamicThresholdSensitivity")
class DynamicThresholdSensitivity(builtins.str, Enum):
    """
    The extent of deviation required to trigger an alert. This will affect how tight the threshold is to the metric series pattern.
    """
    LOW = "Low"
    MEDIUM = "Medium"
    HIGH = "High"


@pulumi.type_token("azure-native:monitor:ExporterType")
class ExporterType(builtins.str, Enum):
    """
    The type of exporter.
    """
    AZURE_MONITOR_WORKSPACE_LOGS = "AzureMonitorWorkspaceLogs"
    """
    Export logs to Azure Monitor Workspace.
    """
    PIPELINE_GROUP = "PipelineGroup"
    """
    Export data to another pipeline group instance.
    """


@pulumi.type_token("azure-native:monitor:ExtendedLocationType")
class ExtendedLocationType(builtins.str, Enum):
    """
    The type of the extended location.
    """
    EDGE_ZONE = "EdgeZone"
    """
    Azure Edge Zones location type
    """
    CUSTOM_LOCATION = "CustomLocation"
    """
    Azure Custom Locations type
    """


@pulumi.type_token("azure-native:monitor:ExternalNetworkingMode")
class ExternalNetworkingMode(builtins.str, Enum):
    """
    External networking mode.
    """
    LOAD_BALANCER_ONLY = "LoadBalancerOnly"
    """
    Load balancer only.
    """


@pulumi.type_token("azure-native:monitor:IdentityType")
class IdentityType(builtins.str, Enum):
    """
    Type of managed service identity.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:monitor:IncidentManagementService")
class IncidentManagementService(builtins.str, Enum):
    """
    The incident management service type
    """
    ICM = "Icm"


@pulumi.type_token("azure-native:monitor:JsonMapperElement")
class JsonMapperElement(builtins.str, Enum):
    """
    Define the destination's element. The element is the body or the attributes of the message, to which the json array mapper will write the output map.
    """
    BODY = "body"
    """
    Read or write the json array from or to the body of the message.
    """
    ATTRIBUTES = "attributes"
    """
    Read or write the json array from or to the attributes of the message.
    """


@pulumi.type_token("azure-native:monitor:Kind")
class Kind(builtins.str, Enum):
    """
    Indicates the type of scheduled query rule. The default is LogAlert.
    """
    LOG_ALERT = "LogAlert"
    EVENT_LOG_ALERT = "EventLogAlert"
    LOG_TO_METRIC = "LogToMetric"


@pulumi.type_token("azure-native:monitor:KnownColumnDefinitionType")
class KnownColumnDefinitionType(builtins.str, Enum):
    """
    The type of the column data.
    """
    STRING = "string"
    INT = "int"
    LONG = "long"
    REAL = "real"
    BOOLEAN = "boolean"
    DATETIME = "datetime"
    DYNAMIC = "dynamic"


@pulumi.type_token("azure-native:monitor:KnownDataCollectionEndpointResourceKind")
class KnownDataCollectionEndpointResourceKind(builtins.str, Enum):
    """
    The kind of the resource.
    """
    LINUX = "Linux"
    WINDOWS = "Windows"


@pulumi.type_token("azure-native:monitor:KnownDataCollectionRuleResourceKind")
class KnownDataCollectionRuleResourceKind(builtins.str, Enum):
    """
    The kind of the resource.
    """
    LINUX = "Linux"
    WINDOWS = "Windows"


@pulumi.type_token("azure-native:monitor:KnownDataFlowStreams")
class KnownDataFlowStreams(builtins.str, Enum):
    MICROSOFT_EVENT = "Microsoft-Event"
    MICROSOFT_INSIGHTS_METRICS = "Microsoft-InsightsMetrics"
    MICROSOFT_PERF = "Microsoft-Perf"
    MICROSOFT_SYSLOG = "Microsoft-Syslog"
    MICROSOFT_WINDOWS_EVENT = "Microsoft-WindowsEvent"


@pulumi.type_token("azure-native:monitor:KnownExtensionDataSourceStreams")
class KnownExtensionDataSourceStreams(builtins.str, Enum):
    MICROSOFT_EVENT = "Microsoft-Event"
    MICROSOFT_INSIGHTS_METRICS = "Microsoft-InsightsMetrics"
    MICROSOFT_PERF = "Microsoft-Perf"
    MICROSOFT_SYSLOG = "Microsoft-Syslog"
    MICROSOFT_WINDOWS_EVENT = "Microsoft-WindowsEvent"


@pulumi.type_token("azure-native:monitor:KnownLogFileTextSettingsRecordStartTimestampFormat")
class KnownLogFileTextSettingsRecordStartTimestampFormat(builtins.str, Enum):
    """
    One of the supported timestamp formats
    """
    IS_O_8601 = "ISO 8601"
    YYY_Y_M_M_D_D_H_H_M_M_SS = "YYYY-MM-DD HH:MM:SS"
    M_D_YYY_Y_H_H_M_M_S_S_A_M_PM = "M/D/YYYY HH:MM:SS AM/PM"
    MON_D_D_YYY_Y_H_H_M_M_SS = "Mon DD, YYYY HH:MM:SS"
    YY_M_MDD_H_H_MM_SS = "yyMMdd HH:mm:ss"
    DD_M_MYY_H_H_MM_SS = "ddMMyy HH:mm:ss"
    MM_M_D_HH_MM_SS = "MMM d hh:mm:ss"
    DD_MM_M_YYYY_H_H_MM_SS_ZZZ = "dd/MMM/yyyy:HH:mm:ss zzz"
    YYYY_M_M_DD_TH_H_MM_SS_K = "yyyy-MM-ddTHH:mm:ssK"


@pulumi.type_token("azure-native:monitor:KnownLogFilesDataSourceFormat")
class KnownLogFilesDataSourceFormat(builtins.str, Enum):
    """
    The data format of the log files
    """
    TEXT = "text"


@pulumi.type_token("azure-native:monitor:KnownPerfCounterDataSourceStreams")
class KnownPerfCounterDataSourceStreams(builtins.str, Enum):
    MICROSOFT_PERF = "Microsoft-Perf"
    MICROSOFT_INSIGHTS_METRICS = "Microsoft-InsightsMetrics"


@pulumi.type_token("azure-native:monitor:KnownPrometheusForwarderDataSourceStreams")
class KnownPrometheusForwarderDataSourceStreams(builtins.str, Enum):
    MICROSOFT_PROMETHEUS_METRICS = "Microsoft-PrometheusMetrics"


@pulumi.type_token("azure-native:monitor:KnownPublicNetworkAccessOptions")
class KnownPublicNetworkAccessOptions(builtins.str, Enum):
    """
    The configuration to set whether network access from public internet to the endpoints are allowed.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"
    SECURED_BY_PERIMETER = "SecuredByPerimeter"


@pulumi.type_token("azure-native:monitor:KnownSyslogDataSourceFacilityNames")
class KnownSyslogDataSourceFacilityNames(builtins.str, Enum):
    ALERT = "alert"
    AUDIT = "audit"
    AUTH = "auth"
    AUTHPRIV = "authpriv"
    CLOCK = "clock"
    CRON = "cron"
    DAEMON = "daemon"
    FTP = "ftp"
    KERN = "kern"
    LPR = "lpr"
    MAIL = "mail"
    MARK = "mark"
    NEWS = "news"
    NOPRI = "nopri"
    NTP = "ntp"
    SYSLOG = "syslog"
    USER = "user"
    UUCP = "uucp"
    LOCAL0 = "local0"
    LOCAL1 = "local1"
    LOCAL2 = "local2"
    LOCAL3 = "local3"
    LOCAL4 = "local4"
    LOCAL5 = "local5"
    LOCAL6 = "local6"
    LOCAL7 = "local7"
    ASTERISK = "*"


@pulumi.type_token("azure-native:monitor:KnownSyslogDataSourceLogLevels")
class KnownSyslogDataSourceLogLevels(builtins.str, Enum):
    DEBUG = "Debug"
    INFO = "Info"
    NOTICE = "Notice"
    WARNING = "Warning"
    ERROR = "Error"
    CRITICAL = "Critical"
    ALERT = "Alert"
    EMERGENCY = "Emergency"
    ASTERISK = "*"


@pulumi.type_token("azure-native:monitor:KnownSyslogDataSourceStreams")
class KnownSyslogDataSourceStreams(builtins.str, Enum):
    MICROSOFT_SYSLOG = "Microsoft-Syslog"


@pulumi.type_token("azure-native:monitor:KnownWindowsEventLogDataSourceStreams")
class KnownWindowsEventLogDataSourceStreams(builtins.str, Enum):
    MICROSOFT_WINDOWS_EVENT = "Microsoft-WindowsEvent"
    MICROSOFT_EVENT = "Microsoft-Event"


@pulumi.type_token("azure-native:monitor:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


@pulumi.type_token("azure-native:monitor:MetricStatisticType")
class MetricStatisticType(builtins.str, Enum):
    """
    the metric statistic type. How the metrics from multiple instances are combined.
    """
    AVERAGE = "Average"
    MIN = "Min"
    MAX = "Max"
    SUM = "Sum"
    COUNT = "Count"


@pulumi.type_token("azure-native:monitor:Odatatype")
class Odatatype(builtins.str, Enum):
    """
    specifies the type of the alert criteria.
    """
    MICROSOFT_AZURE_MONITOR_SINGLE_RESOURCE_MULTIPLE_METRIC_CRITERIA = "Microsoft.Azure.Monitor.SingleResourceMultipleMetricCriteria"
    MICROSOFT_AZURE_MONITOR_MULTIPLE_RESOURCE_MULTIPLE_METRIC_CRITERIA = "Microsoft.Azure.Monitor.MultipleResourceMultipleMetricCriteria"
    MICROSOFT_AZURE_MONITOR_WEBTEST_LOCATION_AVAILABILITY_CRITERIA = "Microsoft.Azure.Monitor.WebtestLocationAvailabilityCriteria"


@pulumi.type_token("azure-native:monitor:OperationType")
class OperationType(builtins.str, Enum):
    """
    the operation associated with the notification and its value must be "scale"
    """
    SCALE = "Scale"


@pulumi.type_token("azure-native:monitor:Operator")
class Operator(builtins.str, Enum):
    """
    the criteria operator.
    """
    EQUALS = "Equals"
    GREATER_THAN = "GreaterThan"
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    LESS_THAN = "LessThan"
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"


@pulumi.type_token("azure-native:monitor:PipelineType")
class PipelineType(builtins.str, Enum):
    """
    The type of pipeline
    """
    LOGS = "Logs"
    """
    Pipeline for logs telemetry.
    """


@pulumi.type_token("azure-native:monitor:PredictiveAutoscalePolicyScaleMode")
class PredictiveAutoscalePolicyScaleMode(builtins.str, Enum):
    """
    the predictive autoscale mode
    """
    DISABLED = "Disabled"
    FORECAST_ONLY = "ForecastOnly"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:monitor:PrivateEndpointServiceConnectionStatus")
class PrivateEndpointServiceConnectionStatus(builtins.str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"


@pulumi.type_token("azure-native:monitor:ProcessorType")
class ProcessorType(builtins.str, Enum):
    """
    The type of processor.
    """
    BATCH = "Batch"
    """
    Batch processor.
    """


@pulumi.type_token("azure-native:monitor:PublicNetworkAccess")
class PublicNetworkAccess(builtins.str, Enum):
    """
    Gets or sets allow or disallow public network access to Azure Monitor Workspace
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:monitor:ReceiverType")
class ReceiverType(builtins.str, Enum):
    """
    The type of receiver.
    """
    SYSLOG = "Syslog"
    """
    Linux syslog.
    """
    AMA = "Ama"
    """
    Receives data from azure monitor agent receiver.
    """
    PIPELINE_GROUP = "PipelineGroup"
    """
    Receives data from another pipeline group.
    """
    OTLP = "OTLP"
    """
    Receives data from a OTLP collector.
    """
    UDP = "UDP"
    """
    Receives data from an UDP collector.
    """


@pulumi.type_token("azure-native:monitor:RecurrenceFrequency")
class RecurrenceFrequency(builtins.str, Enum):
    """
    the recurrence frequency. How often the schedule profile should take effect. This value must be Week, meaning each week will have the same set of profiles. For example, to set a daily schedule, set **schedule** to every day of the week. The frequency property specifies that the schedule is repeated weekly.
    """
    NONE = "None"
    SECOND = "Second"
    MINUTE = "Minute"
    HOUR = "Hour"
    DAY = "Day"
    WEEK = "Week"
    MONTH = "Month"
    YEAR = "Year"


@pulumi.type_token("azure-native:monitor:ScaleDirection")
class ScaleDirection(builtins.str, Enum):
    """
    the scale direction. Whether the scaling action increases or decreases the number of instances.
    """
    NONE = "None"
    INCREASE = "Increase"
    DECREASE = "Decrease"


@pulumi.type_token("azure-native:monitor:ScaleRuleMetricDimensionOperationType")
class ScaleRuleMetricDimensionOperationType(builtins.str, Enum):
    """
    the dimension operator. Only 'Equals' and 'NotEquals' are supported. 'Equals' being equal to any of the values. 'NotEquals' being not equal to all of the values
    """
    EQUALS = "Equals"
    NOT_EQUALS = "NotEquals"


@pulumi.type_token("azure-native:monitor:ScaleType")
class ScaleType(builtins.str, Enum):
    """
    the type of action that should occur when the scale rule fires.
    """
    CHANGE_COUNT = "ChangeCount"
    PERCENT_CHANGE_COUNT = "PercentChangeCount"
    EXACT_COUNT = "ExactCount"
    SERVICE_ALLOWED_NEXT_VALUE = "ServiceAllowedNextValue"


@pulumi.type_token("azure-native:monitor:ScopedResourceKind")
class ScopedResourceKind(builtins.str, Enum):
    """
    The kind of scoped Azure monitor resource.
    """
    RESOURCE = "Resource"
    METRICS = "Metrics"


@pulumi.type_token("azure-native:monitor:StreamEncodingType")
class StreamEncodingType(builtins.str, Enum):
    """
    The encoding of the stream being received.
    """
    NOP = "nop"
    """
    No encoding validation. Treats the file as a stream of raw bytes.
    """
    UTF_8 = "utf-8"
    """
    UTF-8 encoding.
    """
    UTF_16LE = "utf-16le"
    """
    UTF-16 encoding with little-endian byte order.
    """
    UTF_16BE = "utf-16be"
    """
    UTF-16 encoding with little-endian byte order.
    """
    ASCII = "ascii"
    """
    ASCII encoding.
    """
    BIG5 = "big5"
    """
    The Big5 Chinese character encoding.
    """


@pulumi.type_token("azure-native:monitor:SyslogProtocol")
class SyslogProtocol(builtins.str, Enum):
    """
    Protocol to parse syslog messages. Default rfc3164
    """
    RFC3164 = "rfc3164"
    """
    rfc3164 protocol.
    """
    RFC5424 = "rfc5424"
    """
    rfc5424 protocol.
    """


@pulumi.type_token("azure-native:monitor:TimeAggregation")
class TimeAggregation(builtins.str, Enum):
    """
    Aggregation type. Relevant and required only for rules of the kind LogAlert.
    """
    COUNT = "Count"
    AVERAGE = "Average"
    MINIMUM = "Minimum"
    MAXIMUM = "Maximum"
    TOTAL = "Total"


@pulumi.type_token("azure-native:monitor:TimeAggregationType")
class TimeAggregationType(builtins.str, Enum):
    """
    time aggregation type. How the data that is collected should be combined over time. The default value is Average.
    """
    AVERAGE = "Average"
    MINIMUM = "Minimum"
    MAXIMUM = "Maximum"
    TOTAL = "Total"
    COUNT = "Count"
    LAST = "Last"
