# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ApplicationType',
    'AvsDataStore',
    'ChownMode',
    'CoolAccessRetrievalPolicy',
    'CoolAccessTieringPolicy',
    'EnableSubvolumes',
    'EncryptionKeySource',
    'EncryptionType',
    'EndpointType',
    'KeySource',
    'ManagedServiceIdentityType',
    'NetworkFeatures',
    'QosType',
    'ReplicationSchedule',
    'SecurityStyle',
    'ServiceLevel',
    'SmbAccessBasedEnumeration',
    'SmbNonBrowsable',
    'Type',
]


@pulumi.type_token("azure-native:netapp:ApplicationType")
class ApplicationType(builtins.str, Enum):
    """
    Application Type
    """
    SA_P_HANA = "SAP-HANA"
    ORACLE = "ORACLE"


@pulumi.type_token("azure-native:netapp:AvsDataStore")
class AvsDataStore(builtins.str, Enum):
    """
    Specifies whether the volume is enabled for Azure VMware Solution (AVS) datastore purpose
    """
    ENABLED = "Enabled"
    """
    avsDataStore is enabled
    """
    DISABLED = "Disabled"
    """
    avsDataStore is disabled
    """


@pulumi.type_token("azure-native:netapp:ChownMode")
class ChownMode(builtins.str, Enum):
    """
    This parameter specifies who is authorized to change the ownership of a file. restricted - Only root user can change the ownership of the file. unrestricted - Non-root users can change ownership of files that they own.
    """
    RESTRICTED = "Restricted"
    UNRESTRICTED = "Unrestricted"


@pulumi.type_token("azure-native:netapp:CoolAccessRetrievalPolicy")
class CoolAccessRetrievalPolicy(builtins.str, Enum):
    """
    coolAccessRetrievalPolicy determines the data retrieval behavior from the cool tier to standard storage based on the read pattern for cool access enabled volumes. The possible values for this field are: 
     Default - Data will be pulled from cool tier to standard storage on random reads. This policy is the default.
     OnRead - All client-driven data read is pulled from cool tier to standard storage on both sequential and random reads.
     Never - No client-driven data is pulled from cool tier to standard storage.
    """
    DEFAULT = "Default"
    ON_READ = "OnRead"
    NEVER = "Never"


@pulumi.type_token("azure-native:netapp:CoolAccessTieringPolicy")
class CoolAccessTieringPolicy(builtins.str, Enum):
    """
    coolAccessTieringPolicy determines which cold data blocks are moved to cool tier. The possible values for this field are: Auto - Moves cold user data blocks in both the Snapshot copies and the active file system to the cool tier tier. This policy is the default. SnapshotOnly - Moves user data blocks of the Volume Snapshot copies that are not associated with the active file system to the cool tier.
    """
    AUTO = "Auto"
    SNAPSHOT_ONLY = "SnapshotOnly"


@pulumi.type_token("azure-native:netapp:EnableSubvolumes")
class EnableSubvolumes(builtins.str, Enum):
    """
    Flag indicating whether subvolume operations are enabled on the volume
    """
    ENABLED = "Enabled"
    """
    subvolumes are enabled
    """
    DISABLED = "Disabled"
    """
    subvolumes are not enabled
    """


@pulumi.type_token("azure-native:netapp:EncryptionKeySource")
class EncryptionKeySource(builtins.str, Enum):
    """
    Source of key used to encrypt data in volume. Applicable if NetApp account has encryption.keySource = 'Microsoft.KeyVault'. Possible values (case-insensitive) are: 'Microsoft.NetApp, Microsoft.KeyVault'
    """
    MICROSOFT_NET_APP = "Microsoft.NetApp"
    """
    Microsoft-managed key encryption
    """
    MICROSOFT_KEY_VAULT = "Microsoft.KeyVault"
    """
    Customer-managed key encryption
    """


@pulumi.type_token("azure-native:netapp:EncryptionType")
class EncryptionType(builtins.str, Enum):
    """
    Encryption type of the capacity pool, set encryption type for data at rest for this pool and all volumes in it. This value can only be set when creating new pool.
    """
    SINGLE = "Single"
    """
    EncryptionType Single, volumes will use single encryption at rest
    """
    DOUBLE = "Double"
    """
    EncryptionType Double, volumes will use double encryption at rest
    """


@pulumi.type_token("azure-native:netapp:EndpointType")
class EndpointType(builtins.str, Enum):
    """
    Indicates whether the local volume is the source or destination for the Volume Replication
    """
    SRC = "src"
    DST = "dst"


@pulumi.type_token("azure-native:netapp:KeySource")
class KeySource(builtins.str, Enum):
    """
    The encryption keySource (provider). Possible values (case-insensitive):  Microsoft.NetApp, Microsoft.KeyVault
    """
    MICROSOFT_NET_APP = "Microsoft.NetApp"
    """
    Microsoft-managed key encryption
    """
    MICROSOFT_KEY_VAULT = "Microsoft.KeyVault"
    """
    Customer-managed key encryption
    """


@pulumi.type_token("azure-native:netapp:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


@pulumi.type_token("azure-native:netapp:NetworkFeatures")
class NetworkFeatures(builtins.str, Enum):
    """
    The original value of the network features type available to the volume at the time it was created.
    """
    BASIC = "Basic"
    """
    Basic network features.
    """
    STANDARD = "Standard"
    """
    Standard network features.
    """
    BASIC_STANDARD = "Basic_Standard"
    """
    Updating from Basic to Standard network features.
    """
    STANDARD_BASIC = "Standard_Basic"
    """
    Updating from Standard to Basic network features.
    """


@pulumi.type_token("azure-native:netapp:QosType")
class QosType(builtins.str, Enum):
    """
    The qos type of the pool
    """
    AUTO = "Auto"
    """
    qos type Auto
    """
    MANUAL = "Manual"
    """
    qos type Manual
    """


@pulumi.type_token("azure-native:netapp:ReplicationSchedule")
class ReplicationSchedule(builtins.str, Enum):
    """
    Schedule
    """
    REPLICATION_SCHEDULE_10MINUTELY = "_10minutely"
    HOURLY = "hourly"
    DAILY = "daily"


@pulumi.type_token("azure-native:netapp:SecurityStyle")
class SecurityStyle(builtins.str, Enum):
    """
    The security style of volume, default unix, defaults to ntfs for dual protocol or CIFS protocol
    """
    NTFS = "ntfs"
    UNIX = "unix"


@pulumi.type_token("azure-native:netapp:ServiceLevel")
class ServiceLevel(builtins.str, Enum):
    """
    The service level of the file system
    """
    STANDARD = "Standard"
    """
    Standard service level
    """
    PREMIUM = "Premium"
    """
    Premium service level
    """
    ULTRA = "Ultra"
    """
    Ultra service level
    """
    STANDARD_ZRS = "StandardZRS"
    """
    Zone redundant storage service level
    """


@pulumi.type_token("azure-native:netapp:SmbAccessBasedEnumeration")
class SmbAccessBasedEnumeration(builtins.str, Enum):
    """
    Enables access-based enumeration share property for SMB Shares. Only applicable for SMB/DualProtocol volume
    """
    DISABLED = "Disabled"
    """
    smbAccessBasedEnumeration share setting is disabled
    """
    ENABLED = "Enabled"
    """
    smbAccessBasedEnumeration share setting is enabled
    """


@pulumi.type_token("azure-native:netapp:SmbNonBrowsable")
class SmbNonBrowsable(builtins.str, Enum):
    """
    Enables non-browsable property for SMB Shares. Only applicable for SMB/DualProtocol volume
    """
    DISABLED = "Disabled"
    """
    smbNonBrowsable share setting is disabled
    """
    ENABLED = "Enabled"
    """
    smbNonBrowsable share setting is enabled
    """


@pulumi.type_token("azure-native:netapp:Type")
class Type(builtins.str, Enum):
    """
    Type of quota
    """
    DEFAULT_USER_QUOTA = "DefaultUserQuota"
    """
    Default user quota
    """
    DEFAULT_GROUP_QUOTA = "DefaultGroupQuota"
    """
    Default group quota
    """
    INDIVIDUAL_USER_QUOTA = "IndividualUserQuota"
    """
    Individual user quota
    """
    INDIVIDUAL_GROUP_QUOTA = "IndividualGroupQuota"
    """
    Individual group quota
    """
