# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['CapacityPoolBucketArgs', 'CapacityPoolBucket']

@pulumi.input_type
class CapacityPoolBucketArgs:
    def __init__(__self__, *,
                 account_name: pulumi.Input[builtins.str],
                 pool_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 volume_name: pulumi.Input[builtins.str],
                 bucket_name: Optional[pulumi.Input[builtins.str]] = None,
                 file_system_user: Optional[pulumi.Input['FileSystemUserArgs']] = None,
                 path: Optional[pulumi.Input[builtins.str]] = None,
                 server: Optional[pulumi.Input['BucketServerPropertiesArgs']] = None):
        """
        The set of arguments for constructing a CapacityPoolBucket resource.
        :param pulumi.Input[builtins.str] account_name: The name of the NetApp account
        :param pulumi.Input[builtins.str] pool_name: The name of the capacity pool
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] volume_name: The name of the volume
        :param pulumi.Input[builtins.str] bucket_name: The name of the bucket
        :param pulumi.Input['FileSystemUserArgs'] file_system_user: File System user having access to volume data. For Unix, this is the user's uid and gid. For Windows, this is the user's username. Note that the Unix and Windows user details are mutually exclusive, meaning one or other must be supplied, but not both.
        :param pulumi.Input[builtins.str] path: The volume path mounted inside the bucket. The default is the root path '/' if no value is provided when the bucket is created.
        :param pulumi.Input['BucketServerPropertiesArgs'] server: Properties of the server managing the lifecycle of volume buckets
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "pool_name", pool_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "volume_name", volume_name)
        if bucket_name is not None:
            pulumi.set(__self__, "bucket_name", bucket_name)
        if file_system_user is not None:
            pulumi.set(__self__, "file_system_user", file_system_user)
        if path is None:
            path = '/'
        if path is not None:
            pulumi.set(__self__, "path", path)
        if server is not None:
            pulumi.set(__self__, "server", server)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the NetApp account
        """
        return pulumi.get(self, "account_name")

    @account_name.setter
    def account_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "account_name", value)

    @property
    @pulumi.getter(name="poolName")
    def pool_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the capacity pool
        """
        return pulumi.get(self, "pool_name")

    @pool_name.setter
    def pool_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "pool_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="volumeName")
    def volume_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the volume
        """
        return pulumi.get(self, "volume_name")

    @volume_name.setter
    def volume_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "volume_name", value)

    @property
    @pulumi.getter(name="bucketName")
    def bucket_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the bucket
        """
        return pulumi.get(self, "bucket_name")

    @bucket_name.setter
    def bucket_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "bucket_name", value)

    @property
    @pulumi.getter(name="fileSystemUser")
    def file_system_user(self) -> Optional[pulumi.Input['FileSystemUserArgs']]:
        """
        File System user having access to volume data. For Unix, this is the user's uid and gid. For Windows, this is the user's username. Note that the Unix and Windows user details are mutually exclusive, meaning one or other must be supplied, but not both.
        """
        return pulumi.get(self, "file_system_user")

    @file_system_user.setter
    def file_system_user(self, value: Optional[pulumi.Input['FileSystemUserArgs']]):
        pulumi.set(self, "file_system_user", value)

    @property
    @pulumi.getter
    def path(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The volume path mounted inside the bucket. The default is the root path '/' if no value is provided when the bucket is created.
        """
        return pulumi.get(self, "path")

    @path.setter
    def path(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "path", value)

    @property
    @pulumi.getter
    def server(self) -> Optional[pulumi.Input['BucketServerPropertiesArgs']]:
        """
        Properties of the server managing the lifecycle of volume buckets
        """
        return pulumi.get(self, "server")

    @server.setter
    def server(self, value: Optional[pulumi.Input['BucketServerPropertiesArgs']]):
        pulumi.set(self, "server", value)


@pulumi.type_token("azure-native:netapp:CapacityPoolBucket")
class CapacityPoolBucket(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 bucket_name: Optional[pulumi.Input[builtins.str]] = None,
                 file_system_user: Optional[pulumi.Input[Union['FileSystemUserArgs', 'FileSystemUserArgsDict']]] = None,
                 path: Optional[pulumi.Input[builtins.str]] = None,
                 pool_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 server: Optional[pulumi.Input[Union['BucketServerPropertiesArgs', 'BucketServerPropertiesArgsDict']]] = None,
                 volume_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Bucket resource

        Uses Azure REST API version 2025-01-01-preview.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] account_name: The name of the NetApp account
        :param pulumi.Input[builtins.str] bucket_name: The name of the bucket
        :param pulumi.Input[Union['FileSystemUserArgs', 'FileSystemUserArgsDict']] file_system_user: File System user having access to volume data. For Unix, this is the user's uid and gid. For Windows, this is the user's username. Note that the Unix and Windows user details are mutually exclusive, meaning one or other must be supplied, but not both.
        :param pulumi.Input[builtins.str] path: The volume path mounted inside the bucket. The default is the root path '/' if no value is provided when the bucket is created.
        :param pulumi.Input[builtins.str] pool_name: The name of the capacity pool
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Union['BucketServerPropertiesArgs', 'BucketServerPropertiesArgsDict']] server: Properties of the server managing the lifecycle of volume buckets
        :param pulumi.Input[builtins.str] volume_name: The name of the volume
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CapacityPoolBucketArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Bucket resource

        Uses Azure REST API version 2025-01-01-preview.

        :param str resource_name: The name of the resource.
        :param CapacityPoolBucketArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CapacityPoolBucketArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 bucket_name: Optional[pulumi.Input[builtins.str]] = None,
                 file_system_user: Optional[pulumi.Input[Union['FileSystemUserArgs', 'FileSystemUserArgsDict']]] = None,
                 path: Optional[pulumi.Input[builtins.str]] = None,
                 pool_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 server: Optional[pulumi.Input[Union['BucketServerPropertiesArgs', 'BucketServerPropertiesArgsDict']]] = None,
                 volume_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CapacityPoolBucketArgs.__new__(CapacityPoolBucketArgs)

            if account_name is None and not opts.urn:
                raise TypeError("Missing required property 'account_name'")
            __props__.__dict__["account_name"] = account_name
            __props__.__dict__["bucket_name"] = bucket_name
            __props__.__dict__["file_system_user"] = file_system_user
            if path is None:
                path = '/'
            __props__.__dict__["path"] = path
            if pool_name is None and not opts.urn:
                raise TypeError("Missing required property 'pool_name'")
            __props__.__dict__["pool_name"] = pool_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["server"] = server
            if volume_name is None and not opts.urn:
                raise TypeError("Missing required property 'volume_name'")
            __props__.__dict__["volume_name"] = volume_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:netapp/v20250101preview:CapacityPoolBucket")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(CapacityPoolBucket, __self__).__init__(
            'azure-native:netapp:CapacityPoolBucket',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'CapacityPoolBucket':
        """
        Get an existing CapacityPoolBucket resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = CapacityPoolBucketArgs.__new__(CapacityPoolBucketArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["file_system_user"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["path"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["server"] = None
        __props__.__dict__["status"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return CapacityPoolBucket(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="fileSystemUser")
    def file_system_user(self) -> pulumi.Output[Optional['outputs.FileSystemUserResponse']]:
        """
        File System user having access to volume data. For Unix, this is the user's uid and gid. For Windows, this is the user's username. Note that the Unix and Windows user details are mutually exclusive, meaning one or other must be supplied, but not both.
        """
        return pulumi.get(self, "file_system_user")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def path(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The volume path mounted inside the bucket. The default is the root path '/' if no value is provided when the bucket is created.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        Provisioning state of the resource
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter
    def server(self) -> pulumi.Output[Optional['outputs.BucketServerPropertiesResponse']]:
        """
        Properties of the server managing the lifecycle of volume buckets
        """
        return pulumi.get(self, "server")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[builtins.str]:
        """
        The bucket credentials status. There states:

        "NoCredentialsSet": Access and Secret key pair have not been generated.
        "CredentialsExpired": Access and Secret key pair have expired.
        "Active": The certificate has been installed and credentials are unexpired.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

