# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetCapacityPoolVolumeGroupIdForLdapUserResult',
    'AwaitableGetCapacityPoolVolumeGroupIdForLdapUserResult',
    'get_capacity_pool_volume_group_id_for_ldap_user',
    'get_capacity_pool_volume_group_id_for_ldap_user_output',
]

@pulumi.output_type
class GetCapacityPoolVolumeGroupIdForLdapUserResult:
    """
    Group Id list for Ldap user
    """
    def __init__(__self__, group_ids_for_ldap_user=None):
        if group_ids_for_ldap_user and not isinstance(group_ids_for_ldap_user, list):
            raise TypeError("Expected argument 'group_ids_for_ldap_user' to be a list")
        pulumi.set(__self__, "group_ids_for_ldap_user", group_ids_for_ldap_user)

    @property
    @pulumi.getter(name="groupIdsForLdapUser")
    def group_ids_for_ldap_user(self) -> Optional[Sequence[builtins.str]]:
        """
        Group Id list
        """
        return pulumi.get(self, "group_ids_for_ldap_user")


class AwaitableGetCapacityPoolVolumeGroupIdForLdapUserResult(GetCapacityPoolVolumeGroupIdForLdapUserResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCapacityPoolVolumeGroupIdForLdapUserResult(
            group_ids_for_ldap_user=self.group_ids_for_ldap_user)


def get_capacity_pool_volume_group_id_for_ldap_user(account_name: Optional[builtins.str] = None,
                                                    pool_name: Optional[builtins.str] = None,
                                                    resource_group_name: Optional[builtins.str] = None,
                                                    username: Optional[builtins.str] = None,
                                                    volume_name: Optional[builtins.str] = None,
                                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCapacityPoolVolumeGroupIdForLdapUserResult:
    """
    Returns the list of group Ids for a specific LDAP User

    Uses Azure REST API version 2024-09-01.

    Other available API versions: 2022-11-01, 2022-11-01-preview, 2023-05-01, 2023-05-01-preview, 2023-07-01, 2023-07-01-preview, 2023-11-01, 2023-11-01-preview, 2024-01-01, 2024-03-01, 2024-03-01-preview, 2024-05-01, 2024-05-01-preview, 2024-07-01, 2024-07-01-preview, 2024-09-01-preview, 2025-01-01, 2025-01-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native netapp [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str account_name: The name of the NetApp account
    :param builtins.str pool_name: The name of the capacity pool
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str username: username is required to fetch the group to which user is part of
    :param builtins.str volume_name: The name of the volume
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['poolName'] = pool_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['username'] = username
    __args__['volumeName'] = volume_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:netapp:getCapacityPoolVolumeGroupIdForLdapUser', __args__, opts=opts, typ=GetCapacityPoolVolumeGroupIdForLdapUserResult).value

    return AwaitableGetCapacityPoolVolumeGroupIdForLdapUserResult(
        group_ids_for_ldap_user=pulumi.get(__ret__, 'group_ids_for_ldap_user'))
def get_capacity_pool_volume_group_id_for_ldap_user_output(account_name: Optional[pulumi.Input[builtins.str]] = None,
                                                           pool_name: Optional[pulumi.Input[builtins.str]] = None,
                                                           resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                           username: Optional[pulumi.Input[builtins.str]] = None,
                                                           volume_name: Optional[pulumi.Input[builtins.str]] = None,
                                                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetCapacityPoolVolumeGroupIdForLdapUserResult]:
    """
    Returns the list of group Ids for a specific LDAP User

    Uses Azure REST API version 2024-09-01.

    Other available API versions: 2022-11-01, 2022-11-01-preview, 2023-05-01, 2023-05-01-preview, 2023-07-01, 2023-07-01-preview, 2023-11-01, 2023-11-01-preview, 2024-01-01, 2024-03-01, 2024-03-01-preview, 2024-05-01, 2024-05-01-preview, 2024-07-01, 2024-07-01-preview, 2024-09-01-preview, 2025-01-01, 2025-01-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native netapp [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str account_name: The name of the NetApp account
    :param builtins.str pool_name: The name of the capacity pool
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str username: username is required to fetch the group to which user is part of
    :param builtins.str volume_name: The name of the volume
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['poolName'] = pool_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['username'] = username
    __args__['volumeName'] = volume_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:netapp:getCapacityPoolVolumeGroupIdForLdapUser', __args__, opts=opts, typ=GetCapacityPoolVolumeGroupIdForLdapUserResult)
    return __ret__.apply(lambda __response__: GetCapacityPoolVolumeGroupIdForLdapUserResult(
        group_ids_for_ldap_user=pulumi.get(__response__, 'group_ids_for_ldap_user')))
