# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetRoutingRuleCollectionResult',
    'AwaitableGetRoutingRuleCollectionResult',
    'get_routing_rule_collection',
    'get_routing_rule_collection_output',
]

@pulumi.output_type
class GetRoutingRuleCollectionResult:
    """
    Defines the routing rule collection.
    """
    def __init__(__self__, applies_to=None, azure_api_version=None, description=None, disable_bgp_route_propagation=None, etag=None, id=None, name=None, provisioning_state=None, resource_guid=None, system_data=None, type=None):
        if applies_to and not isinstance(applies_to, list):
            raise TypeError("Expected argument 'applies_to' to be a list")
        pulumi.set(__self__, "applies_to", applies_to)
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if disable_bgp_route_propagation and not isinstance(disable_bgp_route_propagation, str):
            raise TypeError("Expected argument 'disable_bgp_route_propagation' to be a str")
        pulumi.set(__self__, "disable_bgp_route_propagation", disable_bgp_route_propagation)
        if etag and not isinstance(etag, str):
            raise TypeError("Expected argument 'etag' to be a str")
        pulumi.set(__self__, "etag", etag)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if resource_guid and not isinstance(resource_guid, str):
            raise TypeError("Expected argument 'resource_guid' to be a str")
        pulumi.set(__self__, "resource_guid", resource_guid)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="appliesTo")
    def applies_to(self) -> Sequence['outputs.NetworkManagerRoutingGroupItemResponse']:
        """
        Groups for configuration
        """
        return pulumi.get(self, "applies_to")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def description(self) -> Optional[builtins.str]:
        """
        A description of the routing rule collection.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="disableBgpRoutePropagation")
    def disable_bgp_route_propagation(self) -> Optional[builtins.str]:
        """
        Determines whether BGP route propagation is enabled. Defaults to true.
        """
        return pulumi.get(self, "disable_bgp_route_propagation")

    @property
    @pulumi.getter
    def etag(self) -> builtins.str:
        """
        A unique read-only string that changes whenever the resource is updated.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Resource ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="resourceGuid")
    def resource_guid(self) -> builtins.str:
        """
        Unique identifier for this resource.
        """
        return pulumi.get(self, "resource_guid")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        The system metadata related to this resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Resource type.
        """
        return pulumi.get(self, "type")


class AwaitableGetRoutingRuleCollectionResult(GetRoutingRuleCollectionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRoutingRuleCollectionResult(
            applies_to=self.applies_to,
            azure_api_version=self.azure_api_version,
            description=self.description,
            disable_bgp_route_propagation=self.disable_bgp_route_propagation,
            etag=self.etag,
            id=self.id,
            name=self.name,
            provisioning_state=self.provisioning_state,
            resource_guid=self.resource_guid,
            system_data=self.system_data,
            type=self.type)


def get_routing_rule_collection(configuration_name: Optional[builtins.str] = None,
                                network_manager_name: Optional[builtins.str] = None,
                                resource_group_name: Optional[builtins.str] = None,
                                rule_collection_name: Optional[builtins.str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRoutingRuleCollectionResult:
    """
    Gets a network manager routing configuration rule collection.

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str configuration_name: The name of the network manager Routing Configuration.
    :param builtins.str network_manager_name: The name of the network manager.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str rule_collection_name: The name of the network manager routing Configuration rule collection.
    """
    __args__ = dict()
    __args__['configurationName'] = configuration_name
    __args__['networkManagerName'] = network_manager_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['ruleCollectionName'] = rule_collection_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:network:getRoutingRuleCollection', __args__, opts=opts, typ=GetRoutingRuleCollectionResult).value

    return AwaitableGetRoutingRuleCollectionResult(
        applies_to=pulumi.get(__ret__, 'applies_to'),
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        description=pulumi.get(__ret__, 'description'),
        disable_bgp_route_propagation=pulumi.get(__ret__, 'disable_bgp_route_propagation'),
        etag=pulumi.get(__ret__, 'etag'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        resource_guid=pulumi.get(__ret__, 'resource_guid'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_routing_rule_collection_output(configuration_name: Optional[pulumi.Input[builtins.str]] = None,
                                       network_manager_name: Optional[pulumi.Input[builtins.str]] = None,
                                       resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                       rule_collection_name: Optional[pulumi.Input[builtins.str]] = None,
                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRoutingRuleCollectionResult]:
    """
    Gets a network manager routing configuration rule collection.

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str configuration_name: The name of the network manager Routing Configuration.
    :param builtins.str network_manager_name: The name of the network manager.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str rule_collection_name: The name of the network manager routing Configuration rule collection.
    """
    __args__ = dict()
    __args__['configurationName'] = configuration_name
    __args__['networkManagerName'] = network_manager_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['ruleCollectionName'] = rule_collection_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:network:getRoutingRuleCollection', __args__, opts=opts, typ=GetRoutingRuleCollectionResult)
    return __ret__.apply(lambda __response__: GetRoutingRuleCollectionResult(
        applies_to=pulumi.get(__response__, 'applies_to'),
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        description=pulumi.get(__response__, 'description'),
        disable_bgp_route_propagation=pulumi.get(__response__, 'disable_bgp_route_propagation'),
        etag=pulumi.get(__response__, 'etag'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        resource_guid=pulumi.get(__response__, 'resource_guid'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
