# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetVirtualNetworkGatewayConnectionIkeSasResult',
    'AwaitableGetVirtualNetworkGatewayConnectionIkeSasResult',
    'get_virtual_network_gateway_connection_ike_sas',
    'get_virtual_network_gateway_connection_ike_sas_output',
]

@pulumi.output_type
class GetVirtualNetworkGatewayConnectionIkeSasResult:
    def __init__(__self__, value=None):
        if value and not isinstance(value, str):
            raise TypeError("Expected argument 'value' to be a str")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[builtins.str]:
        return pulumi.get(self, "value")


class AwaitableGetVirtualNetworkGatewayConnectionIkeSasResult(GetVirtualNetworkGatewayConnectionIkeSasResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVirtualNetworkGatewayConnectionIkeSasResult(
            value=self.value)


def get_virtual_network_gateway_connection_ike_sas(resource_group_name: Optional[builtins.str] = None,
                                                   virtual_network_gateway_connection_name: Optional[builtins.str] = None,
                                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVirtualNetworkGatewayConnectionIkeSasResult:
    """
    Lists IKE Security Associations for the virtual network gateway connection in the specified resource group.

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2020-08-01, 2020-11-01, 2021-02-01, 2021-03-01, 2021-05-01, 2021-08-01, 2022-01-01, 2022-05-01, 2022-07-01, 2022-09-01, 2022-11-01, 2023-02-01, 2023-04-01, 2023-05-01, 2023-06-01, 2023-09-01, 2023-11-01, 2024-01-01, 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_group_name: The name of the resource group.
    :param builtins.str virtual_network_gateway_connection_name: The name of the virtual network gateway Connection.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['virtualNetworkGatewayConnectionName'] = virtual_network_gateway_connection_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:network:getVirtualNetworkGatewayConnectionIkeSas', __args__, opts=opts, typ=GetVirtualNetworkGatewayConnectionIkeSasResult).value

    return AwaitableGetVirtualNetworkGatewayConnectionIkeSasResult(
        value=pulumi.get(__ret__, 'value'))
def get_virtual_network_gateway_connection_ike_sas_output(resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                          virtual_network_gateway_connection_name: Optional[pulumi.Input[builtins.str]] = None,
                                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetVirtualNetworkGatewayConnectionIkeSasResult]:
    """
    Lists IKE Security Associations for the virtual network gateway connection in the specified resource group.

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2020-08-01, 2020-11-01, 2021-02-01, 2021-03-01, 2021-05-01, 2021-08-01, 2022-01-01, 2022-05-01, 2022-07-01, 2022-09-01, 2022-11-01, 2023-02-01, 2023-04-01, 2023-05-01, 2023-06-01, 2023-09-01, 2023-11-01, 2024-01-01, 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_group_name: The name of the resource group.
    :param builtins.str virtual_network_gateway_connection_name: The name of the virtual network gateway Connection.
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['virtualNetworkGatewayConnectionName'] = virtual_network_gateway_connection_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:network:getVirtualNetworkGatewayConnectionIkeSas', __args__, opts=opts, typ=GetVirtualNetworkGatewayConnectionIkeSasResult)
    return __ret__.apply(lambda __response__: GetVirtualNetworkGatewayConnectionIkeSasResult(
        value=pulumi.get(__response__, 'value')))
