# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = [
    'ListFirewallPolicyIdpsSignatureResult',
    'AwaitableListFirewallPolicyIdpsSignatureResult',
    'list_firewall_policy_idps_signature',
    'list_firewall_policy_idps_signature_output',
]

@pulumi.output_type
class ListFirewallPolicyIdpsSignatureResult:
    """
    Query result
    """
    def __init__(__self__, matching_records_count=None, signatures=None):
        if matching_records_count and not isinstance(matching_records_count, float):
            raise TypeError("Expected argument 'matching_records_count' to be a float")
        pulumi.set(__self__, "matching_records_count", matching_records_count)
        if signatures and not isinstance(signatures, list):
            raise TypeError("Expected argument 'signatures' to be a list")
        pulumi.set(__self__, "signatures", signatures)

    @property
    @pulumi.getter(name="matchingRecordsCount")
    def matching_records_count(self) -> Optional[builtins.float]:
        """
        Number of total records matching the query.
        """
        return pulumi.get(self, "matching_records_count")

    @property
    @pulumi.getter
    def signatures(self) -> Optional[Sequence['outputs.SingleQueryResultResponse']]:
        """
        Array containing the results of the query
        """
        return pulumi.get(self, "signatures")


class AwaitableListFirewallPolicyIdpsSignatureResult(ListFirewallPolicyIdpsSignatureResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListFirewallPolicyIdpsSignatureResult(
            matching_records_count=self.matching_records_count,
            signatures=self.signatures)


def list_firewall_policy_idps_signature(filters: Optional[Sequence[Union['FilterItems', 'FilterItemsDict']]] = None,
                                        firewall_policy_name: Optional[builtins.str] = None,
                                        order_by: Optional[Union['OrderBy', 'OrderByDict']] = None,
                                        resource_group_name: Optional[builtins.str] = None,
                                        results_per_page: Optional[builtins.int] = None,
                                        search: Optional[builtins.str] = None,
                                        skip: Optional[builtins.int] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListFirewallPolicyIdpsSignatureResult:
    """
    Retrieves the current status of IDPS signatures for the relevant policy. Maximal amount of returned signatures is 1000.

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2021-05-01, 2021-08-01, 2022-01-01, 2022-05-01, 2022-07-01, 2022-09-01, 2022-11-01, 2023-02-01, 2023-04-01, 2023-05-01, 2023-06-01, 2023-09-01, 2023-11-01, 2024-01-01, 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param Sequence[Union['FilterItems', 'FilterItemsDict']] filters: Contain all filters names and values
    :param builtins.str firewall_policy_name: The name of the Firewall Policy.
    :param Union['OrderBy', 'OrderByDict'] order_by: Column to sort response by
    :param builtins.str resource_group_name: The name of the resource group.
    :param builtins.int results_per_page: The number of the results to return in each page
    :param builtins.str search: Search term in all columns
    :param builtins.int skip: The number of records matching the filter to skip
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['firewallPolicyName'] = firewall_policy_name
    __args__['orderBy'] = order_by
    __args__['resourceGroupName'] = resource_group_name
    __args__['resultsPerPage'] = results_per_page
    __args__['search'] = search
    __args__['skip'] = skip
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:network:listFirewallPolicyIdpsSignature', __args__, opts=opts, typ=ListFirewallPolicyIdpsSignatureResult).value

    return AwaitableListFirewallPolicyIdpsSignatureResult(
        matching_records_count=pulumi.get(__ret__, 'matching_records_count'),
        signatures=pulumi.get(__ret__, 'signatures'))
def list_firewall_policy_idps_signature_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['FilterItems', 'FilterItemsDict']]]]] = None,
                                               firewall_policy_name: Optional[pulumi.Input[builtins.str]] = None,
                                               order_by: Optional[pulumi.Input[Optional[Union['OrderBy', 'OrderByDict']]]] = None,
                                               resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                               results_per_page: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                                               search: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                               skip: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListFirewallPolicyIdpsSignatureResult]:
    """
    Retrieves the current status of IDPS signatures for the relevant policy. Maximal amount of returned signatures is 1000.

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2021-05-01, 2021-08-01, 2022-01-01, 2022-05-01, 2022-07-01, 2022-09-01, 2022-11-01, 2023-02-01, 2023-04-01, 2023-05-01, 2023-06-01, 2023-09-01, 2023-11-01, 2024-01-01, 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param Sequence[Union['FilterItems', 'FilterItemsDict']] filters: Contain all filters names and values
    :param builtins.str firewall_policy_name: The name of the Firewall Policy.
    :param Union['OrderBy', 'OrderByDict'] order_by: Column to sort response by
    :param builtins.str resource_group_name: The name of the resource group.
    :param builtins.int results_per_page: The number of the results to return in each page
    :param builtins.str search: Search term in all columns
    :param builtins.int skip: The number of records matching the filter to skip
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['firewallPolicyName'] = firewall_policy_name
    __args__['orderBy'] = order_by
    __args__['resourceGroupName'] = resource_group_name
    __args__['resultsPerPage'] = results_per_page
    __args__['search'] = search
    __args__['skip'] = skip
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:network:listFirewallPolicyIdpsSignature', __args__, opts=opts, typ=ListFirewallPolicyIdpsSignatureResult)
    return __ret__.apply(lambda __response__: ListFirewallPolicyIdpsSignatureResult(
        matching_records_count=pulumi.get(__response__, 'matching_records_count'),
        signatures=pulumi.get(__response__, 'signatures')))
