# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListFirewallPolicyIdpsSignaturesFilterValueResult',
    'AwaitableListFirewallPolicyIdpsSignaturesFilterValueResult',
    'list_firewall_policy_idps_signatures_filter_value',
    'list_firewall_policy_idps_signatures_filter_value_output',
]

@pulumi.output_type
class ListFirewallPolicyIdpsSignaturesFilterValueResult:
    """
    Describes the list of all possible values for a specific filter value
    """
    def __init__(__self__, filter_values=None):
        if filter_values and not isinstance(filter_values, list):
            raise TypeError("Expected argument 'filter_values' to be a list")
        pulumi.set(__self__, "filter_values", filter_values)

    @property
    @pulumi.getter(name="filterValues")
    def filter_values(self) -> Optional[Sequence[builtins.str]]:
        """
        Describes the possible values
        """
        return pulumi.get(self, "filter_values")


class AwaitableListFirewallPolicyIdpsSignaturesFilterValueResult(ListFirewallPolicyIdpsSignaturesFilterValueResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListFirewallPolicyIdpsSignaturesFilterValueResult(
            filter_values=self.filter_values)


def list_firewall_policy_idps_signatures_filter_value(filter_name: Optional[builtins.str] = None,
                                                      firewall_policy_name: Optional[builtins.str] = None,
                                                      resource_group_name: Optional[builtins.str] = None,
                                                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListFirewallPolicyIdpsSignaturesFilterValueResult:
    """
    Retrieves the current filter values for the signatures overrides

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2021-05-01, 2021-08-01, 2022-01-01, 2022-05-01, 2022-07-01, 2022-09-01, 2022-11-01, 2023-02-01, 2023-04-01, 2023-05-01, 2023-06-01, 2023-09-01, 2023-11-01, 2024-01-01, 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str filter_name: Describes the name of the column which values will be returned
    :param builtins.str firewall_policy_name: The name of the Firewall Policy.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['filterName'] = filter_name
    __args__['firewallPolicyName'] = firewall_policy_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:network:listFirewallPolicyIdpsSignaturesFilterValue', __args__, opts=opts, typ=ListFirewallPolicyIdpsSignaturesFilterValueResult).value

    return AwaitableListFirewallPolicyIdpsSignaturesFilterValueResult(
        filter_values=pulumi.get(__ret__, 'filter_values'))
def list_firewall_policy_idps_signatures_filter_value_output(filter_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                                             firewall_policy_name: Optional[pulumi.Input[builtins.str]] = None,
                                                             resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                             opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListFirewallPolicyIdpsSignaturesFilterValueResult]:
    """
    Retrieves the current filter values for the signatures overrides

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2021-05-01, 2021-08-01, 2022-01-01, 2022-05-01, 2022-07-01, 2022-09-01, 2022-11-01, 2023-02-01, 2023-04-01, 2023-05-01, 2023-06-01, 2023-09-01, 2023-11-01, 2024-01-01, 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str filter_name: Describes the name of the column which values will be returned
    :param builtins.str firewall_policy_name: The name of the Firewall Policy.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['filterName'] = filter_name
    __args__['firewallPolicyName'] = firewall_policy_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:network:listFirewallPolicyIdpsSignaturesFilterValue', __args__, opts=opts, typ=ListFirewallPolicyIdpsSignaturesFilterValueResult)
    return __ret__.apply(lambda __response__: ListFirewallPolicyIdpsSignaturesFilterValueResult(
        filter_values=pulumi.get(__response__, 'filter_values')))
