# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListIpamPoolAssociatedResourcesResult',
    'AwaitableListIpamPoolAssociatedResourcesResult',
    'list_ipam_pool_associated_resources',
    'list_ipam_pool_associated_resources_output',
]

@pulumi.output_type
class ListIpamPoolAssociatedResourcesResult:
    """
    List of PoolAssociation
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> Optional[builtins.str]:
        """
        The link used to get the next page of operations.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.PoolAssociationResponse']]:
        return pulumi.get(self, "value")


class AwaitableListIpamPoolAssociatedResourcesResult(ListIpamPoolAssociatedResourcesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListIpamPoolAssociatedResourcesResult(
            next_link=self.next_link,
            value=self.value)


def list_ipam_pool_associated_resources(network_manager_name: Optional[builtins.str] = None,
                                        pool_name: Optional[builtins.str] = None,
                                        resource_group_name: Optional[builtins.str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListIpamPoolAssociatedResourcesResult:
    """
    List of PoolAssociation

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2024-01-01-preview, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str network_manager_name: The name of the network manager.
    :param builtins.str pool_name: Pool resource name.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['networkManagerName'] = network_manager_name
    __args__['poolName'] = pool_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:network:listIpamPoolAssociatedResources', __args__, opts=opts, typ=ListIpamPoolAssociatedResourcesResult).value

    return AwaitableListIpamPoolAssociatedResourcesResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))
def list_ipam_pool_associated_resources_output(network_manager_name: Optional[pulumi.Input[builtins.str]] = None,
                                               pool_name: Optional[pulumi.Input[builtins.str]] = None,
                                               resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListIpamPoolAssociatedResourcesResult]:
    """
    List of PoolAssociation

    Uses Azure REST API version 2024-05-01.

    Other available API versions: 2024-01-01-preview, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str network_manager_name: The name of the network manager.
    :param builtins.str pool_name: Pool resource name.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['networkManagerName'] = network_manager_name
    __args__['poolName'] = pool_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:network:listIpamPoolAssociatedResources', __args__, opts=opts, typ=ListIpamPoolAssociatedResourcesResult)
    return __ret__.apply(lambda __response__: ListIpamPoolAssociatedResourcesResult(
        next_link=pulumi.get(__response__, 'next_link'),
        value=pulumi.get(__response__, 'value')))
