# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['NetworkProfileArgs', 'NetworkProfile']

@pulumi.input_type
class NetworkProfileArgs:
    def __init__(__self__, *,
                 resource_group_name: pulumi.Input[builtins.str],
                 container_network_interface_configurations: Optional[pulumi.Input[Sequence[pulumi.Input['ContainerNetworkInterfaceConfigurationArgs']]]] = None,
                 id: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 network_profile_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a NetworkProfile resource.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group.
        :param pulumi.Input[Sequence[pulumi.Input['ContainerNetworkInterfaceConfigurationArgs']]] container_network_interface_configurations: List of chid container network interface configurations.
        :param pulumi.Input[builtins.str] id: Resource ID.
        :param pulumi.Input[builtins.str] location: Resource location.
        :param pulumi.Input[builtins.str] network_profile_name: The name of the network profile.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if container_network_interface_configurations is not None:
            pulumi.set(__self__, "container_network_interface_configurations", container_network_interface_configurations)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if network_profile_name is not None:
            pulumi.set(__self__, "network_profile_name", network_profile_name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="containerNetworkInterfaceConfigurations")
    def container_network_interface_configurations(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ContainerNetworkInterfaceConfigurationArgs']]]]:
        """
        List of chid container network interface configurations.
        """
        return pulumi.get(self, "container_network_interface_configurations")

    @container_network_interface_configurations.setter
    def container_network_interface_configurations(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ContainerNetworkInterfaceConfigurationArgs']]]]):
        pulumi.set(self, "container_network_interface_configurations", value)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Resource ID.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Resource location.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="networkProfileName")
    def network_profile_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the network profile.
        """
        return pulumi.get(self, "network_profile_name")

    @network_profile_name.setter
    def network_profile_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "network_profile_name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.type_token("azure-native:network:NetworkProfile")
class NetworkProfile(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 container_network_interface_configurations: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ContainerNetworkInterfaceConfigurationArgs', 'ContainerNetworkInterfaceConfigurationArgsDict']]]]] = None,
                 id: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 network_profile_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        Network profile resource.

        Uses Azure REST API version 2024-05-01. In version 2.x of the Azure Native provider, it used API version 2023-02-01.

        Other available API versions: 2018-08-01, 2018-10-01, 2018-11-01, 2018-12-01, 2019-02-01, 2019-04-01, 2019-06-01, 2019-07-01, 2019-08-01, 2019-09-01, 2019-11-01, 2019-12-01, 2020-03-01, 2020-04-01, 2020-05-01, 2020-06-01, 2020-07-01, 2020-08-01, 2020-11-01, 2021-02-01, 2021-03-01, 2021-05-01, 2021-08-01, 2022-01-01, 2022-05-01, 2022-07-01, 2022-09-01, 2022-11-01, 2023-02-01, 2023-04-01, 2023-05-01, 2023-06-01, 2023-09-01, 2023-11-01, 2024-01-01, 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ContainerNetworkInterfaceConfigurationArgs', 'ContainerNetworkInterfaceConfigurationArgsDict']]]] container_network_interface_configurations: List of chid container network interface configurations.
        :param pulumi.Input[builtins.str] id: Resource ID.
        :param pulumi.Input[builtins.str] location: Resource location.
        :param pulumi.Input[builtins.str] network_profile_name: The name of the network profile.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: Resource tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NetworkProfileArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Network profile resource.

        Uses Azure REST API version 2024-05-01. In version 2.x of the Azure Native provider, it used API version 2023-02-01.

        Other available API versions: 2018-08-01, 2018-10-01, 2018-11-01, 2018-12-01, 2019-02-01, 2019-04-01, 2019-06-01, 2019-07-01, 2019-08-01, 2019-09-01, 2019-11-01, 2019-12-01, 2020-03-01, 2020-04-01, 2020-05-01, 2020-06-01, 2020-07-01, 2020-08-01, 2020-11-01, 2021-02-01, 2021-03-01, 2021-05-01, 2021-08-01, 2022-01-01, 2022-05-01, 2022-07-01, 2022-09-01, 2022-11-01, 2023-02-01, 2023-04-01, 2023-05-01, 2023-06-01, 2023-09-01, 2023-11-01, 2024-01-01, 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param NetworkProfileArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NetworkProfileArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 container_network_interface_configurations: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ContainerNetworkInterfaceConfigurationArgs', 'ContainerNetworkInterfaceConfigurationArgsDict']]]]] = None,
                 id: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 network_profile_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NetworkProfileArgs.__new__(NetworkProfileArgs)

            __props__.__dict__["container_network_interface_configurations"] = container_network_interface_configurations
            __props__.__dict__["id"] = id
            __props__.__dict__["location"] = location
            __props__.__dict__["network_profile_name"] = network_profile_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["container_network_interfaces"] = None
            __props__.__dict__["etag"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["resource_guid"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:network/v20180801:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20181001:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20181101:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20181201:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20190201:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20190401:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20190601:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20190701:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20190801:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20190901:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20191101:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20191201:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20200301:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20200401:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20200501:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20200601:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20200701:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20200801:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20201101:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20210201:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20210301:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20210501:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20210801:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20220101:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20220501:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20220701:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20220901:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20221101:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20230201:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20230401:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20230501:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20230601:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20230901:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20231101:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20240101:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20240301:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20240501:NetworkProfile"), pulumi.Alias(type_="azure-native:network/v20240701:NetworkProfile")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(NetworkProfile, __self__).__init__(
            'azure-native:network:NetworkProfile',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'NetworkProfile':
        """
        Get an existing NetworkProfile resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = NetworkProfileArgs.__new__(NetworkProfileArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["container_network_interface_configurations"] = None
        __props__.__dict__["container_network_interfaces"] = None
        __props__.__dict__["etag"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["resource_guid"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return NetworkProfile(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="containerNetworkInterfaceConfigurations")
    def container_network_interface_configurations(self) -> pulumi.Output[Optional[Sequence['outputs.ContainerNetworkInterfaceConfigurationResponse']]]:
        """
        List of chid container network interface configurations.
        """
        return pulumi.get(self, "container_network_interface_configurations")

    @property
    @pulumi.getter(name="containerNetworkInterfaces")
    def container_network_interfaces(self) -> pulumi.Output[Sequence['outputs.ContainerNetworkInterfaceResponse']]:
        """
        List of child container network interfaces.
        """
        return pulumi.get(self, "container_network_interfaces")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[builtins.str]:
        """
        A unique read-only string that changes whenever the resource is updated.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Resource location.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        The provisioning state of the network profile resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="resourceGuid")
    def resource_guid(self) -> pulumi.Output[builtins.str]:
        """
        The resource GUID property of the network profile resource.
        """
        return pulumi.get(self, "resource_guid")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        Resource type.
        """
        return pulumi.get(self, "type")

