# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NetworkSecurityPerimeterLoggingConfigurationArgs', 'NetworkSecurityPerimeterLoggingConfiguration']

@pulumi.input_type
class NetworkSecurityPerimeterLoggingConfigurationArgs:
    def __init__(__self__, *,
                 network_security_perimeter_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 logging_configuration_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input['NspLoggingConfigurationPropertiesArgs']] = None):
        """
        The set of arguments for constructing a NetworkSecurityPerimeterLoggingConfiguration resource.
        :param pulumi.Input[builtins.str] network_security_perimeter_name: The name of the network security perimeter.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group.
        :param pulumi.Input[builtins.str] logging_configuration_name: The name of the NSP logging configuration. Accepts 'instance' as name.
        :param pulumi.Input['NspLoggingConfigurationPropertiesArgs'] properties: Properties of the NSP logging configuration.
        """
        pulumi.set(__self__, "network_security_perimeter_name", network_security_perimeter_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if logging_configuration_name is not None:
            pulumi.set(__self__, "logging_configuration_name", logging_configuration_name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter(name="networkSecurityPerimeterName")
    def network_security_perimeter_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the network security perimeter.
        """
        return pulumi.get(self, "network_security_perimeter_name")

    @network_security_perimeter_name.setter
    def network_security_perimeter_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "network_security_perimeter_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="loggingConfigurationName")
    def logging_configuration_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the NSP logging configuration. Accepts 'instance' as name.
        """
        return pulumi.get(self, "logging_configuration_name")

    @logging_configuration_name.setter
    def logging_configuration_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "logging_configuration_name", value)

    @property
    @pulumi.getter
    def properties(self) -> Optional[pulumi.Input['NspLoggingConfigurationPropertiesArgs']]:
        """
        Properties of the NSP logging configuration.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: Optional[pulumi.Input['NspLoggingConfigurationPropertiesArgs']]):
        pulumi.set(self, "properties", value)


@pulumi.type_token("azure-native:network:NetworkSecurityPerimeterLoggingConfiguration")
class NetworkSecurityPerimeterLoggingConfiguration(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 logging_configuration_name: Optional[pulumi.Input[builtins.str]] = None,
                 network_security_perimeter_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['NspLoggingConfigurationPropertiesArgs', 'NspLoggingConfigurationPropertiesArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        The NSP logging configuration

        Uses Azure REST API version 2024-06-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-06-01-preview.

        Other available API versions: 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] logging_configuration_name: The name of the NSP logging configuration. Accepts 'instance' as name.
        :param pulumi.Input[builtins.str] network_security_perimeter_name: The name of the network security perimeter.
        :param pulumi.Input[Union['NspLoggingConfigurationPropertiesArgs', 'NspLoggingConfigurationPropertiesArgsDict']] properties: Properties of the NSP logging configuration.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NetworkSecurityPerimeterLoggingConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The NSP logging configuration

        Uses Azure REST API version 2024-06-01-preview. In version 2.x of the Azure Native provider, it used API version 2024-06-01-preview.

        Other available API versions: 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param NetworkSecurityPerimeterLoggingConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NetworkSecurityPerimeterLoggingConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 logging_configuration_name: Optional[pulumi.Input[builtins.str]] = None,
                 network_security_perimeter_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['NspLoggingConfigurationPropertiesArgs', 'NspLoggingConfigurationPropertiesArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NetworkSecurityPerimeterLoggingConfigurationArgs.__new__(NetworkSecurityPerimeterLoggingConfigurationArgs)

            __props__.__dict__["logging_configuration_name"] = logging_configuration_name
            if network_security_perimeter_name is None and not opts.urn:
                raise TypeError("Missing required property 'network_security_perimeter_name'")
            __props__.__dict__["network_security_perimeter_name"] = network_security_perimeter_name
            __props__.__dict__["properties"] = properties
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["etag"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:network/v20240601preview:NetworkSecurityPerimeterLoggingConfiguration"), pulumi.Alias(type_="azure-native:network/v20240701:NetworkSecurityPerimeterLoggingConfiguration")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(NetworkSecurityPerimeterLoggingConfiguration, __self__).__init__(
            'azure-native:network:NetworkSecurityPerimeterLoggingConfiguration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'NetworkSecurityPerimeterLoggingConfiguration':
        """
        Get an existing NetworkSecurityPerimeterLoggingConfiguration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = NetworkSecurityPerimeterLoggingConfigurationArgs.__new__(NetworkSecurityPerimeterLoggingConfigurationArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["etag"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["type"] = None
        return NetworkSecurityPerimeterLoggingConfiguration(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[builtins.str]:
        """
        A unique read-only string that changes whenever the resource is updated.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.NspLoggingConfigurationPropertiesResponse']:
        """
        Properties of the NSP logging configuration.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        Resource type.
        """
        return pulumi.get(self, "type")

