# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ReachabilityAnalysisRunArgs', 'ReachabilityAnalysisRun']

@pulumi.input_type
class ReachabilityAnalysisRunArgs:
    def __init__(__self__, *,
                 network_manager_name: pulumi.Input[builtins.str],
                 properties: pulumi.Input['ReachabilityAnalysisRunPropertiesArgs'],
                 resource_group_name: pulumi.Input[builtins.str],
                 workspace_name: pulumi.Input[builtins.str],
                 reachability_analysis_run_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a ReachabilityAnalysisRun resource.
        :param pulumi.Input[builtins.str] network_manager_name: The name of the network manager.
        :param pulumi.Input['ReachabilityAnalysisRunPropertiesArgs'] properties: Represents the Reachability Analysis Run properties.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group.
        :param pulumi.Input[builtins.str] workspace_name: Workspace name.
        :param pulumi.Input[builtins.str] reachability_analysis_run_name: Reachability Analysis Run name.
        """
        pulumi.set(__self__, "network_manager_name", network_manager_name)
        pulumi.set(__self__, "properties", properties)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "workspace_name", workspace_name)
        if reachability_analysis_run_name is not None:
            pulumi.set(__self__, "reachability_analysis_run_name", reachability_analysis_run_name)

    @property
    @pulumi.getter(name="networkManagerName")
    def network_manager_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the network manager.
        """
        return pulumi.get(self, "network_manager_name")

    @network_manager_name.setter
    def network_manager_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "network_manager_name", value)

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Input['ReachabilityAnalysisRunPropertiesArgs']:
        """
        Represents the Reachability Analysis Run properties.
        """
        return pulumi.get(self, "properties")

    @properties.setter
    def properties(self, value: pulumi.Input['ReachabilityAnalysisRunPropertiesArgs']):
        pulumi.set(self, "properties", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="workspaceName")
    def workspace_name(self) -> pulumi.Input[builtins.str]:
        """
        Workspace name.
        """
        return pulumi.get(self, "workspace_name")

    @workspace_name.setter
    def workspace_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "workspace_name", value)

    @property
    @pulumi.getter(name="reachabilityAnalysisRunName")
    def reachability_analysis_run_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Reachability Analysis Run name.
        """
        return pulumi.get(self, "reachability_analysis_run_name")

    @reachability_analysis_run_name.setter
    def reachability_analysis_run_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "reachability_analysis_run_name", value)


@pulumi.type_token("azure-native:network:ReachabilityAnalysisRun")
class ReachabilityAnalysisRun(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 network_manager_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['ReachabilityAnalysisRunPropertiesArgs', 'ReachabilityAnalysisRunPropertiesArgsDict']]] = None,
                 reachability_analysis_run_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Configuration information for analysis run.

        Uses Azure REST API version 2024-05-01. In version 2.x of the Azure Native provider, it used API version 2024-01-01-preview.

        Other available API versions: 2024-01-01-preview, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] network_manager_name: The name of the network manager.
        :param pulumi.Input[Union['ReachabilityAnalysisRunPropertiesArgs', 'ReachabilityAnalysisRunPropertiesArgsDict']] properties: Represents the Reachability Analysis Run properties.
        :param pulumi.Input[builtins.str] reachability_analysis_run_name: Reachability Analysis Run name.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group.
        :param pulumi.Input[builtins.str] workspace_name: Workspace name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ReachabilityAnalysisRunArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configuration information for analysis run.

        Uses Azure REST API version 2024-05-01. In version 2.x of the Azure Native provider, it used API version 2024-01-01-preview.

        Other available API versions: 2024-01-01-preview, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param ReachabilityAnalysisRunArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ReachabilityAnalysisRunArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 network_manager_name: Optional[pulumi.Input[builtins.str]] = None,
                 properties: Optional[pulumi.Input[Union['ReachabilityAnalysisRunPropertiesArgs', 'ReachabilityAnalysisRunPropertiesArgsDict']]] = None,
                 reachability_analysis_run_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ReachabilityAnalysisRunArgs.__new__(ReachabilityAnalysisRunArgs)

            if network_manager_name is None and not opts.urn:
                raise TypeError("Missing required property 'network_manager_name'")
            __props__.__dict__["network_manager_name"] = network_manager_name
            if properties is None and not opts.urn:
                raise TypeError("Missing required property 'properties'")
            __props__.__dict__["properties"] = properties
            __props__.__dict__["reachability_analysis_run_name"] = reachability_analysis_run_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if workspace_name is None and not opts.urn:
                raise TypeError("Missing required property 'workspace_name'")
            __props__.__dict__["workspace_name"] = workspace_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:network/v20240101preview:ReachabilityAnalysisRun"), pulumi.Alias(type_="azure-native:network/v20240501:ReachabilityAnalysisRun"), pulumi.Alias(type_="azure-native:network/v20240701:ReachabilityAnalysisRun")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(ReachabilityAnalysisRun, __self__).__init__(
            'azure-native:network:ReachabilityAnalysisRun',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'ReachabilityAnalysisRun':
        """
        Get an existing ReachabilityAnalysisRun resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ReachabilityAnalysisRunArgs.__new__(ReachabilityAnalysisRunArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return ReachabilityAnalysisRun(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.ReachabilityAnalysisRunPropertiesResponse']:
        """
        Represents the Reachability Analysis Run properties.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

