# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['RoutingRuleCollectionArgs', 'RoutingRuleCollection']

@pulumi.input_type
class RoutingRuleCollectionArgs:
    def __init__(__self__, *,
                 applies_to: pulumi.Input[Sequence[pulumi.Input['NetworkManagerRoutingGroupItemArgs']]],
                 configuration_name: pulumi.Input[builtins.str],
                 network_manager_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 disable_bgp_route_propagation: Optional[pulumi.Input[Union[builtins.str, 'DisableBgpRoutePropagation']]] = None,
                 rule_collection_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a RoutingRuleCollection resource.
        :param pulumi.Input[Sequence[pulumi.Input['NetworkManagerRoutingGroupItemArgs']]] applies_to: Groups for configuration
        :param pulumi.Input[builtins.str] configuration_name: The name of the network manager Routing Configuration.
        :param pulumi.Input[builtins.str] network_manager_name: The name of the network manager.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] description: A description of the routing rule collection.
        :param pulumi.Input[Union[builtins.str, 'DisableBgpRoutePropagation']] disable_bgp_route_propagation: Determines whether BGP route propagation is enabled. Defaults to true.
        :param pulumi.Input[builtins.str] rule_collection_name: The name of the network manager routing Configuration rule collection.
        """
        pulumi.set(__self__, "applies_to", applies_to)
        pulumi.set(__self__, "configuration_name", configuration_name)
        pulumi.set(__self__, "network_manager_name", network_manager_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if disable_bgp_route_propagation is not None:
            pulumi.set(__self__, "disable_bgp_route_propagation", disable_bgp_route_propagation)
        if rule_collection_name is not None:
            pulumi.set(__self__, "rule_collection_name", rule_collection_name)

    @property
    @pulumi.getter(name="appliesTo")
    def applies_to(self) -> pulumi.Input[Sequence[pulumi.Input['NetworkManagerRoutingGroupItemArgs']]]:
        """
        Groups for configuration
        """
        return pulumi.get(self, "applies_to")

    @applies_to.setter
    def applies_to(self, value: pulumi.Input[Sequence[pulumi.Input['NetworkManagerRoutingGroupItemArgs']]]):
        pulumi.set(self, "applies_to", value)

    @property
    @pulumi.getter(name="configurationName")
    def configuration_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the network manager Routing Configuration.
        """
        return pulumi.get(self, "configuration_name")

    @configuration_name.setter
    def configuration_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "configuration_name", value)

    @property
    @pulumi.getter(name="networkManagerName")
    def network_manager_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the network manager.
        """
        return pulumi.get(self, "network_manager_name")

    @network_manager_name.setter
    def network_manager_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "network_manager_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A description of the routing rule collection.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="disableBgpRoutePropagation")
    def disable_bgp_route_propagation(self) -> Optional[pulumi.Input[Union[builtins.str, 'DisableBgpRoutePropagation']]]:
        """
        Determines whether BGP route propagation is enabled. Defaults to true.
        """
        return pulumi.get(self, "disable_bgp_route_propagation")

    @disable_bgp_route_propagation.setter
    def disable_bgp_route_propagation(self, value: Optional[pulumi.Input[Union[builtins.str, 'DisableBgpRoutePropagation']]]):
        pulumi.set(self, "disable_bgp_route_propagation", value)

    @property
    @pulumi.getter(name="ruleCollectionName")
    def rule_collection_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the network manager routing Configuration rule collection.
        """
        return pulumi.get(self, "rule_collection_name")

    @rule_collection_name.setter
    def rule_collection_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "rule_collection_name", value)


@pulumi.type_token("azure-native:network:RoutingRuleCollection")
class RoutingRuleCollection(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 applies_to: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NetworkManagerRoutingGroupItemArgs', 'NetworkManagerRoutingGroupItemArgsDict']]]]] = None,
                 configuration_name: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 disable_bgp_route_propagation: Optional[pulumi.Input[Union[builtins.str, 'DisableBgpRoutePropagation']]] = None,
                 network_manager_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 rule_collection_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Defines the routing rule collection.

        Uses Azure REST API version 2024-05-01. In version 2.x of the Azure Native provider, it used API version 2024-03-01.

        Other available API versions: 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['NetworkManagerRoutingGroupItemArgs', 'NetworkManagerRoutingGroupItemArgsDict']]]] applies_to: Groups for configuration
        :param pulumi.Input[builtins.str] configuration_name: The name of the network manager Routing Configuration.
        :param pulumi.Input[builtins.str] description: A description of the routing rule collection.
        :param pulumi.Input[Union[builtins.str, 'DisableBgpRoutePropagation']] disable_bgp_route_propagation: Determines whether BGP route propagation is enabled. Defaults to true.
        :param pulumi.Input[builtins.str] network_manager_name: The name of the network manager.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] rule_collection_name: The name of the network manager routing Configuration rule collection.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RoutingRuleCollectionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Defines the routing rule collection.

        Uses Azure REST API version 2024-05-01. In version 2.x of the Azure Native provider, it used API version 2024-03-01.

        Other available API versions: 2024-03-01, 2024-07-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native network [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param RoutingRuleCollectionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RoutingRuleCollectionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 applies_to: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NetworkManagerRoutingGroupItemArgs', 'NetworkManagerRoutingGroupItemArgsDict']]]]] = None,
                 configuration_name: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 disable_bgp_route_propagation: Optional[pulumi.Input[Union[builtins.str, 'DisableBgpRoutePropagation']]] = None,
                 network_manager_name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 rule_collection_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RoutingRuleCollectionArgs.__new__(RoutingRuleCollectionArgs)

            if applies_to is None and not opts.urn:
                raise TypeError("Missing required property 'applies_to'")
            __props__.__dict__["applies_to"] = applies_to
            if configuration_name is None and not opts.urn:
                raise TypeError("Missing required property 'configuration_name'")
            __props__.__dict__["configuration_name"] = configuration_name
            __props__.__dict__["description"] = description
            __props__.__dict__["disable_bgp_route_propagation"] = disable_bgp_route_propagation
            if network_manager_name is None and not opts.urn:
                raise TypeError("Missing required property 'network_manager_name'")
            __props__.__dict__["network_manager_name"] = network_manager_name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["rule_collection_name"] = rule_collection_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["etag"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["resource_guid"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:network/v20240301:RoutingRuleCollection"), pulumi.Alias(type_="azure-native:network/v20240501:RoutingRuleCollection"), pulumi.Alias(type_="azure-native:network/v20240701:RoutingRuleCollection")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(RoutingRuleCollection, __self__).__init__(
            'azure-native:network:RoutingRuleCollection',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'RoutingRuleCollection':
        """
        Get an existing RoutingRuleCollection resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = RoutingRuleCollectionArgs.__new__(RoutingRuleCollectionArgs)

        __props__.__dict__["applies_to"] = None
        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["description"] = None
        __props__.__dict__["disable_bgp_route_propagation"] = None
        __props__.__dict__["etag"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["resource_guid"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return RoutingRuleCollection(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="appliesTo")
    def applies_to(self) -> pulumi.Output[Sequence['outputs.NetworkManagerRoutingGroupItemResponse']]:
        """
        Groups for configuration
        """
        return pulumi.get(self, "applies_to")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        A description of the routing rule collection.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="disableBgpRoutePropagation")
    def disable_bgp_route_propagation(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Determines whether BGP route propagation is enabled. Defaults to true.
        """
        return pulumi.get(self, "disable_bgp_route_propagation")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[builtins.str]:
        """
        A unique read-only string that changes whenever the resource is updated.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        The provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="resourceGuid")
    def resource_guid(self) -> pulumi.Output[builtins.str]:
        """
        Unique identifier for this resource.
        """
        return pulumi.get(self, "resource_guid")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        The system metadata related to this resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        Resource type.
        """
        return pulumi.get(self, "type")

