# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AdvertiseToFabric',
    'AgentPoolMode',
    'BareMetalMachineKeySetPrivilegeLevel',
    'BfdEnabled',
    'BgpMultiHop',
    'BmcKeySetPrivilegeLevel',
    'CloudServicesNetworkEnableDefaultEgressEndpoints',
    'ClusterSecretArchiveEnabled',
    'ClusterType',
    'ClusterUpdateStrategyType',
    'ConsoleEnabled',
    'DefaultGateway',
    'FabricPeeringEnabled',
    'HugepagesSize',
    'HybridAksIpamEnabled',
    'HybridAksPluginType',
    'IpAllocationType',
    'KubernetesPluginType',
    'L3NetworkConfigurationIpamEnabled',
    'ManagedServiceIdentitySelectorType',
    'ManagedServiceIdentityType',
    'OsDiskCreateOption',
    'OsDiskDeleteOption',
    'RuntimeProtectionEnforcementLevel',
    'ValidationThresholdGrouping',
    'ValidationThresholdType',
    'VirtualMachineBootMethod',
    'VirtualMachineDeviceModelType',
    'VirtualMachineIPAllocationMethod',
    'VirtualMachineIsolateEmulatorThread',
    'VirtualMachinePlacementHintPodAffinityScope',
    'VirtualMachinePlacementHintType',
    'VirtualMachineSchedulingExecution',
    'VirtualMachineVirtioInterfaceType',
    'VulnerabilityScanningSettingsContainerScan',
]


@pulumi.type_token("azure-native:networkcloud:AdvertiseToFabric")
class AdvertiseToFabric(builtins.str, Enum):
    """
    The indicator of if this advertisement is also made to the network fabric associated with the Network Cloud Cluster. This field is ignored if fabricPeeringEnabled is set to False.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:AgentPoolMode")
class AgentPoolMode(builtins.str, Enum):
    """
    The selection of how this agent pool is utilized, either as a system pool or a user pool. System pools run the features and critical services for the Kubernetes Cluster, while user pools are dedicated to user workloads. Every Kubernetes cluster must contain at least one system node pool with at least one node.
    """
    SYSTEM = "System"
    USER = "User"
    NOT_APPLICABLE = "NotApplicable"


@pulumi.type_token("azure-native:networkcloud:BareMetalMachineKeySetPrivilegeLevel")
class BareMetalMachineKeySetPrivilegeLevel(builtins.str, Enum):
    """
    The access level allowed for the users in this key set.
    """
    STANDARD = "Standard"
    SUPERUSER = "Superuser"


@pulumi.type_token("azure-native:networkcloud:BfdEnabled")
class BfdEnabled(builtins.str, Enum):
    """
    The indicator to prevent the use of IP addresses ending with .0 and .255 for this pool. Enabling this option will only use IP addresses between .1 and .254 inclusive.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:BgpMultiHop")
class BgpMultiHop(builtins.str, Enum):
    """
    The indicator to enable multi-hop peering support.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:BmcKeySetPrivilegeLevel")
class BmcKeySetPrivilegeLevel(builtins.str, Enum):
    """
    The access level allowed for the users in this key set.
    """
    READ_ONLY = "ReadOnly"
    ADMINISTRATOR = "Administrator"


@pulumi.type_token("azure-native:networkcloud:CloudServicesNetworkEnableDefaultEgressEndpoints")
class CloudServicesNetworkEnableDefaultEgressEndpoints(builtins.str, Enum):
    """
    The indicator of whether the platform default endpoints are allowed for the egress traffic.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:ClusterSecretArchiveEnabled")
class ClusterSecretArchiveEnabled(builtins.str, Enum):
    """
    The indicator if the specified key vault should be used to archive the secrets of the cluster.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:ClusterType")
class ClusterType(builtins.str, Enum):
    """
    The type of rack configuration for the cluster.
    """
    SINGLE_RACK = "SingleRack"
    MULTI_RACK = "MultiRack"


@pulumi.type_token("azure-native:networkcloud:ClusterUpdateStrategyType")
class ClusterUpdateStrategyType(builtins.str, Enum):
    """
    The mode of operation for runtime protection.
    """
    RACK = "Rack"
    PAUSE_AFTER_RACK = "PauseAfterRack"


@pulumi.type_token("azure-native:networkcloud:ConsoleEnabled")
class ConsoleEnabled(builtins.str, Enum):
    """
    The indicator of whether the console access is enabled.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:DefaultGateway")
class DefaultGateway(builtins.str, Enum):
    """
    The indicator of whether this is the default gateway.
    Only one of the attached networks (including the CloudServicesNetwork attachment) for a single machine may be specified as True.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:FabricPeeringEnabled")
class FabricPeeringEnabled(builtins.str, Enum):
    """
    The indicator to specify if the load balancer peers with the network fabric.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:HugepagesSize")
class HugepagesSize(builtins.str, Enum):
    """
    The size of the hugepages to allocate.
    """
    HUGEPAGES_SIZE_2_M = "2M"
    HUGEPAGES_SIZE_1_G = "1G"


@pulumi.type_token("azure-native:networkcloud:HybridAksIpamEnabled")
class HybridAksIpamEnabled(builtins.str, Enum):
    """
    Field Deprecated. The field was previously optional, now it will have no defined behavior and will be ignored. The indicator of whether or not to disable IPAM allocation on the network attachment definition injected into the Hybrid AKS Cluster.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:HybridAksPluginType")
class HybridAksPluginType(builtins.str, Enum):
    """
    Field Deprecated. The field was previously optional, now it will have no defined behavior and will be ignored. The network plugin type for Hybrid AKS.
    """
    DPDK = "DPDK"
    SRIOV = "SRIOV"
    OS_DEVICE = "OSDevice"


@pulumi.type_token("azure-native:networkcloud:IpAllocationType")
class IpAllocationType(builtins.str, Enum):
    """
    The type of the IP address allocation, defaulted to "DualStack".
    """
    IPV4 = "IPV4"
    IPV6 = "IPV6"
    DUAL_STACK = "DualStack"


@pulumi.type_token("azure-native:networkcloud:KubernetesPluginType")
class KubernetesPluginType(builtins.str, Enum):
    """
    The indicator of how this network will be utilized by the Kubernetes cluster.
    """
    DPDK = "DPDK"
    SRIOV = "SRIOV"
    OS_DEVICE = "OSDevice"
    MACVLAN = "MACVLAN"
    IPVLAN = "IPVLAN"


@pulumi.type_token("azure-native:networkcloud:L3NetworkConfigurationIpamEnabled")
class L3NetworkConfigurationIpamEnabled(builtins.str, Enum):
    """
    The indication of whether this network will or will not perform IP address management and allocate IP addresses when attached.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:ManagedServiceIdentitySelectorType")
class ManagedServiceIdentitySelectorType(builtins.str, Enum):
    """
    The type of managed identity that is being selected.
    """
    SYSTEM_ASSIGNED_IDENTITY = "SystemAssignedIdentity"
    USER_ASSIGNED_IDENTITY = "UserAssignedIdentity"


@pulumi.type_token("azure-native:networkcloud:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


@pulumi.type_token("azure-native:networkcloud:OsDiskCreateOption")
class OsDiskCreateOption(builtins.str, Enum):
    """
    The strategy for creating the OS disk.
    """
    EPHEMERAL = "Ephemeral"
    """
    Utilize the local storage of the host machine.
    """
    PERSISTENT = "Persistent"
    """
    Utilize a storage appliance backed volume to host the disk.
    """


@pulumi.type_token("azure-native:networkcloud:OsDiskDeleteOption")
class OsDiskDeleteOption(builtins.str, Enum):
    """
    The strategy for deleting the OS disk.
    """
    DELETE = "Delete"


@pulumi.type_token("azure-native:networkcloud:RuntimeProtectionEnforcementLevel")
class RuntimeProtectionEnforcementLevel(builtins.str, Enum):
    """
    The mode of operation for runtime protection.
    """
    AUDIT = "Audit"
    DISABLED = "Disabled"
    ON_DEMAND = "OnDemand"
    PASSIVE = "Passive"
    REAL_TIME = "RealTime"


@pulumi.type_token("azure-native:networkcloud:ValidationThresholdGrouping")
class ValidationThresholdGrouping(builtins.str, Enum):
    """
    Selection of how the type evaluation is applied to the cluster calculation.
    """
    PER_CLUSTER = "PerCluster"
    PER_RACK = "PerRack"


@pulumi.type_token("azure-native:networkcloud:ValidationThresholdType")
class ValidationThresholdType(builtins.str, Enum):
    """
    Selection of how the threshold should be evaluated.
    """
    COUNT_SUCCESS = "CountSuccess"
    PERCENT_SUCCESS = "PercentSuccess"


@pulumi.type_token("azure-native:networkcloud:VirtualMachineBootMethod")
class VirtualMachineBootMethod(builtins.str, Enum):
    """
    Selects the boot method for the virtual machine.
    """
    UEFI = "UEFI"
    BIOS = "BIOS"


@pulumi.type_token("azure-native:networkcloud:VirtualMachineDeviceModelType")
class VirtualMachineDeviceModelType(builtins.str, Enum):
    """
    The type of the device model to use.
    """
    T1 = "T1"
    """
    Traditional and most compatible device virtualization interface.
    """
    T2 = "T2"
    """
    Modern and enhanced device virtualization interface.
    """
    T3 = "T3"
    """
    Improved security and functionality (including TPM and secure boot support). Required for windows 11 and server 2025.
    """


@pulumi.type_token("azure-native:networkcloud:VirtualMachineIPAllocationMethod")
class VirtualMachineIPAllocationMethod(builtins.str, Enum):
    """
    The IP allocation mechanism for the virtual machine.
    Dynamic and Static are only valid for l3Network which may also specify Disabled.
    Otherwise, Disabled is the only permitted value.
    """
    DYNAMIC = "Dynamic"
    STATIC = "Static"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:networkcloud:VirtualMachineIsolateEmulatorThread")
class VirtualMachineIsolateEmulatorThread(builtins.str, Enum):
    """
    Field Deprecated, the value will be ignored if provided. The indicator of whether one of the specified CPU cores is isolated to run the emulator thread for this virtual machine.
    """
    TRUE = "True"
    FALSE = "False"


@pulumi.type_token("azure-native:networkcloud:VirtualMachinePlacementHintPodAffinityScope")
class VirtualMachinePlacementHintPodAffinityScope(builtins.str, Enum):
    """
    The scope for the virtual machine affinity or anti-affinity placement hint. It should always be "Machine" in the case of node affinity.
    """
    RACK = "Rack"
    MACHINE = "Machine"


@pulumi.type_token("azure-native:networkcloud:VirtualMachinePlacementHintType")
class VirtualMachinePlacementHintType(builtins.str, Enum):
    """
    The specification of whether this hint supports affinity or anti-affinity with the referenced resources.
    """
    AFFINITY = "Affinity"
    ANTI_AFFINITY = "AntiAffinity"


@pulumi.type_token("azure-native:networkcloud:VirtualMachineSchedulingExecution")
class VirtualMachineSchedulingExecution(builtins.str, Enum):
    """
    The indicator of whether the hint is a hard or soft requirement during scheduling.
    """
    HARD = "Hard"
    SOFT = "Soft"


@pulumi.type_token("azure-native:networkcloud:VirtualMachineVirtioInterfaceType")
class VirtualMachineVirtioInterfaceType(builtins.str, Enum):
    """
    Field Deprecated, use virtualizationModel instead. The type of the virtio interface.
    """
    MODERN = "Modern"
    TRANSITIONAL = "Transitional"


@pulumi.type_token("azure-native:networkcloud:VulnerabilityScanningSettingsContainerScan")
class VulnerabilityScanningSettingsContainerScan(builtins.str, Enum):
    """
    The mode selection for container vulnerability scanning.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"
