# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetCollectorPolicyResult',
    'AwaitableGetCollectorPolicyResult',
    'get_collector_policy',
    'get_collector_policy_output',
]

@pulumi.output_type
class GetCollectorPolicyResult:
    """
    Collector policy resource.
    """
    def __init__(__self__, azure_api_version=None, emission_policies=None, etag=None, id=None, ingestion_policy=None, location=None, name=None, provisioning_state=None, system_data=None, tags=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if emission_policies and not isinstance(emission_policies, list):
            raise TypeError("Expected argument 'emission_policies' to be a list")
        pulumi.set(__self__, "emission_policies", emission_policies)
        if etag and not isinstance(etag, str):
            raise TypeError("Expected argument 'etag' to be a str")
        pulumi.set(__self__, "etag", etag)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ingestion_policy and not isinstance(ingestion_policy, dict):
            raise TypeError("Expected argument 'ingestion_policy' to be a dict")
        pulumi.set(__self__, "ingestion_policy", ingestion_policy)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="emissionPolicies")
    def emission_policies(self) -> Optional[Sequence['outputs.EmissionPoliciesPropertiesFormatResponse']]:
        """
        Emission policies.
        """
        return pulumi.get(self, "emission_policies")

    @property
    @pulumi.getter
    def etag(self) -> builtins.str:
        """
        A unique read-only string that changes whenever the resource is updated.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Resource ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ingestionPolicy")
    def ingestion_policy(self) -> Optional['outputs.IngestionPolicyPropertiesFormatResponse']:
        """
        Ingestion policies.
        """
        return pulumi.get(self, "ingestion_policy")

    @property
    @pulumi.getter
    def location(self) -> builtins.str:
        """
        Resource location.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The provisioning state.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.TrackedResourceResponseSystemData':
        """
        Metadata pertaining to creation and last modification of the resource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, builtins.str]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Resource type.
        """
        return pulumi.get(self, "type")


class AwaitableGetCollectorPolicyResult(GetCollectorPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCollectorPolicyResult(
            azure_api_version=self.azure_api_version,
            emission_policies=self.emission_policies,
            etag=self.etag,
            id=self.id,
            ingestion_policy=self.ingestion_policy,
            location=self.location,
            name=self.name,
            provisioning_state=self.provisioning_state,
            system_data=self.system_data,
            tags=self.tags,
            type=self.type)


def get_collector_policy(azure_traffic_collector_name: Optional[builtins.str] = None,
                         collector_policy_name: Optional[builtins.str] = None,
                         resource_group_name: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCollectorPolicyResult:
    """
    Gets the collector policy in a specified Traffic Collector

    Uses Azure REST API version 2022-11-01.


    :param builtins.str azure_traffic_collector_name: Azure Traffic Collector name
    :param builtins.str collector_policy_name: Collector Policy Name
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['azureTrafficCollectorName'] = azure_traffic_collector_name
    __args__['collectorPolicyName'] = collector_policy_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:networkfunction:getCollectorPolicy', __args__, opts=opts, typ=GetCollectorPolicyResult).value

    return AwaitableGetCollectorPolicyResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        emission_policies=pulumi.get(__ret__, 'emission_policies'),
        etag=pulumi.get(__ret__, 'etag'),
        id=pulumi.get(__ret__, 'id'),
        ingestion_policy=pulumi.get(__ret__, 'ingestion_policy'),
        location=pulumi.get(__ret__, 'location'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        system_data=pulumi.get(__ret__, 'system_data'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'))
def get_collector_policy_output(azure_traffic_collector_name: Optional[pulumi.Input[builtins.str]] = None,
                                collector_policy_name: Optional[pulumi.Input[builtins.str]] = None,
                                resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetCollectorPolicyResult]:
    """
    Gets the collector policy in a specified Traffic Collector

    Uses Azure REST API version 2022-11-01.


    :param builtins.str azure_traffic_collector_name: Azure Traffic Collector name
    :param builtins.str collector_policy_name: Collector Policy Name
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['azureTrafficCollectorName'] = azure_traffic_collector_name
    __args__['collectorPolicyName'] = collector_policy_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:networkfunction:getCollectorPolicy', __args__, opts=opts, typ=GetCollectorPolicyResult)
    return __ret__.apply(lambda __response__: GetCollectorPolicyResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        emission_policies=pulumi.get(__response__, 'emission_policies'),
        etag=pulumi.get(__response__, 'etag'),
        id=pulumi.get(__response__, 'id'),
        ingestion_policy=pulumi.get(__response__, 'ingestion_policy'),
        location=pulumi.get(__response__, 'location'),
        name=pulumi.get(__response__, 'name'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        system_data=pulumi.get(__response__, 'system_data'),
        tags=pulumi.get(__response__, 'tags'),
        type=pulumi.get(__response__, 'type')))
