# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'ListSpacecraftAvailableContactsResult',
    'AwaitableListSpacecraftAvailableContactsResult',
    'list_spacecraft_available_contacts',
    'list_spacecraft_available_contacts_output',
]

@pulumi.output_type
class ListSpacecraftAvailableContactsResult:
    """
    Response for the ListAvailableContacts API service call.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> builtins.str:
        """
        The URL to get the next set of results.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.AvailableContactsResponse']]:
        """
        A list of available contacts.
        """
        return pulumi.get(self, "value")


class AwaitableListSpacecraftAvailableContactsResult(ListSpacecraftAvailableContactsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListSpacecraftAvailableContactsResult(
            next_link=self.next_link,
            value=self.value)


def list_spacecraft_available_contacts(contact_profile: Optional[Union['ContactParametersContactProfile', 'ContactParametersContactProfileDict']] = None,
                                       end_time: Optional[builtins.str] = None,
                                       ground_station_name: Optional[builtins.str] = None,
                                       resource_group_name: Optional[builtins.str] = None,
                                       spacecraft_name: Optional[builtins.str] = None,
                                       start_time: Optional[builtins.str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListSpacecraftAvailableContactsResult:
    """
    Returns list of available contacts. A contact is available if the spacecraft is visible from the ground station for more than the minimum viable contact duration provided in the contact profile.

    Uses Azure REST API version 2022-11-01.


    :param Union['ContactParametersContactProfile', 'ContactParametersContactProfileDict'] contact_profile: The reference to the contact profile resource.
    :param builtins.str end_time: End time of a contact (ISO 8601 UTC standard).
    :param builtins.str ground_station_name: Name of Azure Ground Station.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str spacecraft_name: Spacecraft ID.
    :param builtins.str start_time: Start time of a contact (ISO 8601 UTC standard).
    """
    __args__ = dict()
    __args__['contactProfile'] = contact_profile
    __args__['endTime'] = end_time
    __args__['groundStationName'] = ground_station_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['spacecraftName'] = spacecraft_name
    __args__['startTime'] = start_time
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:orbital:listSpacecraftAvailableContacts', __args__, opts=opts, typ=ListSpacecraftAvailableContactsResult).value

    return AwaitableListSpacecraftAvailableContactsResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))
def list_spacecraft_available_contacts_output(contact_profile: Optional[pulumi.Input[Union['ContactParametersContactProfile', 'ContactParametersContactProfileDict']]] = None,
                                              end_time: Optional[pulumi.Input[builtins.str]] = None,
                                              ground_station_name: Optional[pulumi.Input[builtins.str]] = None,
                                              resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                              spacecraft_name: Optional[pulumi.Input[builtins.str]] = None,
                                              start_time: Optional[pulumi.Input[builtins.str]] = None,
                                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListSpacecraftAvailableContactsResult]:
    """
    Returns list of available contacts. A contact is available if the spacecraft is visible from the ground station for more than the minimum viable contact duration provided in the contact profile.

    Uses Azure REST API version 2022-11-01.


    :param Union['ContactParametersContactProfile', 'ContactParametersContactProfileDict'] contact_profile: The reference to the contact profile resource.
    :param builtins.str end_time: End time of a contact (ISO 8601 UTC standard).
    :param builtins.str ground_station_name: Name of Azure Ground Station.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str spacecraft_name: Spacecraft ID.
    :param builtins.str start_time: Start time of a contact (ISO 8601 UTC standard).
    """
    __args__ = dict()
    __args__['contactProfile'] = contact_profile
    __args__['endTime'] = end_time
    __args__['groundStationName'] = ground_station_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['spacecraftName'] = spacecraft_name
    __args__['startTime'] = start_time
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:orbital:listSpacecraftAvailableContacts', __args__, opts=opts, typ=ListSpacecraftAvailableContactsResult)
    return __ret__.apply(lambda __response__: ListSpacecraftAvailableContactsResult(
        next_link=pulumi.get(__response__, 'next_link'),
        value=pulumi.get(__response__, 'value')))
