# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetConnectionMonitorTestResult',
    'AwaitableGetConnectionMonitorTestResult',
    'get_connection_monitor_test',
    'get_connection_monitor_test_output',
]

@pulumi.output_type
class GetConnectionMonitorTestResult:
    """
    The Connection Monitor Test class.
    """
    def __init__(__self__, azure_api_version=None, destination=None, destination_port=None, id=None, is_test_successful=None, name=None, path=None, provisioning_state=None, source_agent=None, test_frequency_in_sec=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if destination and not isinstance(destination, str):
            raise TypeError("Expected argument 'destination' to be a str")
        pulumi.set(__self__, "destination", destination)
        if destination_port and not isinstance(destination_port, int):
            raise TypeError("Expected argument 'destination_port' to be a int")
        pulumi.set(__self__, "destination_port", destination_port)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if is_test_successful and not isinstance(is_test_successful, bool):
            raise TypeError("Expected argument 'is_test_successful' to be a bool")
        pulumi.set(__self__, "is_test_successful", is_test_successful)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if path and not isinstance(path, list):
            raise TypeError("Expected argument 'path' to be a list")
        pulumi.set(__self__, "path", path)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if source_agent and not isinstance(source_agent, str):
            raise TypeError("Expected argument 'source_agent' to be a str")
        pulumi.set(__self__, "source_agent", source_agent)
        if test_frequency_in_sec and not isinstance(test_frequency_in_sec, int):
            raise TypeError("Expected argument 'test_frequency_in_sec' to be a int")
        pulumi.set(__self__, "test_frequency_in_sec", test_frequency_in_sec)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def destination(self) -> Optional[builtins.str]:
        """
        The Connection Monitor test destination
        """
        return pulumi.get(self, "destination")

    @property
    @pulumi.getter(name="destinationPort")
    def destination_port(self) -> Optional[builtins.int]:
        """
        The Connection Monitor test destination port
        """
        return pulumi.get(self, "destination_port")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The ID of the resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isTestSuccessful")
    def is_test_successful(self) -> builtins.bool:
        """
        The flag that indicates if the Connection Monitor test is successful or not.
        """
        return pulumi.get(self, "is_test_successful")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def path(self) -> Sequence[builtins.str]:
        """
        The path representing the Connection Monitor test.
        """
        return pulumi.get(self, "path")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The provisioning state of the resource.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="sourceAgent")
    def source_agent(self) -> Optional[builtins.str]:
        """
        The Connection Monitor test source agent
        """
        return pulumi.get(self, "source_agent")

    @property
    @pulumi.getter(name="testFrequencyInSec")
    def test_frequency_in_sec(self) -> Optional[builtins.int]:
        """
        The Connection Monitor test frequency in seconds
        """
        return pulumi.get(self, "test_frequency_in_sec")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource.
        """
        return pulumi.get(self, "type")


class AwaitableGetConnectionMonitorTestResult(GetConnectionMonitorTestResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetConnectionMonitorTestResult(
            azure_api_version=self.azure_api_version,
            destination=self.destination,
            destination_port=self.destination_port,
            id=self.id,
            is_test_successful=self.is_test_successful,
            name=self.name,
            path=self.path,
            provisioning_state=self.provisioning_state,
            source_agent=self.source_agent,
            test_frequency_in_sec=self.test_frequency_in_sec,
            type=self.type)


def get_connection_monitor_test(connection_monitor_test_name: Optional[builtins.str] = None,
                                peering_service_name: Optional[builtins.str] = None,
                                resource_group_name: Optional[builtins.str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetConnectionMonitorTestResult:
    """
    Gets an existing connection monitor test with the specified name under the given subscription, resource group and peering service.

    Uses Azure REST API version 2022-10-01.


    :param builtins.str connection_monitor_test_name: The name of the connection monitor test
    :param builtins.str peering_service_name: The name of the peering service.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['connectionMonitorTestName'] = connection_monitor_test_name
    __args__['peeringServiceName'] = peering_service_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:peering:getConnectionMonitorTest', __args__, opts=opts, typ=GetConnectionMonitorTestResult).value

    return AwaitableGetConnectionMonitorTestResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        destination=pulumi.get(__ret__, 'destination'),
        destination_port=pulumi.get(__ret__, 'destination_port'),
        id=pulumi.get(__ret__, 'id'),
        is_test_successful=pulumi.get(__ret__, 'is_test_successful'),
        name=pulumi.get(__ret__, 'name'),
        path=pulumi.get(__ret__, 'path'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        source_agent=pulumi.get(__ret__, 'source_agent'),
        test_frequency_in_sec=pulumi.get(__ret__, 'test_frequency_in_sec'),
        type=pulumi.get(__ret__, 'type'))
def get_connection_monitor_test_output(connection_monitor_test_name: Optional[pulumi.Input[builtins.str]] = None,
                                       peering_service_name: Optional[pulumi.Input[builtins.str]] = None,
                                       resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetConnectionMonitorTestResult]:
    """
    Gets an existing connection monitor test with the specified name under the given subscription, resource group and peering service.

    Uses Azure REST API version 2022-10-01.


    :param builtins.str connection_monitor_test_name: The name of the connection monitor test
    :param builtins.str peering_service_name: The name of the peering service.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['connectionMonitorTestName'] = connection_monitor_test_name
    __args__['peeringServiceName'] = peering_service_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:peering:getConnectionMonitorTest', __args__, opts=opts, typ=GetConnectionMonitorTestResult)
    return __ret__.apply(lambda __response__: GetConnectionMonitorTestResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        destination=pulumi.get(__response__, 'destination'),
        destination_port=pulumi.get(__response__, 'destination_port'),
        id=pulumi.get(__response__, 'id'),
        is_test_successful=pulumi.get(__response__, 'is_test_successful'),
        name=pulumi.get(__response__, 'name'),
        path=pulumi.get(__response__, 'path'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        source_agent=pulumi.get(__response__, 'source_agent'),
        test_frequency_in_sec=pulumi.get(__response__, 'test_frequency_in_sec'),
        type=pulumi.get(__response__, 'type')))
