# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListRemediationDeploymentsAtSubscriptionResult',
    'AwaitableListRemediationDeploymentsAtSubscriptionResult',
    'list_remediation_deployments_at_subscription',
    'list_remediation_deployments_at_subscription_output',
]

@pulumi.output_type
class ListRemediationDeploymentsAtSubscriptionResult:
    """
    List of deployments for a remediation.
    """
    def __init__(__self__, next_link=None, value=None):
        if next_link and not isinstance(next_link, str):
            raise TypeError("Expected argument 'next_link' to be a str")
        pulumi.set(__self__, "next_link", next_link)
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="nextLink")
    def next_link(self) -> builtins.str:
        """
        The URL to get the next set of results.
        """
        return pulumi.get(self, "next_link")

    @property
    @pulumi.getter
    def value(self) -> Sequence['outputs.RemediationDeploymentResponse']:
        """
        Array of deployments for the remediation.
        """
        return pulumi.get(self, "value")


class AwaitableListRemediationDeploymentsAtSubscriptionResult(ListRemediationDeploymentsAtSubscriptionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListRemediationDeploymentsAtSubscriptionResult(
            next_link=self.next_link,
            value=self.value)


def list_remediation_deployments_at_subscription(remediation_name: Optional[builtins.str] = None,
                                                 top: Optional[builtins.int] = None,
                                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListRemediationDeploymentsAtSubscriptionResult:
    """
    Gets all deployments for a remediation at subscription scope.

    Uses Azure REST API version 2024-10-01.

    Other available API versions: 2021-10-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native policyinsights [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str remediation_name: The name of the remediation.
    :param builtins.int top: Maximum number of records to return.
    """
    __args__ = dict()
    __args__['remediationName'] = remediation_name
    __args__['top'] = top
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:policyinsights:listRemediationDeploymentsAtSubscription', __args__, opts=opts, typ=ListRemediationDeploymentsAtSubscriptionResult).value

    return AwaitableListRemediationDeploymentsAtSubscriptionResult(
        next_link=pulumi.get(__ret__, 'next_link'),
        value=pulumi.get(__ret__, 'value'))
def list_remediation_deployments_at_subscription_output(remediation_name: Optional[pulumi.Input[builtins.str]] = None,
                                                        top: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                                                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListRemediationDeploymentsAtSubscriptionResult]:
    """
    Gets all deployments for a remediation at subscription scope.

    Uses Azure REST API version 2024-10-01.

    Other available API versions: 2021-10-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native policyinsights [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str remediation_name: The name of the remediation.
    :param builtins.int top: Maximum number of records to return.
    """
    __args__ = dict()
    __args__['remediationName'] = remediation_name
    __args__['top'] = top
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:policyinsights:listRemediationDeploymentsAtSubscription', __args__, opts=opts, typ=ListRemediationDeploymentsAtSubscriptionResult)
    return __ret__.apply(lambda __response__: ListRemediationDeploymentsAtSubscriptionResult(
        next_link=pulumi.get(__response__, 'next_link'),
        value=pulumi.get(__response__, 'value')))
