# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'ConfigurationPropertiesResponse',
    'ConsolePropertiesResponse',
    'DashboardLensResponse',
    'DashboardPartMetadataResponse',
    'DashboardPartsPositionResponse',
    'DashboardPartsResponse',
    'DashboardPropertiesWithProvisioningStateResponse',
    'StorageProfileResponse',
    'SystemDataResponse',
    'TerminalSettingsResponse',
    'UserPropertiesResponse',
    'ViolationResponse',
]

@pulumi.output_type
class ConfigurationPropertiesResponse(dict):
    """
    Tenant Configuration Properties with Provisioning state
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "provisioningState":
            suggest = "provisioning_state"
        elif key == "enforcePrivateMarkdownStorage":
            suggest = "enforce_private_markdown_storage"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConfigurationPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConfigurationPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConfigurationPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 provisioning_state: builtins.str,
                 enforce_private_markdown_storage: Optional[builtins.bool] = None):
        """
        Tenant Configuration Properties with Provisioning state
        :param builtins.str provisioning_state: The status of the last operation.
        :param builtins.bool enforce_private_markdown_storage: When flag is set to true Markdown tile will require external storage configuration (URI). The inline content configuration will be prohibited.
        """
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if enforce_private_markdown_storage is not None:
            pulumi.set(__self__, "enforce_private_markdown_storage", enforce_private_markdown_storage)

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="enforcePrivateMarkdownStorage")
    def enforce_private_markdown_storage(self) -> Optional[builtins.bool]:
        """
        When flag is set to true Markdown tile will require external storage configuration (URI). The inline content configuration will be prohibited.
        """
        return pulumi.get(self, "enforce_private_markdown_storage")


@pulumi.output_type
class ConsolePropertiesResponse(dict):
    """
    Cloud shell console properties.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "osType":
            suggest = "os_type"
        elif key == "provisioningState":
            suggest = "provisioning_state"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ConsolePropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ConsolePropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ConsolePropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 os_type: builtins.str,
                 provisioning_state: builtins.str,
                 uri: builtins.str):
        """
        Cloud shell console properties.
        :param builtins.str os_type: The operating system type of the cloud shell.
        :param builtins.str provisioning_state: Provisioning state of the console.
        :param builtins.str uri: Uri of the console.
        """
        pulumi.set(__self__, "os_type", os_type)
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter(name="osType")
    def os_type(self) -> builtins.str:
        """
        The operating system type of the cloud shell.
        """
        return pulumi.get(self, "os_type")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        Provisioning state of the console.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter
    def uri(self) -> builtins.str:
        """
        Uri of the console.
        """
        return pulumi.get(self, "uri")


@pulumi.output_type
class DashboardLensResponse(dict):
    """
    A dashboard lens.
    """
    def __init__(__self__, *,
                 order: builtins.int,
                 parts: Sequence['outputs.DashboardPartsResponse'],
                 metadata: Optional[Any] = None):
        """
        A dashboard lens.
        :param builtins.int order: The lens order.
        :param Sequence['DashboardPartsResponse'] parts: The dashboard parts.
        :param Any metadata: The dashboard len's metadata.
        """
        pulumi.set(__self__, "order", order)
        pulumi.set(__self__, "parts", parts)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)

    @property
    @pulumi.getter
    def order(self) -> builtins.int:
        """
        The lens order.
        """
        return pulumi.get(self, "order")

    @property
    @pulumi.getter
    def parts(self) -> Sequence['outputs.DashboardPartsResponse']:
        """
        The dashboard parts.
        """
        return pulumi.get(self, "parts")

    @property
    @pulumi.getter
    def metadata(self) -> Optional[Any]:
        """
        The dashboard len's metadata.
        """
        return pulumi.get(self, "metadata")


@pulumi.output_type
class DashboardPartMetadataResponse(dict):
    """
    A dashboard part metadata.
    """
    def __init__(__self__, *,
                 type: builtins.str,
                 inputs: Optional[Sequence[Any]] = None,
                 settings: Optional[Mapping[str, Any]] = None):
        """
        A dashboard part metadata.
        :param builtins.str type: The type of dashboard part.
        :param Sequence[Any] inputs: Inputs to dashboard part.
        :param Mapping[str, Any] settings: Settings of dashboard part.
        """
        pulumi.set(__self__, "type", type)
        if inputs is not None:
            pulumi.set(__self__, "inputs", inputs)
        if settings is not None:
            pulumi.set(__self__, "settings", settings)

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of dashboard part.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def inputs(self) -> Optional[Sequence[Any]]:
        """
        Inputs to dashboard part.
        """
        return pulumi.get(self, "inputs")

    @property
    @pulumi.getter
    def settings(self) -> Optional[Mapping[str, Any]]:
        """
        Settings of dashboard part.
        """
        return pulumi.get(self, "settings")


@pulumi.output_type
class DashboardPartsPositionResponse(dict):
    """
    The dashboard's part position.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "colSpan":
            suggest = "col_span"
        elif key == "rowSpan":
            suggest = "row_span"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DashboardPartsPositionResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DashboardPartsPositionResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DashboardPartsPositionResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 col_span: builtins.int,
                 row_span: builtins.int,
                 x: builtins.int,
                 y: builtins.int,
                 metadata: Optional[Any] = None):
        """
        The dashboard's part position.
        :param builtins.int col_span: The dashboard's part column span.
        :param builtins.int row_span: The dashboard's part row span.
        :param builtins.int x: The dashboard's part x coordinate.
        :param builtins.int y: The dashboard's part y coordinate.
        :param Any metadata: The dashboard part's metadata.
        """
        pulumi.set(__self__, "col_span", col_span)
        pulumi.set(__self__, "row_span", row_span)
        pulumi.set(__self__, "x", x)
        pulumi.set(__self__, "y", y)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)

    @property
    @pulumi.getter(name="colSpan")
    def col_span(self) -> builtins.int:
        """
        The dashboard's part column span.
        """
        return pulumi.get(self, "col_span")

    @property
    @pulumi.getter(name="rowSpan")
    def row_span(self) -> builtins.int:
        """
        The dashboard's part row span.
        """
        return pulumi.get(self, "row_span")

    @property
    @pulumi.getter
    def x(self) -> builtins.int:
        """
        The dashboard's part x coordinate.
        """
        return pulumi.get(self, "x")

    @property
    @pulumi.getter
    def y(self) -> builtins.int:
        """
        The dashboard's part y coordinate.
        """
        return pulumi.get(self, "y")

    @property
    @pulumi.getter
    def metadata(self) -> Optional[Any]:
        """
        The dashboard part's metadata.
        """
        return pulumi.get(self, "metadata")


@pulumi.output_type
class DashboardPartsResponse(dict):
    """
    A dashboard part.
    """
    def __init__(__self__, *,
                 position: 'outputs.DashboardPartsPositionResponse',
                 metadata: Optional['outputs.DashboardPartMetadataResponse'] = None):
        """
        A dashboard part.
        :param 'DashboardPartsPositionResponse' position: The dashboard's part position.
        :param 'DashboardPartMetadataResponse' metadata: The dashboard's part metadata.
        """
        pulumi.set(__self__, "position", position)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)

    @property
    @pulumi.getter
    def position(self) -> 'outputs.DashboardPartsPositionResponse':
        """
        The dashboard's part position.
        """
        return pulumi.get(self, "position")

    @property
    @pulumi.getter
    def metadata(self) -> Optional['outputs.DashboardPartMetadataResponse']:
        """
        The dashboard's part metadata.
        """
        return pulumi.get(self, "metadata")


@pulumi.output_type
class DashboardPropertiesWithProvisioningStateResponse(dict):
    """
    Dashboard Properties with Provisioning state
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "provisioningState":
            suggest = "provisioning_state"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DashboardPropertiesWithProvisioningStateResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DashboardPropertiesWithProvisioningStateResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DashboardPropertiesWithProvisioningStateResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 provisioning_state: builtins.str,
                 lenses: Optional[Sequence['outputs.DashboardLensResponse']] = None,
                 metadata: Optional[Any] = None):
        """
        Dashboard Properties with Provisioning state
        :param builtins.str provisioning_state: The status of the last operation.
        :param Sequence['DashboardLensResponse'] lenses: The dashboard lenses.
        :param Any metadata: The dashboard metadata.
        """
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if lenses is not None:
            pulumi.set(__self__, "lenses", lenses)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter
    def lenses(self) -> Optional[Sequence['outputs.DashboardLensResponse']]:
        """
        The dashboard lenses.
        """
        return pulumi.get(self, "lenses")

    @property
    @pulumi.getter
    def metadata(self) -> Optional[Any]:
        """
        The dashboard metadata.
        """
        return pulumi.get(self, "metadata")


@pulumi.output_type
class StorageProfileResponse(dict):
    """
    The storage profile of the user settings.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "diskSizeInGB":
            suggest = "disk_size_in_gb"
        elif key == "fileShareName":
            suggest = "file_share_name"
        elif key == "storageAccountResourceId":
            suggest = "storage_account_resource_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in StorageProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        StorageProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        StorageProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 disk_size_in_gb: Optional[builtins.int] = None,
                 file_share_name: Optional[builtins.str] = None,
                 storage_account_resource_id: Optional[builtins.str] = None):
        """
        The storage profile of the user settings.
        :param builtins.int disk_size_in_gb: Size of file share
        :param builtins.str file_share_name: Name of the mounted file share. 63 characters or less, lowercase alphabet, numbers, and -
        :param builtins.str storage_account_resource_id: Full resource ID of storage account.
        """
        if disk_size_in_gb is not None:
            pulumi.set(__self__, "disk_size_in_gb", disk_size_in_gb)
        if file_share_name is not None:
            pulumi.set(__self__, "file_share_name", file_share_name)
        if storage_account_resource_id is not None:
            pulumi.set(__self__, "storage_account_resource_id", storage_account_resource_id)

    @property
    @pulumi.getter(name="diskSizeInGB")
    def disk_size_in_gb(self) -> Optional[builtins.int]:
        """
        Size of file share
        """
        return pulumi.get(self, "disk_size_in_gb")

    @property
    @pulumi.getter(name="fileShareName")
    def file_share_name(self) -> Optional[builtins.str]:
        """
        Name of the mounted file share. 63 characters or less, lowercase alphabet, numbers, and -
        """
        return pulumi.get(self, "file_share_name")

    @property
    @pulumi.getter(name="storageAccountResourceId")
    def storage_account_resource_id(self) -> Optional[builtins.str]:
        """
        Full resource ID of storage account.
        """
        return pulumi.get(self, "storage_account_resource_id")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[builtins.str] = None,
                 created_by: Optional[builtins.str] = None,
                 created_by_type: Optional[builtins.str] = None,
                 last_modified_at: Optional[builtins.str] = None,
                 last_modified_by: Optional[builtins.str] = None,
                 last_modified_by_type: Optional[builtins.str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param builtins.str created_at: The timestamp of resource creation (UTC).
        :param builtins.str created_by: The identity that created the resource.
        :param builtins.str created_by_type: The type of identity that created the resource.
        :param builtins.str last_modified_at: The timestamp of resource last modification (UTC)
        :param builtins.str last_modified_by: The identity that last modified the resource.
        :param builtins.str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[builtins.str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[builtins.str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[builtins.str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[builtins.str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[builtins.str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[builtins.str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


@pulumi.output_type
class TerminalSettingsResponse(dict):
    """
    Settings for terminal appearance.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "fontSize":
            suggest = "font_size"
        elif key == "fontStyle":
            suggest = "font_style"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TerminalSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TerminalSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TerminalSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 font_size: Optional[builtins.str] = None,
                 font_style: Optional[builtins.str] = None):
        """
        Settings for terminal appearance.
        :param builtins.str font_size: Size of terminal font.
        :param builtins.str font_style: Style of terminal font.
        """
        if font_size is not None:
            pulumi.set(__self__, "font_size", font_size)
        if font_style is not None:
            pulumi.set(__self__, "font_style", font_style)

    @property
    @pulumi.getter(name="fontSize")
    def font_size(self) -> Optional[builtins.str]:
        """
        Size of terminal font.
        """
        return pulumi.get(self, "font_size")

    @property
    @pulumi.getter(name="fontStyle")
    def font_style(self) -> Optional[builtins.str]:
        """
        Style of terminal font.
        """
        return pulumi.get(self, "font_style")


@pulumi.output_type
class UserPropertiesResponse(dict):
    """
    The cloud shell user settings properties.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "preferredLocation":
            suggest = "preferred_location"
        elif key == "preferredOsType":
            suggest = "preferred_os_type"
        elif key == "preferredShellType":
            suggest = "preferred_shell_type"
        elif key == "storageProfile":
            suggest = "storage_profile"
        elif key == "terminalSettings":
            suggest = "terminal_settings"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in UserPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        UserPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        UserPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 preferred_location: builtins.str,
                 preferred_os_type: builtins.str,
                 preferred_shell_type: builtins.str,
                 storage_profile: 'outputs.StorageProfileResponse',
                 terminal_settings: 'outputs.TerminalSettingsResponse'):
        """
        The cloud shell user settings properties.
        :param builtins.str preferred_location: The preferred location of the cloud shell.
        :param builtins.str preferred_os_type: The operating system type of the cloud shell. Deprecated, use preferredShellType.
        :param builtins.str preferred_shell_type: The shell type of the cloud shell.
        :param 'StorageProfileResponse' storage_profile: The storage profile of the user settings.
        :param 'TerminalSettingsResponse' terminal_settings: Settings for terminal appearance.
        """
        pulumi.set(__self__, "preferred_location", preferred_location)
        pulumi.set(__self__, "preferred_os_type", preferred_os_type)
        pulumi.set(__self__, "preferred_shell_type", preferred_shell_type)
        pulumi.set(__self__, "storage_profile", storage_profile)
        pulumi.set(__self__, "terminal_settings", terminal_settings)

    @property
    @pulumi.getter(name="preferredLocation")
    def preferred_location(self) -> builtins.str:
        """
        The preferred location of the cloud shell.
        """
        return pulumi.get(self, "preferred_location")

    @property
    @pulumi.getter(name="preferredOsType")
    def preferred_os_type(self) -> builtins.str:
        """
        The operating system type of the cloud shell. Deprecated, use preferredShellType.
        """
        return pulumi.get(self, "preferred_os_type")

    @property
    @pulumi.getter(name="preferredShellType")
    def preferred_shell_type(self) -> builtins.str:
        """
        The shell type of the cloud shell.
        """
        return pulumi.get(self, "preferred_shell_type")

    @property
    @pulumi.getter(name="storageProfile")
    def storage_profile(self) -> 'outputs.StorageProfileResponse':
        """
        The storage profile of the user settings.
        """
        return pulumi.get(self, "storage_profile")

    @property
    @pulumi.getter(name="terminalSettings")
    def terminal_settings(self) -> 'outputs.TerminalSettingsResponse':
        """
        Settings for terminal appearance.
        """
        return pulumi.get(self, "terminal_settings")


@pulumi.output_type
class ViolationResponse(dict):
    """
    Violation information.
    """
    def __init__(__self__, *,
                 error_message: builtins.str,
                 id: builtins.str,
                 user_id: builtins.str):
        """
        Violation information.
        :param builtins.str error_message: Error message.
        :param builtins.str id: Id of the item that violates tenant configuration.
        :param builtins.str user_id: Id of the user who owns violated item.
        """
        pulumi.set(__self__, "error_message", error_message)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter(name="errorMessage")
    def error_message(self) -> builtins.str:
        """
        Error message.
        """
        return pulumi.get(self, "error_message")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Id of the item that violates tenant configuration.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> builtins.str:
        """
        Id of the user who owns violated item.
        """
        return pulumi.get(self, "user_id")


