# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListWorkspaceCollectionAccessKeysResult',
    'AwaitableListWorkspaceCollectionAccessKeysResult',
    'list_workspace_collection_access_keys',
    'list_workspace_collection_access_keys_output',
]

@pulumi.output_type
class ListWorkspaceCollectionAccessKeysResult:
    def __init__(__self__, key1=None, key2=None):
        if key1 and not isinstance(key1, str):
            raise TypeError("Expected argument 'key1' to be a str")
        pulumi.set(__self__, "key1", key1)
        if key2 and not isinstance(key2, str):
            raise TypeError("Expected argument 'key2' to be a str")
        pulumi.set(__self__, "key2", key2)

    @property
    @pulumi.getter
    def key1(self) -> Optional[builtins.str]:
        """
        Access key 1
        """
        return pulumi.get(self, "key1")

    @property
    @pulumi.getter
    def key2(self) -> Optional[builtins.str]:
        """
        Access key 2
        """
        return pulumi.get(self, "key2")


class AwaitableListWorkspaceCollectionAccessKeysResult(ListWorkspaceCollectionAccessKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListWorkspaceCollectionAccessKeysResult(
            key1=self.key1,
            key2=self.key2)


def list_workspace_collection_access_keys(resource_group_name: Optional[builtins.str] = None,
                                          workspace_collection_name: Optional[builtins.str] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListWorkspaceCollectionAccessKeysResult:
    """
    Retrieves the primary and secondary access keys for the specified Power BI Workspace Collection.

    Uses Azure REST API version 2016-01-29.


    :param builtins.str resource_group_name: Azure resource group
    :param builtins.str workspace_collection_name: Power BI Embedded Workspace Collection name
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceCollectionName'] = workspace_collection_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:powerbi:listWorkspaceCollectionAccessKeys', __args__, opts=opts, typ=ListWorkspaceCollectionAccessKeysResult).value

    return AwaitableListWorkspaceCollectionAccessKeysResult(
        key1=pulumi.get(__ret__, 'key1'),
        key2=pulumi.get(__ret__, 'key2'))
def list_workspace_collection_access_keys_output(resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                 workspace_collection_name: Optional[pulumi.Input[builtins.str]] = None,
                                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListWorkspaceCollectionAccessKeysResult]:
    """
    Retrieves the primary and secondary access keys for the specified Power BI Workspace Collection.

    Uses Azure REST API version 2016-01-29.


    :param builtins.str resource_group_name: Azure resource group
    :param builtins.str workspace_collection_name: Power BI Embedded Workspace Collection name
    """
    __args__ = dict()
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceCollectionName'] = workspace_collection_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:powerbi:listWorkspaceCollectionAccessKeys', __args__, opts=opts, typ=ListWorkspaceCollectionAccessKeysResult)
    return __ret__.apply(lambda __response__: ListWorkspaceCollectionAccessKeysResult(
        key1=pulumi.get(__response__, 'key1'),
        key2=pulumi.get(__response__, 'key2')))
