# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AcquireStorageAccountLock',
    'AgentAutoUpdateStatus',
    'AlertsState',
    'AutoProtectionOfDataDisk',
    'AutomationAccountAuthenticationType',
    'BackupItemType',
    'BackupManagementType',
    'CreateMode',
    'CrossRegionRestore',
    'CrossSubscriptionRestoreState',
    'DayOfWeek',
    'DiskAccountType',
    'EnhancedSecurityState',
    'ExtendedLocationType',
    'FailoverDeploymentModel',
    'HealthErrorCustomerResolvability',
    'IAASVMPolicyType',
    'IaasVMSnapshotConsistencyType',
    'ImmutabilityState',
    'InfrastructureEncryptionState',
    'LastBackupStatus',
    'LicenseType',
    'LinuxLicenseType',
    'MonthOfYear',
    'MultiVmGroupCreateOption',
    'OperationType',
    'PolicyType',
    'PossibleOperationsDirections',
    'PrivateEndpointConnectionStatus',
    'ProtectableContainerType',
    'ProtectedItemHealthStatus',
    'ProtectedItemState',
    'ProtectionIntentItemType',
    'ProtectionState',
    'ProtectionStatus',
    'ProvisioningState',
    'PublicNetworkAccess',
    'RecoveryPlanActionLocation',
    'RecoveryPlanGroupType',
    'ReplicationProtectedItemOperation',
    'ResourceHealthStatus',
    'ResourceIdentityType',
    'RetentionDurationType',
    'RetentionScheduleFormat',
    'ScheduleRunType',
    'SecurityConfiguration',
    'SecurityType',
    'SetMultiVmSyncStatus',
    'SkuName',
    'SoftDeleteState',
    'SqlServerLicenseType',
    'StandardTierStorageRedundancy',
    'TieringMode',
    'VaultSubResourceType',
    'WeekOfMonth',
    'WorkloadItemType',
    'WorkloadType',
]


@pulumi.type_token("azure-native:recoveryservices:AcquireStorageAccountLock")
class AcquireStorageAccountLock(builtins.str, Enum):
    """
    Whether storage account lock is to be acquired for this container or not.
    """
    ACQUIRE = "Acquire"
    NOT_ACQUIRE = "NotAcquire"


@pulumi.type_token("azure-native:recoveryservices:AgentAutoUpdateStatus")
class AgentAutoUpdateStatus(builtins.str, Enum):
    """
    A value indicating whether the auto update is enabled.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:recoveryservices:AlertsState")
class AlertsState(builtins.str, Enum):
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:recoveryservices:AutoProtectionOfDataDisk")
class AutoProtectionOfDataDisk(builtins.str, Enum):
    """
    A value indicating whether the disk auto protection is enabled.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:recoveryservices:AutomationAccountAuthenticationType")
class AutomationAccountAuthenticationType(builtins.str, Enum):
    """
    A value indicating the type authentication to use for automation Account.
    """
    RUN_AS_ACCOUNT = "RunAsAccount"
    SYSTEM_ASSIGNED_IDENTITY = "SystemAssignedIdentity"


@pulumi.type_token("azure-native:recoveryservices:BackupItemType")
class BackupItemType(builtins.str, Enum):
    """
    Type of backup items associated with this container.
    """
    INVALID = "Invalid"
    VM = "VM"
    FILE_FOLDER = "FileFolder"
    AZURE_SQL_DB = "AzureSqlDb"
    SQLDB = "SQLDB"
    EXCHANGE = "Exchange"
    SHAREPOINT = "Sharepoint"
    V_MWARE_VM = "VMwareVM"
    SYSTEM_STATE = "SystemState"
    CLIENT = "Client"
    GENERIC_DATA_SOURCE = "GenericDataSource"
    SQL_DATA_BASE = "SQLDataBase"
    AZURE_FILE_SHARE = "AzureFileShare"
    SAP_HANA_DATABASE = "SAPHanaDatabase"
    SAPASE_DATABASE = "SAPAseDatabase"
    SAP_HANA_DB_INSTANCE = "SAPHanaDBInstance"


@pulumi.type_token("azure-native:recoveryservices:BackupManagementType")
class BackupManagementType(builtins.str, Enum):
    """
    Type of backup management for the backed up item.
    """
    INVALID = "Invalid"
    AZURE_IAAS_VM = "AzureIaasVM"
    MAB = "MAB"
    DPM = "DPM"
    AZURE_BACKUP_SERVER = "AzureBackupServer"
    AZURE_SQL = "AzureSql"
    AZURE_STORAGE = "AzureStorage"
    AZURE_WORKLOAD = "AzureWorkload"
    DEFAULT_BACKUP = "DefaultBackup"


@pulumi.type_token("azure-native:recoveryservices:CreateMode")
class CreateMode(builtins.str, Enum):
    """
    Create mode to indicate recovery of existing soft deleted data source or creation of new data source.
    """
    INVALID = "Invalid"
    DEFAULT = "Default"
    RECOVER = "Recover"


@pulumi.type_token("azure-native:recoveryservices:CrossRegionRestore")
class CrossRegionRestore(builtins.str, Enum):
    """
    Flag to show if Cross Region Restore is enabled on the Vault or not
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:recoveryservices:CrossSubscriptionRestoreState")
class CrossSubscriptionRestoreState(builtins.str, Enum):
    ENABLED = "Enabled"
    DISABLED = "Disabled"
    PERMANENTLY_DISABLED = "PermanentlyDisabled"


@pulumi.type_token("azure-native:recoveryservices:DayOfWeek")
class DayOfWeek(builtins.str, Enum):
    SUNDAY = "Sunday"
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"


@pulumi.type_token("azure-native:recoveryservices:DiskAccountType")
class DiskAccountType(builtins.str, Enum):
    """
    The disk type.
    """
    STANDARD_LRS = "Standard_LRS"
    PREMIUM_LRS = "Premium_LRS"
    STANDARD_SS_D_LRS = "StandardSSD_LRS"
    PREMIUM_V2_LRS = "PremiumV2_LRS"
    ULTRA_SS_D_LRS = "UltraSSD_LRS"
    STANDARD_SS_D_ZRS = "StandardSSD_ZRS"
    PREMIUM_ZRS = "Premium_ZRS"


@pulumi.type_token("azure-native:recoveryservices:EnhancedSecurityState")
class EnhancedSecurityState(builtins.str, Enum):
    INVALID = "Invalid"
    ENABLED = "Enabled"
    DISABLED = "Disabled"
    ALWAYS_ON = "AlwaysON"


@pulumi.type_token("azure-native:recoveryservices:ExtendedLocationType")
class ExtendedLocationType(builtins.str, Enum):
    """
    The extended location type.
    """
    EDGE_ZONE = "EdgeZone"


@pulumi.type_token("azure-native:recoveryservices:FailoverDeploymentModel")
class FailoverDeploymentModel(builtins.str, Enum):
    """
    The failover deployment model.
    """
    NOT_APPLICABLE = "NotApplicable"
    CLASSIC = "Classic"
    RESOURCE_MANAGER = "ResourceManager"


@pulumi.type_token("azure-native:recoveryservices:HealthErrorCustomerResolvability")
class HealthErrorCustomerResolvability(builtins.str, Enum):
    """
    Value indicating whether the health error is customer resolvable.
    """
    ALLOWED = "Allowed"
    NOT_ALLOWED = "NotAllowed"


@pulumi.type_token("azure-native:recoveryservices:IAASVMPolicyType")
class IAASVMPolicyType(builtins.str, Enum):
    INVALID = "Invalid"
    V1 = "V1"
    V2 = "V2"


@pulumi.type_token("azure-native:recoveryservices:IaasVMSnapshotConsistencyType")
class IaasVMSnapshotConsistencyType(builtins.str, Enum):
    ONLY_CRASH_CONSISTENT = "OnlyCrashConsistent"


@pulumi.type_token("azure-native:recoveryservices:ImmutabilityState")
class ImmutabilityState(builtins.str, Enum):
    DISABLED = "Disabled"
    UNLOCKED = "Unlocked"
    LOCKED = "Locked"


@pulumi.type_token("azure-native:recoveryservices:InfrastructureEncryptionState")
class InfrastructureEncryptionState(builtins.str, Enum):
    """
    Enabling/Disabling the Double Encryption state
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:recoveryservices:LastBackupStatus")
class LastBackupStatus(builtins.str, Enum):
    """
    Last backup operation status. Possible values: Healthy, Unhealthy.
    """
    INVALID = "Invalid"
    HEALTHY = "Healthy"
    UNHEALTHY = "Unhealthy"
    IR_PENDING = "IRPending"


@pulumi.type_token("azure-native:recoveryservices:LicenseType")
class LicenseType(builtins.str, Enum):
    """
    The license type.
    """
    NOT_SPECIFIED = "NotSpecified"
    NO_LICENSE_TYPE = "NoLicenseType"
    WINDOWS_SERVER = "WindowsServer"


@pulumi.type_token("azure-native:recoveryservices:LinuxLicenseType")
class LinuxLicenseType(builtins.str, Enum):
    """
    The license type for Linux VM's.
    """
    NOT_SPECIFIED = "NotSpecified"
    NO_LICENSE_TYPE = "NoLicenseType"
    LINUX_SERVER = "LinuxServer"


@pulumi.type_token("azure-native:recoveryservices:MonthOfYear")
class MonthOfYear(builtins.str, Enum):
    INVALID = "Invalid"
    JANUARY = "January"
    FEBRUARY = "February"
    MARCH = "March"
    APRIL = "April"
    MAY = "May"
    JUNE = "June"
    JULY = "July"
    AUGUST = "August"
    SEPTEMBER = "September"
    OCTOBER = "October"
    NOVEMBER = "November"
    DECEMBER = "December"


@pulumi.type_token("azure-native:recoveryservices:MultiVmGroupCreateOption")
class MultiVmGroupCreateOption(builtins.str, Enum):
    """
    Whether Multi VM group is auto created or specified by user.
    """
    AUTO_CREATED = "AutoCreated"
    USER_SPECIFIED = "UserSpecified"


@pulumi.type_token("azure-native:recoveryservices:OperationType")
class OperationType(builtins.str, Enum):
    """
    Re-Do Operation
    """
    INVALID = "Invalid"
    REGISTER = "Register"
    REREGISTER = "Reregister"
    REHYDRATE = "Rehydrate"


@pulumi.type_token("azure-native:recoveryservices:PolicyType")
class PolicyType(builtins.str, Enum):
    """
    Type of backup policy type
    """
    INVALID = "Invalid"
    FULL = "Full"
    DIFFERENTIAL = "Differential"
    LOG = "Log"
    COPY_ONLY_FULL = "CopyOnlyFull"
    INCREMENTAL = "Incremental"
    SNAPSHOT_FULL = "SnapshotFull"
    SNAPSHOT_COPY_ONLY_FULL = "SnapshotCopyOnlyFull"


@pulumi.type_token("azure-native:recoveryservices:PossibleOperationsDirections")
class PossibleOperationsDirections(builtins.str, Enum):
    PRIMARY_TO_RECOVERY = "PrimaryToRecovery"
    RECOVERY_TO_PRIMARY = "RecoveryToPrimary"


@pulumi.type_token("azure-native:recoveryservices:PrivateEndpointConnectionStatus")
class PrivateEndpointConnectionStatus(builtins.str, Enum):
    """
    Gets or sets the status
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"
    DISCONNECTED = "Disconnected"


@pulumi.type_token("azure-native:recoveryservices:ProtectableContainerType")
class ProtectableContainerType(builtins.str, Enum):
    """
    Type of the container. The value of this property for: 1. Compute Azure VM is Microsoft.Compute/virtualMachines 2.
    Classic Compute Azure VM is Microsoft.ClassicCompute/virtualMachines 3. Windows machines (like MAB, DPM etc) is
    Windows 4. Azure SQL instance is AzureSqlContainer. 5. Storage containers is StorageContainer. 6. Azure workload
    Backup is VMAppContainer
    """
    INVALID = "Invalid"
    UNKNOWN = "Unknown"
    IAAS_VM_CONTAINER = "IaasVMContainer"
    IAAS_VM_SERVICE_CONTAINER = "IaasVMServiceContainer"
    DPM_CONTAINER = "DPMContainer"
    AZURE_BACKUP_SERVER_CONTAINER = "AzureBackupServerContainer"
    MAB_CONTAINER = "MABContainer"
    CLUSTER = "Cluster"
    AZURE_SQL_CONTAINER = "AzureSqlContainer"
    WINDOWS = "Windows"
    V_CENTER = "VCenter"
    VM_APP_CONTAINER = "VMAppContainer"
    SQLAG_WORK_LOAD_CONTAINER = "SQLAGWorkLoadContainer"
    STORAGE_CONTAINER = "StorageContainer"
    GENERIC_CONTAINER = "GenericContainer"
    MICROSOFT_CLASSIC_COMPUTE_VIRTUAL_MACHINES = "Microsoft.ClassicCompute/virtualMachines"
    MICROSOFT_COMPUTE_VIRTUAL_MACHINES = "Microsoft.Compute/virtualMachines"
    AZURE_WORKLOAD_CONTAINER = "AzureWorkloadContainer"


@pulumi.type_token("azure-native:recoveryservices:ProtectedItemHealthStatus")
class ProtectedItemHealthStatus(builtins.str, Enum):
    """
    Health status of the backup item, evaluated based on last heartbeat received
    """
    INVALID = "Invalid"
    HEALTHY = "Healthy"
    UNHEALTHY = "Unhealthy"
    NOT_REACHABLE = "NotReachable"
    IR_PENDING = "IRPending"


@pulumi.type_token("azure-native:recoveryservices:ProtectedItemState")
class ProtectedItemState(builtins.str, Enum):
    """
    Protection state of the backup engine
    """
    INVALID = "Invalid"
    IR_PENDING = "IRPending"
    PROTECTED = "Protected"
    PROTECTION_ERROR = "ProtectionError"
    PROTECTION_STOPPED = "ProtectionStopped"
    PROTECTION_PAUSED = "ProtectionPaused"
    BACKUPS_SUSPENDED = "BackupsSuspended"


@pulumi.type_token("azure-native:recoveryservices:ProtectionIntentItemType")
class ProtectionIntentItemType(builtins.str, Enum):
    """
    backup protectionIntent type.
    """
    INVALID = "Invalid"
    AZURE_RESOURCE_ITEM = "AzureResourceItem"
    RECOVERY_SERVICE_VAULT_ITEM = "RecoveryServiceVaultItem"
    AZURE_WORKLOAD_CONTAINER_AUTO_PROTECTION_INTENT = "AzureWorkloadContainerAutoProtectionIntent"
    AZURE_WORKLOAD_AUTO_PROTECTION_INTENT = "AzureWorkloadAutoProtectionIntent"
    AZURE_WORKLOAD_SQL_AUTO_PROTECTION_INTENT = "AzureWorkloadSQLAutoProtectionIntent"


@pulumi.type_token("azure-native:recoveryservices:ProtectionState")
class ProtectionState(builtins.str, Enum):
    """
    Backup state of this backup item.
    """
    INVALID = "Invalid"
    IR_PENDING = "IRPending"
    PROTECTED = "Protected"
    PROTECTION_ERROR = "ProtectionError"
    PROTECTION_STOPPED = "ProtectionStopped"
    PROTECTION_PAUSED = "ProtectionPaused"
    BACKUPS_SUSPENDED = "BackupsSuspended"


@pulumi.type_token("azure-native:recoveryservices:ProtectionStatus")
class ProtectionStatus(builtins.str, Enum):
    """
    Backup state of this backup item.
    """
    INVALID = "Invalid"
    NOT_PROTECTED = "NotProtected"
    PROTECTING = "Protecting"
    PROTECTED = "Protected"
    PROTECTION_FAILED = "ProtectionFailed"


@pulumi.type_token("azure-native:recoveryservices:ProvisioningState")
class ProvisioningState(builtins.str, Enum):
    """
    Gets or sets provisioning state of the private endpoint connection
    """
    SUCCEEDED = "Succeeded"
    DELETING = "Deleting"
    FAILED = "Failed"
    PENDING = "Pending"


@pulumi.type_token("azure-native:recoveryservices:PublicNetworkAccess")
class PublicNetworkAccess(builtins.str, Enum):
    """
    property to enable or disable resource provider inbound network traffic from public clients
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:recoveryservices:RecoveryPlanActionLocation")
class RecoveryPlanActionLocation(builtins.str, Enum):
    """
    The fabric location.
    """
    PRIMARY = "Primary"
    RECOVERY = "Recovery"


@pulumi.type_token("azure-native:recoveryservices:RecoveryPlanGroupType")
class RecoveryPlanGroupType(builtins.str, Enum):
    """
    The group type.
    """
    SHUTDOWN = "Shutdown"
    BOOT = "Boot"
    FAILOVER = "Failover"


@pulumi.type_token("azure-native:recoveryservices:ReplicationProtectedItemOperation")
class ReplicationProtectedItemOperation(builtins.str, Enum):
    REVERSE_REPLICATE = "ReverseReplicate"
    COMMIT = "Commit"
    PLANNED_FAILOVER = "PlannedFailover"
    UNPLANNED_FAILOVER = "UnplannedFailover"
    DISABLE_PROTECTION = "DisableProtection"
    TEST_FAILOVER = "TestFailover"
    TEST_FAILOVER_CLEANUP = "TestFailoverCleanup"
    FAILBACK = "Failback"
    FINALIZE_FAILBACK = "FinalizeFailback"
    CANCEL_FAILOVER = "CancelFailover"
    CHANGE_PIT = "ChangePit"
    REPAIR_REPLICATION = "RepairReplication"
    SWITCH_PROTECTION = "SwitchProtection"
    COMPLETE_MIGRATION = "CompleteMigration"


@pulumi.type_token("azure-native:recoveryservices:ResourceHealthStatus")
class ResourceHealthStatus(builtins.str, Enum):
    """
    Resource Health Status
    """
    HEALTHY = "Healthy"
    TRANSIENT_DEGRADED = "TransientDegraded"
    PERSISTENT_DEGRADED = "PersistentDegraded"
    TRANSIENT_UNHEALTHY = "TransientUnhealthy"
    PERSISTENT_UNHEALTHY = "PersistentUnhealthy"
    INVALID = "Invalid"


@pulumi.type_token("azure-native:recoveryservices:ResourceIdentityType")
class ResourceIdentityType(builtins.str, Enum):
    """
    The type of managed identity used. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user-assigned identities. The type 'None' will remove any identities.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    NONE = "None"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


@pulumi.type_token("azure-native:recoveryservices:RetentionDurationType")
class RetentionDurationType(builtins.str, Enum):
    """
    Retention duration type: days/weeks/months/years
    Used only if TieringMode is set to TierAfter
    """
    INVALID = "Invalid"
    DAYS = "Days"
    WEEKS = "Weeks"
    MONTHS = "Months"
    YEARS = "Years"


@pulumi.type_token("azure-native:recoveryservices:RetentionScheduleFormat")
class RetentionScheduleFormat(builtins.str, Enum):
    """
    Retention schedule format for yearly retention policy.
    """
    INVALID = "Invalid"
    DAILY = "Daily"
    WEEKLY = "Weekly"


@pulumi.type_token("azure-native:recoveryservices:ScheduleRunType")
class ScheduleRunType(builtins.str, Enum):
    """
    Frequency of the schedule operation of this policy.
    """
    INVALID = "Invalid"
    DAILY = "Daily"
    WEEKLY = "Weekly"
    HOURLY = "Hourly"


@pulumi.type_token("azure-native:recoveryservices:SecurityConfiguration")
class SecurityConfiguration(builtins.str, Enum):
    """
    A value indicating whether trusted platform module to be enabled.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:recoveryservices:SecurityType")
class SecurityType(builtins.str, Enum):
    """
    The target VM security type.
    """
    NONE = "None"
    TRUSTED_LAUNCH = "TrustedLaunch"
    CONFIDENTIAL_VM = "ConfidentialVM"


@pulumi.type_token("azure-native:recoveryservices:SetMultiVmSyncStatus")
class SetMultiVmSyncStatus(builtins.str, Enum):
    """
    A value indicating whether multi-VM sync has to be enabled. Value should be 'Enabled' or 'Disabled'.
    """
    ENABLE = "Enable"
    DISABLE = "Disable"


@pulumi.type_token("azure-native:recoveryservices:SkuName")
class SkuName(builtins.str, Enum):
    """
    Name of SKU is RS0 (Recovery Services 0th version) and the tier is standard tier. They do not have affect on backend storage redundancy or any other vault settings. To manage storage redundancy, use the backupstorageconfig
    """
    STANDARD = "Standard"
    RS0 = "RS0"


@pulumi.type_token("azure-native:recoveryservices:SoftDeleteState")
class SoftDeleteState(builtins.str, Enum):
    INVALID = "Invalid"
    ENABLED = "Enabled"
    DISABLED = "Disabled"
    ALWAYS_ON = "AlwaysON"


@pulumi.type_token("azure-native:recoveryservices:SqlServerLicenseType")
class SqlServerLicenseType(builtins.str, Enum):
    """
    The SQL Server license type.
    """
    NOT_SPECIFIED = "NotSpecified"
    NO_LICENSE_TYPE = "NoLicenseType"
    PAYG = "PAYG"
    AHUB = "AHUB"


@pulumi.type_token("azure-native:recoveryservices:StandardTierStorageRedundancy")
class StandardTierStorageRedundancy(builtins.str, Enum):
    """
    The storage redundancy setting of a vault
    """
    INVALID = "Invalid"
    LOCALLY_REDUNDANT = "LocallyRedundant"
    GEO_REDUNDANT = "GeoRedundant"
    ZONE_REDUNDANT = "ZoneRedundant"


@pulumi.type_token("azure-native:recoveryservices:TieringMode")
class TieringMode(builtins.str, Enum):
    """
    Tiering Mode to control automatic tiering of recovery points. Supported values are:
    1. TierRecommended: Tier all recovery points recommended to be tiered
    2. TierAfter: Tier all recovery points after a fixed period, as specified in duration + durationType below.
    3. DoNotTier: Do not tier any recovery points
    """
    INVALID = "Invalid"
    TIER_RECOMMENDED = "TierRecommended"
    TIER_AFTER = "TierAfter"
    DO_NOT_TIER = "DoNotTier"


@pulumi.type_token("azure-native:recoveryservices:VaultSubResourceType")
class VaultSubResourceType(builtins.str, Enum):
    """
    GroupId for the PrivateEndpointConnection - AzureBackup, AzureBackup_secondary or AzureSiteRecovery
    """
    AZURE_BACKUP = "AzureBackup"
    AZURE_BACKUP_SECONDARY = "AzureBackup_secondary"
    AZURE_SITE_RECOVERY = "AzureSiteRecovery"


@pulumi.type_token("azure-native:recoveryservices:WeekOfMonth")
class WeekOfMonth(builtins.str, Enum):
    FIRST = "First"
    SECOND = "Second"
    THIRD = "Third"
    FOURTH = "Fourth"
    LAST = "Last"
    INVALID = "Invalid"


@pulumi.type_token("azure-native:recoveryservices:WorkloadItemType")
class WorkloadItemType(builtins.str, Enum):
    """
    Workload item type of the item for which intent is to be set
    """
    INVALID = "Invalid"
    SQL_INSTANCE = "SQLInstance"
    SQL_DATA_BASE = "SQLDataBase"
    SAP_HANA_SYSTEM = "SAPHanaSystem"
    SAP_HANA_DATABASE = "SAPHanaDatabase"
    SAPASE_SYSTEM = "SAPAseSystem"
    SAPASE_DATABASE = "SAPAseDatabase"
    SAP_HANA_DB_INSTANCE = "SAPHanaDBInstance"


@pulumi.type_token("azure-native:recoveryservices:WorkloadType")
class WorkloadType(builtins.str, Enum):
    """
    Type of workload for the backup management
    """
    INVALID = "Invalid"
    VM = "VM"
    FILE_FOLDER = "FileFolder"
    AZURE_SQL_DB = "AzureSqlDb"
    SQLDB = "SQLDB"
    EXCHANGE = "Exchange"
    SHAREPOINT = "Sharepoint"
    V_MWARE_VM = "VMwareVM"
    SYSTEM_STATE = "SystemState"
    CLIENT = "Client"
    GENERIC_DATA_SOURCE = "GenericDataSource"
    SQL_DATA_BASE = "SQLDataBase"
    AZURE_FILE_SHARE = "AzureFileShare"
    SAP_HANA_DATABASE = "SAPHanaDatabase"
    SAPASE_DATABASE = "SAPAseDatabase"
    SAP_HANA_DB_INSTANCE = "SAPHanaDBInstance"
