# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetRecoveryPointAccessTokenResult',
    'AwaitableGetRecoveryPointAccessTokenResult',
    'get_recovery_point_access_token',
    'get_recovery_point_access_token_output',
]

@pulumi.output_type
class GetRecoveryPointAccessTokenResult:
    def __init__(__self__, e_tag=None, id=None, location=None, name=None, properties=None, tags=None, type=None):
        if e_tag and not isinstance(e_tag, str):
            raise TypeError("Expected argument 'e_tag' to be a str")
        pulumi.set(__self__, "e_tag", e_tag)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="eTag")
    def e_tag(self) -> Optional[builtins.str]:
        """
        Optional ETag.
        """
        return pulumi.get(self, "e_tag")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Resource Id represents the complete path to the resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> Optional[builtins.str]:
        """
        Resource location.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Resource name associated with the resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.WorkloadCrrAccessTokenResponse':
        """
        CrrAccessTokenResource properties
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, builtins.str]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Resource type represents the complete path of the form Namespace/ResourceType/ResourceType/...
        """
        return pulumi.get(self, "type")


class AwaitableGetRecoveryPointAccessTokenResult(GetRecoveryPointAccessTokenResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRecoveryPointAccessTokenResult(
            e_tag=self.e_tag,
            id=self.id,
            location=self.location,
            name=self.name,
            properties=self.properties,
            tags=self.tags,
            type=self.type)


def get_recovery_point_access_token(container_name: Optional[builtins.str] = None,
                                    e_tag: Optional[builtins.str] = None,
                                    fabric_name: Optional[builtins.str] = None,
                                    location: Optional[builtins.str] = None,
                                    properties: Optional[Union['AADProperties', 'AADPropertiesDict']] = None,
                                    protected_item_name: Optional[builtins.str] = None,
                                    recovery_point_id: Optional[builtins.str] = None,
                                    resource_group_name: Optional[builtins.str] = None,
                                    tags: Optional[Mapping[str, builtins.str]] = None,
                                    vault_name: Optional[builtins.str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRecoveryPointAccessTokenResult:
    """
    Uses Azure REST API version 2023-01-15.


    :param builtins.str container_name: Name of the container.
    :param builtins.str e_tag: Optional ETag.
    :param builtins.str fabric_name: Fabric name associated with the container.
    :param builtins.str location: Resource location.
    :param Union['AADProperties', 'AADPropertiesDict'] properties: AADPropertiesResource properties
    :param builtins.str protected_item_name: Name of the Protected Item.
    :param builtins.str recovery_point_id: Recovery Point Id
    :param builtins.str resource_group_name: The name of the resource group where the recovery services vault is present.
    :param Mapping[str, builtins.str] tags: Resource tags.
    :param builtins.str vault_name: The name of the recovery services vault.
    """
    __args__ = dict()
    __args__['containerName'] = container_name
    __args__['eTag'] = e_tag
    __args__['fabricName'] = fabric_name
    __args__['location'] = location
    __args__['properties'] = properties
    __args__['protectedItemName'] = protected_item_name
    __args__['recoveryPointId'] = recovery_point_id
    __args__['resourceGroupName'] = resource_group_name
    __args__['tags'] = tags
    __args__['vaultName'] = vault_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:recoveryservices:getRecoveryPointAccessToken', __args__, opts=opts, typ=GetRecoveryPointAccessTokenResult).value

    return AwaitableGetRecoveryPointAccessTokenResult(
        e_tag=pulumi.get(__ret__, 'e_tag'),
        id=pulumi.get(__ret__, 'id'),
        location=pulumi.get(__ret__, 'location'),
        name=pulumi.get(__ret__, 'name'),
        properties=pulumi.get(__ret__, 'properties'),
        tags=pulumi.get(__ret__, 'tags'),
        type=pulumi.get(__ret__, 'type'))
def get_recovery_point_access_token_output(container_name: Optional[pulumi.Input[builtins.str]] = None,
                                           e_tag: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                           fabric_name: Optional[pulumi.Input[builtins.str]] = None,
                                           location: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                           properties: Optional[pulumi.Input[Optional[Union['AADProperties', 'AADPropertiesDict']]]] = None,
                                           protected_item_name: Optional[pulumi.Input[builtins.str]] = None,
                                           recovery_point_id: Optional[pulumi.Input[builtins.str]] = None,
                                           resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                           tags: Optional[pulumi.Input[Optional[Mapping[str, builtins.str]]]] = None,
                                           vault_name: Optional[pulumi.Input[builtins.str]] = None,
                                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRecoveryPointAccessTokenResult]:
    """
    Uses Azure REST API version 2023-01-15.


    :param builtins.str container_name: Name of the container.
    :param builtins.str e_tag: Optional ETag.
    :param builtins.str fabric_name: Fabric name associated with the container.
    :param builtins.str location: Resource location.
    :param Union['AADProperties', 'AADPropertiesDict'] properties: AADPropertiesResource properties
    :param builtins.str protected_item_name: Name of the Protected Item.
    :param builtins.str recovery_point_id: Recovery Point Id
    :param builtins.str resource_group_name: The name of the resource group where the recovery services vault is present.
    :param Mapping[str, builtins.str] tags: Resource tags.
    :param builtins.str vault_name: The name of the recovery services vault.
    """
    __args__ = dict()
    __args__['containerName'] = container_name
    __args__['eTag'] = e_tag
    __args__['fabricName'] = fabric_name
    __args__['location'] = location
    __args__['properties'] = properties
    __args__['protectedItemName'] = protected_item_name
    __args__['recoveryPointId'] = recovery_point_id
    __args__['resourceGroupName'] = resource_group_name
    __args__['tags'] = tags
    __args__['vaultName'] = vault_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:recoveryservices:getRecoveryPointAccessToken', __args__, opts=opts, typ=GetRecoveryPointAccessTokenResult)
    return __ret__.apply(lambda __response__: GetRecoveryPointAccessTokenResult(
        e_tag=pulumi.get(__response__, 'e_tag'),
        id=pulumi.get(__response__, 'id'),
        location=pulumi.get(__response__, 'location'),
        name=pulumi.get(__response__, 'name'),
        properties=pulumi.get(__response__, 'properties'),
        tags=pulumi.get(__response__, 'tags'),
        type=pulumi.get(__response__, 'type')))
