# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'DayOfWeek',
    'ManagedServiceIdentityType',
    'PrivateEndpointServiceConnectionStatus',
    'PublicNetworkAccess',
    'ReplicationRole',
    'SkuFamily',
    'SkuName',
    'TlsVersion',
    'UpdateChannel',
    'ZonalAllocationPolicy',
]


@pulumi.type_token("azure-native:redis:DayOfWeek")
class DayOfWeek(builtins.str, Enum):
    """
    Day of the week when a cache can be patched.
    """
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"
    SUNDAY = "Sunday"
    EVERYDAY = "Everyday"
    WEEKEND = "Weekend"


@pulumi.type_token("azure-native:redis:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


@pulumi.type_token("azure-native:redis:PrivateEndpointServiceConnectionStatus")
class PrivateEndpointServiceConnectionStatus(builtins.str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"


@pulumi.type_token("azure-native:redis:PublicNetworkAccess")
class PublicNetworkAccess(builtins.str, Enum):
    """
    Whether or not public endpoint access is allowed for this cache.  Value is optional but if passed in, must be 'Enabled' or 'Disabled'. If 'Disabled', private endpoints are the exclusive access method. Default value is 'Enabled'
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:redis:ReplicationRole")
class ReplicationRole(builtins.str, Enum):
    """
    Role of the linked server.
    """
    PRIMARY = "Primary"
    SECONDARY = "Secondary"


@pulumi.type_token("azure-native:redis:SkuFamily")
class SkuFamily(builtins.str, Enum):
    """
    The SKU family to use. Valid values: (C, P). (C = Basic/Standard, P = Premium).
    """
    C = "C"
    P = "P"


@pulumi.type_token("azure-native:redis:SkuName")
class SkuName(builtins.str, Enum):
    """
    The type of Redis cache to deploy. Valid values: (Basic, Standard, Premium)
    """
    BASIC = "Basic"
    STANDARD = "Standard"
    PREMIUM = "Premium"


@pulumi.type_token("azure-native:redis:TlsVersion")
class TlsVersion(builtins.str, Enum):
    """
    Optional: requires clients to use a specified TLS version (or higher) to connect (e,g, '1.0', '1.1', '1.2')
    """
    TLS_VERSION_1_0 = "1.0"
    TLS_VERSION_1_1 = "1.1"
    TLS_VERSION_1_2 = "1.2"


@pulumi.type_token("azure-native:redis:UpdateChannel")
class UpdateChannel(builtins.str, Enum):
    """
    Optional: Specifies the update channel for the monthly Redis updates your Redis Cache will receive. Caches using 'Preview' update channel get latest Redis updates at least 4 weeks ahead of 'Stable' channel caches. Default value is 'Stable'.
    """
    STABLE = "Stable"
    PREVIEW = "Preview"


@pulumi.type_token("azure-native:redis:ZonalAllocationPolicy")
class ZonalAllocationPolicy(builtins.str, Enum):
    """
    Optional: Specifies how availability zones are allocated to the Redis cache. 'Automatic' enables zone redundancy and Azure will automatically select zones based on regional availability and capacity. 'UserDefined' will select availability zones passed in by you using the 'zones' parameter. 'NoZones' will produce a non-zonal cache. If 'zonalAllocationPolicy' is not passed, it will be set to 'UserDefined' when zones are passed in, otherwise, it will be set to 'Automatic' in regions where zones are supported and 'NoZones' in regions where zones are not supported.
    """
    AUTOMATIC = "Automatic"
    USER_DEFINED = "UserDefined"
    NO_ZONES = "NoZones"
