# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetRedisFirewallRuleResult',
    'AwaitableGetRedisFirewallRuleResult',
    'get_redis_firewall_rule',
    'get_redis_firewall_rule_output',
]

@pulumi.output_type
class GetRedisFirewallRuleResult:
    """
    A firewall rule on a redis cache has a name, and describes a contiguous range of IP addresses permitted to connect
    """
    def __init__(__self__, azure_api_version=None, end_ip=None, id=None, name=None, start_ip=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if end_ip and not isinstance(end_ip, str):
            raise TypeError("Expected argument 'end_ip' to be a str")
        pulumi.set(__self__, "end_ip", end_ip)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if start_ip and not isinstance(start_ip, str):
            raise TypeError("Expected argument 'start_ip' to be a str")
        pulumi.set(__self__, "start_ip", start_ip)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="endIP")
    def end_ip(self) -> builtins.str:
        """
        highest IP address included in the range
        """
        return pulumi.get(self, "end_ip")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        resource ID (of the firewall rule)
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        name of the firewall rule
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="startIP")
    def start_ip(self) -> builtins.str:
        """
        lowest IP address included in the range
        """
        return pulumi.get(self, "start_ip")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        type (of the firewall rule resource = 'Microsoft.Cache/redis/firewallRule')
        """
        return pulumi.get(self, "type")


class AwaitableGetRedisFirewallRuleResult(GetRedisFirewallRuleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRedisFirewallRuleResult(
            azure_api_version=self.azure_api_version,
            end_ip=self.end_ip,
            id=self.id,
            name=self.name,
            start_ip=self.start_ip,
            type=self.type)


def get_redis_firewall_rule(cache_name: Optional[builtins.str] = None,
                            resource_group_name: Optional[builtins.str] = None,
                            rule_name: Optional[builtins.str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRedisFirewallRuleResult:
    """
    Gets a single firewall rule in a specified redis cache.

    Uses Azure REST API version 2016-04-01.


    :param builtins.str cache_name: The name of the Redis cache.
    :param builtins.str resource_group_name: The name of the resource group.
    :param builtins.str rule_name: The name of the firewall rule.
    """
    __args__ = dict()
    __args__['cacheName'] = cache_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['ruleName'] = rule_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:redis:getRedisFirewallRule', __args__, opts=opts, typ=GetRedisFirewallRuleResult).value

    return AwaitableGetRedisFirewallRuleResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        end_ip=pulumi.get(__ret__, 'end_ip'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        start_ip=pulumi.get(__ret__, 'start_ip'),
        type=pulumi.get(__ret__, 'type'))
def get_redis_firewall_rule_output(cache_name: Optional[pulumi.Input[builtins.str]] = None,
                                   resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                   rule_name: Optional[pulumi.Input[builtins.str]] = None,
                                   opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRedisFirewallRuleResult]:
    """
    Gets a single firewall rule in a specified redis cache.

    Uses Azure REST API version 2016-04-01.


    :param builtins.str cache_name: The name of the Redis cache.
    :param builtins.str resource_group_name: The name of the resource group.
    :param builtins.str rule_name: The name of the firewall rule.
    """
    __args__ = dict()
    __args__['cacheName'] = cache_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['ruleName'] = rule_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:redis:getRedisFirewallRule', __args__, opts=opts, typ=GetRedisFirewallRuleResult)
    return __ret__.apply(lambda __response__: GetRedisFirewallRuleResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        end_ip=pulumi.get(__response__, 'end_ip'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        start_ip=pulumi.get(__response__, 'start_ip'),
        type=pulumi.get(__response__, 'type')))
