# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from ._enums import *

__all__ = ['RedisLinkedServerArgs', 'RedisLinkedServer']

@pulumi.input_type
class RedisLinkedServerArgs:
    def __init__(__self__, *,
                 linked_redis_cache_id: pulumi.Input[builtins.str],
                 linked_redis_cache_location: pulumi.Input[builtins.str],
                 name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 server_role: pulumi.Input['ReplicationRole'],
                 linked_server_name: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a RedisLinkedServer resource.
        :param pulumi.Input[builtins.str] linked_redis_cache_id: Fully qualified resourceId of the linked redis cache.
        :param pulumi.Input[builtins.str] linked_redis_cache_location: Location of the linked redis cache.
        :param pulumi.Input[builtins.str] name: The name of the Redis cache.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group.
        :param pulumi.Input['ReplicationRole'] server_role: Role of the linked server.
        :param pulumi.Input[builtins.str] linked_server_name: The name of the linked server that is being added to the Redis cache.
        """
        pulumi.set(__self__, "linked_redis_cache_id", linked_redis_cache_id)
        pulumi.set(__self__, "linked_redis_cache_location", linked_redis_cache_location)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "server_role", server_role)
        if linked_server_name is not None:
            pulumi.set(__self__, "linked_server_name", linked_server_name)

    @property
    @pulumi.getter(name="linkedRedisCacheId")
    def linked_redis_cache_id(self) -> pulumi.Input[builtins.str]:
        """
        Fully qualified resourceId of the linked redis cache.
        """
        return pulumi.get(self, "linked_redis_cache_id")

    @linked_redis_cache_id.setter
    def linked_redis_cache_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "linked_redis_cache_id", value)

    @property
    @pulumi.getter(name="linkedRedisCacheLocation")
    def linked_redis_cache_location(self) -> pulumi.Input[builtins.str]:
        """
        Location of the linked redis cache.
        """
        return pulumi.get(self, "linked_redis_cache_location")

    @linked_redis_cache_location.setter
    def linked_redis_cache_location(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "linked_redis_cache_location", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the Redis cache.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="serverRole")
    def server_role(self) -> pulumi.Input['ReplicationRole']:
        """
        Role of the linked server.
        """
        return pulumi.get(self, "server_role")

    @server_role.setter
    def server_role(self, value: pulumi.Input['ReplicationRole']):
        pulumi.set(self, "server_role", value)

    @property
    @pulumi.getter(name="linkedServerName")
    def linked_server_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the linked server that is being added to the Redis cache.
        """
        return pulumi.get(self, "linked_server_name")

    @linked_server_name.setter
    def linked_server_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "linked_server_name", value)


@pulumi.type_token("azure-native:redis:RedisLinkedServer")
class RedisLinkedServer(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 linked_redis_cache_id: Optional[pulumi.Input[builtins.str]] = None,
                 linked_redis_cache_location: Optional[pulumi.Input[builtins.str]] = None,
                 linked_server_name: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 server_role: Optional[pulumi.Input['ReplicationRole']] = None,
                 __props__=None):
        """
        Response to put/get linked server (with properties) for Redis cache.

        Uses Azure REST API version 2017-02-01.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] linked_redis_cache_id: Fully qualified resourceId of the linked redis cache.
        :param pulumi.Input[builtins.str] linked_redis_cache_location: Location of the linked redis cache.
        :param pulumi.Input[builtins.str] linked_server_name: The name of the linked server that is being added to the Redis cache.
        :param pulumi.Input[builtins.str] name: The name of the Redis cache.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group.
        :param pulumi.Input['ReplicationRole'] server_role: Role of the linked server.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RedisLinkedServerArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Response to put/get linked server (with properties) for Redis cache.

        Uses Azure REST API version 2017-02-01.

        :param str resource_name: The name of the resource.
        :param RedisLinkedServerArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RedisLinkedServerArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 linked_redis_cache_id: Optional[pulumi.Input[builtins.str]] = None,
                 linked_redis_cache_location: Optional[pulumi.Input[builtins.str]] = None,
                 linked_server_name: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 server_role: Optional[pulumi.Input['ReplicationRole']] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RedisLinkedServerArgs.__new__(RedisLinkedServerArgs)

            if linked_redis_cache_id is None and not opts.urn:
                raise TypeError("Missing required property 'linked_redis_cache_id'")
            __props__.__dict__["linked_redis_cache_id"] = linked_redis_cache_id
            if linked_redis_cache_location is None and not opts.urn:
                raise TypeError("Missing required property 'linked_redis_cache_location'")
            __props__.__dict__["linked_redis_cache_location"] = linked_redis_cache_location
            __props__.__dict__["linked_server_name"] = linked_server_name
            if name is None and not opts.urn:
                raise TypeError("Missing required property 'name'")
            __props__.__dict__["name"] = name
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            if server_role is None and not opts.urn:
                raise TypeError("Missing required property 'server_role'")
            __props__.__dict__["server_role"] = server_role
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:cache/v20230401:LinkedServer"), pulumi.Alias(type_="azure-native:cache/v20230501preview:LinkedServer"), pulumi.Alias(type_="azure-native:cache/v20230801:LinkedServer"), pulumi.Alias(type_="azure-native:cache/v20240301:LinkedServer"), pulumi.Alias(type_="azure-native:cache/v20240401preview:LinkedServer"), pulumi.Alias(type_="azure-native:cache/v20241101:LinkedServer"), pulumi.Alias(type_="azure-native:cache:LinkedServer"), pulumi.Alias(type_="azure-native:redis/v20170201:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20171001:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20180301:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20190701:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20200601:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20201201:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20210601:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20220501:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20220601:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20230401:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20230501preview:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20230801:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20240301:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20240401preview:RedisLinkedServer"), pulumi.Alias(type_="azure-native:redis/v20241101:RedisLinkedServer")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(RedisLinkedServer, __self__).__init__(
            'azure-native:redis:RedisLinkedServer',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'RedisLinkedServer':
        """
        Get an existing RedisLinkedServer resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = RedisLinkedServerArgs.__new__(RedisLinkedServerArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["linked_redis_cache_id"] = None
        __props__.__dict__["linked_redis_cache_location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["server_role"] = None
        __props__.__dict__["type"] = None
        return RedisLinkedServer(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="linkedRedisCacheId")
    def linked_redis_cache_id(self) -> pulumi.Output[builtins.str]:
        """
        Fully qualified resourceId of the linked redis cache.
        """
        return pulumi.get(self, "linked_redis_cache_id")

    @property
    @pulumi.getter(name="linkedRedisCacheLocation")
    def linked_redis_cache_location(self) -> pulumi.Output[builtins.str]:
        """
        Location of the linked redis cache.
        """
        return pulumi.get(self, "linked_redis_cache_location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        Terminal state of the link between primary and secondary redis cache.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="serverRole")
    def server_role(self) -> pulumi.Output[builtins.str]:
        """
        Role of the linked server.
        """
        return pulumi.get(self, "server_role")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        Resource type.
        """
        return pulumi.get(self, "type")

