# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'CleanupOptions',
    'DenySettingsMode',
    'DeploymentMode',
    'DeploymentStacksDeleteDetachEnum',
    'ExpressionEvaluationOptionsScopeType',
    'ExtendedLocationType',
    'ManagedServiceIdentityType',
    'OnErrorDeploymentType',
    'ResourceIdentityType',
    'ScriptType',
]


@pulumi.type_token("azure-native:resources:CleanupOptions")
class CleanupOptions(builtins.str, Enum):
    """
    The clean up preference when the script execution gets in a terminal state. Default setting is 'Always'.
    """
    ALWAYS = "Always"
    ON_SUCCESS = "OnSuccess"
    ON_EXPIRATION = "OnExpiration"


@pulumi.type_token("azure-native:resources:DenySettingsMode")
class DenySettingsMode(builtins.str, Enum):
    """
    denySettings Mode that defines denied actions.
    """
    DENY_DELETE = "denyDelete"
    """
    Authorized users are able to read and modify the resources, but cannot delete.
    """
    DENY_WRITE_AND_DELETE = "denyWriteAndDelete"
    """
    Authorized users can read from a resource, but cannot modify or delete it.
    """
    NONE = "none"
    """
    No denyAssignments have been applied.
    """


@pulumi.type_token("azure-native:resources:DeploymentMode")
class DeploymentMode(builtins.str, Enum):
    """
    The mode that is used to deploy resources. This value can be either Incremental or Complete. In Incremental mode, resources are deployed without deleting existing resources that are not included in the template. In Complete mode, resources are deployed and existing resources in the resource group that are not included in the template are deleted. Be careful when using Complete mode as you may unintentionally delete resources.
    """
    INCREMENTAL = "Incremental"
    COMPLETE = "Complete"


@pulumi.type_token("azure-native:resources:DeploymentStacksDeleteDetachEnum")
class DeploymentStacksDeleteDetachEnum(builtins.str, Enum):
    """
    Specifies an action for a newly unmanaged resource. Delete will attempt to delete the resource from Azure. Detach will leave the resource in it's current state.
    """
    DELETE = "delete"
    DETACH = "detach"


@pulumi.type_token("azure-native:resources:ExpressionEvaluationOptionsScopeType")
class ExpressionEvaluationOptionsScopeType(builtins.str, Enum):
    """
    The scope to be used for evaluation of parameters, variables and functions in a nested template.
    """
    NOT_SPECIFIED = "NotSpecified"
    OUTER = "Outer"
    INNER = "Inner"


@pulumi.type_token("azure-native:resources:ExtendedLocationType")
class ExtendedLocationType(builtins.str, Enum):
    """
    The extended location type.
    """
    EDGE_ZONE = "EdgeZone"


@pulumi.type_token("azure-native:resources:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of the managed identity.
    """
    USER_ASSIGNED = "UserAssigned"


@pulumi.type_token("azure-native:resources:OnErrorDeploymentType")
class OnErrorDeploymentType(builtins.str, Enum):
    """
    The deployment on error behavior type. Possible values are LastSuccessful and SpecificDeployment.
    """
    LAST_SUCCESSFUL = "LastSuccessful"
    SPECIFIC_DEPLOYMENT = "SpecificDeployment"


@pulumi.type_token("azure-native:resources:ResourceIdentityType")
class ResourceIdentityType(builtins.str, Enum):
    """
    The identity type.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:resources:ScriptType")
class ScriptType(builtins.str, Enum):
    """
    Type of the script.
    """
    AZURE_POWER_SHELL = "AzurePowerShell"
    AZURE_CLI = "AzureCLI"
