# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ActionType',
    'AdditionalWorkspaceDataType',
    'AdditionalWorkspaceType',
    'ApplicationSourceResourceType',
    'AssessmentStatusCode',
    'AssessmentType',
    'AttestationComplianceState',
    'AuthenticationType',
    'AutoDiscovery',
    'AutoProvision',
    'Categories',
    'CloudName',
    'DataSource',
    'DevOpsProvisioningState',
    'Effect',
    'Enforce',
    'EnvironmentType',
    'EventSource',
    'ExemptionCategory',
    'ExportData',
    'GovernanceRuleOwnerSourceType',
    'GovernanceRuleSourceResourceType',
    'GovernanceRuleType',
    'ImplementationEffort',
    'IsEnabled',
    'MinimalRiskLevel',
    'MinimalSeverity',
    'OfferingType',
    'Operator',
    'OrganizationMembershipType',
    'PricingTier',
    'PropertyType',
    'Protocol',
    'RecommendationConfigStatus',
    'RecommendationSupportedClouds',
    'RecommendationType',
    'RuleState',
    'ScanningMode',
    'SecurityContactRole',
    'SecurityIssue',
    'SecuritySolutionStatus',
    'ServerVulnerabilityAssessmentsAzureSettingSelectedProvider',
    'ServerVulnerabilityAssessmentsSettingKind',
    'Severity',
    'SeverityEnum',
    'Source',
    'SourceType',
    'StandardSupportedCloud',
    'StandardSupportedClouds',
    'State',
    'Status',
    'StatusReason',
    'SubPlan',
    'SupportedCloudEnum',
    'Tactics',
    'Techniques',
    'Threats',
    'Type',
    'UnmaskedIpLoggingStatus',
    'UserImpact',
]


@pulumi.type_token("azure-native:security:ActionType")
class ActionType(builtins.str, Enum):
    """
    The type of the action that will be triggered by the Automation
    """
    LOGIC_APP = "LogicApp"
    EVENT_HUB = "EventHub"
    WORKSPACE = "Workspace"


@pulumi.type_token("azure-native:security:AdditionalWorkspaceDataType")
class AdditionalWorkspaceDataType(builtins.str, Enum):
    """
    Data types sent to workspace.
    """
    ALERTS = "Alerts"
    RAW_EVENTS = "RawEvents"


@pulumi.type_token("azure-native:security:AdditionalWorkspaceType")
class AdditionalWorkspaceType(builtins.str, Enum):
    """
    Workspace type.
    """
    SENTINEL = "Sentinel"


@pulumi.type_token("azure-native:security:ApplicationSourceResourceType")
class ApplicationSourceResourceType(builtins.str, Enum):
    """
    The application source, what it affects, e.g. Assessments
    """
    ASSESSMENTS = "Assessments"
    """
    The source of the application is assessments
    """


@pulumi.type_token("azure-native:security:AssessmentStatusCode")
class AssessmentStatusCode(builtins.str, Enum):
    """
    Programmatic code for the status of the assessment
    """
    HEALTHY = "Healthy"
    """
    The resource is healthy
    """
    UNHEALTHY = "Unhealthy"
    """
    The resource has a security issue that needs to be addressed
    """
    NOT_APPLICABLE = "NotApplicable"
    """
    Assessment for this resource did not happen
    """


@pulumi.type_token("azure-native:security:AssessmentType")
class AssessmentType(builtins.str, Enum):
    """
    BuiltIn if the assessment based on built-in Azure Policy definition, Custom if the assessment based on custom Azure Policy definition
    """
    BUILT_IN = "BuiltIn"
    """
    Microsoft Defender for Cloud managed assessments
    """
    CUSTOM_POLICY = "CustomPolicy"
    """
    User defined policies that are automatically ingested from Azure Policy to Microsoft Defender for Cloud
    """
    CUSTOMER_MANAGED = "CustomerManaged"
    """
    User assessments pushed directly by the user or other third party to Microsoft Defender for Cloud
    """


@pulumi.type_token("azure-native:security:AttestationComplianceState")
class AttestationComplianceState(builtins.str, Enum):
    """
    Attest category of this assignment
    """
    UNKNOWN = "unknown"
    COMPLIANT = "compliant"
    NON_COMPLIANT = "nonCompliant"


@pulumi.type_token("azure-native:security:AuthenticationType")
class AuthenticationType(builtins.str, Enum):
    """
    The authentication type
    """
    ACCESS_TOKEN = "AccessToken"


@pulumi.type_token("azure-native:security:AutoDiscovery")
class AutoDiscovery(builtins.str, Enum):
    """
    AutoDiscovery states.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"
    NOT_APPLICABLE = "NotApplicable"


@pulumi.type_token("azure-native:security:AutoProvision")
class AutoProvision(builtins.str, Enum):
    """
    Whether or not to automatically install Azure Arc (hybrid compute) agents on machines
    """
    ON = "On"
    """
    Install missing Azure Arc agents on machines automatically
    """
    OFF = "Off"
    """
    Do not install Azure Arc agent on the machines automatically
    """


@pulumi.type_token("azure-native:security:Categories")
class Categories(builtins.str, Enum):
    """
    The categories of resource that is at risk when the assessment is unhealthy
    """
    COMPUTE = "Compute"
    NETWORKING = "Networking"
    DATA = "Data"
    IDENTITY_AND_ACCESS = "IdentityAndAccess"
    IO_T = "IoT"


@pulumi.type_token("azure-native:security:CloudName")
class CloudName(builtins.str, Enum):
    """
    The multi cloud resource's cloud name.
    """
    AZURE = "Azure"
    AWS = "AWS"
    GCP = "GCP"
    GITHUB = "Github"
    AZURE_DEV_OPS = "AzureDevOps"
    GIT_LAB = "GitLab"
    DOCKER_HUB = "DockerHub"
    J_FROG = "JFrog"


@pulumi.type_token("azure-native:security:DataSource")
class DataSource(builtins.str, Enum):
    TWIN_DATA = "TwinData"
    """
    Devices twin data
    """


@pulumi.type_token("azure-native:security:DevOpsProvisioningState")
class DevOpsProvisioningState(builtins.str, Enum):
    """
    The provisioning state of the resource.
    
    Pending - Provisioning pending.
    Failed - Provisioning failed.
    Succeeded - Successful provisioning.
    Canceled - Provisioning canceled.
    PendingDeletion - Deletion pending.
    DeletionSuccess - Deletion successful.
    DeletionFailure - Deletion failure.
    """
    SUCCEEDED = "Succeeded"
    FAILED = "Failed"
    CANCELED = "Canceled"
    PENDING = "Pending"
    PENDING_DELETION = "PendingDeletion"
    DELETION_SUCCESS = "DeletionSuccess"
    DELETION_FAILURE = "DeletionFailure"


@pulumi.type_token("azure-native:security:Effect")
class Effect(builtins.str, Enum):
    """
    Expected effect of this assignment (Audit/Exempt/Attest)
    """
    AUDIT = "Audit"
    EXEMPT = "Exempt"
    ATTEST = "Attest"


@pulumi.type_token("azure-native:security:Enforce")
class Enforce(builtins.str, Enum):
    """
    If set to "False", it allows the descendants of this scope to override the pricing configuration set on this scope (allows setting inherited="False"). If set to "True", it prevents overrides and forces this pricing configuration on all the descendants of this scope. This field is only available for subscription-level pricing.
    """
    FALSE = "False"
    """
    Allows the descendants of this scope to override the pricing configuration set on this scope (allows setting inherited="False")
    """
    TRUE = "True"
    """
    Prevents overrides and forces the current scope's pricing configuration to all descendants
    """


@pulumi.type_token("azure-native:security:EnvironmentType")
class EnvironmentType(builtins.str, Enum):
    """
    The type of the environment data.
    """
    AWS_ACCOUNT = "AwsAccount"
    GCP_PROJECT = "GcpProject"
    GITHUB_SCOPE = "GithubScope"
    AZURE_DEV_OPS_SCOPE = "AzureDevOpsScope"
    GITLAB_SCOPE = "GitlabScope"
    DOCKER_HUB_ORGANIZATION = "DockerHubOrganization"
    J_FROG_ARTIFACTORY = "JFrogArtifactory"


@pulumi.type_token("azure-native:security:EventSource")
class EventSource(builtins.str, Enum):
    """
    A valid event source type.
    """
    ASSESSMENTS = "Assessments"
    ASSESSMENTS_SNAPSHOT = "AssessmentsSnapshot"
    SUB_ASSESSMENTS = "SubAssessments"
    SUB_ASSESSMENTS_SNAPSHOT = "SubAssessmentsSnapshot"
    ALERTS = "Alerts"
    SECURE_SCORES = "SecureScores"
    SECURE_SCORES_SNAPSHOT = "SecureScoresSnapshot"
    SECURE_SCORE_CONTROLS = "SecureScoreControls"
    SECURE_SCORE_CONTROLS_SNAPSHOT = "SecureScoreControlsSnapshot"
    REGULATORY_COMPLIANCE_ASSESSMENT = "RegulatoryComplianceAssessment"
    REGULATORY_COMPLIANCE_ASSESSMENT_SNAPSHOT = "RegulatoryComplianceAssessmentSnapshot"
    ATTACK_PATHS = "AttackPaths"
    ATTACK_PATHS_SNAPSHOT = "AttackPathsSnapshot"


@pulumi.type_token("azure-native:security:ExemptionCategory")
class ExemptionCategory(builtins.str, Enum):
    """
    Exemption category of this assignment
    """
    WAIVER = "waiver"
    MITIGATED = "mitigated"


@pulumi.type_token("azure-native:security:ExportData")
class ExportData(builtins.str, Enum):
    RAW_EVENTS = "RawEvents"
    """
    Agent raw events
    """


@pulumi.type_token("azure-native:security:GovernanceRuleOwnerSourceType")
class GovernanceRuleOwnerSourceType(builtins.str, Enum):
    """
    The owner type for the governance rule owner source
    """
    BY_TAG = "ByTag"
    """
    The rule source type defined using resource tag
    """
    MANUALLY = "Manually"
    """
    The rule source type defined manually
    """


@pulumi.type_token("azure-native:security:GovernanceRuleSourceResourceType")
class GovernanceRuleSourceResourceType(builtins.str, Enum):
    """
    The governance rule source, what the rule affects, e.g. Assessments
    """
    ASSESSMENTS = "Assessments"
    """
    The source of the governance rule is assessments
    """


@pulumi.type_token("azure-native:security:GovernanceRuleType")
class GovernanceRuleType(builtins.str, Enum):
    """
    The rule type of the governance rule, defines the source of the rule e.g. Integrated
    """
    INTEGRATED = "Integrated"
    """
    The source of the rule type definition is integrated
    """
    SERVICE_NOW = "ServiceNow"
    """
    The source of the rule type definition is ServiceNow
    """


@pulumi.type_token("azure-native:security:ImplementationEffort")
class ImplementationEffort(builtins.str, Enum):
    """
    The implementation effort required to remediate this assessment
    """
    LOW = "Low"
    MODERATE = "Moderate"
    HIGH = "High"


@pulumi.type_token("azure-native:security:IsEnabled")
class IsEnabled(builtins.str, Enum):
    """
    Indicates whether the extension is enabled.
    """
    TRUE = "True"
    """
    Indicates the extension is enabled
    """
    FALSE = "False"
    """
    Indicates the extension is disabled
    """


@pulumi.type_token("azure-native:security:MinimalRiskLevel")
class MinimalRiskLevel(builtins.str, Enum):
    """
    Defines the minimal attach path risk level which will be sent as email notifications
    """
    CRITICAL = "Critical"
    """
    Get notifications on new attack paths with Critical risk level
    """
    HIGH = "High"
    """
    Get notifications on new attack paths with High or Critical risk level
    """
    MEDIUM = "Medium"
    """
    Get notifications on new attach paths with Medium, High or Critical risk level
    """
    LOW = "Low"
    """
    Get notifications on new attach paths with Low, Medium, High or Critical risk level
    """


@pulumi.type_token("azure-native:security:MinimalSeverity")
class MinimalSeverity(builtins.str, Enum):
    """
    Defines the minimal alert severity which will be sent as email notifications
    """
    HIGH = "High"
    """
    Get notifications on new alerts with High severity
    """
    MEDIUM = "Medium"
    """
    Get notifications on new alerts with Medium or High severity
    """
    LOW = "Low"
    """
    Get notifications on new alerts with Low, Medium or High severity
    """


@pulumi.type_token("azure-native:security:OfferingType")
class OfferingType(builtins.str, Enum):
    """
    The type of the security offering.
    """
    CSPM_MONITOR_AWS = "CspmMonitorAws"
    DEFENDER_FOR_CONTAINERS_AWS = "DefenderForContainersAws"
    DEFENDER_FOR_SERVERS_AWS = "DefenderForServersAws"
    DEFENDER_FOR_DATABASES_AWS = "DefenderForDatabasesAws"
    CSPM_MONITOR_GCP = "CspmMonitorGcp"
    CSPM_MONITOR_GITHUB = "CspmMonitorGithub"
    CSPM_MONITOR_AZURE_DEV_OPS = "CspmMonitorAzureDevOps"
    DEFENDER_FOR_SERVERS_GCP = "DefenderForServersGcp"
    DEFENDER_FOR_CONTAINERS_GCP = "DefenderForContainersGcp"
    DEFENDER_FOR_DATABASES_GCP = "DefenderForDatabasesGcp"
    DEFENDER_CSPM_AWS = "DefenderCspmAws"
    DEFENDER_CSPM_GCP = "DefenderCspmGcp"
    CSPM_MONITOR_GIT_LAB = "CspmMonitorGitLab"
    CSPM_MONITOR_DOCKER_HUB = "CspmMonitorDockerHub"
    DEFENDER_FOR_CONTAINERS_DOCKER_HUB = "DefenderForContainersDockerHub"
    DEFENDER_CSPM_DOCKER_HUB = "DefenderCspmDockerHub"
    CSPM_MONITOR_J_FROG = "CspmMonitorJFrog"
    DEFENDER_FOR_CONTAINERS_J_FROG = "DefenderForContainersJFrog"
    DEFENDER_CSPM_J_FROG = "DefenderCspmJFrog"


@pulumi.type_token("azure-native:security:Operator")
class Operator(builtins.str, Enum):
    """
    A valid comparer operator to use. A case-insensitive comparison will be applied for String PropertyType.
    """
    EQUALS = "Equals"
    """
    Applies for decimal and non-decimal operands
    """
    GREATER_THAN = "GreaterThan"
    """
    Applies only for decimal operands
    """
    GREATER_THAN_OR_EQUAL_TO = "GreaterThanOrEqualTo"
    """
    Applies only for decimal operands
    """
    LESSER_THAN = "LesserThan"
    """
    Applies only for decimal operands
    """
    LESSER_THAN_OR_EQUAL_TO = "LesserThanOrEqualTo"
    """
    Applies only for decimal operands
    """
    NOT_EQUALS = "NotEquals"
    """
    Applies  for decimal and non-decimal operands
    """
    CONTAINS = "Contains"
    """
    Applies only for non-decimal operands
    """
    STARTS_WITH = "StartsWith"
    """
    Applies only for non-decimal operands
    """
    ENDS_WITH = "EndsWith"
    """
    Applies only for non-decimal operands
    """


@pulumi.type_token("azure-native:security:OrganizationMembershipType")
class OrganizationMembershipType(builtins.str, Enum):
    """
    The multi cloud account's membership type in the organization
    """
    MEMBER = "Member"
    ORGANIZATION = "Organization"


@pulumi.type_token("azure-native:security:PricingTier")
class PricingTier(builtins.str, Enum):
    """
    Indicates whether the Defender plan is enabled on the selected scope. Microsoft Defender for Cloud is provided in two pricing tiers: free and standard. The standard tier offers advanced security capabilities, while the free tier offers basic security features.
    """
    FREE = "Free"
    """
    Get free Microsoft Defender for Cloud experience with basic security features
    """
    STANDARD = "Standard"
    """
    Get the standard Microsoft Defender for Cloud experience with advanced security features
    """


@pulumi.type_token("azure-native:security:PropertyType")
class PropertyType(builtins.str, Enum):
    """
    The data type of the compared operands (string, integer, floating point number or a boolean [true/false]]
    """
    STRING = "String"
    INTEGER = "Integer"
    NUMBER = "Number"
    BOOLEAN = "Boolean"


@pulumi.type_token("azure-native:security:Protocol")
class Protocol(builtins.str, Enum):
    TCP = "TCP"
    UDP = "UDP"
    ALL = "*"


@pulumi.type_token("azure-native:security:RecommendationConfigStatus")
class RecommendationConfigStatus(builtins.str, Enum):
    """
    Recommendation status. When the recommendation status is disabled recommendations are not generated.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"


@pulumi.type_token("azure-native:security:RecommendationSupportedClouds")
class RecommendationSupportedClouds(builtins.str, Enum):
    """
    The cloud that the recommendation is supported on.
    """
    AZURE = "Azure"
    AWS = "AWS"
    GCP = "GCP"


@pulumi.type_token("azure-native:security:RecommendationType")
class RecommendationType(builtins.str, Enum):
    """
    The type of IoT Security recommendation.
    """
    IO_T_ACR_AUTHENTICATION = "IoT_ACRAuthentication"
    """
    Authentication schema used for pull an edge module from an ACR repository does not use Service Principal Authentication.
    """
    IO_T_AGENT_SENDS_UNUTILIZED_MESSAGES = "IoT_AgentSendsUnutilizedMessages"
    """
    IoT agent message size capacity is currently underutilized, causing an increase in the number of sent messages. Adjust message intervals for better utilization.
    """
    IO_T_BASELINE = "IoT_Baseline"
    """
    Identified security related system configuration issues.
    """
    IO_T_EDGE_HUB_MEM_OPTIMIZE = "IoT_EdgeHubMemOptimize"
    """
    You can optimize Edge Hub memory usage by turning off protocol heads for any protocols not used by Edge modules in your solution.
    """
    IO_T_EDGE_LOGGING_OPTIONS = "IoT_EdgeLoggingOptions"
    """
    Logging is disabled for this edge module.
    """
    IO_T_INCONSISTENT_MODULE_SETTINGS = "IoT_InconsistentModuleSettings"
    """
    A minority within a device security group has inconsistent Edge Module settings with the rest of their group.
    """
    IO_T_INSTALL_AGENT = "IoT_InstallAgent"
    """
    Install the Azure Security of Things Agent.
    """
    IO_T_IP_FILTER_DENY_ALL = "IoT_IPFilter_DenyAll"
    """
    IP Filter Configuration should have rules defined for allowed traffic and should deny all other traffic by default.
    """
    IO_T_IP_FILTER_PERMISSIVE_RULE = "IoT_IPFilter_PermissiveRule"
    """
    An Allow IP Filter rules source IP range is too large. Overly permissive rules might expose your IoT hub to malicious intenders.
    """
    IO_T_OPEN_PORTS = "IoT_OpenPorts"
    """
    A listening endpoint was found on the device.
    """
    IO_T_PERMISSIVE_FIREWALL_POLICY = "IoT_PermissiveFirewallPolicy"
    """
    An Allowed firewall policy was found (INPUT/OUTPUT). The policy should Deny all traffic by default and define rules to allow necessary communication to/from the device.
    """
    IO_T_PERMISSIVE_INPUT_FIREWALL_RULES = "IoT_PermissiveInputFirewallRules"
    """
    A rule in the firewall has been found that contains a permissive pattern for a wide range of IP addresses or Ports.
    """
    IO_T_PERMISSIVE_OUTPUT_FIREWALL_RULES = "IoT_PermissiveOutputFirewallRules"
    """
    A rule in the firewall has been found that contains a permissive pattern for a wide range of IP addresses or Ports.
    """
    IO_T_PRIVILEGED_DOCKER_OPTIONS = "IoT_PrivilegedDockerOptions"
    """
    Edge module is configured to run in privileged mode, with extensive Linux capabilities or with host-level network access (send/receive data to host machine).
    """
    IO_T_SHARED_CREDENTIALS = "IoT_SharedCredentials"
    """
    Same authentication credentials to the IoT Hub used by multiple devices. This could indicate an illegitimate device impersonating a legitimate device. It also exposes the risk of device impersonation by an attacker.
    """
    IO_T_VULNERABLE_TLS_CIPHER_SUITE = "IoT_VulnerableTLSCipherSuite"
    """
    Insecure TLS configurations detected. Immediate upgrade recommended.
    """


@pulumi.type_token("azure-native:security:RuleState")
class RuleState(builtins.str, Enum):
    """
    Possible states of the rule
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"
    EXPIRED = "Expired"


@pulumi.type_token("azure-native:security:ScanningMode")
class ScanningMode(builtins.str, Enum):
    """
    The scanning mode for the VM scan.
    """
    DEFAULT = "Default"


@pulumi.type_token("azure-native:security:SecurityContactRole")
class SecurityContactRole(builtins.str, Enum):
    """
    A possible role to configure sending security notification alerts to
    """
    ACCOUNT_ADMIN = "AccountAdmin"
    """
    If enabled, send notification on new alerts to the account admins
    """
    SERVICE_ADMIN = "ServiceAdmin"
    """
    If enabled, send notification on new alerts to the service admins
    """
    OWNER = "Owner"
    """
    If enabled, send notification on new alerts to the subscription owners
    """
    CONTRIBUTOR = "Contributor"
    """
    If enabled, send notification on new alerts to the subscription contributors
    """


@pulumi.type_token("azure-native:security:SecurityIssue")
class SecurityIssue(builtins.str, Enum):
    """
    The severity to relate to the assessments generated by this Recommendation.
    """
    VULNERABILITY = "Vulnerability"
    EXCESSIVE_PERMISSIONS = "ExcessivePermissions"
    ANONYMOUS_ACCESS = "AnonymousAccess"
    NETWORK_EXPOSURE = "NetworkExposure"
    TRAFFIC_ENCRYPTION = "TrafficEncryption"
    BEST_PRACTICES = "BestPractices"


@pulumi.type_token("azure-native:security:SecuritySolutionStatus")
class SecuritySolutionStatus(builtins.str, Enum):
    """
    Status of the IoT Security solution.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:security:ServerVulnerabilityAssessmentsAzureSettingSelectedProvider")
class ServerVulnerabilityAssessmentsAzureSettingSelectedProvider(builtins.str, Enum):
    """
    The selected vulnerability assessments provider on Azure servers in the defined scope.
    """
    MDE_TVM = "MdeTvm"
    """
    Microsoft Defender for Endpoints threat and vulnerability management.
    """


@pulumi.type_token("azure-native:security:ServerVulnerabilityAssessmentsSettingKind")
class ServerVulnerabilityAssessmentsSettingKind(builtins.str, Enum):
    """
    The kind of the server vulnerability assessments setting.
    """
    AZURE_SERVERS_SETTING = "AzureServersSetting"


@pulumi.type_token("azure-native:security:Severity")
class Severity(builtins.str, Enum):
    """
    The severity level of the assessment
    """
    LOW = "Low"
    MEDIUM = "Medium"
    HIGH = "High"


@pulumi.type_token("azure-native:security:SeverityEnum")
class SeverityEnum(builtins.str, Enum):
    """
    The severity to relate to the assessments generated by this Recommendation.
    """
    HIGH = "High"
    MEDIUM = "Medium"
    LOW = "Low"


@pulumi.type_token("azure-native:security:Source")
class Source(builtins.str, Enum):
    """
    The platform where the assessed resource resides
    """
    AZURE = "Azure"
    """
    Resource is in Azure
    """
    ON_PREMISE = "OnPremise"
    """
    Resource in an on premise machine connected to Azure cloud
    """
    ON_PREMISE_SQL = "OnPremiseSql"
    """
    SQL Resource in an on premise machine connected to Azure cloud
    """


@pulumi.type_token("azure-native:security:SourceType")
class SourceType(builtins.str, Enum):
    """
    The source type that will trigger the notification
    """
    ALERT = "Alert"
    ATTACK_PATH = "AttackPath"


@pulumi.type_token("azure-native:security:StandardSupportedCloud")
class StandardSupportedCloud(builtins.str, Enum):
    """
    The cloud that the standard is supported on.
    """
    AZURE = "Azure"
    AWS = "AWS"
    GCP = "GCP"


@pulumi.type_token("azure-native:security:StandardSupportedClouds")
class StandardSupportedClouds(builtins.str, Enum):
    """
    The cloud that the standard is supported on.
    """
    AWS = "AWS"
    GCP = "GCP"


@pulumi.type_token("azure-native:security:State")
class State(builtins.str, Enum):
    """
    Defines whether to send email notifications from AMicrosoft Defender for Cloud to persons with specific RBAC roles on the subscription.
    """
    ON = "On"
    """
    Send notification on new alerts to the subscription's admins
    """
    OFF = "Off"
    """
    Don't send notification on new alerts to the subscription's admins
    """


@pulumi.type_token("azure-native:security:Status")
class Status(builtins.str, Enum):
    """
    The status of the port
    """
    REVOKED = "Revoked"
    INITIATED = "Initiated"


@pulumi.type_token("azure-native:security:StatusReason")
class StatusReason(builtins.str, Enum):
    """
    A description of why the `status` has its value
    """
    EXPIRED = "Expired"
    USER_REQUESTED = "UserRequested"
    NEWER_REQUEST_INITIATED = "NewerRequestInitiated"


@pulumi.type_token("azure-native:security:SubPlan")
class SubPlan(builtins.str, Enum):
    """
    The available sub plans
    """
    P1 = "P1"
    P2 = "P2"


@pulumi.type_token("azure-native:security:SupportedCloudEnum")
class SupportedCloudEnum(builtins.str, Enum):
    """
    Relevant cloud for the custom assessment automation.
    """
    AWS = "AWS"
    GCP = "GCP"


@pulumi.type_token("azure-native:security:Tactics")
class Tactics(builtins.str, Enum):
    """
    Tactic of the assessment
    """
    RECONNAISSANCE = "Reconnaissance"
    RESOURCE_DEVELOPMENT = "Resource Development"
    INITIAL_ACCESS = "Initial Access"
    EXECUTION = "Execution"
    PERSISTENCE = "Persistence"
    PRIVILEGE_ESCALATION = "Privilege Escalation"
    DEFENSE_EVASION = "Defense Evasion"
    CREDENTIAL_ACCESS = "Credential Access"
    DISCOVERY = "Discovery"
    LATERAL_MOVEMENT = "Lateral Movement"
    COLLECTION = "Collection"
    COMMAND_AND_CONTROL = "Command and Control"
    EXFILTRATION = "Exfiltration"
    IMPACT = "Impact"


@pulumi.type_token("azure-native:security:Techniques")
class Techniques(builtins.str, Enum):
    """
    Techniques of the assessment
    """
    ABUSE_ELEVATION_CONTROL_MECHANISM = "Abuse Elevation Control Mechanism"
    ACCESS_TOKEN_MANIPULATION = "Access Token Manipulation"
    ACCOUNT_DISCOVERY = "Account Discovery"
    ACCOUNT_MANIPULATION = "Account Manipulation"
    ACTIVE_SCANNING = "Active Scanning"
    APPLICATION_LAYER_PROTOCOL = "Application Layer Protocol"
    AUDIO_CAPTURE = "Audio Capture"
    BOOT_OR_LOGON_AUTOSTART_EXECUTION = "Boot or Logon Autostart Execution"
    BOOT_OR_LOGON_INITIALIZATION_SCRIPTS = "Boot or Logon Initialization Scripts"
    BRUTE_FORCE = "Brute Force"
    CLOUD_INFRASTRUCTURE_DISCOVERY = "Cloud Infrastructure Discovery"
    CLOUD_SERVICE_DASHBOARD = "Cloud Service Dashboard"
    CLOUD_SERVICE_DISCOVERY = "Cloud Service Discovery"
    COMMAND_AND_SCRIPTING_INTERPRETER = "Command and Scripting Interpreter"
    COMPROMISE_CLIENT_SOFTWARE_BINARY = "Compromise Client Software Binary"
    COMPROMISE_INFRASTRUCTURE = "Compromise Infrastructure"
    CONTAINER_AND_RESOURCE_DISCOVERY = "Container and Resource Discovery"
    CREATE_ACCOUNT = "Create Account"
    CREATE_OR_MODIFY_SYSTEM_PROCESS = "Create or Modify System Process"
    CREDENTIALS_FROM_PASSWORD_STORES = "Credentials from Password Stores"
    DATA_DESTRUCTION = "Data Destruction"
    DATA_ENCRYPTED_FOR_IMPACT = "Data Encrypted for Impact"
    DATA_FROM_CLOUD_STORAGE_OBJECT = "Data from Cloud Storage Object"
    DATA_FROM_CONFIGURATION_REPOSITORY = "Data from Configuration Repository"
    DATA_FROM_INFORMATION_REPOSITORIES = "Data from Information Repositories"
    DATA_FROM_LOCAL_SYSTEM = "Data from Local System"
    DATA_MANIPULATION = "Data Manipulation"
    DATA_STAGED = "Data Staged"
    DEFACEMENT = "Defacement"
    DEOBFUSCATE_DECODE_FILES_OR_INFORMATION = "Deobfuscate/Decode Files or Information"
    DISK_WIPE = "Disk Wipe"
    DOMAIN_TRUST_DISCOVERY = "Domain Trust Discovery"
    DRIVE_BY_COMPROMISE = "Drive-by Compromise"
    DYNAMIC_RESOLUTION = "Dynamic Resolution"
    ENDPOINT_DENIAL_OF_SERVICE = "Endpoint Denial of Service"
    EVENT_TRIGGERED_EXECUTION = "Event Triggered Execution"
    EXFILTRATION_OVER_ALTERNATIVE_PROTOCOL = "Exfiltration Over Alternative Protocol"
    EXPLOIT_PUBLIC_FACING_APPLICATION = "Exploit Public-Facing Application"
    EXPLOITATION_FOR_CLIENT_EXECUTION = "Exploitation for Client Execution"
    EXPLOITATION_FOR_CREDENTIAL_ACCESS = "Exploitation for Credential Access"
    EXPLOITATION_FOR_DEFENSE_EVASION = "Exploitation for Defense Evasion"
    EXPLOITATION_FOR_PRIVILEGE_ESCALATION = "Exploitation for Privilege Escalation"
    EXPLOITATION_OF_REMOTE_SERVICES = "Exploitation of Remote Services"
    EXTERNAL_REMOTE_SERVICES = "External Remote Services"
    FALLBACK_CHANNELS = "Fallback Channels"
    FILE_AND_DIRECTORY_DISCOVERY = "File and Directory Discovery"
    GATHER_VICTIM_NETWORK_INFORMATION = "Gather Victim Network Information"
    HIDE_ARTIFACTS = "Hide Artifacts"
    HIJACK_EXECUTION_FLOW = "Hijack Execution Flow"
    IMPAIR_DEFENSES = "Impair Defenses"
    IMPLANT_CONTAINER_IMAGE = "Implant Container Image"
    INDICATOR_REMOVAL_ON_HOST = "Indicator Removal on Host"
    INDIRECT_COMMAND_EXECUTION = "Indirect Command Execution"
    INGRESS_TOOL_TRANSFER = "Ingress Tool Transfer"
    INPUT_CAPTURE = "Input Capture"
    INTER_PROCESS_COMMUNICATION = "Inter-Process Communication"
    LATERAL_TOOL_TRANSFER = "Lateral Tool Transfer"
    MAN_IN_THE_MIDDLE = "Man-in-the-Middle"
    MASQUERADING = "Masquerading"
    MODIFY_AUTHENTICATION_PROCESS = "Modify Authentication Process"
    MODIFY_REGISTRY = "Modify Registry"
    NETWORK_DENIAL_OF_SERVICE = "Network Denial of Service"
    NETWORK_SERVICE_SCANNING = "Network Service Scanning"
    NETWORK_SNIFFING = "Network Sniffing"
    NON_APPLICATION_LAYER_PROTOCOL = "Non-Application Layer Protocol"
    NON_STANDARD_PORT = "Non-Standard Port"
    OBTAIN_CAPABILITIES = "Obtain Capabilities"
    OBFUSCATED_FILES_OR_INFORMATION = "Obfuscated Files or Information"
    OFFICE_APPLICATION_STARTUP = "Office Application Startup"
    O_S_CREDENTIAL_DUMPING = "OS Credential Dumping"
    PERMISSION_GROUPS_DISCOVERY = "Permission Groups Discovery"
    PHISHING = "Phishing"
    PRE_O_S_BOOT = "Pre-OS Boot"
    PROCESS_DISCOVERY = "Process Discovery"
    PROCESS_INJECTION = "Process Injection"
    PROTOCOL_TUNNELING = "Protocol Tunneling"
    PROXY = "Proxy"
    QUERY_REGISTRY = "Query Registry"
    REMOTE_ACCESS_SOFTWARE = "Remote Access Software"
    REMOTE_SERVICE_SESSION_HIJACKING = "Remote Service Session Hijacking"
    REMOTE_SERVICES = "Remote Services"
    REMOTE_SYSTEM_DISCOVERY = "Remote System Discovery"
    RESOURCE_HIJACKING = "Resource Hijacking"
    SCHEDULED_TASK_JOB = "Scheduled Task/Job"
    SCREEN_CAPTURE = "Screen Capture"
    SEARCH_VICTIM_OWNED_WEBSITES = "Search Victim-Owned Websites"
    SERVER_SOFTWARE_COMPONENT = "Server Software Component"
    SERVICE_STOP = "Service Stop"
    SIGNED_BINARY_PROXY_EXECUTION = "Signed Binary Proxy Execution"
    SOFTWARE_DEPLOYMENT_TOOLS = "Software Deployment Tools"
    SQ_L_STORED_PROCEDURES = "SQL Stored Procedures"
    STEAL_OR_FORGE_KERBEROS_TICKETS = "Steal or Forge Kerberos Tickets"
    SUBVERT_TRUST_CONTROLS = "Subvert Trust Controls"
    SUPPLY_CHAIN_COMPROMISE = "Supply Chain Compromise"
    SYSTEM_INFORMATION_DISCOVERY = "System Information Discovery"
    TAINT_SHARED_CONTENT = "Taint Shared Content"
    TRAFFIC_SIGNALING = "Traffic Signaling"
    TRANSFER_DATA_TO_CLOUD_ACCOUNT = "Transfer Data to Cloud Account"
    TRUSTED_RELATIONSHIP = "Trusted Relationship"
    UNSECURED_CREDENTIALS = "Unsecured Credentials"
    USER_EXECUTION = "User Execution"
    VALID_ACCOUNTS = "Valid Accounts"
    WINDOWS_MANAGEMENT_INSTRUMENTATION = "Windows Management Instrumentation"
    FILE_AND_DIRECTORY_PERMISSIONS_MODIFICATION = "File and Directory Permissions Modification"


@pulumi.type_token("azure-native:security:Threats")
class Threats(builtins.str, Enum):
    """
    Threats impact of the assessment
    """
    ACCOUNT_BREACH = "accountBreach"
    DATA_EXFILTRATION = "dataExfiltration"
    DATA_SPILLAGE = "dataSpillage"
    MALICIOUS_INSIDER = "maliciousInsider"
    ELEVATION_OF_PRIVILEGE = "elevationOfPrivilege"
    THREAT_RESISTANCE = "threatResistance"
    MISSING_COVERAGE = "missingCoverage"
    DENIAL_OF_SERVICE = "denialOfService"


@pulumi.type_token("azure-native:security:Type")
class Type(builtins.str, Enum):
    """
    The Vulnerability Assessment solution to be provisioned. Can be either 'TVM' or 'Qualys'
    """
    QUALYS = "Qualys"
    TVM = "TVM"


@pulumi.type_token("azure-native:security:UnmaskedIpLoggingStatus")
class UnmaskedIpLoggingStatus(builtins.str, Enum):
    """
    Unmasked IP address logging status
    """
    DISABLED = "Disabled"
    """
    Unmasked IP logging is disabled
    """
    ENABLED = "Enabled"
    """
    Unmasked IP logging is enabled
    """


@pulumi.type_token("azure-native:security:UserImpact")
class UserImpact(builtins.str, Enum):
    """
    The user impact of the assessment
    """
    LOW = "Low"
    MODERATE = "Moderate"
    HIGH = "High"
