# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListWhoisByDomainResult',
    'AwaitableListWhoisByDomainResult',
    'list_whois_by_domain',
    'list_whois_by_domain_output',
]

@pulumi.output_type
class ListWhoisByDomainResult:
    """
    Whois information for a given domain and associated metadata
    """
    def __init__(__self__, created=None, domain=None, expires=None, parsed_whois=None, server=None, updated=None):
        if created and not isinstance(created, str):
            raise TypeError("Expected argument 'created' to be a str")
        pulumi.set(__self__, "created", created)
        if domain and not isinstance(domain, str):
            raise TypeError("Expected argument 'domain' to be a str")
        pulumi.set(__self__, "domain", domain)
        if expires and not isinstance(expires, str):
            raise TypeError("Expected argument 'expires' to be a str")
        pulumi.set(__self__, "expires", expires)
        if parsed_whois and not isinstance(parsed_whois, dict):
            raise TypeError("Expected argument 'parsed_whois' to be a dict")
        pulumi.set(__self__, "parsed_whois", parsed_whois)
        if server and not isinstance(server, str):
            raise TypeError("Expected argument 'server' to be a str")
        pulumi.set(__self__, "server", server)
        if updated and not isinstance(updated, str):
            raise TypeError("Expected argument 'updated' to be a str")
        pulumi.set(__self__, "updated", updated)

    @property
    @pulumi.getter
    def created(self) -> Optional[builtins.str]:
        """
        The timestamp at which this record was created
        """
        return pulumi.get(self, "created")

    @property
    @pulumi.getter
    def domain(self) -> Optional[builtins.str]:
        """
        The domain for this whois record
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter
    def expires(self) -> Optional[builtins.str]:
        """
        The timestamp at which this record will expire
        """
        return pulumi.get(self, "expires")

    @property
    @pulumi.getter(name="parsedWhois")
    def parsed_whois(self) -> Optional['outputs.EnrichmentDomainWhoisDetailsResponse']:
        """
        The whois record for a given domain
        """
        return pulumi.get(self, "parsed_whois")

    @property
    @pulumi.getter
    def server(self) -> Optional[builtins.str]:
        """
        The hostname of this registrar's whois server
        """
        return pulumi.get(self, "server")

    @property
    @pulumi.getter
    def updated(self) -> Optional[builtins.str]:
        """
        The timestamp at which this record was last updated
        """
        return pulumi.get(self, "updated")


class AwaitableListWhoisByDomainResult(ListWhoisByDomainResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListWhoisByDomainResult(
            created=self.created,
            domain=self.domain,
            expires=self.expires,
            parsed_whois=self.parsed_whois,
            server=self.server,
            updated=self.updated)


def list_whois_by_domain(domain: Optional[builtins.str] = None,
                         enrichment_type: Optional[builtins.str] = None,
                         resource_group_name: Optional[builtins.str] = None,
                         workspace_name: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListWhoisByDomainResult:
    """
    Get whois information for a single domain name

    Uses Azure REST API version 2025-01-01-preview.

    Other available API versions: 2024-01-01-preview, 2024-04-01-preview, 2024-10-01-preview, 2025-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native securityinsights [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str domain: The domain name
    :param builtins.str enrichment_type: Enrichment type
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str workspace_name: The name of the workspace.
    """
    __args__ = dict()
    __args__['domain'] = domain
    __args__['enrichmentType'] = enrichment_type
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:securityinsights:listWhoisByDomain', __args__, opts=opts, typ=ListWhoisByDomainResult).value

    return AwaitableListWhoisByDomainResult(
        created=pulumi.get(__ret__, 'created'),
        domain=pulumi.get(__ret__, 'domain'),
        expires=pulumi.get(__ret__, 'expires'),
        parsed_whois=pulumi.get(__ret__, 'parsed_whois'),
        server=pulumi.get(__ret__, 'server'),
        updated=pulumi.get(__ret__, 'updated'))
def list_whois_by_domain_output(domain: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                enrichment_type: Optional[pulumi.Input[builtins.str]] = None,
                                resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListWhoisByDomainResult]:
    """
    Get whois information for a single domain name

    Uses Azure REST API version 2025-01-01-preview.

    Other available API versions: 2024-01-01-preview, 2024-04-01-preview, 2024-10-01-preview, 2025-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native securityinsights [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str domain: The domain name
    :param builtins.str enrichment_type: Enrichment type
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str workspace_name: The name of the workspace.
    """
    __args__ = dict()
    __args__['domain'] = domain
    __args__['enrichmentType'] = enrichment_type
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:securityinsights:listWhoisByDomain', __args__, opts=opts, typ=ListWhoisByDomainResult)
    return __ret__.apply(lambda __response__: ListWhoisByDomainResult(
        created=pulumi.get(__response__, 'created'),
        domain=pulumi.get(__response__, 'domain'),
        expires=pulumi.get(__response__, 'expires'),
        parsed_whois=pulumi.get(__response__, 'parsed_whois'),
        server=pulumi.get(__response__, 'server'),
        updated=pulumi.get(__response__, 'updated')))
