# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['MDATPDataConnectorArgs', 'MDATPDataConnector']

@pulumi.input_type
class MDATPDataConnectorArgs:
    def __init__(__self__, *,
                 kind: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 workspace_name: pulumi.Input[builtins.str],
                 data_connector_id: Optional[pulumi.Input[builtins.str]] = None,
                 data_types: Optional[pulumi.Input['AlertsDataTypeOfDataConnectorArgs']] = None,
                 tenant_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a MDATPDataConnector resource.
        :param pulumi.Input[builtins.str] kind: The kind of the data connector
               Expected value is 'MicrosoftDefenderAdvancedThreatProtection'.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] workspace_name: The name of the workspace.
        :param pulumi.Input[builtins.str] data_connector_id: Connector ID
        :param pulumi.Input['AlertsDataTypeOfDataConnectorArgs'] data_types: The available data types for the connector.
        :param pulumi.Input[builtins.str] tenant_id: The tenant id to connect to, and get the data from.
        """
        pulumi.set(__self__, "kind", 'MicrosoftDefenderAdvancedThreatProtection')
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "workspace_name", workspace_name)
        if data_connector_id is not None:
            pulumi.set(__self__, "data_connector_id", data_connector_id)
        if data_types is not None:
            pulumi.set(__self__, "data_types", data_types)
        if tenant_id is not None:
            pulumi.set(__self__, "tenant_id", tenant_id)

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Input[builtins.str]:
        """
        The kind of the data connector
        Expected value is 'MicrosoftDefenderAdvancedThreatProtection'.
        """
        return pulumi.get(self, "kind")

    @kind.setter
    def kind(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "kind", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="workspaceName")
    def workspace_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the workspace.
        """
        return pulumi.get(self, "workspace_name")

    @workspace_name.setter
    def workspace_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "workspace_name", value)

    @property
    @pulumi.getter(name="dataConnectorId")
    def data_connector_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Connector ID
        """
        return pulumi.get(self, "data_connector_id")

    @data_connector_id.setter
    def data_connector_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "data_connector_id", value)

    @property
    @pulumi.getter(name="dataTypes")
    def data_types(self) -> Optional[pulumi.Input['AlertsDataTypeOfDataConnectorArgs']]:
        """
        The available data types for the connector.
        """
        return pulumi.get(self, "data_types")

    @data_types.setter
    def data_types(self, value: Optional[pulumi.Input['AlertsDataTypeOfDataConnectorArgs']]):
        pulumi.set(self, "data_types", value)

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The tenant id to connect to, and get the data from.
        """
        return pulumi.get(self, "tenant_id")

    @tenant_id.setter
    def tenant_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "tenant_id", value)


@pulumi.type_token("azure-native:securityinsights:MDATPDataConnector")
class MDATPDataConnector(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 data_connector_id: Optional[pulumi.Input[builtins.str]] = None,
                 data_types: Optional[pulumi.Input[Union['AlertsDataTypeOfDataConnectorArgs', 'AlertsDataTypeOfDataConnectorArgsDict']]] = None,
                 kind: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 tenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Represents MDATP (Microsoft Defender Advanced Threat Protection) data connector.

        Uses Azure REST API version 2024-09-01. In version 2.x of the Azure Native provider, it used API version 2023-02-01.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] data_connector_id: Connector ID
        :param pulumi.Input[Union['AlertsDataTypeOfDataConnectorArgs', 'AlertsDataTypeOfDataConnectorArgsDict']] data_types: The available data types for the connector.
        :param pulumi.Input[builtins.str] kind: The kind of the data connector
               Expected value is 'MicrosoftDefenderAdvancedThreatProtection'.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] tenant_id: The tenant id to connect to, and get the data from.
        :param pulumi.Input[builtins.str] workspace_name: The name of the workspace.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MDATPDataConnectorArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Represents MDATP (Microsoft Defender Advanced Threat Protection) data connector.

        Uses Azure REST API version 2024-09-01. In version 2.x of the Azure Native provider, it used API version 2023-02-01.

        :param str resource_name: The name of the resource.
        :param MDATPDataConnectorArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MDATPDataConnectorArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 data_connector_id: Optional[pulumi.Input[builtins.str]] = None,
                 data_types: Optional[pulumi.Input[Union['AlertsDataTypeOfDataConnectorArgs', 'AlertsDataTypeOfDataConnectorArgsDict']]] = None,
                 kind: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 tenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MDATPDataConnectorArgs.__new__(MDATPDataConnectorArgs)

            __props__.__dict__["data_connector_id"] = data_connector_id
            __props__.__dict__["data_types"] = data_types
            if kind is None and not opts.urn:
                raise TypeError("Missing required property 'kind'")
            __props__.__dict__["kind"] = 'MicrosoftDefenderAdvancedThreatProtection'
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["tenant_id"] = tenant_id
            if workspace_name is None and not opts.urn:
                raise TypeError("Missing required property 'workspace_name'")
            __props__.__dict__["workspace_name"] = workspace_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["etag"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:securityinsights/v20190101preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20200101:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210901preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20211001:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20211001preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220101preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220401preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220501preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220601preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220701preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220801:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220801preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220901preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20221001preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20221101:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20221101preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20221201preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230301preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230401preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230501preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:PremiumMicrosoftDefenderForThreatIntelligence"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:PurviewAuditDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20250101preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20250301:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20250401preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:TIDataConnector")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(MDATPDataConnector, __self__).__init__(
            'azure-native:securityinsights:MDATPDataConnector',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'MDATPDataConnector':
        """
        Get an existing MDATPDataConnector resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = MDATPDataConnectorArgs.__new__(MDATPDataConnectorArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["data_types"] = None
        __props__.__dict__["etag"] = None
        __props__.__dict__["kind"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tenant_id"] = None
        __props__.__dict__["type"] = None
        return MDATPDataConnector(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="dataTypes")
    def data_types(self) -> pulumi.Output[Optional['outputs.AlertsDataTypeOfDataConnectorResponse']]:
        """
        The available data types for the connector.
        """
        return pulumi.get(self, "data_types")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Etag of the azure resource
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Output[builtins.str]:
        """
        The kind of the data connector
        Expected value is 'MicrosoftDefenderAdvancedThreatProtection'.
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The tenant id to connect to, and get the data from.
        """
        return pulumi.get(self, "tenant_id")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

