# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['RestApiPollerDataConnectorArgs', 'RestApiPollerDataConnector']

@pulumi.input_type
class RestApiPollerDataConnectorArgs:
    def __init__(__self__, *,
                 auth: pulumi.Input[Union['AWSAuthModelArgs', 'ApiKeyAuthModelArgs', 'BasicAuthModelArgs', 'GCPAuthModelArgs', 'GenericBlobSbsAuthModelArgs', 'GitHubAuthModelArgs', 'JwtAuthModelArgs', 'NoneAuthModelArgs', 'OAuthModelArgs', 'OracleAuthModelArgs', 'SessionAuthModelArgs']],
                 connector_definition_name: pulumi.Input[builtins.str],
                 kind: pulumi.Input[builtins.str],
                 request: pulumi.Input['RestApiPollerRequestConfigArgs'],
                 resource_group_name: pulumi.Input[builtins.str],
                 workspace_name: pulumi.Input[builtins.str],
                 add_on_attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 data_connector_id: Optional[pulumi.Input[builtins.str]] = None,
                 data_type: Optional[pulumi.Input[builtins.str]] = None,
                 dcr_config: Optional[pulumi.Input['DCRConfigurationArgs']] = None,
                 is_active: Optional[pulumi.Input[builtins.bool]] = None,
                 paging: Optional[pulumi.Input['RestApiPollerRequestPagingConfigArgs']] = None,
                 response: Optional[pulumi.Input['CcpResponseConfigArgs']] = None):
        """
        The set of arguments for constructing a RestApiPollerDataConnector resource.
        :param pulumi.Input[Union['AWSAuthModelArgs', 'ApiKeyAuthModelArgs', 'BasicAuthModelArgs', 'GCPAuthModelArgs', 'GenericBlobSbsAuthModelArgs', 'GitHubAuthModelArgs', 'JwtAuthModelArgs', 'NoneAuthModelArgs', 'OAuthModelArgs', 'OracleAuthModelArgs', 'SessionAuthModelArgs']] auth: The a authentication model.
        :param pulumi.Input[builtins.str] connector_definition_name: The connector definition name (the dataConnectorDefinition resource id).
        :param pulumi.Input[builtins.str] kind: The kind of the data connector
               Expected value is 'RestApiPoller'.
        :param pulumi.Input['RestApiPollerRequestConfigArgs'] request: The request configuration.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] workspace_name: The name of the workspace.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] add_on_attributes: The add on attributes. The key name will become attribute name (a column) and the value will become the attribute value in the payload.
        :param pulumi.Input[builtins.str] data_connector_id: Connector ID
        :param pulumi.Input[builtins.str] data_type: The Log Analytics table destination.
        :param pulumi.Input['DCRConfigurationArgs'] dcr_config: The DCR related properties.
        :param pulumi.Input[builtins.bool] is_active: Indicates whether the connector is active or not.
        :param pulumi.Input['RestApiPollerRequestPagingConfigArgs'] paging: The paging configuration.
        :param pulumi.Input['CcpResponseConfigArgs'] response: The response configuration.
        """
        pulumi.set(__self__, "auth", auth)
        pulumi.set(__self__, "connector_definition_name", connector_definition_name)
        pulumi.set(__self__, "kind", 'RestApiPoller')
        pulumi.set(__self__, "request", request)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        pulumi.set(__self__, "workspace_name", workspace_name)
        if add_on_attributes is not None:
            pulumi.set(__self__, "add_on_attributes", add_on_attributes)
        if data_connector_id is not None:
            pulumi.set(__self__, "data_connector_id", data_connector_id)
        if data_type is not None:
            pulumi.set(__self__, "data_type", data_type)
        if dcr_config is not None:
            pulumi.set(__self__, "dcr_config", dcr_config)
        if is_active is not None:
            pulumi.set(__self__, "is_active", is_active)
        if paging is not None:
            pulumi.set(__self__, "paging", paging)
        if response is not None:
            pulumi.set(__self__, "response", response)

    @property
    @pulumi.getter
    def auth(self) -> pulumi.Input[Union['AWSAuthModelArgs', 'ApiKeyAuthModelArgs', 'BasicAuthModelArgs', 'GCPAuthModelArgs', 'GenericBlobSbsAuthModelArgs', 'GitHubAuthModelArgs', 'JwtAuthModelArgs', 'NoneAuthModelArgs', 'OAuthModelArgs', 'OracleAuthModelArgs', 'SessionAuthModelArgs']]:
        """
        The a authentication model.
        """
        return pulumi.get(self, "auth")

    @auth.setter
    def auth(self, value: pulumi.Input[Union['AWSAuthModelArgs', 'ApiKeyAuthModelArgs', 'BasicAuthModelArgs', 'GCPAuthModelArgs', 'GenericBlobSbsAuthModelArgs', 'GitHubAuthModelArgs', 'JwtAuthModelArgs', 'NoneAuthModelArgs', 'OAuthModelArgs', 'OracleAuthModelArgs', 'SessionAuthModelArgs']]):
        pulumi.set(self, "auth", value)

    @property
    @pulumi.getter(name="connectorDefinitionName")
    def connector_definition_name(self) -> pulumi.Input[builtins.str]:
        """
        The connector definition name (the dataConnectorDefinition resource id).
        """
        return pulumi.get(self, "connector_definition_name")

    @connector_definition_name.setter
    def connector_definition_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "connector_definition_name", value)

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Input[builtins.str]:
        """
        The kind of the data connector
        Expected value is 'RestApiPoller'.
        """
        return pulumi.get(self, "kind")

    @kind.setter
    def kind(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "kind", value)

    @property
    @pulumi.getter
    def request(self) -> pulumi.Input['RestApiPollerRequestConfigArgs']:
        """
        The request configuration.
        """
        return pulumi.get(self, "request")

    @request.setter
    def request(self, value: pulumi.Input['RestApiPollerRequestConfigArgs']):
        pulumi.set(self, "request", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="workspaceName")
    def workspace_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the workspace.
        """
        return pulumi.get(self, "workspace_name")

    @workspace_name.setter
    def workspace_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "workspace_name", value)

    @property
    @pulumi.getter(name="addOnAttributes")
    def add_on_attributes(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        The add on attributes. The key name will become attribute name (a column) and the value will become the attribute value in the payload.
        """
        return pulumi.get(self, "add_on_attributes")

    @add_on_attributes.setter
    def add_on_attributes(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "add_on_attributes", value)

    @property
    @pulumi.getter(name="dataConnectorId")
    def data_connector_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Connector ID
        """
        return pulumi.get(self, "data_connector_id")

    @data_connector_id.setter
    def data_connector_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "data_connector_id", value)

    @property
    @pulumi.getter(name="dataType")
    def data_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The Log Analytics table destination.
        """
        return pulumi.get(self, "data_type")

    @data_type.setter
    def data_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "data_type", value)

    @property
    @pulumi.getter(name="dcrConfig")
    def dcr_config(self) -> Optional[pulumi.Input['DCRConfigurationArgs']]:
        """
        The DCR related properties.
        """
        return pulumi.get(self, "dcr_config")

    @dcr_config.setter
    def dcr_config(self, value: Optional[pulumi.Input['DCRConfigurationArgs']]):
        pulumi.set(self, "dcr_config", value)

    @property
    @pulumi.getter(name="isActive")
    def is_active(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Indicates whether the connector is active or not.
        """
        return pulumi.get(self, "is_active")

    @is_active.setter
    def is_active(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_active", value)

    @property
    @pulumi.getter
    def paging(self) -> Optional[pulumi.Input['RestApiPollerRequestPagingConfigArgs']]:
        """
        The paging configuration.
        """
        return pulumi.get(self, "paging")

    @paging.setter
    def paging(self, value: Optional[pulumi.Input['RestApiPollerRequestPagingConfigArgs']]):
        pulumi.set(self, "paging", value)

    @property
    @pulumi.getter
    def response(self) -> Optional[pulumi.Input['CcpResponseConfigArgs']]:
        """
        The response configuration.
        """
        return pulumi.get(self, "response")

    @response.setter
    def response(self, value: Optional[pulumi.Input['CcpResponseConfigArgs']]):
        pulumi.set(self, "response", value)


@pulumi.type_token("azure-native:securityinsights:RestApiPollerDataConnector")
class RestApiPollerDataConnector(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 add_on_attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 auth: Optional[pulumi.Input[Union[Union['AWSAuthModelArgs', 'AWSAuthModelArgsDict'], Union['ApiKeyAuthModelArgs', 'ApiKeyAuthModelArgsDict'], Union['BasicAuthModelArgs', 'BasicAuthModelArgsDict'], Union['GCPAuthModelArgs', 'GCPAuthModelArgsDict'], Union['GenericBlobSbsAuthModelArgs', 'GenericBlobSbsAuthModelArgsDict'], Union['GitHubAuthModelArgs', 'GitHubAuthModelArgsDict'], Union['JwtAuthModelArgs', 'JwtAuthModelArgsDict'], Union['NoneAuthModelArgs', 'NoneAuthModelArgsDict'], Union['OAuthModelArgs', 'OAuthModelArgsDict'], Union['OracleAuthModelArgs', 'OracleAuthModelArgsDict'], Union['SessionAuthModelArgs', 'SessionAuthModelArgsDict']]]] = None,
                 connector_definition_name: Optional[pulumi.Input[builtins.str]] = None,
                 data_connector_id: Optional[pulumi.Input[builtins.str]] = None,
                 data_type: Optional[pulumi.Input[builtins.str]] = None,
                 dcr_config: Optional[pulumi.Input[Union['DCRConfigurationArgs', 'DCRConfigurationArgsDict']]] = None,
                 is_active: Optional[pulumi.Input[builtins.bool]] = None,
                 kind: Optional[pulumi.Input[builtins.str]] = None,
                 paging: Optional[pulumi.Input[Union['RestApiPollerRequestPagingConfigArgs', 'RestApiPollerRequestPagingConfigArgsDict']]] = None,
                 request: Optional[pulumi.Input[Union['RestApiPollerRequestConfigArgs', 'RestApiPollerRequestConfigArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 response: Optional[pulumi.Input[Union['CcpResponseConfigArgs', 'CcpResponseConfigArgsDict']]] = None,
                 workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Represents Rest Api Poller data connector.

        Uses Azure REST API version 2024-09-01. In version 2.x of the Azure Native provider, it used API version 2023-02-01.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] add_on_attributes: The add on attributes. The key name will become attribute name (a column) and the value will become the attribute value in the payload.
        :param pulumi.Input[Union[Union['AWSAuthModelArgs', 'AWSAuthModelArgsDict'], Union['ApiKeyAuthModelArgs', 'ApiKeyAuthModelArgsDict'], Union['BasicAuthModelArgs', 'BasicAuthModelArgsDict'], Union['GCPAuthModelArgs', 'GCPAuthModelArgsDict'], Union['GenericBlobSbsAuthModelArgs', 'GenericBlobSbsAuthModelArgsDict'], Union['GitHubAuthModelArgs', 'GitHubAuthModelArgsDict'], Union['JwtAuthModelArgs', 'JwtAuthModelArgsDict'], Union['NoneAuthModelArgs', 'NoneAuthModelArgsDict'], Union['OAuthModelArgs', 'OAuthModelArgsDict'], Union['OracleAuthModelArgs', 'OracleAuthModelArgsDict'], Union['SessionAuthModelArgs', 'SessionAuthModelArgsDict']]] auth: The a authentication model.
        :param pulumi.Input[builtins.str] connector_definition_name: The connector definition name (the dataConnectorDefinition resource id).
        :param pulumi.Input[builtins.str] data_connector_id: Connector ID
        :param pulumi.Input[builtins.str] data_type: The Log Analytics table destination.
        :param pulumi.Input[Union['DCRConfigurationArgs', 'DCRConfigurationArgsDict']] dcr_config: The DCR related properties.
        :param pulumi.Input[builtins.bool] is_active: Indicates whether the connector is active or not.
        :param pulumi.Input[builtins.str] kind: The kind of the data connector
               Expected value is 'RestApiPoller'.
        :param pulumi.Input[Union['RestApiPollerRequestPagingConfigArgs', 'RestApiPollerRequestPagingConfigArgsDict']] paging: The paging configuration.
        :param pulumi.Input[Union['RestApiPollerRequestConfigArgs', 'RestApiPollerRequestConfigArgsDict']] request: The request configuration.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[Union['CcpResponseConfigArgs', 'CcpResponseConfigArgsDict']] response: The response configuration.
        :param pulumi.Input[builtins.str] workspace_name: The name of the workspace.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RestApiPollerDataConnectorArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Represents Rest Api Poller data connector.

        Uses Azure REST API version 2024-09-01. In version 2.x of the Azure Native provider, it used API version 2023-02-01.

        :param str resource_name: The name of the resource.
        :param RestApiPollerDataConnectorArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RestApiPollerDataConnectorArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 add_on_attributes: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 auth: Optional[pulumi.Input[Union[Union['AWSAuthModelArgs', 'AWSAuthModelArgsDict'], Union['ApiKeyAuthModelArgs', 'ApiKeyAuthModelArgsDict'], Union['BasicAuthModelArgs', 'BasicAuthModelArgsDict'], Union['GCPAuthModelArgs', 'GCPAuthModelArgsDict'], Union['GenericBlobSbsAuthModelArgs', 'GenericBlobSbsAuthModelArgsDict'], Union['GitHubAuthModelArgs', 'GitHubAuthModelArgsDict'], Union['JwtAuthModelArgs', 'JwtAuthModelArgsDict'], Union['NoneAuthModelArgs', 'NoneAuthModelArgsDict'], Union['OAuthModelArgs', 'OAuthModelArgsDict'], Union['OracleAuthModelArgs', 'OracleAuthModelArgsDict'], Union['SessionAuthModelArgs', 'SessionAuthModelArgsDict']]]] = None,
                 connector_definition_name: Optional[pulumi.Input[builtins.str]] = None,
                 data_connector_id: Optional[pulumi.Input[builtins.str]] = None,
                 data_type: Optional[pulumi.Input[builtins.str]] = None,
                 dcr_config: Optional[pulumi.Input[Union['DCRConfigurationArgs', 'DCRConfigurationArgsDict']]] = None,
                 is_active: Optional[pulumi.Input[builtins.bool]] = None,
                 kind: Optional[pulumi.Input[builtins.str]] = None,
                 paging: Optional[pulumi.Input[Union['RestApiPollerRequestPagingConfigArgs', 'RestApiPollerRequestPagingConfigArgsDict']]] = None,
                 request: Optional[pulumi.Input[Union['RestApiPollerRequestConfigArgs', 'RestApiPollerRequestConfigArgsDict']]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 response: Optional[pulumi.Input[Union['CcpResponseConfigArgs', 'CcpResponseConfigArgsDict']]] = None,
                 workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RestApiPollerDataConnectorArgs.__new__(RestApiPollerDataConnectorArgs)

            __props__.__dict__["add_on_attributes"] = add_on_attributes
            if auth is None and not opts.urn:
                raise TypeError("Missing required property 'auth'")
            __props__.__dict__["auth"] = auth
            if connector_definition_name is None and not opts.urn:
                raise TypeError("Missing required property 'connector_definition_name'")
            __props__.__dict__["connector_definition_name"] = connector_definition_name
            __props__.__dict__["data_connector_id"] = data_connector_id
            __props__.__dict__["data_type"] = data_type
            __props__.__dict__["dcr_config"] = dcr_config
            __props__.__dict__["is_active"] = is_active
            if kind is None and not opts.urn:
                raise TypeError("Missing required property 'kind'")
            __props__.__dict__["kind"] = 'RestApiPoller'
            __props__.__dict__["paging"] = paging
            if request is None and not opts.urn:
                raise TypeError("Missing required property 'request'")
            __props__.__dict__["request"] = request
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["response"] = response
            if workspace_name is None and not opts.urn:
                raise TypeError("Missing required property 'workspace_name'")
            __props__.__dict__["workspace_name"] = workspace_name
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["etag"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:securityinsights/v20190101preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20200101:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210301preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20210901preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20211001:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20211001preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220101preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220401preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220501preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220601preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220701preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220801:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220801preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20220901preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20221001preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20221101:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20221101preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20221201preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230201preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230301preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230401preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230501preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230601preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230701preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230801preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20230901preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231001preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231101:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20231201preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240101preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240301:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240401preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:PremiumMicrosoftDefenderForThreatIntelligence"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20240901:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:AwsS3DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:CodelessApiPollingDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:CodelessUiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:Dynamics365DataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:GCPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:IoTDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MSTIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MTPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:MicrosoftPurviewInformationProtectionDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:Office365ProjectDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:OfficeATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:OfficeIRMDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:OfficePowerBIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:PurviewAuditDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:TIDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20241001preview:TiTaxiiDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20250101preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20250301:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights/v20250401preview:RestApiPollerDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:AADDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:AATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:ASCDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:AwsCloudTrailDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:MCASDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:MDATPDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:OfficeDataConnector"), pulumi.Alias(type_="azure-native:securityinsights:TIDataConnector")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(RestApiPollerDataConnector, __self__).__init__(
            'azure-native:securityinsights:RestApiPollerDataConnector',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'RestApiPollerDataConnector':
        """
        Get an existing RestApiPollerDataConnector resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = RestApiPollerDataConnectorArgs.__new__(RestApiPollerDataConnectorArgs)

        __props__.__dict__["add_on_attributes"] = None
        __props__.__dict__["auth"] = None
        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["connector_definition_name"] = None
        __props__.__dict__["data_type"] = None
        __props__.__dict__["dcr_config"] = None
        __props__.__dict__["etag"] = None
        __props__.__dict__["is_active"] = None
        __props__.__dict__["kind"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["paging"] = None
        __props__.__dict__["request"] = None
        __props__.__dict__["response"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["type"] = None
        return RestApiPollerDataConnector(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="addOnAttributes")
    def add_on_attributes(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        The add on attributes. The key name will become attribute name (a column) and the value will become the attribute value in the payload.
        """
        return pulumi.get(self, "add_on_attributes")

    @property
    @pulumi.getter
    def auth(self) -> pulumi.Output[Any]:
        """
        The a authentication model.
        """
        return pulumi.get(self, "auth")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="connectorDefinitionName")
    def connector_definition_name(self) -> pulumi.Output[builtins.str]:
        """
        The connector definition name (the dataConnectorDefinition resource id).
        """
        return pulumi.get(self, "connector_definition_name")

    @property
    @pulumi.getter(name="dataType")
    def data_type(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The Log Analytics table destination.
        """
        return pulumi.get(self, "data_type")

    @property
    @pulumi.getter(name="dcrConfig")
    def dcr_config(self) -> pulumi.Output[Optional['outputs.DCRConfigurationResponse']]:
        """
        The DCR related properties.
        """
        return pulumi.get(self, "dcr_config")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Etag of the azure resource
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter(name="isActive")
    def is_active(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Indicates whether the connector is active or not.
        """
        return pulumi.get(self, "is_active")

    @property
    @pulumi.getter
    def kind(self) -> pulumi.Output[builtins.str]:
        """
        The kind of the data connector
        Expected value is 'RestApiPoller'.
        """
        return pulumi.get(self, "kind")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def paging(self) -> pulumi.Output[Optional['outputs.RestApiPollerRequestPagingConfigResponse']]:
        """
        The paging configuration.
        """
        return pulumi.get(self, "paging")

    @property
    @pulumi.getter
    def request(self) -> pulumi.Output['outputs.RestApiPollerRequestConfigResponse']:
        """
        The request configuration.
        """
        return pulumi.get(self, "request")

    @property
    @pulumi.getter
    def response(self) -> pulumi.Output[Optional['outputs.CcpResponseConfigResponse']]:
        """
        The response configuration.
        """
        return pulumi.get(self, "response")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

