# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AccessRights',
    'DefaultAction',
    'EndPointProvisioningState',
    'EntityStatus',
    'FilterType',
    'IPAction',
    'KeySource',
    'ManagedServiceIdentityType',
    'NetworkRuleIPAction',
    'PrivateLinkConnectionStatus',
    'PublicNetworkAccess',
    'PublicNetworkAccessFlag',
    'SkuName',
    'SkuTier',
    'TlsVersion',
]


@pulumi.type_token("azure-native:servicebus:AccessRights")
class AccessRights(builtins.str, Enum):
    MANAGE = "Manage"
    SEND = "Send"
    LISTEN = "Listen"


@pulumi.type_token("azure-native:servicebus:DefaultAction")
class DefaultAction(builtins.str, Enum):
    """
    Default Action for Network Rule Set
    """
    ALLOW = "Allow"
    DENY = "Deny"


@pulumi.type_token("azure-native:servicebus:EndPointProvisioningState")
class EndPointProvisioningState(builtins.str, Enum):
    """
    Provisioning state of the Private Endpoint Connection.
    """
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    SUCCEEDED = "Succeeded"
    CANCELED = "Canceled"
    FAILED = "Failed"


@pulumi.type_token("azure-native:servicebus:EntityStatus")
class EntityStatus(builtins.str, Enum):
    """
    Enumerates the possible values for the status of a messaging entity.
    """
    ACTIVE = "Active"
    DISABLED = "Disabled"
    RESTORING = "Restoring"
    SEND_DISABLED = "SendDisabled"
    RECEIVE_DISABLED = "ReceiveDisabled"
    CREATING = "Creating"
    DELETING = "Deleting"
    RENAMING = "Renaming"
    UNKNOWN = "Unknown"


@pulumi.type_token("azure-native:servicebus:FilterType")
class FilterType(builtins.str, Enum):
    """
    Filter type that is evaluated against a BrokeredMessage.
    """
    SQL_FILTER = "SqlFilter"
    CORRELATION_FILTER = "CorrelationFilter"


@pulumi.type_token("azure-native:servicebus:IPAction")
class IPAction(builtins.str, Enum):
    """
    The IP Filter Action
    """
    ACCEPT = "Accept"
    REJECT = "Reject"


@pulumi.type_token("azure-native:servicebus:KeySource")
class KeySource(builtins.str, Enum):
    """
    Enumerates the possible value of keySource for Encryption
    """
    MICROSOFT_KEY_VAULT = "Microsoft.KeyVault"


@pulumi.type_token("azure-native:servicebus:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:servicebus:NetworkRuleIPAction")
class NetworkRuleIPAction(builtins.str, Enum):
    """
    The IP Filter Action
    """
    ALLOW = "Allow"


@pulumi.type_token("azure-native:servicebus:PrivateLinkConnectionStatus")
class PrivateLinkConnectionStatus(builtins.str, Enum):
    """
    Status of the connection.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"
    DISCONNECTED = "Disconnected"


@pulumi.type_token("azure-native:servicebus:PublicNetworkAccess")
class PublicNetworkAccess(builtins.str, Enum):
    """
    This determines if traffic is allowed over public network. By default it is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"
    SECURED_BY_PERIMETER = "SecuredByPerimeter"


@pulumi.type_token("azure-native:servicebus:PublicNetworkAccessFlag")
class PublicNetworkAccessFlag(builtins.str, Enum):
    """
    This determines if traffic is allowed over public network. By default it is enabled.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


@pulumi.type_token("azure-native:servicebus:SkuName")
class SkuName(builtins.str, Enum):
    """
    Name of this SKU.
    """
    BASIC = "Basic"
    STANDARD = "Standard"
    PREMIUM = "Premium"


@pulumi.type_token("azure-native:servicebus:SkuTier")
class SkuTier(builtins.str, Enum):
    """
    The billing tier of this particular SKU.
    """
    BASIC = "Basic"
    STANDARD = "Standard"
    PREMIUM = "Premium"


@pulumi.type_token("azure-native:servicebus:TlsVersion")
class TlsVersion(builtins.str, Enum):
    """
    The minimum TLS version for the cluster to support, e.g. '1.2'
    """
    TLS_VERSION_1_0 = "1.0"
    TLS_VERSION_1_1 = "1.1"
    TLS_VERSION_1_2 = "1.2"
