# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetManagedAzResiliencyStatusResult',
    'AwaitableGetManagedAzResiliencyStatusResult',
    'get_managed_az_resiliency_status',
    'get_managed_az_resiliency_status_output',
]

@pulumi.output_type
class GetManagedAzResiliencyStatusResult:
    """
    Describes the result of the request to list Managed VM Sizes for Service Fabric Managed Clusters.
    """
    def __init__(__self__, base_resource_status=None, is_cluster_zone_resilient=None):
        if base_resource_status and not isinstance(base_resource_status, list):
            raise TypeError("Expected argument 'base_resource_status' to be a list")
        pulumi.set(__self__, "base_resource_status", base_resource_status)
        if is_cluster_zone_resilient and not isinstance(is_cluster_zone_resilient, bool):
            raise TypeError("Expected argument 'is_cluster_zone_resilient' to be a bool")
        pulumi.set(__self__, "is_cluster_zone_resilient", is_cluster_zone_resilient)

    @property
    @pulumi.getter(name="baseResourceStatus")
    def base_resource_status(self) -> Optional[Sequence['outputs.ResourceAzStatusResponse']]:
        """
        List of Managed VM Sizes for Service Fabric Managed Clusters.
        """
        return pulumi.get(self, "base_resource_status")

    @property
    @pulumi.getter(name="isClusterZoneResilient")
    def is_cluster_zone_resilient(self) -> builtins.bool:
        """
        URL to get the next set of Managed VM Sizes if there are any.
        """
        return pulumi.get(self, "is_cluster_zone_resilient")


class AwaitableGetManagedAzResiliencyStatusResult(GetManagedAzResiliencyStatusResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetManagedAzResiliencyStatusResult(
            base_resource_status=self.base_resource_status,
            is_cluster_zone_resilient=self.is_cluster_zone_resilient)


def get_managed_az_resiliency_status(cluster_name: Optional[builtins.str] = None,
                                     resource_group_name: Optional[builtins.str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetManagedAzResiliencyStatusResult:
    """
    Action to get Az Resiliency Status of all the Base resources constituting Service Fabric Managed Clusters.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2023-03-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01-preview, 2024-02-01-preview, 2024-06-01-preview, 2024-09-01-preview, 2024-11-01-preview, 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native servicefabric [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str cluster_name: The name of the cluster resource.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['clusterName'] = cluster_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:servicefabric:getManagedAzResiliencyStatus', __args__, opts=opts, typ=GetManagedAzResiliencyStatusResult).value

    return AwaitableGetManagedAzResiliencyStatusResult(
        base_resource_status=pulumi.get(__ret__, 'base_resource_status'),
        is_cluster_zone_resilient=pulumi.get(__ret__, 'is_cluster_zone_resilient'))
def get_managed_az_resiliency_status_output(cluster_name: Optional[pulumi.Input[builtins.str]] = None,
                                            resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetManagedAzResiliencyStatusResult]:
    """
    Action to get Az Resiliency Status of all the Base resources constituting Service Fabric Managed Clusters.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2023-03-01-preview, 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01-preview, 2024-02-01-preview, 2024-06-01-preview, 2024-09-01-preview, 2024-11-01-preview, 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native servicefabric [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str cluster_name: The name of the cluster resource.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['clusterName'] = cluster_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:servicefabric:getManagedAzResiliencyStatus', __args__, opts=opts, typ=GetManagedAzResiliencyStatusResult)
    return __ret__.apply(lambda __response__: GetManagedAzResiliencyStatusResult(
        base_resource_status=pulumi.get(__response__, 'base_resource_status'),
        is_cluster_zone_resilient=pulumi.get(__response__, 'is_cluster_zone_resilient')))
