# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetManagedMaintenanceWindowStatusResult',
    'AwaitableGetManagedMaintenanceWindowStatusResult',
    'get_managed_maintenance_window_status',
    'get_managed_maintenance_window_status_output',
]

@pulumi.output_type
class GetManagedMaintenanceWindowStatusResult:
    """
    Describes the maintenance window status of the Service Fabric Managed Cluster.
    """
    def __init__(__self__, can_apply_updates=None, is_region_ready=None, is_window_active=None, is_window_enabled=None, last_window_end_time_utc=None, last_window_start_time_utc=None, last_window_status_update_at_utc=None):
        if can_apply_updates and not isinstance(can_apply_updates, bool):
            raise TypeError("Expected argument 'can_apply_updates' to be a bool")
        pulumi.set(__self__, "can_apply_updates", can_apply_updates)
        if is_region_ready and not isinstance(is_region_ready, bool):
            raise TypeError("Expected argument 'is_region_ready' to be a bool")
        pulumi.set(__self__, "is_region_ready", is_region_ready)
        if is_window_active and not isinstance(is_window_active, bool):
            raise TypeError("Expected argument 'is_window_active' to be a bool")
        pulumi.set(__self__, "is_window_active", is_window_active)
        if is_window_enabled and not isinstance(is_window_enabled, bool):
            raise TypeError("Expected argument 'is_window_enabled' to be a bool")
        pulumi.set(__self__, "is_window_enabled", is_window_enabled)
        if last_window_end_time_utc and not isinstance(last_window_end_time_utc, str):
            raise TypeError("Expected argument 'last_window_end_time_utc' to be a str")
        pulumi.set(__self__, "last_window_end_time_utc", last_window_end_time_utc)
        if last_window_start_time_utc and not isinstance(last_window_start_time_utc, str):
            raise TypeError("Expected argument 'last_window_start_time_utc' to be a str")
        pulumi.set(__self__, "last_window_start_time_utc", last_window_start_time_utc)
        if last_window_status_update_at_utc and not isinstance(last_window_status_update_at_utc, str):
            raise TypeError("Expected argument 'last_window_status_update_at_utc' to be a str")
        pulumi.set(__self__, "last_window_status_update_at_utc", last_window_status_update_at_utc)

    @property
    @pulumi.getter(name="canApplyUpdates")
    def can_apply_updates(self) -> builtins.bool:
        """
        If updates can be applied.
        """
        return pulumi.get(self, "can_apply_updates")

    @property
    @pulumi.getter(name="isRegionReady")
    def is_region_ready(self) -> builtins.bool:
        """
        Indicates if the region is ready to configure maintenance windows.
        """
        return pulumi.get(self, "is_region_ready")

    @property
    @pulumi.getter(name="isWindowActive")
    def is_window_active(self) -> builtins.bool:
        """
        If maintenance window is active.
        """
        return pulumi.get(self, "is_window_active")

    @property
    @pulumi.getter(name="isWindowEnabled")
    def is_window_enabled(self) -> builtins.bool:
        """
        If maintenance window is enabled on this cluster.
        """
        return pulumi.get(self, "is_window_enabled")

    @property
    @pulumi.getter(name="lastWindowEndTimeUTC")
    def last_window_end_time_utc(self) -> builtins.str:
        """
        Last window end time in UTC.
        """
        return pulumi.get(self, "last_window_end_time_utc")

    @property
    @pulumi.getter(name="lastWindowStartTimeUTC")
    def last_window_start_time_utc(self) -> builtins.str:
        """
        Last window start time in UTC.
        """
        return pulumi.get(self, "last_window_start_time_utc")

    @property
    @pulumi.getter(name="lastWindowStatusUpdateAtUTC")
    def last_window_status_update_at_utc(self) -> builtins.str:
        """
        Last window update time in UTC.
        """
        return pulumi.get(self, "last_window_status_update_at_utc")


class AwaitableGetManagedMaintenanceWindowStatusResult(GetManagedMaintenanceWindowStatusResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetManagedMaintenanceWindowStatusResult(
            can_apply_updates=self.can_apply_updates,
            is_region_ready=self.is_region_ready,
            is_window_active=self.is_window_active,
            is_window_enabled=self.is_window_enabled,
            last_window_end_time_utc=self.last_window_end_time_utc,
            last_window_start_time_utc=self.last_window_start_time_utc,
            last_window_status_update_at_utc=self.last_window_status_update_at_utc)


def get_managed_maintenance_window_status(cluster_name: Optional[builtins.str] = None,
                                          resource_group_name: Optional[builtins.str] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetManagedMaintenanceWindowStatusResult:
    """
    Action to get Maintenance Window Status of the Service Fabric Managed Clusters.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01-preview, 2024-02-01-preview, 2024-06-01-preview, 2024-09-01-preview, 2024-11-01-preview, 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native servicefabric [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str cluster_name: The name of the cluster resource.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['clusterName'] = cluster_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:servicefabric:getManagedMaintenanceWindowStatus', __args__, opts=opts, typ=GetManagedMaintenanceWindowStatusResult).value

    return AwaitableGetManagedMaintenanceWindowStatusResult(
        can_apply_updates=pulumi.get(__ret__, 'can_apply_updates'),
        is_region_ready=pulumi.get(__ret__, 'is_region_ready'),
        is_window_active=pulumi.get(__ret__, 'is_window_active'),
        is_window_enabled=pulumi.get(__ret__, 'is_window_enabled'),
        last_window_end_time_utc=pulumi.get(__ret__, 'last_window_end_time_utc'),
        last_window_start_time_utc=pulumi.get(__ret__, 'last_window_start_time_utc'),
        last_window_status_update_at_utc=pulumi.get(__ret__, 'last_window_status_update_at_utc'))
def get_managed_maintenance_window_status_output(cluster_name: Optional[pulumi.Input[builtins.str]] = None,
                                                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetManagedMaintenanceWindowStatusResult]:
    """
    Action to get Maintenance Window Status of the Service Fabric Managed Clusters.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2023-07-01-preview, 2023-09-01-preview, 2023-11-01-preview, 2023-12-01-preview, 2024-02-01-preview, 2024-06-01-preview, 2024-09-01-preview, 2024-11-01-preview, 2025-03-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native servicefabric [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str cluster_name: The name of the cluster resource.
    :param builtins.str resource_group_name: The name of the resource group.
    """
    __args__ = dict()
    __args__['clusterName'] = cluster_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:servicefabric:getManagedMaintenanceWindowStatus', __args__, opts=opts, typ=GetManagedMaintenanceWindowStatusResult)
    return __ret__.apply(lambda __response__: GetManagedMaintenanceWindowStatusResult(
        can_apply_updates=pulumi.get(__response__, 'can_apply_updates'),
        is_region_ready=pulumi.get(__response__, 'is_region_ready'),
        is_window_active=pulumi.get(__response__, 'is_window_active'),
        is_window_enabled=pulumi.get(__response__, 'is_window_enabled'),
        last_window_end_time_utc=pulumi.get(__response__, 'last_window_end_time_utc'),
        last_window_start_time_utc=pulumi.get(__response__, 'last_window_start_time_utc'),
        last_window_status_update_at_utc=pulumi.get(__response__, 'last_window_status_update_at_utc')))
