# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ApplicationScopedVolumeKind',
    'AutoScalingMechanismKind',
    'AutoScalingMetricKind',
    'AutoScalingResourceMetricName',
    'AutoScalingTriggerKind',
    'DiagnosticsSinkKind',
    'HeaderMatchType',
    'NetworkKind',
    'OperatingSystemType',
    'PathMatchType',
    'SecretKind',
    'SizeTypes',
    'VolumeProvider',
]


@pulumi.type_token("azure-native:servicefabricmesh:ApplicationScopedVolumeKind")
class ApplicationScopedVolumeKind(builtins.str, Enum):
    """
    Specifies the application-scoped volume kind.
    """
    SERVICE_FABRIC_VOLUME_DISK = "ServiceFabricVolumeDisk"
    """
    Provides Service Fabric High Availability Volume Disk
    """


@pulumi.type_token("azure-native:servicefabricmesh:AutoScalingMechanismKind")
class AutoScalingMechanismKind(builtins.str, Enum):
    """
    The type of auto scaling mechanism.
    """
    ADD_REMOVE_REPLICA = "AddRemoveReplica"
    """
    Indicates that scaling should be performed by adding or removing replicas.
    """


@pulumi.type_token("azure-native:servicefabricmesh:AutoScalingMetricKind")
class AutoScalingMetricKind(builtins.str, Enum):
    """
    The type of auto scaling metric
    """
    RESOURCE = "Resource"
    """
    Indicates that the metric is one of resources, like cpu or memory.
    """


@pulumi.type_token("azure-native:servicefabricmesh:AutoScalingResourceMetricName")
class AutoScalingResourceMetricName(builtins.str, Enum):
    """
    Name of the resource.
    """
    CPU = "cpu"
    """
    Indicates that the resource is CPU cores.
    """
    MEMORY_IN_GB = "memoryInGB"
    """
    Indicates that the resource is memory in GB.
    """


@pulumi.type_token("azure-native:servicefabricmesh:AutoScalingTriggerKind")
class AutoScalingTriggerKind(builtins.str, Enum):
    """
    The type of auto scaling trigger
    """
    AVERAGE_LOAD = "AverageLoad"
    """
    Indicates that scaling should be performed based on average load of all replicas in the service.
    """


@pulumi.type_token("azure-native:servicefabricmesh:DiagnosticsSinkKind")
class DiagnosticsSinkKind(builtins.str, Enum):
    """
    The kind of DiagnosticsSink.
    """
    INVALID = "Invalid"
    """
    Indicates an invalid sink kind. All Service Fabric enumerations have the invalid type.
    """
    AZURE_INTERNAL_MONITORING_PIPELINE = "AzureInternalMonitoringPipeline"
    """
    Diagnostics settings for Geneva.
    """


@pulumi.type_token("azure-native:servicefabricmesh:HeaderMatchType")
class HeaderMatchType(builtins.str, Enum):
    """
    how to match header value
    """
    EXACT = "exact"


@pulumi.type_token("azure-native:servicefabricmesh:NetworkKind")
class NetworkKind(builtins.str, Enum):
    """
    The type of a Service Fabric container network.
    """
    LOCAL = "Local"
    """
    Indicates a container network local to a single Service Fabric cluster. The value is 1.
    """


@pulumi.type_token("azure-native:servicefabricmesh:OperatingSystemType")
class OperatingSystemType(builtins.str, Enum):
    """
    The operation system required by the code in service.
    """
    LINUX = "Linux"
    """
    The required operating system is Linux.
    """
    WINDOWS = "Windows"
    """
    The required operating system is Windows.
    """


@pulumi.type_token("azure-native:servicefabricmesh:PathMatchType")
class PathMatchType(builtins.str, Enum):
    """
    how to match value in the Uri
    """
    PREFIX = "prefix"


@pulumi.type_token("azure-native:servicefabricmesh:SecretKind")
class SecretKind(builtins.str, Enum):
    """
    Describes the kind of secret.
    """
    INLINED_VALUE = "inlinedValue"
    """
    A simple secret resource whose plaintext value is provided by the user.
    """


@pulumi.type_token("azure-native:servicefabricmesh:SizeTypes")
class SizeTypes(builtins.str, Enum):
    """
    Volume size
    """
    SMALL = "Small"
    MEDIUM = "Medium"
    LARGE = "Large"


@pulumi.type_token("azure-native:servicefabricmesh:VolumeProvider")
class VolumeProvider(builtins.str, Enum):
    """
    Provider of the volume.
    """
    SF_AZURE_FILE = "SFAzureFile"
    """
    Provides volumes that are backed by Azure Files.
    """
