# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AccessKeyPermissions',
    'ActionType',
    'AllowType',
    'AuthMode',
    'AuthType',
    'AzureResourceType',
    'ClientType',
    'DaprMetadataRequired',
    'DeleteOrUpdateBehavior',
    'DryrunActionName',
    'SecretType',
    'TargetServiceType',
    'VNetSolutionType',
]


@pulumi.type_token("azure-native:servicelinker:AccessKeyPermissions")
class AccessKeyPermissions(builtins.str, Enum):
    READ = "Read"
    WRITE = "Write"
    LISTEN = "Listen"
    SEND = "Send"
    MANAGE = "Manage"


@pulumi.type_token("azure-native:servicelinker:ActionType")
class ActionType(builtins.str, Enum):
    """
    Optional. Indicates public network solution. If enable, enable public network access of target service with best try. Default is enable. If optOut, opt out public network access configuration.
    """
    ENABLE = "enable"
    OPT_OUT = "optOut"


@pulumi.type_token("azure-native:servicelinker:AllowType")
class AllowType(builtins.str, Enum):
    """
    Allow caller client IP to access the target service if true. the property is used when connecting local application to target service.
    """
    TRUE = "true"
    FALSE = "false"


@pulumi.type_token("azure-native:servicelinker:AuthMode")
class AuthMode(builtins.str, Enum):
    """
    Optional. Indicates how to configure authentication. If optInAllAuth, service linker configures authentication such as enabling identity on source resource and granting RBAC roles. If optOutAllAuth, opt out authentication setup. Default is optInAllAuth.
    """
    OPT_IN_ALL_AUTH = "optInAllAuth"
    """
    Default authentication configuration according to the authentication type.
    """
    OPT_OUT_ALL_AUTH = "optOutAllAuth"
    """
    Skip all authentication configuration such as enabling managed identity and granting RBAC roles
    """


@pulumi.type_token("azure-native:servicelinker:AuthType")
class AuthType(builtins.str, Enum):
    """
    The authentication type.
    """
    SYSTEM_ASSIGNED_IDENTITY = "systemAssignedIdentity"
    USER_ASSIGNED_IDENTITY = "userAssignedIdentity"
    SERVICE_PRINCIPAL_SECRET = "servicePrincipalSecret"
    SERVICE_PRINCIPAL_CERTIFICATE = "servicePrincipalCertificate"
    SECRET = "secret"
    ACCESS_KEY = "accessKey"
    USER_ACCOUNT = "userAccount"
    EASY_AUTH_MICROSOFT_ENTRA_ID = "easyAuthMicrosoftEntraID"


@pulumi.type_token("azure-native:servicelinker:AzureResourceType")
class AzureResourceType(builtins.str, Enum):
    """
    The azure resource type.
    """
    KEY_VAULT = "KeyVault"


@pulumi.type_token("azure-native:servicelinker:ClientType")
class ClientType(builtins.str, Enum):
    """
    The application client type
    """
    NONE = "none"
    DOTNET = "dotnet"
    JAVA = "java"
    PYTHON = "python"
    GO = "go"
    PHP = "php"
    RUBY = "ruby"
    DJANGO = "django"
    NODEJS = "nodejs"
    SPRING_BOOT = "springBoot"
    KAFKA_SPRING_BOOT = "kafka-springBoot"
    JMS_SPRING_BOOT = "jms-springBoot"
    DAPR = "dapr"


@pulumi.type_token("azure-native:servicelinker:DaprMetadataRequired")
class DaprMetadataRequired(builtins.str, Enum):
    """
    The value indicating whether the metadata is required or not
    """
    TRUE = "true"
    FALSE = "false"


@pulumi.type_token("azure-native:servicelinker:DeleteOrUpdateBehavior")
class DeleteOrUpdateBehavior(builtins.str, Enum):
    """
    Indicates whether to clean up previous operation when Linker is updating or deleting
    """
    DEFAULT = "Default"
    FORCED_CLEANUP = "ForcedCleanup"


@pulumi.type_token("azure-native:servicelinker:DryrunActionName")
class DryrunActionName(builtins.str, Enum):
    """
    The name of action for you dryrun job.
    """
    CREATE_OR_UPDATE = "createOrUpdate"


@pulumi.type_token("azure-native:servicelinker:SecretType")
class SecretType(builtins.str, Enum):
    """
    The secret type.
    """
    RAW_VALUE = "rawValue"
    KEY_VAULT_SECRET_URI = "keyVaultSecretUri"
    KEY_VAULT_SECRET_REFERENCE = "keyVaultSecretReference"


@pulumi.type_token("azure-native:servicelinker:TargetServiceType")
class TargetServiceType(builtins.str, Enum):
    """
    The target service type.
    """
    AZURE_RESOURCE = "AzureResource"
    CONFLUENT_BOOTSTRAP_SERVER = "ConfluentBootstrapServer"
    CONFLUENT_SCHEMA_REGISTRY = "ConfluentSchemaRegistry"
    SELF_HOSTED_SERVER = "SelfHostedServer"


@pulumi.type_token("azure-native:servicelinker:VNetSolutionType")
class VNetSolutionType(builtins.str, Enum):
    """
    Type of VNet solution.
    """
    SERVICE_ENDPOINT = "serviceEndpoint"
    PRIVATE_LINK = "privateLink"
