# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetConnectorResult',
    'AwaitableGetConnectorResult',
    'get_connector',
    'get_connector_output',
]

@pulumi.output_type
class GetConnectorResult:
    """
    Linker of source and target resource
    """
    def __init__(__self__, auth_info=None, azure_api_version=None, client_type=None, configuration_info=None, id=None, name=None, provisioning_state=None, public_network_solution=None, scope=None, secret_store=None, system_data=None, target_service=None, type=None, v_net_solution=None):
        if auth_info and not isinstance(auth_info, dict):
            raise TypeError("Expected argument 'auth_info' to be a dict")
        pulumi.set(__self__, "auth_info", auth_info)
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if client_type and not isinstance(client_type, str):
            raise TypeError("Expected argument 'client_type' to be a str")
        pulumi.set(__self__, "client_type", client_type)
        if configuration_info and not isinstance(configuration_info, dict):
            raise TypeError("Expected argument 'configuration_info' to be a dict")
        pulumi.set(__self__, "configuration_info", configuration_info)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if provisioning_state and not isinstance(provisioning_state, str):
            raise TypeError("Expected argument 'provisioning_state' to be a str")
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if public_network_solution and not isinstance(public_network_solution, dict):
            raise TypeError("Expected argument 'public_network_solution' to be a dict")
        pulumi.set(__self__, "public_network_solution", public_network_solution)
        if scope and not isinstance(scope, str):
            raise TypeError("Expected argument 'scope' to be a str")
        pulumi.set(__self__, "scope", scope)
        if secret_store and not isinstance(secret_store, dict):
            raise TypeError("Expected argument 'secret_store' to be a dict")
        pulumi.set(__self__, "secret_store", secret_store)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if target_service and not isinstance(target_service, dict):
            raise TypeError("Expected argument 'target_service' to be a dict")
        pulumi.set(__self__, "target_service", target_service)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if v_net_solution and not isinstance(v_net_solution, dict):
            raise TypeError("Expected argument 'v_net_solution' to be a dict")
        pulumi.set(__self__, "v_net_solution", v_net_solution)

    @property
    @pulumi.getter(name="authInfo")
    def auth_info(self) -> Optional[Any]:
        """
        The authentication type.
        """
        return pulumi.get(self, "auth_info")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="clientType")
    def client_type(self) -> Optional[builtins.str]:
        """
        The application client type
        """
        return pulumi.get(self, "client_type")

    @property
    @pulumi.getter(name="configurationInfo")
    def configuration_info(self) -> Optional['outputs.ConfigurationInfoResponse']:
        """
        The connection information consumed by applications, including secrets, connection strings.
        """
        return pulumi.get(self, "configuration_info")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The provisioning state. 
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="publicNetworkSolution")
    def public_network_solution(self) -> Optional['outputs.PublicNetworkSolutionResponse']:
        """
        The network solution.
        """
        return pulumi.get(self, "public_network_solution")

    @property
    @pulumi.getter
    def scope(self) -> Optional[builtins.str]:
        """
        connection scope in source service.
        """
        return pulumi.get(self, "scope")

    @property
    @pulumi.getter(name="secretStore")
    def secret_store(self) -> Optional['outputs.SecretStoreResponse']:
        """
        An option to store secret value in secure place
        """
        return pulumi.get(self, "secret_store")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter(name="targetService")
    def target_service(self) -> Optional[Any]:
        """
        The target service properties
        """
        return pulumi.get(self, "target_service")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="vNetSolution")
    def v_net_solution(self) -> Optional['outputs.VNetSolutionResponse']:
        """
        The VNet solution.
        """
        return pulumi.get(self, "v_net_solution")


class AwaitableGetConnectorResult(GetConnectorResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetConnectorResult(
            auth_info=self.auth_info,
            azure_api_version=self.azure_api_version,
            client_type=self.client_type,
            configuration_info=self.configuration_info,
            id=self.id,
            name=self.name,
            provisioning_state=self.provisioning_state,
            public_network_solution=self.public_network_solution,
            scope=self.scope,
            secret_store=self.secret_store,
            system_data=self.system_data,
            target_service=self.target_service,
            type=self.type,
            v_net_solution=self.v_net_solution)


def get_connector(connector_name: Optional[builtins.str] = None,
                  location: Optional[builtins.str] = None,
                  resource_group_name: Optional[builtins.str] = None,
                  subscription_id: Optional[builtins.str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetConnectorResult:
    """
    Returns Connector resource for a given name.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2022-11-01-preview, 2023-04-01-preview, 2024-07-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native servicelinker [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str connector_name: The name of resource.
    :param builtins.str location: The name of Azure region.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str subscription_id: The ID of the target subscription.
    """
    __args__ = dict()
    __args__['connectorName'] = connector_name
    __args__['location'] = location
    __args__['resourceGroupName'] = resource_group_name
    __args__['subscriptionId'] = subscription_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:servicelinker:getConnector', __args__, opts=opts, typ=GetConnectorResult).value

    return AwaitableGetConnectorResult(
        auth_info=pulumi.get(__ret__, 'auth_info'),
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        client_type=pulumi.get(__ret__, 'client_type'),
        configuration_info=pulumi.get(__ret__, 'configuration_info'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        provisioning_state=pulumi.get(__ret__, 'provisioning_state'),
        public_network_solution=pulumi.get(__ret__, 'public_network_solution'),
        scope=pulumi.get(__ret__, 'scope'),
        secret_store=pulumi.get(__ret__, 'secret_store'),
        system_data=pulumi.get(__ret__, 'system_data'),
        target_service=pulumi.get(__ret__, 'target_service'),
        type=pulumi.get(__ret__, 'type'),
        v_net_solution=pulumi.get(__ret__, 'v_net_solution'))
def get_connector_output(connector_name: Optional[pulumi.Input[builtins.str]] = None,
                         location: Optional[pulumi.Input[builtins.str]] = None,
                         resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                         subscription_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetConnectorResult]:
    """
    Returns Connector resource for a given name.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2022-11-01-preview, 2023-04-01-preview, 2024-07-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native servicelinker [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str connector_name: The name of resource.
    :param builtins.str location: The name of Azure region.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str subscription_id: The ID of the target subscription.
    """
    __args__ = dict()
    __args__['connectorName'] = connector_name
    __args__['location'] = location
    __args__['resourceGroupName'] = resource_group_name
    __args__['subscriptionId'] = subscription_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:servicelinker:getConnector', __args__, opts=opts, typ=GetConnectorResult)
    return __ret__.apply(lambda __response__: GetConnectorResult(
        auth_info=pulumi.get(__response__, 'auth_info'),
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        client_type=pulumi.get(__response__, 'client_type'),
        configuration_info=pulumi.get(__response__, 'configuration_info'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        provisioning_state=pulumi.get(__response__, 'provisioning_state'),
        public_network_solution=pulumi.get(__response__, 'public_network_solution'),
        scope=pulumi.get(__response__, 'scope'),
        secret_store=pulumi.get(__response__, 'secret_store'),
        system_data=pulumi.get(__response__, 'system_data'),
        target_service=pulumi.get(__response__, 'target_service'),
        type=pulumi.get(__response__, 'type'),
        v_net_solution=pulumi.get(__response__, 'v_net_solution')))
