# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListLinkerConfigurationsResult',
    'AwaitableListLinkerConfigurationsResult',
    'list_linker_configurations',
    'list_linker_configurations_output',
]

@pulumi.output_type
class ListLinkerConfigurationsResult:
    """
    Configurations for source resource, include appSettings, connectionString and serviceBindings
    """
    def __init__(__self__, configurations=None):
        if configurations and not isinstance(configurations, list):
            raise TypeError("Expected argument 'configurations' to be a list")
        pulumi.set(__self__, "configurations", configurations)

    @property
    @pulumi.getter
    def configurations(self) -> Optional[Sequence['outputs.SourceConfigurationResponse']]:
        """
        The configuration properties for source resource.
        """
        return pulumi.get(self, "configurations")


class AwaitableListLinkerConfigurationsResult(ListLinkerConfigurationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListLinkerConfigurationsResult(
            configurations=self.configurations)


def list_linker_configurations(linker_name: Optional[builtins.str] = None,
                               resource_uri: Optional[builtins.str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListLinkerConfigurationsResult:
    """
    list source configurations for a Linker.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2022-11-01-preview, 2023-04-01-preview, 2024-07-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native servicelinker [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str linker_name: The name Linker resource.
    :param builtins.str resource_uri: The fully qualified Azure Resource manager identifier of the resource to be connected.
    """
    __args__ = dict()
    __args__['linkerName'] = linker_name
    __args__['resourceUri'] = resource_uri
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:servicelinker:listLinkerConfigurations', __args__, opts=opts, typ=ListLinkerConfigurationsResult).value

    return AwaitableListLinkerConfigurationsResult(
        configurations=pulumi.get(__ret__, 'configurations'))
def list_linker_configurations_output(linker_name: Optional[pulumi.Input[builtins.str]] = None,
                                      resource_uri: Optional[pulumi.Input[builtins.str]] = None,
                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListLinkerConfigurationsResult]:
    """
    list source configurations for a Linker.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2022-11-01-preview, 2023-04-01-preview, 2024-07-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native servicelinker [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str linker_name: The name Linker resource.
    :param builtins.str resource_uri: The fully qualified Azure Resource manager identifier of the resource to be connected.
    """
    __args__ = dict()
    __args__['linkerName'] = linker_name
    __args__['resourceUri'] = resource_uri
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:servicelinker:listLinkerConfigurations', __args__, opts=opts, typ=ListLinkerConfigurationsResult)
    return __ret__.apply(lambda __response__: ListLinkerConfigurationsResult(
        configurations=pulumi.get(__response__, 'configurations')))
