# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'ACLAction',
    'FeatureFlags',
    'ManagedIdentityType',
    'PrivateLinkServiceConnectionStatus',
    'ServiceKind',
    'SignalRRequestType',
    'SignalRSkuTier',
    'UpstreamAuthType',
]


@pulumi.type_token("azure-native:signalrservice:ACLAction")
class ACLAction(builtins.str, Enum):
    """
    Azure Networking ACL Action.
    """
    ALLOW = "Allow"
    DENY = "Deny"


@pulumi.type_token("azure-native:signalrservice:FeatureFlags")
class FeatureFlags(builtins.str, Enum):
    """
    FeatureFlags is the supported features of Azure SignalR service.
    - ServiceMode: Flag for backend server for SignalR service. Values allowed: "Default": have your own backend server; "Serverless": your application doesn't have a backend server; "Classic": for backward compatibility. Support both Default and Serverless mode but not recommended; "PredefinedOnly": for future use.
    - EnableConnectivityLogs: "true"/"false", to enable/disable the connectivity log category respectively.
    - EnableMessagingLogs: "true"/"false", to enable/disable the connectivity log category respectively.
    - EnableLiveTrace: Live Trace allows you to know what's happening inside Azure SignalR service, it will give you live traces in real time, it will be helpful when you developing your own Azure SignalR based web application or self-troubleshooting some issues. Please note that live traces are counted as outbound messages that will be charged. Values allowed: "true"/"false", to enable/disable live trace feature.
    """
    SERVICE_MODE = "ServiceMode"
    ENABLE_CONNECTIVITY_LOGS = "EnableConnectivityLogs"
    ENABLE_MESSAGING_LOGS = "EnableMessagingLogs"
    ENABLE_LIVE_TRACE = "EnableLiveTrace"


@pulumi.type_token("azure-native:signalrservice:ManagedIdentityType")
class ManagedIdentityType(builtins.str, Enum):
    """
    Represents the identity type: systemAssigned, userAssigned, None
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"


@pulumi.type_token("azure-native:signalrservice:PrivateLinkServiceConnectionStatus")
class PrivateLinkServiceConnectionStatus(builtins.str, Enum):
    """
    Indicates whether the connection has been Approved/Rejected/Removed by the owner of the service.
    """
    PENDING = "Pending"
    APPROVED = "Approved"
    REJECTED = "Rejected"
    DISCONNECTED = "Disconnected"


@pulumi.type_token("azure-native:signalrservice:ServiceKind")
class ServiceKind(builtins.str, Enum):
    """
    The kind of the service
    """
    SIGNAL_R = "SignalR"
    RAW_WEB_SOCKETS = "RawWebSockets"


@pulumi.type_token("azure-native:signalrservice:SignalRRequestType")
class SignalRRequestType(builtins.str, Enum):
    """
    The incoming request type to the service
    """
    CLIENT_CONNECTION = "ClientConnection"
    SERVER_CONNECTION = "ServerConnection"
    RESTAPI = "RESTAPI"
    TRACE = "Trace"


@pulumi.type_token("azure-native:signalrservice:SignalRSkuTier")
class SignalRSkuTier(builtins.str, Enum):
    """
    Optional tier of this particular SKU. 'Standard' or 'Free'. 
    
    `Basic` is deprecated, use `Standard` instead.
    """
    FREE = "Free"
    BASIC = "Basic"
    STANDARD = "Standard"
    PREMIUM = "Premium"


@pulumi.type_token("azure-native:signalrservice:UpstreamAuthType")
class UpstreamAuthType(builtins.str, Enum):
    """
    Upstream auth type enum.
    """
    NONE = "None"
    MANAGED_IDENTITY = "ManagedIdentity"
