# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'FirewallCreationOptions',
    'ManagedIdentityResourceType',
    'ManagedServiceIdentityType',
    'ResourceCreationOptions',
    'ResourceType',
]


@pulumi.type_token("azure-native:sovereign:FirewallCreationOptions")
class FirewallCreationOptions(builtins.str, Enum):
    """
    Parameter used for deploying a Firewall: Select 'No' to skip deployment, 'Standard' to deploy the Standard SKU, or 'Premium' to deploy the Premium SKU.
    """
    NONE = "None"
    """
    Select 'None' value to skip Firewall deployment.
    """
    STANDARD = "Standard"
    """
    Select 'Standard' value to deploy the Firewall Standard SKU.
    """
    PREMIUM = "Premium"
    """
    Select 'Premium' value to deploy the Firewall Premium SKU.
    """


@pulumi.type_token("azure-native:sovereign:ManagedIdentityResourceType")
class ManagedIdentityResourceType(builtins.str, Enum):
    """
    The type of managed identity.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    """
    System assigned managed identity.
    """
    USER_ASSIGNED = "UserAssigned"
    """
    User assigned managed identity.
    """


@pulumi.type_token("azure-native:sovereign:ManagedServiceIdentityType")
class ManagedServiceIdentityType(builtins.str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


@pulumi.type_token("azure-native:sovereign:ResourceCreationOptions")
class ResourceCreationOptions(builtins.str, Enum):
    """
    Parameter used to deploy a log analytics workspace: Select 'Yes' to enable deployment, 'No' to skip it, or 'Existing' to reuse an existing log analytics workspace.
    """
    YES = "Yes"
    """
    Value to create a new resource.
    """
    NO = "No"
    """
    Value to not create a new resource.
    """
    USE_EXISTING = "UseExisting"
    """
    Value to use an existing resource.
    """


@pulumi.type_token("azure-native:sovereign:ResourceType")
class ResourceType(builtins.str, Enum):
    """
    The type of the resource.
    """
    AZURE_FIREWALLS = "azureFirewalls"
    """
    Value when customer wants to provide a custom naming convention for Azure Firewall.
    """
    WORKSPACES = "workspaces"
    """
    Value when customer wants to provide a custom naming convention for Log Analytics workspace.
    """
    AUTOMATION_ACCOUNTS = "automationAccounts"
    """
    Value when customer wants to provide a custom naming convention for automation account.
    """
    DASHBOARDS = "dashboards"
    """
    Value when customer wants to provide a custom naming convention for dashboard.
    """
    USER_ASSIGNED_IDENTITIES = "userAssignedIdentities"
    """
    Value when customer wants to provide a custom naming convention for managed identity.
    """
    BASTION_HOSTS = "bastionHosts"
    """
    Value when customer wants to provide a custom naming convention for Bastion.
    """
    DDOS_PROTECTION_PLANS = "ddosProtectionPlans"
    """
    Value when customer wants to provide a custom naming convention for DDoS protection plan.
    """
    NETWORK_SECURITY_GROUPS = "networkSecurityGroups"
    """
    Value when customer wants to provide a custom naming convention for Bastion NSG.
    """
    VIRTUAL_NETWORKS = "virtualNetworks"
    """
    Value when customer wants to provide a custom naming convention for virtual network.
    """
    ROUTE_TABLES = "routeTables"
    """
    Value when customer wants to provide a custom naming convention for route table.
    """
