# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['StandbyContainerGroupPoolArgs', 'StandbyContainerGroupPool']

@pulumi.input_type
class StandbyContainerGroupPoolArgs:
    def __init__(__self__, *,
                 container_group_properties: pulumi.Input['ContainerGroupPropertiesArgs'],
                 elasticity_profile: pulumi.Input['StandbyContainerGroupPoolElasticityProfileArgs'],
                 resource_group_name: pulumi.Input[builtins.str],
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 standby_container_group_pool_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a StandbyContainerGroupPool resource.
        :param pulumi.Input['ContainerGroupPropertiesArgs'] container_group_properties: Specifies container group properties of standby container group pools.
        :param pulumi.Input['StandbyContainerGroupPoolElasticityProfileArgs'] elasticity_profile: Specifies elasticity profile of standby container group pools.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] location: The geo-location where the resource lives
        :param pulumi.Input[builtins.str] standby_container_group_pool_name: Name of the standby container group pool
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: Resource tags.
        """
        pulumi.set(__self__, "container_group_properties", container_group_properties)
        pulumi.set(__self__, "elasticity_profile", elasticity_profile)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if standby_container_group_pool_name is not None:
            pulumi.set(__self__, "standby_container_group_pool_name", standby_container_group_pool_name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="containerGroupProperties")
    def container_group_properties(self) -> pulumi.Input['ContainerGroupPropertiesArgs']:
        """
        Specifies container group properties of standby container group pools.
        """
        return pulumi.get(self, "container_group_properties")

    @container_group_properties.setter
    def container_group_properties(self, value: pulumi.Input['ContainerGroupPropertiesArgs']):
        pulumi.set(self, "container_group_properties", value)

    @property
    @pulumi.getter(name="elasticityProfile")
    def elasticity_profile(self) -> pulumi.Input['StandbyContainerGroupPoolElasticityProfileArgs']:
        """
        Specifies elasticity profile of standby container group pools.
        """
        return pulumi.get(self, "elasticity_profile")

    @elasticity_profile.setter
    def elasticity_profile(self, value: pulumi.Input['StandbyContainerGroupPoolElasticityProfileArgs']):
        pulumi.set(self, "elasticity_profile", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="standbyContainerGroupPoolName")
    def standby_container_group_pool_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Name of the standby container group pool
        """
        return pulumi.get(self, "standby_container_group_pool_name")

    @standby_container_group_pool_name.setter
    def standby_container_group_pool_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "standby_container_group_pool_name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.type_token("azure-native:standbypool:StandbyContainerGroupPool")
class StandbyContainerGroupPool(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 container_group_properties: Optional[pulumi.Input[Union['ContainerGroupPropertiesArgs', 'ContainerGroupPropertiesArgsDict']]] = None,
                 elasticity_profile: Optional[pulumi.Input[Union['StandbyContainerGroupPoolElasticityProfileArgs', 'StandbyContainerGroupPoolElasticityProfileArgsDict']]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 standby_container_group_pool_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        A StandbyContainerGroupPoolResource.

        Uses Azure REST API version 2024-03-01. In version 2.x of the Azure Native provider, it used API version 2023-12-01-preview.

        Other available API versions: 2023-12-01-preview, 2024-03-01-preview, 2025-03-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native standbypool [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['ContainerGroupPropertiesArgs', 'ContainerGroupPropertiesArgsDict']] container_group_properties: Specifies container group properties of standby container group pools.
        :param pulumi.Input[Union['StandbyContainerGroupPoolElasticityProfileArgs', 'StandbyContainerGroupPoolElasticityProfileArgsDict']] elasticity_profile: Specifies elasticity profile of standby container group pools.
        :param pulumi.Input[builtins.str] location: The geo-location where the resource lives
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group. The name is case insensitive.
        :param pulumi.Input[builtins.str] standby_container_group_pool_name: Name of the standby container group pool
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: Resource tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: StandbyContainerGroupPoolArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        A StandbyContainerGroupPoolResource.

        Uses Azure REST API version 2024-03-01. In version 2.x of the Azure Native provider, it used API version 2023-12-01-preview.

        Other available API versions: 2023-12-01-preview, 2024-03-01-preview, 2025-03-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native standbypool [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param StandbyContainerGroupPoolArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(StandbyContainerGroupPoolArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 container_group_properties: Optional[pulumi.Input[Union['ContainerGroupPropertiesArgs', 'ContainerGroupPropertiesArgsDict']]] = None,
                 elasticity_profile: Optional[pulumi.Input[Union['StandbyContainerGroupPoolElasticityProfileArgs', 'StandbyContainerGroupPoolElasticityProfileArgsDict']]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 standby_container_group_pool_name: Optional[pulumi.Input[builtins.str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = StandbyContainerGroupPoolArgs.__new__(StandbyContainerGroupPoolArgs)

            if container_group_properties is None and not opts.urn:
                raise TypeError("Missing required property 'container_group_properties'")
            __props__.__dict__["container_group_properties"] = container_group_properties
            if elasticity_profile is None and not opts.urn:
                raise TypeError("Missing required property 'elasticity_profile'")
            __props__.__dict__["elasticity_profile"] = elasticity_profile
            __props__.__dict__["location"] = location
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["standby_container_group_pool_name"] = standby_container_group_pool_name
            __props__.__dict__["tags"] = tags
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["provisioning_state"] = None
            __props__.__dict__["system_data"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:standbypool/v20231201preview:StandbyContainerGroupPool"), pulumi.Alias(type_="azure-native:standbypool/v20240301:StandbyContainerGroupPool"), pulumi.Alias(type_="azure-native:standbypool/v20240301preview:StandbyContainerGroupPool"), pulumi.Alias(type_="azure-native:standbypool/v20250301:StandbyContainerGroupPool")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(StandbyContainerGroupPool, __self__).__init__(
            'azure-native:standbypool:StandbyContainerGroupPool',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'StandbyContainerGroupPool':
        """
        Get an existing StandbyContainerGroupPool resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = StandbyContainerGroupPoolArgs.__new__(StandbyContainerGroupPoolArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["container_group_properties"] = None
        __props__.__dict__["elasticity_profile"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioning_state"] = None
        __props__.__dict__["system_data"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return StandbyContainerGroupPool(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter(name="containerGroupProperties")
    def container_group_properties(self) -> pulumi.Output['outputs.ContainerGroupPropertiesResponse']:
        """
        Specifies container group properties of standby container group pools.
        """
        return pulumi.get(self, "container_group_properties")

    @property
    @pulumi.getter(name="elasticityProfile")
    def elasticity_profile(self) -> pulumi.Output['outputs.StandbyContainerGroupPoolElasticityProfileResponse']:
        """
        Specifies elasticity profile of standby container group pools.
        """
        return pulumi.get(self, "elasticity_profile")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[builtins.str]:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> pulumi.Output[builtins.str]:
        """
        The status of the last operation.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> pulumi.Output['outputs.SystemDataResponse']:
        """
        Azure Resource Manager metadata containing createdBy and modifiedBy information.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

