# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = ['FileShareArgs', 'FileShare']

@pulumi.input_type
class FileShareArgs:
    def __init__(__self__, *,
                 account_name: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 access_tier: Optional[pulumi.Input[Union[builtins.str, 'ShareAccessTier']]] = None,
                 enabled_protocols: Optional[pulumi.Input[Union[builtins.str, 'EnabledProtocols']]] = None,
                 expand: Optional[pulumi.Input[builtins.str]] = None,
                 file_share_paid_bursting: Optional[pulumi.Input['FileSharePropertiesFileSharePaidBurstingArgs']] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 provisioned_bandwidth_mibps: Optional[pulumi.Input[builtins.int]] = None,
                 provisioned_iops: Optional[pulumi.Input[builtins.int]] = None,
                 root_squash: Optional[pulumi.Input[Union[builtins.str, 'RootSquashType']]] = None,
                 share_name: Optional[pulumi.Input[builtins.str]] = None,
                 share_quota: Optional[pulumi.Input[builtins.int]] = None,
                 signed_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input['SignedIdentifierArgs']]]] = None):
        """
        The set of arguments for constructing a FileShare resource.
        :param pulumi.Input[builtins.str] account_name: The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group within the user's subscription. The name is case insensitive.
        :param pulumi.Input[Union[builtins.str, 'ShareAccessTier']] access_tier: Access tier for specific share. GpV2 account can choose between TransactionOptimized (default), Hot, and Cool. FileStorage account can choose Premium.
        :param pulumi.Input[Union[builtins.str, 'EnabledProtocols']] enabled_protocols: The authentication protocol that is used for the file share. Can only be specified when creating a share.
        :param pulumi.Input[builtins.str] expand: Optional, used to expand the properties within share's properties. Valid values are: snapshots. Should be passed as a string with delimiter ','
        :param pulumi.Input['FileSharePropertiesFileSharePaidBurstingArgs'] file_share_paid_bursting: File Share Paid Bursting properties.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] metadata: A name-value pair to associate with the share as metadata.
        :param pulumi.Input[builtins.int] provisioned_bandwidth_mibps: The provisioned bandwidth of the share, in mebibytes per second. This property is only for file shares created under Files Provisioned v2 account type. Please refer to the GetFileServiceUsage API response for the minimum and maximum allowed value for provisioned bandwidth.
        :param pulumi.Input[builtins.int] provisioned_iops: The provisioned IOPS of the share. This property is only for file shares created under Files Provisioned v2 account type. Please refer to the GetFileServiceUsage API response for the minimum and maximum allowed value for provisioned IOPS.
        :param pulumi.Input[Union[builtins.str, 'RootSquashType']] root_squash: The property is for NFS share only. The default is NoRootSquash.
        :param pulumi.Input[builtins.str] share_name: The name of the file share within the specified storage account. File share names must be between 3 and 63 characters in length and use numbers, lower-case letters and dash (-) only. Every dash (-) character must be immediately preceded and followed by a letter or number.
        :param pulumi.Input[builtins.int] share_quota: The provisioned size of the share, in gibibytes. Must be greater than 0, and less than or equal to 5TB (5120). For Large File Shares, the maximum size is 102400. For file shares created under Files Provisioned v2 account type, please refer to the GetFileServiceUsage API response for the minimum and maximum allowed provisioned storage size.
        :param pulumi.Input[Sequence[pulumi.Input['SignedIdentifierArgs']]] signed_identifiers: List of stored access policies specified on the share.
        """
        pulumi.set(__self__, "account_name", account_name)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if access_tier is not None:
            pulumi.set(__self__, "access_tier", access_tier)
        if enabled_protocols is not None:
            pulumi.set(__self__, "enabled_protocols", enabled_protocols)
        if expand is not None:
            pulumi.set(__self__, "expand", expand)
        if file_share_paid_bursting is not None:
            pulumi.set(__self__, "file_share_paid_bursting", file_share_paid_bursting)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if provisioned_bandwidth_mibps is not None:
            pulumi.set(__self__, "provisioned_bandwidth_mibps", provisioned_bandwidth_mibps)
        if provisioned_iops is not None:
            pulumi.set(__self__, "provisioned_iops", provisioned_iops)
        if root_squash is not None:
            pulumi.set(__self__, "root_squash", root_squash)
        if share_name is not None:
            pulumi.set(__self__, "share_name", share_name)
        if share_quota is not None:
            pulumi.set(__self__, "share_quota", share_quota)
        if signed_identifiers is not None:
            pulumi.set(__self__, "signed_identifiers", signed_identifiers)

    @property
    @pulumi.getter(name="accountName")
    def account_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.
        """
        return pulumi.get(self, "account_name")

    @account_name.setter
    def account_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "account_name", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group within the user's subscription. The name is case insensitive.
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="accessTier")
    def access_tier(self) -> Optional[pulumi.Input[Union[builtins.str, 'ShareAccessTier']]]:
        """
        Access tier for specific share. GpV2 account can choose between TransactionOptimized (default), Hot, and Cool. FileStorage account can choose Premium.
        """
        return pulumi.get(self, "access_tier")

    @access_tier.setter
    def access_tier(self, value: Optional[pulumi.Input[Union[builtins.str, 'ShareAccessTier']]]):
        pulumi.set(self, "access_tier", value)

    @property
    @pulumi.getter(name="enabledProtocols")
    def enabled_protocols(self) -> Optional[pulumi.Input[Union[builtins.str, 'EnabledProtocols']]]:
        """
        The authentication protocol that is used for the file share. Can only be specified when creating a share.
        """
        return pulumi.get(self, "enabled_protocols")

    @enabled_protocols.setter
    def enabled_protocols(self, value: Optional[pulumi.Input[Union[builtins.str, 'EnabledProtocols']]]):
        pulumi.set(self, "enabled_protocols", value)

    @property
    @pulumi.getter
    def expand(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Optional, used to expand the properties within share's properties. Valid values are: snapshots. Should be passed as a string with delimiter ','
        """
        return pulumi.get(self, "expand")

    @expand.setter
    def expand(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "expand", value)

    @property
    @pulumi.getter(name="fileSharePaidBursting")
    def file_share_paid_bursting(self) -> Optional[pulumi.Input['FileSharePropertiesFileSharePaidBurstingArgs']]:
        """
        File Share Paid Bursting properties.
        """
        return pulumi.get(self, "file_share_paid_bursting")

    @file_share_paid_bursting.setter
    def file_share_paid_bursting(self, value: Optional[pulumi.Input['FileSharePropertiesFileSharePaidBurstingArgs']]):
        pulumi.set(self, "file_share_paid_bursting", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        A name-value pair to associate with the share as metadata.
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter(name="provisionedBandwidthMibps")
    def provisioned_bandwidth_mibps(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The provisioned bandwidth of the share, in mebibytes per second. This property is only for file shares created under Files Provisioned v2 account type. Please refer to the GetFileServiceUsage API response for the minimum and maximum allowed value for provisioned bandwidth.
        """
        return pulumi.get(self, "provisioned_bandwidth_mibps")

    @provisioned_bandwidth_mibps.setter
    def provisioned_bandwidth_mibps(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "provisioned_bandwidth_mibps", value)

    @property
    @pulumi.getter(name="provisionedIops")
    def provisioned_iops(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The provisioned IOPS of the share. This property is only for file shares created under Files Provisioned v2 account type. Please refer to the GetFileServiceUsage API response for the minimum and maximum allowed value for provisioned IOPS.
        """
        return pulumi.get(self, "provisioned_iops")

    @provisioned_iops.setter
    def provisioned_iops(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "provisioned_iops", value)

    @property
    @pulumi.getter(name="rootSquash")
    def root_squash(self) -> Optional[pulumi.Input[Union[builtins.str, 'RootSquashType']]]:
        """
        The property is for NFS share only. The default is NoRootSquash.
        """
        return pulumi.get(self, "root_squash")

    @root_squash.setter
    def root_squash(self, value: Optional[pulumi.Input[Union[builtins.str, 'RootSquashType']]]):
        pulumi.set(self, "root_squash", value)

    @property
    @pulumi.getter(name="shareName")
    def share_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the file share within the specified storage account. File share names must be between 3 and 63 characters in length and use numbers, lower-case letters and dash (-) only. Every dash (-) character must be immediately preceded and followed by a letter or number.
        """
        return pulumi.get(self, "share_name")

    @share_name.setter
    def share_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "share_name", value)

    @property
    @pulumi.getter(name="shareQuota")
    def share_quota(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The provisioned size of the share, in gibibytes. Must be greater than 0, and less than or equal to 5TB (5120). For Large File Shares, the maximum size is 102400. For file shares created under Files Provisioned v2 account type, please refer to the GetFileServiceUsage API response for the minimum and maximum allowed provisioned storage size.
        """
        return pulumi.get(self, "share_quota")

    @share_quota.setter
    def share_quota(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "share_quota", value)

    @property
    @pulumi.getter(name="signedIdentifiers")
    def signed_identifiers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['SignedIdentifierArgs']]]]:
        """
        List of stored access policies specified on the share.
        """
        return pulumi.get(self, "signed_identifiers")

    @signed_identifiers.setter
    def signed_identifiers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['SignedIdentifierArgs']]]]):
        pulumi.set(self, "signed_identifiers", value)


@pulumi.type_token("azure-native:storage:FileShare")
class FileShare(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_tier: Optional[pulumi.Input[Union[builtins.str, 'ShareAccessTier']]] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 enabled_protocols: Optional[pulumi.Input[Union[builtins.str, 'EnabledProtocols']]] = None,
                 expand: Optional[pulumi.Input[builtins.str]] = None,
                 file_share_paid_bursting: Optional[pulumi.Input[Union['FileSharePropertiesFileSharePaidBurstingArgs', 'FileSharePropertiesFileSharePaidBurstingArgsDict']]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 provisioned_bandwidth_mibps: Optional[pulumi.Input[builtins.int]] = None,
                 provisioned_iops: Optional[pulumi.Input[builtins.int]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 root_squash: Optional[pulumi.Input[Union[builtins.str, 'RootSquashType']]] = None,
                 share_name: Optional[pulumi.Input[builtins.str]] = None,
                 share_quota: Optional[pulumi.Input[builtins.int]] = None,
                 signed_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[Union['SignedIdentifierArgs', 'SignedIdentifierArgsDict']]]]] = None,
                 __props__=None):
        """
        Properties of the file share, including Id, resource name, resource type, Etag.

        Uses Azure REST API version 2024-01-01. In version 2.x of the Azure Native provider, it used API version 2022-09-01.

        Other available API versions: 2022-09-01, 2023-01-01, 2023-04-01, 2023-05-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native storage [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union[builtins.str, 'ShareAccessTier']] access_tier: Access tier for specific share. GpV2 account can choose between TransactionOptimized (default), Hot, and Cool. FileStorage account can choose Premium.
        :param pulumi.Input[builtins.str] account_name: The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.
        :param pulumi.Input[Union[builtins.str, 'EnabledProtocols']] enabled_protocols: The authentication protocol that is used for the file share. Can only be specified when creating a share.
        :param pulumi.Input[builtins.str] expand: Optional, used to expand the properties within share's properties. Valid values are: snapshots. Should be passed as a string with delimiter ','
        :param pulumi.Input[Union['FileSharePropertiesFileSharePaidBurstingArgs', 'FileSharePropertiesFileSharePaidBurstingArgsDict']] file_share_paid_bursting: File Share Paid Bursting properties.
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] metadata: A name-value pair to associate with the share as metadata.
        :param pulumi.Input[builtins.int] provisioned_bandwidth_mibps: The provisioned bandwidth of the share, in mebibytes per second. This property is only for file shares created under Files Provisioned v2 account type. Please refer to the GetFileServiceUsage API response for the minimum and maximum allowed value for provisioned bandwidth.
        :param pulumi.Input[builtins.int] provisioned_iops: The provisioned IOPS of the share. This property is only for file shares created under Files Provisioned v2 account type. Please refer to the GetFileServiceUsage API response for the minimum and maximum allowed value for provisioned IOPS.
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group within the user's subscription. The name is case insensitive.
        :param pulumi.Input[Union[builtins.str, 'RootSquashType']] root_squash: The property is for NFS share only. The default is NoRootSquash.
        :param pulumi.Input[builtins.str] share_name: The name of the file share within the specified storage account. File share names must be between 3 and 63 characters in length and use numbers, lower-case letters and dash (-) only. Every dash (-) character must be immediately preceded and followed by a letter or number.
        :param pulumi.Input[builtins.int] share_quota: The provisioned size of the share, in gibibytes. Must be greater than 0, and less than or equal to 5TB (5120). For Large File Shares, the maximum size is 102400. For file shares created under Files Provisioned v2 account type, please refer to the GetFileServiceUsage API response for the minimum and maximum allowed provisioned storage size.
        :param pulumi.Input[Sequence[pulumi.Input[Union['SignedIdentifierArgs', 'SignedIdentifierArgsDict']]]] signed_identifiers: List of stored access policies specified on the share.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FileShareArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Properties of the file share, including Id, resource name, resource type, Etag.

        Uses Azure REST API version 2024-01-01. In version 2.x of the Azure Native provider, it used API version 2022-09-01.

        Other available API versions: 2022-09-01, 2023-01-01, 2023-04-01, 2023-05-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native storage [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.

        :param str resource_name: The name of the resource.
        :param FileShareArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FileShareArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_tier: Optional[pulumi.Input[Union[builtins.str, 'ShareAccessTier']]] = None,
                 account_name: Optional[pulumi.Input[builtins.str]] = None,
                 enabled_protocols: Optional[pulumi.Input[Union[builtins.str, 'EnabledProtocols']]] = None,
                 expand: Optional[pulumi.Input[builtins.str]] = None,
                 file_share_paid_bursting: Optional[pulumi.Input[Union['FileSharePropertiesFileSharePaidBurstingArgs', 'FileSharePropertiesFileSharePaidBurstingArgsDict']]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 provisioned_bandwidth_mibps: Optional[pulumi.Input[builtins.int]] = None,
                 provisioned_iops: Optional[pulumi.Input[builtins.int]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 root_squash: Optional[pulumi.Input[Union[builtins.str, 'RootSquashType']]] = None,
                 share_name: Optional[pulumi.Input[builtins.str]] = None,
                 share_quota: Optional[pulumi.Input[builtins.int]] = None,
                 signed_identifiers: Optional[pulumi.Input[Sequence[pulumi.Input[Union['SignedIdentifierArgs', 'SignedIdentifierArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FileShareArgs.__new__(FileShareArgs)

            __props__.__dict__["access_tier"] = access_tier
            if account_name is None and not opts.urn:
                raise TypeError("Missing required property 'account_name'")
            __props__.__dict__["account_name"] = account_name
            __props__.__dict__["enabled_protocols"] = enabled_protocols
            __props__.__dict__["expand"] = expand
            __props__.__dict__["file_share_paid_bursting"] = file_share_paid_bursting
            __props__.__dict__["metadata"] = metadata
            __props__.__dict__["provisioned_bandwidth_mibps"] = provisioned_bandwidth_mibps
            __props__.__dict__["provisioned_iops"] = provisioned_iops
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["root_squash"] = root_squash
            __props__.__dict__["share_name"] = share_name
            __props__.__dict__["share_quota"] = share_quota
            __props__.__dict__["signed_identifiers"] = signed_identifiers
            __props__.__dict__["access_tier_change_time"] = None
            __props__.__dict__["access_tier_status"] = None
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["deleted"] = None
            __props__.__dict__["deleted_time"] = None
            __props__.__dict__["etag"] = None
            __props__.__dict__["included_burst_iops"] = None
            __props__.__dict__["last_modified_time"] = None
            __props__.__dict__["lease_duration"] = None
            __props__.__dict__["lease_state"] = None
            __props__.__dict__["lease_status"] = None
            __props__.__dict__["max_burst_credits_for_iops"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["next_allowed_provisioned_bandwidth_downgrade_time"] = None
            __props__.__dict__["next_allowed_provisioned_iops_downgrade_time"] = None
            __props__.__dict__["next_allowed_quota_downgrade_time"] = None
            __props__.__dict__["remaining_retention_days"] = None
            __props__.__dict__["share_usage_bytes"] = None
            __props__.__dict__["snapshot_time"] = None
            __props__.__dict__["type"] = None
            __props__.__dict__["version"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:storage/v20190401:FileShare"), pulumi.Alias(type_="azure-native:storage/v20190601:FileShare"), pulumi.Alias(type_="azure-native:storage/v20200801preview:FileShare"), pulumi.Alias(type_="azure-native:storage/v20210101:FileShare"), pulumi.Alias(type_="azure-native:storage/v20210201:FileShare"), pulumi.Alias(type_="azure-native:storage/v20210401:FileShare"), pulumi.Alias(type_="azure-native:storage/v20210601:FileShare"), pulumi.Alias(type_="azure-native:storage/v20210801:FileShare"), pulumi.Alias(type_="azure-native:storage/v20210901:FileShare"), pulumi.Alias(type_="azure-native:storage/v20220501:FileShare"), pulumi.Alias(type_="azure-native:storage/v20220901:FileShare"), pulumi.Alias(type_="azure-native:storage/v20230101:FileShare"), pulumi.Alias(type_="azure-native:storage/v20230401:FileShare"), pulumi.Alias(type_="azure-native:storage/v20230501:FileShare"), pulumi.Alias(type_="azure-native:storage/v20240101:FileShare")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(FileShare, __self__).__init__(
            'azure-native:storage:FileShare',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'FileShare':
        """
        Get an existing FileShare resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = FileShareArgs.__new__(FileShareArgs)

        __props__.__dict__["access_tier"] = None
        __props__.__dict__["access_tier_change_time"] = None
        __props__.__dict__["access_tier_status"] = None
        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["deleted"] = None
        __props__.__dict__["deleted_time"] = None
        __props__.__dict__["enabled_protocols"] = None
        __props__.__dict__["etag"] = None
        __props__.__dict__["file_share_paid_bursting"] = None
        __props__.__dict__["included_burst_iops"] = None
        __props__.__dict__["last_modified_time"] = None
        __props__.__dict__["lease_duration"] = None
        __props__.__dict__["lease_state"] = None
        __props__.__dict__["lease_status"] = None
        __props__.__dict__["max_burst_credits_for_iops"] = None
        __props__.__dict__["metadata"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["next_allowed_provisioned_bandwidth_downgrade_time"] = None
        __props__.__dict__["next_allowed_provisioned_iops_downgrade_time"] = None
        __props__.__dict__["next_allowed_quota_downgrade_time"] = None
        __props__.__dict__["provisioned_bandwidth_mibps"] = None
        __props__.__dict__["provisioned_iops"] = None
        __props__.__dict__["remaining_retention_days"] = None
        __props__.__dict__["root_squash"] = None
        __props__.__dict__["share_quota"] = None
        __props__.__dict__["share_usage_bytes"] = None
        __props__.__dict__["signed_identifiers"] = None
        __props__.__dict__["snapshot_time"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["version"] = None
        return FileShare(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessTier")
    def access_tier(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Access tier for specific share. GpV2 account can choose between TransactionOptimized (default), Hot, and Cool. FileStorage account can choose Premium.
        """
        return pulumi.get(self, "access_tier")

    @property
    @pulumi.getter(name="accessTierChangeTime")
    def access_tier_change_time(self) -> pulumi.Output[builtins.str]:
        """
        Indicates the last modification time for share access tier.
        """
        return pulumi.get(self, "access_tier_change_time")

    @property
    @pulumi.getter(name="accessTierStatus")
    def access_tier_status(self) -> pulumi.Output[builtins.str]:
        """
        Indicates if there is a pending transition for access tier.
        """
        return pulumi.get(self, "access_tier_status")

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def deleted(self) -> pulumi.Output[builtins.bool]:
        """
        Indicates whether the share was deleted.
        """
        return pulumi.get(self, "deleted")

    @property
    @pulumi.getter(name="deletedTime")
    def deleted_time(self) -> pulumi.Output[builtins.str]:
        """
        The deleted time if the share was deleted.
        """
        return pulumi.get(self, "deleted_time")

    @property
    @pulumi.getter(name="enabledProtocols")
    def enabled_protocols(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The authentication protocol that is used for the file share. Can only be specified when creating a share.
        """
        return pulumi.get(self, "enabled_protocols")

    @property
    @pulumi.getter
    def etag(self) -> pulumi.Output[builtins.str]:
        """
        Resource Etag.
        """
        return pulumi.get(self, "etag")

    @property
    @pulumi.getter(name="fileSharePaidBursting")
    def file_share_paid_bursting(self) -> pulumi.Output[Optional['outputs.FileSharePropertiesResponseFileSharePaidBursting']]:
        """
        File Share Paid Bursting properties.
        """
        return pulumi.get(self, "file_share_paid_bursting")

    @property
    @pulumi.getter(name="includedBurstIops")
    def included_burst_iops(self) -> pulumi.Output[builtins.int]:
        """
        The calculated burst IOPS of the share. This property is only for file shares created under Files Provisioned v2 account type.
        """
        return pulumi.get(self, "included_burst_iops")

    @property
    @pulumi.getter(name="lastModifiedTime")
    def last_modified_time(self) -> pulumi.Output[builtins.str]:
        """
        Returns the date and time the share was last modified.
        """
        return pulumi.get(self, "last_modified_time")

    @property
    @pulumi.getter(name="leaseDuration")
    def lease_duration(self) -> pulumi.Output[builtins.str]:
        """
        Specifies whether the lease on a share is of infinite or fixed duration, only when the share is leased.
        """
        return pulumi.get(self, "lease_duration")

    @property
    @pulumi.getter(name="leaseState")
    def lease_state(self) -> pulumi.Output[builtins.str]:
        """
        Lease state of the share.
        """
        return pulumi.get(self, "lease_state")

    @property
    @pulumi.getter(name="leaseStatus")
    def lease_status(self) -> pulumi.Output[builtins.str]:
        """
        The lease status of the share.
        """
        return pulumi.get(self, "lease_status")

    @property
    @pulumi.getter(name="maxBurstCreditsForIops")
    def max_burst_credits_for_iops(self) -> pulumi.Output[builtins.float]:
        """
        The calculated maximum burst credits for the share. This property is only for file shares created under Files Provisioned v2 account type.
        """
        return pulumi.get(self, "max_burst_credits_for_iops")

    @property
    @pulumi.getter
    def metadata(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        A name-value pair to associate with the share as metadata.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nextAllowedProvisionedBandwidthDowngradeTime")
    def next_allowed_provisioned_bandwidth_downgrade_time(self) -> pulumi.Output[builtins.str]:
        """
        Returns the next allowed provisioned bandwidth downgrade time for the share. This property is only for file shares created under Files Provisioned v2 account type.
        """
        return pulumi.get(self, "next_allowed_provisioned_bandwidth_downgrade_time")

    @property
    @pulumi.getter(name="nextAllowedProvisionedIopsDowngradeTime")
    def next_allowed_provisioned_iops_downgrade_time(self) -> pulumi.Output[builtins.str]:
        """
        Returns the next allowed provisioned IOPS downgrade time for the share. This property is only for file shares created under Files Provisioned v2 account type.
        """
        return pulumi.get(self, "next_allowed_provisioned_iops_downgrade_time")

    @property
    @pulumi.getter(name="nextAllowedQuotaDowngradeTime")
    def next_allowed_quota_downgrade_time(self) -> pulumi.Output[builtins.str]:
        """
        Returns the next allowed provisioned storage size downgrade time for the share. This property is only for file shares created under Files Provisioned v1 SSD and Files Provisioned v2 account type
        """
        return pulumi.get(self, "next_allowed_quota_downgrade_time")

    @property
    @pulumi.getter(name="provisionedBandwidthMibps")
    def provisioned_bandwidth_mibps(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The provisioned bandwidth of the share, in mebibytes per second. This property is only for file shares created under Files Provisioned v2 account type. Please refer to the GetFileServiceUsage API response for the minimum and maximum allowed value for provisioned bandwidth.
        """
        return pulumi.get(self, "provisioned_bandwidth_mibps")

    @property
    @pulumi.getter(name="provisionedIops")
    def provisioned_iops(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The provisioned IOPS of the share. This property is only for file shares created under Files Provisioned v2 account type. Please refer to the GetFileServiceUsage API response for the minimum and maximum allowed value for provisioned IOPS.
        """
        return pulumi.get(self, "provisioned_iops")

    @property
    @pulumi.getter(name="remainingRetentionDays")
    def remaining_retention_days(self) -> pulumi.Output[builtins.int]:
        """
        Remaining retention days for share that was soft deleted.
        """
        return pulumi.get(self, "remaining_retention_days")

    @property
    @pulumi.getter(name="rootSquash")
    def root_squash(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The property is for NFS share only. The default is NoRootSquash.
        """
        return pulumi.get(self, "root_squash")

    @property
    @pulumi.getter(name="shareQuota")
    def share_quota(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The provisioned size of the share, in gibibytes. Must be greater than 0, and less than or equal to 5TB (5120). For Large File Shares, the maximum size is 102400. For file shares created under Files Provisioned v2 account type, please refer to the GetFileServiceUsage API response for the minimum and maximum allowed provisioned storage size.
        """
        return pulumi.get(self, "share_quota")

    @property
    @pulumi.getter(name="shareUsageBytes")
    def share_usage_bytes(self) -> pulumi.Output[builtins.float]:
        """
        The approximate size of the data stored on the share. Note that this value may not include all recently created or recently resized files.
        """
        return pulumi.get(self, "share_usage_bytes")

    @property
    @pulumi.getter(name="signedIdentifiers")
    def signed_identifiers(self) -> pulumi.Output[Optional[Sequence['outputs.SignedIdentifierResponse']]]:
        """
        List of stored access policies specified on the share.
        """
        return pulumi.get(self, "signed_identifiers")

    @property
    @pulumi.getter(name="snapshotTime")
    def snapshot_time(self) -> pulumi.Output[builtins.str]:
        """
        Creation time of share snapshot returned in the response of list shares with expand param "snapshots".
        """
        return pulumi.get(self, "snapshot_time")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[builtins.str]:
        """
        The version of the share.
        """
        return pulumi.get(self, "version")

