# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListLocalUserKeysResult',
    'AwaitableListLocalUserKeysResult',
    'list_local_user_keys',
    'list_local_user_keys_output',
]

@pulumi.output_type
class ListLocalUserKeysResult:
    """
    The Storage Account Local User keys.
    """
    def __init__(__self__, shared_key=None, ssh_authorized_keys=None):
        if shared_key and not isinstance(shared_key, str):
            raise TypeError("Expected argument 'shared_key' to be a str")
        pulumi.set(__self__, "shared_key", shared_key)
        if ssh_authorized_keys and not isinstance(ssh_authorized_keys, list):
            raise TypeError("Expected argument 'ssh_authorized_keys' to be a list")
        pulumi.set(__self__, "ssh_authorized_keys", ssh_authorized_keys)

    @property
    @pulumi.getter(name="sharedKey")
    def shared_key(self) -> builtins.str:
        """
        Auto generated by the server for SMB authentication.
        """
        return pulumi.get(self, "shared_key")

    @property
    @pulumi.getter(name="sshAuthorizedKeys")
    def ssh_authorized_keys(self) -> Optional[Sequence['outputs.SshPublicKeyResponse']]:
        """
        Optional, local user ssh authorized keys for SFTP.
        """
        return pulumi.get(self, "ssh_authorized_keys")


class AwaitableListLocalUserKeysResult(ListLocalUserKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListLocalUserKeysResult(
            shared_key=self.shared_key,
            ssh_authorized_keys=self.ssh_authorized_keys)


def list_local_user_keys(account_name: Optional[builtins.str] = None,
                         resource_group_name: Optional[builtins.str] = None,
                         username: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListLocalUserKeysResult:
    """
    List SSH authorized keys and shared key of the local user.

    Uses Azure REST API version 2024-01-01.

    Other available API versions: 2022-09-01, 2023-01-01, 2023-04-01, 2023-05-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native storage [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str account_name: The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.
    :param builtins.str resource_group_name: The name of the resource group within the user's subscription. The name is case insensitive.
    :param builtins.str username: The name of local user. The username must contain lowercase letters and numbers only. It must be unique only within the storage account.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['username'] = username
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:storage:listLocalUserKeys', __args__, opts=opts, typ=ListLocalUserKeysResult).value

    return AwaitableListLocalUserKeysResult(
        shared_key=pulumi.get(__ret__, 'shared_key'),
        ssh_authorized_keys=pulumi.get(__ret__, 'ssh_authorized_keys'))
def list_local_user_keys_output(account_name: Optional[pulumi.Input[builtins.str]] = None,
                                resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                username: Optional[pulumi.Input[builtins.str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListLocalUserKeysResult]:
    """
    List SSH authorized keys and shared key of the local user.

    Uses Azure REST API version 2024-01-01.

    Other available API versions: 2022-09-01, 2023-01-01, 2023-04-01, 2023-05-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native storage [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str account_name: The name of the storage account within the specified resource group. Storage account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.
    :param builtins.str resource_group_name: The name of the resource group within the user's subscription. The name is case insensitive.
    :param builtins.str username: The name of local user. The username must contain lowercase letters and numbers only. It must be unique only within the storage account.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['username'] = username
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:storage:listLocalUserKeys', __args__, opts=opts, typ=ListLocalUserKeysResult)
    return __ret__.apply(lambda __response__: ListLocalUserKeysResult(
        shared_key=pulumi.get(__response__, 'shared_key'),
        ssh_authorized_keys=pulumi.get(__response__, 'ssh_authorized_keys')))
