# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import pulumi
from enum import Enum

__all__ = [
    'AmlFilesystemIdentityType',
    'AmlFilesystemSquashMode',
    'AutoExportJobAdminStatus',
    'AutoExportStatusType',
    'CacheIdentityType',
    'ConflictResolutionMode',
    'MaintenanceDayOfWeekType',
    'NfsAccessRuleAccess',
    'NfsAccessRuleScope',
    'OperationalStateType',
    'StorageTargetType',
    'UsernameSource',
]


@pulumi.type_token("azure-native:storagecache:AmlFilesystemIdentityType")
class AmlFilesystemIdentityType(builtins.str, Enum):
    """
    The type of identity used for the resource.
    """
    USER_ASSIGNED = "UserAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:storagecache:AmlFilesystemSquashMode")
class AmlFilesystemSquashMode(builtins.str, Enum):
    """
    Squash mode of the AML file system. 'All': User and Group IDs on files will be squashed to the provided values for all users on non-trusted systems. 'RootOnly': User and Group IDs on files will be squashed to provided values for solely the root user on non-trusted systems. 'None': No squashing of User and Group IDs is performed for any users on any systems.
    """
    NONE = "None"
    ROOT_ONLY = "RootOnly"
    ALL = "All"


@pulumi.type_token("azure-native:storagecache:AutoExportJobAdminStatus")
class AutoExportJobAdminStatus(builtins.str, Enum):
    """
    The administrative status of the auto export job. Possible values: 'Enable', 'Disable'. Passing in a value of 'Disable' will disable the current active auto export job. By default it is set to 'Enable'.
    """
    ENABLE = "Enable"
    DISABLE = "Disable"


@pulumi.type_token("azure-native:storagecache:AutoExportStatusType")
class AutoExportStatusType(builtins.str, Enum):
    """
    The operational state of auto export. InProgress indicates the export is running.  Disabling indicates the user has requested to disable the export but the disabling is still in progress. Disabled indicates auto export has been disabled.  DisableFailed indicates the disabling has failed.  Failed means the export was unable to continue, due to a fatal error.
    """
    IN_PROGRESS = "InProgress"
    DISABLING = "Disabling"
    DISABLED = "Disabled"
    DISABLE_FAILED = "DisableFailed"
    FAILED = "Failed"


@pulumi.type_token("azure-native:storagecache:CacheIdentityType")
class CacheIdentityType(builtins.str, Enum):
    """
    The type of identity used for the cache
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"
    NONE = "None"


@pulumi.type_token("azure-native:storagecache:ConflictResolutionMode")
class ConflictResolutionMode(builtins.str, Enum):
    """
    How the import job will handle conflicts. For example, if the import job is trying to bring in a directory, but a file is at that path, how it handles it. Fail indicates that the import job should stop immediately and not do anything with the conflict. Skip indicates that it should pass over the conflict. OverwriteIfDirty causes the import job to delete and re-import the file or directory if it is a conflicting type, is dirty, or was not previously imported. OverwriteAlways extends OverwriteIfDirty to include releasing files that had been restored but were not dirty. Please reference https://learn.microsoft.com/en-us/azure/azure-managed-lustre/ for a thorough explanation of these resolution modes.
    """
    FAIL = "Fail"
    SKIP = "Skip"
    OVERWRITE_IF_DIRTY = "OverwriteIfDirty"
    OVERWRITE_ALWAYS = "OverwriteAlways"


@pulumi.type_token("azure-native:storagecache:MaintenanceDayOfWeekType")
class MaintenanceDayOfWeekType(builtins.str, Enum):
    """
    Day of the week on which the maintenance window will occur.
    """
    MONDAY = "Monday"
    TUESDAY = "Tuesday"
    WEDNESDAY = "Wednesday"
    THURSDAY = "Thursday"
    FRIDAY = "Friday"
    SATURDAY = "Saturday"
    SUNDAY = "Sunday"


@pulumi.type_token("azure-native:storagecache:NfsAccessRuleAccess")
class NfsAccessRuleAccess(builtins.str, Enum):
    """
    Access allowed by this rule.
    """
    NO = "no"
    RO = "ro"
    RW = "rw"


@pulumi.type_token("azure-native:storagecache:NfsAccessRuleScope")
class NfsAccessRuleScope(builtins.str, Enum):
    """
    Scope for this rule. The scope and filter determine which clients match the rule.
    """
    DEFAULT = "default"
    NETWORK = "network"
    HOST = "host"


@pulumi.type_token("azure-native:storagecache:OperationalStateType")
class OperationalStateType(builtins.str, Enum):
    """
    Storage target operational state.
    """
    READY = "Ready"
    BUSY = "Busy"
    SUSPENDED = "Suspended"
    FLUSHING = "Flushing"


@pulumi.type_token("azure-native:storagecache:StorageTargetType")
class StorageTargetType(builtins.str, Enum):
    """
    Type of the Storage Target.
    """
    NFS3 = "nfs3"
    CLFS = "clfs"
    UNKNOWN = "unknown"
    BLOB_NFS = "blobNfs"


@pulumi.type_token("azure-native:storagecache:UsernameSource")
class UsernameSource(builtins.str, Enum):
    """
    This setting determines how the cache gets username and group names for clients.
    """
    AD = "AD"
    LDAP = "LDAP"
    FILE = "File"
    NONE = "None"
