# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetManagerDevicePublicEncryptionKeyResult',
    'AwaitableGetManagerDevicePublicEncryptionKeyResult',
    'get_manager_device_public_encryption_key',
    'get_manager_device_public_encryption_key_output',
]

@pulumi.output_type
class GetManagerDevicePublicEncryptionKeyResult:
    """
    The public key.
    """
    def __init__(__self__, key=None):
        if key and not isinstance(key, str):
            raise TypeError("Expected argument 'key' to be a str")
        pulumi.set(__self__, "key", key)

    @property
    @pulumi.getter
    def key(self) -> builtins.str:
        """
        The key.
        """
        return pulumi.get(self, "key")


class AwaitableGetManagerDevicePublicEncryptionKeyResult(GetManagerDevicePublicEncryptionKeyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetManagerDevicePublicEncryptionKeyResult(
            key=self.key)


def get_manager_device_public_encryption_key(device_name: Optional[builtins.str] = None,
                                             manager_name: Optional[builtins.str] = None,
                                             resource_group_name: Optional[builtins.str] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetManagerDevicePublicEncryptionKeyResult:
    """
    Returns the public encryption key of the device.

    Uses Azure REST API version 2017-06-01.


    :param builtins.str device_name: The device name
    :param builtins.str manager_name: The manager name
    :param builtins.str resource_group_name: The resource group name
    """
    __args__ = dict()
    __args__['deviceName'] = device_name
    __args__['managerName'] = manager_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:storsimple:getManagerDevicePublicEncryptionKey', __args__, opts=opts, typ=GetManagerDevicePublicEncryptionKeyResult).value

    return AwaitableGetManagerDevicePublicEncryptionKeyResult(
        key=pulumi.get(__ret__, 'key'))
def get_manager_device_public_encryption_key_output(device_name: Optional[pulumi.Input[builtins.str]] = None,
                                                    manager_name: Optional[pulumi.Input[builtins.str]] = None,
                                                    resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetManagerDevicePublicEncryptionKeyResult]:
    """
    Returns the public encryption key of the device.

    Uses Azure REST API version 2017-06-01.


    :param builtins.str device_name: The device name
    :param builtins.str manager_name: The manager name
    :param builtins.str resource_group_name: The resource group name
    """
    __args__ = dict()
    __args__['deviceName'] = device_name
    __args__['managerName'] = manager_name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:storsimple:getManagerDevicePublicEncryptionKey', __args__, opts=opts, typ=GetManagerDevicePublicEncryptionKeyResult)
    return __ret__.apply(lambda __response__: GetManagerDevicePublicEncryptionKeyResult(
        key=pulumi.get(__response__, 'key')))
