# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'ListKustoPoolFollowerDatabasesResult',
    'AwaitableListKustoPoolFollowerDatabasesResult',
    'list_kusto_pool_follower_databases',
    'list_kusto_pool_follower_databases_output',
]

@pulumi.output_type
class ListKustoPoolFollowerDatabasesResult:
    """
    The list Kusto database principals operation response.
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.FollowerDatabaseDefinitionResponse']]:
        """
        The list of follower database result.
        """
        return pulumi.get(self, "value")


class AwaitableListKustoPoolFollowerDatabasesResult(ListKustoPoolFollowerDatabasesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListKustoPoolFollowerDatabasesResult(
            value=self.value)


def list_kusto_pool_follower_databases(kusto_pool_name: Optional[builtins.str] = None,
                                       resource_group_name: Optional[builtins.str] = None,
                                       workspace_name: Optional[builtins.str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListKustoPoolFollowerDatabasesResult:
    """
    Returns a list of databases that are owned by this Kusto Pool and were followed by another Kusto Pool.

    Uses Azure REST API version 2021-06-01-preview.


    :param builtins.str kusto_pool_name: The name of the Kusto pool.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str workspace_name: The name of the workspace.
    """
    __args__ = dict()
    __args__['kustoPoolName'] = kusto_pool_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:synapse:listKustoPoolFollowerDatabases', __args__, opts=opts, typ=ListKustoPoolFollowerDatabasesResult).value

    return AwaitableListKustoPoolFollowerDatabasesResult(
        value=pulumi.get(__ret__, 'value'))
def list_kusto_pool_follower_databases_output(kusto_pool_name: Optional[pulumi.Input[builtins.str]] = None,
                                              resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                              workspace_name: Optional[pulumi.Input[builtins.str]] = None,
                                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListKustoPoolFollowerDatabasesResult]:
    """
    Returns a list of databases that are owned by this Kusto Pool and were followed by another Kusto Pool.

    Uses Azure REST API version 2021-06-01-preview.


    :param builtins.str kusto_pool_name: The name of the Kusto pool.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str workspace_name: The name of the workspace.
    """
    __args__ = dict()
    __args__['kustoPoolName'] = kusto_pool_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['workspaceName'] = workspace_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:synapse:listKustoPoolFollowerDatabases', __args__, opts=opts, typ=ListKustoPoolFollowerDatabasesResult)
    return __ret__.apply(lambda __response__: ListKustoPoolFollowerDatabasesResult(
        value=pulumi.get(__response__, 'value')))
