# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetTestResultVideoDownloadURLResult',
    'AwaitableGetTestResultVideoDownloadURLResult',
    'get_test_result_video_download_url',
    'get_test_result_video_download_url_output',
]

@pulumi.output_type
class GetTestResultVideoDownloadURLResult:
    """
    The response of getting a download URL.
    """
    def __init__(__self__, download_url=None, expiration_time=None):
        if download_url and not isinstance(download_url, str):
            raise TypeError("Expected argument 'download_url' to be a str")
        pulumi.set(__self__, "download_url", download_url)
        if expiration_time and not isinstance(expiration_time, str):
            raise TypeError("Expected argument 'expiration_time' to be a str")
        pulumi.set(__self__, "expiration_time", expiration_time)

    @property
    @pulumi.getter(name="downloadUrl")
    def download_url(self) -> builtins.str:
        """
        The download URL.
        """
        return pulumi.get(self, "download_url")

    @property
    @pulumi.getter(name="expirationTime")
    def expiration_time(self) -> builtins.str:
        """
        Expiry date of the download URL.
        """
        return pulumi.get(self, "expiration_time")


class AwaitableGetTestResultVideoDownloadURLResult(GetTestResultVideoDownloadURLResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTestResultVideoDownloadURLResult(
            download_url=self.download_url,
            expiration_time=self.expiration_time)


def get_test_result_video_download_url(package_name: Optional[builtins.str] = None,
                                       resource_group_name: Optional[builtins.str] = None,
                                       test_base_account_name: Optional[builtins.str] = None,
                                       test_result_name: Optional[builtins.str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTestResultVideoDownloadURLResult:
    """
    Gets the download URL of the test execution screen recording.

    Uses Azure REST API version 2023-11-01-preview.

    Other available API versions: 2022-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native testbase [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str package_name: The resource name of the Test Base Package.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str test_base_account_name: The resource name of the Test Base Account.
    :param builtins.str test_result_name: The Test Result Name. It equals to TestResult-{TestResultId} string.
    """
    __args__ = dict()
    __args__['packageName'] = package_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['testBaseAccountName'] = test_base_account_name
    __args__['testResultName'] = test_result_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:testbase:getTestResultVideoDownloadURL', __args__, opts=opts, typ=GetTestResultVideoDownloadURLResult).value

    return AwaitableGetTestResultVideoDownloadURLResult(
        download_url=pulumi.get(__ret__, 'download_url'),
        expiration_time=pulumi.get(__ret__, 'expiration_time'))
def get_test_result_video_download_url_output(package_name: Optional[pulumi.Input[builtins.str]] = None,
                                              resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                              test_base_account_name: Optional[pulumi.Input[builtins.str]] = None,
                                              test_result_name: Optional[pulumi.Input[builtins.str]] = None,
                                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTestResultVideoDownloadURLResult]:
    """
    Gets the download URL of the test execution screen recording.

    Uses Azure REST API version 2023-11-01-preview.

    Other available API versions: 2022-04-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native testbase [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str package_name: The resource name of the Test Base Package.
    :param builtins.str resource_group_name: The name of the resource group. The name is case insensitive.
    :param builtins.str test_base_account_name: The resource name of the Test Base Account.
    :param builtins.str test_result_name: The Test Result Name. It equals to TestResult-{TestResultId} string.
    """
    __args__ = dict()
    __args__['packageName'] = package_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['testBaseAccountName'] = test_base_account_name
    __args__['testResultName'] = test_result_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:testbase:getTestResultVideoDownloadURL', __args__, opts=opts, typ=GetTestResultVideoDownloadURLResult)
    return __ret__.apply(lambda __response__: GetTestResultVideoDownloadURLResult(
        download_url=pulumi.get(__response__, 'download_url'),
        expiration_time=pulumi.get(__response__, 'expiration_time')))
