# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DedicatedCloudNodeArgs', 'DedicatedCloudNode']

@pulumi.input_type
class DedicatedCloudNodeArgs:
    def __init__(__self__, *,
                 availability_zone_id: pulumi.Input[builtins.str],
                 id: pulumi.Input[builtins.str],
                 name: pulumi.Input[builtins.str],
                 nodes_count: pulumi.Input[builtins.int],
                 placement_group_id: pulumi.Input[builtins.str],
                 purchase_id: pulumi.Input[builtins.str],
                 resource_group_name: pulumi.Input[builtins.str],
                 dedicated_cloud_node_name: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 sku: Optional[pulumi.Input['SkuArgs']] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None):
        """
        The set of arguments for constructing a DedicatedCloudNode resource.
        :param pulumi.Input[builtins.str] availability_zone_id: Availability Zone id, e.g. "az1"
        :param pulumi.Input[builtins.str] id: SKU's id
        :param pulumi.Input[builtins.str] name: SKU's name
        :param pulumi.Input[builtins.int] nodes_count: count of nodes to create
        :param pulumi.Input[builtins.str] placement_group_id: Placement Group id, e.g. "n1"
        :param pulumi.Input[builtins.str] purchase_id: purchase id
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group
        :param pulumi.Input[builtins.str] dedicated_cloud_node_name: dedicated cloud node name
        :param pulumi.Input[builtins.str] location: Azure region
        :param pulumi.Input['SkuArgs'] sku: Dedicated Cloud Nodes SKU
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: Dedicated Cloud Nodes tags
        """
        pulumi.set(__self__, "availability_zone_id", availability_zone_id)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "nodes_count", nodes_count)
        pulumi.set(__self__, "placement_group_id", placement_group_id)
        pulumi.set(__self__, "purchase_id", purchase_id)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if dedicated_cloud_node_name is not None:
            pulumi.set(__self__, "dedicated_cloud_node_name", dedicated_cloud_node_name)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if sku is not None:
            pulumi.set(__self__, "sku", sku)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="availabilityZoneId")
    def availability_zone_id(self) -> pulumi.Input[builtins.str]:
        """
        Availability Zone id, e.g. "az1"
        """
        return pulumi.get(self, "availability_zone_id")

    @availability_zone_id.setter
    def availability_zone_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "availability_zone_id", value)

    @property
    @pulumi.getter
    def id(self) -> pulumi.Input[builtins.str]:
        """
        SKU's id
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[builtins.str]:
        """
        SKU's name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="nodesCount")
    def nodes_count(self) -> pulumi.Input[builtins.int]:
        """
        count of nodes to create
        """
        return pulumi.get(self, "nodes_count")

    @nodes_count.setter
    def nodes_count(self, value: pulumi.Input[builtins.int]):
        pulumi.set(self, "nodes_count", value)

    @property
    @pulumi.getter(name="placementGroupId")
    def placement_group_id(self) -> pulumi.Input[builtins.str]:
        """
        Placement Group id, e.g. "n1"
        """
        return pulumi.get(self, "placement_group_id")

    @placement_group_id.setter
    def placement_group_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "placement_group_id", value)

    @property
    @pulumi.getter(name="purchaseId")
    def purchase_id(self) -> pulumi.Input[builtins.str]:
        """
        purchase id
        """
        return pulumi.get(self, "purchase_id")

    @purchase_id.setter
    def purchase_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "purchase_id", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[builtins.str]:
        """
        The name of the resource group
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter(name="dedicatedCloudNodeName")
    def dedicated_cloud_node_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        dedicated cloud node name
        """
        return pulumi.get(self, "dedicated_cloud_node_name")

    @dedicated_cloud_node_name.setter
    def dedicated_cloud_node_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "dedicated_cloud_node_name", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Azure region
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def sku(self) -> Optional[pulumi.Input['SkuArgs']]:
        """
        Dedicated Cloud Nodes SKU
        """
        return pulumi.get(self, "sku")

    @sku.setter
    def sku(self, value: Optional[pulumi.Input['SkuArgs']]):
        pulumi.set(self, "sku", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]:
        """
        Dedicated Cloud Nodes tags
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.type_token("azure-native:vmwarecloudsimple:DedicatedCloudNode")
class DedicatedCloudNode(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 availability_zone_id: Optional[pulumi.Input[builtins.str]] = None,
                 dedicated_cloud_node_name: Optional[pulumi.Input[builtins.str]] = None,
                 id: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 nodes_count: Optional[pulumi.Input[builtins.int]] = None,
                 placement_group_id: Optional[pulumi.Input[builtins.str]] = None,
                 purchase_id: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 sku: Optional[pulumi.Input[Union['SkuArgs', 'SkuArgsDict']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        """
        Dedicated cloud node model

        Uses Azure REST API version 2019-04-01. In version 2.x of the Azure Native provider, it used API version 2019-04-01.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] availability_zone_id: Availability Zone id, e.g. "az1"
        :param pulumi.Input[builtins.str] dedicated_cloud_node_name: dedicated cloud node name
        :param pulumi.Input[builtins.str] id: SKU's id
        :param pulumi.Input[builtins.str] location: Azure region
        :param pulumi.Input[builtins.str] name: SKU's name
        :param pulumi.Input[builtins.int] nodes_count: count of nodes to create
        :param pulumi.Input[builtins.str] placement_group_id: Placement Group id, e.g. "n1"
        :param pulumi.Input[builtins.str] purchase_id: purchase id
        :param pulumi.Input[builtins.str] resource_group_name: The name of the resource group
        :param pulumi.Input[Union['SkuArgs', 'SkuArgsDict']] sku: Dedicated Cloud Nodes SKU
        :param pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]] tags: Dedicated Cloud Nodes tags
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DedicatedCloudNodeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Dedicated cloud node model

        Uses Azure REST API version 2019-04-01. In version 2.x of the Azure Native provider, it used API version 2019-04-01.

        :param str resource_name: The name of the resource.
        :param DedicatedCloudNodeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DedicatedCloudNodeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 availability_zone_id: Optional[pulumi.Input[builtins.str]] = None,
                 dedicated_cloud_node_name: Optional[pulumi.Input[builtins.str]] = None,
                 id: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 nodes_count: Optional[pulumi.Input[builtins.int]] = None,
                 placement_group_id: Optional[pulumi.Input[builtins.str]] = None,
                 purchase_id: Optional[pulumi.Input[builtins.str]] = None,
                 resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                 sku: Optional[pulumi.Input[Union['SkuArgs', 'SkuArgsDict']]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[builtins.str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DedicatedCloudNodeArgs.__new__(DedicatedCloudNodeArgs)

            if availability_zone_id is None and not opts.urn:
                raise TypeError("Missing required property 'availability_zone_id'")
            __props__.__dict__["availability_zone_id"] = availability_zone_id
            __props__.__dict__["dedicated_cloud_node_name"] = dedicated_cloud_node_name
            if id is None and not opts.urn:
                raise TypeError("Missing required property 'id'")
            __props__.__dict__["id"] = id
            __props__.__dict__["location"] = location
            if name is None and not opts.urn:
                raise TypeError("Missing required property 'name'")
            __props__.__dict__["name"] = name
            if nodes_count is None and not opts.urn:
                raise TypeError("Missing required property 'nodes_count'")
            __props__.__dict__["nodes_count"] = nodes_count
            if placement_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'placement_group_id'")
            __props__.__dict__["placement_group_id"] = placement_group_id
            if purchase_id is None and not opts.urn:
                raise TypeError("Missing required property 'purchase_id'")
            __props__.__dict__["purchase_id"] = purchase_id
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["sku"] = sku
            __props__.__dict__["tags"] = tags
            __props__.__dict__["azure_api_version"] = None
            __props__.__dict__["properties"] = None
            __props__.__dict__["type"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-native:vmwarecloudsimple/v20190401:DedicatedCloudNode")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(DedicatedCloudNode, __self__).__init__(
            'azure-native:vmwarecloudsimple:DedicatedCloudNode',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'DedicatedCloudNode':
        """
        Get an existing DedicatedCloudNode resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = DedicatedCloudNodeArgs.__new__(DedicatedCloudNodeArgs)

        __props__.__dict__["azure_api_version"] = None
        __props__.__dict__["location"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["properties"] = None
        __props__.__dict__["sku"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["type"] = None
        return DedicatedCloudNode(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> pulumi.Output[builtins.str]:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[builtins.str]:
        """
        Azure region
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        {dedicatedCloudNodeName}
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> pulumi.Output['outputs.DedicatedCloudNodePropertiesResponse']:
        """
        Dedicated Cloud Nodes properties
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def sku(self) -> pulumi.Output[Optional['outputs.SkuResponse']]:
        """
        Dedicated Cloud Nodes SKU
        """
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, builtins.str]]]:
        """
        Dedicated Cloud Nodes tags
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        {resourceProviderNamespace}/{resourceType}
        """
        return pulumi.get(self, "type")

