# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'DedicatedCloudNodePropertiesResponse',
    'GuestOSCustomizationResponse',
    'GuestOSNICCustomizationResponse',
    'ResourcePoolResponse',
    'SkuResponse',
    'VirtualDiskControllerResponse',
    'VirtualDiskResponse',
    'VirtualNetworkResponse',
    'VirtualNicResponse',
]

@pulumi.output_type
class DedicatedCloudNodePropertiesResponse(dict):
    """
    Properties of dedicated cloud node
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "availabilityZoneId":
            suggest = "availability_zone_id"
        elif key == "availabilityZoneName":
            suggest = "availability_zone_name"
        elif key == "cloudRackName":
            suggest = "cloud_rack_name"
        elif key == "nodesCount":
            suggest = "nodes_count"
        elif key == "placementGroupId":
            suggest = "placement_group_id"
        elif key == "placementGroupName":
            suggest = "placement_group_name"
        elif key == "privateCloudId":
            suggest = "private_cloud_id"
        elif key == "privateCloudName":
            suggest = "private_cloud_name"
        elif key == "provisioningState":
            suggest = "provisioning_state"
        elif key == "purchaseId":
            suggest = "purchase_id"
        elif key == "vmwareClusterName":
            suggest = "vmware_cluster_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DedicatedCloudNodePropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DedicatedCloudNodePropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DedicatedCloudNodePropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 availability_zone_id: builtins.str,
                 availability_zone_name: builtins.str,
                 cloud_rack_name: builtins.str,
                 created: builtins.str,
                 id: builtins.str,
                 name: builtins.str,
                 nodes_count: builtins.int,
                 placement_group_id: builtins.str,
                 placement_group_name: builtins.str,
                 private_cloud_id: builtins.str,
                 private_cloud_name: builtins.str,
                 provisioning_state: builtins.str,
                 purchase_id: builtins.str,
                 status: builtins.str,
                 vmware_cluster_name: builtins.str):
        """
        Properties of dedicated cloud node
        :param builtins.str availability_zone_id: Availability Zone id, e.g. "az1"
        :param builtins.str availability_zone_name: Availability Zone name, e.g. "Availability Zone 1"
        :param builtins.str cloud_rack_name: VMWare Cloud Rack Name
        :param builtins.str created: date time the resource was created
        :param builtins.str id: SKU's id
        :param builtins.str name: SKU's name
        :param builtins.int nodes_count: count of nodes to create
        :param builtins.str placement_group_id: Placement Group id, e.g. "n1"
        :param builtins.str placement_group_name: Placement Name, e.g. "Placement Group 1"
        :param builtins.str private_cloud_id: Private Cloud Id
        :param builtins.str private_cloud_name: Resource Pool Name
        :param builtins.str provisioning_state: The provisioning status of the resource
        :param builtins.str purchase_id: purchase id
        :param builtins.str status: Node status, indicates is private cloud set up on this node or not
        :param builtins.str vmware_cluster_name: VMWare Cluster Name
        """
        pulumi.set(__self__, "availability_zone_id", availability_zone_id)
        pulumi.set(__self__, "availability_zone_name", availability_zone_name)
        pulumi.set(__self__, "cloud_rack_name", cloud_rack_name)
        pulumi.set(__self__, "created", created)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "nodes_count", nodes_count)
        pulumi.set(__self__, "placement_group_id", placement_group_id)
        pulumi.set(__self__, "placement_group_name", placement_group_name)
        pulumi.set(__self__, "private_cloud_id", private_cloud_id)
        pulumi.set(__self__, "private_cloud_name", private_cloud_name)
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        pulumi.set(__self__, "purchase_id", purchase_id)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "vmware_cluster_name", vmware_cluster_name)

    @property
    @pulumi.getter(name="availabilityZoneId")
    def availability_zone_id(self) -> builtins.str:
        """
        Availability Zone id, e.g. "az1"
        """
        return pulumi.get(self, "availability_zone_id")

    @property
    @pulumi.getter(name="availabilityZoneName")
    def availability_zone_name(self) -> builtins.str:
        """
        Availability Zone name, e.g. "Availability Zone 1"
        """
        return pulumi.get(self, "availability_zone_name")

    @property
    @pulumi.getter(name="cloudRackName")
    def cloud_rack_name(self) -> builtins.str:
        """
        VMWare Cloud Rack Name
        """
        return pulumi.get(self, "cloud_rack_name")

    @property
    @pulumi.getter
    def created(self) -> builtins.str:
        """
        date time the resource was created
        """
        return pulumi.get(self, "created")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        SKU's id
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        SKU's name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodesCount")
    def nodes_count(self) -> builtins.int:
        """
        count of nodes to create
        """
        return pulumi.get(self, "nodes_count")

    @property
    @pulumi.getter(name="placementGroupId")
    def placement_group_id(self) -> builtins.str:
        """
        Placement Group id, e.g. "n1"
        """
        return pulumi.get(self, "placement_group_id")

    @property
    @pulumi.getter(name="placementGroupName")
    def placement_group_name(self) -> builtins.str:
        """
        Placement Name, e.g. "Placement Group 1"
        """
        return pulumi.get(self, "placement_group_name")

    @property
    @pulumi.getter(name="privateCloudId")
    def private_cloud_id(self) -> builtins.str:
        """
        Private Cloud Id
        """
        return pulumi.get(self, "private_cloud_id")

    @property
    @pulumi.getter(name="privateCloudName")
    def private_cloud_name(self) -> builtins.str:
        """
        Resource Pool Name
        """
        return pulumi.get(self, "private_cloud_name")

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The provisioning status of the resource
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="purchaseId")
    def purchase_id(self) -> builtins.str:
        """
        purchase id
        """
        return pulumi.get(self, "purchase_id")

    @property
    @pulumi.getter
    def status(self) -> builtins.str:
        """
        Node status, indicates is private cloud set up on this node or not
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="vmwareClusterName")
    def vmware_cluster_name(self) -> builtins.str:
        """
        VMWare Cluster Name
        """
        return pulumi.get(self, "vmware_cluster_name")


@pulumi.output_type
class GuestOSCustomizationResponse(dict):
    """
    Guest OS Customization properties
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dnsServers":
            suggest = "dns_servers"
        elif key == "hostName":
            suggest = "host_name"
        elif key == "policyId":
            suggest = "policy_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GuestOSCustomizationResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GuestOSCustomizationResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GuestOSCustomizationResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dns_servers: Optional[Sequence[builtins.str]] = None,
                 host_name: Optional[builtins.str] = None,
                 password: Optional[builtins.str] = None,
                 policy_id: Optional[builtins.str] = None,
                 username: Optional[builtins.str] = None):
        """
        Guest OS Customization properties
        :param Sequence[builtins.str] dns_servers: List of dns servers to use
        :param builtins.str host_name: Virtual Machine hostname
        :param builtins.str password: Password for login
        :param builtins.str policy_id: id of customization policy
        :param builtins.str username: Username for login
        """
        if dns_servers is not None:
            pulumi.set(__self__, "dns_servers", dns_servers)
        if host_name is not None:
            pulumi.set(__self__, "host_name", host_name)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if policy_id is not None:
            pulumi.set(__self__, "policy_id", policy_id)
        if username is not None:
            pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="dnsServers")
    def dns_servers(self) -> Optional[Sequence[builtins.str]]:
        """
        List of dns servers to use
        """
        return pulumi.get(self, "dns_servers")

    @property
    @pulumi.getter(name="hostName")
    def host_name(self) -> Optional[builtins.str]:
        """
        Virtual Machine hostname
        """
        return pulumi.get(self, "host_name")

    @property
    @pulumi.getter
    def password(self) -> Optional[builtins.str]:
        """
        Password for login
        """
        return pulumi.get(self, "password")

    @property
    @pulumi.getter(name="policyId")
    def policy_id(self) -> Optional[builtins.str]:
        """
        id of customization policy
        """
        return pulumi.get(self, "policy_id")

    @property
    @pulumi.getter
    def username(self) -> Optional[builtins.str]:
        """
        Username for login
        """
        return pulumi.get(self, "username")


@pulumi.output_type
class GuestOSNICCustomizationResponse(dict):
    """
    Guest OS nic customization
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dnsServers":
            suggest = "dns_servers"
        elif key == "ipAddress":
            suggest = "ip_address"
        elif key == "primaryWinsServer":
            suggest = "primary_wins_server"
        elif key == "secondaryWinsServer":
            suggest = "secondary_wins_server"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GuestOSNICCustomizationResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GuestOSNICCustomizationResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GuestOSNICCustomizationResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 allocation: Optional[builtins.str] = None,
                 dns_servers: Optional[Sequence[builtins.str]] = None,
                 gateway: Optional[Sequence[builtins.str]] = None,
                 ip_address: Optional[builtins.str] = None,
                 mask: Optional[builtins.str] = None,
                 primary_wins_server: Optional[builtins.str] = None,
                 secondary_wins_server: Optional[builtins.str] = None):
        """
        Guest OS nic customization
        :param builtins.str allocation: IP address allocation method
        :param Sequence[builtins.str] dns_servers: List of dns servers to use
        :param Sequence[builtins.str] gateway: Gateway addresses assigned to nic
        :param builtins.str ip_address: Static ip address for nic
        :param builtins.str mask: Network mask for nic
        :param builtins.str primary_wins_server: primary WINS server for Windows
        :param builtins.str secondary_wins_server: secondary WINS server for Windows
        """
        if allocation is not None:
            pulumi.set(__self__, "allocation", allocation)
        if dns_servers is not None:
            pulumi.set(__self__, "dns_servers", dns_servers)
        if gateway is not None:
            pulumi.set(__self__, "gateway", gateway)
        if ip_address is not None:
            pulumi.set(__self__, "ip_address", ip_address)
        if mask is not None:
            pulumi.set(__self__, "mask", mask)
        if primary_wins_server is not None:
            pulumi.set(__self__, "primary_wins_server", primary_wins_server)
        if secondary_wins_server is not None:
            pulumi.set(__self__, "secondary_wins_server", secondary_wins_server)

    @property
    @pulumi.getter
    def allocation(self) -> Optional[builtins.str]:
        """
        IP address allocation method
        """
        return pulumi.get(self, "allocation")

    @property
    @pulumi.getter(name="dnsServers")
    def dns_servers(self) -> Optional[Sequence[builtins.str]]:
        """
        List of dns servers to use
        """
        return pulumi.get(self, "dns_servers")

    @property
    @pulumi.getter
    def gateway(self) -> Optional[Sequence[builtins.str]]:
        """
        Gateway addresses assigned to nic
        """
        return pulumi.get(self, "gateway")

    @property
    @pulumi.getter(name="ipAddress")
    def ip_address(self) -> Optional[builtins.str]:
        """
        Static ip address for nic
        """
        return pulumi.get(self, "ip_address")

    @property
    @pulumi.getter
    def mask(self) -> Optional[builtins.str]:
        """
        Network mask for nic
        """
        return pulumi.get(self, "mask")

    @property
    @pulumi.getter(name="primaryWinsServer")
    def primary_wins_server(self) -> Optional[builtins.str]:
        """
        primary WINS server for Windows
        """
        return pulumi.get(self, "primary_wins_server")

    @property
    @pulumi.getter(name="secondaryWinsServer")
    def secondary_wins_server(self) -> Optional[builtins.str]:
        """
        secondary WINS server for Windows
        """
        return pulumi.get(self, "secondary_wins_server")


@pulumi.output_type
class ResourcePoolResponse(dict):
    """
    Resource pool model
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "fullName":
            suggest = "full_name"
        elif key == "privateCloudId":
            suggest = "private_cloud_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ResourcePoolResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ResourcePoolResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ResourcePoolResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 full_name: builtins.str,
                 id: builtins.str,
                 location: builtins.str,
                 name: builtins.str,
                 private_cloud_id: builtins.str,
                 type: builtins.str):
        """
        Resource pool model
        :param builtins.str full_name: Hierarchical resource pool name
        :param builtins.str id: resource pool id (privateCloudId:vsphereId)
        :param builtins.str location: Azure region
        :param builtins.str name: {ResourcePoolName}
        :param builtins.str private_cloud_id: The Private Cloud Id
        :param builtins.str type: {resourceProviderNamespace}/{resourceType}
        """
        pulumi.set(__self__, "full_name", full_name)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "location", location)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "private_cloud_id", private_cloud_id)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="fullName")
    def full_name(self) -> builtins.str:
        """
        Hierarchical resource pool name
        """
        return pulumi.get(self, "full_name")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        resource pool id (privateCloudId:vsphereId)
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> builtins.str:
        """
        Azure region
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        {ResourcePoolName}
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="privateCloudId")
    def private_cloud_id(self) -> builtins.str:
        """
        The Private Cloud Id
        """
        return pulumi.get(self, "private_cloud_id")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        {resourceProviderNamespace}/{resourceType}
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class SkuResponse(dict):
    """
    The purchase SKU for CloudSimple paid resources
    """
    def __init__(__self__, *,
                 name: builtins.str,
                 capacity: Optional[builtins.str] = None,
                 description: Optional[builtins.str] = None,
                 family: Optional[builtins.str] = None,
                 tier: Optional[builtins.str] = None):
        """
        The purchase SKU for CloudSimple paid resources
        :param builtins.str name: The name of the SKU for VMWare CloudSimple Node
        :param builtins.str capacity: The capacity of the SKU
        :param builtins.str description: dedicatedCloudNode example: 8 x Ten-Core Intel® Xeon® Processor E5-2640 v4 2.40GHz 25MB Cache (90W); 12 x 64GB PC4-19200 2400MHz DDR4 ECC Registered DIMM, ...
        :param builtins.str family: If the service has different generations of hardware, for the same SKU, then that can be captured here
        :param builtins.str tier: The tier of the SKU
        """
        pulumi.set(__self__, "name", name)
        if capacity is not None:
            pulumi.set(__self__, "capacity", capacity)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if family is not None:
            pulumi.set(__self__, "family", family)
        if tier is not None:
            pulumi.set(__self__, "tier", tier)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The name of the SKU for VMWare CloudSimple Node
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def capacity(self) -> Optional[builtins.str]:
        """
        The capacity of the SKU
        """
        return pulumi.get(self, "capacity")

    @property
    @pulumi.getter
    def description(self) -> Optional[builtins.str]:
        """
        dedicatedCloudNode example: 8 x Ten-Core Intel® Xeon® Processor E5-2640 v4 2.40GHz 25MB Cache (90W); 12 x 64GB PC4-19200 2400MHz DDR4 ECC Registered DIMM, ...
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def family(self) -> Optional[builtins.str]:
        """
        If the service has different generations of hardware, for the same SKU, then that can be captured here
        """
        return pulumi.get(self, "family")

    @property
    @pulumi.getter
    def tier(self) -> Optional[builtins.str]:
        """
        The tier of the SKU
        """
        return pulumi.get(self, "tier")


@pulumi.output_type
class VirtualDiskControllerResponse(dict):
    """
    Virtual disk controller model
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "subType":
            suggest = "sub_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualDiskControllerResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualDiskControllerResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualDiskControllerResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 id: builtins.str,
                 name: builtins.str,
                 sub_type: builtins.str,
                 type: builtins.str):
        """
        Virtual disk controller model
        :param builtins.str id: Controller's id
        :param builtins.str name: The display name of Controller
        :param builtins.str sub_type: dik controller subtype (VMWARE_PARAVIRTUAL, BUS_PARALLEL, LSI_PARALLEL, LSI_SAS)
        :param builtins.str type: disk controller type (SCSI)
        """
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "sub_type", sub_type)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Controller's id
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The display name of Controller
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="subType")
    def sub_type(self) -> builtins.str:
        """
        dik controller subtype (VMWARE_PARAVIRTUAL, BUS_PARALLEL, LSI_PARALLEL, LSI_SAS)
        """
        return pulumi.get(self, "sub_type")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        disk controller type (SCSI)
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class VirtualDiskResponse(dict):
    """
    Virtual disk model
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "controllerId":
            suggest = "controller_id"
        elif key == "independenceMode":
            suggest = "independence_mode"
        elif key == "totalSize":
            suggest = "total_size"
        elif key == "virtualDiskName":
            suggest = "virtual_disk_name"
        elif key == "virtualDiskId":
            suggest = "virtual_disk_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualDiskResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualDiskResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualDiskResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 controller_id: builtins.str,
                 independence_mode: builtins.str,
                 total_size: builtins.int,
                 virtual_disk_name: builtins.str,
                 virtual_disk_id: Optional[builtins.str] = None):
        """
        Virtual disk model
        :param builtins.str controller_id: Disk's Controller id
        :param builtins.str independence_mode: Disk's independence mode type
        :param builtins.int total_size: Disk's total size
        :param builtins.str virtual_disk_name: Disk's display name
        :param builtins.str virtual_disk_id: Disk's id
        """
        pulumi.set(__self__, "controller_id", controller_id)
        pulumi.set(__self__, "independence_mode", independence_mode)
        pulumi.set(__self__, "total_size", total_size)
        pulumi.set(__self__, "virtual_disk_name", virtual_disk_name)
        if virtual_disk_id is not None:
            pulumi.set(__self__, "virtual_disk_id", virtual_disk_id)

    @property
    @pulumi.getter(name="controllerId")
    def controller_id(self) -> builtins.str:
        """
        Disk's Controller id
        """
        return pulumi.get(self, "controller_id")

    @property
    @pulumi.getter(name="independenceMode")
    def independence_mode(self) -> builtins.str:
        """
        Disk's independence mode type
        """
        return pulumi.get(self, "independence_mode")

    @property
    @pulumi.getter(name="totalSize")
    def total_size(self) -> builtins.int:
        """
        Disk's total size
        """
        return pulumi.get(self, "total_size")

    @property
    @pulumi.getter(name="virtualDiskName")
    def virtual_disk_name(self) -> builtins.str:
        """
        Disk's display name
        """
        return pulumi.get(self, "virtual_disk_name")

    @property
    @pulumi.getter(name="virtualDiskId")
    def virtual_disk_id(self) -> Optional[builtins.str]:
        """
        Disk's id
        """
        return pulumi.get(self, "virtual_disk_id")


@pulumi.output_type
class VirtualNetworkResponse(dict):
    """
    Virtual network model
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "privateCloudId":
            suggest = "private_cloud_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualNetworkResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualNetworkResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualNetworkResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 assignable: builtins.bool,
                 id: builtins.str,
                 location: builtins.str,
                 name: builtins.str,
                 private_cloud_id: builtins.str,
                 type: builtins.str):
        """
        Virtual network model
        :param builtins.bool assignable: can be used in vm creation/deletion
        :param builtins.str id: virtual network id (privateCloudId:vsphereId)
        :param builtins.str location: Azure region
        :param builtins.str name: {VirtualNetworkName}
        :param builtins.str private_cloud_id: The Private Cloud id
        :param builtins.str type: {resourceProviderNamespace}/{resourceType}
        """
        pulumi.set(__self__, "assignable", assignable)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "location", location)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "private_cloud_id", private_cloud_id)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def assignable(self) -> builtins.bool:
        """
        can be used in vm creation/deletion
        """
        return pulumi.get(self, "assignable")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        virtual network id (privateCloudId:vsphereId)
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def location(self) -> builtins.str:
        """
        Azure region
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        {VirtualNetworkName}
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="privateCloudId")
    def private_cloud_id(self) -> builtins.str:
        """
        The Private Cloud id
        """
        return pulumi.get(self, "private_cloud_id")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        {resourceProviderNamespace}/{resourceType}
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class VirtualNicResponse(dict):
    """
    Virtual NIC model
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "nicType":
            suggest = "nic_type"
        elif key == "virtualNicName":
            suggest = "virtual_nic_name"
        elif key == "ipAddresses":
            suggest = "ip_addresses"
        elif key == "macAddress":
            suggest = "mac_address"
        elif key == "powerOnBoot":
            suggest = "power_on_boot"
        elif key == "virtualNicId":
            suggest = "virtual_nic_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualNicResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualNicResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualNicResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 network: 'outputs.VirtualNetworkResponse',
                 nic_type: builtins.str,
                 virtual_nic_name: builtins.str,
                 customization: Optional['outputs.GuestOSNICCustomizationResponse'] = None,
                 ip_addresses: Optional[Sequence[builtins.str]] = None,
                 mac_address: Optional[builtins.str] = None,
                 power_on_boot: Optional[builtins.bool] = None,
                 virtual_nic_id: Optional[builtins.str] = None):
        """
        Virtual NIC model
        :param 'VirtualNetworkResponse' network: Virtual Network
        :param builtins.str nic_type: NIC type
        :param builtins.str virtual_nic_name: NIC name
        :param 'GuestOSNICCustomizationResponse' customization: guest OS customization for nic
        :param Sequence[builtins.str] ip_addresses: NIC ip address
        :param builtins.str mac_address: NIC MAC address
        :param builtins.bool power_on_boot: Is NIC powered on/off on boot
        :param builtins.str virtual_nic_id: NIC id
        """
        pulumi.set(__self__, "network", network)
        pulumi.set(__self__, "nic_type", nic_type)
        pulumi.set(__self__, "virtual_nic_name", virtual_nic_name)
        if customization is not None:
            pulumi.set(__self__, "customization", customization)
        if ip_addresses is not None:
            pulumi.set(__self__, "ip_addresses", ip_addresses)
        if mac_address is not None:
            pulumi.set(__self__, "mac_address", mac_address)
        if power_on_boot is not None:
            pulumi.set(__self__, "power_on_boot", power_on_boot)
        if virtual_nic_id is not None:
            pulumi.set(__self__, "virtual_nic_id", virtual_nic_id)

    @property
    @pulumi.getter
    def network(self) -> 'outputs.VirtualNetworkResponse':
        """
        Virtual Network
        """
        return pulumi.get(self, "network")

    @property
    @pulumi.getter(name="nicType")
    def nic_type(self) -> builtins.str:
        """
        NIC type
        """
        return pulumi.get(self, "nic_type")

    @property
    @pulumi.getter(name="virtualNicName")
    def virtual_nic_name(self) -> builtins.str:
        """
        NIC name
        """
        return pulumi.get(self, "virtual_nic_name")

    @property
    @pulumi.getter
    def customization(self) -> Optional['outputs.GuestOSNICCustomizationResponse']:
        """
        guest OS customization for nic
        """
        return pulumi.get(self, "customization")

    @property
    @pulumi.getter(name="ipAddresses")
    def ip_addresses(self) -> Optional[Sequence[builtins.str]]:
        """
        NIC ip address
        """
        return pulumi.get(self, "ip_addresses")

    @property
    @pulumi.getter(name="macAddress")
    def mac_address(self) -> Optional[builtins.str]:
        """
        NIC MAC address
        """
        return pulumi.get(self, "mac_address")

    @property
    @pulumi.getter(name="powerOnBoot")
    def power_on_boot(self) -> Optional[builtins.bool]:
        """
        Is NIC powered on/off on boot
        """
        return pulumi.get(self, "power_on_boot")

    @property
    @pulumi.getter(name="virtualNicId")
    def virtual_nic_id(self) -> Optional[builtins.str]:
        """
        NIC id
        """
        return pulumi.get(self, "virtual_nic_id")


