# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListConnectionKeysResult',
    'AwaitableListConnectionKeysResult',
    'list_connection_keys',
    'list_connection_keys_output',
]

@pulumi.output_type
class ListConnectionKeysResult:
    def __init__(__self__, connection_key=None, parameter_values=None):
        if connection_key and not isinstance(connection_key, str):
            raise TypeError("Expected argument 'connection_key' to be a str")
        pulumi.set(__self__, "connection_key", connection_key)
        if parameter_values and not isinstance(parameter_values, dict):
            raise TypeError("Expected argument 'parameter_values' to be a dict")
        pulumi.set(__self__, "parameter_values", parameter_values)

    @property
    @pulumi.getter(name="connectionKey")
    def connection_key(self) -> Optional[builtins.str]:
        """
        Connection Key
        """
        return pulumi.get(self, "connection_key")

    @property
    @pulumi.getter(name="parameterValues")
    def parameter_values(self) -> Optional[Mapping[str, Any]]:
        """
        Tokens/Claim
        """
        return pulumi.get(self, "parameter_values")


class AwaitableListConnectionKeysResult(ListConnectionKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListConnectionKeysResult(
            connection_key=self.connection_key,
            parameter_values=self.parameter_values)


def list_connection_keys(connection_name: Optional[builtins.str] = None,
                         id: Optional[builtins.str] = None,
                         kind: Optional[builtins.str] = None,
                         location: Optional[builtins.str] = None,
                         name: Optional[builtins.str] = None,
                         resource_group_name: Optional[builtins.str] = None,
                         tags: Optional[Mapping[str, builtins.str]] = None,
                         type: Optional[builtins.str] = None,
                         validity_time_span: Optional[builtins.str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListConnectionKeysResult:
    """
    Lists connection keys.

    Uses Azure REST API version 2015-08-01-preview.


    :param builtins.str connection_name: The connection name.
    :param builtins.str id: Resource Id
    :param builtins.str kind: Kind of resource
    :param builtins.str location: Resource Location
    :param builtins.str name: Resource Name
    :param builtins.str resource_group_name: The resource group name.
    :param Mapping[str, builtins.str] tags: Resource tags
    :param builtins.str type: Resource type
    :param builtins.str validity_time_span: time span for how long the keys will be valid
    """
    __args__ = dict()
    __args__['connectionName'] = connection_name
    __args__['id'] = id
    __args__['kind'] = kind
    __args__['location'] = location
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    __args__['tags'] = tags
    __args__['type'] = type
    __args__['validityTimeSpan'] = validity_time_span
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:web:listConnectionKeys', __args__, opts=opts, typ=ListConnectionKeysResult).value

    return AwaitableListConnectionKeysResult(
        connection_key=pulumi.get(__ret__, 'connection_key'),
        parameter_values=pulumi.get(__ret__, 'parameter_values'))
def list_connection_keys_output(connection_name: Optional[pulumi.Input[builtins.str]] = None,
                                id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                kind: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                location: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                tags: Optional[pulumi.Input[Optional[Mapping[str, builtins.str]]]] = None,
                                type: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                validity_time_span: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListConnectionKeysResult]:
    """
    Lists connection keys.

    Uses Azure REST API version 2015-08-01-preview.


    :param builtins.str connection_name: The connection name.
    :param builtins.str id: Resource Id
    :param builtins.str kind: Kind of resource
    :param builtins.str location: Resource Location
    :param builtins.str name: Resource Name
    :param builtins.str resource_group_name: The resource group name.
    :param Mapping[str, builtins.str] tags: Resource tags
    :param builtins.str type: Resource type
    :param builtins.str validity_time_span: time span for how long the keys will be valid
    """
    __args__ = dict()
    __args__['connectionName'] = connection_name
    __args__['id'] = id
    __args__['kind'] = kind
    __args__['location'] = location
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    __args__['tags'] = tags
    __args__['type'] = type
    __args__['validityTimeSpan'] = validity_time_span
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:web:listConnectionKeys', __args__, opts=opts, typ=ListConnectionKeysResult)
    return __ret__.apply(lambda __response__: ListConnectionKeysResult(
        connection_key=pulumi.get(__response__, 'connection_key'),
        parameter_values=pulumi.get(__response__, 'parameter_values')))
