# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *
from ._inputs import *

__all__ = [
    'ListCustomApiWsdlInterfacesResult',
    'AwaitableListCustomApiWsdlInterfacesResult',
    'list_custom_api_wsdl_interfaces',
    'list_custom_api_wsdl_interfaces_output',
]

@pulumi.output_type
class ListCustomApiWsdlInterfacesResult:
    """
    A list of custom API WSDL interfaces
    """
    def __init__(__self__, value=None):
        if value and not isinstance(value, list):
            raise TypeError("Expected argument 'value' to be a list")
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[Sequence['outputs.WsdlServiceResponse']]:
        """
        Collection of WSDL interfaces
        """
        return pulumi.get(self, "value")


class AwaitableListCustomApiWsdlInterfacesResult(ListCustomApiWsdlInterfacesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListCustomApiWsdlInterfacesResult(
            value=self.value)


def list_custom_api_wsdl_interfaces(content: Optional[builtins.str] = None,
                                    import_method: Optional[Union[builtins.str, 'WsdlImportMethod']] = None,
                                    location: Optional[builtins.str] = None,
                                    service: Optional[Union['WsdlService', 'WsdlServiceDict']] = None,
                                    subscription_id: Optional[builtins.str] = None,
                                    url: Optional[builtins.str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListCustomApiWsdlInterfacesResult:
    """
    This returns the list of interfaces in the WSDL

    Uses Azure REST API version 2016-06-01.


    :param builtins.str content: The WSDL content
    :param Union[builtins.str, 'WsdlImportMethod'] import_method: The WSDL import method
    :param builtins.str location: The location
    :param Union['WsdlService', 'WsdlServiceDict'] service: The service with name and endpoint names
    :param builtins.str subscription_id: Subscription Id
    :param builtins.str url: The WSDL URL
    """
    __args__ = dict()
    __args__['content'] = content
    __args__['importMethod'] = import_method
    __args__['location'] = location
    __args__['service'] = service
    __args__['subscriptionId'] = subscription_id
    __args__['url'] = url
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:web:listCustomApiWsdlInterfaces', __args__, opts=opts, typ=ListCustomApiWsdlInterfacesResult).value

    return AwaitableListCustomApiWsdlInterfacesResult(
        value=pulumi.get(__ret__, 'value'))
def list_custom_api_wsdl_interfaces_output(content: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                           import_method: Optional[pulumi.Input[Optional[Union[builtins.str, 'WsdlImportMethod']]]] = None,
                                           location: Optional[pulumi.Input[builtins.str]] = None,
                                           service: Optional[pulumi.Input[Optional[Union['WsdlService', 'WsdlServiceDict']]]] = None,
                                           subscription_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                           url: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListCustomApiWsdlInterfacesResult]:
    """
    This returns the list of interfaces in the WSDL

    Uses Azure REST API version 2016-06-01.


    :param builtins.str content: The WSDL content
    :param Union[builtins.str, 'WsdlImportMethod'] import_method: The WSDL import method
    :param builtins.str location: The location
    :param Union['WsdlService', 'WsdlServiceDict'] service: The service with name and endpoint names
    :param builtins.str subscription_id: Subscription Id
    :param builtins.str url: The WSDL URL
    """
    __args__ = dict()
    __args__['content'] = content
    __args__['importMethod'] = import_method
    __args__['location'] = location
    __args__['service'] = service
    __args__['subscriptionId'] = subscription_id
    __args__['url'] = url
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:web:listCustomApiWsdlInterfaces', __args__, opts=opts, typ=ListCustomApiWsdlInterfacesResult)
    return __ret__.apply(lambda __response__: ListCustomApiWsdlInterfacesResult(
        value=pulumi.get(__response__, 'value')))
