# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'ListWebAppHostKeysResult',
    'AwaitableListWebAppHostKeysResult',
    'list_web_app_host_keys',
    'list_web_app_host_keys_output',
]

@pulumi.output_type
class ListWebAppHostKeysResult:
    """
    Functions host level keys.
    """
    def __init__(__self__, function_keys=None, master_key=None, system_keys=None):
        if function_keys and not isinstance(function_keys, dict):
            raise TypeError("Expected argument 'function_keys' to be a dict")
        pulumi.set(__self__, "function_keys", function_keys)
        if master_key and not isinstance(master_key, str):
            raise TypeError("Expected argument 'master_key' to be a str")
        pulumi.set(__self__, "master_key", master_key)
        if system_keys and not isinstance(system_keys, dict):
            raise TypeError("Expected argument 'system_keys' to be a dict")
        pulumi.set(__self__, "system_keys", system_keys)

    @property
    @pulumi.getter(name="functionKeys")
    def function_keys(self) -> Optional[Mapping[str, builtins.str]]:
        """
        Host level function keys.
        """
        return pulumi.get(self, "function_keys")

    @property
    @pulumi.getter(name="masterKey")
    def master_key(self) -> Optional[builtins.str]:
        """
        Secret key.
        """
        return pulumi.get(self, "master_key")

    @property
    @pulumi.getter(name="systemKeys")
    def system_keys(self) -> Optional[Mapping[str, builtins.str]]:
        """
        System keys.
        """
        return pulumi.get(self, "system_keys")


class AwaitableListWebAppHostKeysResult(ListWebAppHostKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListWebAppHostKeysResult(
            function_keys=self.function_keys,
            master_key=self.master_key,
            system_keys=self.system_keys)


def list_web_app_host_keys(name: Optional[builtins.str] = None,
                           resource_group_name: Optional[builtins.str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListWebAppHostKeysResult:
    """
    Description for Get host secrets for a function app.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2018-02-01, 2019-08-01, 2020-06-01, 2020-09-01, 2020-10-01, 2020-12-01, 2021-01-01, 2021-01-15, 2021-02-01, 2021-03-01, 2022-03-01, 2022-09-01, 2023-01-01, 2023-12-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native web [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str name: Site name.
    :param builtins.str resource_group_name: Name of the resource group to which the resource belongs.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:web:listWebAppHostKeys', __args__, opts=opts, typ=ListWebAppHostKeysResult).value

    return AwaitableListWebAppHostKeysResult(
        function_keys=pulumi.get(__ret__, 'function_keys'),
        master_key=pulumi.get(__ret__, 'master_key'),
        system_keys=pulumi.get(__ret__, 'system_keys'))
def list_web_app_host_keys_output(name: Optional[pulumi.Input[builtins.str]] = None,
                                  resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[ListWebAppHostKeysResult]:
    """
    Description for Get host secrets for a function app.

    Uses Azure REST API version 2024-04-01.

    Other available API versions: 2018-02-01, 2019-08-01, 2020-06-01, 2020-09-01, 2020-10-01, 2020-12-01, 2021-01-01, 2021-01-15, 2021-02-01, 2021-03-01, 2022-03-01, 2022-09-01, 2023-01-01, 2023-12-01. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native web [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str name: Site name.
    :param builtins.str resource_group_name: Name of the resource group to which the resource belongs.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['resourceGroupName'] = resource_group_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:web:listWebAppHostKeys', __args__, opts=opts, typ=ListWebAppHostKeysResult)
    return __ret__.apply(lambda __response__: ListWebAppHostKeysResult(
        function_keys=pulumi.get(__response__, 'function_keys'),
        master_key=pulumi.get(__response__, 'master_key'),
        system_keys=pulumi.get(__response__, 'system_keys')))
