# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetSqlVulnerabilityAssessmentBaselineRuleResult',
    'AwaitableGetSqlVulnerabilityAssessmentBaselineRuleResult',
    'get_sql_vulnerability_assessment_baseline_rule',
    'get_sql_vulnerability_assessment_baseline_rule_output',
]

@pulumi.output_type
class GetSqlVulnerabilityAssessmentBaselineRuleResult:
    """
    Rule results.
    """
    def __init__(__self__, azure_api_version=None, id=None, name=None, properties=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if properties and not isinstance(properties, dict):
            raise TypeError("Expected argument 'properties' to be a dict")
        pulumi.set(__self__, "properties", properties)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Resource Id
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Resource name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> 'outputs.RuleResultsPropertiesResponse':
        """
        Rule results properties.
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Resource type
        """
        return pulumi.get(self, "type")


class AwaitableGetSqlVulnerabilityAssessmentBaselineRuleResult(GetSqlVulnerabilityAssessmentBaselineRuleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSqlVulnerabilityAssessmentBaselineRuleResult(
            azure_api_version=self.azure_api_version,
            id=self.id,
            name=self.name,
            properties=self.properties,
            type=self.type)


def get_sql_vulnerability_assessment_baseline_rule(resource_id: Optional[builtins.str] = None,
                                                   rule_id: Optional[builtins.str] = None,
                                                   workspace_id: Optional[builtins.str] = None,
                                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSqlVulnerabilityAssessmentBaselineRuleResult:
    """
    Rule results.

    Uses Azure REST API version 2023-02-01-preview.

    Other available API versions: 2020-07-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native security [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_id: The identifier of the resource.
    :param builtins.str rule_id: The rule Id.
    :param builtins.str workspace_id: The workspace Id.
    """
    __args__ = dict()
    __args__['resourceId'] = resource_id
    __args__['ruleId'] = rule_id
    __args__['workspaceId'] = workspace_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:security:getSqlVulnerabilityAssessmentBaselineRule', __args__, opts=opts, typ=GetSqlVulnerabilityAssessmentBaselineRuleResult).value

    return AwaitableGetSqlVulnerabilityAssessmentBaselineRuleResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        properties=pulumi.get(__ret__, 'properties'),
        type=pulumi.get(__ret__, 'type'))
def get_sql_vulnerability_assessment_baseline_rule_output(resource_id: Optional[pulumi.Input[builtins.str]] = None,
                                                          rule_id: Optional[pulumi.Input[builtins.str]] = None,
                                                          workspace_id: Optional[pulumi.Input[builtins.str]] = None,
                                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSqlVulnerabilityAssessmentBaselineRuleResult]:
    """
    Rule results.

    Uses Azure REST API version 2023-02-01-preview.

    Other available API versions: 2020-07-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native security [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str resource_id: The identifier of the resource.
    :param builtins.str rule_id: The rule Id.
    :param builtins.str workspace_id: The workspace Id.
    """
    __args__ = dict()
    __args__['resourceId'] = resource_id
    __args__['ruleId'] = rule_id
    __args__['workspaceId'] = workspace_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:security:getSqlVulnerabilityAssessmentBaselineRule', __args__, opts=opts, typ=GetSqlVulnerabilityAssessmentBaselineRuleResult)
    return __ret__.apply(lambda __response__: GetSqlVulnerabilityAssessmentBaselineRuleResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        properties=pulumi.get(__response__, 'properties'),
        type=pulumi.get(__response__, 'type')))
