# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'AdditionalCapabilitiesResponse',
    'AdditionalLocationsProfileResponse',
    'AdditionalUnattendContentResponse',
    'ApiEntityReferenceResponse',
    'ApplicationProfileResponse',
    'BaseVirtualMachineProfileResponse',
    'BootDiagnosticsResponse',
    'CapacityReservationProfileResponse',
    'ComputeProfileResponse',
    'DiagnosticsProfileResponse',
    'DiffDiskSettingsResponse',
    'DiskEncryptionSetParametersResponse',
    'EncryptionIdentityResponse',
    'ImageReferenceResponse',
    'KeyVaultSecretReferenceResponse',
    'LinuxConfigurationResponse',
    'LinuxPatchSettingsResponse',
    'LinuxVMGuestPatchAutomaticByPlatformSettingsResponse',
    'LocationProfileResponse',
    'ManagedServiceIdentityResponse',
    'OSImageNotificationProfileResponse',
    'PatchSettingsResponse',
    'PlanResponse',
    'ProxyAgentSettingsResponse',
    'PublicIPAddressSkuResponse',
    'RegularPriorityProfileResponse',
    'ScheduledEventsProfileResponse',
    'SecurityPostureReferenceResponse',
    'SecurityProfileResponse',
    'ServiceArtifactReferenceResponse',
    'SpotPriorityProfileResponse',
    'SshConfigurationResponse',
    'SshPublicKeyResponse',
    'SubResourceResponse',
    'SystemDataResponse',
    'TerminateNotificationProfileResponse',
    'UefiSettingsResponse',
    'UserAssignedIdentityResponse',
    'VMAttributeMinMaxDoubleResponse',
    'VMAttributeMinMaxIntegerResponse',
    'VMAttributesResponse',
    'VMDiskSecurityProfileResponse',
    'VMGalleryApplicationResponse',
    'VMSizePropertiesResponse',
    'VaultCertificateResponse',
    'VaultSecretGroupResponse',
    'VirtualHardDiskResponse',
    'VirtualMachineScaleSetDataDiskResponse',
    'VirtualMachineScaleSetExtensionProfileResponse',
    'VirtualMachineScaleSetExtensionPropertiesResponse',
    'VirtualMachineScaleSetExtensionResponse',
    'VirtualMachineScaleSetHardwareProfileResponse',
    'VirtualMachineScaleSetIPConfigurationPropertiesResponse',
    'VirtualMachineScaleSetIPConfigurationResponse',
    'VirtualMachineScaleSetIpTagResponse',
    'VirtualMachineScaleSetManagedDiskParametersResponse',
    'VirtualMachineScaleSetNetworkConfigurationDnsSettingsResponse',
    'VirtualMachineScaleSetNetworkConfigurationPropertiesResponse',
    'VirtualMachineScaleSetNetworkConfigurationResponse',
    'VirtualMachineScaleSetNetworkProfileResponse',
    'VirtualMachineScaleSetOSDiskResponse',
    'VirtualMachineScaleSetOSProfileResponse',
    'VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettingsResponse',
    'VirtualMachineScaleSetPublicIPAddressConfigurationPropertiesResponse',
    'VirtualMachineScaleSetPublicIPAddressConfigurationResponse',
    'VirtualMachineScaleSetStorageProfileResponse',
    'VmSizeProfileResponse',
    'WinRMConfigurationResponse',
    'WinRMListenerResponse',
    'WindowsConfigurationResponse',
    'WindowsVMGuestPatchAutomaticByPlatformSettingsResponse',
]

@pulumi.output_type
class AdditionalCapabilitiesResponse(dict):
    """
    AdditionalCapabilities for VM.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "hibernationEnabled":
            suggest = "hibernation_enabled"
        elif key == "ultraSSDEnabled":
            suggest = "ultra_ssd_enabled"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AdditionalCapabilitiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AdditionalCapabilitiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AdditionalCapabilitiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 hibernation_enabled: Optional[builtins.bool] = None,
                 ultra_ssd_enabled: Optional[builtins.bool] = None):
        """
        AdditionalCapabilities for VM.
        :param builtins.bool hibernation_enabled: The flag that enables or disables hibernation capability on the VM.
        :param builtins.bool ultra_ssd_enabled: The flag that enables or disables a capability to have one or more managed data disks with UltraSSD_LRS storage account type on the VM or VMSS.
               Managed disks with storage account type UltraSSD_LRS can be added to a virtual machine or virtual machine scale set only if this property is enabled.
        """
        if hibernation_enabled is not None:
            pulumi.set(__self__, "hibernation_enabled", hibernation_enabled)
        if ultra_ssd_enabled is not None:
            pulumi.set(__self__, "ultra_ssd_enabled", ultra_ssd_enabled)

    @property
    @pulumi.getter(name="hibernationEnabled")
    def hibernation_enabled(self) -> Optional[builtins.bool]:
        """
        The flag that enables or disables hibernation capability on the VM.
        """
        return pulumi.get(self, "hibernation_enabled")

    @property
    @pulumi.getter(name="ultraSSDEnabled")
    def ultra_ssd_enabled(self) -> Optional[builtins.bool]:
        """
        The flag that enables or disables a capability to have one or more managed data disks with UltraSSD_LRS storage account type on the VM or VMSS.
        Managed disks with storage account type UltraSSD_LRS can be added to a virtual machine or virtual machine scale set only if this property is enabled.
        """
        return pulumi.get(self, "ultra_ssd_enabled")


@pulumi.output_type
class AdditionalLocationsProfileResponse(dict):
    """
    Represents the configuration for additional locations where Fleet resources may be deployed.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "locationProfiles":
            suggest = "location_profiles"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AdditionalLocationsProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AdditionalLocationsProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AdditionalLocationsProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 location_profiles: Sequence['outputs.LocationProfileResponse']):
        """
        Represents the configuration for additional locations where Fleet resources may be deployed.
        :param Sequence['LocationProfileResponse'] location_profiles: The list of location profiles.
        """
        pulumi.set(__self__, "location_profiles", location_profiles)

    @property
    @pulumi.getter(name="locationProfiles")
    def location_profiles(self) -> Sequence['outputs.LocationProfileResponse']:
        """
        The list of location profiles.
        """
        return pulumi.get(self, "location_profiles")


@pulumi.output_type
class AdditionalUnattendContentResponse(dict):
    """
    Specifies additional XML formatted information that can be included in the
    Unattend.xml file, which is used by Windows Setup. Contents are defined by
    setting name, component name, and the pass in which the content is applied.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "componentName":
            suggest = "component_name"
        elif key == "passName":
            suggest = "pass_name"
        elif key == "settingName":
            suggest = "setting_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AdditionalUnattendContentResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AdditionalUnattendContentResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AdditionalUnattendContentResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 component_name: Optional[builtins.str] = None,
                 pass_name: Optional[builtins.str] = None,
                 setting_name: Optional[builtins.str] = None):
        """
        Specifies additional XML formatted information that can be included in the
        Unattend.xml file, which is used by Windows Setup. Contents are defined by
        setting name, component name, and the pass in which the content is applied.
        :param builtins.str component_name: The component name. Currently, the only allowable value is
               Microsoft-Windows-Shell-Setup.
        :param builtins.str pass_name: The pass name. Currently, the only allowable value is OobeSystem.
        :param builtins.str setting_name: Specifies the name of the setting to which the content applies. Possible values
               are: FirstLogonCommands and AutoLogon.
        """
        if component_name is not None:
            pulumi.set(__self__, "component_name", component_name)
        if pass_name is not None:
            pulumi.set(__self__, "pass_name", pass_name)
        if setting_name is not None:
            pulumi.set(__self__, "setting_name", setting_name)

    @property
    @pulumi.getter(name="componentName")
    def component_name(self) -> Optional[builtins.str]:
        """
        The component name. Currently, the only allowable value is
        Microsoft-Windows-Shell-Setup.
        """
        return pulumi.get(self, "component_name")

    @property
    @pulumi.getter(name="passName")
    def pass_name(self) -> Optional[builtins.str]:
        """
        The pass name. Currently, the only allowable value is OobeSystem.
        """
        return pulumi.get(self, "pass_name")

    @property
    @pulumi.getter(name="settingName")
    def setting_name(self) -> Optional[builtins.str]:
        """
        Specifies the name of the setting to which the content applies. Possible values
        are: FirstLogonCommands and AutoLogon.
        """
        return pulumi.get(self, "setting_name")


@pulumi.output_type
class ApiEntityReferenceResponse(dict):
    """
    The API entity reference.
    """
    def __init__(__self__, *,
                 id: Optional[builtins.str] = None):
        """
        The API entity reference.
        :param builtins.str id: The ARM resource id in the form of
               /subscriptions/{SubscriptionId}/resourceGroups/{ResourceGroupName}/...
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        The ARM resource id in the form of
        /subscriptions/{SubscriptionId}/resourceGroups/{ResourceGroupName}/...
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class ApplicationProfileResponse(dict):
    """
    Contains the list of gallery applications that should be made available to the
    VM/VMSS
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "galleryApplications":
            suggest = "gallery_applications"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ApplicationProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ApplicationProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ApplicationProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 gallery_applications: Optional[Sequence['outputs.VMGalleryApplicationResponse']] = None):
        """
        Contains the list of gallery applications that should be made available to the
        VM/VMSS
        :param Sequence['VMGalleryApplicationResponse'] gallery_applications: Specifies the gallery applications that should be made available to the VM/VMSS
        """
        if gallery_applications is not None:
            pulumi.set(__self__, "gallery_applications", gallery_applications)

    @property
    @pulumi.getter(name="galleryApplications")
    def gallery_applications(self) -> Optional[Sequence['outputs.VMGalleryApplicationResponse']]:
        """
        Specifies the gallery applications that should be made available to the VM/VMSS
        """
        return pulumi.get(self, "gallery_applications")


@pulumi.output_type
class BaseVirtualMachineProfileResponse(dict):
    """
    Describes the base virtual machine profile for fleet
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "timeCreated":
            suggest = "time_created"
        elif key == "applicationProfile":
            suggest = "application_profile"
        elif key == "capacityReservation":
            suggest = "capacity_reservation"
        elif key == "diagnosticsProfile":
            suggest = "diagnostics_profile"
        elif key == "extensionProfile":
            suggest = "extension_profile"
        elif key == "hardwareProfile":
            suggest = "hardware_profile"
        elif key == "licenseType":
            suggest = "license_type"
        elif key == "networkProfile":
            suggest = "network_profile"
        elif key == "osProfile":
            suggest = "os_profile"
        elif key == "scheduledEventsProfile":
            suggest = "scheduled_events_profile"
        elif key == "securityPostureReference":
            suggest = "security_posture_reference"
        elif key == "securityProfile":
            suggest = "security_profile"
        elif key == "serviceArtifactReference":
            suggest = "service_artifact_reference"
        elif key == "storageProfile":
            suggest = "storage_profile"
        elif key == "userData":
            suggest = "user_data"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in BaseVirtualMachineProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        BaseVirtualMachineProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        BaseVirtualMachineProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 time_created: builtins.str,
                 application_profile: Optional['outputs.ApplicationProfileResponse'] = None,
                 capacity_reservation: Optional['outputs.CapacityReservationProfileResponse'] = None,
                 diagnostics_profile: Optional['outputs.DiagnosticsProfileResponse'] = None,
                 extension_profile: Optional['outputs.VirtualMachineScaleSetExtensionProfileResponse'] = None,
                 hardware_profile: Optional['outputs.VirtualMachineScaleSetHardwareProfileResponse'] = None,
                 license_type: Optional[builtins.str] = None,
                 network_profile: Optional['outputs.VirtualMachineScaleSetNetworkProfileResponse'] = None,
                 os_profile: Optional['outputs.VirtualMachineScaleSetOSProfileResponse'] = None,
                 scheduled_events_profile: Optional['outputs.ScheduledEventsProfileResponse'] = None,
                 security_posture_reference: Optional['outputs.SecurityPostureReferenceResponse'] = None,
                 security_profile: Optional['outputs.SecurityProfileResponse'] = None,
                 service_artifact_reference: Optional['outputs.ServiceArtifactReferenceResponse'] = None,
                 storage_profile: Optional['outputs.VirtualMachineScaleSetStorageProfileResponse'] = None,
                 user_data: Optional[builtins.str] = None):
        """
        Describes the base virtual machine profile for fleet
        :param builtins.str time_created: Specifies the time in which this VM profile for the Virtual Machine Scale Set
               was created. Minimum API version for this property is 2023-09-01. This value
               will be added to VMSS Flex VM tags when creating/updating the VMSS VM Profile
               with minimum api-version 2023-09-01. Examples: "2024-07-01T00:00:01.1234567+00:00"
        :param 'ApplicationProfileResponse' application_profile: Specifies the gallery applications that should be made available to the VM/VMSS
        :param 'CapacityReservationProfileResponse' capacity_reservation: Specifies the capacity reservation related details of a scale set. Minimum
               api-version: 2021-04-01.
        :param 'DiagnosticsProfileResponse' diagnostics_profile: Specifies the boot diagnostic settings state.
        :param 'VirtualMachineScaleSetExtensionProfileResponse' extension_profile: Specifies a collection of settings for extensions installed on virtual machines
               in the scale set.
        :param 'VirtualMachineScaleSetHardwareProfileResponse' hardware_profile: Specifies the hardware profile related details of a scale set. Minimum
               api-version: 2021-11-01.
        :param builtins.str license_type: Specifies that the image or disk that is being used was licensed on-premises.
               <br><br> Possible values for Windows Server operating system are: <br><br>
               Windows_Client <br><br> Windows_Server <br><br> Possible values for Linux
               Server operating system are: <br><br> RHEL_BYOS (for RHEL) <br><br> SLES_BYOS
               (for SUSE) <br><br> For more information, see [Azure Hybrid Use Benefit for
               Windows
               Server](https://learn.microsoft.com/azure/virtual-machines/windows/hybrid-use-benefit-licensing)
               <br><br> [Azure Hybrid Use Benefit for Linux
               Server](https://learn.microsoft.com/azure/virtual-machines/linux/azure-hybrid-benefit-linux)
               <br><br> Minimum api-version: 2015-06-15
        :param 'VirtualMachineScaleSetNetworkProfileResponse' network_profile: Specifies properties of the network interfaces of the virtual machines in the
               scale set.
        :param 'VirtualMachineScaleSetOSProfileResponse' os_profile: Specifies the operating system settings for the virtual machines in the scale
               set.
        :param 'ScheduledEventsProfileResponse' scheduled_events_profile: Specifies Scheduled Event related configurations.
        :param 'SecurityPostureReferenceResponse' security_posture_reference: Specifies the security posture to be used for all virtual machines in the scale
               set. Minimum api-version: 2023-03-01
        :param 'SecurityProfileResponse' security_profile: Specifies the Security related profile settings for the virtual machines in the
               scale set.
        :param 'ServiceArtifactReferenceResponse' service_artifact_reference: Specifies the service artifact reference id used to set same image version for
               all virtual machines in the scale set when using 'latest' image version.
               Minimum api-version: 2022-11-01
        :param 'VirtualMachineScaleSetStorageProfileResponse' storage_profile: Specifies the storage settings for the virtual machine disks.
        :param builtins.str user_data: UserData for the virtual machines in the scale set, which must be base-64
               encoded. Customer should not pass any secrets in here. Minimum api-version:
               2021-03-01.
        """
        pulumi.set(__self__, "time_created", time_created)
        if application_profile is not None:
            pulumi.set(__self__, "application_profile", application_profile)
        if capacity_reservation is not None:
            pulumi.set(__self__, "capacity_reservation", capacity_reservation)
        if diagnostics_profile is not None:
            pulumi.set(__self__, "diagnostics_profile", diagnostics_profile)
        if extension_profile is not None:
            pulumi.set(__self__, "extension_profile", extension_profile)
        if hardware_profile is not None:
            pulumi.set(__self__, "hardware_profile", hardware_profile)
        if license_type is not None:
            pulumi.set(__self__, "license_type", license_type)
        if network_profile is not None:
            pulumi.set(__self__, "network_profile", network_profile)
        if os_profile is not None:
            pulumi.set(__self__, "os_profile", os_profile)
        if scheduled_events_profile is not None:
            pulumi.set(__self__, "scheduled_events_profile", scheduled_events_profile)
        if security_posture_reference is not None:
            pulumi.set(__self__, "security_posture_reference", security_posture_reference)
        if security_profile is not None:
            pulumi.set(__self__, "security_profile", security_profile)
        if service_artifact_reference is not None:
            pulumi.set(__self__, "service_artifact_reference", service_artifact_reference)
        if storage_profile is not None:
            pulumi.set(__self__, "storage_profile", storage_profile)
        if user_data is not None:
            pulumi.set(__self__, "user_data", user_data)

    @property
    @pulumi.getter(name="timeCreated")
    def time_created(self) -> builtins.str:
        """
        Specifies the time in which this VM profile for the Virtual Machine Scale Set
        was created. Minimum API version for this property is 2023-09-01. This value
        will be added to VMSS Flex VM tags when creating/updating the VMSS VM Profile
        with minimum api-version 2023-09-01. Examples: "2024-07-01T00:00:01.1234567+00:00"
        """
        return pulumi.get(self, "time_created")

    @property
    @pulumi.getter(name="applicationProfile")
    def application_profile(self) -> Optional['outputs.ApplicationProfileResponse']:
        """
        Specifies the gallery applications that should be made available to the VM/VMSS
        """
        return pulumi.get(self, "application_profile")

    @property
    @pulumi.getter(name="capacityReservation")
    def capacity_reservation(self) -> Optional['outputs.CapacityReservationProfileResponse']:
        """
        Specifies the capacity reservation related details of a scale set. Minimum
        api-version: 2021-04-01.
        """
        return pulumi.get(self, "capacity_reservation")

    @property
    @pulumi.getter(name="diagnosticsProfile")
    def diagnostics_profile(self) -> Optional['outputs.DiagnosticsProfileResponse']:
        """
        Specifies the boot diagnostic settings state.
        """
        return pulumi.get(self, "diagnostics_profile")

    @property
    @pulumi.getter(name="extensionProfile")
    def extension_profile(self) -> Optional['outputs.VirtualMachineScaleSetExtensionProfileResponse']:
        """
        Specifies a collection of settings for extensions installed on virtual machines
        in the scale set.
        """
        return pulumi.get(self, "extension_profile")

    @property
    @pulumi.getter(name="hardwareProfile")
    def hardware_profile(self) -> Optional['outputs.VirtualMachineScaleSetHardwareProfileResponse']:
        """
        Specifies the hardware profile related details of a scale set. Minimum
        api-version: 2021-11-01.
        """
        return pulumi.get(self, "hardware_profile")

    @property
    @pulumi.getter(name="licenseType")
    def license_type(self) -> Optional[builtins.str]:
        """
        Specifies that the image or disk that is being used was licensed on-premises.
        <br><br> Possible values for Windows Server operating system are: <br><br>
        Windows_Client <br><br> Windows_Server <br><br> Possible values for Linux
        Server operating system are: <br><br> RHEL_BYOS (for RHEL) <br><br> SLES_BYOS
        (for SUSE) <br><br> For more information, see [Azure Hybrid Use Benefit for
        Windows
        Server](https://learn.microsoft.com/azure/virtual-machines/windows/hybrid-use-benefit-licensing)
        <br><br> [Azure Hybrid Use Benefit for Linux
        Server](https://learn.microsoft.com/azure/virtual-machines/linux/azure-hybrid-benefit-linux)
        <br><br> Minimum api-version: 2015-06-15
        """
        return pulumi.get(self, "license_type")

    @property
    @pulumi.getter(name="networkProfile")
    def network_profile(self) -> Optional['outputs.VirtualMachineScaleSetNetworkProfileResponse']:
        """
        Specifies properties of the network interfaces of the virtual machines in the
        scale set.
        """
        return pulumi.get(self, "network_profile")

    @property
    @pulumi.getter(name="osProfile")
    def os_profile(self) -> Optional['outputs.VirtualMachineScaleSetOSProfileResponse']:
        """
        Specifies the operating system settings for the virtual machines in the scale
        set.
        """
        return pulumi.get(self, "os_profile")

    @property
    @pulumi.getter(name="scheduledEventsProfile")
    def scheduled_events_profile(self) -> Optional['outputs.ScheduledEventsProfileResponse']:
        """
        Specifies Scheduled Event related configurations.
        """
        return pulumi.get(self, "scheduled_events_profile")

    @property
    @pulumi.getter(name="securityPostureReference")
    def security_posture_reference(self) -> Optional['outputs.SecurityPostureReferenceResponse']:
        """
        Specifies the security posture to be used for all virtual machines in the scale
        set. Minimum api-version: 2023-03-01
        """
        return pulumi.get(self, "security_posture_reference")

    @property
    @pulumi.getter(name="securityProfile")
    def security_profile(self) -> Optional['outputs.SecurityProfileResponse']:
        """
        Specifies the Security related profile settings for the virtual machines in the
        scale set.
        """
        return pulumi.get(self, "security_profile")

    @property
    @pulumi.getter(name="serviceArtifactReference")
    def service_artifact_reference(self) -> Optional['outputs.ServiceArtifactReferenceResponse']:
        """
        Specifies the service artifact reference id used to set same image version for
        all virtual machines in the scale set when using 'latest' image version.
        Minimum api-version: 2022-11-01
        """
        return pulumi.get(self, "service_artifact_reference")

    @property
    @pulumi.getter(name="storageProfile")
    def storage_profile(self) -> Optional['outputs.VirtualMachineScaleSetStorageProfileResponse']:
        """
        Specifies the storage settings for the virtual machine disks.
        """
        return pulumi.get(self, "storage_profile")

    @property
    @pulumi.getter(name="userData")
    def user_data(self) -> Optional[builtins.str]:
        """
        UserData for the virtual machines in the scale set, which must be base-64
        encoded. Customer should not pass any secrets in here. Minimum api-version:
        2021-03-01.
        """
        return pulumi.get(self, "user_data")


@pulumi.output_type
class BootDiagnosticsResponse(dict):
    """
    Boot Diagnostics is a debugging feature which allows you to view Console Output
    and Screenshot to diagnose VM status. You can easily view the output of your
    console log. Azure also enables you to see a screenshot of the VM from the
    hypervisor.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "storageUri":
            suggest = "storage_uri"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in BootDiagnosticsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        BootDiagnosticsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        BootDiagnosticsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 enabled: Optional[builtins.bool] = None,
                 storage_uri: Optional[builtins.str] = None):
        """
        Boot Diagnostics is a debugging feature which allows you to view Console Output
        and Screenshot to diagnose VM status. You can easily view the output of your
        console log. Azure also enables you to see a screenshot of the VM from the
        hypervisor.
        :param builtins.bool enabled: Whether boot diagnostics should be enabled on the Virtual Machine.
        :param builtins.str storage_uri: Uri of the storage account to use for placing the console output and
               screenshot. If storageUri is not specified while enabling boot diagnostics,
               managed storage will be used.
        """
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if storage_uri is not None:
            pulumi.set(__self__, "storage_uri", storage_uri)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[builtins.bool]:
        """
        Whether boot diagnostics should be enabled on the Virtual Machine.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="storageUri")
    def storage_uri(self) -> Optional[builtins.str]:
        """
        Uri of the storage account to use for placing the console output and
        screenshot. If storageUri is not specified while enabling boot diagnostics,
        managed storage will be used.
        """
        return pulumi.get(self, "storage_uri")


@pulumi.output_type
class CapacityReservationProfileResponse(dict):
    """
    The parameters of a capacity reservation Profile.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "capacityReservationGroup":
            suggest = "capacity_reservation_group"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CapacityReservationProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CapacityReservationProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CapacityReservationProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 capacity_reservation_group: Optional['outputs.SubResourceResponse'] = None):
        """
        The parameters of a capacity reservation Profile.
        :param 'SubResourceResponse' capacity_reservation_group: Specifies the capacity reservation group resource id that should be used for
               allocating the virtual machine or scaleset vm instances provided enough
               capacity has been reserved. Please refer to https://aka.ms/CapacityReservation
               for more details.
        """
        if capacity_reservation_group is not None:
            pulumi.set(__self__, "capacity_reservation_group", capacity_reservation_group)

    @property
    @pulumi.getter(name="capacityReservationGroup")
    def capacity_reservation_group(self) -> Optional['outputs.SubResourceResponse']:
        """
        Specifies the capacity reservation group resource id that should be used for
        allocating the virtual machine or scaleset vm instances provided enough
        capacity has been reserved. Please refer to https://aka.ms/CapacityReservation
        for more details.
        """
        return pulumi.get(self, "capacity_reservation_group")


@pulumi.output_type
class ComputeProfileResponse(dict):
    """
    Compute Profile to use for running user's workloads.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "baseVirtualMachineProfile":
            suggest = "base_virtual_machine_profile"
        elif key == "additionalVirtualMachineCapabilities":
            suggest = "additional_virtual_machine_capabilities"
        elif key == "computeApiVersion":
            suggest = "compute_api_version"
        elif key == "platformFaultDomainCount":
            suggest = "platform_fault_domain_count"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ComputeProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ComputeProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ComputeProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 base_virtual_machine_profile: 'outputs.BaseVirtualMachineProfileResponse',
                 additional_virtual_machine_capabilities: Optional['outputs.AdditionalCapabilitiesResponse'] = None,
                 compute_api_version: Optional[builtins.str] = None,
                 platform_fault_domain_count: Optional[builtins.int] = None):
        """
        Compute Profile to use for running user's workloads.
        :param 'BaseVirtualMachineProfileResponse' base_virtual_machine_profile: Base Virtual Machine Profile Properties to be specified according to "specification/compute/resource-manager/Microsoft.Compute/ComputeRP/stable/{computeApiVersion}/virtualMachineScaleSet.json#/definitions/VirtualMachineScaleSetVMProfile"
        :param 'AdditionalCapabilitiesResponse' additional_virtual_machine_capabilities: Specifies VMSS and VM API entity models support two additional capabilities as of today: ultraSSDEnabled and hibernationEnabled.
               ultraSSDEnabled: Enables UltraSSD_LRS storage account type on the VMSS VMs.
               hibernationEnabled: Enables the hibernation capability on the VMSS VMs.
               Default value is null if not specified. This property cannot be updated once set.
        :param builtins.str compute_api_version: Specifies the Microsoft.Compute API version to use when creating underlying Virtual Machine scale sets and Virtual Machines.
               The default value will be the latest supported computeApiVersion by Compute Fleet.
        :param builtins.int platform_fault_domain_count: Specifies the number of fault domains to use when creating the underlying VMSS.
               A fault domain is a logical group of hardware within an Azure datacenter.
               VMs in the same fault domain share a common power source and network switch.
               If not specified, defaults to 1, which represents "Max Spreading" (using as many fault domains as possible).
               This property cannot be updated.
        """
        pulumi.set(__self__, "base_virtual_machine_profile", base_virtual_machine_profile)
        if additional_virtual_machine_capabilities is not None:
            pulumi.set(__self__, "additional_virtual_machine_capabilities", additional_virtual_machine_capabilities)
        if compute_api_version is not None:
            pulumi.set(__self__, "compute_api_version", compute_api_version)
        if platform_fault_domain_count is not None:
            pulumi.set(__self__, "platform_fault_domain_count", platform_fault_domain_count)

    @property
    @pulumi.getter(name="baseVirtualMachineProfile")
    def base_virtual_machine_profile(self) -> 'outputs.BaseVirtualMachineProfileResponse':
        """
        Base Virtual Machine Profile Properties to be specified according to "specification/compute/resource-manager/Microsoft.Compute/ComputeRP/stable/{computeApiVersion}/virtualMachineScaleSet.json#/definitions/VirtualMachineScaleSetVMProfile"
        """
        return pulumi.get(self, "base_virtual_machine_profile")

    @property
    @pulumi.getter(name="additionalVirtualMachineCapabilities")
    def additional_virtual_machine_capabilities(self) -> Optional['outputs.AdditionalCapabilitiesResponse']:
        """
        Specifies VMSS and VM API entity models support two additional capabilities as of today: ultraSSDEnabled and hibernationEnabled.
        ultraSSDEnabled: Enables UltraSSD_LRS storage account type on the VMSS VMs.
        hibernationEnabled: Enables the hibernation capability on the VMSS VMs.
        Default value is null if not specified. This property cannot be updated once set.
        """
        return pulumi.get(self, "additional_virtual_machine_capabilities")

    @property
    @pulumi.getter(name="computeApiVersion")
    def compute_api_version(self) -> Optional[builtins.str]:
        """
        Specifies the Microsoft.Compute API version to use when creating underlying Virtual Machine scale sets and Virtual Machines.
        The default value will be the latest supported computeApiVersion by Compute Fleet.
        """
        return pulumi.get(self, "compute_api_version")

    @property
    @pulumi.getter(name="platformFaultDomainCount")
    def platform_fault_domain_count(self) -> Optional[builtins.int]:
        """
        Specifies the number of fault domains to use when creating the underlying VMSS.
        A fault domain is a logical group of hardware within an Azure datacenter.
        VMs in the same fault domain share a common power source and network switch.
        If not specified, defaults to 1, which represents "Max Spreading" (using as many fault domains as possible).
        This property cannot be updated.
        """
        return pulumi.get(self, "platform_fault_domain_count")


@pulumi.output_type
class DiagnosticsProfileResponse(dict):
    """
    Specifies the boot diagnostic settings state. Minimum api-version: 2015-06-15.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "bootDiagnostics":
            suggest = "boot_diagnostics"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DiagnosticsProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DiagnosticsProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DiagnosticsProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 boot_diagnostics: Optional['outputs.BootDiagnosticsResponse'] = None):
        """
        Specifies the boot diagnostic settings state. Minimum api-version: 2015-06-15.
        :param 'BootDiagnosticsResponse' boot_diagnostics: Boot Diagnostics is a debugging feature which allows you to view Console Output
               and Screenshot to diagnose VM status. **NOTE**: If storageUri is being
               specified then ensure that the storage account is in the same region and
               subscription as the VM. You can easily view the output of your console log.
               Azure also enables you to see a screenshot of the VM from the hypervisor.
        """
        if boot_diagnostics is not None:
            pulumi.set(__self__, "boot_diagnostics", boot_diagnostics)

    @property
    @pulumi.getter(name="bootDiagnostics")
    def boot_diagnostics(self) -> Optional['outputs.BootDiagnosticsResponse']:
        """
        Boot Diagnostics is a debugging feature which allows you to view Console Output
        and Screenshot to diagnose VM status. **NOTE**: If storageUri is being
        specified then ensure that the storage account is in the same region and
        subscription as the VM. You can easily view the output of your console log.
        Azure also enables you to see a screenshot of the VM from the hypervisor.
        """
        return pulumi.get(self, "boot_diagnostics")


@pulumi.output_type
class DiffDiskSettingsResponse(dict):
    """
    Describes the parameters of ephemeral disk settings that can be specified for
    operating system disk. **Note:** The ephemeral disk settings can only be
    specified for managed disk.
    """
    def __init__(__self__, *,
                 option: Optional[builtins.str] = None,
                 placement: Optional[builtins.str] = None):
        """
        Describes the parameters of ephemeral disk settings that can be specified for
        operating system disk. **Note:** The ephemeral disk settings can only be
        specified for managed disk.
        :param builtins.str option: Specifies the ephemeral disk settings for operating system disk.
        :param builtins.str placement: Specifies the ephemeral disk placement for operating system disk. Possible
               values are: **CacheDisk,** **ResourceDisk.** The defaulting behavior is:
               **CacheDisk** if one is configured for the VM size otherwise **ResourceDisk**
               is used. Refer to the VM size documentation for Windows VM at
               https://learn.microsoft.com/azure/virtual-machines/windows/sizes and Linux VM at
               https://learn.microsoft.com/azure/virtual-machines/linux/sizes to check which VM
               sizes exposes a cache disk.
        """
        if option is not None:
            pulumi.set(__self__, "option", option)
        if placement is not None:
            pulumi.set(__self__, "placement", placement)

    @property
    @pulumi.getter
    def option(self) -> Optional[builtins.str]:
        """
        Specifies the ephemeral disk settings for operating system disk.
        """
        return pulumi.get(self, "option")

    @property
    @pulumi.getter
    def placement(self) -> Optional[builtins.str]:
        """
        Specifies the ephemeral disk placement for operating system disk. Possible
        values are: **CacheDisk,** **ResourceDisk.** The defaulting behavior is:
        **CacheDisk** if one is configured for the VM size otherwise **ResourceDisk**
        is used. Refer to the VM size documentation for Windows VM at
        https://learn.microsoft.com/azure/virtual-machines/windows/sizes and Linux VM at
        https://learn.microsoft.com/azure/virtual-machines/linux/sizes to check which VM
        sizes exposes a cache disk.
        """
        return pulumi.get(self, "placement")


@pulumi.output_type
class DiskEncryptionSetParametersResponse(dict):
    """
    Describes the parameter of customer managed disk encryption set resource id
    that can be specified for disk. **Note:** The disk encryption set resource id
    can only be specified for managed disk. Please refer
    https://aka.ms/mdssewithcmkoverview for more details.
    """
    def __init__(__self__, *,
                 id: Optional[builtins.str] = None):
        """
        Describes the parameter of customer managed disk encryption set resource id
        that can be specified for disk. **Note:** The disk encryption set resource id
        can only be specified for managed disk. Please refer
        https://aka.ms/mdssewithcmkoverview for more details.
        :param builtins.str id: Resource Id
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        Resource Id
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class EncryptionIdentityResponse(dict):
    """
    Specifies the Managed Identity used by ADE to get access token for keyvault
    operations.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "userAssignedIdentityResourceId":
            suggest = "user_assigned_identity_resource_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in EncryptionIdentityResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        EncryptionIdentityResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        EncryptionIdentityResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 user_assigned_identity_resource_id: Optional[builtins.str] = None):
        """
        Specifies the Managed Identity used by ADE to get access token for keyvault
        operations.
        :param builtins.str user_assigned_identity_resource_id: Specifies ARM Resource ID of one of the user identities associated with the VM.
        """
        if user_assigned_identity_resource_id is not None:
            pulumi.set(__self__, "user_assigned_identity_resource_id", user_assigned_identity_resource_id)

    @property
    @pulumi.getter(name="userAssignedIdentityResourceId")
    def user_assigned_identity_resource_id(self) -> Optional[builtins.str]:
        """
        Specifies ARM Resource ID of one of the user identities associated with the VM.
        """
        return pulumi.get(self, "user_assigned_identity_resource_id")


@pulumi.output_type
class ImageReferenceResponse(dict):
    """
    Specifies information about the image to use. You can specify information about
    platform images, marketplace images, or virtual machine images. This element is
    required when you want to use a platform image, marketplace image, or virtual
    machine image, but is not used in other creation operations. NOTE: Image
    reference publisher and offer can only be set when you create the scale set.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "exactVersion":
            suggest = "exact_version"
        elif key == "communityGalleryImageId":
            suggest = "community_gallery_image_id"
        elif key == "sharedGalleryImageId":
            suggest = "shared_gallery_image_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ImageReferenceResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ImageReferenceResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ImageReferenceResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 exact_version: builtins.str,
                 community_gallery_image_id: Optional[builtins.str] = None,
                 id: Optional[builtins.str] = None,
                 offer: Optional[builtins.str] = None,
                 publisher: Optional[builtins.str] = None,
                 shared_gallery_image_id: Optional[builtins.str] = None,
                 sku: Optional[builtins.str] = None,
                 version: Optional[builtins.str] = None):
        """
        Specifies information about the image to use. You can specify information about
        platform images, marketplace images, or virtual machine images. This element is
        required when you want to use a platform image, marketplace image, or virtual
        machine image, but is not used in other creation operations. NOTE: Image
        reference publisher and offer can only be set when you create the scale set.
        :param builtins.str exact_version: Specifies in decimal numbers, the version of platform image or marketplace
               image used to create the virtual machine. This readonly field differs from 'version',
               only if the value specified in 'version' field is 'latest'.
        :param builtins.str community_gallery_image_id: Specified the community gallery image unique id for vm deployment. This can be
               fetched from community gallery image GET call.
        :param builtins.str id: Resource Id
        :param builtins.str offer: Specifies the offer of the platform image or marketplace image used to create
               the virtual machine.
        :param builtins.str publisher: The image publisher.
        :param builtins.str shared_gallery_image_id: Specified the shared gallery image unique id for vm deployment. This can be
               fetched from shared gallery image GET call.
        :param builtins.str sku: The image SKU.
        :param builtins.str version: Specifies the version of the platform image or marketplace image used to create
               the virtual machine. The allowed formats are Major.Minor.Build or 'latest'.
               Major, Minor, and Build are decimal numbers. Specify 'latest' to use the latest
               version of an image available at deploy time. Even if you use 'latest', the VM
               image will not automatically update after deploy time even if a new version
               becomes available. Please do not use field 'version' for gallery image
               deployment, gallery image should always use 'id' field for deployment, to use 'latest'
               version of gallery image, just set
               '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/galleries/{galleryName}/images/{imageName}'
               in the 'id' field without version input.
        """
        pulumi.set(__self__, "exact_version", exact_version)
        if community_gallery_image_id is not None:
            pulumi.set(__self__, "community_gallery_image_id", community_gallery_image_id)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if offer is not None:
            pulumi.set(__self__, "offer", offer)
        if publisher is not None:
            pulumi.set(__self__, "publisher", publisher)
        if shared_gallery_image_id is not None:
            pulumi.set(__self__, "shared_gallery_image_id", shared_gallery_image_id)
        if sku is not None:
            pulumi.set(__self__, "sku", sku)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="exactVersion")
    def exact_version(self) -> builtins.str:
        """
        Specifies in decimal numbers, the version of platform image or marketplace
        image used to create the virtual machine. This readonly field differs from 'version',
        only if the value specified in 'version' field is 'latest'.
        """
        return pulumi.get(self, "exact_version")

    @property
    @pulumi.getter(name="communityGalleryImageId")
    def community_gallery_image_id(self) -> Optional[builtins.str]:
        """
        Specified the community gallery image unique id for vm deployment. This can be
        fetched from community gallery image GET call.
        """
        return pulumi.get(self, "community_gallery_image_id")

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        Resource Id
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def offer(self) -> Optional[builtins.str]:
        """
        Specifies the offer of the platform image or marketplace image used to create
        the virtual machine.
        """
        return pulumi.get(self, "offer")

    @property
    @pulumi.getter
    def publisher(self) -> Optional[builtins.str]:
        """
        The image publisher.
        """
        return pulumi.get(self, "publisher")

    @property
    @pulumi.getter(name="sharedGalleryImageId")
    def shared_gallery_image_id(self) -> Optional[builtins.str]:
        """
        Specified the shared gallery image unique id for vm deployment. This can be
        fetched from shared gallery image GET call.
        """
        return pulumi.get(self, "shared_gallery_image_id")

    @property
    @pulumi.getter
    def sku(self) -> Optional[builtins.str]:
        """
        The image SKU.
        """
        return pulumi.get(self, "sku")

    @property
    @pulumi.getter
    def version(self) -> Optional[builtins.str]:
        """
        Specifies the version of the platform image or marketplace image used to create
        the virtual machine. The allowed formats are Major.Minor.Build or 'latest'.
        Major, Minor, and Build are decimal numbers. Specify 'latest' to use the latest
        version of an image available at deploy time. Even if you use 'latest', the VM
        image will not automatically update after deploy time even if a new version
        becomes available. Please do not use field 'version' for gallery image
        deployment, gallery image should always use 'id' field for deployment, to use 'latest'
        version of gallery image, just set
        '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Compute/galleries/{galleryName}/images/{imageName}'
        in the 'id' field without version input.
        """
        return pulumi.get(self, "version")


@pulumi.output_type
class KeyVaultSecretReferenceResponse(dict):
    """
    Describes a reference to Key Vault Secret
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "secretUrl":
            suggest = "secret_url"
        elif key == "sourceVault":
            suggest = "source_vault"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in KeyVaultSecretReferenceResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        KeyVaultSecretReferenceResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        KeyVaultSecretReferenceResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 secret_url: builtins.str,
                 source_vault: 'outputs.SubResourceResponse'):
        """
        Describes a reference to Key Vault Secret
        :param builtins.str secret_url: The URL referencing a secret in a Key Vault.
        :param 'SubResourceResponse' source_vault: The relative URL of the Key Vault containing the secret.
        """
        pulumi.set(__self__, "secret_url", secret_url)
        pulumi.set(__self__, "source_vault", source_vault)

    @property
    @pulumi.getter(name="secretUrl")
    def secret_url(self) -> builtins.str:
        """
        The URL referencing a secret in a Key Vault.
        """
        return pulumi.get(self, "secret_url")

    @property
    @pulumi.getter(name="sourceVault")
    def source_vault(self) -> 'outputs.SubResourceResponse':
        """
        The relative URL of the Key Vault containing the secret.
        """
        return pulumi.get(self, "source_vault")


@pulumi.output_type
class LinuxConfigurationResponse(dict):
    """
    Specifies the Linux operating system settings on the virtual machine. For a
    list of supported Linux distributions, see [Linux on Azure-Endorsed
    Distributions](https://learn.microsoft.com/azure/virtual-machines/linux/endorsed-distros).
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "disablePasswordAuthentication":
            suggest = "disable_password_authentication"
        elif key == "enableVMAgentPlatformUpdates":
            suggest = "enable_vm_agent_platform_updates"
        elif key == "patchSettings":
            suggest = "patch_settings"
        elif key == "provisionVMAgent":
            suggest = "provision_vm_agent"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinuxConfigurationResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinuxConfigurationResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinuxConfigurationResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 disable_password_authentication: Optional[builtins.bool] = None,
                 enable_vm_agent_platform_updates: Optional[builtins.bool] = None,
                 patch_settings: Optional['outputs.LinuxPatchSettingsResponse'] = None,
                 provision_vm_agent: Optional[builtins.bool] = None,
                 ssh: Optional['outputs.SshConfigurationResponse'] = None):
        """
        Specifies the Linux operating system settings on the virtual machine. For a
        list of supported Linux distributions, see [Linux on Azure-Endorsed
        Distributions](https://learn.microsoft.com/azure/virtual-machines/linux/endorsed-distros).
        :param builtins.bool disable_password_authentication: Specifies whether password authentication should be disabled.
        :param builtins.bool enable_vm_agent_platform_updates: Indicates whether VMAgent Platform Updates is enabled for the Linux virtual
               machine. Default value is false.
        :param 'LinuxPatchSettingsResponse' patch_settings: [Preview Feature] Specifies settings related to VM Guest Patching on Linux.
        :param builtins.bool provision_vm_agent: Indicates whether virtual machine agent should be provisioned on the virtual
               machine. When this property is not specified in the request body, default
               behavior is to set it to true. This will ensure that VM Agent is installed on
               the VM so that extensions can be added to the VM later.
        :param 'SshConfigurationResponse' ssh: Specifies the ssh key configuration for a Linux OS.
        """
        if disable_password_authentication is not None:
            pulumi.set(__self__, "disable_password_authentication", disable_password_authentication)
        if enable_vm_agent_platform_updates is not None:
            pulumi.set(__self__, "enable_vm_agent_platform_updates", enable_vm_agent_platform_updates)
        if patch_settings is not None:
            pulumi.set(__self__, "patch_settings", patch_settings)
        if provision_vm_agent is not None:
            pulumi.set(__self__, "provision_vm_agent", provision_vm_agent)
        if ssh is not None:
            pulumi.set(__self__, "ssh", ssh)

    @property
    @pulumi.getter(name="disablePasswordAuthentication")
    def disable_password_authentication(self) -> Optional[builtins.bool]:
        """
        Specifies whether password authentication should be disabled.
        """
        return pulumi.get(self, "disable_password_authentication")

    @property
    @pulumi.getter(name="enableVMAgentPlatformUpdates")
    def enable_vm_agent_platform_updates(self) -> Optional[builtins.bool]:
        """
        Indicates whether VMAgent Platform Updates is enabled for the Linux virtual
        machine. Default value is false.
        """
        return pulumi.get(self, "enable_vm_agent_platform_updates")

    @property
    @pulumi.getter(name="patchSettings")
    def patch_settings(self) -> Optional['outputs.LinuxPatchSettingsResponse']:
        """
        [Preview Feature] Specifies settings related to VM Guest Patching on Linux.
        """
        return pulumi.get(self, "patch_settings")

    @property
    @pulumi.getter(name="provisionVMAgent")
    def provision_vm_agent(self) -> Optional[builtins.bool]:
        """
        Indicates whether virtual machine agent should be provisioned on the virtual
        machine. When this property is not specified in the request body, default
        behavior is to set it to true. This will ensure that VM Agent is installed on
        the VM so that extensions can be added to the VM later.
        """
        return pulumi.get(self, "provision_vm_agent")

    @property
    @pulumi.getter
    def ssh(self) -> Optional['outputs.SshConfigurationResponse']:
        """
        Specifies the ssh key configuration for a Linux OS.
        """
        return pulumi.get(self, "ssh")


@pulumi.output_type
class LinuxPatchSettingsResponse(dict):
    """
    Specifies settings related to VM Guest Patching on Linux.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "assessmentMode":
            suggest = "assessment_mode"
        elif key == "automaticByPlatformSettings":
            suggest = "automatic_by_platform_settings"
        elif key == "patchMode":
            suggest = "patch_mode"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinuxPatchSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinuxPatchSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinuxPatchSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 assessment_mode: Optional[builtins.str] = None,
                 automatic_by_platform_settings: Optional['outputs.LinuxVMGuestPatchAutomaticByPlatformSettingsResponse'] = None,
                 patch_mode: Optional[builtins.str] = None):
        """
        Specifies settings related to VM Guest Patching on Linux.
        :param builtins.str assessment_mode: Specifies the mode of VM Guest Patch Assessment for the IaaS virtual
               machine.<br /><br /> Possible values are:<br /><br /> **ImageDefault** - You
               control the timing of patch assessments on a virtual machine. <br /><br />
               **AutomaticByPlatform** - The platform will trigger periodic patch assessments.
               The property provisionVMAgent must be true.
        :param 'LinuxVMGuestPatchAutomaticByPlatformSettingsResponse' automatic_by_platform_settings: Specifies additional settings for patch mode AutomaticByPlatform in VM Guest
               Patching on Linux.
        :param builtins.str patch_mode: Specifies the mode of VM Guest Patching to IaaS virtual machine or virtual
               machines associated to virtual machine scale set with OrchestrationMode as
               Flexible.<br /><br /> Possible values are:<br /><br /> **ImageDefault** - The
               virtual machine's default patching configuration is used. <br /><br />
               **AutomaticByPlatform** - The virtual machine will be automatically updated by
               the platform. The property provisionVMAgent must be true
        """
        if assessment_mode is not None:
            pulumi.set(__self__, "assessment_mode", assessment_mode)
        if automatic_by_platform_settings is not None:
            pulumi.set(__self__, "automatic_by_platform_settings", automatic_by_platform_settings)
        if patch_mode is not None:
            pulumi.set(__self__, "patch_mode", patch_mode)

    @property
    @pulumi.getter(name="assessmentMode")
    def assessment_mode(self) -> Optional[builtins.str]:
        """
        Specifies the mode of VM Guest Patch Assessment for the IaaS virtual
        machine.<br /><br /> Possible values are:<br /><br /> **ImageDefault** - You
        control the timing of patch assessments on a virtual machine. <br /><br />
        **AutomaticByPlatform** - The platform will trigger periodic patch assessments.
        The property provisionVMAgent must be true.
        """
        return pulumi.get(self, "assessment_mode")

    @property
    @pulumi.getter(name="automaticByPlatformSettings")
    def automatic_by_platform_settings(self) -> Optional['outputs.LinuxVMGuestPatchAutomaticByPlatformSettingsResponse']:
        """
        Specifies additional settings for patch mode AutomaticByPlatform in VM Guest
        Patching on Linux.
        """
        return pulumi.get(self, "automatic_by_platform_settings")

    @property
    @pulumi.getter(name="patchMode")
    def patch_mode(self) -> Optional[builtins.str]:
        """
        Specifies the mode of VM Guest Patching to IaaS virtual machine or virtual
        machines associated to virtual machine scale set with OrchestrationMode as
        Flexible.<br /><br /> Possible values are:<br /><br /> **ImageDefault** - The
        virtual machine's default patching configuration is used. <br /><br />
        **AutomaticByPlatform** - The virtual machine will be automatically updated by
        the platform. The property provisionVMAgent must be true
        """
        return pulumi.get(self, "patch_mode")


@pulumi.output_type
class LinuxVMGuestPatchAutomaticByPlatformSettingsResponse(dict):
    """
    Specifies additional settings to be applied when patch mode AutomaticByPlatform
    is selected in Linux patch settings.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "bypassPlatformSafetyChecksOnUserSchedule":
            suggest = "bypass_platform_safety_checks_on_user_schedule"
        elif key == "rebootSetting":
            suggest = "reboot_setting"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LinuxVMGuestPatchAutomaticByPlatformSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LinuxVMGuestPatchAutomaticByPlatformSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LinuxVMGuestPatchAutomaticByPlatformSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 bypass_platform_safety_checks_on_user_schedule: Optional[builtins.bool] = None,
                 reboot_setting: Optional[builtins.str] = None):
        """
        Specifies additional settings to be applied when patch mode AutomaticByPlatform
        is selected in Linux patch settings.
        :param builtins.bool bypass_platform_safety_checks_on_user_schedule: Enables customer to schedule patching without accidental upgrades
        :param builtins.str reboot_setting: Specifies the reboot setting for all AutomaticByPlatform patch installation
               operations.
        """
        if bypass_platform_safety_checks_on_user_schedule is not None:
            pulumi.set(__self__, "bypass_platform_safety_checks_on_user_schedule", bypass_platform_safety_checks_on_user_schedule)
        if reboot_setting is not None:
            pulumi.set(__self__, "reboot_setting", reboot_setting)

    @property
    @pulumi.getter(name="bypassPlatformSafetyChecksOnUserSchedule")
    def bypass_platform_safety_checks_on_user_schedule(self) -> Optional[builtins.bool]:
        """
        Enables customer to schedule patching without accidental upgrades
        """
        return pulumi.get(self, "bypass_platform_safety_checks_on_user_schedule")

    @property
    @pulumi.getter(name="rebootSetting")
    def reboot_setting(self) -> Optional[builtins.str]:
        """
        Specifies the reboot setting for all AutomaticByPlatform patch installation
        operations.
        """
        return pulumi.get(self, "reboot_setting")


@pulumi.output_type
class LocationProfileResponse(dict):
    """
    Represents the profile for a single additional location in the Fleet. The location and the virtualMachineProfileOverride (optional).
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "virtualMachineProfileOverride":
            suggest = "virtual_machine_profile_override"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in LocationProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        LocationProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        LocationProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 location: builtins.str,
                 virtual_machine_profile_override: Optional['outputs.BaseVirtualMachineProfileResponse'] = None):
        """
        Represents the profile for a single additional location in the Fleet. The location and the virtualMachineProfileOverride (optional).
        :param builtins.str location: The ARM location name of the additional region. If LocationProfile is specified, then location is required.
        :param 'BaseVirtualMachineProfileResponse' virtual_machine_profile_override: An override for computeProfile.baseVirtualMachineProfile specific to this region. 
               This override is merged with the base virtual machine profile to define the final virtual machine profile for the resources deployed in this location.
        """
        pulumi.set(__self__, "location", location)
        if virtual_machine_profile_override is not None:
            pulumi.set(__self__, "virtual_machine_profile_override", virtual_machine_profile_override)

    @property
    @pulumi.getter
    def location(self) -> builtins.str:
        """
        The ARM location name of the additional region. If LocationProfile is specified, then location is required.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter(name="virtualMachineProfileOverride")
    def virtual_machine_profile_override(self) -> Optional['outputs.BaseVirtualMachineProfileResponse']:
        """
        An override for computeProfile.baseVirtualMachineProfile specific to this region. 
        This override is merged with the base virtual machine profile to define the final virtual machine profile for the resources deployed in this location.
        """
        return pulumi.get(self, "virtual_machine_profile_override")


@pulumi.output_type
class ManagedServiceIdentityResponse(dict):
    """
    Managed service identity (system assigned and/or user assigned identities)
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "principalId":
            suggest = "principal_id"
        elif key == "tenantId":
            suggest = "tenant_id"
        elif key == "userAssignedIdentities":
            suggest = "user_assigned_identities"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ManagedServiceIdentityResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ManagedServiceIdentityResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ManagedServiceIdentityResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 principal_id: builtins.str,
                 tenant_id: builtins.str,
                 type: builtins.str,
                 user_assigned_identities: Optional[Mapping[str, 'outputs.UserAssignedIdentityResponse']] = None):
        """
        Managed service identity (system assigned and/or user assigned identities)
        :param builtins.str principal_id: The service principal ID of the system assigned identity. This property will only be provided for a system assigned identity.
        :param builtins.str tenant_id: The tenant ID of the system assigned identity. This property will only be provided for a system assigned identity.
        :param builtins.str type: Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        :param Mapping[str, 'UserAssignedIdentityResponse'] user_assigned_identities: The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        pulumi.set(__self__, "principal_id", principal_id)
        pulumi.set(__self__, "tenant_id", tenant_id)
        pulumi.set(__self__, "type", type)
        if user_assigned_identities is not None:
            pulumi.set(__self__, "user_assigned_identities", user_assigned_identities)

    @property
    @pulumi.getter(name="principalId")
    def principal_id(self) -> builtins.str:
        """
        The service principal ID of the system assigned identity. This property will only be provided for a system assigned identity.
        """
        return pulumi.get(self, "principal_id")

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> builtins.str:
        """
        The tenant ID of the system assigned identity. This property will only be provided for a system assigned identity.
        """
        return pulumi.get(self, "tenant_id")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="userAssignedIdentities")
    def user_assigned_identities(self) -> Optional[Mapping[str, 'outputs.UserAssignedIdentityResponse']]:
        """
        The set of user assigned identities associated with the resource. The userAssignedIdentities dictionary keys will be ARM resource ids in the form: '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}. The dictionary values can be empty objects ({}) in requests.
        """
        return pulumi.get(self, "user_assigned_identities")


@pulumi.output_type
class OSImageNotificationProfileResponse(dict):
    """
    Specifies OS Image Scheduled Event related configurations.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "notBeforeTimeout":
            suggest = "not_before_timeout"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in OSImageNotificationProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        OSImageNotificationProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        OSImageNotificationProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 enable: Optional[builtins.bool] = None,
                 not_before_timeout: Optional[builtins.str] = None):
        """
        Specifies OS Image Scheduled Event related configurations.
        :param builtins.bool enable: Specifies whether the OS Image Scheduled event is enabled or disabled.
        :param builtins.str not_before_timeout: Length of time a Virtual Machine being reimaged or having its OS upgraded will
               have to potentially approve the OS Image Scheduled Event before the event is
               auto approved (timed out). The configuration is specified in ISO 8601 format,
               and the value must not exceed 15 minutes (PT15M)
        """
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if not_before_timeout is not None:
            pulumi.set(__self__, "not_before_timeout", not_before_timeout)

    @property
    @pulumi.getter
    def enable(self) -> Optional[builtins.bool]:
        """
        Specifies whether the OS Image Scheduled event is enabled or disabled.
        """
        return pulumi.get(self, "enable")

    @property
    @pulumi.getter(name="notBeforeTimeout")
    def not_before_timeout(self) -> Optional[builtins.str]:
        """
        Length of time a Virtual Machine being reimaged or having its OS upgraded will
        have to potentially approve the OS Image Scheduled Event before the event is
        auto approved (timed out). The configuration is specified in ISO 8601 format,
        and the value must not exceed 15 minutes (PT15M)
        """
        return pulumi.get(self, "not_before_timeout")


@pulumi.output_type
class PatchSettingsResponse(dict):
    """
    Specifies settings related to VM Guest Patching on Windows.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "assessmentMode":
            suggest = "assessment_mode"
        elif key == "automaticByPlatformSettings":
            suggest = "automatic_by_platform_settings"
        elif key == "enableHotpatching":
            suggest = "enable_hotpatching"
        elif key == "patchMode":
            suggest = "patch_mode"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PatchSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PatchSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PatchSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 assessment_mode: Optional[builtins.str] = None,
                 automatic_by_platform_settings: Optional['outputs.WindowsVMGuestPatchAutomaticByPlatformSettingsResponse'] = None,
                 enable_hotpatching: Optional[builtins.bool] = None,
                 patch_mode: Optional[builtins.str] = None):
        """
        Specifies settings related to VM Guest Patching on Windows.
        :param builtins.str assessment_mode: Specifies the mode of VM Guest patch assessment for the IaaS virtual
               machine.<br /><br /> Possible values are:<br /><br /> **ImageDefault** - You
               control the timing of patch assessments on a virtual machine.<br /><br />
               **AutomaticByPlatform** - The platform will trigger periodic patch assessments.
               The property provisionVMAgent must be true.
        :param 'WindowsVMGuestPatchAutomaticByPlatformSettingsResponse' automatic_by_platform_settings: Specifies additional settings for patch mode AutomaticByPlatform in VM Guest
               Patching on Windows.
        :param builtins.bool enable_hotpatching: Enables customers to patch their Azure VMs without requiring a reboot. For
               enableHotpatching, the 'provisionVMAgent' must be set to true and 'patchMode'
               must be set to 'AutomaticByPlatform'.
        :param builtins.str patch_mode: Specifies the mode of VM Guest Patching to IaaS virtual machine or virtual
               machines associated to virtual machine scale set with OrchestrationMode as
               Flexible.<br /><br /> Possible values are:<br /><br /> **Manual** - You
               control the application of patches to a virtual machine. You do this by
               applying patches manually inside the VM. In this mode, automatic updates are
               disabled; the property WindowsConfiguration.enableAutomaticUpdates must be
               false<br /><br /> **AutomaticByOS** - The virtual machine will automatically be
               updated by the OS. The property WindowsConfiguration.enableAutomaticUpdates
               must be true. <br /><br /> **AutomaticByPlatform** - the virtual machine will
               automatically updated by the platform. The properties provisionVMAgent and
               WindowsConfiguration.enableAutomaticUpdates must be true
        """
        if assessment_mode is not None:
            pulumi.set(__self__, "assessment_mode", assessment_mode)
        if automatic_by_platform_settings is not None:
            pulumi.set(__self__, "automatic_by_platform_settings", automatic_by_platform_settings)
        if enable_hotpatching is not None:
            pulumi.set(__self__, "enable_hotpatching", enable_hotpatching)
        if patch_mode is not None:
            pulumi.set(__self__, "patch_mode", patch_mode)

    @property
    @pulumi.getter(name="assessmentMode")
    def assessment_mode(self) -> Optional[builtins.str]:
        """
        Specifies the mode of VM Guest patch assessment for the IaaS virtual
        machine.<br /><br /> Possible values are:<br /><br /> **ImageDefault** - You
        control the timing of patch assessments on a virtual machine.<br /><br />
        **AutomaticByPlatform** - The platform will trigger periodic patch assessments.
        The property provisionVMAgent must be true.
        """
        return pulumi.get(self, "assessment_mode")

    @property
    @pulumi.getter(name="automaticByPlatformSettings")
    def automatic_by_platform_settings(self) -> Optional['outputs.WindowsVMGuestPatchAutomaticByPlatformSettingsResponse']:
        """
        Specifies additional settings for patch mode AutomaticByPlatform in VM Guest
        Patching on Windows.
        """
        return pulumi.get(self, "automatic_by_platform_settings")

    @property
    @pulumi.getter(name="enableHotpatching")
    def enable_hotpatching(self) -> Optional[builtins.bool]:
        """
        Enables customers to patch their Azure VMs without requiring a reboot. For
        enableHotpatching, the 'provisionVMAgent' must be set to true and 'patchMode'
        must be set to 'AutomaticByPlatform'.
        """
        return pulumi.get(self, "enable_hotpatching")

    @property
    @pulumi.getter(name="patchMode")
    def patch_mode(self) -> Optional[builtins.str]:
        """
        Specifies the mode of VM Guest Patching to IaaS virtual machine or virtual
        machines associated to virtual machine scale set with OrchestrationMode as
        Flexible.<br /><br /> Possible values are:<br /><br /> **Manual** - You
        control the application of patches to a virtual machine. You do this by
        applying patches manually inside the VM. In this mode, automatic updates are
        disabled; the property WindowsConfiguration.enableAutomaticUpdates must be
        false<br /><br /> **AutomaticByOS** - The virtual machine will automatically be
        updated by the OS. The property WindowsConfiguration.enableAutomaticUpdates
        must be true. <br /><br /> **AutomaticByPlatform** - the virtual machine will
        automatically updated by the platform. The properties provisionVMAgent and
        WindowsConfiguration.enableAutomaticUpdates must be true
        """
        return pulumi.get(self, "patch_mode")


@pulumi.output_type
class PlanResponse(dict):
    """
    Plan for the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "promotionCode":
            suggest = "promotion_code"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in PlanResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        PlanResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        PlanResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 name: builtins.str,
                 product: builtins.str,
                 publisher: builtins.str,
                 promotion_code: Optional[builtins.str] = None,
                 version: Optional[builtins.str] = None):
        """
        Plan for the resource.
        :param builtins.str name: A user defined name of the 3rd Party Artifact that is being procured.
        :param builtins.str product: The 3rd Party artifact that is being procured. E.g. NewRelic. Product maps to the OfferID specified for the artifact at the time of Data Market onboarding. 
        :param builtins.str publisher: The publisher of the 3rd Party Artifact that is being bought. E.g. NewRelic
        :param builtins.str promotion_code: A publisher provided promotion code as provisioned in Data Market for the said product/artifact.
        :param builtins.str version: The version of the desired product/artifact.
        """
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "product", product)
        pulumi.set(__self__, "publisher", publisher)
        if promotion_code is not None:
            pulumi.set(__self__, "promotion_code", promotion_code)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        A user defined name of the 3rd Party Artifact that is being procured.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def product(self) -> builtins.str:
        """
        The 3rd Party artifact that is being procured. E.g. NewRelic. Product maps to the OfferID specified for the artifact at the time of Data Market onboarding. 
        """
        return pulumi.get(self, "product")

    @property
    @pulumi.getter
    def publisher(self) -> builtins.str:
        """
        The publisher of the 3rd Party Artifact that is being bought. E.g. NewRelic
        """
        return pulumi.get(self, "publisher")

    @property
    @pulumi.getter(name="promotionCode")
    def promotion_code(self) -> Optional[builtins.str]:
        """
        A publisher provided promotion code as provisioned in Data Market for the said product/artifact.
        """
        return pulumi.get(self, "promotion_code")

    @property
    @pulumi.getter
    def version(self) -> Optional[builtins.str]:
        """
        The version of the desired product/artifact.
        """
        return pulumi.get(self, "version")


@pulumi.output_type
class ProxyAgentSettingsResponse(dict):
    """
    Specifies ProxyAgent settings while creating the virtual machine. Minimum
    api-version: 2023-09-01.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "keyIncarnationId":
            suggest = "key_incarnation_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProxyAgentSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProxyAgentSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProxyAgentSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 enabled: Optional[builtins.bool] = None,
                 key_incarnation_id: Optional[builtins.int] = None,
                 mode: Optional[builtins.str] = None):
        """
        Specifies ProxyAgent settings while creating the virtual machine. Minimum
        api-version: 2023-09-01.
        :param builtins.bool enabled: Specifies whether ProxyAgent feature should be enabled on the virtual machine
               or virtual machine scale set.
        :param builtins.int key_incarnation_id: Increase the value of this property allows user to reset the key used for
               securing communication channel between guest and host.
        :param builtins.str mode: Specifies the mode that ProxyAgent will execute on if the feature is enabled.
               ProxyAgent will start to audit or monitor but not enforce access control over
               requests to host endpoints in Audit mode, while in Enforce mode it will enforce
               access control. The default value is Enforce mode.
        """
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if key_incarnation_id is not None:
            pulumi.set(__self__, "key_incarnation_id", key_incarnation_id)
        if mode is not None:
            pulumi.set(__self__, "mode", mode)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[builtins.bool]:
        """
        Specifies whether ProxyAgent feature should be enabled on the virtual machine
        or virtual machine scale set.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="keyIncarnationId")
    def key_incarnation_id(self) -> Optional[builtins.int]:
        """
        Increase the value of this property allows user to reset the key used for
        securing communication channel between guest and host.
        """
        return pulumi.get(self, "key_incarnation_id")

    @property
    @pulumi.getter
    def mode(self) -> Optional[builtins.str]:
        """
        Specifies the mode that ProxyAgent will execute on if the feature is enabled.
        ProxyAgent will start to audit or monitor but not enforce access control over
        requests to host endpoints in Audit mode, while in Enforce mode it will enforce
        access control. The default value is Enforce mode.
        """
        return pulumi.get(self, "mode")


@pulumi.output_type
class PublicIPAddressSkuResponse(dict):
    """
    Describes the public IP Sku. It can only be set with OrchestrationMode as
    Flexible.
    """
    def __init__(__self__, *,
                 name: Optional[builtins.str] = None,
                 tier: Optional[builtins.str] = None):
        """
        Describes the public IP Sku. It can only be set with OrchestrationMode as
        Flexible.
        :param builtins.str name: Specify public IP sku name
        :param builtins.str tier: Specify public IP sku tier
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if tier is not None:
            pulumi.set(__self__, "tier", tier)

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        Specify public IP sku name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def tier(self) -> Optional[builtins.str]:
        """
        Specify public IP sku tier
        """
        return pulumi.get(self, "tier")


@pulumi.output_type
class RegularPriorityProfileResponse(dict):
    """
    Configuration Options for Regular instances in Compute Fleet.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "allocationStrategy":
            suggest = "allocation_strategy"
        elif key == "minCapacity":
            suggest = "min_capacity"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RegularPriorityProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RegularPriorityProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RegularPriorityProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 allocation_strategy: Optional[builtins.str] = None,
                 capacity: Optional[builtins.int] = None,
                 min_capacity: Optional[builtins.int] = None):
        """
        Configuration Options for Regular instances in Compute Fleet.
        :param builtins.str allocation_strategy: Allocation strategy to follow when determining the VM sizes distribution for Regular VMs.
        :param builtins.int capacity: Total capacity to achieve. It is currently in terms of number of VMs.
        :param builtins.int min_capacity: Minimum capacity to achieve which cannot be updated. If we will not be able to "guarantee" minimum capacity, we will reject the request in the sync path itself.
        """
        if allocation_strategy is not None:
            pulumi.set(__self__, "allocation_strategy", allocation_strategy)
        if capacity is not None:
            pulumi.set(__self__, "capacity", capacity)
        if min_capacity is not None:
            pulumi.set(__self__, "min_capacity", min_capacity)

    @property
    @pulumi.getter(name="allocationStrategy")
    def allocation_strategy(self) -> Optional[builtins.str]:
        """
        Allocation strategy to follow when determining the VM sizes distribution for Regular VMs.
        """
        return pulumi.get(self, "allocation_strategy")

    @property
    @pulumi.getter
    def capacity(self) -> Optional[builtins.int]:
        """
        Total capacity to achieve. It is currently in terms of number of VMs.
        """
        return pulumi.get(self, "capacity")

    @property
    @pulumi.getter(name="minCapacity")
    def min_capacity(self) -> Optional[builtins.int]:
        """
        Minimum capacity to achieve which cannot be updated. If we will not be able to "guarantee" minimum capacity, we will reject the request in the sync path itself.
        """
        return pulumi.get(self, "min_capacity")


@pulumi.output_type
class ScheduledEventsProfileResponse(dict):
    """
    Specifies Scheduled Event related configurations.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "osImageNotificationProfile":
            suggest = "os_image_notification_profile"
        elif key == "terminateNotificationProfile":
            suggest = "terminate_notification_profile"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ScheduledEventsProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ScheduledEventsProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ScheduledEventsProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 os_image_notification_profile: Optional['outputs.OSImageNotificationProfileResponse'] = None,
                 terminate_notification_profile: Optional['outputs.TerminateNotificationProfileResponse'] = None):
        """
        Specifies Scheduled Event related configurations.
        :param 'OSImageNotificationProfileResponse' os_image_notification_profile: Specifies OS Image Scheduled Event related configurations.
        :param 'TerminateNotificationProfileResponse' terminate_notification_profile: Specifies Terminate Scheduled Event related configurations.
        """
        if os_image_notification_profile is not None:
            pulumi.set(__self__, "os_image_notification_profile", os_image_notification_profile)
        if terminate_notification_profile is not None:
            pulumi.set(__self__, "terminate_notification_profile", terminate_notification_profile)

    @property
    @pulumi.getter(name="osImageNotificationProfile")
    def os_image_notification_profile(self) -> Optional['outputs.OSImageNotificationProfileResponse']:
        """
        Specifies OS Image Scheduled Event related configurations.
        """
        return pulumi.get(self, "os_image_notification_profile")

    @property
    @pulumi.getter(name="terminateNotificationProfile")
    def terminate_notification_profile(self) -> Optional['outputs.TerminateNotificationProfileResponse']:
        """
        Specifies Terminate Scheduled Event related configurations.
        """
        return pulumi.get(self, "terminate_notification_profile")


@pulumi.output_type
class SecurityPostureReferenceResponse(dict):
    """
    Specifies the security posture to be used for all virtual machines in the scale
    set. Minimum api-version: 2023-03-01
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "excludeExtensions":
            suggest = "exclude_extensions"
        elif key == "isOverridable":
            suggest = "is_overridable"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SecurityPostureReferenceResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SecurityPostureReferenceResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SecurityPostureReferenceResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 exclude_extensions: Optional[Sequence[builtins.str]] = None,
                 id: Optional[builtins.str] = None,
                 is_overridable: Optional[builtins.bool] = None):
        """
        Specifies the security posture to be used for all virtual machines in the scale
        set. Minimum api-version: 2023-03-01
        :param Sequence[builtins.str] exclude_extensions: List of virtual machine extension names to exclude when applying the security
               posture.
        :param builtins.str id: The security posture reference id in the form of
               /CommunityGalleries/{communityGalleryName}/securityPostures/{securityPostureName}/versions/{major.minor.patch}|{major.*}|latest
        :param builtins.bool is_overridable: Whether the security posture can be overridden by the user.
        """
        if exclude_extensions is not None:
            pulumi.set(__self__, "exclude_extensions", exclude_extensions)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if is_overridable is not None:
            pulumi.set(__self__, "is_overridable", is_overridable)

    @property
    @pulumi.getter(name="excludeExtensions")
    def exclude_extensions(self) -> Optional[Sequence[builtins.str]]:
        """
        List of virtual machine extension names to exclude when applying the security
        posture.
        """
        return pulumi.get(self, "exclude_extensions")

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        The security posture reference id in the form of
        /CommunityGalleries/{communityGalleryName}/securityPostures/{securityPostureName}/versions/{major.minor.patch}|{major.*}|latest
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isOverridable")
    def is_overridable(self) -> Optional[builtins.bool]:
        """
        Whether the security posture can be overridden by the user.
        """
        return pulumi.get(self, "is_overridable")


@pulumi.output_type
class SecurityProfileResponse(dict):
    """
    Specifies the Security profile settings for the virtual machine or virtual
    machine scale set.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "encryptionAtHost":
            suggest = "encryption_at_host"
        elif key == "encryptionIdentity":
            suggest = "encryption_identity"
        elif key == "proxyAgentSettings":
            suggest = "proxy_agent_settings"
        elif key == "securityType":
            suggest = "security_type"
        elif key == "uefiSettings":
            suggest = "uefi_settings"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SecurityProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SecurityProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SecurityProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 encryption_at_host: Optional[builtins.bool] = None,
                 encryption_identity: Optional['outputs.EncryptionIdentityResponse'] = None,
                 proxy_agent_settings: Optional['outputs.ProxyAgentSettingsResponse'] = None,
                 security_type: Optional[builtins.str] = None,
                 uefi_settings: Optional['outputs.UefiSettingsResponse'] = None):
        """
        Specifies the Security profile settings for the virtual machine or virtual
        machine scale set.
        :param builtins.bool encryption_at_host: This property can be used by user in the request to enable or disable the Host
               Encryption for the virtual machine or virtual machine scale set. This will
               enable the encryption for all the disks including Resource/Temp disk at host
               itself. The default behavior is: The Encryption at host will be disabled unless
               this property is set to true for the resource.
        :param 'EncryptionIdentityResponse' encryption_identity: Specifies the Managed Identity used by ADE to get access token for keyvault
               operations.
        :param 'ProxyAgentSettingsResponse' proxy_agent_settings: Specifies ProxyAgent settings while creating the virtual machine. Minimum
               api-version: 2023-09-01.
        :param builtins.str security_type: Specifies the SecurityType of the virtual machine. It has to be set to any
               specified value to enable UefiSettings. The default behavior is: UefiSettings
               will not be enabled unless this property is set.
        :param 'UefiSettingsResponse' uefi_settings: Specifies the security settings like secure boot and vTPM used while creating
               the virtual machine. Minimum api-version: 2020-12-01.
        """
        if encryption_at_host is not None:
            pulumi.set(__self__, "encryption_at_host", encryption_at_host)
        if encryption_identity is not None:
            pulumi.set(__self__, "encryption_identity", encryption_identity)
        if proxy_agent_settings is not None:
            pulumi.set(__self__, "proxy_agent_settings", proxy_agent_settings)
        if security_type is not None:
            pulumi.set(__self__, "security_type", security_type)
        if uefi_settings is not None:
            pulumi.set(__self__, "uefi_settings", uefi_settings)

    @property
    @pulumi.getter(name="encryptionAtHost")
    def encryption_at_host(self) -> Optional[builtins.bool]:
        """
        This property can be used by user in the request to enable or disable the Host
        Encryption for the virtual machine or virtual machine scale set. This will
        enable the encryption for all the disks including Resource/Temp disk at host
        itself. The default behavior is: The Encryption at host will be disabled unless
        this property is set to true for the resource.
        """
        return pulumi.get(self, "encryption_at_host")

    @property
    @pulumi.getter(name="encryptionIdentity")
    def encryption_identity(self) -> Optional['outputs.EncryptionIdentityResponse']:
        """
        Specifies the Managed Identity used by ADE to get access token for keyvault
        operations.
        """
        return pulumi.get(self, "encryption_identity")

    @property
    @pulumi.getter(name="proxyAgentSettings")
    def proxy_agent_settings(self) -> Optional['outputs.ProxyAgentSettingsResponse']:
        """
        Specifies ProxyAgent settings while creating the virtual machine. Minimum
        api-version: 2023-09-01.
        """
        return pulumi.get(self, "proxy_agent_settings")

    @property
    @pulumi.getter(name="securityType")
    def security_type(self) -> Optional[builtins.str]:
        """
        Specifies the SecurityType of the virtual machine. It has to be set to any
        specified value to enable UefiSettings. The default behavior is: UefiSettings
        will not be enabled unless this property is set.
        """
        return pulumi.get(self, "security_type")

    @property
    @pulumi.getter(name="uefiSettings")
    def uefi_settings(self) -> Optional['outputs.UefiSettingsResponse']:
        """
        Specifies the security settings like secure boot and vTPM used while creating
        the virtual machine. Minimum api-version: 2020-12-01.
        """
        return pulumi.get(self, "uefi_settings")


@pulumi.output_type
class ServiceArtifactReferenceResponse(dict):
    """
    Specifies the service artifact reference id used to set same image version for
    all virtual machines in the scale set when using 'latest' image version.
    Minimum api-version: 2022-11-01
    """
    def __init__(__self__, *,
                 id: Optional[builtins.str] = None):
        """
        Specifies the service artifact reference id used to set same image version for
        all virtual machines in the scale set when using 'latest' image version.
        Minimum api-version: 2022-11-01
        :param builtins.str id: The service artifact reference id in the form of
               /subscriptions/{subscriptionId}/resourceGroups/{resourceGroup}/providers/Microsoft.Compute/galleries/{galleryName}/serviceArtifacts/{serviceArtifactName}/vmArtifactsProfiles/{vmArtifactsProfilesName}
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        The service artifact reference id in the form of
        /subscriptions/{subscriptionId}/resourceGroups/{resourceGroup}/providers/Microsoft.Compute/galleries/{galleryName}/serviceArtifacts/{serviceArtifactName}/vmArtifactsProfiles/{vmArtifactsProfilesName}
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class SpotPriorityProfileResponse(dict):
    """
    Configuration Options for Spot instances in Compute Fleet.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "allocationStrategy":
            suggest = "allocation_strategy"
        elif key == "evictionPolicy":
            suggest = "eviction_policy"
        elif key == "maxPricePerVM":
            suggest = "max_price_per_vm"
        elif key == "minCapacity":
            suggest = "min_capacity"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SpotPriorityProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SpotPriorityProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SpotPriorityProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 allocation_strategy: Optional[builtins.str] = None,
                 capacity: Optional[builtins.int] = None,
                 eviction_policy: Optional[builtins.str] = None,
                 maintain: Optional[builtins.bool] = None,
                 max_price_per_vm: Optional[builtins.float] = None,
                 min_capacity: Optional[builtins.int] = None):
        """
        Configuration Options for Spot instances in Compute Fleet.
        :param builtins.str allocation_strategy: Allocation strategy to follow when determining the VM sizes distribution for Spot VMs.
        :param builtins.int capacity: Total capacity to achieve. It is currently in terms of number of VMs.
        :param builtins.str eviction_policy: Eviction Policy to follow when evicting Spot VMs.
        :param builtins.bool maintain: Flag to enable/disable continuous goal seeking for the desired capacity and restoration of evicted Spot VMs.
               If maintain is enabled, AzureFleetRP will use all VM sizes in vmSizesProfile to create new VMs (if VMs are evicted deleted)
               or update existing VMs with new VM sizes (if VMs are evicted deallocated or failed to allocate due to capacity constraint) in order to achieve the desired capacity.
               Maintain is enabled by default.
        :param builtins.float max_price_per_vm: Price per hour of each Spot VM will never exceed this.
        :param builtins.int min_capacity: Minimum capacity to achieve which cannot be updated. If we will not be able to "guarantee" minimum capacity, we will reject the request in the sync path itself.
        """
        if allocation_strategy is not None:
            pulumi.set(__self__, "allocation_strategy", allocation_strategy)
        if capacity is not None:
            pulumi.set(__self__, "capacity", capacity)
        if eviction_policy is not None:
            pulumi.set(__self__, "eviction_policy", eviction_policy)
        if maintain is not None:
            pulumi.set(__self__, "maintain", maintain)
        if max_price_per_vm is not None:
            pulumi.set(__self__, "max_price_per_vm", max_price_per_vm)
        if min_capacity is not None:
            pulumi.set(__self__, "min_capacity", min_capacity)

    @property
    @pulumi.getter(name="allocationStrategy")
    def allocation_strategy(self) -> Optional[builtins.str]:
        """
        Allocation strategy to follow when determining the VM sizes distribution for Spot VMs.
        """
        return pulumi.get(self, "allocation_strategy")

    @property
    @pulumi.getter
    def capacity(self) -> Optional[builtins.int]:
        """
        Total capacity to achieve. It is currently in terms of number of VMs.
        """
        return pulumi.get(self, "capacity")

    @property
    @pulumi.getter(name="evictionPolicy")
    def eviction_policy(self) -> Optional[builtins.str]:
        """
        Eviction Policy to follow when evicting Spot VMs.
        """
        return pulumi.get(self, "eviction_policy")

    @property
    @pulumi.getter
    def maintain(self) -> Optional[builtins.bool]:
        """
        Flag to enable/disable continuous goal seeking for the desired capacity and restoration of evicted Spot VMs.
        If maintain is enabled, AzureFleetRP will use all VM sizes in vmSizesProfile to create new VMs (if VMs are evicted deleted)
        or update existing VMs with new VM sizes (if VMs are evicted deallocated or failed to allocate due to capacity constraint) in order to achieve the desired capacity.
        Maintain is enabled by default.
        """
        return pulumi.get(self, "maintain")

    @property
    @pulumi.getter(name="maxPricePerVM")
    def max_price_per_vm(self) -> Optional[builtins.float]:
        """
        Price per hour of each Spot VM will never exceed this.
        """
        return pulumi.get(self, "max_price_per_vm")

    @property
    @pulumi.getter(name="minCapacity")
    def min_capacity(self) -> Optional[builtins.int]:
        """
        Minimum capacity to achieve which cannot be updated. If we will not be able to "guarantee" minimum capacity, we will reject the request in the sync path itself.
        """
        return pulumi.get(self, "min_capacity")


@pulumi.output_type
class SshConfigurationResponse(dict):
    """
    SSH configuration for Linux based VMs running on Azure
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "publicKeys":
            suggest = "public_keys"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SshConfigurationResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SshConfigurationResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SshConfigurationResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 public_keys: Optional[Sequence['outputs.SshPublicKeyResponse']] = None):
        """
        SSH configuration for Linux based VMs running on Azure
        :param Sequence['SshPublicKeyResponse'] public_keys: The list of SSH public keys used to authenticate with linux based VMs.
        """
        if public_keys is not None:
            pulumi.set(__self__, "public_keys", public_keys)

    @property
    @pulumi.getter(name="publicKeys")
    def public_keys(self) -> Optional[Sequence['outputs.SshPublicKeyResponse']]:
        """
        The list of SSH public keys used to authenticate with linux based VMs.
        """
        return pulumi.get(self, "public_keys")


@pulumi.output_type
class SshPublicKeyResponse(dict):
    """
    Contains information about SSH certificate public key and the path on the Linux
    VM where the public key is placed.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "keyData":
            suggest = "key_data"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SshPublicKeyResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SshPublicKeyResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SshPublicKeyResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 key_data: Optional[builtins.str] = None,
                 path: Optional[builtins.str] = None):
        """
        Contains information about SSH certificate public key and the path on the Linux
        VM where the public key is placed.
        :param builtins.str key_data: SSH public key certificate used to authenticate with the VM through ssh. The
               key needs to be at least 2048-bit and in ssh-rsa format. For creating ssh keys,
               see [Create SSH keys on Linux and Mac for Linux VMs in
               Azure]https://learn.microsoft.com/azure/virtual-machines/linux/create-ssh-keys-detailed).
        :param builtins.str path: Specifies the full path on the created VM where ssh public key is stored. If
               the file already exists, the specified key is appended to the file. Example:
               /home/user/.ssh/authorized_keys
        """
        if key_data is not None:
            pulumi.set(__self__, "key_data", key_data)
        if path is not None:
            pulumi.set(__self__, "path", path)

    @property
    @pulumi.getter(name="keyData")
    def key_data(self) -> Optional[builtins.str]:
        """
        SSH public key certificate used to authenticate with the VM through ssh. The
        key needs to be at least 2048-bit and in ssh-rsa format. For creating ssh keys,
        see [Create SSH keys on Linux and Mac for Linux VMs in
        Azure]https://learn.microsoft.com/azure/virtual-machines/linux/create-ssh-keys-detailed).
        """
        return pulumi.get(self, "key_data")

    @property
    @pulumi.getter
    def path(self) -> Optional[builtins.str]:
        """
        Specifies the full path on the created VM where ssh public key is stored. If
        the file already exists, the specified key is appended to the file. Example:
        /home/user/.ssh/authorized_keys
        """
        return pulumi.get(self, "path")


@pulumi.output_type
class SubResourceResponse(dict):
    """
    Describes SubResource
    """
    def __init__(__self__, *,
                 id: Optional[builtins.str] = None):
        """
        Describes SubResource
        :param builtins.str id: Resource Id
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        Resource Id
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class SystemDataResponse(dict):
    """
    Metadata pertaining to creation and last modification of the resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createdAt":
            suggest = "created_at"
        elif key == "createdBy":
            suggest = "created_by"
        elif key == "createdByType":
            suggest = "created_by_type"
        elif key == "lastModifiedAt":
            suggest = "last_modified_at"
        elif key == "lastModifiedBy":
            suggest = "last_modified_by"
        elif key == "lastModifiedByType":
            suggest = "last_modified_by_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SystemDataResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SystemDataResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 created_at: Optional[builtins.str] = None,
                 created_by: Optional[builtins.str] = None,
                 created_by_type: Optional[builtins.str] = None,
                 last_modified_at: Optional[builtins.str] = None,
                 last_modified_by: Optional[builtins.str] = None,
                 last_modified_by_type: Optional[builtins.str] = None):
        """
        Metadata pertaining to creation and last modification of the resource.
        :param builtins.str created_at: The timestamp of resource creation (UTC).
        :param builtins.str created_by: The identity that created the resource.
        :param builtins.str created_by_type: The type of identity that created the resource.
        :param builtins.str last_modified_at: The timestamp of resource last modification (UTC)
        :param builtins.str last_modified_by: The identity that last modified the resource.
        :param builtins.str last_modified_by_type: The type of identity that last modified the resource.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if created_by is not None:
            pulumi.set(__self__, "created_by", created_by)
        if created_by_type is not None:
            pulumi.set(__self__, "created_by_type", created_by_type)
        if last_modified_at is not None:
            pulumi.set(__self__, "last_modified_at", last_modified_at)
        if last_modified_by is not None:
            pulumi.set(__self__, "last_modified_by", last_modified_by)
        if last_modified_by_type is not None:
            pulumi.set(__self__, "last_modified_by_type", last_modified_by_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[builtins.str]:
        """
        The timestamp of resource creation (UTC).
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> Optional[builtins.str]:
        """
        The identity that created the resource.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdByType")
    def created_by_type(self) -> Optional[builtins.str]:
        """
        The type of identity that created the resource.
        """
        return pulumi.get(self, "created_by_type")

    @property
    @pulumi.getter(name="lastModifiedAt")
    def last_modified_at(self) -> Optional[builtins.str]:
        """
        The timestamp of resource last modification (UTC)
        """
        return pulumi.get(self, "last_modified_at")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> Optional[builtins.str]:
        """
        The identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter(name="lastModifiedByType")
    def last_modified_by_type(self) -> Optional[builtins.str]:
        """
        The type of identity that last modified the resource.
        """
        return pulumi.get(self, "last_modified_by_type")


@pulumi.output_type
class TerminateNotificationProfileResponse(dict):
    """
    Specifies Terminate Scheduled Event related configurations.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "notBeforeTimeout":
            suggest = "not_before_timeout"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in TerminateNotificationProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        TerminateNotificationProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        TerminateNotificationProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 enable: Optional[builtins.bool] = None,
                 not_before_timeout: Optional[builtins.str] = None):
        """
        Specifies Terminate Scheduled Event related configurations.
        :param builtins.bool enable: Specifies whether the Terminate Scheduled event is enabled or disabled.
        :param builtins.str not_before_timeout: Configurable length of time a Virtual Machine being deleted will have to
               potentially approve the Terminate Scheduled Event before the event is auto
               approved (timed out). The configuration must be specified in ISO 8601 format,
               the default value is 5 minutes (PT5M)
        """
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if not_before_timeout is not None:
            pulumi.set(__self__, "not_before_timeout", not_before_timeout)

    @property
    @pulumi.getter
    def enable(self) -> Optional[builtins.bool]:
        """
        Specifies whether the Terminate Scheduled event is enabled or disabled.
        """
        return pulumi.get(self, "enable")

    @property
    @pulumi.getter(name="notBeforeTimeout")
    def not_before_timeout(self) -> Optional[builtins.str]:
        """
        Configurable length of time a Virtual Machine being deleted will have to
        potentially approve the Terminate Scheduled Event before the event is auto
        approved (timed out). The configuration must be specified in ISO 8601 format,
        the default value is 5 minutes (PT5M)
        """
        return pulumi.get(self, "not_before_timeout")


@pulumi.output_type
class UefiSettingsResponse(dict):
    """
    Specifies the security settings like secure boot and vTPM used while creating
    the virtual machine. Minimum api-version: 2020-12-01.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "secureBootEnabled":
            suggest = "secure_boot_enabled"
        elif key == "vTpmEnabled":
            suggest = "v_tpm_enabled"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in UefiSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        UefiSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        UefiSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 secure_boot_enabled: Optional[builtins.bool] = None,
                 v_tpm_enabled: Optional[builtins.bool] = None):
        """
        Specifies the security settings like secure boot and vTPM used while creating
        the virtual machine. Minimum api-version: 2020-12-01.
        :param builtins.bool secure_boot_enabled: Specifies whether secure boot should be enabled on the virtual machine. Minimum
               api-version: 2020-12-01.
        :param builtins.bool v_tpm_enabled: Specifies whether vTPM should be enabled on the virtual machine. Minimum
               api-version: 2020-12-01.
        """
        if secure_boot_enabled is not None:
            pulumi.set(__self__, "secure_boot_enabled", secure_boot_enabled)
        if v_tpm_enabled is not None:
            pulumi.set(__self__, "v_tpm_enabled", v_tpm_enabled)

    @property
    @pulumi.getter(name="secureBootEnabled")
    def secure_boot_enabled(self) -> Optional[builtins.bool]:
        """
        Specifies whether secure boot should be enabled on the virtual machine. Minimum
        api-version: 2020-12-01.
        """
        return pulumi.get(self, "secure_boot_enabled")

    @property
    @pulumi.getter(name="vTpmEnabled")
    def v_tpm_enabled(self) -> Optional[builtins.bool]:
        """
        Specifies whether vTPM should be enabled on the virtual machine. Minimum
        api-version: 2020-12-01.
        """
        return pulumi.get(self, "v_tpm_enabled")


@pulumi.output_type
class UserAssignedIdentityResponse(dict):
    """
    User assigned identity properties
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "clientId":
            suggest = "client_id"
        elif key == "principalId":
            suggest = "principal_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in UserAssignedIdentityResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        UserAssignedIdentityResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        UserAssignedIdentityResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 client_id: builtins.str,
                 principal_id: builtins.str):
        """
        User assigned identity properties
        :param builtins.str client_id: The client ID of the assigned identity.
        :param builtins.str principal_id: The principal ID of the assigned identity.
        """
        pulumi.set(__self__, "client_id", client_id)
        pulumi.set(__self__, "principal_id", principal_id)

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> builtins.str:
        """
        The client ID of the assigned identity.
        """
        return pulumi.get(self, "client_id")

    @property
    @pulumi.getter(name="principalId")
    def principal_id(self) -> builtins.str:
        """
        The principal ID of the assigned identity.
        """
        return pulumi.get(self, "principal_id")


@pulumi.output_type
class VMAttributeMinMaxDoubleResponse(dict):
    """
    VMAttributes using double values.
    """
    def __init__(__self__, *,
                 max: Optional[builtins.float] = None,
                 min: Optional[builtins.float] = None):
        """
        VMAttributes using double values.
        :param builtins.float max: Maximum value. Double.MaxValue(1.7976931348623157E+308)
        :param builtins.float min: Minimum value. default 0. Double.MinValue()
        """
        if max is not None:
            pulumi.set(__self__, "max", max)
        if min is not None:
            pulumi.set(__self__, "min", min)

    @property
    @pulumi.getter
    def max(self) -> Optional[builtins.float]:
        """
        Maximum value. Double.MaxValue(1.7976931348623157E+308)
        """
        return pulumi.get(self, "max")

    @property
    @pulumi.getter
    def min(self) -> Optional[builtins.float]:
        """
        Minimum value. default 0. Double.MinValue()
        """
        return pulumi.get(self, "min")


@pulumi.output_type
class VMAttributeMinMaxIntegerResponse(dict):
    """
    While retrieving VMSizes from CRS, Min = 0 (uint.MinValue) if not specified, Max = 4294967295 (uint.MaxValue) if not specified. This allows to filter VMAttributes on all available VMSizes.
    """
    def __init__(__self__, *,
                 max: Optional[builtins.int] = None,
                 min: Optional[builtins.int] = None):
        """
        While retrieving VMSizes from CRS, Min = 0 (uint.MinValue) if not specified, Max = 4294967295 (uint.MaxValue) if not specified. This allows to filter VMAttributes on all available VMSizes.
        :param builtins.int max: Max VMSize from CRS, Max = 4294967295 (uint.MaxValue) if not specified.
        :param builtins.int min: Min VMSize from CRS, Min = 0 (uint.MinValue) if not specified.
        """
        if max is not None:
            pulumi.set(__self__, "max", max)
        if min is not None:
            pulumi.set(__self__, "min", min)

    @property
    @pulumi.getter
    def max(self) -> Optional[builtins.int]:
        """
        Max VMSize from CRS, Max = 4294967295 (uint.MaxValue) if not specified.
        """
        return pulumi.get(self, "max")

    @property
    @pulumi.getter
    def min(self) -> Optional[builtins.int]:
        """
        Min VMSize from CRS, Min = 0 (uint.MinValue) if not specified.
        """
        return pulumi.get(self, "min")


@pulumi.output_type
class VMAttributesResponse(dict):
    """
    VMAttributes that will be used to filter VMSizes which will be used to build Fleet.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "memoryInGiB":
            suggest = "memory_in_gi_b"
        elif key == "vCpuCount":
            suggest = "v_cpu_count"
        elif key == "acceleratorCount":
            suggest = "accelerator_count"
        elif key == "acceleratorManufacturers":
            suggest = "accelerator_manufacturers"
        elif key == "acceleratorSupport":
            suggest = "accelerator_support"
        elif key == "acceleratorTypes":
            suggest = "accelerator_types"
        elif key == "architectureTypes":
            suggest = "architecture_types"
        elif key == "burstableSupport":
            suggest = "burstable_support"
        elif key == "cpuManufacturers":
            suggest = "cpu_manufacturers"
        elif key == "dataDiskCount":
            suggest = "data_disk_count"
        elif key == "excludedVMSizes":
            suggest = "excluded_vm_sizes"
        elif key == "localStorageDiskTypes":
            suggest = "local_storage_disk_types"
        elif key == "localStorageInGiB":
            suggest = "local_storage_in_gi_b"
        elif key == "localStorageSupport":
            suggest = "local_storage_support"
        elif key == "memoryInGiBPerVCpu":
            suggest = "memory_in_gi_b_per_v_cpu"
        elif key == "networkBandwidthInMbps":
            suggest = "network_bandwidth_in_mbps"
        elif key == "networkInterfaceCount":
            suggest = "network_interface_count"
        elif key == "rdmaNetworkInterfaceCount":
            suggest = "rdma_network_interface_count"
        elif key == "rdmaSupport":
            suggest = "rdma_support"
        elif key == "vmCategories":
            suggest = "vm_categories"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VMAttributesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VMAttributesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VMAttributesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 memory_in_gi_b: 'outputs.VMAttributeMinMaxDoubleResponse',
                 v_cpu_count: 'outputs.VMAttributeMinMaxIntegerResponse',
                 accelerator_count: Optional['outputs.VMAttributeMinMaxIntegerResponse'] = None,
                 accelerator_manufacturers: Optional[Sequence[builtins.str]] = None,
                 accelerator_support: Optional[builtins.str] = None,
                 accelerator_types: Optional[Sequence[builtins.str]] = None,
                 architecture_types: Optional[Sequence[builtins.str]] = None,
                 burstable_support: Optional[builtins.str] = None,
                 cpu_manufacturers: Optional[Sequence[builtins.str]] = None,
                 data_disk_count: Optional['outputs.VMAttributeMinMaxIntegerResponse'] = None,
                 excluded_vm_sizes: Optional[Sequence[builtins.str]] = None,
                 local_storage_disk_types: Optional[Sequence[builtins.str]] = None,
                 local_storage_in_gi_b: Optional['outputs.VMAttributeMinMaxDoubleResponse'] = None,
                 local_storage_support: Optional[builtins.str] = None,
                 memory_in_gi_b_per_v_cpu: Optional['outputs.VMAttributeMinMaxDoubleResponse'] = None,
                 network_bandwidth_in_mbps: Optional['outputs.VMAttributeMinMaxDoubleResponse'] = None,
                 network_interface_count: Optional['outputs.VMAttributeMinMaxIntegerResponse'] = None,
                 rdma_network_interface_count: Optional['outputs.VMAttributeMinMaxIntegerResponse'] = None,
                 rdma_support: Optional[builtins.str] = None,
                 vm_categories: Optional[Sequence[builtins.str]] = None):
        """
        VMAttributes that will be used to filter VMSizes which will be used to build Fleet.
        :param 'VMAttributeMinMaxDoubleResponse' memory_in_gi_b: The range of memory specified from Min to Max. Must be specified if VMAttributes are specified, either Min or Max is required if specified.
        :param 'VMAttributeMinMaxIntegerResponse' v_cpu_count: The range of vCpuCount specified from Min to Max. Must be specified if VMAttributes are specified, either Min or Max is required if specified.
        :param 'VMAttributeMinMaxIntegerResponse' accelerator_count: The range of accelerator count specified from min to max. Optional parameter. Either Min or Max is required if specified.
               acceleratorSupport should be set to "Included" or "Required" to use this VMAttribute. 
               If acceleratorSupport is "Excluded", this VMAttribute can not be used.
        :param Sequence[builtins.str] accelerator_manufacturers: The accelerator manufacturers specified as a list. 
               acceleratorSupport should be set to "Included" or "Required" to use this VMAttribute. 
               If acceleratorSupport is "Excluded", this VMAttribute can not be used.
        :param builtins.str accelerator_support: Specifies whether the VMSize supporting accelerator should be used to build Fleet or not.
               acceleratorSupport should be set to "Included" or "Required" to use this VMAttribute. 
               If acceleratorSupport is "Excluded", this VMAttribute can not be used.
        :param Sequence[builtins.str] accelerator_types: The accelerator types specified as a list. acceleratorSupport should be set to "Included" or "Required" to use this VMAttribute. 
               If acceleratorSupport is "Excluded", this VMAttribute can not be used.
        :param Sequence[builtins.str] architecture_types: The VM architecture types specified as a list. Optional parameter.
        :param builtins.str burstable_support: Specifies whether the VMSize supporting burstable capability should be used to build Fleet or not.
        :param Sequence[builtins.str] cpu_manufacturers: The VM CPU manufacturers specified as a list. Optional parameter.
        :param 'VMAttributeMinMaxIntegerResponse' data_disk_count: The range of data disk count specified from Min to Max. Optional parameter. Either Min or Max is required if specified.
        :param Sequence[builtins.str] excluded_vm_sizes: Specifies which VMSizes should be excluded while building Fleet. Optional parameter.
        :param Sequence[builtins.str] local_storage_disk_types: The local storage disk types specified as a list. LocalStorageSupport should be set to "Included" or "Required" to use this VMAttribute. 
               If localStorageSupport is "Excluded", this VMAttribute can not be used.
        :param 'VMAttributeMinMaxDoubleResponse' local_storage_in_gi_b: LocalStorageSupport should be set to "Included" or "Required" to use this VMAttribute. 
               If localStorageSupport is "Excluded", this VMAttribute can not be used.
        :param builtins.str local_storage_support: Specifies whether the VMSize supporting local storage should be used to build Fleet or not.
               Included - Default if not specified as most Azure VMs support local storage.
        :param 'VMAttributeMinMaxDoubleResponse' memory_in_gi_b_per_v_cpu: The range of memory in GiB per vCPU specified from min to max. Optional parameter. Either Min or Max is required if specified.
        :param 'VMAttributeMinMaxDoubleResponse' network_bandwidth_in_mbps: The range of network bandwidth in Mbps specified from Min to Max. Optional parameter. Either Min or Max is required if specified.
        :param 'VMAttributeMinMaxIntegerResponse' network_interface_count: The range of network interface count specified from Min to Max. Optional parameter. Either Min or Max is required if specified.
        :param 'VMAttributeMinMaxIntegerResponse' rdma_network_interface_count: The range of RDMA (Remote Direct Memory Access) network interface count specified from Min to Max. Optional parameter. Either Min or Max is required if specified.
               rdmaSupport should be set to "Included" or "Required" to use this VMAttribute. 
               If rdmaSupport is "Excluded", this VMAttribute can not be used.
        :param builtins.str rdma_support: Specifies whether the VMSize supporting RDMA (Remote Direct Memory Access) should be used to build Fleet or not.
        :param Sequence[builtins.str] vm_categories: The VM category specified as a list. Optional parameter.
        """
        pulumi.set(__self__, "memory_in_gi_b", memory_in_gi_b)
        pulumi.set(__self__, "v_cpu_count", v_cpu_count)
        if accelerator_count is not None:
            pulumi.set(__self__, "accelerator_count", accelerator_count)
        if accelerator_manufacturers is not None:
            pulumi.set(__self__, "accelerator_manufacturers", accelerator_manufacturers)
        if accelerator_support is not None:
            pulumi.set(__self__, "accelerator_support", accelerator_support)
        if accelerator_types is not None:
            pulumi.set(__self__, "accelerator_types", accelerator_types)
        if architecture_types is not None:
            pulumi.set(__self__, "architecture_types", architecture_types)
        if burstable_support is not None:
            pulumi.set(__self__, "burstable_support", burstable_support)
        if cpu_manufacturers is not None:
            pulumi.set(__self__, "cpu_manufacturers", cpu_manufacturers)
        if data_disk_count is not None:
            pulumi.set(__self__, "data_disk_count", data_disk_count)
        if excluded_vm_sizes is not None:
            pulumi.set(__self__, "excluded_vm_sizes", excluded_vm_sizes)
        if local_storage_disk_types is not None:
            pulumi.set(__self__, "local_storage_disk_types", local_storage_disk_types)
        if local_storage_in_gi_b is not None:
            pulumi.set(__self__, "local_storage_in_gi_b", local_storage_in_gi_b)
        if local_storage_support is not None:
            pulumi.set(__self__, "local_storage_support", local_storage_support)
        if memory_in_gi_b_per_v_cpu is not None:
            pulumi.set(__self__, "memory_in_gi_b_per_v_cpu", memory_in_gi_b_per_v_cpu)
        if network_bandwidth_in_mbps is not None:
            pulumi.set(__self__, "network_bandwidth_in_mbps", network_bandwidth_in_mbps)
        if network_interface_count is not None:
            pulumi.set(__self__, "network_interface_count", network_interface_count)
        if rdma_network_interface_count is not None:
            pulumi.set(__self__, "rdma_network_interface_count", rdma_network_interface_count)
        if rdma_support is not None:
            pulumi.set(__self__, "rdma_support", rdma_support)
        if vm_categories is not None:
            pulumi.set(__self__, "vm_categories", vm_categories)

    @property
    @pulumi.getter(name="memoryInGiB")
    def memory_in_gi_b(self) -> 'outputs.VMAttributeMinMaxDoubleResponse':
        """
        The range of memory specified from Min to Max. Must be specified if VMAttributes are specified, either Min or Max is required if specified.
        """
        return pulumi.get(self, "memory_in_gi_b")

    @property
    @pulumi.getter(name="vCpuCount")
    def v_cpu_count(self) -> 'outputs.VMAttributeMinMaxIntegerResponse':
        """
        The range of vCpuCount specified from Min to Max. Must be specified if VMAttributes are specified, either Min or Max is required if specified.
        """
        return pulumi.get(self, "v_cpu_count")

    @property
    @pulumi.getter(name="acceleratorCount")
    def accelerator_count(self) -> Optional['outputs.VMAttributeMinMaxIntegerResponse']:
        """
        The range of accelerator count specified from min to max. Optional parameter. Either Min or Max is required if specified.
        acceleratorSupport should be set to "Included" or "Required" to use this VMAttribute. 
        If acceleratorSupport is "Excluded", this VMAttribute can not be used.
        """
        return pulumi.get(self, "accelerator_count")

    @property
    @pulumi.getter(name="acceleratorManufacturers")
    def accelerator_manufacturers(self) -> Optional[Sequence[builtins.str]]:
        """
        The accelerator manufacturers specified as a list. 
        acceleratorSupport should be set to "Included" or "Required" to use this VMAttribute. 
        If acceleratorSupport is "Excluded", this VMAttribute can not be used.
        """
        return pulumi.get(self, "accelerator_manufacturers")

    @property
    @pulumi.getter(name="acceleratorSupport")
    def accelerator_support(self) -> Optional[builtins.str]:
        """
        Specifies whether the VMSize supporting accelerator should be used to build Fleet or not.
        acceleratorSupport should be set to "Included" or "Required" to use this VMAttribute. 
        If acceleratorSupport is "Excluded", this VMAttribute can not be used.
        """
        return pulumi.get(self, "accelerator_support")

    @property
    @pulumi.getter(name="acceleratorTypes")
    def accelerator_types(self) -> Optional[Sequence[builtins.str]]:
        """
        The accelerator types specified as a list. acceleratorSupport should be set to "Included" or "Required" to use this VMAttribute. 
        If acceleratorSupport is "Excluded", this VMAttribute can not be used.
        """
        return pulumi.get(self, "accelerator_types")

    @property
    @pulumi.getter(name="architectureTypes")
    def architecture_types(self) -> Optional[Sequence[builtins.str]]:
        """
        The VM architecture types specified as a list. Optional parameter.
        """
        return pulumi.get(self, "architecture_types")

    @property
    @pulumi.getter(name="burstableSupport")
    def burstable_support(self) -> Optional[builtins.str]:
        """
        Specifies whether the VMSize supporting burstable capability should be used to build Fleet or not.
        """
        return pulumi.get(self, "burstable_support")

    @property
    @pulumi.getter(name="cpuManufacturers")
    def cpu_manufacturers(self) -> Optional[Sequence[builtins.str]]:
        """
        The VM CPU manufacturers specified as a list. Optional parameter.
        """
        return pulumi.get(self, "cpu_manufacturers")

    @property
    @pulumi.getter(name="dataDiskCount")
    def data_disk_count(self) -> Optional['outputs.VMAttributeMinMaxIntegerResponse']:
        """
        The range of data disk count specified from Min to Max. Optional parameter. Either Min or Max is required if specified.
        """
        return pulumi.get(self, "data_disk_count")

    @property
    @pulumi.getter(name="excludedVMSizes")
    def excluded_vm_sizes(self) -> Optional[Sequence[builtins.str]]:
        """
        Specifies which VMSizes should be excluded while building Fleet. Optional parameter.
        """
        return pulumi.get(self, "excluded_vm_sizes")

    @property
    @pulumi.getter(name="localStorageDiskTypes")
    def local_storage_disk_types(self) -> Optional[Sequence[builtins.str]]:
        """
        The local storage disk types specified as a list. LocalStorageSupport should be set to "Included" or "Required" to use this VMAttribute. 
        If localStorageSupport is "Excluded", this VMAttribute can not be used.
        """
        return pulumi.get(self, "local_storage_disk_types")

    @property
    @pulumi.getter(name="localStorageInGiB")
    def local_storage_in_gi_b(self) -> Optional['outputs.VMAttributeMinMaxDoubleResponse']:
        """
        LocalStorageSupport should be set to "Included" or "Required" to use this VMAttribute. 
        If localStorageSupport is "Excluded", this VMAttribute can not be used.
        """
        return pulumi.get(self, "local_storage_in_gi_b")

    @property
    @pulumi.getter(name="localStorageSupport")
    def local_storage_support(self) -> Optional[builtins.str]:
        """
        Specifies whether the VMSize supporting local storage should be used to build Fleet or not.
        Included - Default if not specified as most Azure VMs support local storage.
        """
        return pulumi.get(self, "local_storage_support")

    @property
    @pulumi.getter(name="memoryInGiBPerVCpu")
    def memory_in_gi_b_per_v_cpu(self) -> Optional['outputs.VMAttributeMinMaxDoubleResponse']:
        """
        The range of memory in GiB per vCPU specified from min to max. Optional parameter. Either Min or Max is required if specified.
        """
        return pulumi.get(self, "memory_in_gi_b_per_v_cpu")

    @property
    @pulumi.getter(name="networkBandwidthInMbps")
    def network_bandwidth_in_mbps(self) -> Optional['outputs.VMAttributeMinMaxDoubleResponse']:
        """
        The range of network bandwidth in Mbps specified from Min to Max. Optional parameter. Either Min or Max is required if specified.
        """
        return pulumi.get(self, "network_bandwidth_in_mbps")

    @property
    @pulumi.getter(name="networkInterfaceCount")
    def network_interface_count(self) -> Optional['outputs.VMAttributeMinMaxIntegerResponse']:
        """
        The range of network interface count specified from Min to Max. Optional parameter. Either Min or Max is required if specified.
        """
        return pulumi.get(self, "network_interface_count")

    @property
    @pulumi.getter(name="rdmaNetworkInterfaceCount")
    def rdma_network_interface_count(self) -> Optional['outputs.VMAttributeMinMaxIntegerResponse']:
        """
        The range of RDMA (Remote Direct Memory Access) network interface count specified from Min to Max. Optional parameter. Either Min or Max is required if specified.
        rdmaSupport should be set to "Included" or "Required" to use this VMAttribute. 
        If rdmaSupport is "Excluded", this VMAttribute can not be used.
        """
        return pulumi.get(self, "rdma_network_interface_count")

    @property
    @pulumi.getter(name="rdmaSupport")
    def rdma_support(self) -> Optional[builtins.str]:
        """
        Specifies whether the VMSize supporting RDMA (Remote Direct Memory Access) should be used to build Fleet or not.
        """
        return pulumi.get(self, "rdma_support")

    @property
    @pulumi.getter(name="vmCategories")
    def vm_categories(self) -> Optional[Sequence[builtins.str]]:
        """
        The VM category specified as a list. Optional parameter.
        """
        return pulumi.get(self, "vm_categories")


@pulumi.output_type
class VMDiskSecurityProfileResponse(dict):
    """
    Specifies the security profile settings for the managed disk. **Note:** It can
    only be set for Confidential VMs.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "diskEncryptionSet":
            suggest = "disk_encryption_set"
        elif key == "securityEncryptionType":
            suggest = "security_encryption_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VMDiskSecurityProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VMDiskSecurityProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VMDiskSecurityProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 disk_encryption_set: Optional['outputs.DiskEncryptionSetParametersResponse'] = None,
                 security_encryption_type: Optional[builtins.str] = None):
        """
        Specifies the security profile settings for the managed disk. **Note:** It can
        only be set for Confidential VMs.
        :param 'DiskEncryptionSetParametersResponse' disk_encryption_set: Specifies the customer managed disk encryption set resource id for the managed
               disk that is used for Customer Managed Key encrypted ConfidentialVM OS Disk and
               VMGuest blob.
        :param builtins.str security_encryption_type: Specifies the EncryptionType of the managed disk. It is set to
               DiskWithVMGuestState for encryption of the managed disk along with VMGuestState
               blob, VMGuestStateOnly for encryption of just the VMGuestState blob, and
               NonPersistedTPM for not persisting firmware state in the VMGuestState blob..
               **Note:** It can be set for only Confidential VMs.
        """
        if disk_encryption_set is not None:
            pulumi.set(__self__, "disk_encryption_set", disk_encryption_set)
        if security_encryption_type is not None:
            pulumi.set(__self__, "security_encryption_type", security_encryption_type)

    @property
    @pulumi.getter(name="diskEncryptionSet")
    def disk_encryption_set(self) -> Optional['outputs.DiskEncryptionSetParametersResponse']:
        """
        Specifies the customer managed disk encryption set resource id for the managed
        disk that is used for Customer Managed Key encrypted ConfidentialVM OS Disk and
        VMGuest blob.
        """
        return pulumi.get(self, "disk_encryption_set")

    @property
    @pulumi.getter(name="securityEncryptionType")
    def security_encryption_type(self) -> Optional[builtins.str]:
        """
        Specifies the EncryptionType of the managed disk. It is set to
        DiskWithVMGuestState for encryption of the managed disk along with VMGuestState
        blob, VMGuestStateOnly for encryption of just the VMGuestState blob, and
        NonPersistedTPM for not persisting firmware state in the VMGuestState blob..
        **Note:** It can be set for only Confidential VMs.
        """
        return pulumi.get(self, "security_encryption_type")


@pulumi.output_type
class VMGalleryApplicationResponse(dict):
    """
    Specifies the required information to reference a compute gallery application
    version
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "packageReferenceId":
            suggest = "package_reference_id"
        elif key == "configurationReference":
            suggest = "configuration_reference"
        elif key == "enableAutomaticUpgrade":
            suggest = "enable_automatic_upgrade"
        elif key == "treatFailureAsDeploymentFailure":
            suggest = "treat_failure_as_deployment_failure"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VMGalleryApplicationResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VMGalleryApplicationResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VMGalleryApplicationResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 package_reference_id: builtins.str,
                 configuration_reference: Optional[builtins.str] = None,
                 enable_automatic_upgrade: Optional[builtins.bool] = None,
                 order: Optional[builtins.int] = None,
                 tags: Optional[builtins.str] = None,
                 treat_failure_as_deployment_failure: Optional[builtins.bool] = None):
        """
        Specifies the required information to reference a compute gallery application
        version
        :param builtins.str package_reference_id: Specifies the GalleryApplicationVersion resource id on the form of
               /subscriptions/{SubscriptionId}/resourceGroups/{ResourceGroupName}/providers/Microsoft.Compute/galleries/{galleryName}/applications/{application}/versions/{version}
        :param builtins.str configuration_reference: Optional, Specifies the uri to an azure blob that will replace the default
               configuration for the package if provided
        :param builtins.bool enable_automatic_upgrade: If set to true, when a new Gallery Application version is available in PIR/SIG,
               it will be automatically updated for the VM/VMSS
        :param builtins.int order: Optional, Specifies the order in which the packages have to be installed
        :param builtins.str tags: Optional, Specifies a passthrough value for more generic context.
        :param builtins.bool treat_failure_as_deployment_failure: Optional, If true, any failure for any operation in the VmApplication will fail
               the deployment
        """
        pulumi.set(__self__, "package_reference_id", package_reference_id)
        if configuration_reference is not None:
            pulumi.set(__self__, "configuration_reference", configuration_reference)
        if enable_automatic_upgrade is not None:
            pulumi.set(__self__, "enable_automatic_upgrade", enable_automatic_upgrade)
        if order is not None:
            pulumi.set(__self__, "order", order)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if treat_failure_as_deployment_failure is not None:
            pulumi.set(__self__, "treat_failure_as_deployment_failure", treat_failure_as_deployment_failure)

    @property
    @pulumi.getter(name="packageReferenceId")
    def package_reference_id(self) -> builtins.str:
        """
        Specifies the GalleryApplicationVersion resource id on the form of
        /subscriptions/{SubscriptionId}/resourceGroups/{ResourceGroupName}/providers/Microsoft.Compute/galleries/{galleryName}/applications/{application}/versions/{version}
        """
        return pulumi.get(self, "package_reference_id")

    @property
    @pulumi.getter(name="configurationReference")
    def configuration_reference(self) -> Optional[builtins.str]:
        """
        Optional, Specifies the uri to an azure blob that will replace the default
        configuration for the package if provided
        """
        return pulumi.get(self, "configuration_reference")

    @property
    @pulumi.getter(name="enableAutomaticUpgrade")
    def enable_automatic_upgrade(self) -> Optional[builtins.bool]:
        """
        If set to true, when a new Gallery Application version is available in PIR/SIG,
        it will be automatically updated for the VM/VMSS
        """
        return pulumi.get(self, "enable_automatic_upgrade")

    @property
    @pulumi.getter
    def order(self) -> Optional[builtins.int]:
        """
        Optional, Specifies the order in which the packages have to be installed
        """
        return pulumi.get(self, "order")

    @property
    @pulumi.getter
    def tags(self) -> Optional[builtins.str]:
        """
        Optional, Specifies a passthrough value for more generic context.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="treatFailureAsDeploymentFailure")
    def treat_failure_as_deployment_failure(self) -> Optional[builtins.bool]:
        """
        Optional, If true, any failure for any operation in the VmApplication will fail
        the deployment
        """
        return pulumi.get(self, "treat_failure_as_deployment_failure")


@pulumi.output_type
class VMSizePropertiesResponse(dict):
    """
    Specifies VM Size Property settings on the virtual machine.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "vCPUsAvailable":
            suggest = "v_cpus_available"
        elif key == "vCPUsPerCore":
            suggest = "v_cpus_per_core"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VMSizePropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VMSizePropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VMSizePropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 v_cpus_available: Optional[builtins.int] = None,
                 v_cpus_per_core: Optional[builtins.int] = None):
        """
        Specifies VM Size Property settings on the virtual machine.
        :param builtins.int v_cpus_available: Specifies the number of vCPUs available for the VM. When this property is not
               specified in the request body the default behavior is to set it to the value of
               vCPUs available for that VM size exposed in api response of [List all available
               virtual machine sizes in a
               region](https://learn.microsoft.com/en-us/rest/api/compute/resource-skus/list).
        :param builtins.int v_cpus_per_core: Specifies the vCPU to physical core ratio. When this property is not specified
               in the request body the default behavior is set to the value of vCPUsPerCore
               for the VM Size exposed in api response of [List all available virtual machine
               sizes in a
               region](https://learn.microsoft.com/en-us/rest/api/compute/resource-skus/list).
               **Setting this property to 1 also means that hyper-threading is disabled.**
        """
        if v_cpus_available is not None:
            pulumi.set(__self__, "v_cpus_available", v_cpus_available)
        if v_cpus_per_core is not None:
            pulumi.set(__self__, "v_cpus_per_core", v_cpus_per_core)

    @property
    @pulumi.getter(name="vCPUsAvailable")
    def v_cpus_available(self) -> Optional[builtins.int]:
        """
        Specifies the number of vCPUs available for the VM. When this property is not
        specified in the request body the default behavior is to set it to the value of
        vCPUs available for that VM size exposed in api response of [List all available
        virtual machine sizes in a
        region](https://learn.microsoft.com/en-us/rest/api/compute/resource-skus/list).
        """
        return pulumi.get(self, "v_cpus_available")

    @property
    @pulumi.getter(name="vCPUsPerCore")
    def v_cpus_per_core(self) -> Optional[builtins.int]:
        """
        Specifies the vCPU to physical core ratio. When this property is not specified
        in the request body the default behavior is set to the value of vCPUsPerCore
        for the VM Size exposed in api response of [List all available virtual machine
        sizes in a
        region](https://learn.microsoft.com/en-us/rest/api/compute/resource-skus/list).
        **Setting this property to 1 also means that hyper-threading is disabled.**
        """
        return pulumi.get(self, "v_cpus_per_core")


@pulumi.output_type
class VaultCertificateResponse(dict):
    """
    Describes a single certificate reference in a Key Vault, and where the
    certificate should reside on the VM.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "certificateStore":
            suggest = "certificate_store"
        elif key == "certificateUrl":
            suggest = "certificate_url"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VaultCertificateResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VaultCertificateResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VaultCertificateResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 certificate_store: Optional[builtins.str] = None,
                 certificate_url: Optional[builtins.str] = None):
        """
        Describes a single certificate reference in a Key Vault, and where the
        certificate should reside on the VM.
        :param builtins.str certificate_store: For Windows VMs, specifies the certificate store on the Virtual Machine to
               which the certificate should be added. The specified certificate store is
               implicitly in the LocalMachine account. For Linux VMs, the certificate file is
               placed under the /var/lib/waagent directory, with the file name
               &lt;UppercaseThumbprint&gt;.crt for the X509 certificate file and
               &lt;UppercaseThumbprint&gt;.prv for private key. Both of these files are .pem
               formatted.
        :param builtins.str certificate_url: This is the URL of a certificate that has been uploaded to Key Vault as a
               secret. For adding a secret to the Key Vault, see [Add a key or secret to the
               key
               vault](https://learn.microsoft.com/azure/key-vault/key-vault-get-started/#add).
               In this case, your certificate needs to be It is the Base64 encoding of the
               following JSON Object which is encoded in UTF-8: <br><br> {<br>
               "data":"<Base64-encoded-certificate>",<br>  "dataType":"pfx",<br>
               "password":"<pfx-file-password>"<br>} <br> To install certificates on a virtual
               machine it is recommended to use the [Azure Key Vault virtual machine extension
               for
               Linux](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-linux)
               or the [Azure Key Vault virtual machine extension for
               Windows](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-windows).
        """
        if certificate_store is not None:
            pulumi.set(__self__, "certificate_store", certificate_store)
        if certificate_url is not None:
            pulumi.set(__self__, "certificate_url", certificate_url)

    @property
    @pulumi.getter(name="certificateStore")
    def certificate_store(self) -> Optional[builtins.str]:
        """
        For Windows VMs, specifies the certificate store on the Virtual Machine to
        which the certificate should be added. The specified certificate store is
        implicitly in the LocalMachine account. For Linux VMs, the certificate file is
        placed under the /var/lib/waagent directory, with the file name
        &lt;UppercaseThumbprint&gt;.crt for the X509 certificate file and
        &lt;UppercaseThumbprint&gt;.prv for private key. Both of these files are .pem
        formatted.
        """
        return pulumi.get(self, "certificate_store")

    @property
    @pulumi.getter(name="certificateUrl")
    def certificate_url(self) -> Optional[builtins.str]:
        """
        This is the URL of a certificate that has been uploaded to Key Vault as a
        secret. For adding a secret to the Key Vault, see [Add a key or secret to the
        key
        vault](https://learn.microsoft.com/azure/key-vault/key-vault-get-started/#add).
        In this case, your certificate needs to be It is the Base64 encoding of the
        following JSON Object which is encoded in UTF-8: <br><br> {<br>
        "data":"<Base64-encoded-certificate>",<br>  "dataType":"pfx",<br>
        "password":"<pfx-file-password>"<br>} <br> To install certificates on a virtual
        machine it is recommended to use the [Azure Key Vault virtual machine extension
        for
        Linux](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-linux)
        or the [Azure Key Vault virtual machine extension for
        Windows](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-windows).
        """
        return pulumi.get(self, "certificate_url")


@pulumi.output_type
class VaultSecretGroupResponse(dict):
    """
    Describes a set of certificates which are all in the same Key Vault.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "sourceVault":
            suggest = "source_vault"
        elif key == "vaultCertificates":
            suggest = "vault_certificates"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VaultSecretGroupResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VaultSecretGroupResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VaultSecretGroupResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 source_vault: Optional['outputs.SubResourceResponse'] = None,
                 vault_certificates: Optional[Sequence['outputs.VaultCertificateResponse']] = None):
        """
        Describes a set of certificates which are all in the same Key Vault.
        :param 'SubResourceResponse' source_vault: The relative URL of the Key Vault containing all of the certificates in
               VaultCertificates.
        :param Sequence['VaultCertificateResponse'] vault_certificates: The list of key vault references in SourceVault which contain certificates.
        """
        if source_vault is not None:
            pulumi.set(__self__, "source_vault", source_vault)
        if vault_certificates is not None:
            pulumi.set(__self__, "vault_certificates", vault_certificates)

    @property
    @pulumi.getter(name="sourceVault")
    def source_vault(self) -> Optional['outputs.SubResourceResponse']:
        """
        The relative URL of the Key Vault containing all of the certificates in
        VaultCertificates.
        """
        return pulumi.get(self, "source_vault")

    @property
    @pulumi.getter(name="vaultCertificates")
    def vault_certificates(self) -> Optional[Sequence['outputs.VaultCertificateResponse']]:
        """
        The list of key vault references in SourceVault which contain certificates.
        """
        return pulumi.get(self, "vault_certificates")


@pulumi.output_type
class VirtualHardDiskResponse(dict):
    """
    Describes the uri of a disk.
    """
    def __init__(__self__, *,
                 uri: Optional[builtins.str] = None):
        """
        Describes the uri of a disk.
        :param builtins.str uri: Specifies the virtual hard disk's uri.
        """
        if uri is not None:
            pulumi.set(__self__, "uri", uri)

    @property
    @pulumi.getter
    def uri(self) -> Optional[builtins.str]:
        """
        Specifies the virtual hard disk's uri.
        """
        return pulumi.get(self, "uri")


@pulumi.output_type
class VirtualMachineScaleSetDataDiskResponse(dict):
    """
    Describes a virtual machine scale set data disk.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createOption":
            suggest = "create_option"
        elif key == "deleteOption":
            suggest = "delete_option"
        elif key == "diskIOPSReadWrite":
            suggest = "disk_iops_read_write"
        elif key == "diskMBpsReadWrite":
            suggest = "disk_m_bps_read_write"
        elif key == "diskSizeGB":
            suggest = "disk_size_gb"
        elif key == "managedDisk":
            suggest = "managed_disk"
        elif key == "writeAcceleratorEnabled":
            suggest = "write_accelerator_enabled"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetDataDiskResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetDataDiskResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetDataDiskResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 create_option: builtins.str,
                 lun: builtins.int,
                 caching: Optional[builtins.str] = None,
                 delete_option: Optional[builtins.str] = None,
                 disk_iops_read_write: Optional[builtins.float] = None,
                 disk_m_bps_read_write: Optional[builtins.float] = None,
                 disk_size_gb: Optional[builtins.int] = None,
                 managed_disk: Optional['outputs.VirtualMachineScaleSetManagedDiskParametersResponse'] = None,
                 name: Optional[builtins.str] = None,
                 write_accelerator_enabled: Optional[builtins.bool] = None):
        """
        Describes a virtual machine scale set data disk.
        :param builtins.str create_option: The create option.
        :param builtins.int lun: Specifies the logical unit number of the data disk. This value is used to
               identify data disks within the VM and therefore must be unique for each data
               disk attached to a VM.
        :param builtins.str caching: Specifies the caching requirements. Possible values are: **None,**
               **ReadOnly,** **ReadWrite.** The default values are: **None for Standard
               storage. ReadOnly for Premium storage.**
        :param builtins.str delete_option: Specifies whether data disk should be deleted or detached upon VMSS Flex
               deletion (This feature is available for VMSS with Flexible OrchestrationMode
               only).<br><br> Possible values: <br><br> **Delete** If this value is used, the
               data disk is deleted when the VMSS Flex VM is deleted.<br><br> **Detach** If
               this value is used, the data disk is retained after VMSS Flex VM is
               deleted.<br><br> The default value is set to **Delete**.
        :param builtins.float disk_iops_read_write: Specifies the Read-Write IOPS for the managed disk. Should be used only when
               StorageAccountType is UltraSSD_LRS. If not specified, a default value would be
               assigned based on diskSizeGB.
        :param builtins.float disk_m_bps_read_write: Specifies the bandwidth in MB per second for the managed disk. Should be used
               only when StorageAccountType is UltraSSD_LRS. If not specified, a default value
               would be assigned based on diskSizeGB.
        :param builtins.int disk_size_gb: Specifies the size of an empty data disk in gigabytes. This element can be used
               to overwrite the size of the disk in a virtual machine image. The property
               diskSizeGB is the number of bytes x 1024^3 for the disk and the value cannot be
               larger than 1023.
        :param 'VirtualMachineScaleSetManagedDiskParametersResponse' managed_disk: The managed disk parameters.
        :param builtins.str name: The disk name.
        :param builtins.bool write_accelerator_enabled: Specifies whether writeAccelerator should be enabled or disabled on the disk.
        """
        pulumi.set(__self__, "create_option", create_option)
        pulumi.set(__self__, "lun", lun)
        if caching is not None:
            pulumi.set(__self__, "caching", caching)
        if delete_option is not None:
            pulumi.set(__self__, "delete_option", delete_option)
        if disk_iops_read_write is not None:
            pulumi.set(__self__, "disk_iops_read_write", disk_iops_read_write)
        if disk_m_bps_read_write is not None:
            pulumi.set(__self__, "disk_m_bps_read_write", disk_m_bps_read_write)
        if disk_size_gb is not None:
            pulumi.set(__self__, "disk_size_gb", disk_size_gb)
        if managed_disk is not None:
            pulumi.set(__self__, "managed_disk", managed_disk)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if write_accelerator_enabled is not None:
            pulumi.set(__self__, "write_accelerator_enabled", write_accelerator_enabled)

    @property
    @pulumi.getter(name="createOption")
    def create_option(self) -> builtins.str:
        """
        The create option.
        """
        return pulumi.get(self, "create_option")

    @property
    @pulumi.getter
    def lun(self) -> builtins.int:
        """
        Specifies the logical unit number of the data disk. This value is used to
        identify data disks within the VM and therefore must be unique for each data
        disk attached to a VM.
        """
        return pulumi.get(self, "lun")

    @property
    @pulumi.getter
    def caching(self) -> Optional[builtins.str]:
        """
        Specifies the caching requirements. Possible values are: **None,**
        **ReadOnly,** **ReadWrite.** The default values are: **None for Standard
        storage. ReadOnly for Premium storage.**
        """
        return pulumi.get(self, "caching")

    @property
    @pulumi.getter(name="deleteOption")
    def delete_option(self) -> Optional[builtins.str]:
        """
        Specifies whether data disk should be deleted or detached upon VMSS Flex
        deletion (This feature is available for VMSS with Flexible OrchestrationMode
        only).<br><br> Possible values: <br><br> **Delete** If this value is used, the
        data disk is deleted when the VMSS Flex VM is deleted.<br><br> **Detach** If
        this value is used, the data disk is retained after VMSS Flex VM is
        deleted.<br><br> The default value is set to **Delete**.
        """
        return pulumi.get(self, "delete_option")

    @property
    @pulumi.getter(name="diskIOPSReadWrite")
    def disk_iops_read_write(self) -> Optional[builtins.float]:
        """
        Specifies the Read-Write IOPS for the managed disk. Should be used only when
        StorageAccountType is UltraSSD_LRS. If not specified, a default value would be
        assigned based on diskSizeGB.
        """
        return pulumi.get(self, "disk_iops_read_write")

    @property
    @pulumi.getter(name="diskMBpsReadWrite")
    def disk_m_bps_read_write(self) -> Optional[builtins.float]:
        """
        Specifies the bandwidth in MB per second for the managed disk. Should be used
        only when StorageAccountType is UltraSSD_LRS. If not specified, a default value
        would be assigned based on diskSizeGB.
        """
        return pulumi.get(self, "disk_m_bps_read_write")

    @property
    @pulumi.getter(name="diskSizeGB")
    def disk_size_gb(self) -> Optional[builtins.int]:
        """
        Specifies the size of an empty data disk in gigabytes. This element can be used
        to overwrite the size of the disk in a virtual machine image. The property
        diskSizeGB is the number of bytes x 1024^3 for the disk and the value cannot be
        larger than 1023.
        """
        return pulumi.get(self, "disk_size_gb")

    @property
    @pulumi.getter(name="managedDisk")
    def managed_disk(self) -> Optional['outputs.VirtualMachineScaleSetManagedDiskParametersResponse']:
        """
        The managed disk parameters.
        """
        return pulumi.get(self, "managed_disk")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        The disk name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="writeAcceleratorEnabled")
    def write_accelerator_enabled(self) -> Optional[builtins.bool]:
        """
        Specifies whether writeAccelerator should be enabled or disabled on the disk.
        """
        return pulumi.get(self, "write_accelerator_enabled")


@pulumi.output_type
class VirtualMachineScaleSetExtensionProfileResponse(dict):
    """
    Describes a virtual machine scale set extension profile.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "extensionsTimeBudget":
            suggest = "extensions_time_budget"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetExtensionProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetExtensionProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetExtensionProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 extensions: Optional[Sequence['outputs.VirtualMachineScaleSetExtensionResponse']] = None,
                 extensions_time_budget: Optional[builtins.str] = None):
        """
        Describes a virtual machine scale set extension profile.
        :param Sequence['VirtualMachineScaleSetExtensionResponse'] extensions: The virtual machine scale set child extension resources.
        :param builtins.str extensions_time_budget: Specifies the time alloted for all extensions to start. The time duration
               should be between 15 minutes and 120 minutes (inclusive) and should be
               specified in ISO 8601 format. The default value is 90 minutes (PT1H30M).
               Minimum api-version: 2020-06-01.
        """
        if extensions is not None:
            pulumi.set(__self__, "extensions", extensions)
        if extensions_time_budget is not None:
            pulumi.set(__self__, "extensions_time_budget", extensions_time_budget)

    @property
    @pulumi.getter
    def extensions(self) -> Optional[Sequence['outputs.VirtualMachineScaleSetExtensionResponse']]:
        """
        The virtual machine scale set child extension resources.
        """
        return pulumi.get(self, "extensions")

    @property
    @pulumi.getter(name="extensionsTimeBudget")
    def extensions_time_budget(self) -> Optional[builtins.str]:
        """
        Specifies the time alloted for all extensions to start. The time duration
        should be between 15 minutes and 120 minutes (inclusive) and should be
        specified in ISO 8601 format. The default value is 90 minutes (PT1H30M).
        Minimum api-version: 2020-06-01.
        """
        return pulumi.get(self, "extensions_time_budget")


@pulumi.output_type
class VirtualMachineScaleSetExtensionPropertiesResponse(dict):
    """
    Describes the properties of a Virtual Machine Scale Set Extension.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "provisioningState":
            suggest = "provisioning_state"
        elif key == "autoUpgradeMinorVersion":
            suggest = "auto_upgrade_minor_version"
        elif key == "enableAutomaticUpgrade":
            suggest = "enable_automatic_upgrade"
        elif key == "forceUpdateTag":
            suggest = "force_update_tag"
        elif key == "protectedSettingsFromKeyVault":
            suggest = "protected_settings_from_key_vault"
        elif key == "provisionAfterExtensions":
            suggest = "provision_after_extensions"
        elif key == "suppressFailures":
            suggest = "suppress_failures"
        elif key == "typeHandlerVersion":
            suggest = "type_handler_version"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetExtensionPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetExtensionPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetExtensionPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 provisioning_state: builtins.str,
                 auto_upgrade_minor_version: Optional[builtins.bool] = None,
                 enable_automatic_upgrade: Optional[builtins.bool] = None,
                 force_update_tag: Optional[builtins.str] = None,
                 protected_settings_from_key_vault: Optional['outputs.KeyVaultSecretReferenceResponse'] = None,
                 provision_after_extensions: Optional[Sequence[builtins.str]] = None,
                 publisher: Optional[builtins.str] = None,
                 settings: Optional[Any] = None,
                 suppress_failures: Optional[builtins.bool] = None,
                 type: Optional[builtins.str] = None,
                 type_handler_version: Optional[builtins.str] = None):
        """
        Describes the properties of a Virtual Machine Scale Set Extension.
        :param builtins.str provisioning_state: The provisioning state, which only appears in the response.
        :param builtins.bool auto_upgrade_minor_version: Indicates whether the extension should use a newer minor version if one is
               available at deployment time. Once deployed, however, the extension will not
               upgrade minor versions unless redeployed, even with this property set to true.
        :param builtins.bool enable_automatic_upgrade: Indicates whether the extension should be automatically upgraded by the
               platform if there is a newer version of the extension available.
        :param builtins.str force_update_tag: If a value is provided and is different from the previous value, the extension
               handler will be forced to update even if the extension configuration has not
               changed.
        :param 'KeyVaultSecretReferenceResponse' protected_settings_from_key_vault: The extensions protected settings that are passed by reference, and consumed
               from key vault
        :param Sequence[builtins.str] provision_after_extensions: Collection of extension names after which this extension needs to be
               provisioned.
        :param builtins.str publisher: The name of the extension handler publisher.
        :param Any settings: Json formatted public settings for the extension.
        :param builtins.bool suppress_failures: Indicates whether failures stemming from the extension will be suppressed
               (Operational failures such as not connecting to the VM will not be suppressed
               regardless of this value). The default is false.
        :param builtins.str type: Specifies the type of the extension; an example is "CustomScriptExtension".
        :param builtins.str type_handler_version: Specifies the version of the script handler.
        """
        pulumi.set(__self__, "provisioning_state", provisioning_state)
        if auto_upgrade_minor_version is not None:
            pulumi.set(__self__, "auto_upgrade_minor_version", auto_upgrade_minor_version)
        if enable_automatic_upgrade is not None:
            pulumi.set(__self__, "enable_automatic_upgrade", enable_automatic_upgrade)
        if force_update_tag is not None:
            pulumi.set(__self__, "force_update_tag", force_update_tag)
        if protected_settings_from_key_vault is not None:
            pulumi.set(__self__, "protected_settings_from_key_vault", protected_settings_from_key_vault)
        if provision_after_extensions is not None:
            pulumi.set(__self__, "provision_after_extensions", provision_after_extensions)
        if publisher is not None:
            pulumi.set(__self__, "publisher", publisher)
        if settings is not None:
            pulumi.set(__self__, "settings", settings)
        if suppress_failures is not None:
            pulumi.set(__self__, "suppress_failures", suppress_failures)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if type_handler_version is not None:
            pulumi.set(__self__, "type_handler_version", type_handler_version)

    @property
    @pulumi.getter(name="provisioningState")
    def provisioning_state(self) -> builtins.str:
        """
        The provisioning state, which only appears in the response.
        """
        return pulumi.get(self, "provisioning_state")

    @property
    @pulumi.getter(name="autoUpgradeMinorVersion")
    def auto_upgrade_minor_version(self) -> Optional[builtins.bool]:
        """
        Indicates whether the extension should use a newer minor version if one is
        available at deployment time. Once deployed, however, the extension will not
        upgrade minor versions unless redeployed, even with this property set to true.
        """
        return pulumi.get(self, "auto_upgrade_minor_version")

    @property
    @pulumi.getter(name="enableAutomaticUpgrade")
    def enable_automatic_upgrade(self) -> Optional[builtins.bool]:
        """
        Indicates whether the extension should be automatically upgraded by the
        platform if there is a newer version of the extension available.
        """
        return pulumi.get(self, "enable_automatic_upgrade")

    @property
    @pulumi.getter(name="forceUpdateTag")
    def force_update_tag(self) -> Optional[builtins.str]:
        """
        If a value is provided and is different from the previous value, the extension
        handler will be forced to update even if the extension configuration has not
        changed.
        """
        return pulumi.get(self, "force_update_tag")

    @property
    @pulumi.getter(name="protectedSettingsFromKeyVault")
    def protected_settings_from_key_vault(self) -> Optional['outputs.KeyVaultSecretReferenceResponse']:
        """
        The extensions protected settings that are passed by reference, and consumed
        from key vault
        """
        return pulumi.get(self, "protected_settings_from_key_vault")

    @property
    @pulumi.getter(name="provisionAfterExtensions")
    def provision_after_extensions(self) -> Optional[Sequence[builtins.str]]:
        """
        Collection of extension names after which this extension needs to be
        provisioned.
        """
        return pulumi.get(self, "provision_after_extensions")

    @property
    @pulumi.getter
    def publisher(self) -> Optional[builtins.str]:
        """
        The name of the extension handler publisher.
        """
        return pulumi.get(self, "publisher")

    @property
    @pulumi.getter
    def settings(self) -> Optional[Any]:
        """
        Json formatted public settings for the extension.
        """
        return pulumi.get(self, "settings")

    @property
    @pulumi.getter(name="suppressFailures")
    def suppress_failures(self) -> Optional[builtins.bool]:
        """
        Indicates whether failures stemming from the extension will be suppressed
        (Operational failures such as not connecting to the VM will not be suppressed
        regardless of this value). The default is false.
        """
        return pulumi.get(self, "suppress_failures")

    @property
    @pulumi.getter
    def type(self) -> Optional[builtins.str]:
        """
        Specifies the type of the extension; an example is "CustomScriptExtension".
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="typeHandlerVersion")
    def type_handler_version(self) -> Optional[builtins.str]:
        """
        Specifies the version of the script handler.
        """
        return pulumi.get(self, "type_handler_version")


@pulumi.output_type
class VirtualMachineScaleSetExtensionResponse(dict):
    """
    Describes a Virtual Machine Scale Set Extension.
    """
    def __init__(__self__, *,
                 id: builtins.str,
                 type: builtins.str,
                 name: Optional[builtins.str] = None,
                 properties: Optional['outputs.VirtualMachineScaleSetExtensionPropertiesResponse'] = None):
        """
        Describes a Virtual Machine Scale Set Extension.
        :param builtins.str id: Resource Id
        :param builtins.str type: Resource type
        :param builtins.str name: The name of the extension.
        :param 'VirtualMachineScaleSetExtensionPropertiesResponse' properties: Describes the properties of a Virtual Machine Scale Set Extension.
        """
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "type", type)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Resource Id
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Resource type
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        The name of the extension.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> Optional['outputs.VirtualMachineScaleSetExtensionPropertiesResponse']:
        """
        Describes the properties of a Virtual Machine Scale Set Extension.
        """
        return pulumi.get(self, "properties")


@pulumi.output_type
class VirtualMachineScaleSetHardwareProfileResponse(dict):
    """
    Specifies the hardware settings for the virtual machine scale set.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "vmSizeProperties":
            suggest = "vm_size_properties"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetHardwareProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetHardwareProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetHardwareProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 vm_size_properties: Optional['outputs.VMSizePropertiesResponse'] = None):
        """
        Specifies the hardware settings for the virtual machine scale set.
        :param 'VMSizePropertiesResponse' vm_size_properties: Specifies the properties for customizing the size of the virtual machine.
               Minimum api-version: 2021-11-01. Please follow the instructions in [VM
               Customization](https://aka.ms/vmcustomization) for more details.
        """
        if vm_size_properties is not None:
            pulumi.set(__self__, "vm_size_properties", vm_size_properties)

    @property
    @pulumi.getter(name="vmSizeProperties")
    def vm_size_properties(self) -> Optional['outputs.VMSizePropertiesResponse']:
        """
        Specifies the properties for customizing the size of the virtual machine.
        Minimum api-version: 2021-11-01. Please follow the instructions in [VM
        Customization](https://aka.ms/vmcustomization) for more details.
        """
        return pulumi.get(self, "vm_size_properties")


@pulumi.output_type
class VirtualMachineScaleSetIPConfigurationPropertiesResponse(dict):
    """
    Describes a virtual machine scale set network profile's IP configuration
    properties.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "applicationGatewayBackendAddressPools":
            suggest = "application_gateway_backend_address_pools"
        elif key == "applicationSecurityGroups":
            suggest = "application_security_groups"
        elif key == "loadBalancerBackendAddressPools":
            suggest = "load_balancer_backend_address_pools"
        elif key == "loadBalancerInboundNatPools":
            suggest = "load_balancer_inbound_nat_pools"
        elif key == "privateIPAddressVersion":
            suggest = "private_ip_address_version"
        elif key == "publicIPAddressConfiguration":
            suggest = "public_ip_address_configuration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetIPConfigurationPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetIPConfigurationPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetIPConfigurationPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 application_gateway_backend_address_pools: Optional[Sequence['outputs.SubResourceResponse']] = None,
                 application_security_groups: Optional[Sequence['outputs.SubResourceResponse']] = None,
                 load_balancer_backend_address_pools: Optional[Sequence['outputs.SubResourceResponse']] = None,
                 load_balancer_inbound_nat_pools: Optional[Sequence['outputs.SubResourceResponse']] = None,
                 primary: Optional[builtins.bool] = None,
                 private_ip_address_version: Optional[builtins.str] = None,
                 public_ip_address_configuration: Optional['outputs.VirtualMachineScaleSetPublicIPAddressConfigurationResponse'] = None,
                 subnet: Optional['outputs.ApiEntityReferenceResponse'] = None):
        """
        Describes a virtual machine scale set network profile's IP configuration
        properties.
        :param Sequence['SubResourceResponse'] application_gateway_backend_address_pools: Specifies an array of references to backend address pools of application
               gateways. A scale set can reference backend address pools of multiple
               application gateways. Multiple scale sets cannot use the same application
               gateway.
        :param Sequence['SubResourceResponse'] application_security_groups: Specifies an array of references to application security group.
        :param Sequence['SubResourceResponse'] load_balancer_backend_address_pools: Specifies an array of references to backend address pools of load balancers. A
               scale set can reference backend address pools of one public and one internal
               load balancer. Multiple scale sets cannot use the same basic sku load balancer.
        :param Sequence['SubResourceResponse'] load_balancer_inbound_nat_pools: Specifies an array of references to inbound Nat pools of the load balancers. A
               scale set can reference inbound nat pools of one public and one internal load
               balancer. Multiple scale sets cannot use the same basic sku load balancer.
        :param builtins.bool primary: Specifies the primary network interface in case the virtual machine has more
               than 1 network interface.
        :param builtins.str private_ip_address_version: Available from Api-Version 2017-03-30 onwards, it represents whether the
               specific ipconfiguration is IPv4 or IPv6. Default is taken as IPv4.  Possible
               values are: 'IPv4' and 'IPv6'.
        :param 'VirtualMachineScaleSetPublicIPAddressConfigurationResponse' public_ip_address_configuration: The publicIPAddressConfiguration.
        :param 'ApiEntityReferenceResponse' subnet: Specifies the identifier of the subnet.
        """
        if application_gateway_backend_address_pools is not None:
            pulumi.set(__self__, "application_gateway_backend_address_pools", application_gateway_backend_address_pools)
        if application_security_groups is not None:
            pulumi.set(__self__, "application_security_groups", application_security_groups)
        if load_balancer_backend_address_pools is not None:
            pulumi.set(__self__, "load_balancer_backend_address_pools", load_balancer_backend_address_pools)
        if load_balancer_inbound_nat_pools is not None:
            pulumi.set(__self__, "load_balancer_inbound_nat_pools", load_balancer_inbound_nat_pools)
        if primary is not None:
            pulumi.set(__self__, "primary", primary)
        if private_ip_address_version is not None:
            pulumi.set(__self__, "private_ip_address_version", private_ip_address_version)
        if public_ip_address_configuration is not None:
            pulumi.set(__self__, "public_ip_address_configuration", public_ip_address_configuration)
        if subnet is not None:
            pulumi.set(__self__, "subnet", subnet)

    @property
    @pulumi.getter(name="applicationGatewayBackendAddressPools")
    def application_gateway_backend_address_pools(self) -> Optional[Sequence['outputs.SubResourceResponse']]:
        """
        Specifies an array of references to backend address pools of application
        gateways. A scale set can reference backend address pools of multiple
        application gateways. Multiple scale sets cannot use the same application
        gateway.
        """
        return pulumi.get(self, "application_gateway_backend_address_pools")

    @property
    @pulumi.getter(name="applicationSecurityGroups")
    def application_security_groups(self) -> Optional[Sequence['outputs.SubResourceResponse']]:
        """
        Specifies an array of references to application security group.
        """
        return pulumi.get(self, "application_security_groups")

    @property
    @pulumi.getter(name="loadBalancerBackendAddressPools")
    def load_balancer_backend_address_pools(self) -> Optional[Sequence['outputs.SubResourceResponse']]:
        """
        Specifies an array of references to backend address pools of load balancers. A
        scale set can reference backend address pools of one public and one internal
        load balancer. Multiple scale sets cannot use the same basic sku load balancer.
        """
        return pulumi.get(self, "load_balancer_backend_address_pools")

    @property
    @pulumi.getter(name="loadBalancerInboundNatPools")
    def load_balancer_inbound_nat_pools(self) -> Optional[Sequence['outputs.SubResourceResponse']]:
        """
        Specifies an array of references to inbound Nat pools of the load balancers. A
        scale set can reference inbound nat pools of one public and one internal load
        balancer. Multiple scale sets cannot use the same basic sku load balancer.
        """
        return pulumi.get(self, "load_balancer_inbound_nat_pools")

    @property
    @pulumi.getter
    def primary(self) -> Optional[builtins.bool]:
        """
        Specifies the primary network interface in case the virtual machine has more
        than 1 network interface.
        """
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter(name="privateIPAddressVersion")
    def private_ip_address_version(self) -> Optional[builtins.str]:
        """
        Available from Api-Version 2017-03-30 onwards, it represents whether the
        specific ipconfiguration is IPv4 or IPv6. Default is taken as IPv4.  Possible
        values are: 'IPv4' and 'IPv6'.
        """
        return pulumi.get(self, "private_ip_address_version")

    @property
    @pulumi.getter(name="publicIPAddressConfiguration")
    def public_ip_address_configuration(self) -> Optional['outputs.VirtualMachineScaleSetPublicIPAddressConfigurationResponse']:
        """
        The publicIPAddressConfiguration.
        """
        return pulumi.get(self, "public_ip_address_configuration")

    @property
    @pulumi.getter
    def subnet(self) -> Optional['outputs.ApiEntityReferenceResponse']:
        """
        Specifies the identifier of the subnet.
        """
        return pulumi.get(self, "subnet")


@pulumi.output_type
class VirtualMachineScaleSetIPConfigurationResponse(dict):
    """
    Describes a virtual machine scale set network profile's IP configuration.
    """
    def __init__(__self__, *,
                 name: builtins.str,
                 properties: Optional['outputs.VirtualMachineScaleSetIPConfigurationPropertiesResponse'] = None):
        """
        Describes a virtual machine scale set network profile's IP configuration.
        :param builtins.str name: The IP configuration name.
        :param 'VirtualMachineScaleSetIPConfigurationPropertiesResponse' properties: Describes a virtual machine scale set network profile's IP configuration
               properties.
        """
        pulumi.set(__self__, "name", name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The IP configuration name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> Optional['outputs.VirtualMachineScaleSetIPConfigurationPropertiesResponse']:
        """
        Describes a virtual machine scale set network profile's IP configuration
        properties.
        """
        return pulumi.get(self, "properties")


@pulumi.output_type
class VirtualMachineScaleSetIpTagResponse(dict):
    """
    Contains the IP tag associated with the public IP address.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipTagType":
            suggest = "ip_tag_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetIpTagResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetIpTagResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetIpTagResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip_tag_type: Optional[builtins.str] = None,
                 tag: Optional[builtins.str] = None):
        """
        Contains the IP tag associated with the public IP address.
        :param builtins.str ip_tag_type: IP tag type. Example: FirstPartyUsage.
        :param builtins.str tag: IP tag associated with the public IP. Example: SQL, Storage etc.
        """
        if ip_tag_type is not None:
            pulumi.set(__self__, "ip_tag_type", ip_tag_type)
        if tag is not None:
            pulumi.set(__self__, "tag", tag)

    @property
    @pulumi.getter(name="ipTagType")
    def ip_tag_type(self) -> Optional[builtins.str]:
        """
        IP tag type. Example: FirstPartyUsage.
        """
        return pulumi.get(self, "ip_tag_type")

    @property
    @pulumi.getter
    def tag(self) -> Optional[builtins.str]:
        """
        IP tag associated with the public IP. Example: SQL, Storage etc.
        """
        return pulumi.get(self, "tag")


@pulumi.output_type
class VirtualMachineScaleSetManagedDiskParametersResponse(dict):
    """
    Describes the parameters of a ScaleSet managed disk.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "diskEncryptionSet":
            suggest = "disk_encryption_set"
        elif key == "securityProfile":
            suggest = "security_profile"
        elif key == "storageAccountType":
            suggest = "storage_account_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetManagedDiskParametersResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetManagedDiskParametersResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetManagedDiskParametersResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 disk_encryption_set: Optional['outputs.DiskEncryptionSetParametersResponse'] = None,
                 security_profile: Optional['outputs.VMDiskSecurityProfileResponse'] = None,
                 storage_account_type: Optional[builtins.str] = None):
        """
        Describes the parameters of a ScaleSet managed disk.
        :param 'DiskEncryptionSetParametersResponse' disk_encryption_set: Specifies the customer managed disk encryption set resource id for the managed
               disk.
        :param 'VMDiskSecurityProfileResponse' security_profile: Specifies the security profile for the managed disk.
        :param builtins.str storage_account_type: Specifies the storage account type for the managed disk. NOTE: UltraSSD_LRS can
               only be used with data disks, it cannot be used with OS Disk.
        """
        if disk_encryption_set is not None:
            pulumi.set(__self__, "disk_encryption_set", disk_encryption_set)
        if security_profile is not None:
            pulumi.set(__self__, "security_profile", security_profile)
        if storage_account_type is not None:
            pulumi.set(__self__, "storage_account_type", storage_account_type)

    @property
    @pulumi.getter(name="diskEncryptionSet")
    def disk_encryption_set(self) -> Optional['outputs.DiskEncryptionSetParametersResponse']:
        """
        Specifies the customer managed disk encryption set resource id for the managed
        disk.
        """
        return pulumi.get(self, "disk_encryption_set")

    @property
    @pulumi.getter(name="securityProfile")
    def security_profile(self) -> Optional['outputs.VMDiskSecurityProfileResponse']:
        """
        Specifies the security profile for the managed disk.
        """
        return pulumi.get(self, "security_profile")

    @property
    @pulumi.getter(name="storageAccountType")
    def storage_account_type(self) -> Optional[builtins.str]:
        """
        Specifies the storage account type for the managed disk. NOTE: UltraSSD_LRS can
        only be used with data disks, it cannot be used with OS Disk.
        """
        return pulumi.get(self, "storage_account_type")


@pulumi.output_type
class VirtualMachineScaleSetNetworkConfigurationDnsSettingsResponse(dict):
    """
    Describes a virtual machines scale sets network configuration's DNS settings.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dnsServers":
            suggest = "dns_servers"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetNetworkConfigurationDnsSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetNetworkConfigurationDnsSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetNetworkConfigurationDnsSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dns_servers: Optional[Sequence[builtins.str]] = None):
        """
        Describes a virtual machines scale sets network configuration's DNS settings.
        :param Sequence[builtins.str] dns_servers: List of DNS servers IP addresses
        """
        if dns_servers is not None:
            pulumi.set(__self__, "dns_servers", dns_servers)

    @property
    @pulumi.getter(name="dnsServers")
    def dns_servers(self) -> Optional[Sequence[builtins.str]]:
        """
        List of DNS servers IP addresses
        """
        return pulumi.get(self, "dns_servers")


@pulumi.output_type
class VirtualMachineScaleSetNetworkConfigurationPropertiesResponse(dict):
    """
    Describes a virtual machine scale set network profile's IP configuration.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ipConfigurations":
            suggest = "ip_configurations"
        elif key == "auxiliaryMode":
            suggest = "auxiliary_mode"
        elif key == "auxiliarySku":
            suggest = "auxiliary_sku"
        elif key == "deleteOption":
            suggest = "delete_option"
        elif key == "disableTcpStateTracking":
            suggest = "disable_tcp_state_tracking"
        elif key == "dnsSettings":
            suggest = "dns_settings"
        elif key == "enableAcceleratedNetworking":
            suggest = "enable_accelerated_networking"
        elif key == "enableFpga":
            suggest = "enable_fpga"
        elif key == "enableIPForwarding":
            suggest = "enable_ip_forwarding"
        elif key == "networkSecurityGroup":
            suggest = "network_security_group"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetNetworkConfigurationPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetNetworkConfigurationPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetNetworkConfigurationPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ip_configurations: Sequence['outputs.VirtualMachineScaleSetIPConfigurationResponse'],
                 auxiliary_mode: Optional[builtins.str] = None,
                 auxiliary_sku: Optional[builtins.str] = None,
                 delete_option: Optional[builtins.str] = None,
                 disable_tcp_state_tracking: Optional[builtins.bool] = None,
                 dns_settings: Optional['outputs.VirtualMachineScaleSetNetworkConfigurationDnsSettingsResponse'] = None,
                 enable_accelerated_networking: Optional[builtins.bool] = None,
                 enable_fpga: Optional[builtins.bool] = None,
                 enable_ip_forwarding: Optional[builtins.bool] = None,
                 network_security_group: Optional['outputs.SubResourceResponse'] = None,
                 primary: Optional[builtins.bool] = None):
        """
        Describes a virtual machine scale set network profile's IP configuration.
        :param Sequence['VirtualMachineScaleSetIPConfigurationResponse'] ip_configurations: Specifies the IP configurations of the network interface.
        :param builtins.str auxiliary_mode: Specifies whether the Auxiliary mode is enabled for the Network Interface
               resource.
        :param builtins.str auxiliary_sku: Specifies whether the Auxiliary sku is enabled for the Network Interface
               resource.
        :param builtins.str delete_option: Specify what happens to the network interface when the VM is deleted
        :param builtins.bool disable_tcp_state_tracking: Specifies whether the network interface is disabled for tcp state tracking.
        :param 'VirtualMachineScaleSetNetworkConfigurationDnsSettingsResponse' dns_settings: The dns settings to be applied on the network interfaces.
        :param builtins.bool enable_accelerated_networking: Specifies whether the network interface is accelerated networking-enabled.
        :param builtins.bool enable_fpga: Specifies whether the network interface is FPGA networking-enabled.
        :param builtins.bool enable_ip_forwarding: Whether IP forwarding enabled on this NIC.
        :param 'SubResourceResponse' network_security_group: The network security group.
        :param builtins.bool primary: Specifies the primary network interface in case the virtual machine has more
               than 1 network interface.
        """
        pulumi.set(__self__, "ip_configurations", ip_configurations)
        if auxiliary_mode is not None:
            pulumi.set(__self__, "auxiliary_mode", auxiliary_mode)
        if auxiliary_sku is not None:
            pulumi.set(__self__, "auxiliary_sku", auxiliary_sku)
        if delete_option is not None:
            pulumi.set(__self__, "delete_option", delete_option)
        if disable_tcp_state_tracking is not None:
            pulumi.set(__self__, "disable_tcp_state_tracking", disable_tcp_state_tracking)
        if dns_settings is not None:
            pulumi.set(__self__, "dns_settings", dns_settings)
        if enable_accelerated_networking is not None:
            pulumi.set(__self__, "enable_accelerated_networking", enable_accelerated_networking)
        if enable_fpga is not None:
            pulumi.set(__self__, "enable_fpga", enable_fpga)
        if enable_ip_forwarding is not None:
            pulumi.set(__self__, "enable_ip_forwarding", enable_ip_forwarding)
        if network_security_group is not None:
            pulumi.set(__self__, "network_security_group", network_security_group)
        if primary is not None:
            pulumi.set(__self__, "primary", primary)

    @property
    @pulumi.getter(name="ipConfigurations")
    def ip_configurations(self) -> Sequence['outputs.VirtualMachineScaleSetIPConfigurationResponse']:
        """
        Specifies the IP configurations of the network interface.
        """
        return pulumi.get(self, "ip_configurations")

    @property
    @pulumi.getter(name="auxiliaryMode")
    def auxiliary_mode(self) -> Optional[builtins.str]:
        """
        Specifies whether the Auxiliary mode is enabled for the Network Interface
        resource.
        """
        return pulumi.get(self, "auxiliary_mode")

    @property
    @pulumi.getter(name="auxiliarySku")
    def auxiliary_sku(self) -> Optional[builtins.str]:
        """
        Specifies whether the Auxiliary sku is enabled for the Network Interface
        resource.
        """
        return pulumi.get(self, "auxiliary_sku")

    @property
    @pulumi.getter(name="deleteOption")
    def delete_option(self) -> Optional[builtins.str]:
        """
        Specify what happens to the network interface when the VM is deleted
        """
        return pulumi.get(self, "delete_option")

    @property
    @pulumi.getter(name="disableTcpStateTracking")
    def disable_tcp_state_tracking(self) -> Optional[builtins.bool]:
        """
        Specifies whether the network interface is disabled for tcp state tracking.
        """
        return pulumi.get(self, "disable_tcp_state_tracking")

    @property
    @pulumi.getter(name="dnsSettings")
    def dns_settings(self) -> Optional['outputs.VirtualMachineScaleSetNetworkConfigurationDnsSettingsResponse']:
        """
        The dns settings to be applied on the network interfaces.
        """
        return pulumi.get(self, "dns_settings")

    @property
    @pulumi.getter(name="enableAcceleratedNetworking")
    def enable_accelerated_networking(self) -> Optional[builtins.bool]:
        """
        Specifies whether the network interface is accelerated networking-enabled.
        """
        return pulumi.get(self, "enable_accelerated_networking")

    @property
    @pulumi.getter(name="enableFpga")
    def enable_fpga(self) -> Optional[builtins.bool]:
        """
        Specifies whether the network interface is FPGA networking-enabled.
        """
        return pulumi.get(self, "enable_fpga")

    @property
    @pulumi.getter(name="enableIPForwarding")
    def enable_ip_forwarding(self) -> Optional[builtins.bool]:
        """
        Whether IP forwarding enabled on this NIC.
        """
        return pulumi.get(self, "enable_ip_forwarding")

    @property
    @pulumi.getter(name="networkSecurityGroup")
    def network_security_group(self) -> Optional['outputs.SubResourceResponse']:
        """
        The network security group.
        """
        return pulumi.get(self, "network_security_group")

    @property
    @pulumi.getter
    def primary(self) -> Optional[builtins.bool]:
        """
        Specifies the primary network interface in case the virtual machine has more
        than 1 network interface.
        """
        return pulumi.get(self, "primary")


@pulumi.output_type
class VirtualMachineScaleSetNetworkConfigurationResponse(dict):
    """
    Describes a virtual machine scale set network profile's network configurations.
    """
    def __init__(__self__, *,
                 name: builtins.str,
                 properties: Optional['outputs.VirtualMachineScaleSetNetworkConfigurationPropertiesResponse'] = None):
        """
        Describes a virtual machine scale set network profile's network configurations.
        :param builtins.str name: The network configuration name.
        :param 'VirtualMachineScaleSetNetworkConfigurationPropertiesResponse' properties: Describes a virtual machine scale set network profile's IP configuration.
        """
        pulumi.set(__self__, "name", name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The network configuration name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> Optional['outputs.VirtualMachineScaleSetNetworkConfigurationPropertiesResponse']:
        """
        Describes a virtual machine scale set network profile's IP configuration.
        """
        return pulumi.get(self, "properties")


@pulumi.output_type
class VirtualMachineScaleSetNetworkProfileResponse(dict):
    """
    Describes a virtual machine scale set network profile.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "healthProbe":
            suggest = "health_probe"
        elif key == "networkApiVersion":
            suggest = "network_api_version"
        elif key == "networkInterfaceConfigurations":
            suggest = "network_interface_configurations"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetNetworkProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetNetworkProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetNetworkProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 health_probe: Optional['outputs.ApiEntityReferenceResponse'] = None,
                 network_api_version: Optional[builtins.str] = None,
                 network_interface_configurations: Optional[Sequence['outputs.VirtualMachineScaleSetNetworkConfigurationResponse']] = None):
        """
        Describes a virtual machine scale set network profile.
        :param 'ApiEntityReferenceResponse' health_probe: A reference to a load balancer probe used to determine the health of an
               instance in the virtual machine scale set. The reference will be in the form:
               '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/probes/{probeName}'.
        :param builtins.str network_api_version: specifies the Microsoft.Network API version used when creating networking
               resources in the Network Interface Configurations for Virtual Machine Scale Set
               with orchestration mode 'Flexible'
        :param Sequence['VirtualMachineScaleSetNetworkConfigurationResponse'] network_interface_configurations: The list of network configurations.
        """
        if health_probe is not None:
            pulumi.set(__self__, "health_probe", health_probe)
        if network_api_version is not None:
            pulumi.set(__self__, "network_api_version", network_api_version)
        if network_interface_configurations is not None:
            pulumi.set(__self__, "network_interface_configurations", network_interface_configurations)

    @property
    @pulumi.getter(name="healthProbe")
    def health_probe(self) -> Optional['outputs.ApiEntityReferenceResponse']:
        """
        A reference to a load balancer probe used to determine the health of an
        instance in the virtual machine scale set. The reference will be in the form:
        '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/probes/{probeName}'.
        """
        return pulumi.get(self, "health_probe")

    @property
    @pulumi.getter(name="networkApiVersion")
    def network_api_version(self) -> Optional[builtins.str]:
        """
        specifies the Microsoft.Network API version used when creating networking
        resources in the Network Interface Configurations for Virtual Machine Scale Set
        with orchestration mode 'Flexible'
        """
        return pulumi.get(self, "network_api_version")

    @property
    @pulumi.getter(name="networkInterfaceConfigurations")
    def network_interface_configurations(self) -> Optional[Sequence['outputs.VirtualMachineScaleSetNetworkConfigurationResponse']]:
        """
        The list of network configurations.
        """
        return pulumi.get(self, "network_interface_configurations")


@pulumi.output_type
class VirtualMachineScaleSetOSDiskResponse(dict):
    """
    Describes a virtual machine scale set operating system disk.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "createOption":
            suggest = "create_option"
        elif key == "deleteOption":
            suggest = "delete_option"
        elif key == "diffDiskSettings":
            suggest = "diff_disk_settings"
        elif key == "diskSizeGB":
            suggest = "disk_size_gb"
        elif key == "managedDisk":
            suggest = "managed_disk"
        elif key == "osType":
            suggest = "os_type"
        elif key == "vhdContainers":
            suggest = "vhd_containers"
        elif key == "writeAcceleratorEnabled":
            suggest = "write_accelerator_enabled"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetOSDiskResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetOSDiskResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetOSDiskResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 create_option: builtins.str,
                 caching: Optional[builtins.str] = None,
                 delete_option: Optional[builtins.str] = None,
                 diff_disk_settings: Optional['outputs.DiffDiskSettingsResponse'] = None,
                 disk_size_gb: Optional[builtins.int] = None,
                 image: Optional['outputs.VirtualHardDiskResponse'] = None,
                 managed_disk: Optional['outputs.VirtualMachineScaleSetManagedDiskParametersResponse'] = None,
                 name: Optional[builtins.str] = None,
                 os_type: Optional[builtins.str] = None,
                 vhd_containers: Optional[Sequence[builtins.str]] = None,
                 write_accelerator_enabled: Optional[builtins.bool] = None):
        """
        Describes a virtual machine scale set operating system disk.
        :param builtins.str create_option: Specifies how the virtual machines in the scale set should be created. The only
               allowed value is: **FromImage.** This value is used when you are using an image
               to create the virtual machine. If you are using a platform image, you also use
               the imageReference element described above. If you are using a marketplace
               image, you  also use the plan element previously described.
        :param builtins.str caching: Specifies the caching requirements. Possible values are: **None,**
               **ReadOnly,** **ReadWrite.** The default values are: **None for Standard
               storage. ReadOnly for Premium storage.**
        :param builtins.str delete_option: Specifies whether OS Disk should be deleted or detached upon VMSS Flex deletion
               (This feature is available for VMSS with Flexible OrchestrationMode only).
               <br><br> Possible values: <br><br> **Delete** If this value is used, the OS
               disk is deleted when VMSS Flex VM is deleted.<br><br> **Detach** If this value
               is used, the OS disk is retained after VMSS Flex VM is deleted. <br><br> The
               default value is set to **Delete**. For an Ephemeral OS Disk, the default value
               is set to **Delete**. User cannot change the delete option for Ephemeral OS
               Disk.
        :param 'DiffDiskSettingsResponse' diff_disk_settings: Specifies the ephemeral disk Settings for the operating system disk used by the
               virtual machine scale set.
        :param builtins.int disk_size_gb: Specifies the size of an empty data disk in gigabytes. This element can be used
               to overwrite the size of the disk in a virtual machine image. The property 'diskSizeGB'
               is the number of bytes x 1024^3 for the disk and the value cannot
               be larger than 1023.
        :param 'VirtualHardDiskResponse' image: Specifies information about the unmanaged user image to base the scale set on.
        :param 'VirtualMachineScaleSetManagedDiskParametersResponse' managed_disk: The managed disk parameters.
        :param builtins.str name: The disk name.
        :param builtins.str os_type: This property allows you to specify the type of the OS that is included in the
               disk if creating a VM from user-image or a specialized VHD. Possible values
               are: **Windows,** **Linux.**
        :param Sequence[builtins.str] vhd_containers: Specifies the container urls that are used to store operating system disks for
               the scale set.
        :param builtins.bool write_accelerator_enabled: Specifies whether writeAccelerator should be enabled or disabled on the disk.
        """
        pulumi.set(__self__, "create_option", create_option)
        if caching is not None:
            pulumi.set(__self__, "caching", caching)
        if delete_option is not None:
            pulumi.set(__self__, "delete_option", delete_option)
        if diff_disk_settings is not None:
            pulumi.set(__self__, "diff_disk_settings", diff_disk_settings)
        if disk_size_gb is not None:
            pulumi.set(__self__, "disk_size_gb", disk_size_gb)
        if image is not None:
            pulumi.set(__self__, "image", image)
        if managed_disk is not None:
            pulumi.set(__self__, "managed_disk", managed_disk)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if os_type is not None:
            pulumi.set(__self__, "os_type", os_type)
        if vhd_containers is not None:
            pulumi.set(__self__, "vhd_containers", vhd_containers)
        if write_accelerator_enabled is not None:
            pulumi.set(__self__, "write_accelerator_enabled", write_accelerator_enabled)

    @property
    @pulumi.getter(name="createOption")
    def create_option(self) -> builtins.str:
        """
        Specifies how the virtual machines in the scale set should be created. The only
        allowed value is: **FromImage.** This value is used when you are using an image
        to create the virtual machine. If you are using a platform image, you also use
        the imageReference element described above. If you are using a marketplace
        image, you  also use the plan element previously described.
        """
        return pulumi.get(self, "create_option")

    @property
    @pulumi.getter
    def caching(self) -> Optional[builtins.str]:
        """
        Specifies the caching requirements. Possible values are: **None,**
        **ReadOnly,** **ReadWrite.** The default values are: **None for Standard
        storage. ReadOnly for Premium storage.**
        """
        return pulumi.get(self, "caching")

    @property
    @pulumi.getter(name="deleteOption")
    def delete_option(self) -> Optional[builtins.str]:
        """
        Specifies whether OS Disk should be deleted or detached upon VMSS Flex deletion
        (This feature is available for VMSS with Flexible OrchestrationMode only).
        <br><br> Possible values: <br><br> **Delete** If this value is used, the OS
        disk is deleted when VMSS Flex VM is deleted.<br><br> **Detach** If this value
        is used, the OS disk is retained after VMSS Flex VM is deleted. <br><br> The
        default value is set to **Delete**. For an Ephemeral OS Disk, the default value
        is set to **Delete**. User cannot change the delete option for Ephemeral OS
        Disk.
        """
        return pulumi.get(self, "delete_option")

    @property
    @pulumi.getter(name="diffDiskSettings")
    def diff_disk_settings(self) -> Optional['outputs.DiffDiskSettingsResponse']:
        """
        Specifies the ephemeral disk Settings for the operating system disk used by the
        virtual machine scale set.
        """
        return pulumi.get(self, "diff_disk_settings")

    @property
    @pulumi.getter(name="diskSizeGB")
    def disk_size_gb(self) -> Optional[builtins.int]:
        """
        Specifies the size of an empty data disk in gigabytes. This element can be used
        to overwrite the size of the disk in a virtual machine image. The property 'diskSizeGB'
        is the number of bytes x 1024^3 for the disk and the value cannot
        be larger than 1023.
        """
        return pulumi.get(self, "disk_size_gb")

    @property
    @pulumi.getter
    def image(self) -> Optional['outputs.VirtualHardDiskResponse']:
        """
        Specifies information about the unmanaged user image to base the scale set on.
        """
        return pulumi.get(self, "image")

    @property
    @pulumi.getter(name="managedDisk")
    def managed_disk(self) -> Optional['outputs.VirtualMachineScaleSetManagedDiskParametersResponse']:
        """
        The managed disk parameters.
        """
        return pulumi.get(self, "managed_disk")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        The disk name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="osType")
    def os_type(self) -> Optional[builtins.str]:
        """
        This property allows you to specify the type of the OS that is included in the
        disk if creating a VM from user-image or a specialized VHD. Possible values
        are: **Windows,** **Linux.**
        """
        return pulumi.get(self, "os_type")

    @property
    @pulumi.getter(name="vhdContainers")
    def vhd_containers(self) -> Optional[Sequence[builtins.str]]:
        """
        Specifies the container urls that are used to store operating system disks for
        the scale set.
        """
        return pulumi.get(self, "vhd_containers")

    @property
    @pulumi.getter(name="writeAcceleratorEnabled")
    def write_accelerator_enabled(self) -> Optional[builtins.bool]:
        """
        Specifies whether writeAccelerator should be enabled or disabled on the disk.
        """
        return pulumi.get(self, "write_accelerator_enabled")


@pulumi.output_type
class VirtualMachineScaleSetOSProfileResponse(dict):
    """
    Describes a virtual machine scale set OS profile.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "adminUsername":
            suggest = "admin_username"
        elif key == "allowExtensionOperations":
            suggest = "allow_extension_operations"
        elif key == "computerNamePrefix":
            suggest = "computer_name_prefix"
        elif key == "linuxConfiguration":
            suggest = "linux_configuration"
        elif key == "requireGuestProvisionSignal":
            suggest = "require_guest_provision_signal"
        elif key == "windowsConfiguration":
            suggest = "windows_configuration"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetOSProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetOSProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetOSProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 admin_username: Optional[builtins.str] = None,
                 allow_extension_operations: Optional[builtins.bool] = None,
                 computer_name_prefix: Optional[builtins.str] = None,
                 linux_configuration: Optional['outputs.LinuxConfigurationResponse'] = None,
                 require_guest_provision_signal: Optional[builtins.bool] = None,
                 secrets: Optional[Sequence['outputs.VaultSecretGroupResponse']] = None,
                 windows_configuration: Optional['outputs.WindowsConfigurationResponse'] = None):
        """
        Describes a virtual machine scale set OS profile.
        :param builtins.str admin_username: Specifies the name of the administrator account. <br><br> **Windows-only
               restriction:** Cannot end in "." <br><br> **Disallowed values:**
               "administrator", "admin", "user", "user1", "test", "user2", "test1", "user3",
               "admin1", "1", "123", "a", "actuser", "adm", "admin2", "aspnet", "backup",
               "console", "david", "guest", "john", "owner", "root", "server", "sql",
               "support", "support_388945a0", "sys", "test2", "test3", "user4", "user5".
               <br><br> **Minimum-length (Linux):** 1  character <br><br> **Max-length
               (Linux):** 64 characters <br><br> **Max-length (Windows):** 20 characters
        :param builtins.bool allow_extension_operations: Specifies whether extension operations should be allowed on the virtual machine
               scale set. This may only be set to False when no extensions are present on the
               virtual machine scale set.
        :param builtins.str computer_name_prefix: Specifies the computer name prefix for all of the virtual machines in the scale
               set. Computer name prefixes must be 1 to 15 characters long.
        :param 'LinuxConfigurationResponse' linux_configuration: Specifies the Linux operating system settings on the virtual machine. For a
               list of supported Linux distributions, see [Linux on Azure-Endorsed
               Distributions](https://learn.microsoft.com/azure/virtual-machines/linux/endorsed-distros).
        :param builtins.bool require_guest_provision_signal: Optional property which must either be set to True or omitted.
        :param Sequence['VaultSecretGroupResponse'] secrets: Specifies set of certificates that should be installed onto the virtual
               machines in the scale set. To install certificates on a virtual machine it is
               recommended to use the [Azure Key Vault virtual machine extension for
               Linux](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-linux)
               or the [Azure Key Vault virtual machine extension for
               Windows](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-windows).
        :param 'WindowsConfigurationResponse' windows_configuration: Specifies Windows operating system settings on the virtual machine.
        """
        if admin_username is not None:
            pulumi.set(__self__, "admin_username", admin_username)
        if allow_extension_operations is not None:
            pulumi.set(__self__, "allow_extension_operations", allow_extension_operations)
        if computer_name_prefix is not None:
            pulumi.set(__self__, "computer_name_prefix", computer_name_prefix)
        if linux_configuration is not None:
            pulumi.set(__self__, "linux_configuration", linux_configuration)
        if require_guest_provision_signal is not None:
            pulumi.set(__self__, "require_guest_provision_signal", require_guest_provision_signal)
        if secrets is not None:
            pulumi.set(__self__, "secrets", secrets)
        if windows_configuration is not None:
            pulumi.set(__self__, "windows_configuration", windows_configuration)

    @property
    @pulumi.getter(name="adminUsername")
    def admin_username(self) -> Optional[builtins.str]:
        """
        Specifies the name of the administrator account. <br><br> **Windows-only
        restriction:** Cannot end in "." <br><br> **Disallowed values:**
        "administrator", "admin", "user", "user1", "test", "user2", "test1", "user3",
        "admin1", "1", "123", "a", "actuser", "adm", "admin2", "aspnet", "backup",
        "console", "david", "guest", "john", "owner", "root", "server", "sql",
        "support", "support_388945a0", "sys", "test2", "test3", "user4", "user5".
        <br><br> **Minimum-length (Linux):** 1  character <br><br> **Max-length
        (Linux):** 64 characters <br><br> **Max-length (Windows):** 20 characters
        """
        return pulumi.get(self, "admin_username")

    @property
    @pulumi.getter(name="allowExtensionOperations")
    def allow_extension_operations(self) -> Optional[builtins.bool]:
        """
        Specifies whether extension operations should be allowed on the virtual machine
        scale set. This may only be set to False when no extensions are present on the
        virtual machine scale set.
        """
        return pulumi.get(self, "allow_extension_operations")

    @property
    @pulumi.getter(name="computerNamePrefix")
    def computer_name_prefix(self) -> Optional[builtins.str]:
        """
        Specifies the computer name prefix for all of the virtual machines in the scale
        set. Computer name prefixes must be 1 to 15 characters long.
        """
        return pulumi.get(self, "computer_name_prefix")

    @property
    @pulumi.getter(name="linuxConfiguration")
    def linux_configuration(self) -> Optional['outputs.LinuxConfigurationResponse']:
        """
        Specifies the Linux operating system settings on the virtual machine. For a
        list of supported Linux distributions, see [Linux on Azure-Endorsed
        Distributions](https://learn.microsoft.com/azure/virtual-machines/linux/endorsed-distros).
        """
        return pulumi.get(self, "linux_configuration")

    @property
    @pulumi.getter(name="requireGuestProvisionSignal")
    def require_guest_provision_signal(self) -> Optional[builtins.bool]:
        """
        Optional property which must either be set to True or omitted.
        """
        return pulumi.get(self, "require_guest_provision_signal")

    @property
    @pulumi.getter
    def secrets(self) -> Optional[Sequence['outputs.VaultSecretGroupResponse']]:
        """
        Specifies set of certificates that should be installed onto the virtual
        machines in the scale set. To install certificates on a virtual machine it is
        recommended to use the [Azure Key Vault virtual machine extension for
        Linux](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-linux)
        or the [Azure Key Vault virtual machine extension for
        Windows](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-windows).
        """
        return pulumi.get(self, "secrets")

    @property
    @pulumi.getter(name="windowsConfiguration")
    def windows_configuration(self) -> Optional['outputs.WindowsConfigurationResponse']:
        """
        Specifies Windows operating system settings on the virtual machine.
        """
        return pulumi.get(self, "windows_configuration")


@pulumi.output_type
class VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettingsResponse(dict):
    """
    Describes a virtual machines scale sets network configuration's DNS settings.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "domainNameLabel":
            suggest = "domain_name_label"
        elif key == "domainNameLabelScope":
            suggest = "domain_name_label_scope"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 domain_name_label: builtins.str,
                 domain_name_label_scope: Optional[builtins.str] = None):
        """
        Describes a virtual machines scale sets network configuration's DNS settings.
        :param builtins.str domain_name_label: The Domain name label.The concatenation of the domain name label and vm index
               will be the domain name labels of the PublicIPAddress resources that will be
               created
        :param builtins.str domain_name_label_scope: The Domain name label scope.The concatenation of the hashed domain name label
               that generated according to the policy from domain name label scope and vm
               index will be the domain name labels of the PublicIPAddress resources that will
               be created
        """
        pulumi.set(__self__, "domain_name_label", domain_name_label)
        if domain_name_label_scope is not None:
            pulumi.set(__self__, "domain_name_label_scope", domain_name_label_scope)

    @property
    @pulumi.getter(name="domainNameLabel")
    def domain_name_label(self) -> builtins.str:
        """
        The Domain name label.The concatenation of the domain name label and vm index
        will be the domain name labels of the PublicIPAddress resources that will be
        created
        """
        return pulumi.get(self, "domain_name_label")

    @property
    @pulumi.getter(name="domainNameLabelScope")
    def domain_name_label_scope(self) -> Optional[builtins.str]:
        """
        The Domain name label scope.The concatenation of the hashed domain name label
        that generated according to the policy from domain name label scope and vm
        index will be the domain name labels of the PublicIPAddress resources that will
        be created
        """
        return pulumi.get(self, "domain_name_label_scope")


@pulumi.output_type
class VirtualMachineScaleSetPublicIPAddressConfigurationPropertiesResponse(dict):
    """
    Describes a virtual machines scale set IP Configuration's PublicIPAddress
    configuration
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "deleteOption":
            suggest = "delete_option"
        elif key == "dnsSettings":
            suggest = "dns_settings"
        elif key == "idleTimeoutInMinutes":
            suggest = "idle_timeout_in_minutes"
        elif key == "ipTags":
            suggest = "ip_tags"
        elif key == "publicIPAddressVersion":
            suggest = "public_ip_address_version"
        elif key == "publicIPPrefix":
            suggest = "public_ip_prefix"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetPublicIPAddressConfigurationPropertiesResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetPublicIPAddressConfigurationPropertiesResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetPublicIPAddressConfigurationPropertiesResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 delete_option: Optional[builtins.str] = None,
                 dns_settings: Optional['outputs.VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettingsResponse'] = None,
                 idle_timeout_in_minutes: Optional[builtins.int] = None,
                 ip_tags: Optional[Sequence['outputs.VirtualMachineScaleSetIpTagResponse']] = None,
                 public_ip_address_version: Optional[builtins.str] = None,
                 public_ip_prefix: Optional['outputs.SubResourceResponse'] = None):
        """
        Describes a virtual machines scale set IP Configuration's PublicIPAddress
        configuration
        :param builtins.str delete_option: Specify what happens to the public IP when the VM is deleted
        :param 'VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettingsResponse' dns_settings: The dns settings to be applied on the publicIP addresses .
        :param builtins.int idle_timeout_in_minutes: The idle timeout of the public IP address.
        :param Sequence['VirtualMachineScaleSetIpTagResponse'] ip_tags: The list of IP tags associated with the public IP address.
        :param builtins.str public_ip_address_version: Available from Api-Version 2019-07-01 onwards, it represents whether the
               specific ipconfiguration is IPv4 or IPv6. Default is taken as IPv4. Possible
               values are: 'IPv4' and 'IPv6'.
        :param 'SubResourceResponse' public_ip_prefix: The PublicIPPrefix from which to allocate publicIP addresses.
        """
        if delete_option is not None:
            pulumi.set(__self__, "delete_option", delete_option)
        if dns_settings is not None:
            pulumi.set(__self__, "dns_settings", dns_settings)
        if idle_timeout_in_minutes is not None:
            pulumi.set(__self__, "idle_timeout_in_minutes", idle_timeout_in_minutes)
        if ip_tags is not None:
            pulumi.set(__self__, "ip_tags", ip_tags)
        if public_ip_address_version is not None:
            pulumi.set(__self__, "public_ip_address_version", public_ip_address_version)
        if public_ip_prefix is not None:
            pulumi.set(__self__, "public_ip_prefix", public_ip_prefix)

    @property
    @pulumi.getter(name="deleteOption")
    def delete_option(self) -> Optional[builtins.str]:
        """
        Specify what happens to the public IP when the VM is deleted
        """
        return pulumi.get(self, "delete_option")

    @property
    @pulumi.getter(name="dnsSettings")
    def dns_settings(self) -> Optional['outputs.VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettingsResponse']:
        """
        The dns settings to be applied on the publicIP addresses .
        """
        return pulumi.get(self, "dns_settings")

    @property
    @pulumi.getter(name="idleTimeoutInMinutes")
    def idle_timeout_in_minutes(self) -> Optional[builtins.int]:
        """
        The idle timeout of the public IP address.
        """
        return pulumi.get(self, "idle_timeout_in_minutes")

    @property
    @pulumi.getter(name="ipTags")
    def ip_tags(self) -> Optional[Sequence['outputs.VirtualMachineScaleSetIpTagResponse']]:
        """
        The list of IP tags associated with the public IP address.
        """
        return pulumi.get(self, "ip_tags")

    @property
    @pulumi.getter(name="publicIPAddressVersion")
    def public_ip_address_version(self) -> Optional[builtins.str]:
        """
        Available from Api-Version 2019-07-01 onwards, it represents whether the
        specific ipconfiguration is IPv4 or IPv6. Default is taken as IPv4. Possible
        values are: 'IPv4' and 'IPv6'.
        """
        return pulumi.get(self, "public_ip_address_version")

    @property
    @pulumi.getter(name="publicIPPrefix")
    def public_ip_prefix(self) -> Optional['outputs.SubResourceResponse']:
        """
        The PublicIPPrefix from which to allocate publicIP addresses.
        """
        return pulumi.get(self, "public_ip_prefix")


@pulumi.output_type
class VirtualMachineScaleSetPublicIPAddressConfigurationResponse(dict):
    """
    Describes a virtual machines scale set IP Configuration's PublicIPAddress
    configuration
    """
    def __init__(__self__, *,
                 name: builtins.str,
                 properties: Optional['outputs.VirtualMachineScaleSetPublicIPAddressConfigurationPropertiesResponse'] = None,
                 sku: Optional['outputs.PublicIPAddressSkuResponse'] = None):
        """
        Describes a virtual machines scale set IP Configuration's PublicIPAddress
        configuration
        :param builtins.str name: The publicIP address configuration name.
        :param 'VirtualMachineScaleSetPublicIPAddressConfigurationPropertiesResponse' properties: Describes a virtual machines scale set IP Configuration's PublicIPAddress
               configuration
        :param 'PublicIPAddressSkuResponse' sku: Describes the public IP Sku. It can only be set with OrchestrationMode as
               Flexible.
        """
        pulumi.set(__self__, "name", name)
        if properties is not None:
            pulumi.set(__self__, "properties", properties)
        if sku is not None:
            pulumi.set(__self__, "sku", sku)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The publicIP address configuration name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def properties(self) -> Optional['outputs.VirtualMachineScaleSetPublicIPAddressConfigurationPropertiesResponse']:
        """
        Describes a virtual machines scale set IP Configuration's PublicIPAddress
        configuration
        """
        return pulumi.get(self, "properties")

    @property
    @pulumi.getter
    def sku(self) -> Optional['outputs.PublicIPAddressSkuResponse']:
        """
        Describes the public IP Sku. It can only be set with OrchestrationMode as
        Flexible.
        """
        return pulumi.get(self, "sku")


@pulumi.output_type
class VirtualMachineScaleSetStorageProfileResponse(dict):
    """
    Describes a virtual machine scale set storage profile.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dataDisks":
            suggest = "data_disks"
        elif key == "diskControllerType":
            suggest = "disk_controller_type"
        elif key == "imageReference":
            suggest = "image_reference"
        elif key == "osDisk":
            suggest = "os_disk"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VirtualMachineScaleSetStorageProfileResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VirtualMachineScaleSetStorageProfileResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VirtualMachineScaleSetStorageProfileResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 data_disks: Optional[Sequence['outputs.VirtualMachineScaleSetDataDiskResponse']] = None,
                 disk_controller_type: Optional[builtins.str] = None,
                 image_reference: Optional['outputs.ImageReferenceResponse'] = None,
                 os_disk: Optional['outputs.VirtualMachineScaleSetOSDiskResponse'] = None):
        """
        Describes a virtual machine scale set storage profile.
        :param Sequence['VirtualMachineScaleSetDataDiskResponse'] data_disks: Specifies the parameters that are used to add data disks to the virtual
               machines in the scale set. For more information about disks, see [About disks
               and VHDs for Azure virtual
               machines](https://learn.microsoft.com/azure/virtual-machines/managed-disks-overview).
        :param builtins.str disk_controller_type: Specifies the disk controller type configured for the virtual machines in the scale set. Minimum api-version: 2022-08-01
        :param 'ImageReferenceResponse' image_reference: Specifies information about the image to use. You can specify information about
               platform images, marketplace images, or virtual machine images. This element is
               required when you want to use a platform image, marketplace image, or virtual
               machine image, but is not used in other creation operations.
        :param 'VirtualMachineScaleSetOSDiskResponse' os_disk: Specifies information about the operating system disk used by the virtual
               machines in the scale set. For more information about disks, see [About disks
               and VHDs for Azure virtual
               machines](https://learn.microsoft.com/azure/virtual-machines/managed-disks-overview).
        """
        if data_disks is not None:
            pulumi.set(__self__, "data_disks", data_disks)
        if disk_controller_type is not None:
            pulumi.set(__self__, "disk_controller_type", disk_controller_type)
        if image_reference is not None:
            pulumi.set(__self__, "image_reference", image_reference)
        if os_disk is not None:
            pulumi.set(__self__, "os_disk", os_disk)

    @property
    @pulumi.getter(name="dataDisks")
    def data_disks(self) -> Optional[Sequence['outputs.VirtualMachineScaleSetDataDiskResponse']]:
        """
        Specifies the parameters that are used to add data disks to the virtual
        machines in the scale set. For more information about disks, see [About disks
        and VHDs for Azure virtual
        machines](https://learn.microsoft.com/azure/virtual-machines/managed-disks-overview).
        """
        return pulumi.get(self, "data_disks")

    @property
    @pulumi.getter(name="diskControllerType")
    def disk_controller_type(self) -> Optional[builtins.str]:
        """
        Specifies the disk controller type configured for the virtual machines in the scale set. Minimum api-version: 2022-08-01
        """
        return pulumi.get(self, "disk_controller_type")

    @property
    @pulumi.getter(name="imageReference")
    def image_reference(self) -> Optional['outputs.ImageReferenceResponse']:
        """
        Specifies information about the image to use. You can specify information about
        platform images, marketplace images, or virtual machine images. This element is
        required when you want to use a platform image, marketplace image, or virtual
        machine image, but is not used in other creation operations.
        """
        return pulumi.get(self, "image_reference")

    @property
    @pulumi.getter(name="osDisk")
    def os_disk(self) -> Optional['outputs.VirtualMachineScaleSetOSDiskResponse']:
        """
        Specifies information about the operating system disk used by the virtual
        machines in the scale set. For more information about disks, see [About disks
        and VHDs for Azure virtual
        machines](https://learn.microsoft.com/azure/virtual-machines/managed-disks-overview).
        """
        return pulumi.get(self, "os_disk")


@pulumi.output_type
class VmSizeProfileResponse(dict):
    """
    Specifications about a VM Size. This will also contain the corresponding rank and weight in future.
    """
    def __init__(__self__, *,
                 name: builtins.str,
                 rank: Optional[builtins.int] = None):
        """
        Specifications about a VM Size. This will also contain the corresponding rank and weight in future.
        :param builtins.str name: The Sku name (e.g. 'Standard_DS1_v2')
        :param builtins.int rank: The rank of the VM size. This is used with 'RegularPriorityAllocationStrategy.Prioritized'
               The lower the number, the higher the priority. Starting with 0.
        """
        pulumi.set(__self__, "name", name)
        if rank is not None:
            pulumi.set(__self__, "rank", rank)

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        The Sku name (e.g. 'Standard_DS1_v2')
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def rank(self) -> Optional[builtins.int]:
        """
        The rank of the VM size. This is used with 'RegularPriorityAllocationStrategy.Prioritized'
        The lower the number, the higher the priority. Starting with 0.
        """
        return pulumi.get(self, "rank")


@pulumi.output_type
class WinRMConfigurationResponse(dict):
    """
    Describes Windows Remote Management configuration of the VM
    """
    def __init__(__self__, *,
                 listeners: Optional[Sequence['outputs.WinRMListenerResponse']] = None):
        """
        Describes Windows Remote Management configuration of the VM
        :param Sequence['WinRMListenerResponse'] listeners: The list of Windows Remote Management listeners
        """
        if listeners is not None:
            pulumi.set(__self__, "listeners", listeners)

    @property
    @pulumi.getter
    def listeners(self) -> Optional[Sequence['outputs.WinRMListenerResponse']]:
        """
        The list of Windows Remote Management listeners
        """
        return pulumi.get(self, "listeners")


@pulumi.output_type
class WinRMListenerResponse(dict):
    """
    Describes Protocol and thumbprint of Windows Remote Management listener
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "certificateUrl":
            suggest = "certificate_url"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in WinRMListenerResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        WinRMListenerResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        WinRMListenerResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 certificate_url: Optional[builtins.str] = None,
                 protocol: Optional[builtins.str] = None):
        """
        Describes Protocol and thumbprint of Windows Remote Management listener
        :param builtins.str certificate_url: This is the URL of a certificate that has been uploaded to Key Vault as a
               secret. For adding a secret to the Key Vault, see [Add a key or secret to the
               key
               vault](https://learn.microsoft.com/azure/key-vault/key-vault-get-started/#add).
               In this case, your certificate needs to be the Base64 encoding of the following
               JSON Object which is encoded in UTF-8: <br><br> {<br>
               "data":"<Base64-encoded-certificate>",<br>  "dataType":"pfx",<br>
               "password":"<pfx-file-password>"<br>} <br> To install certificates on a virtual
               machine it is recommended to use the [Azure Key Vault virtual machine extension
               for
               Linux](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-linux)
               or the [Azure Key Vault virtual machine extension for
               Windows](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-windows).
        :param builtins.str protocol: Specifies the protocol of WinRM listener. Possible values are: **http,**
               **https.**
        """
        if certificate_url is not None:
            pulumi.set(__self__, "certificate_url", certificate_url)
        if protocol is not None:
            pulumi.set(__self__, "protocol", protocol)

    @property
    @pulumi.getter(name="certificateUrl")
    def certificate_url(self) -> Optional[builtins.str]:
        """
        This is the URL of a certificate that has been uploaded to Key Vault as a
        secret. For adding a secret to the Key Vault, see [Add a key or secret to the
        key
        vault](https://learn.microsoft.com/azure/key-vault/key-vault-get-started/#add).
        In this case, your certificate needs to be the Base64 encoding of the following
        JSON Object which is encoded in UTF-8: <br><br> {<br>
        "data":"<Base64-encoded-certificate>",<br>  "dataType":"pfx",<br>
        "password":"<pfx-file-password>"<br>} <br> To install certificates on a virtual
        machine it is recommended to use the [Azure Key Vault virtual machine extension
        for
        Linux](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-linux)
        or the [Azure Key Vault virtual machine extension for
        Windows](https://learn.microsoft.com/azure/virtual-machines/extensions/key-vault-windows).
        """
        return pulumi.get(self, "certificate_url")

    @property
    @pulumi.getter
    def protocol(self) -> Optional[builtins.str]:
        """
        Specifies the protocol of WinRM listener. Possible values are: **http,**
        **https.**
        """
        return pulumi.get(self, "protocol")


@pulumi.output_type
class WindowsConfigurationResponse(dict):
    """
    Specifies Windows operating system settings on the virtual machine.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "additionalUnattendContent":
            suggest = "additional_unattend_content"
        elif key == "enableAutomaticUpdates":
            suggest = "enable_automatic_updates"
        elif key == "enableVMAgentPlatformUpdates":
            suggest = "enable_vm_agent_platform_updates"
        elif key == "patchSettings":
            suggest = "patch_settings"
        elif key == "provisionVMAgent":
            suggest = "provision_vm_agent"
        elif key == "timeZone":
            suggest = "time_zone"
        elif key == "winRM":
            suggest = "win_rm"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in WindowsConfigurationResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        WindowsConfigurationResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        WindowsConfigurationResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 additional_unattend_content: Optional[Sequence['outputs.AdditionalUnattendContentResponse']] = None,
                 enable_automatic_updates: Optional[builtins.bool] = None,
                 enable_vm_agent_platform_updates: Optional[builtins.bool] = None,
                 patch_settings: Optional['outputs.PatchSettingsResponse'] = None,
                 provision_vm_agent: Optional[builtins.bool] = None,
                 time_zone: Optional[builtins.str] = None,
                 win_rm: Optional['outputs.WinRMConfigurationResponse'] = None):
        """
        Specifies Windows operating system settings on the virtual machine.
        :param Sequence['AdditionalUnattendContentResponse'] additional_unattend_content: Specifies additional base-64 encoded XML formatted information that can be
               included in the Unattend.xml file, which is used by Windows Setup.
        :param builtins.bool enable_automatic_updates: Indicates whether Automatic Updates is enabled for the Windows virtual machine.
               Default value is true. For virtual machine scale sets, this property can be
               updated and updates will take effect on OS reprovisioning.
        :param builtins.bool enable_vm_agent_platform_updates: Indicates whether VMAgent Platform Updates is enabled for the Windows virtual
               machine. Default value is false.
        :param 'PatchSettingsResponse' patch_settings: [Preview Feature] Specifies settings related to VM Guest Patching on Windows.
        :param builtins.bool provision_vm_agent: Indicates whether virtual machine agent should be provisioned on the virtual
               machine. When this property is not specified in the request body, it is set to
               true by default. This will ensure that VM Agent is installed on the VM so that
               extensions can be added to the VM later.
        :param builtins.str time_zone: Specifies the time zone of the virtual machine. e.g. "Pacific Standard Time".
               Possible values can be
               [TimeZoneInfo.Id](https://learn.microsoft.com/dotnet/api/system.timezoneinfo.id?#System_TimeZoneInfo_Id)
               value from time zones returned by
               [TimeZoneInfo.GetSystemTimeZones](https://learn.microsoft.com/dotnet/api/system.timezoneinfo.getsystemtimezones).
        :param 'WinRMConfigurationResponse' win_rm: Specifies the Windows Remote Management listeners. This enables remote Windows
               PowerShell.
        """
        if additional_unattend_content is not None:
            pulumi.set(__self__, "additional_unattend_content", additional_unattend_content)
        if enable_automatic_updates is not None:
            pulumi.set(__self__, "enable_automatic_updates", enable_automatic_updates)
        if enable_vm_agent_platform_updates is not None:
            pulumi.set(__self__, "enable_vm_agent_platform_updates", enable_vm_agent_platform_updates)
        if patch_settings is not None:
            pulumi.set(__self__, "patch_settings", patch_settings)
        if provision_vm_agent is not None:
            pulumi.set(__self__, "provision_vm_agent", provision_vm_agent)
        if time_zone is not None:
            pulumi.set(__self__, "time_zone", time_zone)
        if win_rm is not None:
            pulumi.set(__self__, "win_rm", win_rm)

    @property
    @pulumi.getter(name="additionalUnattendContent")
    def additional_unattend_content(self) -> Optional[Sequence['outputs.AdditionalUnattendContentResponse']]:
        """
        Specifies additional base-64 encoded XML formatted information that can be
        included in the Unattend.xml file, which is used by Windows Setup.
        """
        return pulumi.get(self, "additional_unattend_content")

    @property
    @pulumi.getter(name="enableAutomaticUpdates")
    def enable_automatic_updates(self) -> Optional[builtins.bool]:
        """
        Indicates whether Automatic Updates is enabled for the Windows virtual machine.
        Default value is true. For virtual machine scale sets, this property can be
        updated and updates will take effect on OS reprovisioning.
        """
        return pulumi.get(self, "enable_automatic_updates")

    @property
    @pulumi.getter(name="enableVMAgentPlatformUpdates")
    def enable_vm_agent_platform_updates(self) -> Optional[builtins.bool]:
        """
        Indicates whether VMAgent Platform Updates is enabled for the Windows virtual
        machine. Default value is false.
        """
        return pulumi.get(self, "enable_vm_agent_platform_updates")

    @property
    @pulumi.getter(name="patchSettings")
    def patch_settings(self) -> Optional['outputs.PatchSettingsResponse']:
        """
        [Preview Feature] Specifies settings related to VM Guest Patching on Windows.
        """
        return pulumi.get(self, "patch_settings")

    @property
    @pulumi.getter(name="provisionVMAgent")
    def provision_vm_agent(self) -> Optional[builtins.bool]:
        """
        Indicates whether virtual machine agent should be provisioned on the virtual
        machine. When this property is not specified in the request body, it is set to
        true by default. This will ensure that VM Agent is installed on the VM so that
        extensions can be added to the VM later.
        """
        return pulumi.get(self, "provision_vm_agent")

    @property
    @pulumi.getter(name="timeZone")
    def time_zone(self) -> Optional[builtins.str]:
        """
        Specifies the time zone of the virtual machine. e.g. "Pacific Standard Time".
        Possible values can be
        [TimeZoneInfo.Id](https://learn.microsoft.com/dotnet/api/system.timezoneinfo.id?#System_TimeZoneInfo_Id)
        value from time zones returned by
        [TimeZoneInfo.GetSystemTimeZones](https://learn.microsoft.com/dotnet/api/system.timezoneinfo.getsystemtimezones).
        """
        return pulumi.get(self, "time_zone")

    @property
    @pulumi.getter(name="winRM")
    def win_rm(self) -> Optional['outputs.WinRMConfigurationResponse']:
        """
        Specifies the Windows Remote Management listeners. This enables remote Windows
        PowerShell.
        """
        return pulumi.get(self, "win_rm")


@pulumi.output_type
class WindowsVMGuestPatchAutomaticByPlatformSettingsResponse(dict):
    """
    Specifies additional settings to be applied when patch mode AutomaticByPlatform
    is selected in Windows patch settings.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "bypassPlatformSafetyChecksOnUserSchedule":
            suggest = "bypass_platform_safety_checks_on_user_schedule"
        elif key == "rebootSetting":
            suggest = "reboot_setting"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in WindowsVMGuestPatchAutomaticByPlatformSettingsResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        WindowsVMGuestPatchAutomaticByPlatformSettingsResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        WindowsVMGuestPatchAutomaticByPlatformSettingsResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 bypass_platform_safety_checks_on_user_schedule: Optional[builtins.bool] = None,
                 reboot_setting: Optional[builtins.str] = None):
        """
        Specifies additional settings to be applied when patch mode AutomaticByPlatform
        is selected in Windows patch settings.
        :param builtins.bool bypass_platform_safety_checks_on_user_schedule: Enables customer to schedule patching without accidental upgrades
        :param builtins.str reboot_setting: Specifies the reboot setting for all AutomaticByPlatform patch installation
               operations.
        """
        if bypass_platform_safety_checks_on_user_schedule is not None:
            pulumi.set(__self__, "bypass_platform_safety_checks_on_user_schedule", bypass_platform_safety_checks_on_user_schedule)
        if reboot_setting is not None:
            pulumi.set(__self__, "reboot_setting", reboot_setting)

    @property
    @pulumi.getter(name="bypassPlatformSafetyChecksOnUserSchedule")
    def bypass_platform_safety_checks_on_user_schedule(self) -> Optional[builtins.bool]:
        """
        Enables customer to schedule patching without accidental upgrades
        """
        return pulumi.get(self, "bypass_platform_safety_checks_on_user_schedule")

    @property
    @pulumi.getter(name="rebootSetting")
    def reboot_setting(self) -> Optional[builtins.str]:
        """
        Specifies the reboot setting for all AutomaticByPlatform patch installation
        operations.
        """
        return pulumi.get(self, "reboot_setting")


