# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult',
    'AwaitableGetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult',
    'get_database_sql_vulnerability_assessment_rule_baseline',
    'get_database_sql_vulnerability_assessment_rule_baseline_output',
]

@pulumi.output_type
class GetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult:
    """
    A database sql vulnerability assessment rule baseline.
    """
    def __init__(__self__, azure_api_version=None, id=None, name=None, results=None, system_data=None, type=None):
        if azure_api_version and not isinstance(azure_api_version, str):
            raise TypeError("Expected argument 'azure_api_version' to be a str")
        pulumi.set(__self__, "azure_api_version", azure_api_version)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="azureApiVersion")
    def azure_api_version(self) -> builtins.str:
        """
        The Azure API version of the resource.
        """
        return pulumi.get(self, "azure_api_version")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        Resource ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> builtins.str:
        """
        Resource name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def results(self) -> Sequence[Sequence[builtins.str]]:
        """
        The rule baseline result
        """
        return pulumi.get(self, "results")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        SystemData of DatabaseSqlVulnerabilityAssessmentRuleBaselineResource.
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def type(self) -> builtins.str:
        """
        Resource type.
        """
        return pulumi.get(self, "type")


class AwaitableGetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult(GetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult(
            azure_api_version=self.azure_api_version,
            id=self.id,
            name=self.name,
            results=self.results,
            system_data=self.system_data,
            type=self.type)


def get_database_sql_vulnerability_assessment_rule_baseline(baseline_name: Optional[builtins.str] = None,
                                                            database_name: Optional[builtins.str] = None,
                                                            resource_group_name: Optional[builtins.str] = None,
                                                            rule_id: Optional[builtins.str] = None,
                                                            server_name: Optional[builtins.str] = None,
                                                            vulnerability_assessment_name: Optional[builtins.str] = None,
                                                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult:
    """
    Gets a database's sql vulnerability assessment rule baseline.

    Uses Azure REST API version 2023-08-01.

    Other available API versions: 2022-02-01-preview, 2022-05-01-preview, 2022-08-01-preview, 2022-11-01-preview, 2023-02-01-preview, 2023-05-01-preview, 2023-08-01-preview, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native sql [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str database_name: The name of the database.
    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str rule_id: The vulnerability assessment rule ID.
    :param builtins.str server_name: The name of the server.
    :param builtins.str vulnerability_assessment_name: The name of the vulnerability assessment.
    """
    __args__ = dict()
    __args__['baselineName'] = baseline_name
    __args__['databaseName'] = database_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['ruleId'] = rule_id
    __args__['serverName'] = server_name
    __args__['vulnerabilityAssessmentName'] = vulnerability_assessment_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('azure-native:sql:getDatabaseSqlVulnerabilityAssessmentRuleBaseline', __args__, opts=opts, typ=GetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult).value

    return AwaitableGetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult(
        azure_api_version=pulumi.get(__ret__, 'azure_api_version'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        results=pulumi.get(__ret__, 'results'),
        system_data=pulumi.get(__ret__, 'system_data'),
        type=pulumi.get(__ret__, 'type'))
def get_database_sql_vulnerability_assessment_rule_baseline_output(baseline_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                   database_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                   resource_group_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                   rule_id: Optional[pulumi.Input[builtins.str]] = None,
                                                                   server_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                   vulnerability_assessment_name: Optional[pulumi.Input[builtins.str]] = None,
                                                                   opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult]:
    """
    Gets a database's sql vulnerability assessment rule baseline.

    Uses Azure REST API version 2023-08-01.

    Other available API versions: 2022-02-01-preview, 2022-05-01-preview, 2022-08-01-preview, 2022-11-01-preview, 2023-02-01-preview, 2023-05-01-preview, 2023-08-01-preview, 2024-05-01-preview. These can be accessed by generating a local SDK package using the CLI command `pulumi package add azure-native sql [ApiVersion]`. See the [version guide](../../../version-guide/#accessing-any-api-version-via-local-packages) for details.


    :param builtins.str database_name: The name of the database.
    :param builtins.str resource_group_name: The name of the resource group that contains the resource. You can obtain this value from the Azure Resource Manager API or the portal.
    :param builtins.str rule_id: The vulnerability assessment rule ID.
    :param builtins.str server_name: The name of the server.
    :param builtins.str vulnerability_assessment_name: The name of the vulnerability assessment.
    """
    __args__ = dict()
    __args__['baselineName'] = baseline_name
    __args__['databaseName'] = database_name
    __args__['resourceGroupName'] = resource_group_name
    __args__['ruleId'] = rule_id
    __args__['serverName'] = server_name
    __args__['vulnerabilityAssessmentName'] = vulnerability_assessment_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('azure-native:sql:getDatabaseSqlVulnerabilityAssessmentRuleBaseline', __args__, opts=opts, typ=GetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult)
    return __ret__.apply(lambda __response__: GetDatabaseSqlVulnerabilityAssessmentRuleBaselineResult(
        azure_api_version=pulumi.get(__response__, 'azure_api_version'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        results=pulumi.get(__response__, 'results'),
        system_data=pulumi.get(__response__, 'system_data'),
        type=pulumi.get(__response__, 'type')))
